
package com.tin.etbaf.rpu;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.Dialog.ModalityType;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.Locale;
import java.text.NumberFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.DefaultCellEditor;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JViewport;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.AncestorEvent;
import javax.swing.event.AncestorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;

import com.tin.etbaf.annexure1.*;
import com.tin.etbaf.validations.SecondaryValidations;
import com.tin.etbaf.validations.Validations;
import com.tin.etabf.annexure2.*;
import com.tin.etabf.filecreator.CorrValidation;
import com.tin.etabf.filecreator.CreateFile;

//added By  for validations of the annexure2

public class GRPU extends JFrame implements Printable, ActionListener {

	public int previousCol = 0, currentCol = 0, clickCount = 0;
	public Object StrCurrent = "";
	public Object StrPrevious = "";

	public String strAnnexIColValue="";// new development for newly appended value "F", FRD1.9 on 18/01/17
	public String strAnnexIIColValue="";// new development for newly appended value "F", FRD1.9 on 18/01/17

	public final static int BATCH_TAB_INDEX = 0;
	public final static int DDO_TAB_INDEX = 1;
	public final static int ANNE_TAB_INDEX = 2;
	public final static int ANNE2_TAB_INDEX = 3;
	public static int OTHER_SERVICES_TAB_INDEX = 4;  //new tab added as utility.
	public final static int TABLE_COLUMN_COUNT_challan = 24; // changed by amit
	public final static int TABLE_COLUMN_COUNT_annI_24Q = 29; // added by
	// Akansha
	//RPU 3.1 start 	 //rpu 3.4 saved 
		public final static int TABLE_COLUMN_COUNT_annI_26Q = 35; //  32 RPU 3.4 original value 33
		public final static int TABLE_COLUMN_COUNT_annI_27Q = 44; //  41 RPU 3.4 original value 42
	 //rpu 3.4 saved 
	
	/************************************************************/
	//public final static int TABLE_COLUMN_COUNT_annI_27EQ = 33; // added by Akansha
	//added by sadhana, FRD 2.2, for newly added teo columns in annexure i
	public final static int TABLE_COLUMN_COUNT_annI_27EQ = 38;//35 previous
	/************************************************************/


	//newly added for FRD1.6 by akansha
	//public final static int TABLE_COLUMN_COUNT_annII = 60; // added by Akansha // FRD1.6 prevoius value 33 // before revised frd1.6 value 51
	/****************** Added for 2.7 Start For Total Columns + 2********************/
	//RPU 2.9 start
	public final static int TABLE_COLUMN_COUNT_annII = 95;  // for 2.7 value 81  //RPU 3.6 changes
	//RPU 2.9 end
	/***************** Added for 2.7 End  ********************/

	public final static int HEIGHT_OF_ROW = 20;
	public boolean flagCheck = false;
	// added by Akansha
	public static int linenumber = 1;

	public String dedtype ="";

	public static int challancount = 2;
	public static int annIcount = 2;
	public static int annIIcount = 2;
	public static int annIcolumn = 2;
	ArrayList<Object> formdetails = new ArrayList<Object>();

	public HashMap<Integer, Object[]> ddlist = new HashMap<Integer, Object[]>();
	// Regular expression for pincode
	private String validateAlphaChar = "^[a-zA-Z]+$";
	// *********************************************

	int flag_annex = 0;
	int flag_challan = 0;
	public double td = 0;
	public double sur = 0;
	public double eduCess = 0;
	public double interest = 0;
	public double fee = 0;
	public double others = 0;
	public double sum = 0;
	public int row_no;
	public double col4 = 0;
	public double col3 = 0;
	public double col5 = 0;
	public double col6 = 0;
	public double col7 = 0;
	public double col8 = 0;


	// Variable for blobking quarter popup while opening a file
	public int checkPopup = 0;
	// ************************************************

	public double s3 = 0;
	public String var = null;

	public String challantype = "";
	public String pancheckfag = "";
	//new development for FRD1.5 by akansha
	PrintStream fileLogs;
	public String pancheckfagAnne2 = "";
	public boolean flagging = true;
	public boolean flaggingAnne = true;
	public boolean panAnne = true;
	// Added by Akansha
	public List assessmentyear = null;
	// *****************************

	// Added By for TotalSalary Field(10) For annexure2



	// end

	// Method added for differentiating between open and import
	public static String method = "";
	// ***********************************************
	// Added By for TotalDeductionField Field(13) For annexure2

	public double col12Ded16II = 0;
	public double col12Ded16III = 0;
	public double TotalDed = 0;
	// end
	// Added for the challan_serial_number_for the annexure 1 tab
	// Added by Akansha
	// Global variables for form attributes
	// First panel
	public String quarter = "";
	public String correctiontype = "";
	public String prevtoken = "";
	public String orgtoken = "";
	public String tan = "";
	public String lasttan = "";
	public String pan = "";
	public String isrevised = "";
	public String updateDD = "";
	public String finyear = "";
	public String assyear = "";
	public String typeofDD = "";
	public String lastDD = "";

	// Second panel for deductor's details
	public String dedname = "";
	public String dedbranch = "";
	public String dedstateone = "";
	public String paocode = "";
	public String paoregnm = "";
	public String flatno = "";
	public String area = "";
	public String road = "";
	public String dedpin = "";
	public String dedtelstd = "";
	public String dedtel = "";
	public String dedalttelstd = "";
	public String dedalttel = "";
	public String dedain = "";
	public String dedminstrydept = "";
	public String dedminstrydeptothers = "";
	public String ddocode = "";
	public String ddoregnm = "";
	public String tanregnm = "";
	public String dedbldgname = "";
	public String dedtown = "";
	public String dedstatetwo = "";
	public String dedemail = "";
	public String dedemailalt = "";
	public String hasaddchanged = "";
	public String gstn = "";

	// Third panel for responsible person
	public String rpname = "";
	public String rpdesig = "";
	public String rpflatno = "";
	public String rpbuldg = "";
	public String rproad = "";
	public String rptelnumstd = "";
	public String rptelnum = "";
	public String rptelnumaltstd = "";
	public String rptelnumalt = "";
	public String rpisaddresschng = "";
	public String rprecieptnm = "";
	public String rparea = "";
	public String rptown = "";
	public String rpstate = "";
	public String rppin = "";
	public String rpemail = "";
	public String rpemailalt = "";
	public String rpmobile = "";
	public String rpisregstatement = "";
	// ************************************

	// Variable added by E-kyc team

	public String ChallanCount;
	public List<String> LastModeofDeposit = new ArrayList<String>();
	// ## Newly developed for correction Ver1.2 by Akansha
	public List<String> LastIncomeTax = new ArrayList<String>();
	public List<String> LastSurcharge = new ArrayList<String>();
	public List<String> LastEduCess = new ArrayList<String>();
	public List<String> LastInterest = new ArrayList<String>();
	public List<String> LastOthers = new ArrayList<String>();
	// ***********************************************************
	public List<String> LastPanRefNo = new ArrayList<String>();

	public final static String fontName = "Arial";
	public static List<String> annexIcount =new ArrayList<String>() ;
	public static String annexIIcount = "";

	/*********************************************************/				
	//FRD 2.3 added 16(ia)		
	public double col12Ded16IA = 0;
	public double totalDed16 = 0;
	public boolean flaggingCol16IA = true;
	/*********************************************************/	

	public class MyComboBoxEditor extends DefaultCellEditor {

		public MyComboBoxEditor(String items[]) {
			super(new JComboBox(items));


		}

	}

	public class MyComboBoxEditor1 extends DefaultCellEditor {

		public MyComboBoxEditor1(String items[]) {
			super(new MyJcomboBox(items));
		}

	}

	// Added by

	MyComboBoxEditor challanSerialNumberComboValue;

	// end

	public class MyJcomboBox extends JComboBox {
		public MyJcomboBox(String items[]) {
			super(items);
			addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {

					if (flagCheck == false) {
						flagCheck = true;
						return;
					}
					flagCheck = false;
					String valueSelected = ((JComboBox) event.getSource())
							.getSelectedItem().toString();
					int postionOfRow = (((JComboBox) event.getSource()).getY());

					int rowNumber = (postionOfRow / HEIGHT_OF_ROW);
					Object[] transObject = (Object[]) saveDDOVector
							.get(rowNumber);

					String ddoValue = transObject[22].toString();
					//System.out.println(ddoValue + " sdsa " + rowNumber);
					if (ddoValue.equalsIgnoreCase("D")
							&& valueSelected.equalsIgnoreCase("Delete")) {

						//System.out.println("Inside DDO Mapping");
						model.setValueAt("--Select--", rowNumber, 2); // yahn pe
						GRPU.grpu
						.getMessage("You cannot select delete when ddo value is delete.");

						reEneterData(rowNumber, transObject);

					} else if (grpu.jComboBox_TypeOfCorrection
							.getSelectedItem().toString()
							.equalsIgnoreCase("Cancel")) {

						// User cannot select Delete in case of Cancel
						//System.out.println("******Action Performed*********");
						GRPU.grpu
						.getMessage("You cannot select delete in cancel mode.");
						grpu.model.setValueAt("--Select--", rowNumber, 2);

					} else if (!valueSelected.equalsIgnoreCase("Update")) {

						reEneterData(rowNumber, transObject);

					}
				}

				public void reEneterData(int rowNumber, Object[] transObject) {

					String tanValue = transObject[6].toString();
					String name = transObject[7].toString();
					String ddoReg = transObject[17].toString();
					String ddoCode = transObject[18].toString();
					String addr1 = transObject[8].toString();
					String addr2 = transObject[9].toString();
					String addr3 = transObject[10].toString();
					String addr4 = transObject[11].toString();
					String city = transObject[12].toString();
					String state = GrpuUtil.getStateName(transObject[13]
							.toString());
					String pin = transObject[14].toString();
					String email = transObject[19].toString();
					String natureOfDed = transObject[21].toString();

					String taxRemittedStr = "";
					String taxRemittedGovtStr = "";

					double tax1 = 0;
					double tax2 = 0;
					if (transObject[15] != null
							&& !transObject[15].toString().equalsIgnoreCase("")) {
						tax1 = Double.parseDouble((transObject[15].toString()));
						taxRemittedStr = transObject[15].toString();
					}
					if (transObject[20] != null
							&& !transObject[20].toString().equalsIgnoreCase("")) {
						tax2 = Double.parseDouble(transObject[20].toString());
						taxRemittedGovtStr = transObject[20].toString();
					}
					int taxRemitted = (int) tax1;
					int taxRemittedGovt = (int) tax2;

					String ddoMap = transObject[22].toString();
					//System.out.println("DDO AP VALUE IS " + ddoMap);

					String ddoValuePrevious = "";
					model.setValueAt(
							taxRemittedStr.substring(0,
									(taxRemittedStr.length() - 3)), rowNumber,
									19);
					model.setValueAt(
							taxRemittedGovtStr.substring(0,
									(taxRemittedGovtStr.length() - 3)),
									rowNumber, 21);

					model.setValueAt(getNatureOfDeduction(natureOfDed),
							rowNumber, 23);
					if (ddoMap == null || ddoMap.equals("")) {
						//System.out.print("INSDIE DDO -- Select");
						ddoValuePrevious = "--Select--";
					} else if (ddoMap.equals("A")) {
						//System.out.print("INSDIE DDO ADD");
						ddoValuePrevious = ddoMappingModes[1];
					} else if (ddoMap.equals("U")) {
						//System.out.print("INSDIE DDO Update");
						ddoValuePrevious = ddoMappingModes[2];
					} else if (ddoMap.equals("D")) {
						//System.out.print("INSDIE DDO DELETE");
						model.setValueAt("", rowNumber, 19);
						model.setValueAt("", rowNumber, 21);
						model.setValueAt("--Select--", rowNumber, 23);
						ddoValuePrevious = ddoMappingModes[3];
					}

					model.setValueAt(tanValue, rowNumber, 4);
					model.setValueAt(name, rowNumber, 5);
					model.setValueAt(ddoReg, rowNumber, 7);
					model.setValueAt(ddoCode, rowNumber, 9);
					model.setValueAt(addr1, rowNumber, 10);
					model.setValueAt(addr2, rowNumber, 11);
					model.setValueAt(addr3, rowNumber, 12);
					model.setValueAt(addr4, rowNumber, 13);
					model.setValueAt(city, rowNumber, 14);
					model.setValueAt(state, rowNumber, 15);

					model.setValueAt(pin, rowNumber, 16);
					model.setValueAt(email, rowNumber, 17);

					model.setValueAt(ddoValuePrevious, rowNumber, 24);

				}
			});
		}
	}

	class MyFilterGRPU extends FileFilter {

		public boolean accept(File file) {
			if (file.isDirectory())
				return true;
			String filename = file.getName();
			return filename.endsWith("");
		}

		public String getDescription() {
			return "";
		}

		MyFilterGRPU() {
		}
	}

	class MyFilterTXT extends FileFilter {

		public boolean accept(File file) {
			if (file.isDirectory())
				return true;
			String filename = file.getName();
			return filename.endsWith(".txt");
		}

		public String getDescription() {
			return "*.txt";
		}

		MyFilterTXT() {
		}
	}

	public class ColumnHeaderToolTips extends MouseMotionAdapter {

		TableColumn curCol;
		Map tips;

		public void setToolTip(TableColumn col, String tooltip) {
			if (tooltip == null)
				tips.remove(col);
			else
				tips.put(col, tooltip);
		}

		public void mouseMoved(MouseEvent evt) {
			TableColumn col = null;
			JTableHeader header = (JTableHeader) evt.getSource();
			JTable table = header.getTable();
			TableColumnModel colModel = table.getColumnModel();
			int vColIndex = colModel.getColumnIndexAtX(evt.getX());
			if (vColIndex >= 0)
				col = colModel.getColumn(vColIndex);
			if (col != curCol) {
				header.setToolTipText((String) tips.get(col));
				curCol = col;
			}
		}

		public ColumnHeaderToolTips() {
			tips = new HashMap();
		}
	}

	class MyFilterOpenFVU extends FileFilter {

		public boolean accept(File file) {
			String filename = file.getName();
			return file.isDirectory() || filename.endsWith(".fvu");
		}

		public String getDescription() {
			return "*.fvu";
		}

		MyFilterOpenFVU() {
		}
	}

	public static String valueOfTypeOfStmt;
	private String formNum;
	private String statementtype;
	public static String filehash;
	private String tdsDate;
	private String valueOfFilePath;
	private String fileExtsn;
	private boolean importedFileStatus;
	public JFrame import_fileFrame;
	private static JFrame JdialogFrame;
	public DefaultTableModel model;
	public DefaultTableModel model1;
	public DefaultTableModel model2;
	// Added by to insert rows
	private DefaultTableModel model_insert;
	// end
	public static JTabbedPane TabGRPU; // ## Newly developed for correction
	// Ver1.2
	public JPanel contentGRPU;
	// Added by for insert row button in the annexure1
	// JFrame frame_insert = new JFrame("Insert Rows");
	JDialog frame_insert = new JDialog(new JFrame(), "Insert Rows",
			ModalityType.APPLICATION_MODAL);
	JTextField addrow = new JTextField(); // Added on 09/07/2015 ----- R&D by
	// Akansha
	// Added For buttons
	JPanel JButton_pannel = new JPanel();
	JButton button_ok = new JButton("OK");
	JButton button_cancel = new JButton("Cancel");
	JPanel panel_insert = new JPanel();
	JTable table_insert;

	//new development for FRD1.3 by Akansha
	boolean delinscheck = false;
	//**************************************

	// added by cholia for pan updation indicator
	ArrayList<Integer> pan_Updtn_Indicator = new ArrayList<Integer>();
	ArrayList<Integer> pan_Updtn_Indicator_Anne2 = new ArrayList<Integer>();
	// end pan updation indicator
	// End for insert row button in the annexure1
	// for Tabs
	private JPanel PanelBatchDet;
	public JPanel PanelTransacDet;
	public JPanel PanelAnnexureDet;
	public JPanel PanelAnnexure2Det;
	public JPanel PanelUtility;                    //added new panel as panelutility for tab4 utility
	public JPanel PannelFormHeaderDet;
	public JPanel PanelTransInsertRow; // added by
	public JFrame jFrame = new JFrame();
	// for Tabs

	// private JPanel PanelAoAndPersonRespDtl; //AO and Person responsible
	// details
	public JTable jTableTransacDetails;
	public JTable jTableTransacDetails1;
	public JTable jTableTransacDetails2;
	// Added by to insert rows for challan tab
	public JTable jTableTransacDetails_insert;
	// End
	// public JScrollPane jScrollPane7;
	public JScrollPane jScrollPaneTab1;

	// added by dhaval 598588 for Swing_RPU start
	public JScrollPane jScrollPaneTab444;
	private JPanel jPanel444;

	// private JLabel jLabel_ReturnDetails;
	public JLabel jLabel_Form_heading1;
	public JLabel jLabel_Form_quarterEnd;
	public static JComboBox jComboBox_Quarter;
	public JTextField jText_Quarter;
	public JTextField jText_BalnkYear;
	public JLabel jLabel_Form_year;
	public JTextField jText_disabledFromNum;
	public JLabel jLabel_Form_formNumber;
	public JLabel jLabel_Form_Sub1_heading;
	public JLabel jLabel_Form_Sub1_Tan;
	public JLabel jLabel_Form_Sub1_LastTan;
	public JLabel jLabel_Form_Sub1_Pan;
	public JLabel jLabel_Form_Sub1_isRevised;
	public JLabel jLabel_Form_Sub1_Update_deductor;
	public JLabel jLabel_Form_Sub1_finYear;
	public JLabel jLabel_Form_Sub1_AssessmentYear;
	public JLabel jLabel_Form_Sub1_Type_of_Deductor;
	public JLabel jLabel_Form_Sub1_Last_Deductor_Type;
	public JLabel jLabel_Form_Sub1_Org_Receipt_Num;
	public JLabel jLabel_Form_Sub1_Previous_Receipt_num;
	public JLabel jLabel_Form_Sub1_Update_Instruction;

	//new development for FRD1.5 Ver1.5 by akansha
	public JButton jButton_Form_Sub1_Know_Your_Tan;

	public JTextField jText_Form_Sub1_Tan;
	public JTextField jText_Form_Sub1_LastTan;
	public JTextField jText_Form_Sub1_Pan;
	public JTextField jText_Form_Sub1_isRevised;
	public JTextField jText_Form_Sub1_Update_deductor;
	public JComboBox JComboBox_Form_Sub1_Update_deductor;
	public JTextField jText_Form_Sub1_finYear;
	public JComboBox JComboBox_Form_Sub1_finYear;
	public JTextField jText_Form_Sub1_AssessmentYear;
	public JTextField jText_Form_Sub1_Type_of_Deductor;
	public JComboBox JComboBox_Form_Sub1_Type_of_Deductor;
	public JTextField jText_Form_Sub1_Last_Deductor_Type;
	public JTextField jText_Form_Sub1_Org_Receipt_Num;
	public JTextField jText_Form_Sub1_Previous_Receipt_num;

	public JLabel jLabel_Form_Sub2_heading;
	public JCheckBox jCheckBox_Form_Sub2_Sameasabove;
	public JLabel jLabel_Form_Sub2_Name;
	public JLabel jLabel_Form_Sub2_Branch;
	public JLabel jLabel_Form_Sub2_State;
	public JLabel jLabel_Form_Sub2_PAO_Code;
	public JLabel jLabel_Form_Sub2_PAO_regNum;
	public JLabel jLabel_Form_Sub2_FlatNo;
	public JLabel jLabel_Form_Sub2_Area;
	public JLabel jLabel_Form_Sub2_Road;
	public JLabel jLabel_Form_Sub2_PinCode;
	public JLabel jLabel_Form_Sub2_TelNum;
	public JLabel jLabel_Form_Sub2_AlternateTelNum;
	public JLabel jLabel_Form_Sub2_AIN;
	public JLabel jLabel_Form_Sub2_GSTN;  //For FRD2.1, added by Sadhana, added new label for GSTN
	public JLabel jLabel_Form_Sub2_MinistryName;
	public JLabel jLabel_Form_Sub2_MinistryName_Other;
	public JLabel jLabel_Form_Sub2_DDO_Code;
	public JLabel jLabel_Form_Sub2_DDO_RegNum;
	public JLabel jLabel_Form_Sub2_TAN_RegNum;
	public JLabel jLabel_Form_Sub2_BuildingName;
	public JLabel jLabel_Form_Sub2_Town;
	public JLabel jLabel_Form_Sub2_StateTwo;
	public JLabel jLabel_Form_Sub2_Email;
	public JLabel jLabel_Form_Sub2_Email_Alternate;
	public JLabel jLabel_Form_Sub2_isAddressChanged;

	public JTextField jText_Form_Sub2_Name;
	public JTextField jText_Form_Sub2_Branch;
	public JComboBox jComboBox_Form_Sub2_State;
	public JTextField jText_Form_Sub2_PAO_Code;
	public JTextField jText_Form_Sub2_PAO_regNum;
	public JTextField jText_Form_Sub2_FlatNo;
	public JTextField jText_Form_Sub2_Area;
	public JTextField jText_Form_Sub2_Road;
	public JTextField jText_Form_Sub2_PinCode;
	public JTextField jText_Form_Sub2_TelNum_Std_Code;
	public JTextField jText_Form_Sub2_TelNum;
	public JTextField jText_Form_Sub2_AlternateTelNum_Std_Code;
	public JTextField jText_Form_Sub2_AlternateTelNum;
	public JTextField jText_Form_Sub2_AIN;
	public JTextField jText_Form_Sub2_GSTN;
	public JTextField jText_Form_Sub2_MinistryName;
	public JComboBox JComboBox_Form_Sub2_MinistryName;
	public JTextField jText_Form_Sub2_MinistryName_Other;
	public JTextField jText_Form_Sub2_DDO_Code;
	public JTextField jText_Form_Sub2_DDO_RegNum;
	public JTextField jText_Form_Sub2_TAN_RegNum;
	public JTextField jText_Form_Sub2_BuildingName;
	public JTextField jText_Form_Sub2_Town;
	public JTextField jText_Form_Sub2_StateTwo;
	public JTextField jText_Form_Sub2_Email;
	public JTextField jText_Form_Sub2_Email_Alternate;
	public JComboBox jComboBox_Form_Sub2_isAddressChanged;

	public JLabel jLabel_Form_Sub3_heading;
	public JLabel jLabel_Form_Sub3_Name;
	public JLabel jLabel_Form_Sub3_Designation;
	public JLabel jLabel_Form_Sub3_FlatNum;
	public JLabel jLabel_Form_Sub3_BuildingName;
	public JLabel jLabel_Form_Sub3_Road;
	public JLabel jLabel_Form_Sub3_TelNum;
	public JLabel jLabel_Form_Sub3_TelNum_Alternate;
	public JLabel jLabel_Form_Sub3_isAddressChange;
	public JLabel jLabel_Form_Sub3_earlierReceiptNum;
	public JLabel jLabel_Form_Sub3_Area;
	public JLabel jLabel_Form_Sub3_Town;
	public JLabel jLabel_Form_Sub3_State;
	public JLabel jLabel_Form_Sub3_PinCode;
	public JLabel jLabel_Form_Sub3_Email;
	public JLabel jLabel_Form_Sub3_Email_Alternate;
	public JLabel jLabel_Form_Sub3_MobileNumber;
	public JLabel jLabel_Form_Sub3_isRegularStatement;
	public JComboBox jComboBox_Form_Sub3_isAddressChanged;

	public JTextField jText_Form_Sub3_Name;
	public JTextField jText_Form_Sub3_Designation;
	public JTextField jText_Form_Sub3_FlatNum;
	public JTextField jText_Form_Sub3_BuildingName;
	public JTextField jText_Form_Sub3_Road;
	public JTextField jText_Form_Sub3_TelNum_Std_Code;
	public JTextField jText_Form_Sub3_TelNum;
	public JTextField jText_Form_Sub3_TelNum_Alternate_Std_Code;
	public JTextField jText_Form_Sub3_TelNum_Alternate;
	public JTextField jText_Form_Sub3_isAddressChange;
	public JTextField jText_Form_Sub3_earlierReceiptNum;
	public JTextField jText_Form_Sub3_Area;
	public JTextField jText_Form_Sub3_Town;
	public JTextField jText_Form_Sub3_State;
	public JTextField jText_Form_Sub3_PinCode;
	public JTextField jText_Form_Sub3_Email;
	public JTextField jText_Form_Sub3_Email_Alternate;
	public JTextField jText_Form_Sub3_MobileNumber;
	public JTextField jText_Form_Sub3_isRegularStatement;

	public JPanel jPanel_Form_particulars;
	public JPanel jPanel_Form_particulars_Deductor;
	public JPanel jPanel_Form_particulars_Person;
	public JComboBox jComboBox_Form_Sub3_isRegularStatement;

	// added by dhaval 598588 for Swing_RPU end
	private JTextField jTextAIN;
	private JTextField jTextAOName;
	private JPanel jPanel14;
	private JPanel jPanel16;
	public JPanel getjPanel14() {
		return jPanel14;
	}

	private boolean ddoTabFlag = false;
	private int numDdoRowsCorr = 0;

	public int getNumDdoRowsCorr() {
		return numDdoRowsCorr;
	}

	public void setNumDdoRowsCorr(int numDdoRowsCorr) {
		this.numDdoRowsCorr = numDdoRowsCorr;
	}

	public String getValueOfTypeOfStmt() {
		return valueOfTypeOfStmt;
	}

	final JPopupMenu textboxmenu = new JPopupMenu(); 

	private String revModeArray[];
	private JPanel jPanel15;
	// private JPanel jPanel16; //Used for ao and responsible person details
	private JPanel jPanelButton;
	/**************************************************************/
	private JPanel jPanelTab1;
	private JPanel jPanelTab2;
	JLabel jlabelAdv1 = new JLabel("Advertisement  Panel");
	JLabel jlabelAdv2 = new JLabel("Advertisement  Panel");
	/**************************************************************/
	private JPanel jPanelMenu;
	JPanel shalinpanel = new JPanel(new BorderLayout(800, 500));
	JLabel jLabel_FormNumber;
	JLabel jLabel_FormSectionRules;
	private JLabel jLabel_AIN;
	private JLabel jLabel_AOName;
	private JLabel jLabel_AOADD1;
	private JLabel jLabel_AOADD2;
	private JLabel jLabel_AOADD3;
	private JLabel jLabel_AOADD4;
	private JLabel jLabel_AOCity;
	private JLabel jLabel_AOState;
	private JLabel jLabel_AOPIN;
	private JLabel jLabel_PhoneNo;
	private JLabel jLabel_STD;
	private JLabel jLabel_EmailID;
	private JLabel jLabel_FinYear;
	private JLabel jLabel_Deductor_Category;
	private JLabel jLabel_State_Name;
	private JLabel jLabel_Month;

	private JLabel jLabel_CntofDDOTransnDtls;
	private JLabel jLabel_OrigRRRNo;
	private JLabel jLabel_PrevRRRNo;
	private JLabel jLabel_TypOfStmt;
	private JLabel jLabel_RespDetails;
	private JLabel jLabel_AODetails;

	private JLabel jLabel_Mandatory;
	Icon openicon;
	Icon saveicon;
	Icon saveasicon;
	// Added by Akansha
	Icon printicon;
	// ****************
	Icon exiticon;
	Icon cuticon;
	Icon copyicon;
	Icon pasteicon;
	Icon findicon;
	Icon Abouticon;
	String maxGRPUVersion;
	String GRPU_TITLE;
	double maxFVUVersion;
	String FVUVersioninFile;
	double FVUVerFile;
	private JTextField jText_AIN;
	private JTextField jText_AOName;
	private JTextField jText_AOADD1;
	private JTextField jText_AOADD2;
	private JTextField jText_AOADD3;
	private JTextField jText_AOADD4;
	private JTextField jText_AOCity;
	private JTextField jText_AOPIN;
	private JTextField jText_PhoneNo;
	private JTextField jText_EmailID;
	private JTextField jText_CntofDDOTransnDtls;
	private JTextField jText_Cur_CntofDDOTransnDtls;
	private JTextField jText_OrigRRRNo;
	private JTextField jText_PrevRRRNo;
	private JTextField jText_FinYear1;
	private JTextField jText_Month;
	private JTextField jText_STD;

	// Responsible person details
	private JLabel jLabel_ResponsiblePersonName;
	private JLabel jLabel_ResponsiblePersonDesgn;
	private JLabel jLabel_ResponsiblePersonADD1;
	private JLabel jLabel_ResponsiblePersonADD2;
	private JLabel jLabel_ResponsiblePersonADD3;
	private JLabel jLabel_ResponsiblePersonADD4;
	private JLabel jLabel_ResponsiblePersonCity;
	private JLabel jLabel_ResponsiblePersonPIN;
	private JLabel jLabel_ResponsiblePersonPhoneNo;
	private JLabel jLabel_ResponsiblePersonEmailID;
	private JLabel jLabel_ResponsiblePersonMobilePhoneNo;
	private JLabel jLabel_ResponsiblePersonState;
	private JLabel jLabel_ResponsiblePersonSTD;

	private JTextField jText_ResponsiblePersonName;
	private JTextField jText_ResponsiblePersonDesgn;
	private JTextField jText_ResponsiblePersonADD1;
	private JTextField jText_ResponsiblePersonADD2;
	private JTextField jText_ResponsiblePersonADD3;
	private JTextField jText_ResponsiblePersonADD4;
	private JTextField jText_ResponsiblePersonCity;
	private JTextField jText_ResponsiblePersonPIN;
	private JTextField jText_ResponsiblePersonPhoneNo;
	private JTextField jText_ResponsiblePersonEmailID;
	private JTextField jText_ResponsiblePersonMobilePhoneNo;
	private JTextField jText_ResponsiblePersonSTD;

	private JComboBox jComboBox_ResponsiblePersonState;
	// end

	// Added By Manish on 28102011
	private JLabel jLabel_TypeOfCorrection;
	private JComboBox jComboBox_TypeOfCorrection;

	// ministry
	private JLabel jLabel_MinistryName;
	private JLabel jLabel_SubMinistryName;
	private JLabel jLabel_OtherMinistryName;

	private JComboBox jComboBox_MinistryName;
	private JComboBox jComboBox_SubMinistryName;
	private JTextField jText_OtherMinistryName;

	// end

	public JComboBox jComboBox_AOState; // ## Newly changed for correction Ver
	// 1.2
	private JComboBox jComboBox_Deductor_Category;
	public JComboBox jComboBox_State_Name;// ## Newly changed for correction Ver
	// 1.2
	private JComboBox jComboBox_Month;

	public JComboBox jComboBox_TypOfStmt; // ## Newly changed for correction Ver
	// 1.2
	private JComboBox jComboBox_FinYear1;
	private JButton jButton_save;
	private JButton jButton_crtFile;

	//newly developed for FRD1.5 by akansha
	private JButton jButton_gotofileupd;
	private JButton jButton_imptoexcel;
	//****************************************
	// Added by Akansha
	private JButton jButton_sveFile;
	private JButton jButton_opnFile;
	private JButton jButton_feedback;//newly added on 12/01/17
	//private JButton jButton_checkTDS_TCS_rate; //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9
	// ************************************
	private JButton jButton_back;
	protected JButton jButton_addRow;
	private JButton jButton_delRow;
	private JButton jButton_insertRow; // added by
	private JPopupMenu menu;
	public Vector row;
	public Vector data;
	public int getRowCnt;
	// added By
	public int getRowCnt1;
	public int getRowCnt2;
	// end
	public int selRow;
	public int selCol;
	public int copyRow;
	public int pos;
	public String str;
	public String addRowElmts[];
	public String mthYrQ1[];
	public String mthYrQ2[];
	public String mthYrQ3[];
	public String mthYrQ4[];
	public String mthYrSelect[];
	public String stateName[];
	public String jComboBox_NtrOfDedtn[];
	// Added By amit
	public String jComboBox_Section_Code[];
	public String jComboBox_Book_Entry[];
	public TableColumn colSectionCode;
	public TableColumn colBookEntry;
	public String jComboBox_Update_Mode[];
	public String jComboBox_Minor_Head_Challan[];
	public TableColumn colupdateModeChallan;
	public TableColumn colMinorHeadChallan;
	// By asmit for annexure2
	public String jComboBox_updation_Mode_Forannx2[];
	public TableColumn updationModeForannx2;
	public TableColumn dedcuteeTypeannx2;
	public String jComboBox_deductee_Type[];
	public TableColumn whetTaxDedHigherRateAnnx2;
	public String whetherTaxDedHigherRate[];
	//newly added for FRD1.6 by akansha
	//	public TableColumn whthrHouseRentAllowanceClaim;
	//	public String whetherHouseRentAllowanceClaim[];

	/*****************************************************/
	//added Combobox for PAN of Lanlord1, PAN of Lanlord2, PAN of Lanlord3, and PAN of Lanlord4, On 16/01/2017, FRD1.9
	//public TableColumn panOfLandlord1Annx2;
	//public TableColumn panOfLandlord2Annx2;
	//public TableColumn panOfLandlord3Annx2;
	//public TableColumn panOfLandlord4Annx2;
	//public String jComboBox_panOfLanlord[];
	/****************************************************/
	// amit end
	public String ddoMappingModes[];
	public TableColumn col;
	public TableColumn colmn;
	public TableColumn colState;
	public TableColumn colNatureOfDeduction;
	public TableColumn ddoMappingFlag;
	public static int lineNo = 0;
	public JViewport viewport;
	public Rectangle rect;
	public Rectangle rect1;
	public Rectangle rect_insert;// added by
	public Point pt;
	public boolean saveflg;
	public boolean isCutRow;
	public boolean fileCreated;
	public boolean ddoValuesChanged;
	public boolean fileSaved;
	public boolean fileSaveAs;
	public boolean rowIsSelected;
	public String saveaspath;
	protected String name;
	public static File selFile;
	// Added by amit
	public String challanSerForDed[];
	public TableColumn dedChallanSer;
	public String updationModeForDed[];
	public String updationModeForDed_add[];
	public TableColumn dedMode;
	public String SecUnderPayMadeDed[];
	public TableColumn dedSecUnderPayMade;
	public String remarksForDed[];
	public String annex1Sectioncode[]; // cholia for annexure 1 section combo
	// box
	public String ded_code[]; // added by amit
	public TableColumn dedcodeannex1;

	// added by for challan serial number
	// public String challan_serial_number[];
	public TableColumn challan_serialannex1;
	int chalnn_getRowCnt = 0;
	int chalnn_getRowCnt1 = 0;
	public int row_count_annex1 = 0;
	public int row_count_annex2 = 0;
	public int row_count_challan = 0;
	public static int k_annex1 = 2;
	int count_annex1 = 0; // newly added by cholia
	int count_annex2 = 0; // newly added by cholia
	int mcolInexSrNo = 0;// newly added on 12 march

	// End
	static int count_challan = 0;

	public String rate_of_tds[]; // added by for TdsRateAnnexure1
	public TableColumn rateTdsannex1;

	public String country_resd[]; // Added For country residence
	public TableColumn country_resdannex1;

	public String nature_remit[]; // Added For Nature Remmitance
	public TableColumn nature_remitsannex1;

	public String paid_book_entry[]; // added by paid by book entry or
	// not
	public TableColumn paidBookEntryAnnex1;

	public String gross_up_indicator[]; // added Grossing up indicator
	public TableColumn grossupindicatorAnnex1;

	public String party_code[]; // Added For Party Code for Form 27EQ
	public TableColumn partycoderesdannex1;

	public String book_entry_27EQ[]; // Added For paid by book entry for Form
	// 27EQ
	public TableColumn bookentry27EQdannex1;

	public TableColumn dedRemarks;
	public TableColumn annex1Section; // added by cholia for the annexure1

	//newly added for FRD1.9
	//newly added for FRD1.9 
	private String[] panoflandlordDDList = {"--Select--", "Enter valid PAN", "Payment made to Government organization (Central/State only)",
			"Payment made to Non-resident","Payment made to Other than Government organization and Non-resident" };
	public TableColumn panoflandlordDD1;
	public TableColumn panoflandlordDD2;
	public TableColumn panoflandlordDD3;
	public TableColumn panoflandlordDD4;

	/************************************************************/
	/*private String[] panOfLenderDDList = {"--Select--","Payment made to Government organization (Central/State only)",
				"Payment made to Non-resident","Payment made to Other than Government organization and Non-resident"};*/
	public TableColumn panOfLenderDD1;
	public TableColumn panOfLenderDD2;
	public TableColumn panOfLenderDD3;
	public TableColumn panOfLenderDD4;
	/************************************************************/

	/*******************************************************************************************/
	//Added by Sadhana, FRD 2.2
	private String dedIsPermanentResidentList[];
	public TableColumn DedIsPermanentResident;

	private String dedIsPermanentResidentEstList[];
	public TableColumn DedIsPermanentResidentEst;
	/*******************************************************************************************/
	//RPU 3.5 Column 34
	private String WhetherpymntisliableList[];
	public TableColumn Whetherpymntisliable;
	
	// section combo box
	public boolean afterkeypressed;

	public String challanSerForDed1[];
	public TableColumn dedChallanSer1;
	public String updationModeForDed1[];
	public TableColumn dedMode1;
	public String SecUnderPayMadeDed1[];
	public TableColumn dedSecUnderPayMade1;
	public String remarksForDed1[];
	public TableColumn dedRemarks1;

	private boolean fileOpenRecently = false;

	// Added by manish
	public File reloadFile;
	JMenuItem item1 = null;
	JMenuItem item2 = null;
	JMenuItem item3 = null;
	JMenuItem item4 = null;

	JMenuItem item6 = null;

	private String typeOfCorrectionValue = "";

	private ArrayList saveDDOVector = new ArrayList();

	public int pasteintotextbox = -1;
	public int selTAB;
	public static int errRow = -1;
	public static int errCol = -1;
	public static String clickValue = "";
	private int prevErrRow;
	private int prevErrCol;
	private boolean isRowSelected;
	private boolean isCutSelected;
	public boolean isOpened;
	public String formNumber;
	public String form24QSection = " ( See Section 192 and Rule 31A ) ";
	//Section Code changes for RPU 2.9  //RPU 3.2 start addition of new section 94K for form 26Q //rpu 3.3 //RPU 3.5 start Addition of new section codes 
		public String form26QSection = " ( See Section 193, 194, 194A, 194BB, 194C, 194D, 194DA, 194LBA(a), 194LBA(b), 194EE, 194F, 194G, 194H, 194I, 194J, 194JA, 194JB, 194K, 194N, 194NF, 194O, 192A, 194LBB, 194LA, 194IC and Rule 31A ) ";
		//RPU 3.0 start
	public String form27QSection = " ( See Section 194E, 195, 196A*, 196B, 196C,194LBA(a), 194LBA(b), 194LBA(c), 194LBB, 192A, 194N, 194NF,196D and Rule 31A, 37A ) "; //new development for FRD1.3 //RPU 3.4 start Addition of new section codes 
	public String form27EQSection = " ( See Section 206C and Rule 31AA ) ";
	private static String fileNameInLowerCase;
	private static String fileName;
	private static String path;
	private static String fileNameForSaving;
	public static File selectedFile;
	public File aPreSelectedFile;
	public static File createdFile;
	private String exitMessage;
	public boolean deleteFlag;
	public static int Recrsncnt = 0;
	static int recursiveCount = 0;
	public int totalCnt;
	public int totalLineCnt;
	private int selectedRows[];
	private int selectedCols[];
	private int selectedRowCount;
	private int selectedColCount;
	public String aoData[];
	public String aoModifiedData[];
	private int NULL_INT_ARRAY[];
	private Vector selectedData;
	public static Object St_AO = "";
	int tabFlag;
	JMenuBar menuBar;
	JMenu filemenu;
	JMenu editmenu;
	JMenu helpMenu;

	MyComboBoxEditor monthYearQ1;
	MyComboBoxEditor monthYearQ2;
	MyComboBoxEditor monthYearQ3;
	MyComboBoxEditor monthYearQ4;
	MyComboBoxEditor monthYearSelect;
	Font font;
	Font fontHeading;
	Font fontTab;
	Font fontButton;
	GRPUHelp grpuHelp;
	public static FindReplace grpuFindReplace = null;
	int cntPasteClk;
	public static GRPU grpu = null;
	public static HashSet hashTanMthYr;
	public static Font plainFontLabel = new Font(fontName, 0, 12);
	int selColFocus;
	int selRowFocus;
	HashSet h;
	RPUFocusListener focusList = new RPUFocusListener();

	boolean flagToDecideReloadFunctionCall = true;

	List<String> batchValueArray = null;

	private int batchIndicator = 0;
	private int numberOfTd = 0;
	private String typeOfCorrection;
	public boolean isError = false;
	public boolean isCreateFileFocusOut = false;

	public String getTypeOfCorrection() {
		return jComboBox_TypeOfCorrection.getSelectedItem().toString();
	}

	public void setTypeOfCorrection(String typeOfCorrection) {
		this.typeOfCorrection = typeOfCorrection;
	}

	private GRPUMain mainObject;


	// statistical data

	private JLabel jLabel_count24QTrans;
	private JTextField jText_count24QTrans;
	private JLabel jLabel_controlTax24q;
	private JTextField jText_controlTax24q;
	private JLabel jLabel_totalTDS24q;
	private JTextField jText_totalTDS24q;

	private JLabel jLabel_count26QTrans;
	private JTextField jText_count26QTrans;
	private JLabel jLabel_controlTax26q;
	private JTextField jText_controlTax26q;
	private JLabel jLabel_totalTDS26q;
	private JTextField jText_totalTDS26q;

	private JLabel jLabel_count27QTrans;
	private JTextField jText_count27QTrans;
	private JLabel jLabel_controlTax27q;
	private JTextField jText_controlTax27q;
	private JLabel jLabel_totalTDS27q;
	private JTextField jText_totalTDS27q;

	private JLabel jLabel_count27EQTrans;
	private JTextField jText_count27EQTrans;
	private JLabel jLabel_controlTax27Eq;
	private JTextField jText_controlTax27Eq;
	private JLabel jLabel_totalTDS27Eq;
	private JTextField jText_totalTDS27Eq;

	private JLabel jLabel_regNoPaoDtoCddo;
	private JTextField jText_regNoPaoDtoCddo;

	private JLabel jLabel_totalTDS;
	private JTextField jText_totalTDS;

	private JLabel jLabel_countOfDDOAdd;
	private JTextField jText_countOfDDOAdd;

	private JLabel jLabel_countOfDDOUpd;
	private JTextField jText_countOfDDOUpd;

	private JLabel jLabel_countOfDDODel;
	private JTextField jText_countOfDDODel;


	//added url in string array.
	String strUriNames[] = {"www.google.com", "www.yahoo.com", "www.rediff.com"};
	Box utility_link_box = Box.createVerticalBox();	

	public GRPU() {

	}

	// Overloaded Constructor // yahan pe milega formnumber and type of
	// statement
	public GRPU(String typeOfStatement, File selFile, GRPUMain gRPUMain,
			String formNumber, String method,String typeOfFile) {
		this.formNumber = formNumber;
		this.isOpened = gRPUMain.isOpened;
		this.aPreSelectedFile = gRPUMain.aPreSelectedFile;
		this.selectedFile = gRPUMain.selectedFile;

		this.mainObject = gRPUMain;


		this.selFile = gRPUMain.selFile;
		reloadFile = gRPUMain.selFile;
		valueOfTypeOfStmt = typeOfStatement; // setting type of statement
		formNum = formNumber;

		if (selFile != null) {
			valueOfFilePath = selFile.getName();
			if (valueOfFilePath.contains("."))
				fileExtsn = valueOfFilePath.substring(
						valueOfFilePath.lastIndexOf("."),
						valueOfFilePath.length());
			else
				fileExtsn = "";
		} else {
			fileExtsn = "";
		}
		grpu = this;
		// Added for logs by Akansha

		try {
			fileLogs = new PrintStream(new FileOutputStream("./rpu_main.log"));
			System.setOut(fileLogs);
			System.setErr(fileLogs);
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		initializeCommon(); // sabse phele yahan pe aata hai
		try {
			initializeBHTab();
		} catch (URISyntaxException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		enableDisableFormFields();

		// -- To add Rupee symbol
		URL url = null;
		try {
			url = getClass().getResource("/images/rp.png");
			if (url == null)
			{ System.out.println("Cannot find image at specified location");
				throw new Exception();
			}

		} catch (Exception e) {
			// System.err.println("Exception  while creating the Rupee image : ");
			e.printStackTrace();

		}

		// -- end

		// Add Here for correction as well
		if ("Correction".equals(valueOfTypeOfStmt)|| "Regular".equals(valueOfTypeOfStmt)) // .grpu
		{

			// Added by to enable challan

			initializeDDOTab();

			// end enable challan

			// annexure 1 here idhar

			initializeAnneTab(formNumber); // -- Form Number Passed Ab
			// amit
			/*Called initializeUtilityTab function from new separated class, InitializeUtilityTab
			added new grpu object
			FRD1.9 on 01/27/2017 */
			InitializeUtilityTab iu = new InitializeUtilityTab();
			iu.initializeUtilityTab(grpu);
		}
		// in case of correction initializeDDOTabf will be called form
		// import_or_open_file function as
		// the num of DDO in the file is required for initialization of the
		// model in initializeDDOTab function.

		initializeMenus();
		initializeBottomMenu();
		intializeOtherVars();

		importedFileStatus = true; // by default making it true
		if (valueOfTypeOfStmt.equals("Correction") || (valueOfTypeOfStmt.equals("Regular")&& "Open".equals(method))) {

			importedFileStatus = import_or_open_file(selFile, method,typeOfFile);
			// added by cholia to change the drop down on the click of differnt 
			// row

			jTableTransacDetails1
			.getColumnModel()
			.getColumn(1)
			.setCellEditor(
					new GRPUTableCellEditorUpdModeannex1(count_annex1));

			if (jText_disabledFromNum.getText().equals("24Q")
					&& jComboBox_Quarter.getSelectedItem() != null)
				if (jComboBox_Quarter.getSelectedItem().equals("Q4")) {
					jTableTransacDetails2
					.getColumnModel()
					.getColumn(1)
					.setCellEditor(
							new GRPUTableCellEditorUpdModeannex2(
									count_annex2));
				}

			jTableTransacDetails
			.getColumnModel()
			.getColumn(0)
			.setCellEditor(
					new GRPUTableCellEditorUpdModeChallan(count_challan));

			// cholia end for the drop down
			if (!jComboBox_TypeOfCorrection.getSelectedItem().toString()
					.equalsIgnoreCase("Modify"))
				disableFields();
		}
		if (!importedFileStatus) {
			// System.out.println("**** IN IF *****");
			gRPUMain.setVisible(true);
			// gRPUMain.resetAllFields();
			return;
		} else {
			gRPUMain.setVisible(false);
		}
		intializeEnd(); // ye bhi hai

		enableDisableBusinessKeyFields();
		// System.out.println("1 enabledisable");
		enableDisableBottomButton();
		setExtendedState(JFrame.MAXIMIZED_BOTH);
		setVisible(true);
		// System.out.println("AIN number:" + jText_AIN.getText());

	}

	private void initializeCommon() {

		import_fileFrame = new JFrame();
		JdialogFrame = new JFrame("");

		TabGRPU = new JTabbedPane();
		jPanelButton = new JPanel();

		/********************************************************/
		jPanelTab1 = new JPanel();
		jPanelTab2 = new JPanel();
		/********************************************************/

		contentGRPU = (JPanel) getContentPane();
		contentGRPU.setLayout(new BorderLayout(8, 10));

		jPanelMenu = new JPanel(new GridLayout(3, 0, 0, 0));
		contentGRPU.add(jPanelMenu, "North");
		contentGRPU.add(TabGRPU, "Center");
		contentGRPU.add(jPanelButton, "South");
		contentGRPU.setBorder(BorderFactory.createEtchedBorder());

		font = new Font(fontName, 1, 12);
		fontHeading = new Font(fontName, 1, 12);
		fontButton = new Font(fontName, 1, 12);
		fontTab = new Font(fontName, 1, 12);
		Font fontTabPanel = new Font(fontName, 1, 12);

		PanelBatchDet = new JPanel();
		PanelTransacDet = new JPanel();
		PanelAnnexureDet = new JPanel();
		PanelAnnexure2Det = new JPanel();
		PannelFormHeaderDet = new JPanel();
		PanelUtility = new JPanel();			//new panel added for utility
		// added by for insert row
		panel_insert = new JPanel();


		TabGRPU.setFont(fontTabPanel);
		TabGRPU.setSize(0, 200);
		TabGRPU.addTab("Form", PanelBatchDet);
		TabGRPU.addTab("Challan", PanelTransacDet);
		if(!"27EQ".equals(formNum))
			TabGRPU.addTab("Annexure I (Deductee details)", PanelAnnexureDet);
		else
			TabGRPU.addTab("Annexure I (Collectee details)", PanelAnnexureDet);
		if (TabGRPU.getComponentCount() < 4){
			TabGRPU.addTab("Other Services of TIN", PanelUtility);
		}
	}

	private void intializeEnd() {
		colorGRPU();

		// used ddoflag to avoid null pointer exception because table if invalid
		// file is imported intialize DDoTab will not be called and table will
		// not be created
		if (ddoTabFlag) {
			// funToolTips(); commented by
			// to intialize the value of Revision mode
			if (valueOfTypeOfStmt.equals("Correction") && !fileExtsn.equals("")) {
				for (int i = 2; i < numDdoRowsCorr; i++) {
					// model.setValueAt("--Select--", i, 2); // Modified by
					// Akansha
				}
			}
		}
		BH_REGsetTabStops();

		InitialFocusSetter.setInitialFocus(this, jText_AIN);
		setLabelcolor();
		getContentPane().enableInputMethods(false);
		Object o = jComboBox_TypOfStmt.getSelectedItem();
		if (o.toString().equals("Regular")) {
			addBlankRows(GRPUConstants.DEFAULT_ROWS_COUNT, false);
			//addBlankRows1(GRPUConstants.DEFAULT_ROWS_COUNT,0,false,false); //comented idhar
			// by to disable annexure 1

		}

		setTitle(GrpuUtil.GRPU_TITLE);
		setLocation(new Point(0, 0));
		setSize(new Dimension(1023, 720));
		setIconImage(GrpuUtil.GRPULogo);
		setDefaultCloseOperation(0);
		setResizable(true);
		setClipboard("");
		aoData[0] = jText_AIN.getText();
		aoData[1] = jText_AOName.getText();
		aoData[2] = jText_AOADD1.getText();
		aoData[3] = jText_AOADD2.getText();
		aoData[4] = jText_AOADD3.getText();
		aoData[5] = jText_AOADD4.getText();
		aoData[6] = jText_AOCity.getText();
		aoData[7] = jComboBox_AOState.getSelectedItem().toString();
		aoData[8] = jText_AOPIN.getText();
		aoData[9] = jText_STD.getText();
		aoData[10] = jText_PhoneNo.getText();
		aoData[11] = jText_EmailID.getText();
		aoData[12] = jText_ResponsiblePersonName.getText();
		aoData[13] = jText_ResponsiblePersonDesgn.getText();
		aoData[14] = jComboBox_FinYear1.getSelectedItem().toString();
		aoData[15] = jComboBox_Deductor_Category.getSelectedItem().toString();
		aoData[16] = jComboBox_Month.getSelectedItem().toString();
		aoData[17] = jText_regNoPaoDtoCddo.getText();
		aoData[18] = jComboBox_State_Name.getSelectedItem().toString();
		aoData[19] = jComboBox_MinistryName.getSelectedItem().toString();
		aoData[20] = jComboBox_SubMinistryName.getSelectedItem().toString();
		aoData[21] = jText_OtherMinistryName.getText();
		aoData[22] = jText_ResponsiblePersonADD1.getText();
		aoData[23] = jText_ResponsiblePersonADD2.getText();
		aoData[24] = jText_ResponsiblePersonADD3.getText();
		aoData[25] = jText_ResponsiblePersonADD4.getText();
		aoData[26] = jText_ResponsiblePersonCity.getText();
		aoData[27] = jComboBox_ResponsiblePersonState.getSelectedItem()
				.toString();
		aoData[28] = jText_ResponsiblePersonPIN.getText();
		aoData[29] = jText_ResponsiblePersonSTD.getText();
		aoData[30] = jText_ResponsiblePersonPhoneNo.getText();
		aoData[31] = jText_ResponsiblePersonMobilePhoneNo.getText();
		aoData[32] = jText_ResponsiblePersonEmailID.getText();

	}

	private void addComponent(Container container, Component c, int x, int y,
			int width, int height) {
		c.setBounds(x, y, width, height);
		container.add(c);
	}

	private void textitem1_actionPerformed(ActionEvent e) {
		switch (pasteintotextbox) {
		case 0: // '\0'
			setClipboard(jText_AIN.getText());
			jText_AIN.setText("");
			break;

		case 2: // '\002'
			setClipboard(jText_AOADD1.getText());
			jText_AOADD1.setText("");
			break;

		case 3: // '\003'
			setClipboard(jText_AOADD2.getText());
			jText_AOADD2.setText("");
			break;

		case 4: // '\004'
			setClipboard(jText_AOADD3.getText());
			jText_AOADD3.setText("");
			break;

		case 5: // '\005'
			setClipboard(jText_AOCity.getText());
			jText_AOCity.setText("");
			break;

		case 6: // '\006'
			setClipboard(jText_AOName.getText());
			jText_AOName.setText("");
			break;

		case 7: // '\007'
			setClipboard(jText_AOPIN.getText());
			jText_AOPIN.setText("");
			break;

		case 8: // '\b'
			setClipboard(jText_EmailID.getText());
			jText_EmailID.setText("");
			break;

		case 9: // '\t'
			setClipboard(jText_PhoneNo.getText());
			jText_PhoneNo.setText("");
			break;

		case 10: // '\n'
			setClipboard(jText_ResponsiblePersonDesgn.getText());
			jText_ResponsiblePersonDesgn.setText("");
			break;

		case 11: // '\013'
			setClipboard(jText_ResponsiblePersonName.getText());
			jText_ResponsiblePersonName.setText("");
			break;

		case 12: // '\f'
			setClipboard(jText_AOADD4.getText());
			jText_AOADD4.setText("");
			break;

		case 13: // '\r'
			setClipboard(jText_STD.getText());
			jText_STD.setText("");
			break;

		case 14: // '\r'
			setClipboard(jText_ResponsiblePersonADD1.getText());
			jText_ResponsiblePersonADD1.setText("");
			break;

		case 15: // '\r'
			setClipboard(jText_ResponsiblePersonADD2.getText());
			jText_ResponsiblePersonADD2.setText("");
			break;

		case 16: // '\r'
			setClipboard(jText_ResponsiblePersonADD3.getText());
			jText_ResponsiblePersonADD3.setText("");
			break;

		case 17: // '\r'
			setClipboard(jText_ResponsiblePersonADD4.getText());
			jText_ResponsiblePersonADD4.setText("");
			break;

		case 18: // '\r'
			setClipboard(jText_ResponsiblePersonCity.getText());
			jText_ResponsiblePersonCity.setText("");
			break;

		case 19: // '\r'
			setClipboard(jText_ResponsiblePersonPIN.getText());
			jText_ResponsiblePersonPIN.setText("");
			break;

		case 20: // '\r'
			setClipboard(jText_ResponsiblePersonSTD.getText());
			jText_ResponsiblePersonSTD.setText("");
			break;

		case 21: // '\r'
			setClipboard(jText_ResponsiblePersonPhoneNo.getText());
			jText_ResponsiblePersonPhoneNo.setText("");
			break;

		case 22: // '\r'
			setClipboard(jText_ResponsiblePersonMobilePhoneNo.getText());
			jText_ResponsiblePersonMobilePhoneNo.setText("");
			break;

		case 23: // '\r'
			setClipboard(jText_ResponsiblePersonEmailID.getText());
			jText_ResponsiblePersonEmailID.setText("");
			break;

		case 24: // '\r'
			setClipboard(jText_regNoPaoDtoCddo.getText());
			jText_regNoPaoDtoCddo.setText("");
			break;

		case 25: // '\r'
			setClipboard(jText_OtherMinistryName.getText());
			jText_OtherMinistryName.setText("");
			break;
		}
	}

	private void textitem2_actionPerformed(ActionEvent e) {
		switch (pasteintotextbox) {
		case 0: // '\0'
			setClipboard(jText_AIN.getText());
			break;

		case 2: // '\002'
			setClipboard(jText_AOADD1.getText());
			break;

		case 3: // '\003'
			setClipboard(jText_AOADD2.getText());
			break;

		case 4: // '\004'
			setClipboard(jText_AOADD3.getText());
			break;

		case 5: // '\005'
			setClipboard(jText_AOCity.getText());
			break;

		case 6: // '\006'
			setClipboard(jText_AOName.getText());
			break;

		case 7: // '\007'
			setClipboard(jText_AOPIN.getText());
			break;

		case 8: // '\b'
			setClipboard(jText_EmailID.getText());
			break;

		case 9: // '\t'
			setClipboard(jText_PhoneNo.getText());
			break;

		case 10: // '\n'
			setClipboard(jText_ResponsiblePersonDesgn.getText());
			break;

		case 11: // '\013'
			setClipboard(jText_ResponsiblePersonName.getText());
			break;

		case 12: // '\f'
			setClipboard(jText_AOADD4.getText());
			break;

		case 13: // '\r'
			setClipboard(jText_STD.getText());
			break;

		case 14: // '\r'
			setClipboard(jText_ResponsiblePersonADD1.getText());
			break;

		case 15: // '\r'
			setClipboard(jText_ResponsiblePersonADD2.getText());
			break;

		case 16: // '\r'
			setClipboard(jText_ResponsiblePersonADD3.getText());
			break;

		case 17: // '\r'
			setClipboard(jText_ResponsiblePersonADD4.getText());
			break;

		case 18: // '\r'
			setClipboard(jText_ResponsiblePersonCity.getText());
			break;

		case 19: // '\r'
			setClipboard(jText_ResponsiblePersonPIN.getText());
			break;

		case 20: // '\r'
			setClipboard(jText_ResponsiblePersonSTD.getText());
			break;

		case 21: // '\r'
			setClipboard(jText_ResponsiblePersonPhoneNo.getText());
			break;

		case 22: // '\r'
			setClipboard(jText_ResponsiblePersonMobilePhoneNo.getText());
			break;

		case 23: // '\r'
			setClipboard(jText_ResponsiblePersonEmailID.getText());
			break;

		case 24: // '\r'
			setClipboard(jText_regNoPaoDtoCddo.getText());
			break;

		case 25: // '\r'
			setClipboard(jText_OtherMinistryName.getText());
			break;

		}
	}

	private void textitem3_actionPerformed(ActionEvent e) {

		switch (pasteintotextbox) {
		case 0: // '\0'
			jText_AIN.setText(getClipboard());
			break;

		case 2: // '\002'
			jText_AOADD1.setText(getClipboard());
			break;

		case 3: // '\003'
			jText_AOADD2.setText(getClipboard());
			break;

		case 4: // '\004'
			jText_AOADD3.setText(getClipboard());
			break;

		case 5: // '\005'
			jText_AOCity.setText(getClipboard());
			break;

		case 6: // '\006'
			jText_AOName.setText(getClipboard());
			break;

		case 7: // '\007'
			jText_AOPIN.setText(getClipboard());
			break;

		case 8: // '\b'
			jText_EmailID.setText(getClipboard());
			break;

		case 9: // '\t'
			jText_PhoneNo.setText(getClipboard());
			break;

		case 10: // '\n'
			jText_ResponsiblePersonDesgn.setText(getClipboard());
			break;

		case 11: // '\013'
			jText_ResponsiblePersonName.setText(getClipboard());
			break;

		case 12: // '\f'
			jText_AOADD4.setText(getClipboard());
			break;

		case 13: // '\r'
			jText_STD.setText(getClipboard());
			break;

		case 14: // '\r'
			jText_ResponsiblePersonADD1.setText(getClipboard());
			break;

		case 15: // '\r'
			jText_ResponsiblePersonADD2.setText(getClipboard());
			break;

		case 16: // '\r'
			jText_ResponsiblePersonADD3.setText(getClipboard());
			break;

		case 17: // '\r'
			jText_ResponsiblePersonADD4.setText(getClipboard());
			break;

		case 18: // '\r'
			jText_ResponsiblePersonCity.setText(getClipboard());
			break;

		case 19: // '\r'
			jText_ResponsiblePersonPIN.setText(getClipboard());
			break;

		case 20: // '\r'
			jText_ResponsiblePersonSTD.setText(getClipboard());
			break;

		case 21: // '\r'
			jText_ResponsiblePersonPhoneNo.setText(getClipboard());
			break;

		case 22: // '\r'
			jText_ResponsiblePersonMobilePhoneNo.setText(getClipboard());
			break;

		case 23: // '\r'
			jText_ResponsiblePersonEmailID.setText(getClipboard());
			break;

		case 24: // '\r'
			jText_regNoPaoDtoCddo.setText(getClipboard());
			break;

		case 25: // '\r'
			jText_OtherMinistryName.setText(getClipboard());
			break;

		}
	}

	// Redundant code
	/*
	 * private void item3_actionPerformed(ActionEvent e) { cntPasteClk++; try {
	 * data = model.getDataVector(); row = (Vector) data.elementAt(copyRow); row
	 * = (Vector) row.clone(); Vector firstRow = (Vector)
	 * data.elementAt(selRow); Vector cutRow = (Vector) data.elementAt(copyRow);
	 * for (int i = 3; i < row.size(); i++) firstRow.set(i, row.get(i));
	 * 
	 * if (isCutRow) { for (int i = 3; i < row.size(); i++) if (copyRow !=
	 * selRow) if (i == 15 || i == 23 || i == 24) cutRow.set(i, "--Select--");
	 * else cutRow.set(i, "");
	 * 
	 * } isCutRow = false; } catch (Exception e1) { e1.printStackTrace(); } }
	 */

	// Copy paste of the rows data to the next row
	public String[] tokeniseExcel(String strExcel, int rowN) {
		int i = 0;
		int caretPos = 0;
		int nxtCaretPos = 0;
		String MthYrArray[] = new String[2];
		Object o = jComboBox_TypOfStmt.getSelectedItem();
		String ExcelReg[];
		if (o.toString().equals("Regular"))
			ExcelReg = new String[11];
		else
			ExcelReg = new String[13];
		for (int j = 0; j < ExcelReg.length; j++)
			ExcelReg[j] = "";

		int lastCaretPos = strExcel.lastIndexOf("\t");
		try {
			if (lastCaretPos == -1) {
				nxtCaretPos = strExcel.length();
				ExcelReg[i] = strExcel.substring(caretPos, nxtCaretPos);
			} else {
				nxtCaretPos = strExcel.indexOf("\t", caretPos + 1);
				ExcelReg[i] = strExcel.substring(caretPos, nxtCaretPos);
				caretPos = nxtCaretPos;
				for (i++; caretPos < lastCaretPos; i++) {
					nxtCaretPos = strExcel.indexOf("\t", caretPos + 1);
					ExcelReg[i] = strExcel.substring(caretPos + 1, nxtCaretPos);
					caretPos = nxtCaretPos;
				}

				ExcelReg[i] = strExcel.substring(lastCaretPos + 1,
						strExcel.length());
			}
		} catch (ArrayIndexOutOfBoundsException e) {
			getMessage("Error Copying Row Number : " + rowN
					+ "\nThe selection done by you has "
					+ "more elements.Paste Fail");
			return null;
		} catch (Exception e1) {
			return null;
		}
		return ExcelReg;
	}

	// ************************************************************

	public int[] getTABSpaceArr(String excelStr) {
		try {
			int caretPos = 0;
			int nxtCaretPos = 0;
			int tabPos[] = (int[]) null;
			totalCnt = 0;
			int i = 0;
			int chkOnlyOneElemnt = excelStr.indexOf("\t", caretPos);
			if (chkOnlyOneElemnt < 0)
				totalCnt = 1;
			else
				while ((nxtCaretPos = excelStr.indexOf("\t", caretPos)) >= 0) {
					caretPos = nxtCaretPos + 1;
					totalCnt++;
				}
			tabPos = new int[totalCnt];
			caretPos = 0;
			nxtCaretPos = 0;
			int lastCaretPos = excelStr.lastIndexOf("\t");
			if (lastCaretPos == -1) {
				nxtCaretPos = excelStr.length();
			} else {
				caretPos = 0;
				for (nxtCaretPos = 0; (nxtCaretPos = excelStr.indexOf("\t",
						caretPos)) >= 0;) {
					tabPos[i] = nxtCaretPos;
					caretPos = nxtCaretPos + 1;
					i++;
				}

			}
			return tabPos;
		} catch (ArrayIndexOutOfBoundsException e) {
			return null;
		} catch (Exception e1) {
			return null;
		}
	}

	public int[] returnEachXL_RowPos(String excelStr) {
		try {
			int caretPos = 0;
			int nxtCaretPos = 0;
			int LinePos[] = (int[]) null;
			totalLineCnt = 0;
			int i = 0;
			while ((nxtCaretPos = excelStr.indexOf("\n", caretPos)) > 0) {
				caretPos = nxtCaretPos + 1;
				totalLineCnt++;
			}
			LinePos = new int[totalLineCnt];
			caretPos = 0;
			nxtCaretPos = 0;
			int lastCaretPos = excelStr.lastIndexOf("\n");
			if (lastCaretPos == -1) {
				nxtCaretPos = excelStr.length();
			} else {
				nxtCaretPos = excelStr.indexOf("\n", caretPos);
				LinePos[i] = nxtCaretPos;
				caretPos = nxtCaretPos + 1;
				for (i++; caretPos < lastCaretPos; i++) {
					nxtCaretPos = excelStr.indexOf("\n", caretPos);
					LinePos[i] = nxtCaretPos;
					caretPos = nxtCaretPos + 1;
				}

			}
			return LinePos;
		} catch (ArrayIndexOutOfBoundsException e) {
			return null;
		} catch (Exception e1) {
			return null;
		}
	}

	public String returnXLRows(int RowPos[], String excelRow) {
		String subStr1_Line = "";
		String subStr2_Line = "";
		String emptyStr_Line = "";
		String ExcelStr = excelRow;
		String New_XL_Str = "";
		recursiveCount = 0;
		Recrsncnt = 0;
		int tabPos[] = (int[]) null;
		try {
			for (int i = 0; i < RowPos.length; i++) {
				if (i + 1 >= RowPos.length)
					break;
				if (RowPos[i + 1] == RowPos[i] + 1) {
					subStr1_Line = ExcelStr.substring(0, RowPos[i + 1]);
					subStr2_Line = ExcelStr.substring(RowPos[i + 1],
							ExcelStr.length());
					ExcelStr = subStr1_Line + emptyStr_Line + subStr2_Line;
				}
			}

			StringTokenizer a = new StringTokenizer(ExcelStr, "\n");
			Vector xlRows = new Vector(a.countTokens());
			for (; a.hasMoreTokens(); xlRows.addElement(a.nextToken()
					.toString()))
				;
			for (int j = 0; j < xlRows.size(); j++)
				if (xlRows.elementAt(j).toString().trim().equals(""))
					xlRows.add(j, "grpuline");

			for (int j = 0; j < xlRows.size(); j++)
				if (!xlRows.elementAt(j).toString().equals("grpuline")) {
					tabPos = getTABSpaceArr(xlRows.elementAt(j).toString());
					New_XL_Str = New_XL_Str
							+ returnXLStr(tabPos, xlRows.elementAt(j)
									.toString()) + "\n";
				} else {
					New_XL_Str = New_XL_Str.trim()
							+ xlRows.elementAt(j).toString();
				}

			int last_Slash_n_Pos = New_XL_Str.lastIndexOf("\n");
			return New_XL_Str.substring(0, last_Slash_n_Pos);
		} catch (Exception e1) {
			e1.printStackTrace();
		}
		return null;
	}

	public String returnXLStr(int tabArr[], String excelStr) {
		String subStr1 = "";
		String subStr2 = "";
		String emptyStr = "";
		String ExcelStr = excelStr;
		int i = recursiveCount;
		try {
			StringTokenizer chkCount = new StringTokenizer(ExcelStr, "\t");
			if (chkCount.countTokens() == 11)
				return ExcelStr;
			for (int j = 0; j < tabArr.length - 1; j++) {
				int k = j + 1;
				if (tabArr[k] == tabArr[j] + 1)
					Recrsncnt++;
			}

			if (Recrsncnt == 0
					&& tabArr[0] != 0
					&& !ExcelStr.substring(tabArr[0] + 1, ExcelStr.length())
					.trim().equals(""))
				return ExcelStr;
			while (recursiveCount < tabArr.length) {
				if (i + 1 > tabArr.length)
					break;
				if (i + 1 == tabArr.length) {
					subStr1 = ExcelStr.substring(0, tabArr[i]);
					subStr2 = ExcelStr.substring(tabArr[i], ExcelStr.length());
					if (ExcelStr.substring(tabArr[i] + 1, ExcelStr.length())
							.trim().equals(""))
						ExcelStr = subStr1 + "\t" + emptyStr + subStr2;
					recursiveCount += 2;
					i = recursiveCount;
					break;
				}
				if (tabArr[i] == 0) {
					subStr1 = emptyStr;
					subStr2 = ExcelStr.substring(tabArr[i], ExcelStr.length());
					ExcelStr = subStr1 + subStr2;
					tabArr = getTABSpaceArr(ExcelStr);
					recursiveCount++;
					i = recursiveCount;
					ExcelStr = returnXLStr(tabArr, ExcelStr);
					break;
				}
				if (tabArr[i + 1] == tabArr[i] + 1) {
					subStr1 = ExcelStr.substring(0, tabArr[i + 1]);
					subStr2 = ExcelStr.substring(tabArr[i + 1],
							ExcelStr.length());
					ExcelStr = subStr1 + emptyStr + subStr2;
					tabArr = getTABSpaceArr(ExcelStr);
					recursiveCount++;
					i = recursiveCount;
					ExcelStr = returnXLStr(tabArr, ExcelStr);
					break;
				}
				recursiveCount++;
				i = recursiveCount;
			}
			recursiveCount = 0;
			return ExcelStr;
		} catch (Exception e1) {
			e1.printStackTrace();
		}
		return null;
	}

	private void pasteXL(String tabname) {
		
		//Col_Pselect + j == actual col no-1
		
		System.out.println("Inside pasteXL");
		int Row_Pselect = 0;
		int Col_Pselect = 0;
		String excelStr = getClipboard();
		try {
			if ((excelStr == null || excelStr.trim().equals(""))) {
				//new development for FRD1.5 by Akansha
				if (!excelStr.contains("\n")) {
					getMessage("No data found for Paste.. ");
					return;
				}
				//**************************************
			}

			Vector rowsList = new Vector();
			//new development for FRD1.5 by akansha
			//Developed for pasting the blank values into the cells
			if(excelStr.contains("\n")){
				//newly added since '\n' is appended at the end of excel data 
				//and while copying from RPU no '\n' is appended
				//System.out.println("String is present: "+excelStr);
				/*if("\n".equals(excelStr.substring(excelStr.length()-1,excelStr.length()))){
					excelStr = excelStr.replace("\n", "\"#$%()Akki#$%()\"\n");
					//excelStr = excelStr.substring(0,excelStr.length()-16);
				}
				else{*/
				excelStr = excelStr.replace("\n", "\"#$%()Akki#$%()\"\n");
				//}
				//excelStr = excelStr.substring(0,excelStr.length()-16);

			}
			//*********************************************************
			StringTokenizer rows = new StringTokenizer(excelStr,"\n");
			//System.out.println("Excel str:"+excelStr);

			// added by cholia here
			if (tabname.trim().equals("Challan")) {
				if (rows.countTokens() > model.getRowCount()
						- jTableTransacDetails.getSelectedRow()) {
					getMessage("Not enough no of rows to paste... ");
					return;
				} else {
					Row_Pselect = jTableTransacDetails.getSelectedRow();
					Col_Pselect = jTableTransacDetails.getSelectedColumn();
				}

			}

			else if (tabname.trim().equals("Anne1")) {
				if (rows.countTokens() > model1.getRowCount()
						- jTableTransacDetails1.getSelectedRow()) {
					getMessage("Not enough no of rows to paste... ");
					return;
				} else {
					System.out.println("inside annex1");
					Row_Pselect = jTableTransacDetails1.getSelectedRow();
					Col_Pselect = jTableTransacDetails1.getSelectedColumn();
				}

			} else if (tabname.trim().equals("Anne2")) {
				if (rows.countTokens() > model2.getRowCount()
						- jTableTransacDetails2.getSelectedRow()) {
					getMessage("Not enough no of rows to paste... ");
					return;
				} else {
					Row_Pselect = jTableTransacDetails2.getSelectedRow();
					Col_Pselect = jTableTransacDetails2.getSelectedColumn();
				}

			}
			while (rows.hasMoreTokens()) {
				String prevToken = null;
				String sep = "\t";
				StringTokenizer cols = new StringTokenizer(rows.nextToken(),
						"\t", true);

				Vector currRow = new Vector();
				while (cols.hasMoreTokens()) {
					String currTok = cols.nextToken();
					//new development for FRD1.5 by akansha
					//Developed for pasting the blank values into the cells
					if(currTok.contains("\"#$%()Akki#$%()\"")){
						currTok =currTok.replace("\"#$%()Akki#$%()\"","");
					}
					//***************************************************
					if (prevToken == null && currTok.equals(sep)) {
						currRow.add("");

					} else if (prevToken == null && !currTok.equals(sep)) {
						currRow.add(currTok);

					} else if (prevToken.equals(sep) && currTok.equals(sep)) {
						currRow.add("");

					} else if (!prevToken.equals(sep) && currTok.equals(sep)) {

					} else {
						currRow.add(currTok);

					}

					prevToken = currTok;
				}

				//new development for FRD1.5 by akansha
				//newly commented for Req no: 14 ---> restriction on the number of columns to be
				//pasted should be removed from 16 to any number
				/*if (currRow.size() > 16) {
					getMessage("More than 16 columns cannot be pasted");
					return;
				}*/
				rowsList.add(currRow);
			}

			// adding to table
			final int selYear_anne2 = Integer
					.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem()
							.toString().substring(0, 4));
			final int next_year_anne2 = Integer
					.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem()
							.toString().substring(5, 9));

			// newly by cholia on 2march
			DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
			DecimalFormat df = new DecimalFormat("0.00",sf);
			df.setMaximumFractionDigits(2);
			// end newly by cholia on 2march
			
			int count = 0;
			int countCh = 0;
			int count1 = 0;
			int count2 = 0;
			int count3 = 0;
			int count4 = 0;
			int count5 = 0;
			int count6=0;

			/****************** Added for 2.7 Start for - count7 Added Sec 10 values col60+....col65 
			 * count 8 Add col59+...+col61********************/
			int count7 = 0;
			int count8 = 0;
			/****************** Added for 2.7 End ********************/
			// newly added by cholia on 13 march
			double col7annex1 = 0;
			double intrstannex1 = 0;
			double othersannex1 = 0;
			double chTds = 0;
			double chSur = 0;
			double chCess = 0;
			String bsrCode = "";
			String chDateTaxDpsted = "";
			String chDdoSrNo = "";
			
			// end
			for (int i = 0; i < rowsList.size(); i++) {
				Vector currTDRow = ((Vector) rowsList.get(i));
				if (tabname.trim().equals("Challan")) {
					double totalSemcol10 = 0;
					count = 0;
					countCh = 0;
					count2 = 0;
					col7annex1 = 0;
					for (int j = 0; j < currTDRow.size()
							&& (Col_Pselect + j) < model.getColumnCount(); j++) {
						//System.out.println("currTDRow: "+ currTDRow.elementAt(j));
						if (Row_Pselect != 0 && Row_Pselect != 1) { // newly
							// added by
							// cholia
							// here on
							// feb
							// 27.02.2015
							if (valueOfTypeOfStmt
									.equalsIgnoreCase("Correction")
									&& Row_Pselect < row_count_challan) // newly
								// added
								// by
								// cholia
								// 0n 9
								// march
							{
								//new development for FRD1.3 by Akansha
								if(Col_Pselect + j == 0)
								{
									if("Update".equals(currTDRow.elementAt(j).toString()))
										model.setValueAt(
												currTDRow.elementAt(j),
												Row_Pselect + i, 1);
								}
								//*********************************************************
								// newly added by cholia on 5 march 2014
								String mode = "";
								Object modeObj = model.getValueAt(Row_Pselect
										+ i, 1);
								if (modeObj != null)
									mode = modeObj.toString();
								if ("--Select--".equals(mode)) {

								}

								if ("ADD".equals(mode)) {
									if (selYear_anne2 < 2010) {
										if (Col_Pselect + j == 1
												|| Col_Pselect + j == 2
												|| Col_Pselect + j == 3
												|| Col_Pselect + j == 4
												|| Col_Pselect + j == 5
												|| Col_Pselect + j == 7
												|| Col_Pselect + j == 10
												|| Col_Pselect + j == 12
												|| Col_Pselect + j == 14
												|| Col_Pselect + j == 16
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19
												|| Col_Pselect + j == 14)// newly
											// added
											// by
											// cholia
											// Date
											// column
										{
											if (Col_Pselect + j == 5) // $$ New
												// development
												// for
												// Java
												// RPU
												// Ver1.2
												//new development for FRD1.5 by akansha
												model.setValueAt(GrpuUtil.validRupee(
														currTDRow.elementAt(j)),
														Row_Pselect + i, 19);
											// ******************************************************
											//new development for FRD1.5 by akansha
											else if(Col_Pselect + j ==14){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){
														model.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
													else												

														model.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flagging = false;
													model.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}
											//new development for FRD1.5 by akansha
											else if(Col_Pselect + j == 2
													|| Col_Pselect + j == 3
													|| Col_Pselect + j == 4
													|| Col_Pselect + j == 5
													|| Col_Pselect + j == 7
													||Col_Pselect + j == 18
													|| Col_Pselect + j == 19){
												model.setValueAt(
														GrpuUtil.validRupee(currTDRow.elementAt(j)),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}

											//******************************************************************
											else

												model.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

										}

										else if (Col_Pselect + j == 17) // tds
											// deposited
											// by
											// book
											// entry
										{

											model.setValueAt(
													currTDRow.elementAt(j),
													Row_Pselect + i, // newly
													// added
													// by
													// cholia
													Col_Pselect + 1 + j); // newly
											// changed
											// by
											// cholia

										}

									} else {
										
										if (Col_Pselect + j == 1
												|| Col_Pselect + j == 2
												|| Col_Pselect + j == 3
												|| Col_Pselect + j == 4
												|| Col_Pselect + j == 5
												|| Col_Pselect + j == 7
												|| Col_Pselect + j == 10
												|| Col_Pselect + j == 12
												|| Col_Pselect + j == 14
												|| Col_Pselect + j == 16
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19
												|| Col_Pselect + j == 6)// fee
											// adde
											// more
										{
											//new development for FRD1.5 by akansha
											if (Col_Pselect + j == 5) // $$ New
												// development
												// for
												// Java
												// RPU
												// Ver1.2
												model.setValueAt(
														GrpuUtil.validRupee(currTDRow.elementAt(j)),
														Row_Pselect + i, 19);
											// ******************************************************
											//new development for FRD1.5 by akansha
											else if(Col_Pselect + j ==14){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){
														model.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
													else	

														model.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flagging = false;
													model.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}
											//******************************************************************
											//new development for FRD1.5 by akansha
											else if(Col_Pselect + j == 2
													|| Col_Pselect + j == 3
													|| Col_Pselect + j == 4
													|| Col_Pselect + j == 5
													|| Col_Pselect + j == 7
													||Col_Pselect + j == 18
													|| Col_Pselect + j == 19){
												model.setValueAt(
														GrpuUtil.validRupee(currTDRow.elementAt(j)),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}
											//*************************************************************
											else
												model.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

										}

										else if (Col_Pselect + j == 17
												|| Col_Pselect + j == 20) // tds
											// deposited
											// by
											// book
											// entry
										{
											model.setValueAt(
													currTDRow.elementAt(j),
													Row_Pselect + i,
													Col_Pselect + 1 + j);
										}

										else {
											// no value to be added
										}

									}
								}
								if ("Update".equals(mode)) // newly added by
									// cholia on 5 march
									// 2014
								{


									if (challantype.charAt(Row_Pselect + i - 2) == 'U') { // selCol
										// +
										// j==14
										// Date
										countCh++; // column
										if (selYear_anne2 < 2010) {
											if (Col_Pselect + j == 1
													|| Col_Pselect + j == 2
													|| Col_Pselect + j == 3
													|| Col_Pselect + j == 4
													|| Col_Pselect + j == 5
													|| Col_Pselect + j == 7
													|| Col_Pselect + j == 8
													|| Col_Pselect + j == 10
													|| Col_Pselect + j == 12
													|| Col_Pselect + j == 14
													|| Col_Pselect + j == 16
													|| Col_Pselect + j == 18
													|| Col_Pselect + j == 19
													|| Col_Pselect + j == 14)// newly
												// added
												// by
												// cholia
												// Date
												// column
											{
												//new development for FRD1.5 by akansha
												if (Col_Pselect + j == 5) // $$
													// New
													// development
													// for
													// Java
													// RPU
													// Ver1.2
													model.setValueAt(GrpuUtil.validRupee(currTDRow
															.elementAt(j)),
															Row_Pselect + i, 19);
												// ******************************************************
												//new development for FRD1.5 by akansha
												else if(Col_Pselect + j ==14){
													if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

														//newly developed for FRD1.5 Ver1.5 by akansha
														if(currTDRow.elementAt(j).toString().contains("-")){

															model.setValueAt(
																	currTDRow.elementAt(j).toString().replace("-","/"),
																	Row_Pselect + i, Col_Pselect
																	+ 1 + j);
														}
														else	

															model.setValueAt(
																	currTDRow.elementAt(j),
																	Row_Pselect + i, Col_Pselect
																	+ 1 + j);
													}else{
														//System.out.println("Inside else");
														flagging = false;
														model.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
												}
												//******************************************************************

												//new development for FRD1.5 by akansha
												else if(Col_Pselect + j == 2
														|| Col_Pselect + j == 3
														|| Col_Pselect + j == 4
														|| Col_Pselect + j == 5
														|| Col_Pselect + j == 7
														||Col_Pselect + j == 18
														|| Col_Pselect + j == 19){
													model.setValueAt(
															GrpuUtil.validRupee(currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
												//**************************************************

												else
													model.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}

											else if (Col_Pselect + j == 17) // tds
												// deposited
												// by
												// book
												// entry
											{

												model.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i, // newly
														// added
														// by
														// cholia
														Col_Pselect + 1 + j); // newly
												// changed
												// by
												// cholia

											}

											else {
												// no value to be added
											}
											// ## Newly developed for correction
											// Ver1.2 by Akansha
											if (countCh > 0) {
												double addition = 0;
												for (int ik = 3; ik <= 8; ik++) {
													if (model
															.getValueAt(
																	Row_Pselect
																	+ i,
																	ik) != null
																	&& !"".equals(model
																			.getValueAt(
																					Row_Pselect
																					+ i,
																					ik)
																					.toString()))
														//new development for FRD1.5 by akansha
														addition += Double
														.parseDouble(GrpuUtil.validRupee(model
																.getValueAt(
																		Row_Pselect
																		+ i,
																		ik)));
													//*******************************************
												}
												if (addition == totalSemcol10){
													//													System.out
													//															.println("Value in paste:"+totalSemcol10);
													model.setValueAt(
															df.format(totalSemcol10),
															Row_Pselect + i, 10);

												}else{
													//													System.out
													//													.println("Value in paste:"+addition);
													model.setValueAt(
															df.format(addition),
															Row_Pselect + i, 10);

												}
											}
											// *************************************************
										} else {

											if (challantype.charAt(Row_Pselect
													+ i - 2) == 'U') {
												countCh++;
												if (Col_Pselect + j == 1
														|| Col_Pselect + j == 2
														|| Col_Pselect + j == 3
														|| Col_Pselect + j == 4
														|| Col_Pselect + j == 5
														|| Col_Pselect + j == 7
														|| Col_Pselect + j == 8
														|| Col_Pselect + j == 10
														|| Col_Pselect + j == 12
														|| Col_Pselect + j == 14
														|| Col_Pselect + j == 16
														|| Col_Pselect + j == 18
														|| Col_Pselect + j == 19
														|| Col_Pselect + j == 6)// fee
													// adde
													// more
												{
													if (Col_Pselect + j == 5) // $$
														// New
														// development
														// for
														// Java
														// RPU
														// Ver1.2
														//new development for FRD1.5 by akansha
														model.setValueAt(
																GrpuUtil.validRupee(currTDRow
																		.elementAt(j)),
																		Row_Pselect + i,
																		19);
													// ******************************************************
													//new development for FRD1.5 by akansha
													else if(Col_Pselect + j ==14){
														if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

															//newly developed for FRD1.5 Ver1.5 by akansha
															if(currTDRow.elementAt(j).toString().contains("-")){

																model.setValueAt(
																		currTDRow.elementAt(j).toString().replace("-","/"),
																		Row_Pselect + i, Col_Pselect
																		+ 1 + j);
															}
															else																
																model.setValueAt(
																		currTDRow.elementAt(j),
																		Row_Pselect + i, Col_Pselect
																		+ 1 + j);
														}else{
															//System.out.println("Inside else");
															flagging = false;
															model.setValueAt(
																	"",
																	Row_Pselect + i, Col_Pselect
																	+ 1 + j);
														}
													}
													//******************************************************************
													//new development for FRD1.5 by akansha
													else if(Col_Pselect + j == 2
															|| Col_Pselect + j == 3
															|| Col_Pselect + j == 4
															|| Col_Pselect + j == 5
															|| Col_Pselect + j == 7
															||Col_Pselect + j == 18
															|| Col_Pselect + j == 19){
														model.setValueAt(
																GrpuUtil.validRupee(currTDRow.elementAt(j)),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}
													//*******************************************************
													else
														model.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

												else if (Col_Pselect + j == 17
														|| Col_Pselect + j == 20) // tds
													// deposited
													// by
													// book
													// entry
												{
													model.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}

												else {
													// no value to be added
												}
												// ## Newly developed for
												// correction Ver1.2 by Akansha
												if (countCh > 0) {
													double addition = 0;
													for (int ik = 3; ik <= 8; ik++) {
														if (model
																.getValueAt(
																		Row_Pselect
																		+ i,
																		ik) != null
																		&& !"".equals(model
																				.getValueAt(
																						Row_Pselect
																						+ i,
																						ik)
																						.toString()))
															//new development for FRD1.5 by akansha
															addition += Double
															.parseDouble(GrpuUtil.validRupee(model
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			ik)));
													}
													if (addition == totalSemcol10)
														model.setValueAt(
																df.format(totalSemcol10),
																Row_Pselect + i,
																10);
													else
														model.setValueAt(
																df.format(addition),
																Row_Pselect + i,
																10);
												}
												// *************************************************
											}

										}

									}

									else if (challantype.charAt(Row_Pselect + i
											- 2) == 'O') {
										if (Col_Pselect + j == 1
												|| Col_Pselect + j == 12
												|| Col_Pselect + j == 14
												|| Col_Pselect + j == 16
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19) {
											//new development for FRD1.5 by akansha
											if(Col_Pselect + j ==14){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){

														model.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
													else	
														model.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flagging = false;
													model.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}else
												//******************************************************************
												model.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
										}

										else {
											// no value to be added
										}

									}

									else if (challantype.charAt(Row_Pselect + i
											- 2) == 'M') {
										if (/*Col_Pselect + j == 1
												||*/ Col_Pselect + j == 18
												|| Col_Pselect + j == 19) {
											model.setValueAt(
													currTDRow.elementAt(j),
													Row_Pselect + i,
													Col_Pselect + 1 + j);
										} else {
											// no value to be added
										}
									}

									else if (challantype.charAt(Row_Pselect + i
											- 2) == 'P') // newly changed to P
										// by cholia
									{
										if (Col_Pselect + j == 1
												|| Col_Pselect + j == 12
												|| Col_Pselect + j == 16
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19
												|| Col_Pselect + j == 14) { // Col_Pselect
											// +
											// j==14
											// newly
											// changed
											// by
											// cholia
											//new development for FRD1.5 by akansha
											if(Col_Pselect + j ==14){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){
													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){

														model.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
													else	
														model.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flagging = false;
													model.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}else
												//******************************************************************
												model.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
										} else {
											// no value to be added
										}
									}

								}

								else {
									// no values to be selecteed
								}

							}

							else // For the regular file //newly added by cholia
								// here on feb 27.02.2015
							{



								if ((selYear_anne2 < 2012 && next_year_anne2 < 2013)
										&& (Col_Pselect + j == 6)) {

								}



								else if (Col_Pselect + j == 0) {

								}

								else if (Col_Pselect + j == 1) // for the
									// section
									// code
								{

									if (selYear_anne2 < 2013) {
										if(GrpuUtil.getDropDownSection(currTDRow.elementAt(j).toString(),formNumber))
											model.setValueAt(
													currTDRow.elementAt(j),
													Row_Pselect + i, Col_Pselect
													+ 1 + j);
									}

									else {

									}

								}
								//new development for FRD1.5 by akansha
								else if(Col_Pselect + j ==14){
									if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){
										//newly developed for FRD1.5 Ver.15 by akansha
										if(currTDRow.elementAt(j).toString().contains("-")){
											model.setValueAt(
													currTDRow.elementAt(j).toString().replace("-","/"),
													Row_Pselect + i, Col_Pselect
													+ 1 + j);
										}else									
											model.setValueAt(
													currTDRow.elementAt(j),
													Row_Pselect + i, Col_Pselect
													+ 1 + j);
									}else{
										//System.out.println("Inside else");
										flagging = false;
										model.setValueAt(
												"",
												Row_Pselect + i, Col_Pselect
												+ 1 + j);
									}
								}
								//******************************************************************
								else if (Col_Pselect + j == 17) // tds deposited
									// by
									// book entry
								{
									//Newly added for FRD ver1.3 by Akansha
									if ("Yes".equals(currTDRow.elementAt(j)
											.toString())
											|| "No".equals(currTDRow.elementAt(
													j).toString()) 
													|| "--Select--".equals(currTDRow.elementAt(j).toString())){ //newly developed for FRD1.5 by akansha
										model.setValueAt(
												currTDRow.elementAt(j),
												Row_Pselect + i, Col_Pselect
												+ 1 + j);
										//new development for FRD1.3 by Akansha
										if("Yes".equals(currTDRow.elementAt(j)
												.toString())|| "--Select--".equals(currTDRow.elementAt(j)
														.toString()))
											model.setValueAt(
													"--Select--",
													Row_Pselect + i,21);

									}
									//*****************************************************************************
								}

								else if (Col_Pselect + j == 20) { //minor head challan filtering values for 200 or 400
									// Newly added for FRD ver1.3 by Akansha
									String tdsEntry = "";
									Object tdsEntryObj = model.getValueAt(
											Row_Pselect + i, 18);
									if (tdsEntryObj != null)
										tdsEntry = tdsEntryObj.toString();

									if ("--Select--".equals(tdsEntry)
											|| "Yes".equals(tdsEntry)) {

									}
									else if ("200".equals(currTDRow.elementAt(j)
											.toString())
											|| "400".equals(currTDRow.elementAt(
													j).toString()) ||
													"--Select--".equals(currTDRow.elementAt(j).toString())) ////newly developed for FRD1.5 by akansha
										model.setValueAt(
												currTDRow.elementAt(j),
												Row_Pselect + i, Col_Pselect
												+ 1 + j);

									else if (selYear_anne2 < 2013) {

									}



								}

								// end newly added by cholia on 3 march 2015

								else if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
										&& (Col_Pselect + j == 10)) {

								}

								else if (Col_Pselect + j == 8
										|| Col_Pselect + j == 9
										|| Col_Pselect + j == 11
										|| Col_Pselect + j == 13
										|| Col_Pselect + j == 15
										|| Col_Pselect + j == 21)
									// newly added by acholia //Col_Pselect + j ==
									// 14
									// newly removed by cholia
								{

								}

								else {
									// newly added by cholia for the copy paste
									if ((Col_Pselect + j == 2)
											|| Col_Pselect + j == 3
											|| Col_Pselect + j == 4
											|| Col_Pselect + j == 5
											|| Col_Pselect + j == 6
											|| Col_Pselect + j == 7) {
										count++;
										if (j == 0) // handling the starting
											// event
										{
											//String temp ="";
											for (int k = 3; k < Col_Pselect + j
													+ 1; k++) {
												if (model.getValueAt(
														Row_Pselect + i, k) != null
														&& !"".equals(model
																.getValueAt(
																		Row_Pselect
																		+ i,
																		k))) {


													//new development for FRD1.5 by akansha
													totalSemcol10 = totalSemcol10
															+ Double.parseDouble(GrpuUtil.validRupee(model.getValueAt(Row_Pselect +i,k)));
													//**********************************************
												}

											}
										}

										if (j == currTDRow.size() - 1) {
											//String temp ="";
											for (int p = Col_Pselect + j + 2; p < 9; p++) // newly
												// changed
												// by
												// cholia
											{
												if (model.getValueAt(
														Row_Pselect + i, p) != null
														&& !"".equals(model
																.getValueAt(
																		Row_Pselect
																		+ i,
																		p))) {

													//new development for FRD1.5 by akansha
													totalSemcol10 = totalSemcol10
															+ Double.parseDouble(GrpuUtil.validRupee(model.getValueAt(Row_Pselect +i,p)));
													//*************************************************
												}
											}

										}
										//	String temp ="";
										if (Col_Pselect + j == 2
												|| Col_Pselect + j == 3
												|| Col_Pselect + j == 4
												|| Col_Pselect + j == 5
												|| Col_Pselect + j == 6
												|| Col_Pselect + j == 7) {
											if (currTDRow.elementAt(j)
													.toString() != null
													&& !"".equals(currTDRow
															.elementAt(j)
															.toString())){

												//new development for FRD1.5 by akansha
												totalSemcol10 = totalSemcol10
														+ Double.parseDouble(GrpuUtil.validRupee(currTDRow.elementAt(j)));
												//***************************************************
											}

										}
										// end newly added by cholia for the
										// copy
										// paste

									}
									int y1 = Row_Pselect + i;
									int y2 = Col_Pselect + 1 + j;

									int row2 = Row_Pselect + i;
									//	System.out.println("row number " + row2);
									if (j != -1) {
										if (currTDRow.elementAt(j).toString() != null
												&& !"".equals(currTDRow
														.elementAt(j)
														.toString()))
											if (y2 == 6) // $$ New development
												// for Java RPU
												// Ver1.2
												//new development for FRD1.5 by Akansha
												model.setValueAt(
														GrpuUtil.validRupee(currTDRow.elementAt(j)),
														Row_Pselect + i, 19);
										// ******************************************************
										//new development for FRD1.5 by Akansha
										if ((Col_Pselect + j == 2)
												|| Col_Pselect + j == 3
												|| Col_Pselect + j == 4
												|| Col_Pselect + j == 5
												|| Col_Pselect + j == 6
												|| Col_Pselect + j == 7
												|| Col_Pselect + j == 19
												|| Col_Pselect + j == 18) {
											model.setValueAt(GrpuUtil.validRupee(currTDRow.elementAt(j)),Row_Pselect + i, Col_Pselect+ 1 + j);
										}
										//********************************************
										else
											model.setValueAt(
													currTDRow.elementAt(j),
													Row_Pselect + i, Col_Pselect
													+ 1 + j);
									}
								}

							}

							if (count > 0) {
								double addition = 0;
								for (int ik = 3; ik <= 8; ik++) {
									if (model.getValueAt(Row_Pselect + i, ik) != null
											&& !"".equals(model.getValueAt(
													Row_Pselect + i, ik)
													.toString()))
										/*addition += Double
												.parseDouble(model.getValueAt(
														Row_Pselect + i, ik)
														.toString());*/
										//new development for FRD1.5 by akansha
										addition += Double
										.parseDouble(GrpuUtil.validRupee(model.getValueAt(Row_Pselect +i,ik)));
									//**************************************
								}
								//newly added for fRD1.5 by akansha
								if (addition == totalSemcol10){
									model.setValueAt(df.format(totalSemcol10),
											Row_Pselect + i, 10);
									if(totalSemcol10>=1.0 && ("Central Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())
											|| "State Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())))
										model.setValueAt("Yes", Row_Pselect + i, 18);
									else if(totalSemcol10>=1.0 && !("Central Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())
											|| "State Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())))
										model.setValueAt("No", Row_Pselect + i, 18);
									else if(totalSemcol10<1.0)
										model.setValueAt("--Select--", Row_Pselect + i, 18);
								}else{
									model.setValueAt(df.format(addition),
											Row_Pselect + i, 10);
									if(addition>=1.0 && ("Central Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())
											|| "State Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())))
										model.setValueAt("Yes", Row_Pselect + i, 18);
									else if(addition>=1.0 && !("Central Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())
											|| "State Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())))
										model.setValueAt("No", Row_Pselect + i, 18);
									else if(addition<1.0)
										model.setValueAt("--Select--", Row_Pselect + i, 18);
								}

								//*************************************************************
							}

						}

					}// newly added bycholia on5march2015
					// newly added by cholia on 13 march 2015 krna hia naya
					// code 13 march 2015

					int p = 0;
					double col10Annex1 = 0;					
					//new development for FRD1.5 by akansha
					if (model.getValueAt(Row_Pselect + i, 3) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 3)))
						chTds = Double.parseDouble(GrpuUtil.validRupee(model.getValueAt(
								Row_Pselect + i, 3)));

					if (model.getValueAt(Row_Pselect + i, 4) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 4)))
						chSur = Double.parseDouble(GrpuUtil.validRupee(model.getValueAt(
								Row_Pselect + i, 4)));

					if (model.getValueAt(Row_Pselect + i, 5) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 5)))
						chCess = Double.parseDouble(GrpuUtil.validRupee(model.getValueAt(
								Row_Pselect + i, 5)));

					if (model.getValueAt(Row_Pselect + i, 6) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 6)))
						intrstannex1 = Double.parseDouble(GrpuUtil.validRupee(model.getValueAt(
								Row_Pselect + i, 6)));

					if (model.getValueAt(Row_Pselect + i, 8) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 8)))
						othersannex1 = Double.parseDouble(GrpuUtil.validRupee(model.getValueAt(
								Row_Pselect + i, 8)));
					//*********************************************************				

					// for bsr code
					if (model.getValueAt(Row_Pselect + i, 13) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 13)))
						bsrCode = model.getValueAt(Row_Pselect + i, 13)
						.toString();
					// end

					// date
					if (model.getValueAt(Row_Pselect + i, 15) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 15)))
						chDateTaxDpsted = model.getValueAt(Row_Pselect + i, 15)
						.toString();
					// end date

					if (model.getValueAt(Row_Pselect + i, 17) != null
							&& !"".equals(model.getValueAt(Row_Pselect + i, 17)))
						chDdoSrNo = model.getValueAt(Row_Pselect + i, 17)
						.toString();

					col7annex1 = chTds + chSur + chCess;

					col10Annex1 = col7annex1 + intrstannex1 + othersannex1;

					for (p = 2; p < model1.getRowCount(); p++) {

						if (model1.getValueAt(p, 1) != null
								&& !"".equals(model1.getValueAt(p, 1)
										.toString())) {
							if (Integer.parseInt(model1.getValueAt(p, 1)
									.toString()) == Row_Pselect + i - 1) {
								if (col7annex1 != 0)
									model1.setValueAt(df.format(col7annex1), p,
											7);

								if (intrstannex1 != 0)
									model1.setValueAt(df.format(intrstannex1),
											p, 8);

								if (bsrCode != null || "".equals(bsrCode)) {
									model1.setValueAt((bsrCode), p, 3);
								}

								if (chDateTaxDpsted != null
										|| "".equals(chDateTaxDpsted)) {
									model1.setValueAt(chDateTaxDpsted, p, 4);
								}
								if (chDdoSrNo != null || "".equals(chDdoSrNo)) {
									model1.setValueAt(chDdoSrNo, p, 5);
								}

								if (othersannex1 != 0) {
									model1.setValueAt(df.format(othersannex1),
											p, 9);
								}

								if (col10Annex1 != 0)
									model1.setValueAt(df.format(col10Annex1),
											p, 10);

							}
						}

					}

					// end //newly added by cholia on 13 march 2015 krna hia
					// naya code 13 march 2015

				}

				else if (tabname.trim().equals("Anne1")) // added by cholia
				{
					double totalTaxDed21 = 0;
					count = 0; // newly added by cholia for the annexure1 copy
					// paste
											if (Row_Pselect != 0 && Row_Pselect != 1) {
						for (int j = 0; j < currTDRow.size() && (Col_Pselect + j) < model1.getColumnCount(); j++) {
							// newly added by cholia for the correction
							// statement
							System.out.println(" Certificate number column is: "+ (Col_Pselect +j));
							if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")&& Row_Pselect < row_count_annex1)// newly
							{
								//System.out.println("Col value in Anne1: "+ (j)+ " "+currTDRow.elementAt(j).toString());
								//new development for FRD1.3 by Akansha
								if(Col_Pselect + j == 1)
								{
									if("UPDATE".equals(currTDRow.elementAt(j).toString()) || "PAN UPDATE".equals(currTDRow.elementAt(j).toString()))
										model1.setValueAt(
												currTDRow.elementAt(j),
												Row_Pselect + i, 2); 
								}
								//*********************************************************

								String mode = "";
								Object modeObj = model1.getValueAt(Row_Pselect+ i, 2);
								if (modeObj != null)
									mode = modeObj.toString();
								if ("--Select--".equals(mode)) {

								} else if (selYear_anne2 <= 2013) // year chnage
									// kro <2010
								{

									System.out.println("I am in less than 2013%%%%%%%%%%%%%%%%%%%%%%%%");

									String remarks = "";
									Object remarks_obj = model1.getValueAt(
											Row_Pselect + i, 26);
									if (remarks_obj != null)
										remarks = remarks_obj.toString();

									if ("UPDATE".equals(mode)&& !("C".equals(remarks))) { // (Col_Pselect
										// + j ==
										// 11) date
										// field hai
										//										System.out
										//												.println("I am inside remarks for my form");
										//new development for FRD1.5 by akansha
										if ((Col_Pselect + j == 5)) {
											/**********************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
												panAnne = true;
											}else{
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownSection(currTDRow.elementAt(j).toString(),formNumber)) //new development FRD1.3 by Akansha
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

												else {

												}
											}
											/*************************************************/

											/*if (selYear_anne2 >= 2013) {
												if(GrpuUtil.getDropDownSection(currTDRow.elementAt(j).toString(),formNumber)) //new development FRD1.3 by Akansha
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											}

											else {

											}*/

										}
										else if ((Col_Pselect + j == 25)) { // new development for FRD1.5 by Akansha
											if (selYear_anne2 >= 2013) {
												if(GrpuUtil.getDropDownRemarks(currTDRow.elementAt(j).toString()))
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}
										}//***********************************************************************
										//**************************************
										if ((Col_Pselect + j == 11)
												|| (Col_Pselect + j == 14)
												|| (Col_Pselect + j == 15)
												|| (Col_Pselect + j == 16)
												|| (Col_Pselect + j == 17)
												|| (Col_Pselect + j == 18)
												|| (Col_Pselect + j == 19)
												|| (Col_Pselect + j == 22
												|| Col_Pselect + j == 15 || Col_Pselect
												+ j == 24)
												)
											// newly added by cholia Col_Pselect + j
											// == 15 && Col_Pselect + j == 24

										{

											//											System.out
											//													.println("raka select row col is "
											//															+ Row_Pselect + i);
											//new development for FRD1.5 by akansha
											if(Col_Pselect + j ==15 || Col_Pselect + j ==24){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){
													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){
														model1.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
													else
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flaggingAnne = false;
													model1.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}
											//******************************************************
											//new development for FRD1.5 by Akansha
											else if((Col_Pselect + j == 16)
													|| (Col_Pselect + j == 17)
													|| (Col_Pselect + j == 18)
													|| (Col_Pselect + j == 19)
													|| (Col_Pselect + j == 22)){

												/*********************************************************************/
												// new development for newly appended value "F",For freezing some columns, FRD1.9 on 02/02/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F' && (Col_Pselect + j == 16 || Col_Pselect + j == 17 ||Col_Pselect + j == 18 || Col_Pselect + j == 19) ){
													panAnne = true;
												}else{
													model1.setValueAt(GrpuUtil.validRupee(currTDRow.elementAt(j)),Row_Pselect + i,Col_Pselect + 1 + j);
												}
												//model1.setValueAt(GrpuUtil.validRupee(currTDRow.elementAt(j)),Row_Pselect + i,Col_Pselect + 1 + j);
												/***********************************************************************/
											}

											//*****************************************************

											else
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

										}
										else if(Col_Pselect + j ==25){
											if(GrpuUtil.getDropDownRemarks(currTDRow.elementAt(j).toString()))
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
										}

										else if ((Col_Pselect + j == 13)) {

											if (pan_Updtn_Indicator
													.get((Row_Pselect + i) - 2) < 2) {

												/*model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);*/
												//new development for FRD1.5 by akansha
												// for checking valid PAN of employee

												/**********************************************/
												// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
													panAnne = true;
												}else{
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt("",Row_Pselect + i, Col_Pselect+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt((currTDRow.elementAt(j).toString()),Row_Pselect + i,Col_Pselect + 1 + j);
													}
													/*********************************************/
												}

												//************************************

											}

										}

										// book entry
										else if (formNum.equals("26Q")|| formNum.equals("27EQ")) {
											if (formNum.equals("26Q") && (Col_Pselect + j == 29)) {
												model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect + 1 + j);
											}
											//rpu 3.1 start to set value null if !94N
										
											if (formNum.equals("27EQ") && (Col_Pselect + j == 29)) {
												//new development for FRD1.5 by akansha
												if(selYear_anne2<2013){
													if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
															|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
												}
												//********************************************
											}

											if ((Col_Pselect + j == 27)) {
												//new development for FRD1.5 by akansha
												if(formNum.equals("27EQ"))
													model1.setValueAt(GrpuUtil.validRupee(
															currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												//****************************************
												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
											if(Col_Pselect + j == 26){
												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow.elementAt(j).toString())) //newly developed for FRd1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											else if ((Col_Pselect + j == 28)) {
												//newly developed for FRD1.5 Ver1.5 by akansha
												if(formNum.equals("26Q") && selYear_anne2==2013){

												}else

													if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
															|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j); // For
												// dedcutee
												// code
												// column
												// column
											}

										}

										else if (formNum.equals("27Q")) {
											

											if ((Col_Pselect + j == 27)) {

												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											}

											else if ((Col_Pselect + j == 26)
													) {
												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
														|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j); // For
												// dedcutee
												// code
												// column
												// column
											}
											else if((Col_Pselect + j == 28)){
												if(selYear_anne2<2013){
													if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
															|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j); 
												}
											}
											if ((Col_Pselect + j == 34)) {
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
											if ((Col_Pselect + j == 29)) {
												
												if (selYear_anne2 >= 2013) {// ##
													// Newly
													// developed
													// for
													// correction
													// Ver1.2
													// by
													// Akansha
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											}
											if ((Col_Pselect + j == 30)) { // ##
												// Newly
												// developed
												// for
												// correction
												// Ver1.2
												// by
												// Akansha
												if (selYear_anne2 >= 2013) {
													if("A".equals(currTDRow
															.elementAt(j).toString())|| "B".equals(currTDRow
																	.elementAt(j).toString())
																	|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
												}

											}
											if ((Col_Pselect + j == 31)) { // ##
												// Newly
												// developed
												// for
												// correction
												// Ver1.2
												// by
												// Akansha
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownRemittance(currTDRow
															.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
												}

											}
											if ((Col_Pselect + j == 32)) { // ##
												// Newly
												// developed
												// for
												// correction
												// Ver1.2
												// by
												// Akansha
												if (selYear_anne2 >= 2013) {
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}

											}
											if ((Col_Pselect + j == 33)) { // ##
												// Newly
												// developed
												// for
												// correction
												// Ver1.2
												// by
												// Akansha
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownCountry(currTDRow
															.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
												}

											}
										}  if (formNum.equals("27EQ")) //changed for new development FRD1.5 by akansha

										{ // (Col_Pselect + j == 30) is paid by
											// book entry
											//new development for FRD1.5
											if((Col_Pselect + j == 27)
													){
												model1.setValueAt(GrpuUtil.validRupee(
														currTDRow.elementAt(j)),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}
											//*************************************
											else	if ( (Col_Pselect + j == 28)) {

												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											} 
											else if(Col_Pselect + j == 26){
												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
														||	"1".equals(currTDRow.elementAt(j).toString()) || "2".equals(currTDRow.elementAt(j).toString())
														|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											else if (Col_Pselect + j == 30) {
												
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); // For
												// paid
												// by
												// book
												// entry
											}

										}

										else {

										}
										if ("24Q".equals(formNum)) {
											if (selYear_anne2 >= 2013) {
												if (Col_Pselect + j == 26) {
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											}
										}

										// ## Newly added for Correction Ver1.2
										// by Akansha
										if (Col_Pselect + j == 17
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19) {
											count++;
											if (j == 0) // handling the starting
												// event
											{

												for (int k = 18; k < Col_Pselect
														+ j + 1; k++) {
													if (model1.getValueAt(
															Row_Pselect + i, k) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				k)));
													}

												}

											}

											if (j == currTDRow.size() - 1) {

												for (int p = Col_Pselect + j
														+ 2; p < 21; p++) {
													if (model1.getValueAt(
															Row_Pselect + i, p) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				p)));
														//***************************************
													}
												}

											}
											int ya = Col_Pselect + j;

											if (Col_Pselect + j == 17
													|| Col_Pselect + j == 18
													|| Col_Pselect + j == 19) {

												//new development for newly appended value "F", FRD1.9 on 02/02/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
													panAnne = true;
												}else{
													if (currTDRow.elementAt(j)
															.toString() != null
															&& !"".equals(currTDRow
																	.elementAt(j)
																	.toString()))
														//new development for FRD1.5 by Akansha
														totalTaxDed21 = totalTaxDed21
														+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
																.elementAt(
																		j)));
												}										
											}

										}
										// ***********************************************************

									}

									// ## Newly added for correction Ver1.2 by
									// Akansha
									else if ("UPDATE".equals(mode)
											&& ("C".equals(remarks)))

									{
										if ((Col_Pselect + j == 5)) {

											/**********************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
												panAnne = true;
											}else{
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownSection(currTDRow.elementAt(j).toString(),formNumber)) //new development FRD1.3 by Akansha
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

												else {

												}
											}
											/*******************************************/

										}

										else if ((Col_Pselect + j == 11)
												|| (Col_Pselect + j == 15)
												|| (Col_Pselect + j == 16)
												|| (Col_Pselect + j == 24)
												|| (Col_Pselect + j == 22)
												|| (Col_Pselect + j == 14)) {
											//new development for FRD1.5 by akansha

											/**********************************************************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F' && Col_Pselect + j == 16){
												panAnne = true;
											}else{
												if(Col_Pselect + j ==15 || Col_Pselect + j ==24){
													if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

														//newly developed for FRD1.5 Ver1.5 by akansha
														if(currTDRow.elementAt(j).toString().contains("-")){
															model1.setValueAt(
																	currTDRow.elementAt(j).toString().replace("-","/"),
																	Row_Pselect + i, Col_Pselect
																	+ 1 + j);
														}
														else
															model1.setValueAt(
																	currTDRow.elementAt(j),
																	Row_Pselect + i, Col_Pselect
																	+ 1 + j);
													}else{
														//System.out.println("Inside else");
														flaggingAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
												}
												//******************************************************************
												//new development for FRD1.5 by Akansha
												else if((Col_Pselect + j == 22)){
													model1.setValueAt(
															GrpuUtil.validRupee(currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
												//*****************************************************
												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}
											/********************************************************************************************/


										} else if ((Col_Pselect + j == 13)) {

											/**********************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
												panAnne = true;
											}else{
												if (pan_Updtn_Indicator
														.get((Row_Pselect + i) - 2) < 2) {

													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
													//new development for FRD1.5 by akansha
													// for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}

													//************************************

												}
											}
											/*********************************************/

										}

										if (("24Q".equals(formNum))
												&& (Col_Pselect + j == 26)) {
											if (selYear_anne2 >= 2013) {
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											}

											else {

											}

										}  if (formNum.equals("27Q")) {
											if ((Col_Pselect + j == 30)) // whether
												// tds
												// dedicted
												// at
												// higher
												// rates
											{
												if (selYear_anne2 >= 2013) {
													if("A".equals(currTDRow
															.elementAt(j).toString())|| "B".equals(currTDRow
																	.elementAt(j).toString())
																	||"--Select--".equals(currTDRow
																			.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

												else {

												}

											}
											if ((Col_Pselect + j == 29)) {
												if (selYear_anne2 >= 2013) {// ##
													// Newly
													// developed
													// for
													// correction
													// Ver1.2
													// by
													// Akansha
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											}
											if ((Col_Pselect + j == 30)) {
												if (selYear_anne2 >= 2013) {// ##
													// Newly
													// developed
													// for
													// correction
													// Ver1.2
													// by
													// Akansha
													if("A".equals(currTDRow
															.elementAt(j).toString())|| "B".equals(currTDRow
																	.elementAt(j).toString())
																	||"--Select--".equals(currTDRow
																			.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
												}
											}
											if (selYear_anne2 >= 2013) {
												if ((Col_Pselect + j == 31)) {
													// ## Newly developed for
													// correction Ver1.2 by
													// Akansha
													if(GrpuUtil.getDropDownRemittance(currTDRow
															.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
												}
												if ((Col_Pselect + j == 32)) {
													// ## Newly developed for
													// correction Ver1.2 by
													// Akansha
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
												if ((Col_Pselect + j == 33)) {
													// ## Newly developed for
													// correction Ver1.2 by
													// Akansha
													if(GrpuUtil.getDropDownCountry(currTDRow
															.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
												}
											}
										}

										else {

										}
										//new development for FRD1.5 by akansha
										if("26Q".equals(formNum) || "27Q".equals(formNum)){
											if (selYear_anne2 >= 2013) {
												if(Col_Pselect == 29){
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											}
										}



										//*********************************************
									} else if ("ADD".equals(mode)) {
										// (Col_Pselect
										// + j ==
										// 11) date
										// field hai
										if ((Col_Pselect + j == 11)
												|| (Col_Pselect + j == 13)
												|| (Col_Pselect + j == 14)
												|| (Col_Pselect + j == 15)
												|| (Col_Pselect + j == 16)
												|| (Col_Pselect + j == 17)
												|| (Col_Pselect + j == 18)
												|| (Col_Pselect + j == 19)
												|| (Col_Pselect + j == 22
												|| Col_Pselect + j == 15 || Col_Pselect
												+ j == 24)
												|| (Col_Pselect + j == 25))
											// newly added by cholia Col_Pselect + j
											// == 15 && Col_Pselect + j == 24

										{

											
											//new development for FRD1.5 by akansha
											if(Col_Pselect + j ==15 || Col_Pselect + j ==24){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){
														model1.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}else
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flaggingAnne = false;
													model1.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}

											else //new development for FRD1.5 by akansha
												if(Col_Pselect + j ==13){ // for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
														//newly added for FRD1.5 by akansha
														if('C'==((currTDRow.elementAt(j).toString()).charAt(3))){
															model1.setValueAt(
																	("01"),
																	Row_Pselect + i,
																	27);
														}else if(!('C'==((currTDRow.elementAt(j).toString()).charAt(3)))){
															model1.setValueAt(
																	("02"),
																	Row_Pselect + i,
																	27);
														}
														if("PANINVALID".equals(currTDRow.elementAt(j).toString())||
																"PANAPPLIED".equals(currTDRow.elementAt(j).toString())||
																"PANNOTAVBL".equals(currTDRow.elementAt(j).toString())){
															model1.setValueAt(
																	("--Select--"),
																	Row_Pselect + i,
																	27);
														}
														//**************************************
													}
												}
											//************************************
											//******************************************************************
											//new development for FRD1.5 by Akansha
												else if((Col_Pselect + j == 16)
														|| (Col_Pselect + j == 17)
														|| (Col_Pselect + j == 18)
														|| (Col_Pselect + j == 19)
														|| (Col_Pselect + j == 22)){
													model1.setValueAt(
															GrpuUtil.validRupee(currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											//*****************************************************

												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

										}
										// newly removed by cholia on 11 march
										/*
										 * else if((Col_Pselect + j == 25)) {
										 * model1.setValueAt("--Select--",
										 * Row_Pselect + i, Col_Pselect + 1 +
										 * j); //For remarks column }
										 */

										// (Col_Pselect + j == 28) is paid by
										// book entry
										else if (formNum.equals("26Q")

												|| formNum.equals("27EQ")) {
											if ((Col_Pselect + j == 27)) {
												//new development for FRD1.5 by akansha
												if(formNum.equals("27EQ"))
													model1.setValueAt(GrpuUtil.validRupee(
															currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												//****************************************
												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
											//RPU 2.9 start
											else if ((Col_Pselect + j == 25)) { // new development of FRD1.3 by Akansha
												System.out.println("Remark field of ann1: "+GrpuUtil.getDropDownRemarks(currTDRow.elementAt(j).toString()));
												if(GrpuUtil.getDropDownRemarks(currTDRow.elementAt(j).toString()))
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
											else if (Col_Pselect + j == 26){
												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											else if ((Col_Pselect + j == 28)) {
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j); // For
												// dedcutee
												// code
												// column
												// column
											}

										}

										else if (formNum.equals("27Q")) {

											if ((Col_Pselect + j == 27)) {

												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											}
											else if ((Col_Pselect + j == 25)) { // new development of FRD1.3 by Akansha
												if(GrpuUtil.getDropDownRemarks(currTDRow.elementAt(j).toString()))
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
											else if (Col_Pselect + j == 26){
												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											else if ((Col_Pselect + j == 28)) {
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j); // For
												// dedcutee
												// code
												// column
												// column
											}


											//new development of FRD1.3 by Akansha
											if((Col_Pselect + j == 30)){
												if("A".equals(currTDRow.elementAt(j).toString())|| "B".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											if((Col_Pselect + j == 31)){
												if(GrpuUtil.getDropDownRemittance(currTDRow.elementAt(j).toString()))
													model1.setValueAt(currTDRow.elementAt(j).toString(), Row_Pselect + i, Col_Pselect + 1 + j);
											}
											if((Col_Pselect + j == 33)){
												if(GrpuUtil.getDropDownCountry(currTDRow.elementAt(j).toString()))
													model1.setValueAt(currTDRow.elementAt(j).toString(), Row_Pselect + i, Col_Pselect + 1 + j);
											}
											//****************************************************************************
											if ((Col_Pselect + j == 34)) {
												//new development of FRD1.3 by Akansha
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
										} else if (formNum.equals("27EQ"))

										{	 // (Col_Pselect + j == 30) is paid by
											// book entry
											//new development for FRD1.5 by akansha
											if((Col_Pselect + j == 27)
													){
												model1.setValueAt(GrpuUtil.validRupee(
														currTDRow.elementAt(j)),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}
											//***************************
											else	if ((Col_Pselect + j == 28)) {

												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											} 

											else if(Col_Pselect + j == 26){
												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString()) ||
														"1".equals(currTDRow.elementAt(j).toString())|| "2".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											else if(Col_Pselect + j == 29){
												//new development of FRD1.3 by Akansha
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j); 
											}

											else if (Col_Pselect + j == 30) {
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); // For
												// paid
												// by
												// book
												// entry
											}
											else if(Col_Pselect + j == 31){ //RPU 3.5 during paste Bug fix for 32nd column
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//Deductee is non resident 
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j); 
											}
											else if(Col_Pselect + j == 33){ //RPU 3.5 during paste
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//whether payment is liable
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j); 
											}

										}

										else {

										}

										// ## Newly added for Correction Ver1.2
										// by Akansha
										if (Col_Pselect + j == 17
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19) {
											count++;
											if (j == 0) // handling the starting
												// event
											{

												for (int k = 18; k < Col_Pselect
														+ j + 1; k++) {
													if (model1.getValueAt(
															Row_Pselect + i, k) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k))) {
														//new development for FRD1.5 by Akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				k)));
													}

												}

											}

											if (j == currTDRow.size() - 1) {

												for (int p = Col_Pselect + j
														+ 2; p < 21; p++) {
													if (model1.getValueAt(
															Row_Pselect + i, p) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				p)));
													}
												}

											}
											int ya = Col_Pselect + j;

											if (Col_Pselect + j == 17
													|| Col_Pselect + j == 18
													|| Col_Pselect + j == 19) {

												if (currTDRow.elementAt(j)
														.toString() != null
														&& !"".equals(currTDRow
																.elementAt(j)
																.toString()))
													//new development for FRD1.5 by akansha
													totalTaxDed21 = totalTaxDed21
													+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
															.elementAt(
																	j)));

											}

										}
										// ***********************************************************

									}
									// *************************************************************

									else if ("PAN UPDATE".equals(mode)) { // raka
										// fpr
										// pn<2
										// pan
										// of
										// the
										// employee
										// able
										// hai
										if (pan_Updtn_Indicator
												.get((Row_Pselect + i) - 2) < 2) {
											if (Col_Pselect + j == 13)
												/*model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);*/
											{
												/**********************************************/
												// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
													panAnne = true;
												}else{
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}
												}
												/*********************************************/
											}
											else {

											}
										} else {

										}

									}

								}

								else if (selYear_anne2 >= 2010) // yahan se
								{
									String remarks = "";
									Object remarks_obj = model1.getValueAt(
											Row_Pselect + i, 26);
									if (remarks_obj != null)
										remarks = remarks_obj.toString();
									System.out.println("I am in 2010@@@@@@@@@");
									if ("UPDATE".equals(mode) && !("C".equals(remarks))) {
										System.out.println("Here are my remarks....");
										if ((Col_Pselect + j == 5)) {

											/**********************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
												panAnne = true;
											}else{
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownSection(currTDRow.elementAt(j).toString(),formNumber))
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

												else {

												}
											}
											/**********************************************/
										}

										else if ((Col_Pselect + j == 26)) {

											if ("26Q".equals(formNum)){

												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
														||"1".equals(currTDRow.elementAt(j).toString())|| "2".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}else

												if (selYear_anne2 >= 2013) {
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

												}

												else {

												}

										}

										//new development for FRD1.5 by akansha
										if ((Col_Pselect + j == 25)) { // new development for FRD1.5 by Akansha
											if (selYear_anne2 >= 2013) {
												if(GrpuUtil.getDropDownRemarks(currTDRow.elementAt(j).toString()))
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}
										}//***********************************************************************
										//**************************************
										//*************************************

										if (formNum.equals("27Q")) {
											//new development of FRD1.3 by Akansha
											if(Col_Pselect + j == 30){
												if (selYear_anne2 >= 2013) {
													if("A".equals(currTDRow
															.elementAt(j).toString())|| "B".equals(currTDRow
																	.elementAt(j).toString())
																	||"--Select--".equals(currTDRow
																			.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}
											}
											if (Col_Pselect + j == 31) {
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownRemittance(currTDRow
															.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}
											}
											if (Col_Pselect + j == 33) {
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownCountry(currTDRow
															.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}
											}

											if ((Col_Pselect + j == 32)) // nature
												// of
												// remittance
											{
												if (selYear_anne2 >= 2013) {

													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

												}

												else {

												}

											}

											//newly added for RPU1.8 by akansha

											if(Col_Pselect + j == 35 ||
													Col_Pselect + j == 36 ||
													Col_Pselect + j == 37 ||
													Col_Pselect + j == 38){
												if (selYear_anne2 >= 2016) 
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											//****************************************************


										}

										// Col_Pselect + j=24 date hai bhai //
										// Col_Pselect + j=25 drop down hai
											//RPU 3.4 COmmenting else
										 if ((Col_Pselect + j == 11)
												|| (Col_Pselect + j == 14)
												|| (Col_Pselect + j == 15)
												|| (Col_Pselect + j == 16)
												|| (Col_Pselect + j == 17)
												|| (Col_Pselect + j == 18)
												|| (Col_Pselect + j == 19)
												|| (Col_Pselect + j == 22
												|| Col_Pselect + j == 15 || Col_Pselect
												+ j == 24)) // Col_Pselect
											// + j == 15
											// ||
											// Col_Pselect
											// + j == 24
											// newly
											// added by
											// cholia
										{
											System.out.println("NAme and rupee colum to paste");
											//new development for FRD1.5 by akansha
											if(Col_Pselect + j ==15 || Col_Pselect + j ==24){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){
														model1.setValueAt(
																currTDRow.elementAt(j).toString().replace("-", "/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
													else
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flaggingAnne = false;
													model1.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}
											//******************************************************************
											//new development for FRD1.5 by Akansha
											else if((Col_Pselect + j == 16)
													|| (Col_Pselect + j == 17)
													|| (Col_Pselect + j == 18)
													|| (Col_Pselect + j == 19)
													|| (Col_Pselect + j == 22)){

												/**********************************************/
												// new development for newly appended value "F",For freezing some columns, FRD1.9 on 02/02/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F' ){
													if(Col_Pselect + j == 16 || Col_Pselect + j == 17 || Col_Pselect + j == 18 || Col_Pselect + j == 19){
														panAnne = true;
														System.out.println("To paste form 27q value 16,17,18 PANANNE"
																+panAnne);
													}
												}else{
													model1.setValueAt(
															GrpuUtil.validRupee(currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
													System.out.println("To paste form 27q value 16,17,18");
												}
												/*********************************************/
												/*model1.setValueAt(
															GrpuUtil.validRupee(currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);*/
											}
											//*****************************************************

											else
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

										} else if ((Col_Pselect + j == 13)) {

											/*********************************************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
												panAnne = true;
											}else{
												if (pan_Updtn_Indicator.get((Row_Pselect + i) - 2) < 2) {

													//new development for FRD1.5 by akansha
													// for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}

													//************************************

												}
											}
											/***************************************************************************/
											/*if (pan_Updtn_Indicator.get((Row_Pselect + i) - 2) < 2) {

												//new development for FRD1.5 by akansha
												 // for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																		+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}

												//************************************

											}*/
										}

										if (formNum.equals("26Q") //changed for FRD1.5 by akansha 
												|| formNum.equals("27Q")
												|| formNum.equals("27EQ")) {
											// System.out.println("Yelloooooo");
											if ((Col_Pselect + j == 27)) {
												//new development for FRD1.5 by akansha
												if(formNum.equals("27EQ"))
													model1.setValueAt(GrpuUtil.validRupee(
															currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);


												//***************************************
												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
											//new development for FRD1.5 by akansha
											if(Col_Pselect + j == 29){
												if (selYear_anne2 >= 2013) {
													/*if(formNum.equals("27Q"))
													model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect + 1 + j);*/
													model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect + 1 + j);
												}
												//***********************************
											}else if ((Col_Pselect + j == 26)
													|| (Col_Pselect + j == 28)) {
												//new development for FRD1.5 by akansha
												if(formNum.equals("27Q")){
													if (Col_Pselect + j == 28) {
														if (selYear_anne2 < 2013) {
															model1.setValueAt(
																	currTDRow
																	.elementAt(j),
																	Row_Pselect
																	+ i,
																	Col_Pselect
																	+ 1
																	+ j);
														}
													}
													if(Col_Pselect + j == 26){
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}
												}

												else{

													if ("26Q".equals(formNum)){
														if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
																||"1".equals(currTDRow.elementAt(j).toString())|| "2".equals(currTDRow.elementAt(j).toString())
																||"--Select--".equals(currTDRow
																		.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
															model1.setValueAt(
																	currTDRow.elementAt(j),
																	Row_Pselect + i,
																	Col_Pselect + 1 + j);
													}else


														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j); // For
													// dedcutee
													// code
													// column
													// column

												}

											}

										}

										if (formNum.equals("27Q")) {
											//new development of FRD1.3 by Akansha
											if ((Col_Pselect + j == 34)) {
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
										}  
										if (formNum.equals("27EQ"))

										{ // (Col_Pselect + j == 30) is paid by
											// book entry
											//new development for FRD1.5 by akansha
											if((Col_Pselect + j == 27)
													){
												model1.setValueAt(GrpuUtil.validRupee(
														currTDRow.elementAt(j)),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}
											//**************************************
											else if ((Col_Pselect + j == 28)) {

												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											} 

											else if ((Col_Pselect + j == 26)){
												if("1".equals(currTDRow.elementAt(j).toString())|| "2".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}
											else if(Col_Pselect + j == 29){
												//new development of FRD1.3 by Akansha
												if(selYear_anne2<2013){
													if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
															||"--Select--".equals(currTDRow
																	.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j); 
												}
											}

											else if (Col_Pselect + j == 30) {
												System.out.println("heee... iam inside");
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); // For
												
											}
											else if(Col_Pselect + j == 31){
												//new development of FRD1.3 by Akansha
												
													if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
															||"--Select--".equals(currTDRow
																	.elementAt(j).toString()))//RPU 3.5 bug fix to paste column 32
														{System.out.println("inside column 31,value should be set at 32");
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j); 
														}
												
											}
											else if(Col_Pselect + j == 32){
												//new development of FRD1.3 by Akansha
												
													if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
															||"--Select--".equals(currTDRow
																	.elementAt(j).toString()))//RPU 3.5 bug fix to paste column 32
														{System.out.println("inside column 32,value should be set at 33");
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j); 
														}
												
											}
											else if(Col_Pselect + j == 33){
												//new development of FRD1.3 by Akansha
												
													if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
															||"--Select--".equals(currTDRow
																	.elementAt(j).toString()))//RPU 3.5 bug fix to paste column 32
														{System.out.println("inside column 33,value should be set at 34");
														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j); 
														}
												
											}
											else if (Col_Pselect + j == 34) {
												System.out.println("pasteChallan number");
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); // For
												
											}else if (Col_Pselect + j == 35) {
												System.out.println("paste date column 36");
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); // For
												
											}

										}

										else {

										}

										// $$$$
										// ## Newly added for Correction Ver1.2
										// by Akansha
										if (Col_Pselect + j == 17
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19) {
											count++;
											if (j == 0) // handling the starting
												// event
											{

												for (int k = 18; k < Col_Pselect
														+ j + 1; k++) {
													if (model1.getValueAt(
															Row_Pselect + i, k) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				k)));
													}

												}

											}

											if (j == currTDRow.size() - 1) {

												for (int p = Col_Pselect + j
														+ 2; p < 21; p++) {
													if (model1.getValueAt(
															Row_Pselect + i, p) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				p)));
													}
												}

											}
											int ya = Col_Pselect + j;

											if (Col_Pselect + j == 17
													|| Col_Pselect + j == 18
													|| Col_Pselect + j == 19) {
												System.out
												.println("check column............");
												//new development for newly appended value "F", FRD1.9 on 02/02/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
													panAnne  = true;
												}else{
													if (currTDRow.elementAt(j)
															.toString() != null
															&& !"".equals(currTDRow
																	.elementAt(j)
																	.toString()))
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
														+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
																.elementAt(
																		j)));
												}

												/*if (currTDRow.elementAt(j)
														.toString() != null
														&& !"".equals(currTDRow
																.elementAt(j)
																.toString()))
													//new development for FRD1.5 by akansha
													totalTaxDed21 = totalTaxDed21
															+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
																	.elementAt(
																			j)));*/

											}

										}
										// end of $$$
									}
									// ## Newly added for Correction Ver1.2 by
									// Akansha
									else if ("ADD".equals(mode)) {
										System.out.println("copy data for ann1 start-- for newly added record");
										if ((Col_Pselect + j == 5)) {
											if (selYear_anne2 >= 2013) {
												if(GrpuUtil.getDropDownSection(currTDRow.elementAt(j).toString(),formNumber))
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}

											else {

											}

										}

										else if ((Col_Pselect + j == 26)) {
											if (selYear_anne2 >= 2013) {
												if("01".equals(currTDRow.elementAt(j).toString())|| "02".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}

											else {

											}

										}

										else if (formNum.equals("27Q")) {
											System.out.println("copy for form 27Q for newly added record");
											//new development of FRD1.3 by Akansha

											if(Col_Pselect + j == 30){
												if (selYear_anne2 >= 2013) {
													if("A".equals(currTDRow.elementAt(j).toString())|| "B".equals(currTDRow
															.elementAt(j).toString())
															||"--Select--".equals(currTDRow
																	.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

											}
											if(Col_Pselect + j == 31){
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownRemittance(currTDRow
															.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

											}
											if(Col_Pselect + j == 33){
												if (selYear_anne2 >= 2013) {
													if(GrpuUtil.getDropDownCountry(currTDRow.elementAt(j).toString()))
														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}

											}

											//****************************************************************

											if ((Col_Pselect + j == 32)) // nature
												// of
												// remittance
											{
												if (selYear_anne2 >= 2013) {

													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

												}

												else {

												}

											}

										}

										// Col_Pselect + j=24 date hai bhai //
										// Col_Pselect + j=25 drop down hai

										else if ((Col_Pselect + j == 13)
												|| (Col_Pselect + j == 11)
												|| (Col_Pselect + j == 14)
												|| (Col_Pselect + j == 15)
												|| (Col_Pselect + j == 16)
												|| (Col_Pselect + j == 17)
												|| (Col_Pselect + j == 18)
												|| (Col_Pselect + j == 19)
												|| (Col_Pselect + j == 22
												|| Col_Pselect + j == 15 || Col_Pselect
												+ j == 24)) // Col_Pselect
											// + j == 15
											// ||
											// Col_Pselect
											// + j == 24
											// newly
											// added by
											// cholia
										{

											//new development for FRD1.5 by akansha
											if(Col_Pselect + j ==15 || Col_Pselect + j ==24){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){
														model1.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
													else

														model1.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flaggingAnne = false;
													model1.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
												}
											}

											else //new development for FRD1.5 by akansha
												if(Col_Pselect + j ==13){ // for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
														//newly added for FRD1.5 by akansha
														if('C'==((currTDRow.elementAt(j).toString()).charAt(3))){
															model1.setValueAt(
																	("01"),
																	Row_Pselect + i,
																	27);
														}else if(!('C'==((currTDRow.elementAt(j).toString()).charAt(3)))){
															model1.setValueAt(
																	("02"),
																	Row_Pselect + i,
																	27);
														}
														if("PANINVALID".equals(currTDRow.elementAt(j).toString())||
																"PANAPPLIED".equals(currTDRow.elementAt(j).toString())||
																"PANNOTAVBL".equals(currTDRow.elementAt(j).toString())){
															model1.setValueAt(
																	("--Select--"),
																	Row_Pselect + i,
																	27);
														}
														//**************************************
													}
												}
											//************************************
											//******************************************************************
											//new development for FRD1.5 by Akansha
												else if((Col_Pselect + j == 16)
														|| (Col_Pselect + j == 17)
														|| (Col_Pselect + j == 18)
														|| (Col_Pselect + j == 19)
														|| (Col_Pselect + j == 22)){
													model1.setValueAt(
															GrpuUtil.validRupee(currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											//*****************************************************

												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

										}

										else if (formNum.equals("26Q")
												|| formNum.equals("27Q")
												|| formNum.equals("27EQ")) {
											if ((Col_Pselect + j == 27)) {
												//new development for FRD1.5 by akansha
												if(formNum.equals("27EQ"))
													model1.setValueAt(GrpuUtil.validRupee(
															currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												//***************************************
												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											else if ((Col_Pselect + j == 26)
													|| (Col_Pselect + j == 28)) {
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); // For
												// dedcutee
												// code
												// column
												// column
											}
											
											else if ((Col_Pselect + j == 30)
													&& (formNum.equals("26Q"))) {
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); 
												
											}
											

										}

										else if (formNum.equals("27Q")) {
											//new development for FRD1.3 by Akansha
											if ((Col_Pselect + j == 34)) {
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														||"--Select--".equals(currTDRow
																.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											}
										} else if (formNum.equals("27EQ"))

										{ // (Col_Pselect + j == 30) is paid by
											// book entry

											if ((Col_Pselect + j == 26)
													|| (Col_Pselect + j == 27)
													|| (Col_Pselect + j == 28)) {

												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											} else if (Col_Pselect + j == 30) {
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j); // For
												// paid
												// by
												// book
												// entry
											}

										}

										else {

										}

										// $$$$
										// ## Newly added for Correction Ver1.2
										// by Akansha
										if (Col_Pselect + j == 17
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19) {
											count++;
											if (j == 0) // handling the starting
												// event
											{

												for (int k = 18; k < Col_Pselect
														+ j + 1; k++) {
													if (model1.getValueAt(
															Row_Pselect + i, k) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				k)));
													}

												}

											}

											if (j == currTDRow.size() - 1) {

												for (int p = Col_Pselect + j
														+ 2; p < 21; p++) {
													if (model1.getValueAt(
															Row_Pselect + i, p) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				p)));
													}
												}

											}
											int ya = Col_Pselect + j;

											if (Col_Pselect + j == 17
													|| Col_Pselect + j == 18
													|| Col_Pselect + j == 19) {

												if (currTDRow.elementAt(j)
														.toString() != null
														&& !"".equals(currTDRow
																.elementAt(j)
																.toString()))
													//new development for FRD1.5 by Akansha
													totalTaxDed21 = totalTaxDed21
													+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
															.elementAt(
																	j)));

											}

										}
										// end of $$$

									}

									// *********************************************************
									else if ("UPDATE".equals(mode)&& ("C".equals(remarks)))
									{
										System.out.println("***********I am in C remarks fr new Fields**************");
										if ((Col_Pselect + j == 5)) {

											/**********************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
												panAnne = true;
											}else{
												if (selYear_anne2 >= 2013) {
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

												}

												else {

												}
											}
											/***********************************************/
											/*if (selYear_anne2 >= 2013) {
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											}
											else {

											}*/

										}

										else if ((Col_Pselect + j == 11)
												|| (Col_Pselect + j == 15)
												|| (Col_Pselect + j == 16)
												|| (Col_Pselect + j == 24)
												|| (Col_Pselect + j == 22)
												|| (Col_Pselect + j == 14)) {
											//new development for FRD1.5 by akansha

											/*************************************************************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F' && Col_Pselect + j == 16){
												panAnne = true;
											}else{
												if(Col_Pselect + j ==15|| Col_Pselect + j ==24){
													if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

														//newly developed for FRD1.5 Ver1.5 by akansha
														if(currTDRow.elementAt(j).toString().contains("-")){
															model1.setValueAt(
																	currTDRow.elementAt(j).toString().replace("-","/"),
																	Row_Pselect + i, Col_Pselect
																	+ 1 + j);
														}
														else

															model1.setValueAt(
																	currTDRow.elementAt(j),
																	Row_Pselect + i, Col_Pselect
																	+ 1 + j);
													}else{
														//System.out.println("Inside else");
														flaggingAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
													}
												}
												//******************************************************************
												//new development for FRD1.5 by Akansha
												else if((Col_Pselect + j == 22)){
													model1.setValueAt(
															GrpuUtil.validRupee(currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
												//*****************************************************

												else
													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}
											/********************************************************************************************/
											/*		if(Col_Pselect + j ==15|| Col_Pselect + j ==24){
												if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

													//newly developed for FRD1.5 Ver1.5 by akansha
													if(currTDRow.elementAt(j).toString().contains("-")){
														model1.setValueAt(
																currTDRow.elementAt(j).toString().replace("-","/"),
																Row_Pselect + i, Col_Pselect
																		+ 1 + j);
													}
													else

													model1.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i, Col_Pselect
																	+ 1 + j);
												}else{
													//System.out.println("Inside else");
													flaggingAnne = false;
													model1.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
																	+ 1 + j);
												}
											}
											//******************************************************************
											//new development for FRD1.5 by Akansha
											else if((Col_Pselect + j == 22)){
												model1.setValueAt(
														GrpuUtil.validRupee(currTDRow.elementAt(j)),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}
											//*****************************************************

											else
											model1.setValueAt(
													currTDRow.elementAt(j),
													Row_Pselect + i,
													Col_Pselect + 1 + j);*/

										} else if ((Col_Pselect + j == 13)) {

											/**********************************************/
											// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
											if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
												panAnne = true;
											}else{
												if (pan_Updtn_Indicator.get((Row_Pselect + i) - 2) < 2) {

													//new development for FRD1.5 by akansha
													// for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}

													//************************************

												}
											}
											/*********************************************/
											/*if (pan_Updtn_Indicator
													.get((Row_Pselect + i) - 2) < 2) {

												//new development for FRD1.5 by akansha
												 // for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																		+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}

												//************************************

											}*/

										}

										if ("24Q".equals(formNum)
												&& (Col_Pselect + j == 26)) {

											if (selYear_anne2 >= 2013) {
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);

											}

											else {

											}

										}  if (formNum.equals("27Q")) {
											//new development for FRD1.3 by Akansha
											if("A".equals(currTDRow.elementAt(j).toString())|| "B".equals(currTDRow.elementAt(j).toString())
													||"--Select--".equals(currTDRow
															.elementAt(j).toString()))//newly developed for FRD1.5 by akansha 
												if ((Col_Pselect + j == 30)) // whether
													// tds
													// dedicted
													// at
													// higher
													// rates
												{
													if (selYear_anne2 >= 2013) {

														model1.setValueAt(currTDRow
																.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

													}

													else {

													}

												}

											//new development for FRD1.5 by akansha
											if(Col_Pselect + j == 31 ||
													Col_Pselect + j == 32 ||
													Col_Pselect + j == 33 
													){
												if(selYear_anne2>=2013)
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}
											if(Col_Pselect + j == 34){
												model1.setValueAt(currTDRow
														.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}
											//************************************


											//newly added for RPU1.8 by akansha

											if(Col_Pselect + j == 35 ||
													Col_Pselect + j == 36 ||
													Col_Pselect + j == 37 ||
													Col_Pselect + j == 38){
												if (selYear_anne2 >= 2016) 
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
											}

											//****************************************************

										}

										else {

										}
										// $$$$$$
										// $$$$
										// ## Newly added for Correction Ver1.2
										// by Akansha
										if (Col_Pselect + j == 17
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19) {
											count++;
											if (j == 0) // handling the starting
												// event
											{

												for (int k = 18; k < Col_Pselect
														+ j + 1; k++) {
													if (model1.getValueAt(
															Row_Pselect + i, k) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				k)));
													}

												}

											}

											if (j == currTDRow.size() - 1) {

												for (int p = Col_Pselect + j
														+ 2; p < 21; p++) {
													if (model1.getValueAt(
															Row_Pselect + i, p) != null
															&& !"".equals(model1
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p))) {
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
																+ Double.parseDouble(GrpuUtil.validRupee(model1
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				p)));
													}
												}

											}
											int ya = Col_Pselect + j;

											if (Col_Pselect + j == 17
													|| Col_Pselect + j == 18
													|| Col_Pselect + j == 19) {

												//new development for newly appended value "F", FRD1.9 on 02/02/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
													panAnne = true;
												}else{
													if (currTDRow.elementAt(j)
															.toString() != null
															&& !"".equals(currTDRow
																	.elementAt(j)
																	.toString()))
														//new development for FRD1.5 by akansha
														totalTaxDed21 = totalTaxDed21
														+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
																.elementAt(
																		j)));
												}
											}
										}
										// end of $$$
										// $$$$$$

										//new development for FRD1.5 by akansha
										if("27Q".equals(formNum)){
											if (selYear_anne2 >= 2013) {
												if(Col_Pselect + j== 29){
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											}
										}
										//*********************************************
										//new development for FRD1.5 by akansha
										if("24Q".equals(formNum)){
											if (selYear_anne2 >= 2013) {
												if(Col_Pselect == 26 ){
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											}
										}
										//*********************************************
										//newly added for FRD1.5 Ver1.7 by akansha
										if("27Q".equals(formNum)){
											if (selYear_anne2 >= 2013) {
												if(Col_Pselect == 17||Col_Pselect == 18||
														Col_Pselect == 19 || Col_Pselect == 25
														|| Col_Pselect == 27
														|| Col_Pselect == 28)
													model1.setValueAt(currTDRow
															.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												System.out.println("Before calling PAste ");
											}
										}
										//*****************************************

									}

									else if ("PAN UPDATE".equals(mode)) {
										// pan of the employee able hai
										if (pan_Updtn_Indicator.get((Row_Pselect + i) - 2) < 2) {
											//new development for FRD1.5 by akansha
											if(Col_Pselect + j ==13){ // for checking valid PAN of employee

												/**********************************************/
												// new development for newly appended value "F",For freezing some columns, FRD1.9 on 23/01/17
												if(strAnnexIColValue.charAt(Row_Pselect - 2) == 'F'){
													panAnne = true;
												}else{
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model1.setValueAt("",Row_Pselect + i, Col_Pselect+ 1 + j);
														pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
													}else{
														model1.setValueAt((currTDRow.elementAt(j).toString()),Row_Pselect + i,Col_Pselect + 1 + j);
													}
												}
												/***********************************************/
											}
											//************************************
											else {

											}

										} else {

										}

									}

								}

							}

							// end newly added by cholia for the correction
							// statement
							else // for Regular statements
							{
								// newly added by cholia for the copy paste on
								// 2.03.2015

								//	System.out.println("I am in column: "+ (Col_Pselect + j) );

								if (Col_Pselect + j == 17
										|| Col_Pselect + j == 18
										|| Col_Pselect + j == 19) {
										System.out.println("I am in column :P: "+ (Col_Pselect + j) );
									count++;
									if (j == 0) // handling the starting event
									{

										for (int k = 18; k < Col_Pselect + j
												+ 1; k++) {
											if (model1.getValueAt(Row_Pselect
													+ i, k) != null
													&& !"".equals(model1
															.getValueAt(
																	Row_Pselect
																	+ i,
																	k))) {
												//new development for FRD1.5 by akansha
												totalTaxDed21 = totalTaxDed21
														+ Double.parseDouble(GrpuUtil.validRupee(model1
																.getValueAt(
																		Row_Pselect
																		+ i,
																		k)));
											}

										}

									}

									if (j == currTDRow.size() - 1) {
										System.out.println("I am in Akki.. :)");
										for (int p = Col_Pselect + j + 2; p < 21; p++) {
											if (model1.getValueAt(Row_Pselect
													+ i, p) != null
													&& !"".equals(model1
															.getValueAt(
																	Row_Pselect
																	+ i,
																	p))) {
												//new development for FRD1.5 by akansha
												totalTaxDed21 = totalTaxDed21
														+ Double.parseDouble(GrpuUtil.validRupee(model1
																.getValueAt(
																		Row_Pselect
																		+ i,
																		p)));
											}
										}

									}
									int ya = Col_Pselect + j;

									if (Col_Pselect + j == 17
											|| Col_Pselect + j == 18
											|| Col_Pselect + j == 19) {

										if (currTDRow.elementAt(j).toString() != null
												&& !"".equals(currTDRow
														.elementAt(j)
														.toString()))
											//new development for FRD1.5 by akansha
											totalTaxDed21 = totalTaxDed21
											+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
													.elementAt(j)));

									}

								}

								// Newly added for 27Q
								if (formNum.equals("27Q")) {

									if (Col_Pselect + j == 31) {
										if (currTDRow.elementAt(j).toString() != null
												&& !"".equals(currTDRow
														.elementAt(j)
														.toString()))
											if(GrpuUtil.getDropDownRemittance(currTDRow.elementAt(j).toString()))
												model1.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
									}
								}
								//rpu 3.1 start
								if (formNum.equals("26Q")) {							
									if (Col_Pselect + j == 30)
									{
										if (currTDRow.elementAt(j).toString() != null && !"".equals(currTDRow.elementAt(j).toString()))
											model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect +1+ j);
									}
									//RPU 3.4
									if (Col_Pselect + j == 31)
									{
										if (currTDRow.elementAt(j).toString() != null && !"".equals(currTDRow.elementAt(j).toString()))
											model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect +1+ j);
									}
									if (Col_Pselect + j == 32)
									{
										if (currTDRow.elementAt(j).toString() != null && !"".equals(currTDRow.elementAt(j).toString()))
											{System.out.println("I am in column: "+ (Col_Pselect + j) );
											model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect +1+ j);}
									}
								}
								if (formNum.equals("27Q")) {							
									if (Col_Pselect + j == 39)
									{
										if (currTDRow.elementAt(j).toString() != null && !"".equals(currTDRow.elementAt(j).toString()))
											model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect +1+ j);
									}
									//RPU 3.4
									if (Col_Pselect + j == 40)
									{
										if (currTDRow.elementAt(j).toString() != null && !"".equals(currTDRow.elementAt(j).toString()))
											model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect +1+ j);
									}
									if (Col_Pselect + j == 41)
									{
										if (currTDRow.elementAt(j).toString() != null && !"".equals(currTDRow.elementAt(j).toString()))
											{System.out.println("I am in column: "+ (Col_Pselect + j) );
											model1.setValueAt(currTDRow.elementAt(j),Row_Pselect + i,Col_Pselect +1+ j);}
									}
								}
								//RPU 2.9 start
								//System.out.println("section field of ann1: "+ currTDRow.elementAt(j-20).toString());
								pasteXLAnnex1(Col_Pselect, Row_Pselect,
										currTDRow.elementAt(j), tabname, i, j,
										selYear_anne2, next_year_anne2);

							}

						}

						// newly added by choliaroma on 2march
						if (count > 0){
							model1.setValueAt(df.format(totalTaxDed21),
									Row_Pselect + i, 21); // setting total sum
							// in the challan
							// tab
							// end //newly added by choliaroma on 2march

							//new development for FRD1.3 by Akansha
							model1.setValueAt(df.format(totalTaxDed21),
									Row_Pselect + i, 23);
						}
					}

				}

				else if (tabname.trim().equals("Anne2")) {
					
					/******************  Copy Paste Logic Start For Annexure 2 *************************/
					
					// Col_Pselect + j =>actual col no -1 
					
					
					double totalSalannex2 = 0;
					double totalDedSeccol13 = 0;
					double incmChargbleHeadSal = 0;
					double chalVIAcol21 = 0;
					double nettaxpayble = 0;
					double totalTaxSource = 0;
					count = 0; // to enable copy paste for the remaining columns
					count1 = 0;// to enable copy paste for the remaining columns
					// for total dedcutions16Iand 16II
					count3 = 0; 
					count2 = 0; // for column 
					count4 = 0;// for column 27
					count5 = 0;
					count6=0;//newly added for FRD1.6 by akansha
					/****************** Added for 2.7 Start for - count7 Added Sec 10 values col60+....col65 *********/
					count7 = 0; // For Additon of col62 to col67
					count8 = 0; // For Additon of col59 to col61 and add sum in col8 
					double totAmtExceptionSec10 = 0;
					double totGrossRecFrmCurEmployer = 0;
					boolean flagtotGrossRecFrmCurEmployer = false;
					String finyear = JComboBox_Form_Sub1_finYear.getSelectedItem().toString();
					int fyear=0;
					fyear = Integer.parseInt(finyear.substring(0,4));
					
					/****************** Added for 2.7 End ********************/
					if (Row_Pselect != 0 && Row_Pselect != 1) // newly adde by
						// cholia on 5
						// march 2015
					{					

						for (int j = 0; j < currTDRow.size() && (Col_Pselect + j) < model2.getColumnCount(); j++) {

						
							String mode = "";
							Object modeObj = model2.getValueAt(Row_Pselect + i,
									2);
							if (modeObj != null)
								mode = modeObj.toString();

 							if (valueOfTypeOfStmt.equalsIgnoreCase("Correction") && Row_Pselect < row_count_annex2 /*&& ("PAN UPDATE".equals(mode) || "DELETE".equals(mode))*/)// newly
								// added
								// by
								// cholia
								// 0n 9
								// march
							{
								System.out.println("Col value in Anne2: "+ (j)+ " "+currTDRow.elementAt(j).toString());
								//new development for FRD1.3 by Akansha
								if(Col_Pselect + j == 1)
								{
									if("DELETE".equals(currTDRow.elementAt(j).toString()) || "PAN UPDATE".equals(currTDRow.elementAt(j).toString()))
										model2.setValueAt(
												currTDRow.elementAt(j),
												Row_Pselect + i, 2); 
								}

								/*String mode = "";
								Object modeObj = model1.getValueAt(Row_Pselect+ i, 2);
								if (modeObj != null)
									mode = modeObj.toString();
								if ("--Select--".equals(mode)) {

								}*/
								//*********************************************************


								if ("PAN UPDATE".equals(mode)) {
									// pan of the employee able hai

									if (pan_Updtn_Indicator_Anne2
											.get((Row_Pselect + i) - 2) < 2) {
										//new development for FRD1.5 by akansha
										if(Col_Pselect + j ==2){ // for checking valid PAN of employee
											if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
												panAnne = false;
												model2.setValueAt(
														"",
														Row_Pselect + i, Col_Pselect
														+ 1 + j);
												pointToCell_Annex2(Row_Pselect+i, Col_Pselect+j);
											}else{
												model2.setValueAt(
														(currTDRow.elementAt(j).toString()),
														Row_Pselect + i,
														Col_Pselect + 1 + j);
											}
										}
										//************************************
										else {

										}

									} else {

									}

								}

								else {
									// dont allow to paste here
									System.out.println("dont copy here");
									// bug fix to paste in already exting(in saved file) rows with update mode "Add"
									model2.setValueAt(
											(currTDRow.elementAt(j).toString()),
											Row_Pselect + i,
											Col_Pselect + 1 + j);
								}

							}

							else // for regular
							{					
								boolean bl1 = columnNumberEditableForcolour(Col_Pselect
										+ j, tabname, Row_Pselect + i,
										selYear_anne2, next_year_anne2,
										formNumber);

								boolean bl2 = columnNumberEditable(
										Col_Pselect + j, tabname,
										Row_Pselect + i);

								System.out.println("bl1 & bl2 = "+bl1 +" and " +bl2);

								if (columnNumberEditableForcolour(Col_Pselect
										+ j, tabname, Row_Pselect + i,
										selYear_anne2, next_year_anne2,
										formNumber)
										|| columnNumberEditable(
												Col_Pselect + j, tabname,
												Row_Pselect + i))// added for
									// date
									// fields in
									// annaexure2
								{ // Col_Pselect + j==5 || Col_Pselect + j==6
									// newly removed by cholia
									//rahul copy paste code
									 
								}

								else {
									// newly added by cholia for the copy paste
									// on 29.02.2015
									System.out.println("I am in first");
									if (Col_Pselect + j == 7
											|| Col_Pselect + j == 8) {

										count++;
										
										/****************** Added for 2.7 Start ********************/
										
										if (fyear >= 2018 )
										{	
											flagtotGrossRecFrmCurEmployer = true; // To calculate the Sum of Columns 59 + 60 + 61
										}
										

										/****************** Added for 2.7 End ********************/
										if (j == 0) // handling the starting
											// event
										{

											for (int k = 8; k < Col_Pselect + j
													+ 1; k++) {
												if (model2.getValueAt(
														Row_Pselect + i, k) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		k))) {
													//new development for FRD1.5 by akansha
													totalSalannex2 = totalSalannex2
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k)));
												}

											}

										}

										if (j == currTDRow.size() - 1) {

											for (int p = Col_Pselect + j + 2; p < 10; p++) {
												if (model2.getValueAt(
														Row_Pselect + i, p) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		p))) {
													//new development for FRD1.5 by akansha
													totalSalannex2 = totalSalannex2
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p)));
												}
											}

										}
										int ya = Col_Pselect + j;

										if (Col_Pselect + j == 7
												|| Col_Pselect + j == 8) {

											if (currTDRow.elementAt(j)
													.toString() != null
													&& !"".equals(currTDRow
															.elementAt(j)
															.toString()))
												//new development for FRD1.5 by akansha
												totalSalannex2 = totalSalannex2
												+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
														.elementAt(j)));

										}

									}
								
									// newly added by cholia for fields
									// deduction16(ii) and deduction16(iii)
									//FRD 2.3 added 16(ia)	added condition for column 13 (i.e. Col_Pselect + j == 12)
									if (Col_Pselect + j == 10
											|| Col_Pselect + j == 11 || Col_Pselect + j == 12
											/****************** Added for 2.7 Start ********************/
											|| Col_Pselect + j == 60
											|| Col_Pselect + j == 61
											|| Col_Pselect + j == 62
											|| Col_Pselect + j == 63
											|| Col_Pselect + j == 64
											|| Col_Pselect + j == 65
											|| Col_Pselect + j == 66
											/****************** Added for 2.7 End ********************/ 
											){
										count1++;
										if (j == 0) // handling the starting
											// event
										{

											for (int k = 11; k < Col_Pselect
													+ j + 1; k++) {
												
												/****************** Added for 2.7 Start ********************/
												if (!((k >=11 && k<=13 ) || (k >=62 && k<=67 )))
												{
													continue;
												}
												/****************** Added for 2.7 End  ********************/
												
												if (model2.getValueAt(
														Row_Pselect + i, k) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		k))) {
													//new development for FRD1.5 by akansha
													totalDedSeccol13 = totalDedSeccol13
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k)));
												}

											}

										}

										if (j == currTDRow.size() - 1) {

											for (int p = Col_Pselect + j + 2; p < 68; p++) { // //FRD 2.3 added 16(ia), added < 14 instead of <13
												
												
												/****************** Added for 2.7 Start ********************/
												if (!((p >=11 && p<=13 ) || (p >=62 && p<=67)))
												{
													continue;
												}
												/****************** Added for 2.7 End  ********************/
												
												
												if (model2.getValueAt(
														Row_Pselect + i, p) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		p))) {
													//new development for FRD1.5 by akansha
													totalDedSeccol13 = totalDedSeccol13
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p)));
												}
											}

										}
										int ya = Col_Pselect + j;
										//FRD 2.3 added 16(ia)	added condition for column 13 (i.e. Col_Pselect + j == 12)
										if (Col_Pselect + j == 10
												|| Col_Pselect + j == 11 || Col_Pselect + j == 12
												/****************** Added for 2.7 Start ********************/
												|| Col_Pselect + j == 60
												|| Col_Pselect + j == 61
												|| Col_Pselect + j == 62
												|| Col_Pselect + j == 63
												|| Col_Pselect + j == 64
												|| Col_Pselect + j == 65
												|| Col_Pselect + j == 66
												/****************** Added for 2.7 End ********************/
												) {

											if (currTDRow.elementAt(j)
													.toString() != null
													&& !"".equals(currTDRow
															.elementAt(j)
															.toString()))
												//new development for FRD1.5 by akansha
												totalDedSeccol13 = totalDedSeccol13
												+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
														.elementAt(j)));

										}

									}

									// start here 3.03.2015

									if (Col_Pselect + j == 14 
										/******************
										 * Added for 2.7 Start col16 Gross Total
										 ********************/
										|| Col_Pselect + j == 68
								){								/****************** Added for 2.7 End ********************/
										System.out.println("I am in second");
										count2++;
										//count++;	
										/****************** Added for 2.7 Start col16 Gross Total ********************/
										
										
										
									/*	incmChargbleHeadSal = 0;
										if (model2.getValueAt(Row_Pselect + i,
												14) != null
												&& !"".equals(model2
														.getValueAt(Row_Pselect
																+ i, 14))) {
											System.out.println("I am in third");
											//new development for FRD1.5 by akansha
											incmChargbleHeadSal = Double
													.parseDouble(GrpuUtil.validRupee(model2
															.getValueAt(
																	Row_Pselect
																	+ i,
																	14)));
										}
										//new development for FRD1.5 by akansha
										incmChargbleHeadSal = incmChargbleHeadSal
												+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
														.elementAt(j)));
										System.out.println("I am in fourth: "+ incmChargbleHeadSal);
									*/}
										/****************** Added for 2.7 End ********************/


									// newly added here cholia 17+18+19+20

									if (Col_Pselect + j == 16
											|| Col_Pselect + j == 17
											|| Col_Pselect + j == 18
											|| Col_Pselect + j == 19
											/****************** Added for 2.9 Start ********************/
											|| Col_Pselect + j == 70
											|| Col_Pselect + j == 72
											|| Col_Pselect + j == 74
											|| Col_Pselect + j == 76
											|| Col_Pselect + j == 78
											|| Col_Pselect + j == 80
											|| Col_Pselect + j == 82
											|| Col_Pselect + j == 85
											|| Col_Pselect + j == 88
											/****************** Added for 2.9 End  ********************/
											) {
										count3++;
										if (j == 0) // handling the starting
											// event
										{

											for (int k = 17; k < Col_Pselect
													+ j + 1; k++) {

												/****************** Added for 2.7 Start ********************/
												/*if (!((k >=17 && k<=20 ) || (k >=70 && k<=78 )))
												{
													continue;
												}*/
												/****************** Added for 2.7 End  ********************/
												if (!((k >=17 && k<=20 ) || (k ==71 || k ==73 || k ==75 || k ==77 || k ==79 || k ==81 || k ==83 || k ==86 || k ==89)))
												{
													continue;
												}
												

												if (model2.getValueAt(Row_Pselect + i, k) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		k))) {
													//new development for FRD1.5 by akansha
													chalVIAcol21 = chalVIAcol21
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k)));
												}

											}

										}

										if (j == currTDRow.size() - 1) {

											/****************** Added for 2.7 Start ********************/
											// Commetted for 2.7 for (int p = Col_Pselect + j + 2; p < 21; p++) {
											/*for (int p = Col_Pselect + j + 2; p < 79; p++) {

												if (!((p >=17 && p<=20 ) || (p >=70 && p<=78 )))
												{
													continue;
												}*/

												/****************** Added for 2.7 End  ********************/
											for (int p = Col_Pselect + j + 2; p < 93; p++) {

												if (!((p >=17 && p<=20 ) || (p ==71 || p ==73 || p ==75 || p ==77 || p ==79 || p ==81 || p ==83 || p ==86 || p ==89 )))
												{
													continue;
												}
												if (model2.getValueAt(
														Row_Pselect + i, p) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		p))) {
													//new development for FRD1.5 by akansha
													chalVIAcol21 = chalVIAcol21
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p)));
												}
											}

										}
										int ya = Col_Pselect + j;

										if (Col_Pselect + j == 16
												|| Col_Pselect + j == 17
												|| Col_Pselect + j == 18
												|| Col_Pselect + j == 19
												/****************** Added for 2.7 Start ********************/
												|| Col_Pselect + j == 70
												|| Col_Pselect + j == 72
												|| Col_Pselect + j == 74
												|| Col_Pselect + j == 76
												|| Col_Pselect + j == 78
												|| Col_Pselect + j == 80
												|| Col_Pselect + j == 82
												|| Col_Pselect + j == 85
												|| Col_Pselect + j == 88
												/****************** Added for 2.7 End  ********************/
												) {

											if (currTDRow.elementAt(j)
													.toString() != null
													&& !"".equals(currTDRow
															.elementAt(j)
															.toString()))
												//new development for FRD1.5 by akansha
												chalVIAcol21 = chalVIAcol21
												+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
														.elementAt(j)));

										}

									}

									// 23+24+25
									if (Col_Pselect + j == 22
											|| Col_Pselect + j == 23
											|| Col_Pselect + j == 24) {
										count4++;
										if (j == 0) // handling the starting
											// event
										{

											for (int k = 23; k < Col_Pselect
													+ j + 1; k++) {
												if (model2.getValueAt(
														Row_Pselect + i, k) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		k))) {
													//new development for FRD1.5 by akansha
													nettaxpayble = nettaxpayble
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k)));
												}

											}

										}

										if (j == currTDRow.size() - 1) {

											for (int p = Col_Pselect + j + 2; p < 26; p++) {
												if (model2.getValueAt(
														Row_Pselect + i, p) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		p))) {
													//new development for FRD1.5 by akansha
													nettaxpayble = nettaxpayble
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p)));
												}
											}

										}
										int ya = Col_Pselect + j;

										if (Col_Pselect + j == 22
												|| Col_Pselect + j == 23
												|| Col_Pselect + j == 24) {

											if (currTDRow.elementAt(j)
													.toString() != null
													&& !"".equals(currTDRow
															.elementAt(j)
															.toString()))
												//new development for FRD1.5 by akansha
												nettaxpayble = nettaxpayble
												+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
														.elementAt(j)));

										}

									}

									// end //23+24+25
									//
									// start here 28+29+57


									//newly added for FRD1.6 by akansha --- Addition of column 57 
									if (Col_Pselect + j == 27
											|| Col_Pselect + j == 28
											|| Col_Pselect + j == 56
											) {
										count5++;
										if (j == 0) // handling the starting
											// event
										{

											for (int k = 28; k < Col_Pselect
													+ j + 1; k++) {
												if(k==28 || k==29 || k==57){
													System.out
													.println("Value of k:"+k);
													if (model2.getValueAt(
															Row_Pselect + i, k) != null
															&& !"".equals(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k))) {
														//new development for FRD1.5 by akansha
														totalTaxSource = totalTaxSource
																+ Double.parseDouble(GrpuUtil.validRupee(model2
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				k)));
													}

												}
											}
										}

										if (j == currTDRow.size() - 1) {
											for (int p = Col_Pselect + j + 2; p < 59; p++) {
												if(p==28 || p==29 || p==57){

													if(p==57){
														if(selYear_anne2>2012 &&
																"Yes".equals(model2.getValueAt(Row_Pselect + i, 51).toString()))
															if (model2.getValueAt(
																	Row_Pselect + i, p) != null
																	&& !"".equals(model2
																			.getValueAt(
																					Row_Pselect
																					+ i,
																					p))) {
																//new development for FRD1.5 by akansha
																totalTaxSource = totalTaxSource
																		+ Double.parseDouble(GrpuUtil.validRupee(model2
																				.getValueAt(
																						Row_Pselect
																						+ i,
																						p)));
															}
													}else{
														if (model2.getValueAt(
																Row_Pselect + i, p) != null
																&& !"".equals(model2
																		.getValueAt(
																				Row_Pselect
																				+ i,
																				p))) {
															//new development for FRD1.5 by akansha
															totalTaxSource = totalTaxSource
																	+ Double.parseDouble(GrpuUtil.validRupee(model2
																			.getValueAt(
																					Row_Pselect
																					+ i,
																					p)));
														}
													}
												}
											}

										}
										int ya = Col_Pselect + j;

										//newly added for FRD1.6 by akansha
										if (Col_Pselect + j == 27
												|| Col_Pselect + j == 28
												|| Col_Pselect + j == 56) {
											if(Col_Pselect + j ==56){
												if(selYear_anne2>2012 &&
														"Yes".equals(model2.getValueAt(Row_Pselect + i, 51).toString()))
													if (currTDRow.elementAt(j)
															.toString() != null
															&& !"".equals(currTDRow
																	.elementAt(j)
																	.toString()))
														//new development for FRD1.5 by akansha
														totalTaxSource = totalTaxSource
														+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
																.elementAt(j)));
											}else{
												if (currTDRow.elementAt(j)
														.toString() != null
														&& !"".equals(currTDRow
																.elementAt(j)
																.toString()))
													//new development for FRD1.5 by akansha
													totalTaxSource = totalTaxSource
													+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
															.elementAt(j)));
											}
										}

									}



									// end start here 28+29+57
									// end
									
                                   // Net Tax Liability and shortfall
									if (Col_Pselect + j == 25
											/****************** Added for 2.7 Start ********************/
											|| Col_Pselect + j == 89 
											/****************** Added for 2.7 End  ********************/) // incometax
										// relief
									{
										double sum = 0; // sum 23+24+25
										if (model2.getValueAt(Row_Pselect + i,
												23) != null
												&& !"".equals(model2
														.getValueAt(Row_Pselect
																+ i, 23))) {
											//new development for FRD1.5 by akansha
											sum = sum
													+ Double.parseDouble(GrpuUtil.validRupee(model2
															.getValueAt(
																	Row_Pselect
																	+ i,
																	23)));
										}
										if (model2.getValueAt(Row_Pselect + i,
												24) != null
												&& !"".equals(model2
														.getValueAt(Row_Pselect
																+ i, 24))) {
											//new development for FRD1.5 by akansha
											sum = sum
													+ Double.parseDouble(GrpuUtil.validRupee(model2
															.getValueAt(
																	Row_Pselect
																	+ i,
																	24)));
										}
										if (model2.getValueAt(Row_Pselect + i,
												25) != null
												&& !"".equals(model2
														.getValueAt(Row_Pselect
																+ i, 25))) {
											//new development for FRD1.5 by akansha
											sum = sum
													+ Double.parseDouble(GrpuUtil.validRupee(model2
															.getValueAt(
																	Row_Pselect
																	+ i,
																	25)));
										}

										double diff = 0;
										double col30 = 0;
										double shortfall = 0;
										/****************** Added for 2.7 Start ********************/
										double tempRelief = 0;
										
										if (Col_Pselect + j == 25)
										{
											
											if (model2.getValueAt(Row_Pselect + i,
													90) != null
													&& !"".equals(model2
															.getValueAt(Row_Pselect
																	+ i, 90))) {
												tempRelief = tempRelief
														+ Double.parseDouble(GrpuUtil.validRupee(model2
																.getValueAt(
																		Row_Pselect
																				+ i,
																		90)));
											}
											
										}else if (Col_Pselect + j == 89)
										{
											if (model2.getValueAt(Row_Pselect + i,
													26) != null
													&& !"".equals(model2
															.getValueAt(Row_Pselect
																	+ i, 26))) {
												tempRelief = tempRelief
														+ Double.parseDouble(GrpuUtil.validRupee(model2
																.getValueAt(
																		Row_Pselect
																				+ i,
																		26)));
											}
										}
										
										

										//new development for FRD1.5 by akansha					
										
										/*if (currTDRow.elementAt(j).toString() != null
												&& !"".equals(currTDRow
														.elementAt(j)
														.toString()))
											diff = sum
													- Double.parseDouble(GrpuUtil.validRupee(currTDRow
															.elementAt(j)));*/

										if (currTDRow.elementAt(j).toString() != null
												&& !"".equals(currTDRow
														.elementAt(j)
														.toString()))
											tempRelief = tempRelief
											+  Double.parseDouble(GrpuUtil.validRupee(currTDRow
													.elementAt(j)));

										diff = sum - tempRelief;

										/****************** Added for 2.7 End  ********************/
										

										model2.setValueAt(df.format(diff),
												Row_Pselect + i, 27);

										if (model2.getValueAt(Row_Pselect + i,
												30) != null
												&& !"".equals(model2
														.getValueAt(Row_Pselect
																+ i, 30))) {
											col30 = Double
													.parseDouble(model2
															.getValueAt(
																	Row_Pselect
																	+ i,
																	30)
																	.toString());
										}

										shortfall = Double
												.parseDouble(model2.getValueAt(
														Row_Pselect + i, 27)
														.toString())
														- col30;

										model2.setValueAt(df.format(shortfall),
												Row_Pselect + i, 31);

									}

									// end newly added by cholia for fields
									// deduction16(ii) and deduction16(iii)

									// fo fy <2013-2014
									if (Col_Pselect + j == 29) // when it is
										// enable for
										// column30
									{
										double diff = 0;
										double col27 = 0;
										if (model2.getValueAt(Row_Pselect + i,
												27) != null
												&& !"".equals(model2
														.getValueAt(Row_Pselect
																+ i, 27))) {
											col27 = Double
													.parseDouble(model2
															.getValueAt(
																	Row_Pselect
																	+ i,
																	27)
																	.toString());
										}

										if (currTDRow.elementAt(j).toString() != null
												&& !"".equals(currTDRow
														.elementAt(j)
														.toString()))
											diff = col27
											- Double.parseDouble(currTDRow
													.elementAt(j)
													.toString());

										model2.setValueAt(df.format(diff),
												Row_Pselect + i, 31);
									}

									if (Col_Pselect + j == 9) // for column 10
									{
										System.out.println("I am in fifth");
										double diff = 0;
										double col13 = 0;
										double add = 0;

										/*********************************************************/				
										//FRD 2.3 added 16(ia)
										/*if (model2.getValueAt(Row_Pselect + i,
												13) != null
												&& !"".equals(model2
														.getValueAt(Row_Pselect
																+ i, 13))) {
											col13 = Double
													.parseDouble(model2
															.getValueAt(
																	Row_Pselect
																			+ i,
																	13)
															.toString());
										}*/

										double ded16IICol11 = 0;
										double ded16IIICol12 = 0;
										double ded16IACol13 = 0;

										if (model2.getValueAt(Row_Pselect + i, 11) != null && model2.getValueAt(Row_Pselect + i, 11).toString().length() != 0) {
											ded16IICol11 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 11).toString());
										}

										if (model2.getValueAt(Row_Pselect + i, 12) != null && model2.getValueAt(Row_Pselect + i, 12).toString().length() != 0) {
											ded16IIICol12 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 12).toString());
										}

										if (model2.getValueAt(Row_Pselect + i, 13) != null && model2.getValueAt(Row_Pselect + i, 13).toString().length() != 0) {
											ded16IACol13 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 13).toString());
										}

										col13 = ded16IICol11 + ded16IIICol12 + ded16IACol13;
										/*********************************************************/	

										if (currTDRow.elementAt(j).toString() != null
												&& !"".equals(currTDRow
														.elementAt(j)
														.toString()))
											diff = Double.parseDouble(currTDRow
													.elementAt(j).toString())
													- col13;
										//new development for FRD1.3 by Akansha
										if(model2.getValueAt(Row_Pselect+i,15)!=null && !"".equals(model2.getValueAt(Row_Pselect+i,15).toString()))
											add = diff + Double
											.parseDouble(model2
													.getValueAt(
															Row_Pselect
															+ i,
															15)
															.toString());
										model2.setValueAt(df.format(diff),
												Row_Pselect + i, 14);
										System.out.println("Addition: "+ add);
										model2.setValueAt(df.format(add),
												Row_Pselect + i, 16); //new development for FRD1.3 by Akansha
									}
									

									if (Col_Pselect + j == 1
											|| Col_Pselect + j == 0) {

									}
									                         
									 

									// end

									// end newly added by cholia for the copy
									// paste on 2.03.2015

									// end newly added by cholia for the copy
									// paste on 29.02.2015
									else {

										//newly modified for FRD1.6 by akansha
										//	if (Col_Pselect + 1 + j <= 57){ // newly
										// added
										// by
										// choi
										// on 11
										// march
										/****************** Added for 2.7 Start ********************/
										if (Col_Pselect + 1 + j <= (TABLE_COLUMN_COUNT_annII - 2)){
											/***************** Added for 2.7 End  ********************/
											//new development for FRD1.5 by akansha
											if(		Col_Pselect + 1 + j == 8 ||
													Col_Pselect + 1 + j == 9 ||
													Col_Pselect + 1 + j == 10 ||
													Col_Pselect + 1 + j == 11 ||
													Col_Pselect + 1 + j == 12 ||	
													Col_Pselect + 1 + j == 13 || //FRD 2.3 added 16(ia), copy paste for column 16IA
													Col_Pselect + 1 + j == 15 ||
													Col_Pselect + 1 + j == 17 ||
													Col_Pselect + 1 + j == 18 ||
													Col_Pselect + 1 + j == 19 ||
													Col_Pselect + 1 + j == 20 ||
													Col_Pselect + 1 + j == 23 ||
													Col_Pselect + 1 + j == 24 ||
													Col_Pselect + 1 + j == 25 || 
													Col_Pselect + 1 + j == 26 ||
													Col_Pselect + 1 + j == 28 ||
													Col_Pselect + 1 + j == 29){

												///*********************************************************/				
												//FRD 2.3 added 16(ia)				
												System.out.println("copy paste for Annexure II");
												if ((selYear_anne2 < 2018 && next_year_anne2 < 2019)
														&& Col_Pselect + j ==12){
													flaggingCol16IA = false;
													model2.setValueAt(
															"",
															Row_Pselect + i, Col_Pselect
															+ 1 + j);
													pointToCell_Annex2(Row_Pselect+i, Col_Pselect+j);
												}
												/*********************************************************/	
												else{																							
													model2.setValueAt(GrpuUtil.validRupee(
															currTDRow.elementAt(j)),
															Row_Pselect + i,
															Col_Pselect + 1 + j);
												}
											}

											else //new development for FRD1.5 by akansha
												if(Col_Pselect + j ==2){ // for checking valid PAN of employee
													if(GrpuUtil.checkPan(currTDRow.elementAt(j).toString())){
														panAnne = false;
														model2.setValueAt(
																"",
																Row_Pselect + i, Col_Pselect
																+ 1 + j);
														pointToCell_Annex2(Row_Pselect+i, Col_Pselect+j);
													}else{
														model2.setValueAt(
																(currTDRow.elementAt(j).toString()),
																Row_Pselect + i,
																Col_Pselect + 1 + j);
													}
												}
											//************************************


												else{

													if(//newly added for FRD1.6 by akansha

															Col_Pselect + 1 + j == 33 ||
															Col_Pselect + 1 + j == 34 ||
															Col_Pselect + 1 + j == 35 ||
															Col_Pselect + 1 + j == 36 ||
															//2nd
															Col_Pselect + 1 + j == 37 ||
															Col_Pselect + 1 + j == 38 ||
															Col_Pselect + 1 + j == 39 ||
															Col_Pselect + 1 + j == 40 ||
															//3rd
															Col_Pselect + 1 + j == 41 

															//													//***********************************)
															){
														if (selYear_anne2 >= 2016) {
															if(Col_Pselect + 1 + j == 33)
																model2.setValueAt(
																		currTDRow.elementAt(j),
																		Row_Pselect + i,
																		Col_Pselect + 1 + j);
															else{
																if("Yes".equals(model2.getValueAt(Row_Pselect + i, 33).toString())){
																	model2.setValueAt(
																			currTDRow.elementAt(j),
																			Row_Pselect + i,
																			Col_Pselect + 1 + j);
																}
															}
														}
													}
													else if(Col_Pselect + 1 + j == 42 ||
															Col_Pselect + 1 + j == 43 ||
															Col_Pselect + 1 + j == 44 ||
															//4th
															Col_Pselect + 1 + j == 45 ||
															Col_Pselect + 1 + j == 46 ||
															Col_Pselect + 1 + j == 47 ||
															Col_Pselect + 1 + j == 48 ||
															Col_Pselect + 1 + j == 49 ||
															Col_Pselect + 1 + j == 50){
														if (selYear_anne2 >= 2016) {
															if(Col_Pselect + 1 + j == 42)
																model2.setValueAt(
																		currTDRow.elementAt(j),
																		Row_Pselect + i,
																		Col_Pselect + 1 + j);
															else{
																if("Yes".equals(model2.getValueAt(Row_Pselect + i, 42).toString())){
																	model2.setValueAt(
																			currTDRow.elementAt(j),
																			Row_Pselect + i,
																			Col_Pselect + 1 + j);
																}
															}
														}
													}   
													
												   //rahul copy paste code
												else if ((Col_Pselect + 1 + j == 93)) {
												if (selYear_anne2 >= 2020) { 
												if("Yes".equals(currTDRow.elementAt(j).toString())|| "No".equals(currTDRow.elementAt(j).toString())
														|| "--Select--".equals(currTDRow.elementAt(j).toString()))//newly developed for FRD1.5 by akansha
													model2.setValueAt(
															currTDRow.elementAt(j),
															Row_Pselect + i,
															Col_Pselect + 1 + j);

											} 
										} 
												                                   
													    else if(Col_Pselect + 1 + j == 51 ||
															//4th
															Col_Pselect + 1 + j == 52 ||
															Col_Pselect + 1 + j == 53 ||
															Col_Pselect + 1 + j == 54 ||
															Col_Pselect + 1 + j == 55 ||
															Col_Pselect + 1 + j == 56 ||
															Col_Pselect + 1 + j == 57){


														if (selYear_anne2 >= 2013) {
															if(Col_Pselect + 1 + j == 51)
																model2.setValueAt(
																		currTDRow.elementAt(j),
																		Row_Pselect + i,
																		Col_Pselect + 1 + j);
															else
															{
																if("Yes".equals(model2.getValueAt(Row_Pselect + i, 51).toString())){

																	//newly added for FRD1.6 by akansha
																	if(Col_Pselect + j ==52 || Col_Pselect + j ==53){
																		if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

																			//newly developed for FRD1.5 Ver1.5 by akansha
																			if(currTDRow.elementAt(j).toString().contains("-")){
																				model2.setValueAt(
																						currTDRow.elementAt(j).toString().replace("-","/"),
																						Row_Pselect + i, Col_Pselect +
																						1+ j);
																			}
																			else

																				model2.setValueAt(
																						currTDRow.elementAt(j),
																						Row_Pselect + i, Col_Pselect +
																						1+ j);
																		}else{
																			//System.out.println("Inside else");
																			flagging = false;
																			if(Col_Pselect + j ==52)
																				model2.setValueAt(
																						"",
																						Row_Pselect + i,53);
																			if(Col_Pselect + j ==53)
																				model2.setValueAt(
																						"",
																						Row_Pselect + i,54);
																		}
																	}else if(Col_Pselect + j ==56){
																		count5++;
																		model2.setValueAt(
																				currTDRow.elementAt(j),
																				Row_Pselect + i,
																				Col_Pselect + 1 + j);
																	}else if(Col_Pselect + j ==54){
																		count6++;
																		model2.setValueAt(
																				currTDRow.elementAt(j),
																				Row_Pselect + i,
																				Col_Pselect + 1 + j);
																	}
																	model2.setValueAt(
																			currTDRow.elementAt(j),
																			Row_Pselect + i,
																			Col_Pselect + 1 + j);
																	//***********************************************************
																}
															}
														}
													}
													else
														model2.setValueAt(
																currTDRow.elementAt(j),
																Row_Pselect + i,
																Col_Pselect + 1 + j);

												}
											     

										}
																			
											}
									

									//new development for FRD1.5 by akansha
									if(Col_Pselect + j ==5 || Col_Pselect + j ==6){
										if(GrpuUtil.verifyDate(currTDRow.elementAt(j).toString())){

											//newly developed for FRD1.5 Ver1.5 by akansha
											if(currTDRow.elementAt(j).toString().contains("-")){
												model2.setValueAt(
														currTDRow.elementAt(j).toString().replace("-","/"),
														Row_Pselect + i, Col_Pselect +
														1+ j);
											}
											else

												model2.setValueAt(
														currTDRow.elementAt(j),
														Row_Pselect + i, Col_Pselect +
														1+ j);
										}else{
											//System.out.println("Inside else");
											flagging = false;
											if(Col_Pselect + j ==5)
												model2.setValueAt(
														"",
														Row_Pselect + i,6);
											if(Col_Pselect + j ==6)
												model2.setValueAt(
														"",
														Row_Pselect + i,7);
										}
									}
									
									//******************************************************************

									/****************** Added for 2.7 Start for - count7 Added Sec 10 values col60+....col65 
									 * count 8 Add col59+...+col61********************/

									if ( Col_Pselect + j == 61              //Col_Pselect + j == actual col no-1
											|| Col_Pselect + j == 62
											|| Col_Pselect + j == 63
											|| Col_Pselect + j == 64
											|| Col_Pselect + j == 65
											|| Col_Pselect + j == 66
											) {
										count7++;
										if (j == 0) // handling the starting
											// event
										{

											for (int k = 62; k < Col_Pselect         //k == actual col no
													+ j + 1; k++) {
												if (model2.getValueAt(
														Row_Pselect + i, k) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		k))) {
													totAmtExceptionSec10 = totAmtExceptionSec10
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			k)));
												}

											}

										}

										if (j == currTDRow.size() - 1) {

											for (int p = Col_Pselect + j + 2; p <=67; p++) {
												if (model2.getValueAt(
														Row_Pselect + i, p) != null
														&& !"".equals(model2
																.getValueAt(
																		Row_Pselect
																		+ i,
																		p))) {
													totAmtExceptionSec10 = totAmtExceptionSec10
															+ Double.parseDouble(GrpuUtil.validRupee(model2
																	.getValueAt(
																			Row_Pselect
																			+ i,
																			p)));
												}
											}

										}
										int ya = Col_Pselect + j;

										if ( Col_Pselect + j == 61
												|| Col_Pselect + j == 62
												|| Col_Pselect + j == 63
												|| Col_Pselect + j == 64
												|| Col_Pselect + j == 65
												|| Col_Pselect + j == 66
												){

											if (currTDRow.elementAt(j)
													.toString() != null
													&& !"".equals(currTDRow
															.elementAt(j)
															.toString()))
												//new development for FRD1.5 by akansha
												totAmtExceptionSec10 = totAmtExceptionSec10
												+ Double.parseDouble(GrpuUtil.validRupee(currTDRow
														.elementAt(j)));

										}

									}
									
									if (Col_Pselect + j == 58 
											|| Col_Pselect + j == 59 
											|| Col_Pselect + j == 60
											|| flagtotGrossRecFrmCurEmployer == true) {
										count8++;
										if (j == 0) // handling the starting
										// event
										{

											for (int k = 59; k < Col_Pselect + j + 1; k++) {
												if (model2.getValueAt(Row_Pselect + i, k) != null
														&& !"".equals(model2.getValueAt(Row_Pselect + i, k))) {
													totGrossRecFrmCurEmployer = totGrossRecFrmCurEmployer + Double.parseDouble(
															GrpuUtil.validRupee(model2.getValueAt(Row_Pselect + i, k)));
												}

											}

										}

										if (j == currTDRow.size() - 1) {

											for (int p = Col_Pselect + j + 2; p <= 61; p++) {
												
												if (!(p >=58 && p<=61 ))
												{
													continue;
												}
												
												if (model2.getValueAt(Row_Pselect + i, p) != null
														&& !"".equals(model2.getValueAt(Row_Pselect + i, p))) {
													totGrossRecFrmCurEmployer = totGrossRecFrmCurEmployer + Double.parseDouble(
															GrpuUtil.validRupee(model2.getValueAt(Row_Pselect + i, p)));
												}
											}

										}
										int ya = Col_Pselect + j;

										if (Col_Pselect + j == 58 
												|| Col_Pselect + j == 59 
												|| Col_Pselect + j == 60
												) 
										{
											if (currTDRow.elementAt(j).toString() != null
													&& !"".equals(currTDRow.elementAt(j).toString()))
												totGrossRecFrmCurEmployer = totGrossRecFrmCurEmployer + Double
												.parseDouble(GrpuUtil.validRupee(currTDRow.elementAt(j)));

										}

									}

									/****************** Added for 2.7 End  ********************/

					





								}

							}
						} // yahan tak
						// newly added by cholia on 2.03.2015
						
						
						
						/****************** Added for 2.7 Start Before count 1 for start********************/

						if (count7 > 0) {

							model2.setValueAt(df.format(totAmtExceptionSec10),
									Row_Pselect + i, 68);


						}


						/****************** Added for 2.7 End  ********************/
						
						if (count > 0
								/****************** Added for 2.7 Start for count 8 Add col59+...+col61 to col8 and populate other columns********************/
								|| count8 > 0
								/****************** Added for 2.7 End ********************/
								) {
							double totalDed16i16II = 0;
							double col10 = 0;
							double diff14 = 0;
							double houspePropertycol15 = 0;
							double grosscol16 = 0;
							double col21 = 0;
							double diff16_21 = 0;

							//newly added for FRD1.6 by akansha
							double grossTotalcolSA58=0,grossTotalcol16=0;
							double amtcontriPI = 0;
							//*********************************

							/*********************************************************/				
							//FRD 2.3 added 16(ia)
							double ded16IICol11 = 0;
							double ded16IIICol12 = 0;
							double ded16IACol13 = 0;

							/*********************************************************/
							
							/****************** Added for 2.7 Start ********************/
							double ded16IACol68 = 0;
							/****************** Added for 2.7 End*******************/

							/****************** Added for 2.7 Start for count 8 Add col59+...+col61 to col8 and populate other columns********************/
							if (count8>0)
							{
								double col8 = 0;
								double col9 = 0;
								model2.setValueAt(df.format(totGrossRecFrmCurEmployer), Row_Pselect + i, 8);
								
								if (model2.getValueAt(Row_Pselect + i, 8) != null
										&& model2.getValueAt(Row_Pselect + i, 8).toString().length() != 0) {
									col8 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 8).toString());
								}
								if (model2.getValueAt(Row_Pselect + i, 9) != null
										&& model2.getValueAt(Row_Pselect + i, 9).toString().length() != 0) {
									col9 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 9).toString());
								}
								
							//System.out.println("totGrossRecFrmCurEmployer : "+ totGrossRecFrmCurEmployer);
								
								col10=col8+col9; // Added to handle condition of adding (59,60,61)
								model2.setValueAt(df.format(col10), Row_Pselect + i, 10);
							}
							else
							{
								model2.setValueAt(df.format(totalSalannex2), Row_Pselect + i, 10);

							}
							
							
							/****************** Added for 2.7 End  ********************/
							col10 = Double.parseDouble(model2.getValueAt(
									Row_Pselect + i, 10).toString());

							/*********************************************************/				
							//FRD 2.3 added 16(ia)	
							/*if (model2.getValueAt(Row_Pselect + i, 13) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 13))) {
								totalDed16i16II = Double.parseDouble(model2
										.getValueAt(Row_Pselect + i, 13)
										.toString());
							}*/

							if (model2.getValueAt(Row_Pselect + i, 11) != null && model2.getValueAt(Row_Pselect + i, 11).toString().length() != 0) {
								ded16IICol11 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 11).toString());
							}

							if (model2.getValueAt(Row_Pselect + i, 12) != null && model2.getValueAt(Row_Pselect + i, 12).toString().length() != 0) {
								ded16IIICol12 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 12).toString());
							}

							if (model2.getValueAt(Row_Pselect + i, 13) != null && model2.getValueAt(Row_Pselect + i, 13).toString().length() != 0) {
								ded16IACol13 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 13).toString());
							}
							
							/****************** Added for 2.7 End  ********************/
							if (model2.getValueAt(Row_Pselect + i, 68) != null && model2.getValueAt(Row_Pselect + i, 68).toString().length() != 0) {
								ded16IACol68 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 68).toString());
							}


							/*********************************************************/		
							

							totalDed16i16II = ded16IICol11 + ded16IIICol12 + ded16IACol13 + ded16IACol68;
							//System.out.println("addition of 11, 12 and 13 = "+totalDed16i16II);

							/*********************************************************/


							diff14 = col10 - totalDed16i16II;

							model2.setValueAt(df.format(diff14), Row_Pselect
									+ i, 14);

							// newly added on 03.03.2015
							if (model2.getValueAt(Row_Pselect + i, 15) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 15))) {
								//new development for FRD1.5 by akansha
								houspePropertycol15 = Double.parseDouble(GrpuUtil.validRupee(model2
										.getValueAt(Row_Pselect + i, 15)));
							}
							
							/****************** Added for 2.7 Start col16 Gross Total ********************/
							if (model2.getValueAt(Row_Pselect + i, 69) != null
									&& !"".equals(model2.getValueAt(Row_Pselect + i, 69))) {
								houspePropertycol15 = houspePropertycol15 + Double
										.parseDouble(GrpuUtil.validRupee(model2.getValueAt(Row_Pselect + i, 69)));
							}
							/****************** Added for 2.7 End ********************/

							//new development for FRD1.5 by akansha
							grosscol16 = houspePropertycol15
									+ Double.parseDouble(GrpuUtil.validRupee(model2.getValueAt(
											Row_Pselect + i, 14)));
							//System.out.println("I am in sixth and value is: "+houspePropertycol15+" "+ grosscol16+" "+model2.getValueAt(Row_Pselect + i, 14));
							model2.setValueAt(df.format(grosscol16),
									Row_Pselect + i, 16);

							//newly added for FRD1.6 by akansha
							if (model2.getValueAt(Row_Pselect + i, 55) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 55))) {
								amtcontriPI = Double.parseDouble(model2
										.getValueAt(Row_Pselect + i, 55)
										.toString());
							}


							//*********************************************

							//newly added for FRD1.6 by akansha
							grossTotalcolSA58 = grosscol16 + amtcontriPI;
							//System.out.println("Model value of col 51:"+model2.getValueAt(Row_Pselect + i, 51).toString() );
							if(model2.getValueAt(Row_Pselect + i, 51)!=null && !"".equals(model2.getValueAt(Row_Pselect + i, 51).toString())){
								if("Yes".equals(model2.getValueAt(Row_Pselect + i, 51).toString()))
									model2.setValueAt(df.format(grossTotalcolSA58),
											Row_Pselect + i, 58);
							}
							//***************************************************

							// setting 16-21
							if (model2.getValueAt(Row_Pselect + i, 21) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 21))) {
								col21 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 21).toString());
							}
							diff16_21 = Double.parseDouble(model2.getValueAt(
									Row_Pselect + i, 16).toString())
									- col21;

							model2.setValueAt(df.format(diff16_21), Row_Pselect
									+ i, 22);

							// end cholia
						}
						if (count1 > 0) {

							/*********************************************************/				
							//FRD 2.3 added 16(ia)
							double ded16IICol11 = 0;
							double ded16IIICol12 = 0;
							double ded16IACol13 = 0;
							
							/****************** Added for 2.7 Start ********************/
							double ded16IACol68 = 0;
							/****************** Added for 2.7 End*******************/
							
							double sumCol = 0;
							double col10 = 0;
							double diff14 = 0;
							double houspePropertycol15 = 0;
							double grosscol16 = 0;
							double col21 = 0;
							double diff16_21 = 0;

							//newly added for FRD1.6 by akansha
							double grossTotalcolSA58=0,grossTotalcol16=0;
							double amtcontriPI = 0;
							//*********************************

							/*********************************************************/				
							//FRD 2.3 added 16(ia)			
							//model2.setValueAt(df.format(totalDedSeccol13),Row_Pselect + i, 13);
							//col13 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 13).toString());

							if (model2.getValueAt(Row_Pselect + i, 11) != null && model2.getValueAt(Row_Pselect + i, 11).toString().length() != 0) {
								ded16IICol11 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 11).toString());
							}

							if (model2.getValueAt(Row_Pselect + i, 12) != null && model2.getValueAt(Row_Pselect + i, 12).toString().length() != 0) {
								ded16IIICol12 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 12).toString());
							}

							if (model2.getValueAt(Row_Pselect + i, 13) != null && model2.getValueAt(Row_Pselect + i, 13).toString().length() != 0) {
								ded16IACol13 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 13).toString());
							}
							
							if (model2.getValueAt(Row_Pselect + i, 68) != null && model2.getValueAt(Row_Pselect + i, 68).toString().length() != 0) {
								ded16IACol68 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 68).toString());
							}

							sumCol = ded16IICol11 + ded16IIICol12 + ded16IACol13 + ded16IACol68;

							/*********************************************************/	


							if (model2.getValueAt(Row_Pselect + i, 10) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 10))) {
								//new development for FRD1.5 by akansha
								col10 = Double.parseDouble(GrpuUtil.validRupee(model2.getValueAt(
										Row_Pselect + i, 10)));
							}
							diff14 = col10 - sumCol;

							model2.setValueAt(df.format(diff14), Row_Pselect
									+ i, 14);

							// newly added on 03.03.2015
							if (model2.getValueAt(Row_Pselect + i, 15) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 15))) {
								//new development for FRD1.5 by akansha
								houspePropertycol15 = Double.parseDouble(GrpuUtil.validRupee(model2
										.getValueAt(Row_Pselect + i, 15)));
							}

							grosscol16 = houspePropertycol15
									+ Double.parseDouble(model2.getValueAt(
											Row_Pselect + i, 14).toString());
							model2.setValueAt(df.format(grosscol16),
									Row_Pselect + i, 16);

							//newly added for FRD1.6 by akansha
							if (model2.getValueAt(Row_Pselect + i, 55) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 55))) {
								amtcontriPI = Double.parseDouble(model2
										.getValueAt(Row_Pselect + i, 55)
										.toString());
							}


							//*********************************************

							//newly added for FRD1.6 by akansha
							grossTotalcolSA58 = grosscol16 + amtcontriPI;

							if(model2.getValueAt(Row_Pselect + i, 51)!=null && !"".equals(model2.getValueAt(Row_Pselect + i, 51).toString())){
								if("Yes".equals(model2.getValueAt(Row_Pselect + i, 51).toString()))
									model2.setValueAt(df.format(grossTotalcolSA58),
											Row_Pselect + i, 58);
							}
							//***************************************************


							//System.out.println("I am in sixth and value is: "+houspePropertycol15+" "+ grosscol16+" "+model2.getValueAt(Row_Pselect + i, 14));

							//
							// setting 16-21
							if (model2.getValueAt(Row_Pselect + i, 21) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 21))) {
								col21 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 21).toString());
							}
							diff16_21 = Double.parseDouble(model2.getValueAt(
									Row_Pselect + i, 16).toString())
									- col21;
							model2.setValueAt(df.format(diff16_21), Row_Pselect
									+ i, 22);

							// end cholia

						}

						
						if (count2 > 0) {
							double col21 = 0;
							double diff16_21 = 0;
							double col14=0;
							double col15=0;
							double col16=0;
							/****************** Added for 2.7 Start col16 Gross Total ********************/
							double col69 = 0;
							/****************** Added for 2.7 End ********************/
							//newly commented for FRD1.6 by akansha
							//							model2.setValueAt(df.format(incmChargbleHeadSal),
							//									Row_Pselect + i, 16);

							//newly added for FRD1.6 by akansha
							if (model2.getValueAt(Row_Pselect + i, 14) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 14))) {
								col14 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 14).toString());
							}
							if (model2.getValueAt(Row_Pselect + i, 15) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 15))) {
								col15 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 15).toString());
							}
							
							/****************** Added for 2.7 Start col16 Gross Total ********************/
							if (model2.getValueAt(Row_Pselect + i, 69) != null
									&& !"".equals(model2.getValueAt(Row_Pselect + i, 69))) {
								col69 = Double.parseDouble(model2.getValueAt(Row_Pselect + i, 69).toString());
							}
						

							col16=col14+col15+col69;
							
							/****************** Added for 2.7 End ********************/

							model2.setValueAt(df.format(col16),
									Row_Pselect + i, 16);

							//******************************************
							// setting 16-21
							if (model2.getValueAt(Row_Pselect + i, 21) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 21))) {
								col21 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 21).toString());
							}
							diff16_21 = Double.parseDouble(model2.getValueAt(
									Row_Pselect + i, 16).toString())
									- col21;
							model2.setValueAt(df.format(diff16_21), Row_Pselect
									+ i, 22);

							// end cholia

						}

						if (count3 > 0) {
							double grossTotalcol16 = 0;
							double taxableIncome = 0;


							model2.setValueAt(df.format(chalVIAcol21),
									Row_Pselect + i, 21);

							if (model2.getValueAt(Row_Pselect + i, 16) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 16))) {
								grossTotalcol16 = Double.parseDouble(model2
										.getValueAt(Row_Pselect + i, 16)
										.toString());
							}



							taxableIncome = grossTotalcol16
									- Double.parseDouble(model2.getValueAt(
											Row_Pselect + i, 21).toString());
							model2.setValueAt(df.format(taxableIncome),
									Row_Pselect + i, 22);

						}

						// end newly added by cholia on 2.03.2015
						// for 23+24+25+-(90+26)
						if (count4 > 0) {
							double taxRelief = 0;
							double col27 = 0;
							double shortfall = 0;
							double col30 = 0;
							if (model2.getValueAt(Row_Pselect + i, 26) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 26))) {
								//new development for FRD1.5 by akansha
								taxRelief = Double.parseDouble(GrpuUtil.validRupee(model2
										.getValueAt(Row_Pselect + i, 26)));
							}
							
							/****************** Added for 2.7 Start ********************/
							//RPU 2.9 start
							if (model2.getValueAt(Row_Pselect + i, 90) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 90))) {
								taxRelief = taxRelief + Double.parseDouble(GrpuUtil.validRupee(model2
										.getValueAt(Row_Pselect + i, 90)));
							}
							if (model2.getValueAt(Row_Pselect + i, 93) != null     //RPU 3.7 Addition of new column rahul
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 93))) {
								//col93 = Double.parseDouble(model2.getValueAt(
									//	Row_Pselect + i, 93).toString());
						}
						
							//RPU 2.9 end
							/****************** Added for 2.7 End  ********************/

							col27 = nettaxpayble - taxRelief;

							model2.setValueAt(df.format(col27),
									Row_Pselect + i, 27);

							if (model2.getValueAt(Row_Pselect + i, 30) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 30))) {
								col30 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 30).toString());
							}

							shortfall = Double.parseDouble(model2.getValueAt(
									Row_Pselect + i, 27).toString())
									- col30;

							model2.setValueAt(df.format(shortfall), Row_Pselect
									+ i, 31);

						}
						// end for 23+24+25+-(26+90)
						// start 28+29
						if (count5 > 0) {
							double col27 = 0;
							double col28=0,col29=0,col57=0;
							double col30=0;
							double shortfall = 0;
							//newly commented for FRD1.6 by akansha
							//							model2.setValueAt(df.format(totalTaxSource),
							//									Row_Pselect + i, 30);
							//newly added for FRD1.6 by akansha
							if (model2.getValueAt(Row_Pselect + i, 28) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 28))) {
								col28 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 28).toString());
							}
							if (model2.getValueAt(Row_Pselect + i, 29) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 29))) {
								col29 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 29).toString());
							}

							if (model2.getValueAt(Row_Pselect + i, 57) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 57))) {
								col57 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 57).toString());
							}

							col30 = col28+col29+col57;
							model2.setValueAt(df.format(col30),
									Row_Pselect + i, 30);

							//**********************************************
							if (model2.getValueAt(Row_Pselect + i, 27) != null
									&& !"".equals(model2.getValueAt(Row_Pselect
											+ i, 27))) {
								col27 = Double.parseDouble(model2.getValueAt(
										Row_Pselect + i, 27).toString());
							}

							shortfall = col27
									- Double.parseDouble(model2.getValueAt(
											Row_Pselect + i, 30).toString());

							model2.setValueAt(df.format(shortfall), Row_Pselect
									+ i, 31);
						}
						//newly added for FRD1.6 by akansha
						//start for 58=16+55
						if(count6 > 0){
							double col16=0;
							double col55=0;
							double col58=0;
							if("Yes".equals(model2.getValueAt(Row_Pselect + i, 51))){
								if (model2.getValueAt(Row_Pselect + i, 16) != null
										&& !"".equals(model2.getValueAt(Row_Pselect
												+ i, 16))) {
									col16 = Double.parseDouble(model2.getValueAt(
											Row_Pselect + i, 16).toString());
								}
								if (model2.getValueAt(Row_Pselect + i, 55) != null
										&& !"".equals(model2.getValueAt(Row_Pselect
												+ i, 55))) {
									col55 = Double.parseDouble(model2.getValueAt(
											Row_Pselect + i, 55).toString());
								}
								col58 = col16 + col55;
								model2.setValueAt(df.format(col58), Row_Pselect
										+ i, 58);

							}
						}
						//*******************************************

					}
					
					/******************  Copy Paste Logic End For Annexure 2 *************************/
				}

			}

		} catch (ArrayIndexOutOfBoundsException e) {
			e.printStackTrace();
		} catch (OutOfMemoryError e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		//new development for FRD1.5 by akansha
		finally{
			if(flagging==false)
				JOptionPane.showMessageDialog(null,"Invalid date, please insert date in DD/MM/YYYY");
			flagging = true;
			if(flaggingAnne==false)
				JOptionPane.showMessageDialog(null,"Invalid date, please insert date in DD/MM/YYYY");
			flaggingAnne = true;
			if(panAnne == false)
				JOptionPane.showMessageDialog(null,"<html>PAN value inserted contains additional spaces or special characters.<br>"
						+ " Kindly input valid 10 digits PAN.</html>");
			panAnne = true;

			/*********************************************************/				
			//FRD 2.3 added 16(ia), flag for copy paste for column 16 IA	
			if(flaggingCol16IA==false)
				JOptionPane.showMessageDialog(null,"This Field is applicable from F.Y. 2013-14 onwards.");
			flaggingCol16IA = true;
			/*********************************************************/	
		}
		//*****************************************
	}

	// Added By cholia for paste from excel for annexure 1

	public void pasteXLAnnex1(int Col_Pselect, int Row_Pselect, Object element,
			String tabname, int i, int j, int selYear_anne2, int next_year_anne2) {

		// added by cholia here
		
		if (columnNumberEditableForcolour(Col_Pselect + j, tabname, Row_Pselect
				+ i, selYear_anne2, next_year_anne2, formNumber)
				|| columnNumberEditable(Col_Pselect + j, tabname, Row_Pselect
						+ i) || Col_Pselect + j == 10) // Col_Pselect + j==24 ||
			// Col_Pselect + j==15
			// newly removed by
			// cholia
		{

		} else {
			System.out.println("I AM IN pasteXLAnnex1 ELSE");
			if(Col_Pselect + j == 5){
				if(GrpuUtil.getDropDownSection(element.toString(),formNumber))
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}
			else if(Col_Pselect + j == 25){
			System.out.println("Remark field value of ann1:"+	element.toString());
				if(GrpuUtil.getDropDownRemarks(element.toString()))
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}else if(Col_Pselect + j == 28 && !"27EQ".equals(formNumber)){
				if("Yes".equals(element.toString())|| "No".equals(element.toString())||"--Select--".equals(element.toString()))//newly developed for FRD1.5 by akansha
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}
			else if(Col_Pselect + j == 29 && "27EQ".equals(formNumber)){
				if("Yes".equals(element.toString())|| "No".equals(element.toString())||"--Select--".equals(element.toString()))//newly developed for FRD1.5 by akansha
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}
			else if(Col_Pselect + j == 30 && !"27EQ".equals(formNumber)){
				if("A".equals(element.toString())|| "B".equals(element.toString())||"--Select--".equals(element.toString()))//newly developed for FRD1.5 by akansha
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}

			else if(Col_Pselect + j == 26 && !"24Q".equals(formNumber)){
				if("01".equals(element.toString())|| "02".equals(element.toString())||"--Select--".equals(element.toString()))//newly developed for FRD1.5 by akansha
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}else if(Col_Pselect + j == 26 && "24Q".equals(formNumber)){
				model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}else if(Col_Pselect + j == 34 &&  !"27EQ".equals(formNumber)){
				if("Yes".equals(element.toString())|| "No".equals(element.toString())||"--Select--".equals(element.toString()))//newly developed for FRD1.5 by akansha
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}else if(Col_Pselect + j==31 && !"27EQ".equals(formNumber)){ //RPU 3.5 to paste 32nd column
				if(GrpuUtil.getDropDownRemittance(element.toString()))
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}
			
			else if(Col_Pselect + j==31 && "27EQ".equals(formNumber)){
				if("Yes".equals(element.toString())|| "No".equals(element.toString())||"--Select--".equals(element.toString()))//RPU 3.5 to paste 32 column
					{
					System.out.println("32nd column" + model1.getValueAt(Row_Pselect + i, Col_Pselect + 1 + j)  +"row " +Row_Pselect + i + "Column "+Col_Pselect + 1 + j);
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
					}
			}
			else if(Col_Pselect + j==33 &&  !"27EQ".equals(formNumber)){
				if(GrpuUtil.getDropDownCountry(element.toString()))
					model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);
			}
		else if(Col_Pselect + j==33 && "27EQ".equals(formNumber)){
			if("F".equals(model1.getValueAt(Row_Pselect + i, 26)) || "G".equals(model1.getValueAt(Row_Pselect + i, 26)))
			if("Yes".equals(element.toString())|| "No".equals(element.toString())||"--Select--".equals(element.toString()))//RPU 3.5 to paste 34 column
				{
				System.out.println("33rd column" + model1.getValueAt(Row_Pselect + i, Col_Pselect + 1 + j)  +"row " +Row_Pselect + i + "COlumn "+Col_Pselect + 1 + j);
				model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);}
		}
		else if(Col_Pselect + j==34 && "27EQ".equals(formNumber)){
			if("Yes".equals(model1.getValueAt(Row_Pselect + i, 34)))//RPU 3.5 to paste 34 column
				{System.out.println("35th column" + model1.getValueAt(Row_Pselect + i, Col_Pselect + 1 + j)  +"row " +Row_Pselect + i + "COlumn "+Col_Pselect + 1 + j);
				model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);}
		}
		else if(Col_Pselect + j==35 && "27EQ".equals(formNumber)){
			if("Yes".equals(model1.getValueAt(Row_Pselect + i, 34)))//RPU 3.5 to paste 34 column
				{ System.out.println("36th column" + model1.getValueAt(Row_Pselect + i, Col_Pselect + 1 + j)  +"row " +Row_Pselect + i + "COlumn "+Col_Pselect + 1 + j);
				model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);}
		}
			//new development for FRD1.5 by Akansha
			else if((Col_Pselect + j == 16)
					|| (Col_Pselect + j == 17)
					|| (Col_Pselect + j == 18)
					|| (Col_Pselect + j == 19)
					|| (Col_Pselect + j == 22)
					|| (Col_Pselect + j == 27)){
				model1.setValueAt(
						GrpuUtil.validRupee(element),
						Row_Pselect + i,
						Col_Pselect + 1 + j);
				System.out.println("MODEL1 16,17,18 VALUE"+model1.getValueAt(Row_Pselect + i, 15)  + model1.getValueAt(Row_Pselect + i, 16) + model1.getValueAt(Row_Pselect + i, 17));
		
			}
			else if((Col_Pselect + j == 15)
					|| (Col_Pselect + j == 24)){
				if(GrpuUtil.verifyDate(element.toString())){

					//newly developed for FRD1.5 Ver1.5 by akansha
					if(element.toString().contains("-")){
						model1.setValueAt(
								element.toString().replace("-","/"),
								Row_Pselect + i, Col_Pselect
								+ 1 + j);
					}
					else

						model1.setValueAt(
								element.toString(),
								Row_Pselect + i, Col_Pselect
								+ 1 + j);
				}else{
					//System.out.println("Inside else");
					flaggingAnne = false;
					model1.setValueAt(
							"",
							Row_Pselect + i, Col_Pselect
							+ 1 + j);
				}
			}
			else if(Col_Pselect + j ==13 && !"24Q".equals(formNumber)){
				if(GrpuUtil.checkPan(element.toString())){
					panAnne = false;
					model1.setValueAt(
							"",
							Row_Pselect + i, Col_Pselect
							+ 1 + j);
					pointToCell_Annex1(Row_Pselect+i, Col_Pselect+j);
				}else{
					model1.setValueAt(
							(element.toString()),
							Row_Pselect + i,
							Col_Pselect + 1 + j);
					//newly added for FRD1.5 by akansha
					if('C'==((element.toString()).charAt(3))){
						model1.setValueAt(
								("01"),
								Row_Pselect + i,
								27);
					}else if(!('C'==((element.toString()).charAt(3)))){
						model1.setValueAt(
								("02"),
								Row_Pselect + i,
								27);
					}
					if("PANINVALID".equals(element.toString())||
							"PANAPPLIED".equals(element.toString())||
							"PANNOTAVBL".equals(element.toString())){
						model1.setValueAt(
								("--Select--"),
								Row_Pselect + i,
								27);
					}
					//**************************************
				}
			}
			//*****************************************************
			//rpu 3.1 start paste 26q
//			else if(Col_Pselect + j == 30 && "26Q".equals(formNumber)){
//				System.out.println("I AM IN ANNEX 1 ELSE DO I COME INSIDE 31st "+element.toString());
//				model1.setValueAt(element.toString(), Row_Pselect + i, 30);
//				
//			}
			else
			{
				System.out.println("I AM IN ANNEX 1 ELSE LAST column "+Col_Pselect + j+" FORM  "+formNumber);
				model1.setValueAt(element, Row_Pselect + i, Col_Pselect + 1 + j);

					}
		}

	}

	// cholia end
	private void item5_actionPerformed(ActionEvent e) {
		int Length = 0;
		if (selCol != 0 && selCol != 1) {
			String excel = getClipboard();
			char s = '\n';
			int v = excel.indexOf(s);
			Length = GrpuUtil.getLength_TDField(selCol);
			if (excel.length() <= Length) {
				model.setValueAt(excel, selRow, selCol);
			} else {
				model.setValueAt("", selRow, selCol);
				getMessage("Length of data being copied cannot be greater than "
						+ Length);
			}
		}
	}

	public void fileitemopen_actionPerformed(ActionEvent e) {
		String str = "";
		int caretCount = 0;
		int caretPos = 0;
		int nxtCaretPos = 0;
		int lastCaretPos = 0;
		String typOfHeader = "";
		try {
			if (jTableTransacDetails.isEditing()
					&& jTableTransacDetails.getEditingRow() >= 0)
				jTableTransacDetails.editCellAt(0, 0);
			File aPreFile = selFile;
			selFile = funOpenDialogBoxGRPU();
			if (selFile != null)
				if (!checkFileName(selFile.getName())){
					getMessage("Invalid File Name.\n  :  /  ?  >  <  *  \"  |  \\  ^ or Space, not allowed in File Name.");

				}else if (selFile.getAbsoluteFile().exists()&& selFile.getParentFile().exists()) {
					if (selFile.getAbsolutePath().endsWith("")) // .grpu
					{
						if (selFile.getAbsolutePath().endsWith(".tds"))
							method = "Import";
						else
							method = "Open";
						importedFileStatus = import_or_open_file(selFile,method,"");

						saveflg = true;
						saveaspath = String.valueOf(selFile);

					} else {
						getMessage("For OPENING a File , Please select a valid file");

					}
				} else {
					getMessage(selFile.getAbsolutePath() + ". File not found");

				}
		} catch (Exception e1) {
			e1.printStackTrace();
			getMessage("Exception occured : File could not be Opened");
		}
	}


	public boolean checkFileName(String nameOfTheFile) {
		for (int i = 0; i < nameOfTheFile.length(); i++)
			if (nameOfTheFile.charAt(i) == '/'
			|| nameOfTheFile.charAt(i) == ':'
			|| nameOfTheFile.charAt(i) == '*'
			|| nameOfTheFile.charAt(i) == '?'
			|| nameOfTheFile.charAt(i) == '"'
			|| nameOfTheFile.charAt(i) == '<'
			|| nameOfTheFile.charAt(i) == '>'
			|| nameOfTheFile.charAt(i) == '|'
			|| nameOfTheFile.charAt(i) == '\\'
			|| nameOfTheFile.charAt(i) == ' '
			// || nameOfTheFile.charAt(i) == '_' // by Akansha
			|| nameOfTheFile.charAt(i) == '^')
				return false;

		return true;
	}


	// Added by Akansha
	private void fileitemprint_actionPerformed1(ActionEvent e) {
		PrinterJob job = PrinterJob.getPrinterJob(); // Get the printer's job
		// list

		job.setPrintable(this); // We print with this class (btnPrintAction,
		// which implements Printable)

		if (job.printDialog() == true) { // If we clicked OK in the print dialog

			try {
				job.print();
			} catch (PrinterException ex) {

				// It did not work (PrinterException thrown), so add any error
				// handling routines.

			}

		}

	}

	// **************************************************************

	//new development for FRD1.5 by akansha
	private void fileitemprint_actionPerformed(ActionEvent e) {

		PrinterJob job = PrinterJob.getPrinterJob(); // Get the
		// printer's job
		// list

		job.setPrintable(this); // We print with this class
		// (btnPrintAction, which implements
		// Printable)

		if (job.printDialog() == true) { // If we clicked OK in the
			// print dialog

			try {
				job.print();
			} catch (PrinterException ex) {

				// It did not work (PrinterException thrown), so add any
				// error handling routines.

			}

		}

	}


	public int print(Graphics gx, PageFormat pf, int page) throws PrinterException {

		if (page > 0) {
			return NO_SUCH_PAGE;
		} // Only one page

		Graphics2D g = (Graphics2D) gx; // Cast to Graphics2D object

		g.translate(pf.getImageableX(), pf.getImageableY()); // Match
		// origins
		// to
		// imageable
		//PRINT IN PINK									// area
		String temp="";
		String details ="";
		//for challan
		details = model.getDataVector().toString();


		g.drawString(details, 100, 100);		

		return PAGE_EXISTS; // Page exists (offsets start at zero!)

	}
	//**************************************************************

	private void TabGRPU_stateChanged(ChangeEvent e, String ab)  {
		
		/******************  Method called for re-intializing the Form using Back button start *************************/
		
		System.out.println("Re-Initializing");
		int DDOCount = 0;
		Object o = jComboBox_TypOfStmt.getSelectedItem();

		//		System.out.println(" type of statmnt"
		//				+ jComboBox_TypOfStmt.getSelectedItem());
		selTAB = TabGRPU.getSelectedIndex();
		int filledRws = actualRowsFilled(GrpuUtil.getFilledRows(model));
		jText_CntofDDOTransnDtls.setText(Integer.toString(numberOfTd));
		if (selTAB == BATCH_TAB_INDEX) {

			//	System.out.println("inside BATCH_TAB_INDEX" + selTAB);
			setBackground(Color.white);
			selColFocus = jTableTransacDetails.getSelectedColumn();
			selRowFocus = jTableTransacDetails.getSelectedRow();
			// newly added by cholia

			enableDisableBottomButton();

			// end newly added by cholia
			// Added by Akansha
			jButton_addRow.setVisible(false);
			jButton_delRow.setVisible(false);
			jButton_sveFile.setVisible(true);
			jButton_crtFile.setVisible(true);
			if (!"Correction".equals(valueOfTypeOfStmt))
				jButton_opnFile.setVisible(true);
			jLabel_Mandatory.setVisible(true);
			jButton_insertRow.setVisible(false); // added by
			jButton_back.setVisible(true); // added by Akansha
			// **************************************
			editmenu.getMenuComponent(0).setEnabled(true);
			editmenu.getMenuComponent(2).setEnabled(true);
			editmenu.getMenuComponent(4).setEnabled(true);
			editmenu.getMenuComponent(6).setEnabled(false);
			editmenu.getMenuComponent(8).setEnabled(false);
			editmenu.getMenuComponent(10).setEnabled(false);
			editmenu.getMenuComponent(12).setEnabled(false);
			//jButton_checkTDS_TCS_rate.setVisible(false);       //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9
		}
		if (selTAB == DDO_TAB_INDEX) {

			if (selColFocus > 0 && selRowFocus >= 0)
				jTableTransacDetails.getComponentAt(selRowFocus, selColFocus)
				.requestFocus();
			setBackground(Color.white);
			//System.out.println("insdie challan 2 enableDisableBottomButton ");
			enableDisableBottomButton();
			editmenu.getMenuComponent(6).setEnabled(true);
			editmenu.getMenuComponent(8).setEnabled(true);
			editmenu.getMenuComponent(10).setEnabled(true);
			editmenu.getMenuComponent(12).setEnabled(true);
			jLabel_Mandatory.setVisible(false); //added by Sadhana, FRD 2.0
			jButton_back.setVisible(false); // added by Akansha
			jButton_opnFile.setVisible(false);// added by Akansha
			jButton_crtFile.setVisible(true);
			jButton_sveFile.setVisible(true);
			//	jButton_checkTDS_TCS_rate.setVisible(false);      //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9
		}
		if (selTAB == ANNE_TAB_INDEX) {

			System.out.println("inside ANNE_TAB_INDEX" + selTAB);
			if (selColFocus > 0 && selRowFocus >= 0)
				jTableTransacDetails.getComponentAt(selRowFocus, selColFocus)
				.requestFocus();
			setBackground(Color.white);
			enableDisableBottomButton(); // amit idhar
			editmenu.getMenuComponent(6).setEnabled(true);
			editmenu.getMenuComponent(8).setEnabled(true);
			editmenu.getMenuComponent(10).setEnabled(true);
			editmenu.getMenuComponent(12).setEnabled(true);
			jLabel_Mandatory.setVisible(false); //added by Sadhana, FRD 2.0
			jButton_back.setVisible(false); // added by Akansha
			jButton_opnFile.setVisible(false);// added by Akansha
			jButton_crtFile.setVisible(true);
			jButton_sveFile.setVisible(true);

			//jButton_checkTDS_TCS_rate.setVisible(true);        //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9
		}

		if("24Q".equals(grpu.formNumber) && grpu.jComboBox_Quarter.getSelectedItem().equals("Q4") ){
			OTHER_SERVICES_TAB_INDEX = 4;
		}else{
			OTHER_SERVICES_TAB_INDEX = 3;
		}

		if (selTAB == ANNE2_TAB_INDEX) {
			//System.out.println("inside ANNE2_TAB_INDEX" + selTAB);

			if (selColFocus > 0 && selRowFocus >= 0)
				jTableTransacDetails.getComponentAt(selRowFocus, selColFocus)
				.requestFocus();
			setBackground(Color.white);
			enableDisableBottomButton();
			editmenu.getMenuComponent(6).setEnabled(true);
			editmenu.getMenuComponent(8).setEnabled(true);
			editmenu.getMenuComponent(10).setEnabled(true);
			editmenu.getMenuComponent(12).setEnabled(true);
			jLabel_Mandatory.setVisible(false); //added by Sadhana, FRD 2.0
			jButton_back.setVisible(false); // added by Akansha
			jButton_opnFile.setVisible(false);// added by Akansha
			jButton_crtFile.setVisible(true);
			jButton_sveFile.setVisible(true);
			//	jButton_checkTDS_TCS_rate.setVisible(false);        //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9
		}
		if (selTAB == OTHER_SERVICES_TAB_INDEX) {
			grpu.setBackground(Color.white);
			enableDisableBottomButton();
			jLabel_Mandatory.setVisible(false); //added by Sadhana, FRD 2.0
			jButton_delRow.setVisible(false);
			jButton_opnFile.setVisible(false);
			jButton_insertRow.setVisible(false);
			jButton_back.setVisible(false);
			jButton_addRow.setVisible(false);
			jButton_crtFile.setVisible(false);
			jButton_sveFile.setVisible(false);
		}/*else{
			grpu.jLabel_Mandatory.setVisible(true);
		}*/

		if (o.toString().equals("Regular") || o.toString().equals("Correction")) {
			// Added By for the challan to check if the financial year
			// has been seleted or not
			if (TabGRPU.getSelectedIndex() == DDO_TAB_INDEX) {
				DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
				DecimalFormat df = new DecimalFormat("0.00",sf);
				df.setMaximumFractionDigits(2);
				if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0
						&& jComboBox_Quarter.getSelectedIndex() != 0) {
					// colSectionCode =
					// jTableTransacDetails.getColumnModel().getColumn(1); //
					// chnaged

					// lost focus case
					jTableTransacDetails.putClientProperty(
							"terminateEditOnFocusLost", Boolean.TRUE);

					// lost focus end

					final int selYear_anne2 = Integer
							.parseInt(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4));
					final int next_year_anne2 = Integer
							.parseInt(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(5, 9));

					// added to change the colour of the column n the basis of
					// the financial year
					if (selYear_anne2 >= 2013) {
						int i = 2;
						for (i = 2; i < model.getRowCount(); i++)
							model.setValueAt("", i, 11);
					}

					// disabling the MinorHeadOfchallan for Fy<2013-2014
					if (selYear_anne2 < 2013) {
						int i = 2;
						for (i = 2; i < model.getRowCount(); i++)
							model.setValueAt("--Select--", i, 21);
					}
					// end
					// for challan section code
					if (selYear_anne2 >= 2013) {
						int i = 2;
						for (i = 2; i < model.getRowCount(); i++)
							model.setValueAt("--Select--", i, 2);
					}

					//newly added for FRD1.5 Ver1.5 by akansha
					//temp comment
					if(selYear_anne2<=2012){
						if ("Correction".equals(valueOfTypeOfStmt)) {
							if ("Central Government"
									.equals(JComboBox_Form_Sub1_Type_of_Deductor
											.getSelectedItem().toString())
											|| "State Government"
											.equals(JComboBox_Form_Sub1_Type_of_Deductor
													.getSelectedItem()
													.toString())) {
								int i = 2;
								for (i = 2; i < model.getRowCount(); i++)
									if("ADD".equals(model.getValueAt(i, 1))){
										if(model.getValueAt(i, 10)!=null && !"".equals(model.getValueAt(i, 10).toString())
												&& Integer.parseInt(model.getValueAt(i, 10).toString().substring(0,
														model.getValueAt(i, 10).toString().length()-3))>1)
											model.setValueAt("Yes", i, 18);
									}
							}
						}
					}
					//********************************************

					// Added on 12/03/2015 for clearing fee
					double tdsdbl = 0, surdbl = 0, edudbl = 0, intrstdbl = 0, otherdbl = 0;
					double totalamt = 0;
					if (selYear_anne2 < 2012) {
						int i = 2;
						// commented by cholia akansha code on 13 march2015
						for (i = 2; i < model.getRowCount(); i++) {
							model.setValueAt("", i, 7);
							Object tds = model.getValueAt(i, 3);
							Object surcharge = model.getValueAt(i, 4);
							Object educess = model.getValueAt(i, 5);
							Object intrst = model.getValueAt(i, 6);
							Object others = model.getValueAt(i, 8);

							if (tds != null && !"".equals(tds))
								tdsdbl = Double.parseDouble(tds.toString());
							else
								tdsdbl = 0;
							if (surcharge != null && !"".equals(surcharge))
								surdbl = Double.parseDouble(surcharge
										.toString());
							else
								surdbl = 0;
							if (educess != null && !"".equals(educess))
								edudbl = Double.parseDouble(educess.toString());
							else
								edudbl = 0;
							if (intrst != null && !"".equals(intrst))
								intrstdbl = Double.parseDouble(intrst
										.toString());
							else
								intrstdbl = 0;
							if (others != null && !"".equals(others))
								otherdbl = Double
								.parseDouble(others.toString());
							else
								otherdbl = 0;

							totalamt = tdsdbl + surdbl + edudbl + intrstdbl
									+ otherdbl;
							model.setValueAt(df.format(totalamt), i, 10);

						}

					}

					jTableTransacDetails
					.getColumnModel()
					.getColumn(1)
					.setCellRenderer(
							new GRPUTableCellRendererForColour(
									"Challan", selYear_anne2,
									next_year_anne2, formNumber, false,
									"",true));
					jTableTransacDetails
					.getColumnModel()
					.getColumn(0)
					.setCellRenderer(
							new GRPUTableCellRendererForColour(
									"Challan", selYear_anne2,
									next_year_anne2, formNumber, false,
									challantype,false));

					// changing the colour of the Fee field on the basis of the
					// If F.Y. 2012-13 onwards is enabled
					jTableTransacDetails
					.getColumnModel()
					.getColumn(6)
					.setCellRenderer(
							new GRPUTableCellRendererForColour(
									"Challan", selYear_anne2,
									next_year_anne2, formNumber, true,
									"",false));

					// Fee End

					// Last Total Tax Deposited //## Newly developed for
					// correction for Ver1.2 by Akansha
					jTableTransacDetails
					.getColumnModel()
					.getColumn(8)
					.setCellRenderer(
							new GRPUTableCellRendererForColour(
									"Challan", selYear_anne2,
									next_year_anne2, formNumber, true,
									"",false));

					// **************************************

					// Challan Balance //## Newly developed for correction for
					// Ver1.2 by Akansha
					jTableTransacDetails
					.getColumnModel()
					.getColumn(21)
					.setCellRenderer(
							new GRPUTableCellRendererForColour(
									"Challan", selYear_anne2,
									next_year_anne2, formNumber, true,
									"",false));

					// **************************************

					// added by cholia for minor head cha;;an
					jTableTransacDetails
					.getColumnModel()
					.getColumn(20)
					.setCellRenderer(
							new GRPUTableCellRendererForColour(
									"Challan", selYear_anne2,
									next_year_anne2, formNumber, false,
									"",false));

					// end cholia

					// changing the colour of the cheque DDNo on the basis of
					// the If F.Y
					jTableTransacDetails
					.getColumnModel()
					.getColumn(10)
					.setCellRenderer(
							new GRPUTableCellRendererForColour(
									"Challan", selYear_anne2,
									next_year_anne2, formNumber, false,
									"",false));


					colupdateModeChallan = jTableTransacDetails
							.getColumnModel().getColumn(0); // chnaged by for
					// the fixed column
					JComboBox comboBox1 = new JComboBox(jComboBox_Update_Mode);
					final MyComboBoxEditor updateModeChallan = new MyComboBoxEditor(
							jComboBox_Update_Mode);

					updateModeChallan.getComponent().setBackground(Color.white);
					// final MyComboBoxEditor updateModeChallan=new
					// MyComboBoxEditor(comboBox1);

					// Drop Down For minorHeadChallan
					colMinorHeadChallan = jTableTransacDetails.getColumnModel()
							.getColumn(20);
					final MyComboBoxEditor minorHeadChallan = new MyComboBoxEditor(
							jComboBox_Minor_Head_Challan);
					minorHeadChallan.getComponent().setBackground(Color.white);

					// amit end

					// amit here

					//	colBookEntry.setCellEditor(bookEntryDropDown);
					colupdateModeChallan.setCellEditor(updateModeChallan);
					colMinorHeadChallan.setCellEditor(minorHeadChallan);


					// Added By for minorHeadChallan
					((JComboBox) minorHeadChallan.getComponent())
					.addAncestorListener(new AncestorListener() {

						public void ancestorAdded(AncestorEvent event) {
							// make sure combobox handles key events
							((JComboBox) minorHeadChallan
									.getComponent())
									.requestFocusInWindow();

						}

						public void ancestorMoved(AncestorEvent event) {

						}

						public void ancestorRemoved(AncestorEvent event) {

						}

					});

				}
				// end for the challan
				else {
					//New dev ver1.3 added by Akansha
					if("--Select--".equals(jComboBox_Quarter.getSelectedItem().toString()) && "--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem()))
						getMessage("Please Select Financial Year & Quarter");
					else if("--Select--".equals(jComboBox_Quarter.getSelectedItem().toString()) && !"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem()))
						getMessage("Please select quarter");
					TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
					jComboBox_FinYear1.requestFocus();

				}

			}
			// Added by for annexure1
			if (TabGRPU.getSelectedIndex() == ANNE_TAB_INDEX) // yahan faizan
			{

				// lost focus code
				jTableTransacDetails1.putClientProperty(
						"terminateEditOnFocusLost", Boolean.TRUE);
				boolean rows_able;

				if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0
						&& jComboBox_Quarter.getSelectedIndex() != 0) {
					final int selYear_anne2 = Integer
							.parseInt(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4));
					final int next_year_anne2 = Integer
							.parseInt(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(5, 9));

					if (chalnn_getRowCnt > 0) {
						
						// initializeAnneTab(formNumber);
						addBlankRows1(GRPUConstants.DEFAULT_ROWS_COUNT, 0,
								false, false);

						// newly added by cholia3 for the remarks column of the
						// annexure1

						if (selYear_anne2 >= 2013) // for annexure 1 only
						{
							
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(25)
							.setCellEditor(
									new GRPUTableCellEditorAnnex1Remarks_annex_new(
											SecUnderPayMadeDed,
											jTableTransacDetails1
											.getSelectedRow(),
											selYear_anne2,
											next_year_anne2, formNumber ,jComboBox_Quarter  //RPU 3.1 start //added parameter quarter
											.getSelectedItem()
											.toString()));
						
						
							
							if (formNumber.equals("26Q") && jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019) {
								// for last column amount of cash withdrawal as in section 194N
					
								jTableTransacDetails1
								.getColumnModel()
								.getColumn(30)
								.setCellRenderer(
										new GRPUTableCellRendererForColour(
												"Anne1", selYear_anne2,
												next_year_anne2,
												formNumber, false, "",false));
//trial instead of true false
							}
							//RPU 3.4 Trial
							if (formNumber.equals("26Q") && jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020) {				
								jTableTransacDetails1
								.getColumnModel()
								.getColumn(31)
								.setCellRenderer(
										new GRPUTableCellRendererForColour(
												"Anne1", selYear_anne2,
												next_year_anne2,
												formNumber, false, "",false));
								jTableTransacDetails1
								.getColumnModel()
								.getColumn(32)
								.setCellRenderer(
										new GRPUTableCellRendererForColour(
												"Anne1", selYear_anne2,
												next_year_anne2,
												formNumber, false, "",false));
							}
							
						//RPU 3.5 tab state change
						
							if (formNumber.equals("27EQ") && ((selYear_anne2 == 2020 &&
							(jComboBox_Quarter.getSelectedItem().equals("Q1") || jComboBox_Quarter.getSelectedItem().equals("Q2")))
									|| (selYear_anne2 < 2020))) 
									{
									System.out.println("Inside 27eq form number" + formNumber);
									jTableTransacDetails1
									.getColumnModel()
									.getColumn(33)
									.setCellRenderer(
											new GRPUTableCellRendererForColour(
													"Anne1", selYear_anne2,
													next_year_anne2,
													formNumber, false, "",false));
									jTableTransacDetails1
									.getColumnModel()
									.getColumn(34)
									.setCellRenderer(
											new GRPUTableCellRendererForColour(
													"Anne1", selYear_anne2,
													next_year_anne2,
													formNumber, false, "",false));
									
									jTableTransacDetails1
									.getColumnModel()
									.getColumn(35)
									.setCellRenderer(
											new GRPUTableCellRendererForColour(
													"Anne1", selYear_anne2,
													next_year_anne2,
													formNumber, false, "",false));
									
									
									}
		

						} else if (selYear_anne2 < 2013) // for challan section
							// code
						{

							jTableTransacDetails1
							.getColumnModel()
							.getColumn(25)
							.setCellEditor(
									new GRPUTableCellEditorAnnex1Remarks_challan_new(
											SecUnderPayMadeDed,
											jTableTransacDetails1
											.getSelectedRow(),
											selYear_anne2,
											next_year_anne2,
											formNumber, model,
											jComboBox_Quarter
											.getSelectedItem()
											.toString()));
						
							
						}

						jTableTransacDetails1
						.getColumnModel()
						.getColumn(0)
						.setCellRenderer(
								new GRPUTableCellRendererForColour(
										"Anne1", selYear_anne2,
										next_year_anne2, formNumber,
										false, "",true));
						jTableTransacDetails1
						.getColumnModel()
						.getColumn(13)
						.setCellRenderer(
								new GRPUTableCellRendererForColour(
										"Anne1", selYear_anne2,
										next_year_anne2, formNumber,
										false, pancheckfag,false));

						if (formNumber.equals("24Q")) {
							// /for certificate number of annex1
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(26)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

						}
						

						if (formNumber.equals("26Q")
								|| formNumber.equals("27Q")) {

							jTableTransacDetails1
							.getColumnModel()
							.getColumn(28)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

							jTableTransacDetails1
							.getColumnModel()
							.getColumn(29)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

						}
						//rpu 3.1 start to grey first two rows of amount of cash withdrwal in sec 194N
						if (formNumber.equals("26Q")) {
							// for last column amount of cash withdrawal as in section 194N
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(30)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));
							//RPU 3.4 start to grey first two rows of amount of cash withdrwal
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(31)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(32)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

						}
						if (formNumber.equals("27Q")) {
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(31)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

							// newly added by cholia for wheter tds rate
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(30)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

							// end
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(33)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

							// newly added by cholia for unique ackinowledge
							// number

							jTableTransacDetails1
							.getColumnModel()
							.getColumn(32)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

							// end newly added by cholia for unique ackinowledge
							// number

							//newly added for FRD1.7 by akansha

							jTableTransacDetails1.getColumnModel().getColumn(35)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, false, "", false));


							jTableTransacDetails1.getColumnModel().getColumn(36)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, true, "", false));


							jTableTransacDetails1.getColumnModel().getColumn(37)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, false, "", false));


							jTableTransacDetails1.getColumnModel().getColumn(38)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, true, "", false));
							//*************************************************	
							//rpu 3.1 start to grey colum amount of cash withdrawal in section 194
							jTableTransacDetails1.getColumnModel().getColumn(39)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, false, "", false));
							//RPU 3.4 start to grey colum amount of cash withdrawal
							jTableTransacDetails1.getColumnModel().getColumn(40)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, false, "", false));
							jTableTransacDetails1.getColumnModel().getColumn(41)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, false, "", false));
						
						}

						if (formNumber.equals("27EQ")) {
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(29)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));

							// newly added by cholia
							jTableTransacDetails1
							.getColumnModel()
							.getColumn(30)
							.setCellRenderer(
									new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,
											next_year_anne2,
											formNumber, false, "",false));
							 //begin from here //RPU 3.5
							jTableTransacDetails1.getColumnModel().getColumn(33)
							.setCellRenderer(new GRPUTableCellRendererForColour(
											"Anne1", selYear_anne2,next_year_anne2,
											formNumber, false, "",false));
							jTableTransacDetails1.getColumnModel().getColumn(34)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, false, "", false));
							jTableTransacDetails1.getColumnModel().getColumn(35)
							.setCellRenderer(new GRPUTableCellRendererForColour("Anne1", selYear_anne2, next_year_anne2,
									formNumber, false, "", false));
					
						}
						//

						// cholia for section codeannexure1 section code
						jTableTransacDetails1
						.getColumnModel()
						.getColumn(5)
						.setCellRenderer(
								new GRPUTableCellRendererForColour(
										"Anne1", selYear_anne2,
										next_year_anne2, formNumber,
										false, "",true));
						//new development for FRD1.5 by Akansha
						jTableTransacDetails1
						.getColumnModel()
						.getColumn(10)
						.setCellRenderer(
								new GRPUTableCellRendererForColour(
										"Anne1", selYear_anne2,
										next_year_anne2, formNumber,
										false, "",true));

						//******************************************
						if (selYear_anne2 < 2013) // clearing the section and
							// the certificate number
						{
							int i = 2;


							if (formNumber.equals("24Q")) {
								for (i = 2; i < model1.getRowCount(); i++) {
									model1.setValueAt("", i, 27); // claering
									// the
									// certificate
									// number

									if ("--Select--".equals(model.getValueAt(
											Integer.parseInt(model1.getValueAt(
													i, 1).toString()) + 1, 2)
													.toString()))
										model1.setValueAt("--Select--", i, 6);// ##
									// Newly
									// added
									// for
									// correction
									// Ver1.2
									// by
									// Akansha
									// Newly
									// added
									// by
									// Akansha
									// for
									// Ver1.1
									else {

										model1.setValueAt(
												model.getValueAt(
														Integer.parseInt(model1
																.getValueAt(i,
																		1)
																		.toString()) + 1,
																		2).toString(), i, 6);
									}

								}

							}

							else if (formNumber.equals("26Q")
									|| formNumber.equals("27Q")) {
								for (i = 2; i < model1.getRowCount(); i++) {
									model1.setValueAt("", i, 30); // claering
									// the
									// certificate
									// number
									if ("--Select--".equals(model.getValueAt(
											Integer.parseInt(model1.getValueAt(
													i, 1).toString()) + 1, 2)
													.toString()))
										model1.setValueAt("--Select--", i, 6);// ##
								
								}
								//rpu 3.1 starts to set value null if year selectd should have disabled colum(amount of cash withdrawal in sec 194N
								if (formNumber.equals("26Q")) {
									for (i = 2; i < model1.getRowCount(); i++) {
									model1.setValueAt("", i, 31);  //last row amount in sec 194N
									model1.setValueAt("", i, 32); //RPU 3.4 start
									model1.setValueAt("", i, 33);
									}
								}
								if (formNumber.equals("27Q")) {
									for (i = 2; i < model1.getRowCount(); i++) {

										//new development fo FRD1.3 by Akansha
										model1.setValueAt("--Select--", i, 31);
										//***************
										model1.setValueAt("--Select--", i, 32); // Added
										// by
										// Akansha
										model1.setValueAt("--Select--", i, 34); // newly
										// added
										// by
										// cholai
										// for
										// country
										// code
										model1.setValueAt("", i, 33); // Unique Ack
										// Number
										// Clearing remittance code for F.Y. before
										// 2013
										//trial
										System.out.println("set value here");
										model1.setValueAt("", i, 40);  //last row amount in sec 194N
										model1.setValueAt("", i, 41);  //RPU 3.4 to set value null when year<2013
										model1.setValueAt("", i, 42);
									}
								}
							} else {
								for (i = 2; i < model1.getRowCount(); i++) {
									model1.setValueAt("", i, 31); // clearing
									// the
									// certificate
									// number
									if ("--Select--".equals(model.getValueAt(
											Integer.parseInt(model1.getValueAt(
													i, 1).toString()) + 1, 2)
													.toString())) // ## Newly added for
										// correction Ver1.2
										// by Akansha
										model1.setValueAt("--Select--", i, 6); // ##
									// Newly
									// added
									// by
									// Akansha
									// for
									// Ver1.1

								}
							}


						}
					/**	 if (selYear_anne2 >2018) //RPU 3.4 Start to set blank values in case section not 4NF in correction
						{
							int i = 2;
							if(!("4NF".equals(model1.getValueAt(i, 6)) && selYear_anne2 >2019 ))
							{
								if (formNumber.equals("26Q")) {
								for (i = 2; i < model1.getRowCount(); i++) {
									System.out.println("set value here new else added");
									if ("--Select--".equals(model.getValueAt(
											Integer.parseInt(model1.getValueAt(
													i, 1).toString()) + 1, 2)
													.toString())) 
										model1.setValueAt("--Select--", i, 6);
								model1.setValueAt("", i, 32); //RPU 3.4 start
								model1.setValueAt("", i, 33);
								}
							}
							if (formNumber.equals("27Q")) {
								for (i = 2; i < model1.getRowCount(); i++) {
									System.out.println("set value here new else added");
									 
									model1.setValueAt("", i, 41);  //RPU 3.4 to set value null when year<2013
									model1.setValueAt("", i, 42);
								}
							}
							}
						 if (selYear_anne2 >= 2019 && next_year_anne2 >= 2020 && !"94N".equals(model1.getValueAt(i,6)) )
							{
							 if (formNumber.equals("26Q")) 
							 {
								 for (i = 2; i < model1.getRowCount(); i++) {
									 if ("--Select--".equals(model.getValueAt(
												Integer.parseInt(model1.getValueAt(
														i, 1).toString()) + 1, 2)
														.toString())) 
											model1.setValueAt("--Select--", i, 6);
									 model1.setValueAt("", i, 31);
									 }
								 }
							 if (formNumber.equals("27Q"))
							 {for (i = 2; i < model1.getRowCount(); i++) {
									model1.setValueAt("", i, 40);
									}
							 }
									
							}
							
						}  **/
						
						// added by cholia for remarks field

						if (o.toString().equals("Regular")) // newly added by
							// cholia for
							// remarks column
						{
							if (selYear_anne2 < 2013) {
								int i = 0;
								flag_annex = 0;

								if (flag_challan == 0) {
									for (i = 2; i < model1.getRowCount(); i++) {
										//new development for FRD1.5 by akansha
										//model1.setValueAt("--Select--", i, 26);

										//newly added by akansha for FRD1.6
										if(formNumber.equals("27Q") && selYear_anne2<2016){
											model1.setValueAt("",i,36);
											model1.setValueAt("",i,37);
											model1.setValueAt("",i,38);
											model1.setValueAt("",i,39);
										}
										//Trial //RPU 3.1 start
										if(formNumber.equals("27Q")){
											model1.setValueAt("",i,40);
											model1.setValueAt("",i,41);//RPU 3.4 start
											model1.setValueAt("",i,42);
										}
										if(formNumber.equals("26Q")){
											model1.setValueAt("",i,31);//RPU 3.4 start
											model1.setValueAt("",i,32);
											model1.setValueAt("",i,33);
										}
										//*************************************************************

										model1.setValueAt("--Select--", i, 6);
										if(formNumber.equals("27EQ"))
										{
											model1.setValueAt("--Select--", i, 30);
										}
									}
								}

								flag_challan++;

							}

							if (selYear_anne2 >= 2013) {
								int i = 0;
								flag_challan = 0;

								if (flag_annex == 0) {
									for (i = 2; i < model1.getRowCount(); i++) {
										//new development for FRD1.5 by akansha
										//newly developed for FRD1.5 Ver1.5 by akansha
										// model1.setValueAt("--Select--", i, 26);
										// model1.setValueAt("--Select--", i, 6);

										//newly added by akansha for FRD1.6
										if(formNumber.equals("27Q") && selYear_anne2<2016){
											model1.setValueAt("",i,36);
											model1.setValueAt("",i,37);
											model1.setValueAt("",i,38);
											model1.setValueAt("",i,39);
										}
										//trial for q1 //RPU 3.1
										if((formNumber.equals("27Q") && (selYear_anne2<2019||
												(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019)))){
											model1.setValueAt("",i,40);
										}
										//trial for q1 //RPU 3.1
										if((formNumber.equals("27Q") && (selYear_anne2<2020||
												(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020)))){
											model1.setValueAt("",i,41);
										}
										if((formNumber.equals("27Q") && (selYear_anne2<2020||
												(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020)))){
											model1.setValueAt("",i,42);
										}
										if(formNumber.equals("26Q") && (selYear_anne2<2019  ||
												(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019 ))){
											//System.out.println(formNumber + " quarter1 2019"+ model1.getValueAt(i, 31)+"model value at 31");
											model1.setValueAt("",i,31);
												}
										if(formNumber.equals("26Q") && (selYear_anne2<2020  ||
												(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020 ))){
											model1.setValueAt("",i,32);
												}
										if(formNumber.equals("26Q") && (selYear_anne2<2020 ||
												(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020 ))){
											model1.setValueAt("",i,33);
												}
										//*************************************************************
										if(formNumber.equals("27EQ"))
										{
											model1.setValueAt("--Select--", i, 30);
											if(selYear_anne2<2020 ||
												((jComboBox_Quarter.getSelectedItem().equals("Q1") || jComboBox_Quarter.getSelectedItem().equals("Q1"))
														&& selYear_anne2 == 2020 )) //RPU 3.5
											{
												model1.setValueAt("",i,34);
											}
											
										}
									
									}
								}

								flag_annex++;

							}
							int p = 0;
							// newly added by cholai on 10 march 2015
							if (selYear_anne2 >= 2013
									&& (formNumber.equals("27Q") || formNumber
											.equals("26Q"))) {
								for (p = 2; p < model1.getRowCount(); p++) {

									//newly added by akansha for FRD1.6
									if(formNumber.equals("27Q") && selYear_anne2<2016){
										model1.setValueAt("",p,36);
										model1.setValueAt("",p,37);
										model1.setValueAt("",p,38);
										model1.setValueAt("",p,39);
									}
									//trial
									if((formNumber.equals("27Q") && (selYear_anne2<2019 ||
											(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019))))
									{
										model1.setValueAt("",p,40);
									}
									//RPU 3.4
									if((formNumber.equals("27Q") && (selYear_anne2<2020 ||
											(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020))))
									{
										model1.setValueAt("",p,41);
									}
									if((formNumber.equals("27Q") && (selYear_anne2<2020 ||
											(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020))))
									{
										model1.setValueAt("",p,42);
									}
									if(formNumber.equals("26Q") && (selYear_anne2<2019  ||
											(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019 ))){
														model1.setValueAt("",p,31);
									}
									if(formNumber.equals("26Q") && (selYear_anne2<2020  ||
											(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020 ))){
														model1.setValueAt("",p,32);
									}
									if(formNumber.equals("26Q") && (selYear_anne2<2020  ||
											(jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020 ))){
														model1.setValueAt("",p,33);
									}
									//*************************************************************

									model1.setValueAt("--Select--", p, 29); // claering the paid by book entry
							

								}

								int k = 0;
								// newly added by cholai on 10 march 2015
								if (selYear_anne2 < 2013
										&& (formNumber.equals("27Q") || formNumber
												.equals("26Q"))) {
									for (k = 2; k < model1.getRowCount(); p++) {

										//newly added by akansha for FRD1.6
										if(formNumber.equals("27Q") && selYear_anne2<2016){
											model1.setValueAt("",k,36);
											model1.setValueAt("",k,37);
											model1.setValueAt("",k,38);
											model1.setValueAt("",k,39);
										}

										//*************************************************************

										model1.setValueAt("--Select--", p, 29); // claering
										// the
										// certificate
										// number
										//trial //RPU 3.4
										if(formNumber.equals("27Q")){
										model1.setValueAt("", p, 40); //last column amount of cash withdrawal in case of section 194N
										model1.setValueAt("", p, 41);
										model1.setValueAt("", p, 42);}
										if(formNumber.equals("26Q")){
											model1.setValueAt("",p,31); //last column amount of cash withdrawal in case of section 194N
											model1.setValueAt("",p,32);
											model1.setValueAt("",p,33);}
									}
								}

								// //newly added by cholai on 10 march 2015
								
							}
						}
						// end cholia for remarks field crtical

						// annexure1 section code

						// div yahn aur ho gya
						if (selYear_anne2 >= 2013 && next_year_anne2 >= 2014) {
							if (formNumber.equals("24Q"))
								if(selYear_anne2>=2021)//CR 80278 new section code 194P
									annex1Sectioncode = (new String[] {
											"--Select--", "92A", "92B", "92C" ,"94P"});
								else
								annex1Sectioncode = (new String[] {
										"--Select--", "92A", "92B", "92C" });
							else if (formNumber.equals("26Q")) {

								if (selYear_anne2 == 2013
										&& next_year_anne2 == 2014) {
									annex1Sectioncode = (new String[] {
											"--Select--", "193", "194", "94A",
											"94B", "4BB", "94C", "94D", "4EE",
											"94F", "94G", "94H", "94J", "94L",
											"4IA", "4IB","9IA" }); //newly added for FRD1.5 by akansha

								}

								else if (selYear_anne2 >= 2014) {
									if (jComboBox_Quarter.getSelectedItem() != null) {
										if ((jComboBox_Quarter
												.getSelectedItem().equals("Q3") || jComboBox_Quarter
												.getSelectedItem().equals("Q4"))
												&& selYear_anne2 == 2014) {
											annex1Sectioncode = (new String[] {
													"--Select--", "193", "194",
													"94A", "94B", "4BB", "94C",
													"94D", "4EE", "94F", "94G",
													"94H", "4IA", "4IB", "94J",
													"94L", "4BA", "4DA","9IA" }); // new development for FRD1.3 by Akansha
											//newly added for FRD1.5 by akansha
										} else if (selYear_anne2 > 2014) {
											if(selYear_anne2 >= 2016 && selYear_anne2 < 2017){
												//Added by Sadhana on 05/04/2017 for FRD2.0
												annex1Sectioncode = (new String[] {
														"--Select--", "193", "194",
														"94A", "94B", "4BB", "94C",
														"94D", "4EE", "94F", "94G",
														"94H", "4IA", "4IB", "94J",
														"94L", "4BA", "4DA", "2AA", 
														"LBB","9IA","LBC" });
											}else if(selYear_anne2 >= 2017 && selYear_anne2 < 2018){
												annex1Sectioncode = (new String[] {
														"--Select--", "193", "194", "194IC", 
														"94A", "94B", "4BB", "94C",
														"94D", "4EE", "94F", "94G",
														"94H", "4IA", "4IB", "94J",
														"94L", "4BA", "4DA", "2AA", // new development for FRD1.3 by Akansha
														"LBB","9IA","LBC" });
											}else if(selYear_anne2 == 2019){
												annex1Sectioncode = (new String[] {
														"--Select--", "193", "194", "194IC", "94N",
														"94A", "94B", "4BB", "94C",
														"94D", "4EE", "94F", "94G",
														"94H", "4IA", "4IB", "94J",
														"94L", "4BA", "4DA", "2AA", //Section Code changes for RPU 2.9
														"LBB","9IA","LBC" });
											}	
											else if(selYear_anne2 == 2020
													&& (jComboBox_Quarter.getSelectedItem().equals("Q1")))
													{//RPU 3.2 start addition of new section 94K for form 26Q
												annex1Sectioncode = (new String[] {
														"--Select--", "193", "194", "194IC", "94N",
														"94A", "94B", "4BB", "94C",
														"94D", "4EE", "94F", "94G",
														"94H", "4IA", "4IB", "4JA", "4JB" //RPU 3.3 start
														,"94K" ,"94L", "4DA",
														"2AA","LBB","9IA","LBC","BA1","BA2"});
													}
													else if(selYear_anne2 == 2020 && 
															(jComboBox_Quarter.getSelectedItem().equals("Q2"))){ //RPU 3.4 start Addition of new section codes
														annex1Sectioncode = (new String[] {
																"--Select--", "193", "194", "194IC", "94N",
																"94A", "94B", "4BB", "94C",
																"94D", "4EE", "94F", "94G",
																"94H", "4IA", "4IB", "4JA", "4JB" 
																,"94K" ,"94L", "4DA",
																"2AA","LBB","9IA","LBC","BA1","BA2","4NF"});
											}
													else if((selYear_anne2 == 2020 &&  //RPU 3.5 Addition of new section code form 26Q
															(jComboBox_Quarter.getSelectedItem().equals("Q3") ||jComboBox_Quarter.getSelectedItem().equals("Q4"))) || (selYear_anne2 ==2021 && jComboBox_Quarter.getSelectedItem().equals("Q1")))
													{
														annex1Sectioncode = (new String[] {
																"--Select--", "193", "194", "194IC", "94N",
																"94A", "94B", "4BB", "94C",
																"94D", "4EE", "94F", "94G",
																"94H", "4IA", "4IB", "4JA", "4JB" 
																,"94K" ,"94L","94O" ,"4DA",
																"2AA","LBB","9IA","LBC","BA1","BA2","4NF"});
													}
													else if((selYear_anne2 == 2021 &&  //RPU 3.7 CR 81169 Addition of new section code form 26Q
															( jComboBox_Quarter.getSelectedItem().equals("Q2") || jComboBox_Quarter.getSelectedItem().equals("Q3") ||jComboBox_Quarter.getSelectedItem().equals("Q4"))) || selYear_anne2 > 2021)
													{
														annex1Sectioncode = (new String[] {
																"--Select--", "193", "194", "194IC", "94N",
																"94A", "94B", "4BB", "94C",
																"94D", "4EE", "94F", "94G",
																"94H", "4IA", "4IB", "4JA", "4JB" 
																,"94K" ,"94L","94O" ,"94Q" ,"4DA",
																"2AA","LBB","9IA","LBC","BA1","BA2","4NF"});
													}
											else
												annex1Sectioncode = (new String[] {
														"--Select--", "193", "194",
														"94A", "94B", "4BB", "94C",
														"94D", "4EE", "94F", "94G",
														"94H", "4IA", "4IB", "94J",
														"94L", "4BA", "4DA", "2AA", // new development for FRD1.3 by Akansha
														"LBB","9IA" }); // $$ New
											// development
											// for RPU Java
											// Ver1.2
											//newly added for FRD1.5 by akansha
										}else {
											annex1Sectioncode = (new String[] {
													"--Select--", "193", "194",
													"94A", "94B", "4BB", "94C",
													"94D", "4EE", "94F", "94G",
													"94H", "4IA", "4IB", "94J",
													"94L","9IA" }); //newly added for fRD1.5 by akansha

										}

									}

								}
								if(selYear_anne2 >=2016){
									if (jComboBox_Quarter.getSelectedItem() != null) {

									}
								}

							}

							else if (formNumber.equals("27Q")) {

								//New dev for ver1.3 added by Akansha
								//System.out.println("Hiii Akki i am inside the code");
						
								//SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
								
								Date date = new Date();
								SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd", Locale.ENGLISH);
								Date date1 = null;
								Date date2 = null;
								try {
									date1 = sdf.parse("2015-06-01"); 
									date2 = sdf.parse(sdf.format(date));

								}
								catch (ParseException pe){
									pe.printStackTrace();
								}

								//**********************************************************

								// cholia ye check krna hai bhai

								if (jComboBox_Quarter.getSelectedItem() != null) {
									if ((jComboBox_Quarter.getSelectedItem()
											.equals("Q3") || jComboBox_Quarter
											.getSelectedItem().equals("Q4"))
											&& selYear_anne2 == 2014) {
										annex1Sectioncode = (new String[] {
												"--Select--", "94E", "195",
												"96A", "96B", "96C", "96D",
												"4LB", "4LC", "4LD", "4BA" });// new development for FRD1.3 by Akansha
									} else if (selYear_anne2 > 2014) {
																													
										if(selYear_anne2 > 2014 && date2.compareTo(date1)>0){ //New dev for ver1.3 added by Akansha
											//RPU 3.4 start Addition of new section codes 
											 if((selYear_anne2 == 2020 && 
														(jComboBox_Quarter.getSelectedItem().equals("Q3")
																|| jComboBox_Quarter.getSelectedItem().equals("Q4"))) || selYear_anne2 > 2020)
												 annex1Sectioncode = (new String[] {
															"--Select--", "94E", "94N" ,"195",
															"96A", "96B", "96C", "96D","6DA",  //CR 80278 new section code 196DP
															"4LB", "4LC", "4LD","2AA", "BA1",
															"BA2","BA3","4NF",
															"LBB","LBC" });
											 else if((selYear_anne2 == 2020 && 
																		jComboBox_Quarter.getSelectedItem().equals("Q2")))
					                        	annex1Sectioncode = (new String[] {
														"--Select--", "94E", "94N" ,"195",
														"96A", "96B", "96C", "96D",
														"4LB", "4LC", "4LD","2AA", "BA1",
														"BA2","BA3","4NF",
														"LBB","LBC" });      
					                        else if (selYear_anne2 == 2020 && 
													jComboBox_Quarter.getSelectedItem().equals("Q1"))
					                        	annex1Sectioncode = (new String[] {
														"--Select--", "94E", "94N" ,"195",
														"96A", "96B", "96C", "96D",
														"4LB", "4LC", "4LD","2AA", "BA1",
														"BA2","BA3",
														"LBB","LBC" });
											//RPU 3.0 start
					                        else if(selYear_anne2 >=2019)
												annex1Sectioncode = (new String[] {
														"--Select--", "94E", "94N" ,"195",
														"96A", "96B", "96C", "96D",
														"4LB", "4LC", "4LD", "4BA","2AA"
														,"LBB","LBC" });
											//RPU 3.0 end
											else if(selYear_anne2 >=2016)
												annex1Sectioncode = (new String[] {
														"--Select--", "94E", "195",
														"96A", "96B", "96C", "96D",
														"4LB", "4LC", "4LD", "4BA","2AA", 
														"LBB","LBC" });
											
											else
												annex1Sectioncode = (new String[] {
														"--Select--", "94E", "195",
														"96A", "96B", "96C", "96D",
														"4LB", "4LC", "4LD", "4BA","2AA", // new development for FRD1.3 by Akansha
												"LBB" });
										} else{
											//newly added for FRD1.6 by akansha
											if(selYear_anne2 >=2016)
												annex1Sectioncode = (new String[] {
														"--Select--", "94E", "195",
														"96A", "96B", "96C", "96D",
														"4LB", "4LC", "4LD", "4BA", 
														"LBB","LBC" });
											else
												annex1Sectioncode = (new String[] {
														"--Select--", "94E", "195",
														"96A", "96B", "96C", "96D",
														"4LB", "4LC", "4LD", "4BA", // new development for FRD1.3 by Akansha
												"LBB" }); // $$ New development
											// for RPU Java
											// Ver1.2
										}
									}

									else {

										annex1Sectioncode = (new String[] {
												"--Select--", "94E", "195",
												"96A", "96B", "96C", "96D",
												"4LB", "4LC", "4LD" });
									}

								}
							}

							else {
								if (jComboBox_Quarter.getSelectedItem() != null) {
									//RPU 3.5 Addition of new section code
									if (((jComboBox_Quarter.getSelectedItem()
											.equals("Q3")
											|| jComboBox_Quarter
											.getSelectedItem().equals(
													"Q4")) && selYear_anne2 == 2020) || selYear_anne2 >2020)
									{System.out.println("Please display in list");
										annex1Sectioncode = (new String[] {
												"--Select--", "A", "B", "C",
												"D", "E", "F", "G", "H", "I",
												"J", "K","L","M","N","O","P","Q","R" });
										
									}
									
									else if ((jComboBox_Quarter.getSelectedItem()
											.equals("Q2")
											|| jComboBox_Quarter
											.getSelectedItem().equals(
													"Q3") || jComboBox_Quarter
													.getSelectedItem().equals("Q4"))
													&& selYear_anne2 == 2012) {
										annex1Sectioncode = (new String[] {
												"--Select--", "A", "B", "C",
												"D", "E", "F", "G", "H", "I",
												"J", "K" });

									} else if (selYear_anne2 > 2012) {
										//newly added for FRD1.6 by akansha
										if(selYear_anne2>=2016)
											annex1Sectioncode = (new String[] {
													"--Select--", "A", "B", "C",
													"D", "E", "F", "G", "H", "I",
													"J", "K","L","M","N" });
										else
											annex1Sectioncode = (new String[] {
													"--Select--", "A", "B", "C",
													"D", "E", "F", "G", "H", "I",
													"J", "K" });
									}

									else {

										annex1Sectioncode = (new String[] {
												"--Select--", "A", "B", "C",
												"D", "E", "F", "G", "H", "I" });

									}

								}
							}

							// akash annexure1 section combo box
							annex1Section = jTableTransacDetails1
									.getColumnModel().getColumn(5);
							final MyComboBoxEditor annexSectionCombo = new MyComboBoxEditor(annex1Sectioncode);
							annexSectionCombo.getComponent().setBackground(Color.WHITE);

							//Temp code
							((JComboBox) annexSectionCombo.getComponent()).setRenderer(new MyComboBoxRenderer(annex1Sectioncode,(JComboBox) annexSectionCombo.getComponent(),formNumber));

							//************ End of temp code************************

							((JComboBox) annexSectionCombo.getComponent())
							.addActionListener(new ActionListener() {

								public void actionPerformed(
										ActionEvent e) {

								}
							});

							annex1Section.setCellEditor(annexSectionCombo);

						}
						// nnexure1 section combo box end
						// final MyComboBoxEditor dedRemarksCombo = new
						// MyComboBoxEditor(remarksForDed);

						// Added for challan serial number
						//						System.out.println("total rows in challan is "
						//								+ chalnn_getRowCnt);

						Object[] chSerialArray = new Object[chalnn_getRowCnt]; // idhar
						// newly added by cholia for drop down size
						String[] challan_serial_number = new String[chalnn_getRowCnt];
						// end newly added by cholia for drop down size

						if (chalnn_getRowCnt > 0) { // challan_serial_number[0]="--Select--";
							for (int i = 0; i < chalnn_getRowCnt; i++) // idhar
							{
								chSerialArray[i] = i + 1;
								// chSerialArray[i]=i;

								challan_serial_number[i] = chSerialArray[i]
										.toString();

							}

						}

						challan_serialannex1 = jTableTransacDetails1
								.getColumnModel().getColumn(0);

						if (challan_serial_number != null) {
							/*
							 * jTableTransacDetails1 .getColumnModel()
							 * .getColumn(0) .setCellEditor( new
							 * GRPUTableCellEditorAnnex1InsertRow(
							 * challan_serial_number));
							 */

							final MyComboBoxEditor challanSerialNumberCombo = new MyComboBoxEditor(
									challan_serial_number);
							challanSerialNumberCombo.getComponent()
							.setBackground(Color.WHITE);

							((JComboBox) challanSerialNumberCombo
									.getComponent())
									.addActionListener(new ActionListener() {
										public void actionPerformed(
												ActionEvent e) {

											jCombo_challanSerialNum_actionPerformed(
													e,
													challanSerialNumberCombo,
													false, 0, 0);

										}

									});

							challan_serialannex1
							.setCellEditor(challanSerialNumberCombo);

						}

						if (formNumber.equals("26Q")
								|| formNumber.equals("27Q")) { // For
							// dedcutee_code
							final MyComboBoxEditor dedCodeCombo = new MyComboBoxEditor(
									ded_code);
							dedCodeCombo.getComponent().setBackground(
									Color.WHITE);
							((JComboBox) dedCodeCombo.getComponent())
							.addAncestorListener(new AncestorListener() {

								public void ancestorAdded(
										AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) dedCodeCombo
											.getComponent())
											.requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});

							dedcodeannex1.setCellEditor(dedCodeCombo);

							// For paid by book entry or not

							final MyComboBoxEditor paidBookEntry = new MyComboBoxEditor(
									paid_book_entry);
							paidBookEntry.getComponent().setBackground(
									Color.WHITE);
							((JComboBox) paidBookEntry.getComponent())
							.addAncestorListener(new AncestorListener() {

								public void ancestorAdded(
										AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) paidBookEntry
											.getComponent())
											.requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});

							paidBookEntryAnnex1.setCellEditor(paidBookEntry);

							// end

						}

						if (formNumber.equals("27Q")) {
							// Added For RateOfTds
							final MyComboBoxEditor tdsRateCombo = new MyComboBoxEditor(
									rate_of_tds);
							tdsRateCombo.getComponent().setBackground(
									Color.WHITE);
							((JComboBox) tdsRateCombo.getComponent())
							.addAncestorListener(new AncestorListener() {

								public void ancestorAdded(
										AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) tdsRateCombo
											.getComponent())
											.requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});

							rateTdsannex1.setCellEditor(tdsRateCombo);

							// Country resdience

							final MyComboBoxEditor countryResdCombo = new MyComboBoxEditor(
									country_resd);
							countryResdCombo.getComponent().setBackground(
									Color.WHITE);
							((JComboBox) countryResdCombo.getComponent())
							.addAncestorListener(new AncestorListener() {

								public void ancestorAdded(
										AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) countryResdCombo
											.getComponent())
											.requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});

							country_resdannex1.setCellEditor(countryResdCombo);

							// End Country resdience

							// For Nature Remittance
							final MyComboBoxEditor natureRemitCombo = new MyComboBoxEditor(
									nature_remit);
							natureRemitCombo.getComponent().setBackground(
									Color.WHITE);
							((JComboBox) natureRemitCombo.getComponent())
							.addAncestorListener(new AncestorListener() {

								public void ancestorAdded(
										AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) natureRemitCombo
											.getComponent())
											.requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});

							nature_remitsannex1.setCellEditor(natureRemitCombo);

							// End

							// Grossing up indicator

							final MyComboBoxEditor grossingUpIndCombo = new MyComboBoxEditor(
									gross_up_indicator);
							grossingUpIndCombo.getComponent().setBackground(
									Color.WHITE);
							((JComboBox) grossingUpIndCombo.getComponent())
							.addAncestorListener(new AncestorListener() {

								public void ancestorAdded(
										AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) grossingUpIndCombo
											.getComponent())
											.requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});

							grossupindicatorAnnex1
							.setCellEditor(grossingUpIndCombo);

							// End Grossing up indicator

						}

						if (formNumber.equals("27EQ")) {
							// party code

							final MyComboBoxEditor partyCodeCombo = new MyComboBoxEditor(party_code);
							partyCodeCombo.getComponent().setBackground(Color.WHITE);
							((JComboBox) partyCodeCombo.getComponent()).addAncestorListener(new AncestorListener() {

								public void ancestorAdded(AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) partyCodeCombo.getComponent()).requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});

							partycoderesdannex1.setCellEditor(partyCodeCombo);

							// End party code

							// Paid By book entry or not

							final MyComboBoxEditor bookEntryCombo = new MyComboBoxEditor(book_entry_27EQ);
							bookEntryCombo.getComponent().setBackground(Color.WHITE);
							((JComboBox) bookEntryCombo.getComponent()).addAncestorListener(new AncestorListener() {

								public void ancestorAdded(AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) bookEntryCombo.getComponent()).requestFocusInWindow();

								}

								public void ancestorMoved(AncestorEvent event) {

								}

								public void ancestorRemoved(AncestorEvent event) {

								}

							});

							bookentry27EQdannex1.setCellEditor(bookEntryCombo);

							// End Paid By book entry or not

							/************************************************************************************************************/
							//added by sadhana, FRD 2.2
							/*DedIsPermanentResident = jTableTransacDetails1.getColumnModel().getColumn(31);
							DedIsPermanentResidentEst = jTableTransacDetails1.getColumnModel().getColumn(32);

							final MyComboBoxEditor dedIsPermanentResidentCombo = new MyComboBoxEditor(dedIsPermanentResidentList);
							dedIsPermanentResidentCombo.getComponent().setBackground(Color.WHITE);

							((JComboBox) dedIsPermanentResidentCombo.getComponent()).addAncestorListener(new AncestorListener() {

								public void ancestorAdded(AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) dedIsPermanentResidentCombo.getComponent()).requestFocusInWindow();

								}

								public void ancestorMoved(AncestorEvent event) {

								}

								public void ancestorRemoved(AncestorEvent event) {

								}

							});

							DedIsPermanentResident.setCellEditor(dedIsPermanentResidentCombo);
							DedIsPermanentResidentEst.setCellEditor(dedIsPermanentResidentCombo);*/

							// start DedIsPermanentResident
							final MyComboBoxEditor dedIsPermanentResidentCombo = new MyComboBoxEditor(dedIsPermanentResidentList);
							dedIsPermanentResidentCombo.getComponent().setBackground(Color.WHITE);
							((JComboBox) dedIsPermanentResidentCombo.getComponent()).addAncestorListener(new AncestorListener() {

								public void ancestorAdded(AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) dedIsPermanentResidentCombo.getComponent()).requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});
							DedIsPermanentResident = jTableTransacDetails1.getColumnModel().getColumn(31);
							DedIsPermanentResident.setCellEditor(dedIsPermanentResidentCombo);
							// end DedIsPermanentResident

							// start dedIsPermanentResidentEstList
							final MyComboBoxEditor dedIsPermanentResidentEstCombo = new MyComboBoxEditor(dedIsPermanentResidentEstList);
							dedIsPermanentResidentEstCombo.getComponent().setBackground(Color.WHITE);
							((JComboBox) dedIsPermanentResidentEstCombo.getComponent()).addAncestorListener(new AncestorListener() {

								public void ancestorAdded(AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) dedIsPermanentResidentEstCombo.getComponent()).requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});
							DedIsPermanentResidentEst = jTableTransacDetails1.getColumnModel().getColumn(32);
							DedIsPermanentResidentEst.setCellEditor(dedIsPermanentResidentEstCombo);
							//end dedIsPermanentResidentEstList
							/************************************************************************************************************/
							//Start whether payment is liable to collectee //RPU 3.5 Column 34
							final MyComboBoxEditor WhetherpymntisliableCombo = new MyComboBoxEditor(WhetherpymntisliableList);
							WhetherpymntisliableCombo.getComponent().setBackground(Color.WHITE);
							((JComboBox) WhetherpymntisliableCombo.getComponent()).addAncestorListener(new AncestorListener() {

								public void ancestorAdded(AncestorEvent event) {
									// make sure combobox handles key
									// events
									((JComboBox) WhetherpymntisliableCombo.getComponent()).requestFocusInWindow();

								}

								public void ancestorMoved(
										AncestorEvent event) {

								}

								public void ancestorRemoved(
										AncestorEvent event) {

								}

							});
							Whetherpymntisliable = jTableTransacDetails1.getColumnModel().getColumn(33);
							Whetherpymntisliable.setCellEditor(WhetherpymntisliableCombo); 
							// end whether payment is liable to collect

						}

					} else {
						getMessage("Please insert Challan details before inserting Annexure I details");
						TabGRPU.setSelectedIndex(DDO_TAB_INDEX); //new development for FRD1.3 by Akansha

					}

				}

				else {
					rows_able = false;

					// initializeAnneTab(formNumber,rows_able);
					//New dev ver1.3 added by Akansha
					if("--Select--".equals(jComboBox_Quarter.getSelectedItem().toString()) && "--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem()))
						getMessage("Please Select Financial Year & Quarter");
					else if("--Select--".equals(jComboBox_Quarter.getSelectedItem().toString()) && !"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem()))
						getMessage("Please select quarter");
					TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
					jComboBox_FinYear1.requestFocus();

				}
				// Code for AnnI tab
				// Modifed by Akansha

				// ***********************************************************
				// ********************************************************
			}
			// Akansha end

			// Added By for Annexure 2 called when selecting Financial Year and Quarter Q4 during Re-initializing
			if("24Q".equals(grpu.formNumber) && grpu.jComboBox_Quarter.getSelectedItem().equals("Q4") ){
				if (TabGRPU.getSelectedIndex() == ANNE2_TAB_INDEX) // yahan faizan
				{
					int i = 0;
					jTableTransacDetails2.putClientProperty(
							"terminateEditOnFocusLost", Boolean.TRUE);

					if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {

						int selYear = Integer.parseInt(JComboBox_Form_Sub1_finYear
								.getSelectedItem().toString().substring(0, 4));
						int next_year = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(5, 9));
						if (selYear <= 2010 && next_year <= 2011)
							jComboBox_deductee_Type = (new String[] { "--Select--",
									"Women", "Senior Citizen", "Others" });
						else if (selYear >= 2011 && next_year >= 2012) {
							jComboBox_deductee_Type = (new String[] { "--Select--",
									"Women", "Senior Citizen",
									"Super Senior Citizen", "Others" });

						}

						// new added by cholia to handle the sum total issue
						// romayahan pe

						// Handle for Financial Year less than 2012
						if (selYear < 2012) {
							double Amnt80CCG = 0;
							double totalAmntChpVIA = 0;
							double totalAmntChpVIA_new = 0;
							DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
							df.setMaximumFractionDigits(2);

							for (i = 2; i < model2.getRowCount(); i++) {
								Object Amnt80CCG_obj = model2.getValueAt(i, 19);

								if (Amnt80CCG_obj != null
										&& !"".equals(Amnt80CCG_obj)) {

									Amnt80CCG = Double.parseDouble(Amnt80CCG_obj
											.toString());

								}
								
								Object totalAmntChpVIA_obj = model2.getValueAt(i,
										21);

								if (totalAmntChpVIA_obj != null
										&& !"".equals(totalAmntChpVIA_obj)) {

									totalAmntChpVIA = Double
											.parseDouble(totalAmntChpVIA_obj
													.toString());

									totalAmntChpVIA_new = totalAmntChpVIA
											- Amnt80CCG;
									model2.setValueAt(
											df.format(totalAmntChpVIA_new), i, 21);

								}

							}

						}

						// newly added by cholia for 80CCF for column 18

						// Handle for Financial Year other than 2010-2011
						if (selYear != 2010 && selYear != 2011) {
							double Amnt80CCF = 0;
							double totalAmntChpVIA = 0;
							double totalAmntChpVIA_new = 0;
							DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
							DecimalFormat df = new DecimalFormat("0.00",sf);
							df.setMaximumFractionDigits(2);

							for (i = 2; i < model2.getRowCount(); i++) {
								Object Amnt80CCF_obj = model2.getValueAt(i, 18);

								if (Amnt80CCF_obj != null
										&& !"".equals(Amnt80CCF_obj)) {

									Amnt80CCF = Double.parseDouble(Amnt80CCF_obj
											.toString());

								}

								Object totalAmntChpVIA_obj = model2.getValueAt(i,
										21);
								// System.out.println("object valus is"+totalAmntChpVIA_obj);
								if (totalAmntChpVIA_obj != null
										&& !"".equals(totalAmntChpVIA_obj)) {

									totalAmntChpVIA = Double
											.parseDouble(totalAmntChpVIA_obj
													.toString());
									// System.out.println("sam valus is " +
									// totalAmntChpVIA);
									totalAmntChpVIA_new = totalAmntChpVIA
											- Amnt80CCF;
									model2.setValueAt(
											df.format(totalAmntChpVIA_new), i, 21);

								}

							}

						}

						// end newly added by cholia
						if (formNumber.equals("24Q") && (!".tds".equals(fileExtsn))) {	
							if ((selYear < 2013 && next_year < 2014)) {

								for (i = 2; i < model2.getRowCount(); i++) {
									model2.setValueAt("", i, 8); // To clear tax
									// amount
									// deducted
									model2.setValueAt("", i, 9); // reported taxable
									// amount
									// model2.setValueAt("",i,10);

									// model2.setValueAt("",i,22); //Total t axable
									// income
									model2.setValueAt("", i, 32); // Whether tax
									// deducted at
									// higher rate
									// 80CCG
									// newly added by cholia2
									model2.setValueAt("", i, 28); // aggr amnt 21
									// column 28
									model2.setValueAt("", i, 29); // column29
									// end added by cholia2
									if(selYear <2012 && next_year<2013){
										model2.setValueAt("",i,19); // newly added for FRD1.3 by Akansha
									}

									if(selYear<2011 && next_year<2012){
										if(model2.getValueAt(i, 5).toString().contains("Super"))
											model2.setValueAt("--Select--",i, 5);
									}

									//newly added for FRD1.6 by akansha

									model2.setValueAt("--Select--", i, 51);
									model2.setValueAt("", i, 52);
									model2.setValueAt("", i, 53);
									model2.setValueAt("", i, 54);
									model2.setValueAt("", i, 55);
									model2.setValueAt("", i, 56);
									model2.setValueAt("", i, 57);
									model2.setValueAt("", i, 58);

									//newly added for FRD1.6 by akansha

									model2.setValueAt("--Select--",i,33);
									model2.setValueAt("",i, 34);
									model2.setValueAt("",i, 35);
									model2.setValueAt("",i, 36);
									model2.setValueAt("",i, 37);
									model2.setValueAt("",i, 38);
									model2.setValueAt("",i, 39);
									model2.setValueAt("",i, 40);
									model2.setValueAt("",i, 41);

									model2.setValueAt("--Select--", i, 42);
									model2.setValueAt("",i, 43);
									model2.setValueAt("",i, 44);
									model2.setValueAt("",i, 45);
									model2.setValueAt("",i, 46);
									model2.setValueAt("",i, 47);
									model2.setValueAt("",i, 48);
									model2.setValueAt("",i, 49);
									model2.setValueAt("",i, 50);


									//*********************************************************

								}


							}




							// newly added by cholia on 28.2.2015
							if (selYear >= 2013) {

								DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
								df.setMaximumFractionDigits(2);
								for (i = 2; i < model2.getRowCount(); i++) {

									//new development for FRD1.3 by Akansha
									// Total amount of salary
									model2.setValueAt("", i,14); //Income
									// chargable under the head salaries
									model2.setValueAt("", i,16); //Gross total
									// income
									//************************************
									// newly added by cholia for the total salary8+9
									// on 29.02.2015
									double totalAmntCurrEmp = 0;
									double totalAmntPrevEmp = 0;
									double totalSalary10 = 0;
									Object totalAmntCurrEmp_obj = model2
											.getValueAt(i, 8);
									// System.out.println("object valus is"+totalAmntCurrEmp_obj);
									if (totalAmntCurrEmp_obj != null
											&& !"".equals(totalAmntCurrEmp_obj)) {

										totalAmntCurrEmp = Double
												.parseDouble(totalAmntCurrEmp_obj
														.toString());

										// model2.setValueAt(df.format(totalAmntChpVIA_new),i,21);

									}

									Object totalAmntPrevEmp_obj = model2
											.getValueAt(i, 9);
									// System.out.println("object valus is"+totalAmntCurrEmp_obj);
									if (totalAmntPrevEmp_obj != null
											&& !"".equals(totalAmntPrevEmp_obj)) {

										totalAmntPrevEmp = Double
												.parseDouble(totalAmntPrevEmp_obj
														.toString());

										// model2.setValueAt(df.format(totalAmntChpVIA_new),i,21);

									}

									totalSalary10 = totalAmntPrevEmp
											+ totalAmntCurrEmp;

									model2.setValueAt(df.format(totalSalary10), i,
											10);

									// end //newly added by cholia for the total
									// salary8+9 on 29.02.2015
									// newly added by cholia income chargable


									/*********************************************************/				
									//FRD 2.3 added 16(ia)	
									/*Object Income_chargable = model2.getValueAt(i,
											13);*/
									double col11 = 0.0;
									double col12 = 0.0;
									double col13 = 0.0;
									double col68 = 0.0;
									if (model2.getValueAt(i, 11) != null && model2.getValueAt(i, 11).toString().length() != 0) {
										col11 = Double.parseDouble(model2.getValueAt(i, 11).toString());
									}

									if (model2.getValueAt(i, 12) != null && model2.getValueAt(i, 12).toString().length() != 0) {
										col12 = Double.parseDouble(model2.getValueAt(i, 12).toString());
									}

									if (model2.getValueAt(i, 13) != null && model2.getValueAt(i, 13).toString().length() != 0) {
										col13 = Double.parseDouble(model2.getValueAt(i, 13).toString());
									}
									
									/****************** Added for 2.7 Start ********************/
									if (selYear >= 2018) {
										if (model2.getValueAt(i, 68) != null && model2.getValueAt(i, 68).toString().length() != 0) {
											col68 = Double.parseDouble(model2.getValueAt(i, 68).toString());
										}

									}

									Object Income_chargable = col11 + col12 + col13 + col68;
									
									/****************** Added for 2.7 End ********************/
									/*********************************************************/	

									if (Income_chargable != null
											&& !"".equals(Income_chargable)) { // newly
										// added
										// by
										// cholia
										// 0n
										// 13
										// march
										// 2015
										double headSal = 0;
										headSal = totalSalary10
												- Double.parseDouble(Income_chargable
														.toString());

										model2.setValueAt(df.format(headSal), i, 14);

										//new development for FRD1.3 by Akansha
										//for wrong population of saved file
										double a =0, othersal =0;
										if(model2.getValueAt(i, 15)!=null && !"".equals(model2.getValueAt(i, 15).toString()))
											a = Double.parseDouble(model2.getValueAt(i, 15).toString());
										else
											a=0;
										/****************** Added for 2.7 Start ********************/
										if (selYear >= 2018) {
											if (model2.getValueAt(i, 69) != null
													&& !"".equals(model2.getValueAt(i, 69).toString())) {
												a = a + Double.parseDouble(model2.getValueAt(i, 69).toString());
											}

										}

										/****************** Added for 2.7 End ********************/
										othersal = a+headSal;
										model2.setValueAt(df.format(othersal), i, 16);
										// end newly added by cholia 0n 13 march
									}
									// end

									//newly added for FRD1.6 by akansha
									if(selYear<2016){

										model2.setValueAt("--Select--",i,33);
										model2.setValueAt("",i, 34);
										model2.setValueAt("",i, 35);
										model2.setValueAt("",i, 36);
										model2.setValueAt("",i, 37);
										model2.setValueAt("",i, 38);
										model2.setValueAt("",i, 39);
										model2.setValueAt("",i, 40);
										model2.setValueAt("",i, 41);

										model2.setValueAt("--Select--", i, 42);
										model2.setValueAt("",i, 43);
										model2.setValueAt("",i, 44);
										model2.setValueAt("",i, 45);
										model2.setValueAt("",i, 46);
										model2.setValueAt("",i, 47);
										model2.setValueAt("",i, 48);
										model2.setValueAt("",i, 49);
										model2.setValueAt("",i, 50);

									}



								}

							}

							// end newly added by cholia on 28.2.2015

							if ((selYear < 2010 && next_year < 2011)
									|| (selYear > 2011 && next_year > 2012)) {
								for (i = 2; i < model2.getRowCount(); i++) {
									model2.setValueAt("", i, 18);

								}
							}

							/****************** Added for 2.7 Start ********************/
							if (selYear < 2018 && next_year < 2019) {
								for (i = 2; i < model2.getRowCount(); i++) {
									model2.setValueAt("", i, 59);
									model2.setValueAt("", i, 60);
									model2.setValueAt("", i, 61);
									model2.setValueAt("", i, 62);
									model2.setValueAt("", i, 63);
									model2.setValueAt("", i, 64);
									model2.setValueAt("", i, 65);
									model2.setValueAt("", i, 66);
									model2.setValueAt("", i, 67);
									model2.setValueAt("", i, 68);
									model2.setValueAt("", i, 69);
									model2.setValueAt("", i, 70);
									model2.setValueAt("", i, 71);
									model2.setValueAt("", i, 72);
									model2.setValueAt("", i, 73);
									model2.setValueAt("", i, 74);
									model2.setValueAt("", i, 75);
									model2.setValueAt("", i, 76);
									model2.setValueAt("", i, 77);
									model2.setValueAt("", i, 78);
									model2.setValueAt("", i, 79);
									//RPU 2.9 start
									model2.setValueAt("", i, 80);
									model2.setValueAt("", i, 81);
									model2.setValueAt("", i, 82);
									model2.setValueAt("", i, 83);
									model2.setValueAt("", i, 84);
									model2.setValueAt("", i, 85);
									model2.setValueAt("", i, 86);
									model2.setValueAt("", i, 87);
									model2.setValueAt("", i, 88);
									model2.setValueAt("", i, 89);
									model2.setValueAt("", i, 90);
									model2.setValueAt("", i, 91);
									model2.setValueAt("", i, 92);
									    
									//RPU 2.9 end
								}
							}
							/****************** Added for 2.7 End ********************/

						}
						/*if (model2.getValueAt(i, 93)!=null && model2.getValueAt(i, 93)!="")
						if (selYear >= 2020 && model2.getValueAt(i, 93).equals("Yes")){   //RPU 3.6 changes adding blank values
							for (i = 2; i < model2.getRowCount(); i++){
								model2.setValueAt("", i, 11);
								model2.setValueAt("", i, 12);
								model2.setValueAt("", i, 13);
								model2.setValueAt("", i, 19);
								model2.setValueAt("", i, 20);
								model2.setValueAt("", i, 62);
								model2.setValueAt("", i, 63);
								model2.setValueAt("", i, 66);
								model2.setValueAt("", i, 70);
								model2.setValueAt("", i, 71);
								model2.setValueAt("", i, 72);
								model2.setValueAt("", i, 73);
								model2.setValueAt("", i, 74);
								model2.setValueAt("", i, 75);
								model2.setValueAt("", i, 76);
								model2.setValueAt("", i, 77);
								model2.setValueAt("", i, 80);
								model2.setValueAt("", i, 81);
								model2.setValueAt("", i, 82);
								model2.setValueAt("", i, 83);
								model2.setValueAt("", i, 84);
								model2.setValueAt("", i, 85);
								model2.setValueAt("", i, 86);
								model2.setValueAt("", i, 87);
								model2.setValueAt("", i, 88);
								model2.setValueAt("", i, 89);
								model2.setValueAt("", i, 91);
								model2.setValueAt("", i, 92);
								
							}
						}*/

						// ***************************************

						// added by cholia to change the colour of the cell
						//gray
						//new development for FRD1.5 by Akansha
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(2)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, pancheckfagAnne2,false));
						//**************************************************
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(7)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));


						jTableTransacDetails2
						.getColumnModel()
						.getColumn(8)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						// total salary
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(9)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(17)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(18)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(27)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(28)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						// vibha here
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(31)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(29)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added

						//newly added for FRD1.6 by akansha
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(32)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added


						jTableTransacDetails2
						.getColumnModel()
						.getColumn(33)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(34)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(35)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(36)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added

						//2nd
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(37)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(38)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(39)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(40)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added

						//3rd
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(41)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(42)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(43)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(44)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added

						//4th
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(45)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(46)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(47)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(48)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(49)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false)); // added

						//newly added for revised FRD1.6 by akansha
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(50)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(51)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(52)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(53)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(54)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(55)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(56)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(57)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										false, "",false)); // added
						//**********************************************************

						// added for gray color
						/****************** Added for 2.7 Start ********************/

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(16)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));



						jTableTransacDetails2
						.getColumnModel()
						.getColumn(58)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(59)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(60)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(61)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(62)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(63)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(64)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(65)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(66)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(67)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(68)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(69)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(70)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(71)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(72)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(73)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(74)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(75)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(76)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(77)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(78)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						//RPU 2.9 start
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(79)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(80)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(81)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(82)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(83)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(84)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(85)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(86)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(87)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(88)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(89)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(90)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						jTableTransacDetails2
						.getColumnModel()
						.getColumn(91)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
						
						jTableTransacDetails2              //RPU 3.7 Addition of new column rahul
						.getColumnModel()
						.getColumn(92)
						.setCellRenderer(
								new GRPUTableCellRendererForColour("Anne2",
										selYear, next_year, formNumber,
										true, "",false));
						
							
						
						//RPU 2.9 end

						/****************** Added for 2.7 Start ********************/

					}

					final MyComboBoxEditor dedcuteeTypeComboAnnx2 = new MyComboBoxEditor(jComboBox_deductee_Type);
					dedcuteeTypeComboAnnx2.getComponent().setBackground(Color.WHITE);
					((JComboBox) dedcuteeTypeComboAnnx2.getComponent()).addAncestorListener(new AncestorListener() {

						public void ancestorAdded(AncestorEvent event) {
							// make sure combobox handles key events
							((JComboBox) dedcuteeTypeComboAnnx2
									.getComponent()).requestFocusInWindow();

						}

						public void ancestorMoved(AncestorEvent event) {

						}

						public void ancestorRemoved(AncestorEvent event) {

						}

					});

					// Added For the updation mode for challan
					dedcuteeTypeannx2 = jTableTransacDetails2.getColumnModel().getColumn(4);
					dedcuteeTypeannx2.setCellEditor(dedcuteeTypeComboAnnx2);

					// added by choia to change the coloue of the updation mode for
					// annexure 2

					if (o.toString().equals("Regular")) {

						jTableTransacDetails2
						.getColumnModel()
						.getColumn(1)
						.setCellRenderer(
								new GRPUTableCellRenderer("Anne2", false));
					}

					// end

					// Added For Whether tax deducted at higher rate due to non
					// furnishing of PAN by

					final MyComboBoxEditor whetherTaxDedHigherRateAnnx2 = new MyComboBoxEditor(whetherTaxDedHigherRate);
					whetherTaxDedHigherRateAnnx2.getComponent().setBackground(Color.WHITE);
					((JComboBox) dedcuteeTypeComboAnnx2.getComponent()).addAncestorListener(new AncestorListener() {

						public void ancestorAdded(AncestorEvent event) {
							// make sure combobox handles key events
							((JComboBox) whetherTaxDedHigherRateAnnx2.getComponent()).requestFocusInWindow();
						}

						public void ancestorMoved(AncestorEvent event) {

						}

						public void ancestorRemoved(AncestorEvent event) {

						}

					});

					whetTaxDedHigherRateAnnx2 = jTableTransacDetails2.getColumnModel().getColumn(31);
					whetTaxDedHigherRateAnnx2.setCellEditor(whetherTaxDedHigherRateAnnx2);

					/*****************************************************************************************************/
					//added Combobox for PAN of Lanlord1, PAN of Lanlord2, PAN of Lanlord3, and PAN of Lanlord4, On 16/01/2017, FRD1.9
					//newly added for FRD1.9
					panoflandlordDD1 = jTableTransacDetails2
							.getColumnModel().getColumn(33);
					panoflandlordDD2 = jTableTransacDetails2
							.getColumnModel().getColumn(35);
					panoflandlordDD3 = jTableTransacDetails2
							.getColumnModel().getColumn(37);
					panoflandlordDD4 = jTableTransacDetails2
							.getColumnModel().getColumn(39);

					//newly added for FRD2.0 by Sadhana
					panoflandlordDD1 = jTableTransacDetails2
							.getColumnModel().getColumn(42);
					panoflandlordDD2 = jTableTransacDetails2
							.getColumnModel().getColumn(44);
					panoflandlordDD3 = jTableTransacDetails2
							.getColumnModel().getColumn(46);
					panoflandlordDD4 = jTableTransacDetails2
							.getColumnModel().getColumn(47);

					final MyComboBoxEditor PanOfLanLordCombo = new MyComboBoxEditor(panoflandlordDDList);
					PanOfLanLordCombo.getComponent().setBackground(Color.WHITE);

					//Temp code
					((JComboBox) PanOfLanLordCombo.getComponent()).setRenderer(new MyComboBoxPanOfLandLord(formNum,(JComboBox) PanOfLanLordCombo.getComponent()));				

					((JComboBox) PanOfLanLordCombo.getComponent())
					.addActionListener(new ActionListener() {

						public void actionPerformed(
								ActionEvent e) {

						}
					});
					//((JComboBox) PanOfLanLordCombo.getComponent()).setEditable(true);
					/*((JComboBox) PanOfLanLordCombo.getComponent()).addItemListener(new ItemListener() {
				            @Override
				            public void itemStateChanged(ItemEvent e) {
				                Object selectedItem = ((JComboBox) PanOfLanLordCombo.getComponent()).getSelectedItem();
				                boolean editable = selectedItem instanceof String && ((String)selectedItem).equals("Enter PAN");
				                ((JComboBox) PanOfLanLordCombo.getComponent()).setEditable(editable);
				            }
				        });

					((JComboBox) PanOfLanLordCombo.getComponent()).setEditable(true);	*/											
					/*********************************************************************************************/
				}
			}


		} else {

		}

		/******************  Method called for re-intializing the Form using Back button end *************************/
	}

	private void jButton_addRow_actionPerformed(ActionEvent e) {
		selTAB = TabGRPU.getSelectedIndex();
		int ia = 0, ja = 0, ka = 0;
		int annIIcnt=0;
		int delval=0;
		if (selTAB == DDO_TAB_INDEX) {
			getRowCnt = 0;// yahan pe
			ia = model.getRowCount() - 2;
		} else if (selTAB == ANNE_TAB_INDEX) {
			getRowCnt1 = 0;
			ja = model1.getRowCount() - 2;
		} else if (selTAB == ANNE2_TAB_INDEX) {
			getRowCnt2 = 0;
			ka = model2.getRowCount() - 2;

			//new development for FRD1.3 by akansha
			if("Correction".equals(valueOfTypeOfStmt) && "Import".equals(method)){

				//changes for SD, when conso file dosen't have records for Annexure II.
				if(!annexIIcount.equals("")){
					annIIcnt = Integer.parseInt(annexIIcount);
				}else{
					annIIcnt = annIIcnt;
				}
				//annIIcnt = Integer.parseInt(annexIIcount);

				//temp code
				for (int ya = 2; ya < model2.getRowCount(); ya++) {
					if (model2.getValueAt(ya, 1) != null
							&& !model2.getValueAt(ya, 1).toString()
							.equalsIgnoreCase("")) {
						if (delval < Integer.parseInt(model2.getValueAt(ya, 1)
								.toString())) {

							delval = Integer.parseInt(model2.getValueAt(ya, 1)
									.toString());
						}
					}
				}

				if(annIIcnt<=delval)
					annIIcnt = delval+1;
				else
					annIIcnt = annIIcnt;

				//************
			}else if("Correction".equals(valueOfTypeOfStmt) && "Open".equals(method))
			{
				for (int ya = 2; ya < model2.getRowCount(); ya++) {
					if (model2.getValueAt(ya, 1) != null
							&& !model2.getValueAt(ya, 1).toString()
							.equalsIgnoreCase("")) {
						if (annIIcnt < Integer.parseInt(model2.getValueAt(ya, 1)
								.toString())) {

							annIIcnt = Integer.parseInt(model2.getValueAt(ya, 1)
									.toString());
						}
					}
				}
			}
			//******************************************

		}
		String message = "Enter number of Rows to be added : ";
		//		String text = JOptionPane.showInputDialog(JdialogFrame, message,
		//				"Add Rows", JOptionPane.WARNING_MESSAGE);

		//R&D development code by Akansha
		String text = mainObject.createCustomDialogAddPopup();
		String temp[] = text.split(",");
		// *****************************************************
		//System.out.println("The Akki input AnneII: " + temp[0] + " " + temp[1]);

		if (text == null)
			return;
		try {
			int text1 = Integer.parseInt(temp[0]);
			if ("OK".equals(temp[1].toString())) {
				if (temp[0] != null) {
					if (text1 < 0)
						getMessage("Number of Rows cannot be Negative.");
					else if (text1 == 0)
						getMessage("Please enter a value greater than 0");

					// newly commented by cholia
					/*
					 * else if (text1 > GRPUConstants.MAX_ROWADD_BLOCK)
					 * getMessage("Please enter maximum of " +
					 * GRPUConstants.MAX_ROWADD_BLOCK + " at a time.");
					 */
					else {
						// added by for annex1 and annex2 by cholia
						if (selTAB == DDO_TAB_INDEX) {

							// newly changed by cholia
							if ((text1 + "").length() < 6) {
								int currRowCnt = jTableTransacDetails
										.getRowCount();
								if ((currRowCnt - 2) + text1 > 99999) {
									getMessage("More than 99999 rows are not allowed");
									return;
								} else {
									//newly developed for FRD1.5 Ver1.5 by akansha
									/*final MyComboBoxEditor bookEntryDropDown = new MyComboBoxEditor(
											jComboBox_Book_Entry);
									bookEntryDropDown.getComponent().setBackground(Color.white);
									bookEntryDropDown.setClickCountToStart(0);
									colBookEntry.setCellEditor(bookEntryDropDown);

									((JComboBox) bookEntryDropDown.getComponent())
											.addActionListener(new ActionListener() {
												public void actionPerformed(ActionEvent e) {


													//************************************************
													if(jTableTransacDetails.getSelectedRow()>-1)
													System.out.println("Jtransac table: "+model.getValueAt(jTableTransacDetails.getSelectedRow(),1).toString());
													//newly developed for FRD1.5 Ver1.5 by akansha
													if("Correction".equals(valueOfTypeOfStmt) && 
															model.getRowCount()>2 && (jTableTransacDetails.getSelectedRow()>-1) &&
															model.getValueAt(jTableTransacDetails.getSelectedRow(),1)!=null && 
															"ADD".equals(model.getValueAt(jTableTransacDetails.getSelectedRow(),1).toString())
															){
														System.out.println("I am inside book entry");
														System.out
																.println("Item count:"+((JComboBox)bookEntryDropDown.getComponent()).getItemCount());
														if(((JComboBox)bookEntryDropDown.getComponent()).getItemCount()>2)
														((JComboBox)bookEntryDropDown.getComponent()).removeItemAt(2);
													}
													//********************************************


												}

											});*/
									//******************end of Ver1.5*****************************************
									addBlankRows(text1, false);

									// System.out.println("Add Rw ch: " + ia);
									for (int i = 0; i < text1; i++) {
										model.setValueAt(ia + 1, ia + 2, 0);
										//newly developed  for FRD1.5 Ver1.5 by akansha
										/*if ("Correction".equals(valueOfTypeOfStmt)) {
												if ("Central Government"
														.equals(JComboBox_Form_Sub1_Type_of_Deductor
																.getSelectedItem().toString())
														|| "State Government"
																.equals(JComboBox_Form_Sub1_Type_of_Deductor
																		.getSelectedItem()
																		.toString())) {
//													int i = 2;
//													for (i = 2; i < model.getRowCount(); i++)
														if("ADD".equals(model.getValueAt(ia + 2, 1)))
																		model.setValueAt("Yes", ia + 2, 18);
												}
											}*/
										//*******************************************************
										ia++;
									}
								}
							} else {
								getMessage("length of Add Rowsfield should be  upto 5 digit only");
							}

						} else if (selTAB == ANNE_TAB_INDEX) {
							if ((text1 + "").length() < 8) {
								addBlankRows1(text1, 0, false, false);

								for (int i = 0; i < text1; i++) {
									model1.setValueAt(ja + 1, ja + 2, 0);
									ja++;
								}
							} else
								getMessage("length of Add Rows field should be  upto 7 digit only");
						} else if (selTAB == ANNE2_TAB_INDEX) // annexure2
						{

							if ((text1 + "").length() < 8) {
								addBlankRows2(text1, false);

								for (int i = 0; i < text1; i++) {
									//new development for FRD1.3 by akansha
									if ("Correction".equals(valueOfTypeOfStmt)
											&& "Import".equals(method)) {
										model2.setValueAt(annIIcnt, ka + 2, 1);
										annIIcnt++;
									}
									else if("Correction".equals(valueOfTypeOfStmt) && "Open".equals(method)){
										annIIcnt++;
										model2.setValueAt(annIIcnt, ka + 2, 1);

									}

									else
										model2.setValueAt(ka + 1, ka + 2, 1);
									//***********************************************
									model2.setValueAt(ka + 1, ka + 2, 0);
									ka++;
								}
							} else
								getMessage("length of Add Rows field should be upto 7 digit only");

						}

					}
				}
			}
		} catch (NumberFormatException e2) {
			getMessage("Please enter only numbers");
		} catch (OutOfMemoryError e2) {
			getMessage("Invalid Number of Rows");
		} catch (Exception e2) {
			e2.printStackTrace();
			getMessage("Row Number entered should be Numeric");
		}
	}

	public void addBlankRows(int rowCount, boolean exist_rows) {
		for (int i = 0; i < rowCount; i++) {
			this.getRowCnt = model.getRowCount();
			model.insertRow(this.getRowCnt, new Object[] { "" });
			model.setValueAt("--Select--", this.getRowCnt, 2); // --
			// setting
			// -select- in
			// the drop down
			model.setValueAt("--Select--", this.getRowCnt, 1);
			model.setValueAt("--Select--", this.getRowCnt, 21);
			model.setValueAt("--Select--", this.getRowCnt, 18); // for
			// bookadjustment
//rpu 3.1 start to set default value in challan
			if (valueOfTypeOfStmt.equals("Regular")) {
				model.setValueAt("0.00", this.getRowCnt, 3);
				model.setValueAt("0.00", this.getRowCnt, 4);
				model.setValueAt("0.00", this.getRowCnt, 5);
				model.setValueAt("0.00", this.getRowCnt, 6);
				model.setValueAt("0.00", this.getRowCnt, 7);
				model.setValueAt("0.00", this.getRowCnt, 8);
				model.setValueAt("0.00", this.getRowCnt, 19);
				model.setValueAt("0.00", this.getRowCnt, 20);
				
			}
			
			if (valueOfTypeOfStmt.equals("Correction")) {
				if (exist_rows) {
					model.setValueAt("--Select--", this.getRowCnt, 1);

					count_challan++;

				} else if (!exist_rows) {
					model.setValueAt("ADD", this.getRowCnt, 1);

				}

			}

		}

		/*
		 * int r = 0; // Added By for (int i = 0; i < model.getRowCount(); i++)
		 * {
		 * 
		 * if (i > 1) // Added By to disable first two rows { String p =
		 * String.valueOf(r + 1); model.setValueAt(p, i, 0); // setvalue(value
		 * to be added,row r = r + 1; // number,column number)
		 * 
		 * }
		 * 
		 * }
		 */

		chalnn_getRowCnt = model.getRowCount() - 2;

		//System.out.println("chalnn_getRowCnt rows are " + chalnn_getRowCnt);

		jText_CntofDDOTransnDtls.setEditable(true);
		jText_CntofDDOTransnDtls.setText("0");
		jText_Cur_CntofDDOTransnDtls.setText(Integer.toString(getRowCnt));
		jText_CntofDDOTransnDtls.setEditable(false);

	}

	public void addBlankRows1(int rowCount, int j, boolean annex_insert,
			boolean exist_rows) {

		for (int i = 0; i < rowCount; i++) {
			this.getRowCnt1 = model1.getRowCount();
			model1.insertRow(this.getRowCnt1, new Object[] { "" });
			// added by cholia
			if (valueOfTypeOfStmt.equals("Regular")) {
				model1.setValueAt("--Select--", this.getRowCnt1, 2);
			}
			// newly added by cholia
			final int selYear_sec = Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem()
							.toString().substring(0, 4));
			// newly added by cholia on 11 march 2015
			model1.setValueAt("--Select--", this.getRowCnt1, 6);
			// end newly added by cholia
			model1.setValueAt("--Select--", this.getRowCnt1, 26);
			if (formNumber.equals("26Q") || formNumber.equals("27Q")) {
				model1.setValueAt("--Select--", this.getRowCnt1, 27); // for
				// Deducteecode
				model1.setValueAt("--Select--", this.getRowCnt1, 29); // Added
				// For
				// paid
				// By
				// book
				// entry
				// or
				// not
				//RPU 3.1
				if( formNumber.equals("26Q") && model1.getValueAt(this.getRowCnt1, 2) != null
						&& model1.getValueAt(this.getRowCnt1, 6) != null){
					
					if (model1.getValueAt(this.getRowCnt1, 2).toString().equalsIgnoreCase("UPDATE")
						&& !("94N".equals(model1.getValueAt(this.getRowCnt1, 6).toString()))  )
				{
					System.out.println("set blank values if update and section not 94");
					model1.setValueAt("", this.getRowCnt1, 31);
				}
					}
				
				
				if( formNumber.equals("27Q") && model1.getValueAt(this.getRowCnt1, 2) != null
						&& model1.getValueAt(this.getRowCnt1, 6) != null){
					
					if (model1.getValueAt(this.getRowCnt1, 2).toString().equalsIgnoreCase("UPDATE")
						&& !("94N".equals(model1.getValueAt(this.getRowCnt1, 6).toString()))  )
				{
					System.out.println("set blank values if update and section not 94");
					model1.setValueAt("", this.getRowCnt1, 40);
				}
					}
				//RPU 3.4 add rows set value null if section!=4nf
				if( formNumber.equals("26Q") && model1.getValueAt(this.getRowCnt1, 2) != null
						&& model1.getValueAt(this.getRowCnt1, 6) != null){
					
					if (model1.getValueAt(this.getRowCnt1, 2).toString().equalsIgnoreCase("UPDATE")
						&& !("4NF".equals(model1.getValueAt(this.getRowCnt1, 6).toString()))  )
				{
					System.out.println("set blank values if update and section not 4NF in column 32,33");
					model1.setValueAt("", this.getRowCnt1, 32);
					model1.setValueAt("", this.getRowCnt1, 33);
				}
					}
				if( formNumber.equals("27Q") && model1.getValueAt(this.getRowCnt1, 2) != null
						&& model1.getValueAt(this.getRowCnt1, 6) != null){
					
					if (model1.getValueAt(this.getRowCnt1, 2).toString().equalsIgnoreCase("UPDATE")
						&& !("4NF".equals(model1.getValueAt(this.getRowCnt1, 6).toString()))  )
				{
					System.out.println("set blank values if update and section not 4NF in column 41,42");
					model1.setValueAt("", this.getRowCnt1, 41);
					model1.setValueAt("", this.getRowCnt1, 42);
				}
					}
			}
			if (formNumber.equals("27Q")) {
				model1.setValueAt("--Select--", this.getRowCnt1, 31); // Rate of
				// Tds
				model1.setValueAt("--Select--", this.getRowCnt1, 32); // country
				// resdience
				model1.setValueAt("--Select--", this.getRowCnt1, 34); // Remitance
				// nature
				model1.setValueAt("--Select--", this.getRowCnt1, 35); // Grossing
				// up
				// indicator

			}

			if (formNumber.equals("27EQ")) {
				model1.setValueAt("--Select--", this.getRowCnt1, 27); // party
				// code
				model1.setValueAt("--Select--", this.getRowCnt1, 30); // paid by
				// book
				// entry

				/*****************************************************************************/
				//Added by Sadhana, FRD 2.2
				model1.setValueAt("--Select--", this.getRowCnt1, 32); 
				// Deductee is Non-Resident 
				model1.setValueAt("--Select--", this.getRowCnt1, 33); 
				// Deductee is having  Permanent Resident Establishment
				//RPU 3.5 default value for addition of blank rows
				if(selYear_sec > 2020 || 
						((jComboBox_Quarter.getSelectedItem().equals("Q3")|| 
								jComboBox_Quarter.getSelectedItem().equals("Q4")) 
						&& selYear_sec == 2020))
				model1.setValueAt("--Select--", this.getRowCnt1, 34);  //Whether payment is liable
				 
				/*****************************************************************************/
				
			}
			//RPU 3.1 valueOfTypeOfStmt.equals("Correction") 
			if (formNumber.equals("26Q") )
				if(	!("94N".equals(model1.getValueAt(this.getRowCnt1, 6)))) {
				model1.setValueAt("", this.getRowCnt1, 31); 
			} else if(	!("4NF".equals(model1.getValueAt(this.getRowCnt1, 6)))) {
				System.out.println("Trying add rows option to set value null");//RPU 3.4
				model1.setValueAt("", this.getRowCnt1, 32);
				model1.setValueAt("", this.getRowCnt1, 33); 
			}
			
			if (valueOfTypeOfStmt.equals("Correction") && 
					formNumber.equals("27Q"))
				if	(!("94N".equals(model1.getValueAt(this.getRowCnt1, 6)))) {
					model1.setValueAt("", this.getRowCnt1, 40); 
			}else if(	!("4NF".equals(model1.getValueAt(this.getRowCnt1, 6)))) {//RPU 3.4
				model1.setValueAt("", this.getRowCnt1, 41);
				model1.setValueAt("", this.getRowCnt1, 42); 
			}
				model1.setValueAt("--Select--", this.getRowCnt1, 2);

			if (annex_insert) {
				model1.setValueAt(j, this.getRowCnt1, 1);
				chalnn_getRowCnt1 = model1.getRowCount() - 2;
				//	System.out.println("annex1 rows are " + chalnn_getRowCnt1);
				jCombo_challanSerialNum_actionPerformed(null, null, true, j,
						this.getRowCnt1);
				// s
			}
			if (!annex_insert) {
				model1.setValueAt("--Select--", this.getRowCnt1, 1);// For
				// challan
			}

			if (valueOfTypeOfStmt.equals("Correction")) {
				if (exist_rows) {
					model1.setValueAt("--Select--", this.getRowCnt1, 2);
					//System.out.println("Model column2 value: "+ model1.getValueAt(this.getRowCnt1, 2).toString());
					count_annex1++;

				} else if (!exist_rows) {
					strAnnexIColValue += "O";
					model1.setValueAt("ADD", this.getRowCnt1, 2);

				}

			}

		}
		/*
		 * int r = 0; // Added By for (int i = 0; i < model1.getRowCount(); i++)
		 * {
		 * 
		 * if (i > 1) // Added By to disable first two rows { String p =
		 * String.valueOf(r + 1); model1.setValueAt(p, i, 0); // setvalue(value
		 * to be added,row r = r + 1; // number,column number)
		 * 
		 * }
		 * 
		 * }
		 */

		int getRowCnt1 = model1.getRowCount();
		// counting the number of rows
		chalnn_getRowCnt1 = model1.getRowCount() - 2;
		// end

	} // khtam

	// method to add blank rows
	public void addBlankRows2(int rowCount, boolean exist_flag) {
		for (int i = 0; i < rowCount; i++) {
			this.getRowCnt2 = model2.getRowCount();
			model2.insertRow(this.getRowCnt2, new Object[] { "" });
			if (valueOfTypeOfStmt.equals("Regular"))
				model2.setValueAt("--Select--", this.getRowCnt2, 2);
			// end cholia
			model2.setValueAt("--Select--", this.getRowCnt2, 5); // default
			// select
			// for the
			// deductee
			// type
			model2.setValueAt("--Select--", this.getRowCnt2, 32); // default
			// selet for
			// column 31

			//newly added for FRD1.6 by akansha
			model2.setValueAt("--Select--", this.getRowCnt2, 33); // default

			model2.setValueAt("--Select--", this.getRowCnt2, 34);
			model2.setValueAt("--Select--", this.getRowCnt2, 36);
			model2.setValueAt("--Select--", this.getRowCnt2, 38);
			model2.setValueAt("--Select--", this.getRowCnt2, 40);

			model2.setValueAt("--Select--",this.getRowCnt2, 42);

			model2.setValueAt("--Select--", this.getRowCnt2, 43);
			model2.setValueAt("--Select--", this.getRowCnt2, 45);
			model2.setValueAt("--Select--", this.getRowCnt2, 47);
			model2.setValueAt("--Select--", this.getRowCnt2, 49);


			//newly added for revised FRD1.6 by akansha
			model2.setValueAt("--Select--",this.getRowCnt2, 51);
			model2.setValueAt("--Select--",this.getRowCnt2, 93);  //RPU 3.7 Addition of new column rahul

			//set for column 32
			//************************************************

			if (valueOfTypeOfStmt.equals("Correction")) {
				if (exist_flag) // added by cholia for default values
				{
					model2.setValueAt("--Select--", this.getRowCnt2, 2);
					count_annex2++;

				} else if (!exist_flag) {
					strAnnexIIColValue += "A";
					System.out.println("value of strAnnexIIColValue = "+strAnnexIIColValue);
					model2.setValueAt("Add", this.getRowCnt2, 2);
				}
			}

		}
		/*
		 * int r = 0; // Added By for (int i = 0; i < model2.getRowCount(); i++)
		 * {
		 * 
		 * if (i > 1) // Added By to disable first two rows { String p =
		 * String.valueOf(r + 1); //newly added by cholia for first row
		 * model2.setValueAt(p, i, 0); // setvalue(value to be added,row
		 * model2.setValueAt(p, i, 1); // For serial Number // // number,column
		 * number) r = r + 1;
		 * 
		 * }
		 * 
		 * }
		 */
		int getRowCnt2 = model2.getRowCount();

	}

	private void addKeySelectionToDropDown() {
		final MyComboBoxEditor stateDropDown = new MyComboBoxEditor(stateName);
		stateDropDown.getComponent().setBackground(Color.white);
		((JComboBox) stateDropDown.getComponent())
		.addAncestorListener(new AncestorListener() {

			public void ancestorAdded(AncestorEvent event) {
				// make sure combobox handles key events
				((JComboBox) stateDropDown.getComponent())
				.requestFocusInWindow();

			}

			public void ancestorMoved(AncestorEvent event) {

			}

			public void ancestorRemoved(AncestorEvent event) {
			}

		});

		colState.setCellEditor(stateDropDown);

		colNatureOfDeduction = jTableTransacDetails.getColumnModel().getColumn(
				23);
		final MyComboBoxEditor natureOfDedDropDown = new MyComboBoxEditor(
				jComboBox_NtrOfDedtn);
		natureOfDedDropDown.getComponent().setBackground(Color.white);

		((JComboBox) natureOfDedDropDown.getComponent())
		.addAncestorListener(new AncestorListener() {

			public void ancestorAdded(AncestorEvent event) {
				// make sure combobox handles key events
				((JComboBox) natureOfDedDropDown.getComponent())
				.requestFocusInWindow();

			}

			public void ancestorMoved(AncestorEvent event) {

			}

			public void ancestorRemoved(AncestorEvent event) {
			}

		});

		// amit here

		ddoMappingFlag = jTableTransacDetails.getColumnModel().getColumn(24);
		final MyComboBoxEditor ddoMappingDropDown = new MyComboBoxEditor(
				ddoMappingModes);
		ddoMappingDropDown.getComponent().setBackground(Color.white);

		((JComboBox) ddoMappingDropDown.getComponent())
		.addAncestorListener(new AncestorListener() {

			public void ancestorAdded(AncestorEvent event) {
				// make sure combobox handles key events
				((JComboBox) ddoMappingDropDown.getComponent())
				.requestFocusInWindow();

			}

			public void ancestorMoved(AncestorEvent event) {

			}

			public void ancestorRemoved(AncestorEvent event) {
			}

		});

		ddoMappingFlag.setCellEditor(ddoMappingDropDown);

	}

	public void jButton_insertRow_actionPerformed(ActionEvent e) {
		//	System.out.println("--AKA--"+formNumber);
		final String[] insert_array = new String[2];
		if(!"27EQ".equals(formNumber))
		{
			//	insert_array[0] = "<html><div style='height:20px'>Row Number<br></div></html>"; //Newly commented for ver1.3 by Akansha
			insert_array[0] = "<html><div style='height:20px'>Challan Number<br></div></html>";
			insert_array[1] = "<html><div style='height:20px'>No of deductee records <br> to be added</div></html>";
		}
		else
		{
			//insert_array[0] = "<html><div style='height:20px'>Row Number<br></div></html>";//Newly commented for ver1.3 by Akansha
			insert_array[0] = "<html><div style='height:20px'>Challan Number<br></div></html>";
			insert_array[1] = "<html><div style='height:20px'>No. of Collectee records <br>to be added</div></html>";
		}

		model_insert = new DefaultTableModel() {


			@Override
			public boolean isCellEditable(int rowIndex, int mColIndex) {
				if (mColIndex == 0) { //Newly removed mColIndex == 1 for ver1.3 added by Akansha
					return false;
				} else
					return true;

			}

			public int getColumnCount() {
				return insert_array.length;
			}

			@Override
			public String getColumnName(int index) {
				return insert_array[index];
			}
		};

		// add(new JScrollPane(table));

		// End button
		// Added by Akansha
		// For making popup as utility type

		frame_insert.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent arg0) {

			}

			public void windowClosed(WindowEvent arg0) {
				frame_insert.setDefaultCloseOperation(DISPOSE_ON_CLOSE);

			}
		});
		// **********************************
		panel_insert.removeAll();
		panel_insert.setLayout(new BorderLayout());
		table_insert = new JTable(model_insert);
		table_insert
		.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
		// neetu
		//New dev for ver1.3 added by Akansha
		DefaultTableCellRenderer rightRenderer = new DefaultTableCellRenderer();
		rightRenderer.setHorizontalAlignment(SwingConstants.CENTER);
		table_insert.getColumnModel().getColumn(1).setCellRenderer(rightRenderer);
		table_insert.getColumnModel().getColumn(0).setCellRenderer(rightRenderer);
		table_insert.setRowSelectionAllowed(false); 
		//***************************************************************
		table_insert.getColumnModel().getColumn(1)
		.setCellEditor(new GRPUTableCellEditorInsertValidation()); //New dev for ver1.3 added by Akansha
		// end
		addBlankRows_insert_row(chalnn_getRowCnt, model_insert);
		JScrollPane tableContainer = new JScrollPane(table_insert);
		panel_insert.add(tableContainer, BorderLayout.CENTER);
		// add button

		// end cholia
		JButton_pannel.add(button_ok);

		JButton_pannel.add(button_cancel);
		panel_insert.add(JButton_pannel, BorderLayout.SOUTH);
		// frame_insert.setType(Type.UTILITY);
		frame_insert.getContentPane().add(panel_insert);
		frame_insert.setIconImage(GrpuUtil.GRPULogo); // new development for FRD1.3 by Akansha
		//New dev for ver1.3 added by Akansha
		frame_insert.getRootPane().setDefaultButton(button_ok); // Added for listening 'Enter' key event
		//New dev for ver1.3 added by Akansha
		frame_insert.getRootPane().getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(
				KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), "Cancel"); 
		frame_insert.getRootPane().getActionMap().put("Cancel", new AbstractAction(){ 
			public void actionPerformed(ActionEvent e)
			{
				frame_insert.dispose();
			}
		});


		//**************
		frame_insert.setSize(400, 268);
		//frame_insert.pack();
		frame_insert.setLocationRelativeTo(mainObject.contentPanel); 
		frame_insert.setVisible(true);
	}

	private void addBlankRows_insert_row(int chalnn_getRowCnt,
			DefaultTableModel model_insert) {

		for (int i = 0; i < chalnn_getRowCnt; i++) {
			int getRowCnt = model_insert.getRowCount();
			model_insert.insertRow(getRowCnt, new Object[] { "" });

		}

		int r = 0; // Added By
		for (int i = 0; i < model_insert.getRowCount(); i++) {

			String p = String.valueOf(i + 1);
			model_insert.setValueAt(p, i, 0); // setvalue(value to be//
			// added,row// number,column//
			// number)
			//model_insert.setValueAt(p, i, 1); //New dev for ver1.3 added by Akansha

		}

	}

	// End here

	public void messageDialog() {
		// Added on 09/07/2015 ---- R&D by Akansha
		addrow = new JTextField();
		String message = "Enter the Row Number to be deleted : ";
		JPanel pnl = new JPanel();
		pnl.add(new JLabel("Enter the number of rows to be deleted: "));
		pnl.add(addrow);

		String text = JOptionPane.showInputDialog(pnl, message, "Delete Rows",
				JOptionPane.QUESTION_MESSAGE);
		//System.out.println("The Akki input: " + text);

		// *******************************************************
	}

	private void jButton_delRow_actionPerformed(ActionEvent e) {
		try {
			//new development for FRD1.3 by Akansha
			int record_annI =0, tempAnnI=1;
			String challan_no ="";
			//******************************
			selTAB = TabGRPU.getSelectedIndex();
			//System.out.println("seltab that is selected is " + selTAB);

			if (jTableTransacDetails.isEditing()
					&& jTableTransacDetails.getEditingRow() >= 0)
				jTableTransacDetails.editCellAt(0, 0);

			if (selTAB == DDO_TAB_INDEX)
				getRowCnt = model.getRowCount();

			else if (selTAB == ANNE_TAB_INDEX)
				getRowCnt1 = model1.getRowCount(); // added By for annex1

			else if (selTAB == ANNE2_TAB_INDEX)
				getRowCnt2 = model2.getRowCount(); // added By for annex2

			if (getRowCnt != 0 && TabGRPU.getSelectedIndex() == DDO_TAB_INDEX) {
				int i = 0;
				int count = 0;

				// Added on 09/07/2015 ---- R&D by Akansha

				String message = "Enter the Row Number to be deleted : ";
				JPanel pnl = new JPanel();
				pnl.add(new JLabel("Enter the number of rows to be deleted: "));
				pnl.add(addrow);

				// String text =
				// JOptionPane.showInputDialog(pnl,message,"Delete Rows",JOptionPane.QUESTION_MESSAGE);
				//R&D development code by Akansha

				String text = mainObject.createCustomDialogPopup();
				System.out.println("Row number entered to be deleted: "+text);
				String temp[] = text.split(",");
				// *****************************************************
				//	System.out.println("The Akki input: " + temp[0]+" "+temp[1]);

				// String message = "Enter the Row Number to be deleted : ";
				// String text = JOptionPane.showInputDialog(JdialogFrame,
				// message, "Delete Rows", JOptionPane.QUESTION_MESSAGE);
				if ("OK".equals(temp[1].toString())) {
					if (temp[0] != null) {
						if (temp[0].length() > 5) {
							getMessage("Length of the Row number to be deleted can not exceed 5 digits");
						} else {
							//	System.out.println("the row count is " + getRowCnt);
							int text1 = Integer.parseInt(temp[0]);

							if (text1 < 0) {
								message = " Row Number cannot be negative";
								JOptionPane.showMessageDialog(JdialogFrame,
										message);
							} else if (text1 == 0) {
								message = "Please enter a value greater than 0";
								JOptionPane.showMessageDialog(JdialogFrame,
										message);
							}

							// System.out.println("the row count is " +
							// getRowCnt);
							else if (getRowCnt > 2 && (text1 + 2 <= getRowCnt)) // delete
								// only
								// last
								// row
							{
								if (text1 + 2 == getRowCnt) {
									for (i = 2; i < model1.getRowCount(); i++) {
										int ChallanSrNo = -1;
										Object ChallanSrNoObj = model1
												.getValueAt(i, 1);
										if (ChallanSrNoObj != null)
											ChallanSrNo = Integer
											.parseInt(ChallanSrNoObj
													.toString());

										if (ChallanSrNo == text1) {
											count++;
											break;

										}

									}

									if (count > 0) {
										getMessage("Delete all related deductees before deleting the challan");
									} else {
										model.removeRow(text1 + 1); // --
										getRowCnt--;
										chalnn_getRowCnt--;

									}

								} else {
									getMessage("Only Last Challan can be deleted");

								}

							} else {
								getMessage("Row to be deleted should be less than the number of rows");// added

							}

							// To change the serial

						}

					}
				}

			}
			// added for annex1
			else if (getRowCnt1 != 0
					&& TabGRPU.getSelectedIndex() == ANNE_TAB_INDEX) {

				String message = "Enter the Row Number to be deleted: ";
				//				String text = JOptionPane.showInputDialog(JdialogFrame,
				//						message, "Delete Rows", JOptionPane.QUESTION_MESSAGE);

				//R&D development code by Akansha
				String text = mainObject.createCustomDialogPopup();
				String temp[] = text.split(",");
				// *****************************************************
				//	System.out.println("The Akki input AnneI: " + temp[0]+" "+temp[1]);

				if ("OK".equals(temp[1].toString())) {
					if (temp[0] != null) {

						if (temp[0].length() > 7) {
							getMessage("Length of the Row number to be deleted can not exceed 7 digits"); // newly
							// changed
							// by
							// cholia
						} else {
							int text1 = Integer.parseInt(temp[0]);
							//	System.out.println("Text1 value: "+ text1);
							record_annI = (text1);//since row starts from 0
							if (text1 < 0) {
								message = " Row Number cannot be negative";
								JOptionPane.showMessageDialog(JdialogFrame,
										message);
							} else if (text1 == 0) {
								message = "Please enter a value greater than 0";
								JOptionPane.showMessageDialog(JdialogFrame,
										message);
							}

							// added by cholia to disable the deletion of the
							// imported
							// rows

							//	System.out.println("the count is inside delete rows " + count_annex1);
							if (valueOfTypeOfStmt.equals("Correction")
									&& (text1 <= count_annex1)
									&& text1 <= getRowCnt1 && text1 > 0) {
								message = "You can not delete rows upto "
										+ count_annex1;
								JOptionPane.showMessageDialog(JdialogFrame,
										message);

							} else if (text1 > 0
									&& text1 + 2 <= getRowCnt1
									&& ((text1 > count_annex1 && valueOfTypeOfStmt
											.equals("Correction")) || valueOfTypeOfStmt
											.equals("Regular"))) {
								if (getRowCnt1 > 2 && (text1 + 1 < getRowCnt1)) {
									if ("Correction".equals(valueOfTypeOfStmt)){
										record_annI++;
										challan_no = model1.getValueAt(record_annI, 1).toString();
										//System.out.println("Record of AnneI: "+ record_annI + "Challan no: "+challan_no);
										//new development for FRD1.5 by akansha
										if(annexIcount!=null && !annexIcount.isEmpty() && !"".equals(challan_no)&& !(annexIcount.size()<=Integer.parseInt(challan_no)))
											tempAnnI=Integer.parseInt(annexIcount.get(Integer.parseInt(challan_no)));
										//System.out.println("Challan deleted: "+ challan_no);
									}

									model1.removeRow(text1 + 1); // --
									getRowCnt1--;
									chalnn_getRowCnt1--; // newly added by
									// cholia
									// for serial number
									// issue

									//new development for FRD1.3 by Akansha
									//added inorder to maintain the sequence number
									if("Regular".equals(valueOfTypeOfStmt))
										sortMethod(null, true); 

									//*****************************************

								}
							} else
								getMessage("Row to be deleted should be less than the number of rows");// added

						}
					}
				}
			}

			// added for annex2

			else if (getRowCnt2 != 0
					&& TabGRPU.getSelectedIndex() == ANNE2_TAB_INDEX) {

				String message = "Enter the Row Number to be deleted: ";
				//				String text = JOptionPane.showInputDialog(JdialogFrame,
				//						message, "Delete Rows", JOptionPane.QUESTION_MESSAGE);

				//R&D development code by Akansha
				String text = mainObject.createCustomDialogPopup();
				String temp[] = text.split(",");
				// *****************************************************
				//	System.out.println("The Akki input AnneII: " + temp[0]+" "+temp[1]);



				if ("OK".equals(temp[1].toString())) {
					if (temp[0] != null) {
						if (temp[0].length() > 7) { // new development for FRD1.3 by Akansha
							getMessage("Length of the Row number to be deleted can not exceed 7 digits"); // newlychanged
							// by
							// cholia
						}

						else {
							int text1 = Integer.parseInt(temp[0]);

							if (text1 < 0) {
								message = " Row Number cannot be negative";
								JOptionPane.showMessageDialog(JdialogFrame,
										message);
							}
							if (text1 == 0) {
								message = "Please enter a value greater than 0";
								JOptionPane.showMessageDialog(JdialogFrame,
										message);
							}

							if (valueOfTypeOfStmt.equals("Correction")
									&& (text1 <= count_annex2)
									&& text1 <= getRowCnt2 && text1 > 0) {
								/*
								 * message = "You can not delete rows upto " +
								 * count_annex2;
								 */
								message = "You can not delete the salary details which has been imported";
								JOptionPane.showMessageDialog(JdialogFrame,
										message);

							} else if (text1 > 0
									&& text1 + 2 <= getRowCnt2
									&& ((text1 > count_annex2 && valueOfTypeOfStmt
											.equals("Correction")) || valueOfTypeOfStmt
											.equals("Regular"))) {
								if (getRowCnt2 > 2 && (text1 + 1 < getRowCnt2)) {
									model2.removeRow(text1 + 1); //
									getRowCnt2--;

								}
							} else
								getMessage("Row to be deleted should be less than the number of rows");// addded
							// for
							// anexure 2

							jText_CntofDDOTransnDtls.setText(Integer
									.toString(numberOfTd));
							jText_CntofDDOTransnDtls.setEditable(false);
							setErrorAt(-1, -1);

						}
					}
				}
			}

			else {
				String message = "There are no rows to delete";
				JOptionPane.showMessageDialog(JdialogFrame, message);
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
			}

			if (selTAB == DDO_TAB_INDEX) {
				//				System.out.println("setting rows for challan row count"
				//						+ getRowCnt);

				int r = 0;// Added By
				for (int i = 0; i < getRowCnt; i++) {
					/*
					 * String p = String.valueOf(i + 1); //Akansha add here
					 * 
					 * model.setValueAt(p, i, 0); model.setValueAt("1", i, 1);
					 */
					if (i > 1) // Added By to disable first two rows
					{
						String p = String.valueOf(r + 1);
						model.setValueAt(p, i, 0); // setvalue(value to be
						// added,row

						r = r + 1; // number,column number)

					}

				}
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
			}

			else if (selTAB == ANNE_TAB_INDEX) {
				//	System.out.println("show row count" + getRowCnt1);

				if ("Regular".equals(valueOfTypeOfStmt)) {
					int r = 0;// Added By
					for (int i = 0; i < getRowCnt1; i++) {
						if (i > 1) // Added By to disable first two rows
						{
							String p = String.valueOf(r + 1);
							model1.setValueAt(p, i, 0); // setvalue(value to be
							// added,row
							r = r + 1; // number,column number)

						}

					}
				}
				//new development for FRD1.3 by akansha
				else if("Correction".equals(valueOfTypeOfStmt)){

					int r = 0,r1=0;// Added By
					String p="",p1="";

					//					System.out.println("Challan no: "+ challan_no + " AnnexI count : "+tempAnnI);
					//					System.out.println("Temp value of Anne1: "+tempAnnI);

					//if("Import".equals(method))
					r1=tempAnnI;

					//	System.out.println("Value of R1: "+ r1);
					for (int i = 0; i < getRowCnt1; i++) {

						if (i > 1) // Added By to disable first two rows
						{

							p = String.valueOf(r + 1);
							p1 = String.valueOf(r1);
							model1.setValueAt(p, i, 0); // setvalue(value to be
							// added,row

							r = r + 1; // number,column number)



						}
						if("ADD".equals(model1.getValueAt(i,2)) && ((Integer.parseInt(challan_no)) == (Integer.parseInt(model1.getValueAt(i,1).toString())) )){
							model1.setValueAt(p1, i, 11); // for serial number
							//	System.out.println("In for match of challan: "+ r1);
							r1++;
						}

					}

				}
				//*****************************************************
				TabGRPU.setSelectedIndex(ANNE_TAB_INDEX);
			}

			else if (selTAB == ANNE2_TAB_INDEX) {
				//	System.out.println("inside setting row in annex2");

				if ("Regular".equals(valueOfTypeOfStmt)) {

					int r = 0;// Added By

					// System.out.println("getting the row number :" +
					// getRowCnt);
					for (int i = 0; i < getRowCnt2; i++) {

						if (i > 1) // Added By to disable first two rows
						{
							String p = String.valueOf(r + 1);
							model2.setValueAt(p, i, 0); // setvalue(value to be
							// added,row
							model2.setValueAt(p, i, 1); // for serial number
							r = r + 1; // number,column number)

						}

					}
				}else if("Correction".equals(valueOfTypeOfStmt)){


					int r = 0,r1=1;// Added By
					int temp=Integer.parseInt(annexIIcount);
					//	System.out.println("Temp value of Anne2: "+temp);
					//new development for FRD1.3 by Akansha
					/*for(int i=2;i<getRowCnt2;i++){
						if("Add".equals(model2.getValueAt(i, 2).toString())){
							System.out.println("Value of temp: "+temp+" and value of model2: "+ model2.getValueAt(i, 1)
									.toString());
							if (model2.getValueAt(i, 1) != null
									&& !model2.getValueAt(i, 1).toString()
											.equalsIgnoreCase("")) {
								if (temp > Integer.parseInt(model2.getValueAt(i, 1)
										.toString())) {

									temp = Integer.parseInt(model2.getValueAt(i, 1)
											.toString());
								}
							}
						}
					}*/
					//*************************************

					// System.out.println("getting the row number :" +
					// getRowCnt);
					//if("Import".equals(method))
					r1=temp;
					for (int i = 0; i < getRowCnt2; i++) {

						if (i > 1) // Added By to disable first two rows
						{

							String p = String.valueOf(r + 1);
							String p1 = String.valueOf(r1);
							model2.setValueAt(p, i, 0); // setvalue(value to be
							// added,row
							if("Add".equals(model2.getValueAt(i,2))){
								model2.setValueAt(p1, i, 1); // for serial number
								r1++;
							}r = r + 1; // number,column number)



						}

					}

				}
				TabGRPU.setSelectedIndex(ANNE2_TAB_INDEX);
			}

		} catch (NumberFormatException e2) {
			{
				System.out.println(e2.getStackTrace());
				System.out.println(e2.getMessage());
				getMessage("Invalid Number of Rows");
				e2.printStackTrace();
			}
		} catch (Exception e1) {

			// System.out.println(e1.printStackTrace());
			e1.printStackTrace();
			System.out.println("message is" + e1.getMessage());
			// TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
		}
	}

	private void setValuesOnBack() {
		int reply = JOptionPane
				.showConfirmDialog(
						null,
						"The information you have entered will be lost, click \"Yes\" to continue",
						"Message", JOptionPane.YES_NO_OPTION);
		if (reply == JOptionPane.YES_OPTION) {
			mainObject.setVisible(true);
			mainObject.jComboBox_FormNumber.setEditable(false);
			mainObject.resetAllFields();
			this.setVisible(false);
			grpu = null;
			mainObject.openflag = false; // new development for FRD1.3 by Akansha
			new Validations().savedfilepath = "";

			//new development for FRD1.5 by akansha
			//Added for resolving the quarter issue
			method = "";
			//************************************

			//new development for FRD1.3 by Akansha
			challantype = "";
			pancheckfag = "";
			mainObject.filename = "";
			//new development for FRD1.5 by Akansha
			pancheckfagAnne2 = "";

			if(mainObject.txtErrorFilePath!=null)
				mainObject.txtErrorFilePath.setText("");
			if(mainObject.consFileName!=null)
				mainObject.consFileName.setText("");
			if(mainObject.txtCINFileName!=null)
				mainObject.txtCINFileName.setText("");
			//***********************************
		} else {
			this.setVisible(true);
		}
		//newly added for fRD1.5 by akansha
		mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

	private void jButton_back_actionPerformed(ActionEvent e) {

		try {
			int rowFocused = jTableTransacDetails.getSelectedRow();
			int colFocused = jTableTransacDetails.getSelectedColumn();
			if (rowFocused != -1
					&& colFocused != -1
					&& (jTableTransacDetails.isEditing() || jTableTransacDetails
							.isCellSelected(rowFocused, colFocused)))
				ddoValuesChanged = true;
			if (checkAODetails()
					&& actualRowsFilled(GrpuUtil.getFilledRows(model)) == 0
					&& !ddoValuesChanged)
				setValuesOnBack();
			else if (!isOpened && !fileCreated) {
				if (checkAODetails()
						&& actualRowsFilled(GrpuUtil.getFilledRows(model)) == 0
						&& !ddoValuesChanged)
					setValuesOnBack();
				else if (fileSaveAs || fileSaved) {
					if (checkAODetails() && !ddoValuesChanged) {
						setValuesOnBack();
					} else {
						//						System.out.println("Value Of NAMe*****"
						//								+ GRPU.selectedFile);
						//	System.out.println("Value of filename" + GRPU.fileName);
						if (getFileName(GRPU.selectedFile.getName(),
								GRPU.selectedFile) == GRPU.fileName)
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.fileName + "?";
						else
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.selectedFile.getName() + "?";
						int answer = JOptionPane.showConfirmDialog(
								GRPU.JdialogFrame, exitMessage);
						if (answer == 0) {
							int dataAdd[] = GrpuUtil.getFilledRows(model);
							if (getFileName(GRPU.selectedFile.getName(),
									GRPU.selectedFile) == GRPU.fileName) {
								// writeFile(GRPU.path + "/" + GRPU.fileName +
								// "",
								// "S", dataAdd);
								savefile();

								setValuesOnBack();
							} else {
								// writeFile(GRPU.selectedFile.getAbsolutePath(),
								// "S", dataAdd);
								savefile();

								setValuesOnBack();
							}
						} else if (answer == 1)
							setValuesOnBack();
					}
				} else if (!fileSaveAs || !fileSaved) {
					//System.out.println("inside File Saved");
					exitMessage = "Do you want to save the changes you made?";
					int answer = JOptionPane.showConfirmDialog(
							GRPU.JdialogFrame, exitMessage);
					if (answer == 0) {
						File fileNameToSave = funSaveDialogBoxGRPU();
						if (fileNameToSave != null)
							if (fileNameToSave.getName().toLowerCase()
									.endsWith(".txt"))
								getMessage("Invalid File Name");
							else if (!fileNameToSave.getName().toLowerCase()
									.endsWith("")
									&& !fileNameToSave.getName().toLowerCase()
									.endsWith(""))
								getMessage("Invalid File Name");
							else if (!fileNameToSave.getName().toLowerCase()
									.endsWith("")
									&& fileNameToSave.getName().toLowerCase()
									.length() > GRPUConstants.FILE_LEN_GRPU)
								getMessage("Invalid length of filename. \nFilename cannot be more than "
										+ GRPUConstants.FILE_LEN_GRPU
										+ " characters");
							else if (fileNameToSave.getName().toLowerCase()
									.length()
									- GRPUConstants.FILE_EXTN_LEN_GRPU > GRPUConstants.FILE_LEN_GRPU)
								getMessage("Invalid length of filename. \nFilename cannot be more than "
										+ GRPUConstants.FILE_LEN_GRPU
										+ " characters");
							else if (!checkFileName(fileNameToSave.getName()))
								getMessage("Invalid File Name.\n  :  /  ?  >  <  *  \"  |  \\  ^  _ or Space, not allowed in File Name.");
							else if (fileNameToSave.getAbsoluteFile().exists()) {
								String msg = fileNameToSave.getName()
										+ " already exists. Do you want to replace the existing file?";
								int userResponse = JOptionPane
										.showConfirmDialog(GRPU.JdialogFrame,
												msg);
								if (userResponse == 0) {
									int data[] = GrpuUtil.getFilledRows(model);
									if (getFileName(fileNameToSave.getName(),
											fileNameToSave) == GRPU.fileName) {
										// writeFile(GRPU.path + "\\"
										// + GRPU.fileName + "", "S", data);
										savefile();

									} else {
										// writeFile(fileNameToSave
										// .getAbsolutePath()
										// + "", "S", data);
										savefile();

									}
									setValuesOnBack();
								}
							} else {
								int data[] = GrpuUtil.getFilledRows(model);
								if (getFileName(fileNameToSave.getName(),
										fileNameToSave) == GRPU.fileName) {
									// writeFile(GRPU.path + "\\" +
									// GRPU.fileName
									// + "", "S", data);
									savefile();

								} else {
									// writeFile(fileNameToSave.getAbsolutePath()
									// + "", "S", data);
									savefile();

								}
								setValuesOnBack();
							}
					} else if (answer == 1)
						setValuesOnBack();
				}
			} else if (fileCreated && !isOpened) {
				if (checkAODetails() && !jTableTransacDetails.isEditing()
						&& !ddoValuesChanged)
					setValuesOnBack();
				else if (!fileSaveAs && !fileSaved) {

					if (getFileName(GRPU.createdFile.getName(),
							GRPU.createdFile) == GRPU.fileName)
						exitMessage = "Do you want to save the changes you made to "
								+ GRPU.fileName + "?";
					else
						exitMessage = "Do you want to save the changes you made to "
								+ GRPU.createdFile.getName() + "?";
					int answer = JOptionPane.showConfirmDialog(
							GRPU.JdialogFrame, exitMessage);
					if (answer == 0) {
						int newdataAdded[] = GrpuUtil.getFilledRows(model);
						if (getFileName(GRPU.createdFile.getName(),
								GRPU.createdFile) == GRPU.fileName) {
							// writeFile(GRPU.path + "\\" + GRPU.fileName + "",
							// "S", newdataAdded);
							savefile();

						} else {
							// writeFile(GRPU.createdFile.getAbsolutePath() +
							// "",
							// "S", newdataAdded);
							savefile();

						}
						setValuesOnBack();
					} else if (answer == 1)
						setValuesOnBack();
				} else if (fileSaveAs || fileSaved) {
					if (checkAODetails() && !ddoValuesChanged)
						setValuesOnBack();
					else if (getFileName(GRPU.selectedFile.getName(),
							GRPU.selectedFile) == GRPU.fileName)
						exitMessage = "Do you want to save the changes you made to "
								+ GRPU.fileName + "?";
					else
						exitMessage = "Do you want to save the changes you made to "
								+ GRPU.selectedFile.getName() + "?";
					int answer = JOptionPane.showConfirmDialog(
							GRPU.JdialogFrame, exitMessage);
					if (answer == 0) {
						int newdataAdded[] = GrpuUtil.getFilledRows(model);
						if (getFileName(GRPU.selectedFile.getName(),
								GRPU.selectedFile) == GRPU.fileName) {
							// writeFile(GRPU.path + "\\" + GRPU.fileName + "",
							// "S", newdataAdded);
							savefile();

						} else {
							// writeFile(GRPU.selectedFile.getAbsolutePath() +
							// "",
							// "S", newdataAdded);
							savefile();

						}
						setValuesOnBack();
					} else if (answer == 1)
						setValuesOnBack();
				}
			} else if (isOpened && fileCreated) {
				if (getFileName(GRPU.selectedFile.getName(), GRPU.selectedFile) == GRPU.fileName)
					exitMessage = "Do you want to save the changes you made to "
							+ GRPU.fileName + "?";
				else
					exitMessage = "Do you want to save the changes you made to "
							+ GRPU.selectedFile.getName() + "?";
				int answer = JOptionPane.showConfirmDialog(GRPU.JdialogFrame,
						exitMessage);
				if (answer == 0) {
					int newdataAdded[] = GrpuUtil.getFilledRows(model);
					if (getFileName(GRPU.selectedFile.getName(),
							GRPU.selectedFile) == GRPU.fileName) {
						// writeFile(GRPU.path + "\\" + GRPU.fileName + "", "S",
						// newdataAdded);
						savefile();

					} else {
						// writeFile(GRPU.selectedFile.getAbsolutePath() + "",
						// "S", newdataAdded);
						savefile();

					}
					setValuesOnBack();
				} else if (answer == 1)
					setValuesOnBack();
			} else if (isOpened)
				try {
					if (checkAODetails() && !jTableTransacDetails.isEditing()
							&& !ddoValuesChanged)
						setValuesOnBack();
					else if (fileSaveAs || fileSaved) {
						if (checkAODetails() && !ddoValuesChanged)
							setValuesOnBack();
						else if (!checkAODetails() || ddoValuesChanged) {
							if (getFileName(GRPU.selectedFile.getName(),
									GRPU.selectedFile) == GRPU.fileName)
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.fileName + "?";
							else
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.selectedFile.getName() + "?";
							int answer = JOptionPane.showConfirmDialog(
									GRPU.JdialogFrame, exitMessage);
							if (answer == 0) {
								int newdataAdded[] = GrpuUtil
										.getFilledRows(model);
								if (getFileName(GRPU.selectedFile.getName(),
										GRPU.selectedFile) == GRPU.fileName) {
									// writeFile(GRPU.path + "\\" +
									// GRPU.fileName
									// + "", "S", newdataAdded);
									savefile();

									setValuesOnBack();
								} else {
									// writeFile(GRPU.selectedFile
									// .getAbsolutePath()
									// + "", "S", newdataAdded);
									savefile();

									setValuesOnBack();
								}
							} else if (answer == 1)
								setValuesOnBack();
						}
					} else if (!fileSaveAs || !fileSaved)
						if (checkAODetails() && !ddoValuesChanged)
							setValuesOnBack();
						else if (!checkAODetails() || ddoValuesChanged) {
							if (getFileName(GRPU.selectedFile.getName(),
									GRPU.selectedFile) == GRPU.fileName)
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.fileName + "?";
							else
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.selectedFile.getName() + "?";
							int answer = JOptionPane.showConfirmDialog(
									GRPU.JdialogFrame, exitMessage);
							if (answer == 0) {
								int newdataAdded[] = GrpuUtil
										.getFilledRows(model);
								if (getFileName(GRPU.selectedFile.getName(),
										GRPU.selectedFile) == GRPU.fileName) {
									// writeFile(GRPU.path + "/" + GRPU.fileName
									// + "", "S", newdataAdded);
									savefile();

									setValuesOnBack();
								} else {
									// writeFile(GRPU.selectedFile
									// .getAbsolutePath()
									// + ".grpu", "S", newdataAdded);
									savefile();

									setValuesOnBack();
								}
							} else if (answer == 1)
								setValuesOnBack();
						}
				} catch (Exception e1) {
					setValuesOnBack();
					e1.printStackTrace();
				}

		} catch (Exception ee) {
			setValuesOnBack();
			ee.printStackTrace();
		}

		return;

	}


	//newly developed for FRD1.5 by akansha
	private void jButton_importexcel_actionPerformed(ActionEvent e) {

		if(!"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())				
				&& !"--Select--".equals(jComboBox_Quarter.getSelectedItem().toString()))
			GrpuUtil.excelfileupload(this);
		else if("--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				&& !"--Select--".equals(jComboBox_Quarter.getSelectedItem().toString())){
			JOptionPane.showMessageDialog(null,"Please select financial year before importing the excel");
		}else if(!"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				&& "--Select--".equals(jComboBox_Quarter.getSelectedItem().toString())){
			JOptionPane.showMessageDialog(null,"Please select quarter before importing the excel");
		}else if("--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				&& "--Select--".equals(jComboBox_Quarter.getSelectedItem().toString())){
			JOptionPane.showMessageDialog(null,"Please select financial year and quarter before importing the excel");
		}

	}
	//newly developed for downloading the excel templates for uploading of the excel
	public void jButton_gotoexcel_actionPerformed(ActionEvent e) {
		GrpuUtil gu = new GrpuUtil();
		if(!"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())				
				&& !"--Select--".equals(jComboBox_Quarter.getSelectedItem().toString()))
			gu.excelfiledownload(formNumber,JComboBox_Form_Sub1_finYear.getSelectedItem().toString());
		else if("--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				&& !"--Select--".equals(jComboBox_Quarter.getSelectedItem().toString())){
			JOptionPane.showMessageDialog(null,"Please select financial year before downloading the excel");
		}else if(!"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				&& "--Select--".equals(jComboBox_Quarter.getSelectedItem().toString())){
			JOptionPane.showMessageDialog(null,"Please select quarter before downloading the excel");
		}else if("--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				&& "--Select--".equals(jComboBox_Quarter.getSelectedItem().toString())){
			JOptionPane.showMessageDialog(null,"Please select financial year and quarter before downloading the excel");
		}

	}
	//**************************************************


	// done to create a file here only changed made
	private void jButton_crtFile_actionPerformed(ActionEvent e) {

		//	 System.out.println("HELLLOOOOO M HERERERREEEREREERERERERERERER");
		//System.out.println("I am a fool.... Latish");

		//newly developed for FRD1.5 Ver1.5 by akansha
		String pattern = "(((?=.*[a-z])|(?=.*[A-Z]))(?=.*[$#_]))|((?=.*[a-z])|(?=.*[A-Z]))";

		// Create a Pattern object
		Pattern r = Pattern.compile(pattern);

		//******************************************************

		//newly developed for FRD1.5 ver1.5 by akansha
		String pattern2 = "(((?=.*[a-z])|(?=.*[A-Z]))(?=.*[$#_]))|((?=.*[a-z])|(?=.*[A-Z]))|(\\s)|[0-9]";

		// Create a Pattern object
		Pattern r2 = Pattern.compile(pattern2);

		//*******************************************************

		hashTanMthYr = new HashSet();
		boolean check;
		// Added by Akansha
		boolean isValid = false;
		CorrValidation corrval = new CorrValidation();
		try {

			if ("Regular".equals(valueOfTypeOfStmt)) {

				//New dev for ver1.3 added by Akansha
				if (!"".equals(jText_Form_Sub1_Tan.getText().toString().trim())) {

					if(new Validations().checkTan(jText_Form_Sub1_Tan.getText().toString().trim())){
						JOptionPane.showMessageDialog(null,
								"Please enter correct TAN");
						jText_Form_Sub1_Tan.requestFocus();
						isValid = true;

					}

				}

				if(!"".equals(jText_Form_Sub1_Pan.getText().toString().trim())){

					if(GrpuUtil.checkDedPan(jText_Form_Sub1_Pan.getText().toString().trim())){
						JOptionPane.showMessageDialog(null,
								"Enter a valid PAN Number");
						jText_Form_Sub1_Pan.requestFocus();
						isValid = true;

					}

				}

				//newly developed for FRD1.5 Ver1.5 by akansha
				if(!"".equals(jText_Form_Sub2_Name.getText().toString())){
					// Now create matcher object.
					Matcher m = r.matcher(jText_Form_Sub2_Name.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Deductor/Employer Name");
						jText_Form_Sub2_Name.requestFocus();
						isValid = true;
					}

				}

				if(!"".equals(jText_Form_Sub2_Branch.getText().toString())){
					// Now create matcher object.
					Matcher m = r.matcher(jText_Form_Sub2_Branch.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Deductor's Branch/ Division");
						jText_Form_Sub2_Branch.requestFocus();
						isValid = true;
					}

				}

				/***************************************************************/
				//For FRD2.1, added by Sadhana, added validation for GSTN field, it should be 15 digits
				if (!"".equals(grpu.jText_Form_Sub2_GSTN.getText().toString().trim())) {
					if(grpu.jText_Form_Sub2_GSTN.getText().length() < 15){
						JOptionPane.showMessageDialog(null,"Please provide valid 15 digits GSTN");
						grpu.jText_Form_Sub2_GSTN.requestFocus();
						isValid = true;
					}
				}
				/***************************************************************/


				if(!"".equals(jText_Form_Sub3_Name.getText().toString())){
					// Now create matcher object.
					Matcher m = r.matcher(jText_Form_Sub3_Name.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Name of Responsible Person");
						jText_Form_Sub3_Name.requestFocus();
						isValid = true;
					}

				}

				if(!"".equals(jText_Form_Sub3_Designation.getText().toString())){
					// Now create matcher object.
					Matcher m = r.matcher(jText_Form_Sub3_Designation.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Designation of Responsible Person");
						jText_Form_Sub3_Designation.requestFocus();
						isValid = true;
					}

				}


				//****************************************************************************** 

				//newly developed for FRD1.5 Ver1.5 by akansha
				if(!"".equals(jText_Form_Sub2_Area.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub2_Area.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Deductor's Area");
						jText_Form_Sub2_Area.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub2_FlatNo.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub2_FlatNo.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Deductor's Flat No.");
						jText_Form_Sub2_FlatNo.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub2_BuildingName.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub2_BuildingName.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Deductor's Building Name");
						jText_Form_Sub2_BuildingName.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub2_Road.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub2_Road.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Deductor's Road");
						jText_Form_Sub2_Road.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub2_Town.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub2_Town.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Deductor's Town");
						jText_Form_Sub2_Town.requestFocus();
						isValid = true;
					}

				}


				if(!"".equals(jText_Form_Sub3_Area.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub3_Area.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Responsible Person's Area");
						jText_Form_Sub3_Area.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub3_FlatNum.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub3_FlatNum.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Responsible Person's Flat No.");
						jText_Form_Sub3_FlatNum.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub3_BuildingName.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub3_BuildingName.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Responsible Person's Building Name");
						jText_Form_Sub3_BuildingName.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub3_Road.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub3_Road.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Responsible Person's Road");
						jText_Form_Sub3_Road.requestFocus();
						isValid = true;
					}

				}
				if(!"".equals(jText_Form_Sub3_Town.getText().toString())){
					// Now create matcher object.
					Matcher m = r2.matcher(jText_Form_Sub3_Town.getText().toString());
					if(!m.find()){
						JOptionPane.showMessageDialog(null,"Invalid value provided under Responsible Person's Town");
						jText_Form_Sub3_Town.requestFocus();
						isValid = true;
					}

				}

				//******************************************************************************

				//	System.out.println("HELLLOOOOO M 1");

				/* if (TabGRPU.getSelectedIndex() == BATCH_TAB_INDEX) { */

				//R&D added .trim() method for textboxes

				if(!"".equals(jText_Form_Sub2_TAN_RegNum.getText().toString().trim())){
					if(GrpuUtil.checkDedPan(jText_Form_Sub2_TAN_RegNum.getText().toString().trim())){
						JOptionPane.showMessageDialog(null,
								"Please mention valid PAN of responsible person");
						pointToCell_New_Form(jText_Form_Sub2_TAN_RegNum);
						isValid = true;

					}
				}
				if (!isValid && (("--Select--".equals(jComboBox_Quarter.getSelectedItem()
						.toString()))
						|| ("".equals(jText_Form_Sub1_Tan.getText().toString().trim()))
						|| ("".equals(jText_Form_Sub1_Pan.getText().toString().trim()))
						|| "".equals(jText_Form_Sub2_Name.getText().toString().trim())
						|| "".equals(jText_Form_Sub2_FlatNo.getText().toString())
						|| "".equals(jText_Form_Sub2_PinCode.getText().toString().trim())
						|| "--Select--".equals(jComboBox_AOState.getSelectedItem().toString())
						|| "--Select--".equals(jComboBox_Form_Sub2_isAddressChanged.getSelectedItem().toString())
						|| "".equals(jText_Form_Sub3_Name.getText().toString().trim()) 
						|| "".equals(jText_Form_Sub2_TAN_RegNum.getText().toString().trim())
						|| "".equals(jText_Form_Sub3_Designation.getText().toString().trim())
						|| "".equals(jText_Form_Sub3_FlatNum.getText().toString().trim())
						|| "".equals(jText_Form_Sub3_PinCode.getText().toString().trim())
						|| "--Select--".equals(jComboBox_State_Name.getSelectedItem().toString())
						|| ("--Select--".equals(jComboBox_Form_Sub3_isAddressChanged.getSelectedItem().toString()))
						|| "--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
						|| "--Select--".equals(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())




						//newly developed for FRD1.5 Ver1.5 by akansha				
						|| ("".equals(jText_Form_Sub2_Email.getText().toString()) && "".equals(jText_Form_Sub3_Email.getText().toString()))

						|| (("".equals(jText_Form_Sub3_MobileNumber.getText().toString())
								||  (jText_Form_Sub3_MobileNumber.getText()==null)) && !"--Select--".equals(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()) &&
										Integer.parseInt(JComboBox_Form_Sub1_finYear
												.getSelectedItem().toString().substring(0,4))>=2010)
												//**************************************************************
												|| jText_Form_Sub1_Tan.getText() == null
												|| jText_Form_Sub1_Pan.getText() == null
												|| jText_Form_Sub2_Name.getText() == null
												|| jText_Form_Sub2_FlatNo.getText() == null
												|| jText_Form_Sub2_PinCode.getText() == null
												|| jText_Form_Sub3_Name.getText() == null
												|| jText_Form_Sub2_TAN_RegNum.getText() == null
												|| jText_Form_Sub3_Designation.getText() == null
												|| jText_Form_Sub3_FlatNum.getText() == null 
												|| jText_Form_Sub3_PinCode.getText() == null
												//newly developed for FRD1.5 Ver1.5 by akansha
												||	jText_Form_Sub2_Email.getText()==null
												||	jText_Form_Sub3_Email.getText()==null

						) ) {

					//	System.out.println("^^" + isValid);



					if ("".equals(jText_Form_Sub1_Tan.getText().toString().trim())
							|| jText_Form_Sub1_Tan.getText() == null) {
						JOptionPane
						.showMessageDialog(null,
								"Enter Tax Deduction and Collection Account Number");
						jText_Form_Sub1_Tan.requestFocus();

					}
					else if ("--Select--".equals(JComboBox_Form_Sub1_finYear
							.getSelectedItem().toString())) {
						JOptionPane.showMessageDialog(null,
								"Enter Financial Year");
						JComboBox_Form_Sub1_finYear.requestFocus();

					}
					else // Added Newly on 24032015 by Akansha
						//added newly for FRD1.5 by akansha
						if (("--Select--".equals(jComboBox_Quarter.getSelectedItem()
								.toString())
								|| jComboBox_Quarter.getSelectedItem() == null)) {
							JOptionPane.showMessageDialog(null, "Enter Quarter");
							jComboBox_Quarter.requestFocus();

						}
					// ****************************************


						else if (""
								.equals(jText_Form_Sub1_Pan.getText().toString().trim())
								|| jText_Form_Sub1_Pan.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter a valid PAN Number");
							//jText_Form_Sub1_Pan.requestFocus();
							pointToCell_New_Form(jText_Form_Sub1_Pan);

						}
						else if ("--Select--"
								.equals(JComboBox_Form_Sub1_Type_of_Deductor
										.getSelectedItem().toString())) {
							JOptionPane.showMessageDialog(null,
									"Select Category of Deductor/Employer");
							JComboBox_Form_Sub1_Type_of_Deductor.requestFocus();
							//	System.out.println("11==" + isValid);
						}


						else if ("".equals(jText_Form_Sub2_Name.getText()
								.toString().trim()) 
								|| jText_Form_Sub2_Name.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter Deductor/Employer Name");
							jText_Form_Sub2_Name.requestFocus();

						}

						else if ("".equals(jText_Form_Sub2_FlatNo.getText()
								.toString())
								|| jText_Form_Sub2_FlatNo.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter Flat No. of Deductor/Employer");
							jText_Form_Sub2_FlatNo.requestFocus();

						}

						else if ("".equals(jText_Form_Sub2_PinCode.getText()
								.toString().trim())
								|| jText_Form_Sub2_PinCode.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter Pincode for Deductor/Employer");
							jText_Form_Sub2_PinCode.requestFocus();

						}else if ("--Select--".equals(jComboBox_AOState
								.getSelectedItem().toString())) {
							JOptionPane.showMessageDialog(null,
									"Select State of Deductor/Employer");
							jComboBox_AOState.requestFocus();
							//System.out.println("12==" + isValid);
						}
						else if(("".equals(jText_Form_Sub2_Email.getText().toString())
								||jText_Form_Sub2_Email.getText()==null)
								&& ("".equals(jText_Form_Sub3_Email.getText().toString())
										||jText_Form_Sub3_Email.getText()==null)){
							JOptionPane.showMessageDialog(null,"Please provide valid email id for Deductor or Responsible Person");
							jText_Form_Sub2_Email.requestFocus();
						}
						else if ("--Select--"
								.equals(jComboBox_Form_Sub2_isAddressChanged
										.getSelectedItem().toString())) {
							JOptionPane
							.showMessageDialog(null,
									"Select if Deductor/Employer Address changed or not");
							jComboBox_Form_Sub2_isAddressChanged.requestFocus();
							//System.out.println("13==" + isValid);
						}

						else if ("".equals(jText_Form_Sub3_Name.getText()
								.toString().trim())
								|| jText_Form_Sub3_Name.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter Name of Responsible Person");
							jText_Form_Sub3_Name.requestFocus();

						}else if (("".equals(jText_Form_Sub2_TAN_RegNum.getText()
								.toString().trim())
								|| jText_Form_Sub2_TAN_RegNum.getText() == null) && !isValid) {
							JOptionPane
							.showMessageDialog(null,
									"Enter valid PAN of responsible person");

							jText_Form_Sub2_TAN_RegNum.requestFocus();

						}

					/*else if (("".equals(jText_Form_Sub2_TAN_RegNum.getText()
								.toString().trim())
								|| jText_Form_Sub2_TAN_RegNum.getText() == null) && !isValid) {
							JOptionPane
									.showMessageDialog(null,
											"Please mention valid PAN of responsible person");

							jText_Form_Sub2_TAN_RegNum.requestFocus();

						}
					else if(!"".equals(grpu.jText_Form_Sub2_TAN_RegNum.getText().toString().trim())){
							if(GrpuUtil.checkDedPan(grpu.jText_Form_Sub2_TAN_RegNum.getText().toString().trim())){
								JOptionPane.showMessageDialog(null,
										"Please mention valid PAN of responsible person");
								grpu.jText_Form_Sub2_TAN_RegNum.requestFocus();
								isValid = true;

							}
						}*/
					// ********************************************


						else if ("".equals(jText_Form_Sub3_Designation.getText()
								.toString())
								|| jText_Form_Sub3_Designation.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter Designation of Responsible Person");
							jText_Form_Sub3_Designation.requestFocus();

						}

						else if ("".equals(jText_Form_Sub3_FlatNum.getText()
								.toString())
								|| jText_Form_Sub3_FlatNum.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter Flat No. of Responsible Person");
							jText_Form_Sub3_FlatNum.requestFocus();

						}

						else if ("".equals(jText_Form_Sub3_PinCode.getText()
								.toString().trim())
								|| jText_Form_Sub3_PinCode.getText() == null) {
							JOptionPane.showMessageDialog(null,
									"Enter Pincode of Responsible Person");
							jText_Form_Sub3_PinCode.requestFocus();

						}else if ("--Select--".equals(jComboBox_State_Name
								.getSelectedItem().toString())) {
							JOptionPane.showMessageDialog(null,
									"Select State of Responsible Person");
							jComboBox_State_Name.requestFocus();
							//System.out.println("14==" + isValid);
						}
					//newly developed for FRD1.5 Ver1.5 by akansha


						else if(("".equals(jText_Form_Sub3_MobileNumber.getText().toString())
								|| jText_Form_Sub3_MobileNumber.getText()==null) && !"--Select--".equals(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()) && Integer.parseInt(JComboBox_Form_Sub1_finYear
												.getSelectedItem().toString().substring(0,4))>=2010){
							JOptionPane.showMessageDialog(null,"Please provide valid mobile number for Responsible Person");
							jText_Form_Sub3_MobileNumber.requestFocus();
						}
					//***********************************************
						else if (("--Select--"
								.equals(jComboBox_Form_Sub3_isAddressChanged
										.getSelectedItem().toString()))) {
							JOptionPane
							.showMessageDialog(null,
									"Select if Responsible Person Address changed or not");
							jComboBox_Form_Sub3_isAddressChanged.requestFocus();
							//System.out.println("15==" + isValid);
						}
					isValid = true;
				}

				//System.out.println("HELLLOOOOO M 2");

				/* if (DDO_TAB_INDEX == TabGRPU.getSelectedIndex()) { */
				if (!isValid) {

					if (jTableTransacDetails.isEditing()
							&& jTableTransacDetails.getEditingRow() >= 0)
						jTableTransacDetails.editCellAt(0, 0);
					int filledrowNo[] = GrpuUtil.getFilledRows(model);
					//					System.out.println(filledrowNo.length
					//							+ "  Length of Array ********");
					// calculateStats(filledrowNo);
					//System.out.println("validating each field");
					boolean valfile = funValidate_challan(filledrowNo);
					if (valfile) {
					} else {
						// getMessage("File creation failed");
						isValid = true;
					}
				}

				//System.out.println("HELLLOOOOO M 3");
				//System.out.println("HERE IS FINAL ISVALID before CD" + isValid);
				if (!isValid) {
					int cdRowCount = model.getRowCount();

					for (int i = 2; i < cdRowCount; i++) {
						if (model.getValueAt(i, 18) != null
								&& model.getValueAt(i, 18).toString()
								.substring(0, 1).equalsIgnoreCase("N")) {					

						} else if (model.getValueAt(i, 18) != null
								&& model.getValueAt(i, 18).toString()
								.substring(0, 1).equalsIgnoreCase("Y")) {
							if (Integer.parseInt(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4)) >= 2013) {
								/*
								 * if (model.getValueAt(i, 11) == null ||
								 * model.getValueAt(i, 11).toString()
								 * .equals("")) { pointToCell_New_Challan(
								 * "Cheque/DD No should not be blank", i, 11);
								 * isValid = true; break; }
								 * 
								 * if (model.getValueAt(i, 13) == null ||
								 * model.getValueAt(i, 13).toString()
								 * .equals("")) { pointToCell_New_Challan(
								 * "BSR Code / Receipt No. of form 24G", i, 13);
								 * isValid = true; break; }
								 */// deepaks call as on 21/04/2015
							}

						}

						if (model.getValueAt(i, 15) == null
								|| model.getValueAt(i, 15).toString()
								.equals("")) {
							pointToCell_New_Challan(
									"Date on which challan deposited should not be blank",
									i, 15);
							isValid = true;
							break;
						}

						if (!GrpuUtil.isDate(
								model.getValueAt(i, 15).toString()
								.substring(0, 1),
								model.getValueAt(i, 15).toString()
								.substring(3, 4),
								model.getValueAt(i, 15).toString()
								.substring(6, 9))) {
							pointToCell_New_Challan(
									"Not a Valid Date on which challan deposited",
									i, 15);
							isValid = true;
							break;
						}

						if (model.getValueAt(i, 1) == null
								| !(model.getValueAt(i, 1).toString()
										.equalsIgnoreCase("--Select--")
										|| model.getValueAt(i, 1).toString()
										.equalsIgnoreCase("UPDATE") || model
										.getValueAt(i, 1).toString()
										.equalsIgnoreCase("SELECT"))) {
							pointToCell_New_Challan(
									"Not a Valid Update mode for challan", i, 1);
							isValid = true;
							break;
						}

						if (model.getValueAt(i, 18) == null
								| !(model.getValueAt(i, 18).toString()
										.equalsIgnoreCase("--Select--")
										|| model.getValueAt(i, 18).toString()
										.equalsIgnoreCase("YES")
										|| model.getValueAt(i, 18).toString()
										.equalsIgnoreCase("NO")
										|| model.getValueAt(i, 18).toString()
										.equalsIgnoreCase("N") || model
										.getValueAt(i, 18).toString()
										.equalsIgnoreCase("Y"))) {

							pointToCell_New_Challan(
									"Not a Valid Mode of deposit", i, 18);
							isValid = true;
							break;
						}
						//						System.out
						//								.println("MINOR HEAD VALUE VALUEEEEEEEEEE BEEFOOOOOOOREE IFF "
						//										+ model.getValueAt(i, 18).toString()
						//										+ "NEW PRINT123");
						//						System.out
						//								.println("MINOR HEAD VALUE VALUEEEEEEEEEE BEEFOOOOOOOREE IFF "
						//										+ model.getValueAt(i, 21).toString()
						//										+ "NEW PRINT");

						if (model.getValueAt(i, 21) == null
								| !(model.getValueAt(i, 21).toString()
										.equalsIgnoreCase("--Select--")
										|| model.getValueAt(i, 21).toString()
										.equalsIgnoreCase("200") || model
										.getValueAt(i, 21).toString()
										.equalsIgnoreCase("400"))) {
							System.out
							.println("MYYYYYYY VALUEEEEEEEEEE AFTERRRRR IFF "
									+ model.getValueAt(i, 21)
									.toString());
							pointToCell_New_Challan(
									"Not a Valid Minor head for challan", i, 21);
							isValid = true;
							break;
						}

					}

				}

				//	System.out.println("HELLLOOOOO M 4");
				//System.out.println("HERE IS FINAL ISVALID before DD" + isValid);
				if (!isValid) {

					int ddRowCount = model1.getRowCount();

					//	System.out.println("DD Row Count is :" + ddRowCount);

					for (int i = 2; i < ddRowCount; i++) {

						if ((model1.getValueAt(i, 11) == null
								|| model1.getValueAt(i, 6) == null
								|| model1.getValueAt(i, 14) == null
								|| model1.getValueAt(i, 15) == null
								|| model1.getValueAt(i, 16) == null
								|| model1.getValueAt(i, 17) == null
								|| model1.getValueAt(i, 18) == null
								|| model1.getValueAt(i, 19) == null
								|| model1.getValueAt(i, 20) == null
								|| model1.getValueAt(i, 21) == null
								|| model1.getValueAt(i, 23) == null /*
								 * || model1
								 * .getValueAt(i,
								 * 25) == null
								 */)
								 || (model1.getValueAt(i, 11).toString()
										 .equals("")
										 || model1.getValueAt(i, 14).toString()
										 .equals("")
										 || model1.getValueAt(i, 15).toString()
										 .equals("")
										 || model1.getValueAt(i, 16).toString()
										 .equals("")
										 || model1.getValueAt(i, 17).toString()
										 .equals("")
										 || model1.getValueAt(i, 18).toString()
										 .equals("")
										 || model1.getValueAt(i, 19).toString()
										 .equals("")
										 || model1.getValueAt(i, 20).toString()
										 .equals("")
										 || model1.getValueAt(i, 21).toString()
										 .equals("")
										 || model1.getValueAt(i, 23).toString()
										 .equals(""))) {

							isValid = true;

							// Added Newly on 24032015 by Akansha

							// *************************************

							if (model1.getValueAt(i, 11) == null
									|| model1.getValueAt(i, 11).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Sr no should not be blank", i, 11);
								break;
							}

							if (model1.getValueAt(i, 14) == null
									|| model1.getValueAt(i, 14).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"PAN of Deductee should not be blank",
										i, 14);
								break;
							}

							if (model1.getValueAt(i, 15) == null
									|| model1.getValueAt(i, 15).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Name of Deductee should not be blank",
										i, 15);
								break;
							}

							if (model1.getValueAt(i, 16) == null
									|| model1.getValueAt(i, 16).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Date of payment  should not be blank",
										i, 16);
								break;
							}

							if (model1.getValueAt(i, 17) == null
									|| model1.getValueAt(i, 17).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Amount paid should not be blank", i,
										17);
								break;
							}

							if (model1.getValueAt(i, 18) == null
									|| model1.getValueAt(i, 18).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"TDS should not be blank", i, 18);
								break;
							}
							if (model1.getValueAt(i, 19) == null
									|| model1.getValueAt(i, 19).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"surcharge should not be blank", i, 19);
								break;
							}
							if (model1.getValueAt(i, 20) == null
									|| model1.getValueAt(i, 20).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Cess no should not be blank", i, 20);
								break;
							}
							if (model1.getValueAt(i, 21) == null
									|| model1.getValueAt(i, 21).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Total tax Deducted should not be blank",
										i, 21);
								break;
							}
							if (model1.getValueAt(i, 23) == null
									|| model1.getValueAt(i, 23).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"total tax Deposited should not be blank",
										i, 23);
								break;
							}
							/*
							 * if (model1.getValueAt(i, 25) == null ||
							 * model1.getValueAt(i, 25).toString().equals( ""))
							 * { pointToCell_New_Annex1(
							 * "Total tax Dedcution should not be blank", i,
							 * 25); break; }
							 */// Added for date ka change

							/*
							 * if (model1.getValueAt(i, 28) == null ||
							 * model1.getValueAt(i, 28).toString().equals("")) {
							 * pointToCell_New_Annex1
							 * ("Rate of tax deducted should not be blank",i,
							 * 28); break; }
							 */

						} else {

							if (model1.getValueAt(i, 2) == null
									| !(model1.getValueAt(i, 2).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 2)
											.toString()
											.equalsIgnoreCase("ADD")
											|| model1.getValueAt(i, 2)
											.toString()
											.equalsIgnoreCase("UPDATE") || model1
											.getValueAt(i, 2).toString()
											.equalsIgnoreCase("PAN UPDATE"))) {
								pointToCell_New_Annex1(
										"Invalid UPDATE MODE for Deductee", i,
										2);
								isValid = true;
								break;
							}

							if (!GrpuUtil.isInt(model1.getValueAt(i, 11)
									.toString())
									|| model1.getValueAt(i, 11).toString()
									.length() > 9) {
								pointToCell_New_Annex1(
										"Sr number should be a Number", i, 11);
								isValid = true;
								break;
							}

							if (GrpuUtil.checkPan(model1.getValueAt(i, 14)
									.toString())) {
								pointToCell_New_Annex1(
										"Not a Valid Pan number", i, 14);
								isValid = true;
								break;
							}

							if (!GrpuUtil.isValidCharString(model1.getValueAt(
									i, 15).toString())) {
								pointToCell_New_Annex1("Not a Valid Name", i,
										15);
								isValid = true;
								break;
							}

							if (model1.getValueAt(i, 16)
									.toString().length()==9 && !GrpuUtil.isDate(model1.getValueAt(i, 16)
											.toString().substring(0, 1),
											model1.getValueAt(i, 16).toString()
											.substring(3, 4), model1
											.getValueAt(i, 16).toString()
											.substring(6, 9))) {
								pointToCell_New_Annex1("Not a Valid Date", i,
										16);
								isValid = true;
								break;
							}else if(model1.getValueAt(i, 16)
									.toString().length()<9) // bug of  deductor in Ver1.3 for length of date less than 9
							{ 
								pointToCell_New_Annex1("Not a Valid Date", i,
										16);
								isValid = true;
								break;
							}

							if (GrpuUtil.isDecimalCreateFile(
									model1.getValueAt(i, 17).toString(), 2)
									|| model1.getValueAt(i, 17).toString()
									.length() > 15) {
								pointToCell_New_Annex1(
										"Amount PAid is not Valid", i, 17);
								isValid = true;
								break;
							}

							if (GrpuUtil.isDecimalCreateFile(
									model1.getValueAt(i, 18).toString(), 2)
									|| model1.getValueAt(i, 18).toString()
									.length() > 15) {
								pointToCell_New_Annex1(
										"TDS Amount is not Valid", i, 18);
								isValid = true;
								break;
							}

							if (GrpuUtil.isDecimalCreateFile(
									model1.getValueAt(i, 19).toString(), 2)
									|| model1.getValueAt(i, 19).toString()
									.length() > 15) {
								pointToCell_New_Annex1(
										"Education Surcharge Amount is not Valid",
										i, 19);
								isValid = true;
								break;
							}

							if (GrpuUtil.isDecimalCreateFile(
									model1.getValueAt(i, 20).toString(), 2)
									|| model1.getValueAt(i, 20).toString()
									.length() > 15) {
								pointToCell_New_Annex1(
										"Education CESS Amount is not Valid", i,
										20);
								isValid = true;
								break;
							}

							Float ActualTotalTax = new Float(model1.getValueAt(
									i, 18).toString())
							+ new Float(model1.getValueAt(i, 19)
									.toString())
							+ new Float(model1.getValueAt(i, 20)
									.toString());

							if (GrpuUtil.isDecimalCreateFile(
									model1.getValueAt(i, 23).toString(), 2)
									|| model1.getValueAt(i, 23).toString()
									.length() > 15) {
								pointToCell_New_Annex1(
										"Total Tax Deposited is not Valid", i,
										23);
								isValid = true;
								break;
							}

						}

						if (Integer.parseInt(JComboBox_Form_Sub1_finYear
								.getSelectedItem().toString().substring(0, 4)) >= 2013) {
							if (model1.getValueAt(i, 6) == null
									|| model1.getValueAt(i, 6).toString()
									.equals("--Select--")) {
								pointToCell_New_Annex1(
										"Section code should not be blank", i,
										6);
								break;
							}
						}

						if (formNumber.equalsIgnoreCase("26Q")) 
						{
							if (model1.getValueAt(i, 27) == null
									|| !(model1.getValueAt(i, 27).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("1")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("2")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("01")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("02"))) 
							{
								pointToCell_New_Annex1("Invalid Deductee code",
										i, 27);
								isValid = true;
								break;
							}

							if (model1.getValueAt(i, 29) == null
						|| !(model1.getValueAt(i, 29).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 29)
											.toString()
											.equalsIgnoreCase("YES")
											|| model1.getValueAt(i, 29)
											.toString()
											.equalsIgnoreCase("NO")
											|| model1.getValueAt(i, 29)
											.toString()
											.equalsIgnoreCase("Y") || model1
											.getValueAt(i, 29).toString()
											.equalsIgnoreCase("N")))
							{
								pointToCell_New_Annex1(
										"Invalid value of paid by book cash entry",
										i, 28);
								isValid = true;
								break;
							}
							
						//rpu 3.1 start amount of cashwithdrawal mandatory

							if ("94N".equals(model1.getValueAt(i, 6))
									&& (!(jComboBox_Quarter.getSelectedItem()
											.equals("Q1"))
											&& Integer
													.parseInt(JComboBox_Form_Sub1_finYear
															.getSelectedItem()
															.toString()
															.substring(0, 4)) == 2019 || (Integer
											.parseInt(JComboBox_Form_Sub1_finYear
													.getSelectedItem()
													.toString().substring(0, 4)) > 2019))) {
								if (model1.getValueAt(i, 31) == null
										|| model1.getValueAt(i, 31).toString()
												.equals("")) {
									pointToCell_New_Annex1(
											"Amount of cash withdrawal in excess of Rs. 1 crore as referred to in section 194N should not be blank",
											i, 31);
									isValid = true;
									break;
								}
							}
							
							if (!("94N".equals(model1.getValueAt(i, 6))) &&  model1.getValueAt(i, 2)
									.toString()
									.equalsIgnoreCase("UPDATE"))
									if (!(jComboBox_Quarter.getSelectedItem()
											.equals("Q1"))
											&& Integer
													.parseInt(JComboBox_Form_Sub1_finYear
															.getSelectedItem()
															.toString()
															.substring(0, 4)) == 2019 || (Integer
											.parseInt(JComboBox_Form_Sub1_finYear
													.getSelectedItem()
													.toString().substring(0, 4)) > 2019))
									
									{
								System.out.println("line 13539");
						if(	model1.getValueAt(i, 31) != null)
						{
							pointToCell_New_Annex1(
									"Amount of cash withdrawal in excess of Rs. 1 crore as referred to in section 194N should not be added for section other than 94N",
									i, 31);
							isValid = true;
							break;
						}
									}
							//RPU 3.4 Column 32
							if ("4NF".equals(model1.getValueAt(i, 6))
									&& (!(jComboBox_Quarter.getSelectedItem().equals("Q1"))
											&& Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) == 2020
											|| (Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) > 2020))) {
								if (model1.getValueAt(i, 32) == null
										|| model1.getValueAt(i, 32).toString().equals("")) {
									pointToCell_New_Annex1("Amount of cash withdrawal which is in excess of Rs. 20 lakhs but does not exceed Rs. 1 crore for cases covered by sub-clause (a) of clause (ii) of first provision to section 194N  should not be blank",
											i, 32);
									isValid = true;
									break;
								}
							}
						
							
							if (!("4NF".equals(model1.getValueAt(i, 6))) &&  model1.getValueAt(i, 2).toString().equalsIgnoreCase("UPDATE"))
									if (!(jComboBox_Quarter.getSelectedItem().equals("Q1"))
											&& Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) == 2020
											|| (Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) > 2020))
									{
								if(	model1.getValueAt(i, 32) != null)
							{
							pointToCell_New_Annex1("Amount of cash withdrawal which is in excess of Rs. 20 lakhs but does not exceed Rs. 1 crore for cases covered by sub-clause (a) of clause (ii) of first provision to section 194N should not be added for section other than 94N",
									i, 32);
							isValid = true;
							break;
							}
									}
							//RPU 3.4 Column 33
							if ("4NF".equals(model1.getValueAt(i, 6))
									&& (!(jComboBox_Quarter.getSelectedItem().equals("Q1"))
											&& Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) == 2020
											|| (Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) > 2020))) {
								if (model1.getValueAt(i, 33) == null
										|| model1.getValueAt(i, 33).toString().equals("")) {
									pointToCell_New_Annex1("Amount of cash withdrawal which is in excess of Rs. 1 crore for cases covered by sub-clause (b) of clause (ii) of first provision to section 194N  should not be blank",
											i, 33);
									isValid = true;
									break;
								}
							}
							
							if (!("4NF".equals(model1.getValueAt(i, 6))) &&  model1.getValueAt(i, 2).toString().equalsIgnoreCase("UPDATE"))
									if (!(jComboBox_Quarter.getSelectedItem().equals("Q1"))
											&& Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) == 2020
											|| (Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) > 2020))
									{
								System.out.println("to throw error if value for column 32,33 is specified when section !=4NF");
								if(	model1.getValueAt(i, 33) != null)
							{
							pointToCell_New_Annex1("Amount of cash withdrawal which is in excess of Rs. 1 crore for cases covered by sub-clause (b) of clause (ii) of first provision to section 194N should not be added for section other than 94N",
									i, 33);
							isValid = true;
							break;
							}
									}
							

						}

						if (formNumber.equalsIgnoreCase("27EQ")) {
							if (model1.getValueAt(i, 27) == null
									| !(model1.getValueAt(i, 27).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("1")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("2")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("01") || model1
											.getValueAt(i, 27).toString()
											.equalsIgnoreCase("02"))) {
								pointToCell_New_Annex1("Invalid Deductee code",
										i, 27);
								isValid = true;
								break;
							}

							if (model1.getValueAt(i, 30) == null
									| !(model1.getValueAt(i, 30).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 30)
											.toString()
											.equalsIgnoreCase("YES")
											|| model1.getValueAt(i, 30)
											.toString()
											.equalsIgnoreCase("NO")
											|| model1.getValueAt(i, 30)
											.toString()
											.equalsIgnoreCase("Y") || model1
											.getValueAt(i, 30).toString()
											.equalsIgnoreCase("N"))) {
								pointToCell_New_Annex1(
										"Invalid value of paid by book cash entry",
										i, 30);
								isValid = true;
								break;
							}
							//RPU 3.5
							if("F".equals(model1.getValueAt(i, 26)) || "G".equals(model1.getValueAt(i, 26)))
							{
								if (model1.getValueAt(i, 34) == null
									| !(model1.getValueAt(i, 34).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 34)
											.toString()
											.equalsIgnoreCase("Yes")
											|| model1.getValueAt(i, 34)
											.toString()
											.equalsIgnoreCase("No")
											|| model1.getValueAt(i, 34)
											.toString()
											.equalsIgnoreCase("Y") || model1
											.getValueAt(i, 34).toString()
											.equalsIgnoreCase("N"))) {
								pointToCell_New_Annex1(
										"Invalid value in Whether the payment by collectee is liable to TDS as per clause (a) of the fifth provison to sub-section (1G) or second provison to sub-section (1H) and whether TDS has been deducted from such payment (if either F or G is selected in 680)",
										i, 34);
								isValid = true;
								break;
							}
					
							}
							if (model1.getValueAt(i, 34).toString().equalsIgnoreCase("Yes"))
								if(model1.getValueAt(i, 35) == null || model1.getValueAt(i, 35).toString().equals(""))
								{
																pointToCell_New_Annex1(
																		"Challan no should not be blank", i, 35);
																isValid = true;
																break;
															}

							if (model1.getValueAt(i, 34).toString().equalsIgnoreCase("Yes")) 
							if(model1.getValueAt(i, 36) == null 
									|| model1.getValueAt(i, 36).toString().equals("")){
								pointToCell_New_Annex1("Date of payment of TDS to Central Government should not be blank", i, 36);
																isValid = true;
																break;
															}

							//newly added for FRD1.8 by akansha
							if(model1.getValueAt(i, 29).toString()
									.length() > 7){
								pointToCell_New_Annex1(
										"Rate of tax deducted is invalid", i,
										29);
								isValid = true;
								break;
							}else{
								//newly added for FRD1.8 by akansha
								if (GrpuUtil.isDecimalCreateFile(model1
										.getValueAt(i, 29).toString(), 4)
										) {
									pointToCell_New_Annex1(
											"Rate of tax deducted is invalid", i,
											29);
									isValid = true;
									break;
								}else{
									double d = 0.00;
									d = Double.parseDouble((model1
											.getValueAt(i, 29).toString()).toString());
									if(d/100>=1){
										pointToCell_New_Annex1(
												"Rate of tax deducted is invalid", i,
												29);
										isValid = true;
										break;
									}

								}
								//************************************************
							}
							//*********************************************************
						}

						if (formNumber.equalsIgnoreCase("27Q")) {
							if (model1.getValueAt(i, 27) == null
									| !(model1.getValueAt(i, 27).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("1")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("2")
											|| model1.getValueAt(i, 27)
											.toString()
											.equalsIgnoreCase("01") || model1
											.getValueAt(i, 27).toString()
											.equalsIgnoreCase("02"))) {
								pointToCell_New_Annex1("Invalid Deductee code",
										i, 27);
								isValid = true;
								break;
							}

							if (model1.getValueAt(i, 29) == null
									| !(model1.getValueAt(i, 29).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 29)
											.toString()
											.equalsIgnoreCase("YES")
											|| model1.getValueAt(i, 29)
											.toString()
											.equalsIgnoreCase("NO")
											|| model1.getValueAt(i, 29)
											.toString()
											.equalsIgnoreCase("Y") || model1
											.getValueAt(i, 29).toString()
											.equalsIgnoreCase("N"))) {
								pointToCell_New_Annex1(
										"Invalid value of paid by book cash entry",
										i, 29);
								isValid = true;
								break;
							}

							if (model1.getValueAt(i, 31) == null
									| !(model1.getValueAt(i, 31).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 31)
											.toString()
											.equalsIgnoreCase("A") 
											|| model1.getValueAt(i, 31)
											.toString()
											.equalsIgnoreCase("B")))// ||
								// model1.getValueAt(i,
								// 31).toString().equalsIgnoreCase("Y")
								// ||
								// model1.getValueAt(i,
								// 31).toString().equalsIgnoreCase("N")
								// ))
							{
								// Newly changed by Akansha
								pointToCell_New_Annex1(
										"Invalid value of whether TDS rate of TDS IS IT ACT ",
										i, 31);
								isValid = true;
								break;
							}

							if (model1.getValueAt(i, 35) == null
									| !(model1.getValueAt(i, 35).toString()
											.equalsIgnoreCase("--Select--")
											|| model1.getValueAt(i, 35)
											.toString()
											.equalsIgnoreCase("YES")
											|| model1.getValueAt(i, 35)
											.toString()
											.equalsIgnoreCase("NO")
											|| model1.getValueAt(i, 35)
											.toString()
											.equalsIgnoreCase("Y") || model1
											.getValueAt(i, 35).toString()
											.equalsIgnoreCase("N"))) {
								pointToCell_New_Annex1(
										"Invalid value of Grossing up indicator ",
										i, 35);
								isValid = true;
								break;
							}
							//rpu 3.1 start
							if ("94N".equals(model1.getValueAt(i, 6))
									&& (!(jComboBox_Quarter.getSelectedItem().equals("Q1"))
											&& Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) == 2019
											|| (Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) > 2019)))
							{
								if (model1.getValueAt(i, 40) == null
										|| model1.getValueAt(i, 40).toString().equals("")) {
									pointToCell_New_Annex1("Amount of cash withdrawal in excess of Rs. 1 crore as referred to in section 194N should not be blank",
											i, 40);
									break;
								}
							}
							//RPU 3.4 column 41
							if ("4NF".equals(model1.getValueAt(i, 6))
									&& (!(jComboBox_Quarter.getSelectedItem().equals("Q1"))
											&& Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) == 2020
											|| (Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) > 2020)))
							{
								if (model1.getValueAt(i, 41) == null
										|| model1.getValueAt(i, 41).toString().equals("")) {
									pointToCell_New_Annex1("Amount of cash withdrawal which is in excess of Rs. 20 lakhs but does not exceed Rs. 1 crore for cases covered by sub-clause (a) of clause (ii) of first provision to section 194N  should not be blank",
											i, 41);
									break;
								}
							}
							//RPU 3.4 column 42
							if ("4NF".equals(model1.getValueAt(i, 6))
									&& (!(jComboBox_Quarter.getSelectedItem().equals("Q1"))
											&& Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) == 2020
											|| (Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4)) > 2020)))
							{
								if (model1.getValueAt(i, 42) == null
										|| model1.getValueAt(i, 42).toString().equals("")) {
									pointToCell_New_Annex1("Amount of cash withdrawal which is in excess of Rs. 1 crore for cases covered by sub-clause (b) of clause (ii) of first provision to section 194N should not be blank",
											i, 42);
									break;
								}
							}
							
						}
						
						

						if ((formNumber.equalsIgnoreCase("26Q") || formNumber
								.equalsIgnoreCase("27Q"))
								&& (model1.getValueAt(i, 28) == null
								|| model1.getValueAt(i, 28).toString()
								.equals("")
								|| model1.getValueAt(i, 27) == null || model1
								.getValueAt(i, 27).toString()
								.equals(""))) {
							if (model1.getValueAt(i, 28) == null
									|| model1.getValueAt(i, 28).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Rate of tax deducted should not be blank",
										i, 28);
								isValid = true;
								break;
							}

							if (model1.getValueAt(i, 27) == null
									|| model1.getValueAt(i, 27).toString()
									.equals("")) {
								pointToCell_New_Annex1(
										"Deductee Code should not be blank", i,
										27);
								isValid = true;
								break;
							}

						} else if (formNumber.equalsIgnoreCase("26Q")
								|| formNumber.equalsIgnoreCase("27Q")) {
							if(model1.getValueAt(i, 28).toString()
									.length() > 7){
								pointToCell_New_Annex1(
										"Rate of tax deducted is invalid", i,
										28);
								isValid = true;
								break;
							}else{
								//added newly for FRD1.8 by akansha
								if (GrpuUtil.isDecimalCreateFile(model1
										.getValueAt(i, 28).toString(), 4)
										) {
									pointToCell_New_Annex1(
											"Rate of tax deducted is invalid", i,
											28);
									isValid = true;
									break;
								}else{
									double d = 0.00;
									d = Double.parseDouble((model1
											.getValueAt(i, 28).toString()).toString());
									if(d/100>=1){
										pointToCell_New_Annex1(
												"Rate of tax deducted is invalid", i,
												28);
										isValid = true;
										break;
									}

								}
								//*********************************************
							}

							if (!(model1.getValueAt(i, 27).toString()
									.equalsIgnoreCase("1")
									|| model1.getValueAt(i, 27).toString()
									.equalsIgnoreCase("2")
									|| model1.getValueAt(i, 27).toString()
									.equalsIgnoreCase("01") || model1
									.getValueAt(i, 27).toString()
									.equalsIgnoreCase("02"))
									|| model1.getValueAt(i, 27).toString()
									.equalsIgnoreCase("Select")) {
								pointToCell_New_Annex1(
										"Not a valid Deductee Code", i, 27);
								isValid = true;
								break;
							}

						}

						//newly added for FRD1.7 by akansha
						// if the PAN is invalid, rate of deduction is less than 20 and remark is 'C'
						boolean PanValid = true;
						/*	if(model1.getValueAt(i,14)!=null && !"".equals(model1.getValueAt(i,14).toString().trim()))
							PanValid = GrpuUtil.checkPan(model1.getValueAt(i,14).toString());
						int rateValid = 0;
						rateValid = Integer.parseInt(model1.getValueAt(i,14).toString().substring(arg0, arg1))*/
						if(formNumber.equalsIgnoreCase("27Q") && Integer.parseInt(grpu.JComboBox_Form_Sub1_finYear
								.getSelectedItem().toString().substring(0, 4)) >= 2016
								&&(model1.getValueAt(i,14)!=null &&
								!PanValid)){
							if(model1.getValueAt(i,36)==null || "".equalsIgnoreCase(model1.getValueAt(i,36).toString())){
								pointToCell_New_Annex1(
										"Invalid value under field Email ID of deductee", i, 36);
								isValid = true;
								break;
							}
							if(model1.getValueAt(i,37)==null || "".equalsIgnoreCase(model1.getValueAt(i,37).toString())){
								pointToCell_New_Annex1(
										"Invalid value under field Contact number of deductee", i, 37);
								isValid = true;
								break;
							}
							if(model1.getValueAt(i,38)==null || "".equalsIgnoreCase(model1.getValueAt(i,38).toString())){
								pointToCell_New_Annex1(
										"Invalid value under field Address of deductee in country of residence", i, 38);
								isValid = true;
								break;
							}
							if(model1.getValueAt(i,39)==null || "".equalsIgnoreCase(model1.getValueAt(i,39).toString())){
								pointToCell_New_Annex1(
										"Invalid value under field Tax Identification Number / Unique identification number of deductee", i, 39);
								isValid = true;
								break;
							}
						}

						//********************************************

					}

				}

				//System.out.println("HELLLOOOOO M 5");
				//System.out.println("HERE IS FINAL ISVALID before SD" + isValid);
				// Validation of annexure II //
				if (!isValid) {
					int sdRowCount = 0;
					if (formNumber.equalsIgnoreCase("24Q")
							&& "Q4".equalsIgnoreCase((jComboBox_Quarter
									.getSelectedItem().toString()))) {

						sdRowCount = model2.getRowCount();

						//System.out.println("SD Row Count is :" + sdRowCount);

						for (int i = 2; i < sdRowCount; i++) {
							
							
							//****************** Added for 2.7 Start ********************//*
							if (new Integer(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4)) >= 2018) {


									if (model2.getValueAt(i, 59) == null
											|| model2.getValueAt(i, 59)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Gross Salary As Per Sec 17(1) Should not be empty ",
												i, 59);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 59).toString(), 2)
												|| model2.getValueAt(i, 59)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Gross Salary As Per Sec 17(1) is invalid ",
													i, 59);
											isValid = true;
											break;
										
									}
									
									if (model2.getValueAt(i, 60) == null
											|| model2.getValueAt(i, 60)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Value Of Perquisite As Per Sec 17(2) Should not be empty ",
												i, 60);
										isValid = true;
										break;
									}
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 60).toString(), 2)
											|| model2.getValueAt(i, 60)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Perquisite As Per Sec 17(2) is invalid ",
												i, 60);
										isValid = true;
										break;
									
								    } 
									
									if (model2.getValueAt(i, 61) == null
											|| model2.getValueAt(i, 61)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Profits In Lieu Of Salary As Per Sec 17(3) Should not be empty ",
												i, 61);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 61).toString(), 2)
												|| model2.getValueAt(i, 61)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Profits In Lieu Of Salary As Per Sec 17(3) is invalid ",
													i, 61);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 62) == null
											|| model2.getValueAt(i, 62)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Travel Concession Should not be empty ",
												i, 62);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if(GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 62).toString(), 2)
												|| model2.getValueAt(i, 62)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Travel Concession is invalid ",
													i, 62);
											isValid = true;
											break;
										
									}
									//if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 63) == null
											|| model2.getValueAt(i, 63)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Death Cum Retirement Gratuity Should not be empty ",
												i, 63);
										isValid = true;
										break;
									}	
									//if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 63).toString(), 2)
												|| model2.getValueAt(i, 63)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Death Cum Retirement Gratuity  is invalid ",
													i, 63);
											isValid = true;
											break;
										
									}
									
									if (model2.getValueAt(i, 64) == null
											|| model2.getValueAt(i, 64)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Commuted Value Of Pension Should not be empty ",
												i, 64);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 64).toString(), 2)
												|| model2.getValueAt(i, 64)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Commuted Value Of Pension is invalid ",
													i, 64);
											isValid = true;
											break;
										
									}
									
									if (model2.getValueAt(i, 65) == null
											|| model2.getValueAt(i, 65)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Cash Equivalent Of Leave Salary Should not be empty ",
												i, 65);
										isValid = true;
										break;
									}
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 65).toString(), 2)
											|| model2.getValueAt(i, 65)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Cash Equivalent Of Leave Salary is invalid ",
												i, 65);
										isValid = true;
										break;
									
								    } 
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 66) == null
											|| model2.getValueAt(i, 66)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"HRA Should not be empty ",
												i, 66);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 66).toString(), 2)
												|| model2.getValueAt(i, 66)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"HRA is invalid ",
													i, 66);
											isValid = true;
											break;
										
									}
									if (model2.getValueAt(i, 67) == null
											|| model2.getValueAt(i, 67)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Amount Of Any Other Exemption Should not be empty ",
												i, 67);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 67).toString(), 2)
												|| model2.getValueAt(i, 67)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Amount Of Any Other Exemption is invalid ",
													i, 67);
											isValid = true;
											break;
										
									}
									if (model2.getValueAt(i, 68) == null
											|| model2.getValueAt(i, 68)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Total Amount Of Exemption Should not be empty ",
												i, 68);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 68).toString(), 2)
												|| model2.getValueAt(i, 68)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Total Amount Of Exemption is invalid ",
													i, 68);
											isValid = true;
											break;
										
									}
									if (model2.getValueAt(i, 69) == null
											|| model2.getValueAt(i, 69)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Income Under The Head Should not be empty ",
												i, 69);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 69).toString(), 2)
												|| model2.getValueAt(i, 69)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Income Under The Head is invalid ",
													i, 69);
											isValid = true;
											break;
										
									}
									//RPU 2.9 start
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 70) == null
											|| model2.getValueAt(i, 70)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80C(Gross Amount) Should not be empty ",
												i, 70);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 70).toString(), 2)
											|| model2.getValueAt(i, 70)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Section 80C(Gross Amount) is invalid ",
												i, 70);
										isValid = true;
										break;
									
								    } 
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 71) == null
											|| model2.getValueAt(i, 71)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80C(Deductible Amount) Should not be empty ",
												i, 71);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 71).toString(), 2)
											|| model2.getValueAt(i, 71)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Section 80C(Deductible Amount) is invalid ",
												i, 71);
										isValid = true;
										break;
									
								    } 
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 72) == null
											|| model2.getValueAt(i, 72)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCC(Gross Amount) Should not be empty ",
												i, 72);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 72).toString(), 2)
												|| model2.getValueAt(i, 72)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCC(Gross Amount) is invalid ",
													i, 72);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns
									if (model2.getValueAt(i, 73) == null
											|| model2.getValueAt(i, 73)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCC(Deductible Amount) Should not be empty ",
												i, 73);
										isValid = true;
										break;
									}	
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 73).toString(), 2)
												|| model2.getValueAt(i, 73)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCC(Deductible Amount) is invalid ",
													i, 73);
											isValid = true;
											break;
										
									}
							
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									
										if (model2.getValueAt(i, 74) == null
											|| model2.getValueAt(i, 74)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCD(1)(Gross Amount) Should not be empty ",
												i, 74);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 74).toString(), 2)
												|| model2.getValueAt(i, 74)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCD(1)(Gross Amount) is invalid ",
													i, 74);
											isValid = true;
											break;
										
									}
									
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									
										if (model2.getValueAt(i, 75) == null
											|| model2.getValueAt(i, 75)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCD(1)(Deductible Amount) Should not be empty ",
												i, 75);
										isValid = true;
										break;
									}	
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 75).toString(), 2)
												|| model2.getValueAt(i, 75)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCD(1)(Deductible Amount) is invalid ",
													i, 75);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 76) == null
											|| model2.getValueAt(i, 76)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCD(1B)(Gross Amount) Should not be empty ",
												i, 76);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 76).toString(), 2)
												|| model2.getValueAt(i, 76)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCD(1B)(Gross Amount) is invalid ",
													i, 76);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 77) == null
											|| model2.getValueAt(i, 77)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCD(1B)(Deductible Amount) Should not be empty ",
												i, 77);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 77).toString(), 2)
												|| model2.getValueAt(i, 77)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCD(1B)(Deductible Amount) is invalid ",
													i, 77);
											isValid = true;
											break;
										
									}
									if (model2.getValueAt(i, 78) == null
											|| model2.getValueAt(i, 78)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCD(2)(Gross Amount) Should not be empty ",
												i, 78);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 78).toString(), 2)
												|| model2.getValueAt(i, 78)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCD(2)(Gross Amount) is invalid ",
													i, 78);
											isValid = true;
											break;
										
									}
									if (model2.getValueAt(i, 79) == null
											|| model2.getValueAt(i, 79)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80CCD(2)(Deductible Amount) Should not be empty ",
												i, 79);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 79).toString(), 2)
												|| model2.getValueAt(i, 79)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80CCD(2)(Deductible Amount) is invalid ",
													i, 79);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 80) == null
											|| model2.getValueAt(i, 80)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80D(Gross Amount) Should not be empty ",
												i, 80);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 80).toString(), 2)
											|| model2.getValueAt(i, 80)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Section 80D(Gross Amount) is invalid ",
												i, 80);
										isValid = true;
										break;
									
								    } 
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 81) == null
											|| model2.getValueAt(i, 81)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80D(Deductible Amount) Should not be empty ",
												i, 81);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 81).toString(), 2)
											|| model2.getValueAt(i, 81)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Section 80D(Deductible Amount) is invalid ",
												i, 81);
										isValid = true;
										break;
									
								    } 
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 82) == null
											|| model2.getValueAt(i, 82)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80E(Gross Amount) Should not be empty ",
												i, 82);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 82).toString(), 2)
												|| model2.getValueAt(i, 82)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80E(Gross Amount) is invalid ",
													i, 82);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 83) == null
											|| model2.getValueAt(i, 83)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80E(Deductible Amount) Should not be empty ",
												i, 83);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 83).toString(), 2)
												|| model2.getValueAt(i, 83)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80E(Deductible Amount) is invalid ",
													i, 83);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 84) == null
											|| model2.getValueAt(i, 84)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80G(Gross Amount) Should not be empty ",
												i, 84);
										isValid = true;
										break;
									}	
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 84).toString(), 2)
												|| model2.getValueAt(i, 84)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80G(Gross Amount) is invalid ",
													i, 84);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 85) == null
											|| model2.getValueAt(i, 85)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80G(Qualifying Amount) Should not be empty ",
												i, 85);
										isValid = true;
										break;
									}	
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 85).toString(), 2)
												|| model2.getValueAt(i, 85)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80G(Qualifying Amount) is invalid ",
													i, 85);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 86) == null
											|| model2.getValueAt(i, 86)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80G(Deductible Amount) Should not be empty ",
												i, 86);
										isValid = true;
										break;
									}	
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 86).toString(), 2)
												|| model2.getValueAt(i, 86)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80G(Deductible Amount) is invalid ",
													i, 86);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 87) == null
											|| model2.getValueAt(i, 87)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80TTA(Gross Amount) Should not be empty ",
												i, 87);
										isValid = true;
										break;
									}	
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 87).toString(), 2)
												|| model2.getValueAt(i, 87)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80TTA(Gross Amount) is invalid ",
													i, 87);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 88) == null
											|| model2.getValueAt(i, 88)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80TTA(Qualifying Amount) Should not be empty ",
												i, 88);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 88).toString(), 2)
												|| model2.getValueAt(i, 88)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80TTA(Qualifying Amount) is invalid ",
													i, 88);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 89) == null
											|| model2.getValueAt(i, 89)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Section 80TTA(Deductible Amount) Should not be empty ",
												i, 89);
										isValid = true;
										break;
									}		
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 89).toString(), 2)
												|| model2.getValueAt(i, 89)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Section 80TTA(Deductible Amount) is invalid ",
													i, 89);
											isValid = true;
											break;
										
									}
									if (model2.getValueAt(i, 90) == null
											|| model2.getValueAt(i, 90)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Rebate Under Section 87A Should not be empty ",
												i, 90);
										isValid = true;
										break;
									}										
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 90).toString(), 2)
												|| model2.getValueAt(i, 90)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Rebate Under Section 87A is invalid ",
													i, 90);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 91) == null
											|| model2.getValueAt(i, 91)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Amount under OTHER provision of Chapter VI_A(Gross Amount) Should not be empty",
												i, 91);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 91).toString(), 2)
												|| model2.getValueAt(i, 91)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Amount under OTHER provision of Chapter VI_A(Gross Amount) is invalid ",
													i, 91);
											isValid = true;
											break;
										
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
									if (model2.getValueAt(i, 92) == null
											|| model2.getValueAt(i, 92)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Amount under OTHER provision of Chapter VI_A(Qualifying Amount) Should not be empty ",
												i, 92);
										isValid = true;
										break;
									}
									if(!model2.getValueAt(i, 93).equals("Yes"))
									if (GrpuUtil.isDecimalCreateFile(model2
												.getValueAt(i, 92).toString(), 2)
												|| model2.getValueAt(i, 92)
												.toString().length() > 15) {
											pointToCell_New_Annex2(
													"Amount under OTHER provision of Chapter VI_A(Qualifying Amount) is invalid ",
													i, 92);
											isValid = true;
											break;
									}
								
									//RPU 2.9 end
								}
							
							if((new Integer(grpu.JComboBox_Form_Sub1_finYear   //RPU 3.6 changes when column is blank
                                    .getSelectedItem().toString()
                                    .substring(0,4)) > 2020) || ((new Integer(grpu.JComboBox_Form_Sub1_finYear  
                                    .getSelectedItem().toString()
                                    .substring(0,4)) == 2020) &&  jComboBox_Quarter.getSelectedItem().equals("Q4"))){
                                if (grpu.model2.getValueAt(i, 93) == null
                                		|| grpu.model2.getValueAt(i, 93).toString()
                                                .equals("--Select--")|| model2.getValueAt(i, 93).toString()
        										.equals("")){ 
                                    grpu.pointToCell_New_Annex2(
                                            "Whether opting for taxation  u/s 115BAC? value is invalid ",
                                            i, 93);
                                    isValid = true;
                                    break;
                                }
							}
                                
							if(model2.getValueAt(i, 93).equals("Yes") && !(model2.getValueAt(i, 15) == null
									|| model2.getValueAt(i, 15)
									.toString().equals("")))
                                if(model2.getValueAt(i, 15).toString().trim().charAt(0) == '-')//RPU 3.6 Changes
                                {
                                    pointToCell_New_Annex2(
                                            "Income Chargeable under any other head salaries(column 15) Should not be negative ",
                                            i, 15);
                                    isValid = true;
                                    break;
                                }
							
							
							
							/****************** Added for 2.7 End ********************/
							
							
							
							
							if ((model2.getValueAt(i, 1) == null
									|| model2.getValueAt(i, 3) == null
									|| model2.getValueAt(i, 4) == null
									|| model2.getValueAt(i, 5) == null
									//newly modified for fRD1.6 by akansha
									|| model2.getValueAt(i, 6) == null
									|| model2.getValueAt(i, 7) == null
									//****************************************
									|| model2.getValueAt(i, 10) == null
									|| model2.getValueAt(i, 11) == null
									|| model2.getValueAt(i, 12) == null
									|| model2.getValueAt(i, 13) == null
									|| model2.getValueAt(i, 14) == null
									|| model2.getValueAt(i, 15) == null
									|| model2.getValueAt(i, 16) == null
									|| model2.getValueAt(i, 17) == null
									|| model2.getValueAt(i, 20) == null
									|| model2.getValueAt(i, 21) == null
									|| model2.getValueAt(i, 22) == null
									|| model2.getValueAt(i, 23) == null
									|| model2.getValueAt(i, 24) == null
									|| model2.getValueAt(i, 25) == null
									|| model2.getValueAt(i, 26) == null
									|| model2.getValueAt(i, 27) == null
									|| model2.getValueAt(i, 30) == null 
									|| model2.getValueAt(i, 31) == null)

									|| (model2.getValueAt(i, 1)
											.toString().equals("")
											|| model2.getValueAt(i, 3)
											.toString().equals("")
											|| model2.getValueAt(i, 4)
											.toString().equals("")
											|| model2.getValueAt(i, 5)
											.toString().equals("")
											//newly modified for FRD1.6 by akansha
											|| model2.getValueAt(i, 6)
											.toString().equals("")
											|| model2.getValueAt(i, 7)
											.toString().equals("")
											//***************************
											|| model2.getValueAt(i, 10)
											.toString().equals("")
											|| model2.getValueAt(i, 11)
											.toString().equals("")
											|| model2.getValueAt(i, 12)
											.toString().equals("")
											|| model2.getValueAt(i, 13)
											.toString().equals("")
											|| model2.getValueAt(i, 14)
											.toString().equals("")
											|| model2.getValueAt(i, 15)
											.toString().equals("")
											|| model2.getValueAt(i, 16)
											.toString().equals("")
											|| model2.getValueAt(i, 17)
											.toString().equals("")
											|| model2.getValueAt(i, 20)
											.toString().equals("")
											|| model2.getValueAt(i, 21)
											.toString().equals("")
											|| model2.getValueAt(i, 22)
											.toString().equals("")
											|| model2.getValueAt(i, 23)
											.toString().equals("")
											|| model2.getValueAt(i, 24)
											.toString().equals("")
											|| model2.getValueAt(i, 25)
											.toString().equals("")
											|| model2.getValueAt(i, 26)
											.toString().equals("")
											|| model2.getValueAt(i, 27)
											.toString().equals("")
											|| model2.getValueAt(i, 30)
											.toString().equals("") 
											|| model2.getValueAt(i, 31)
											.toString().equals(""))

									) {



								if (model2.getValueAt(i, 1) == null
										|| model2.getValueAt(i, 1).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Sr No Should not be empty ", i, 1);
									isValid = true;
									break;
								}

								if (model2.getValueAt(i, 3) == null
										|| model2.getValueAt(i, 3).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Pan No Should not be empty ", i, 3);
									isValid = true;
									break;
								}


								if (model2.getValueAt(i, 4) == null
										|| model2.getValueAt(i, 4).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Name Should not be empty ", i, 4);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 5) == null
										|| model2.getValueAt(i, 5).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Deductee Type Should not be empty ",
											i, 5);
									isValid = true;
									break;
								}

								//newly modified for FRD1.6 by akansha
								if(new Integer(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4)) < 2013){
									if (model2.getValueAt(i, 6) == null
											|| model2.getValueAt(i, 6).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"From Date Should not be empty ",
												i, 6);
										isValid = true;
										break;
									}
									if (model2.getValueAt(i, 7) == null
											|| model2.getValueAt(i, 7).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"To Date Should not be empty ", i,
												7);
										isValid = true;
										break;
									}
								}
								//*************************************************
								if (model2.getValueAt(i, 10) == null
										|| model2.getValueAt(i, 10).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Total Salary Amount Should not be empty ",
											i, 10);
									isValid = true;
									break;
								}
								if(!model2.getValueAt(i, 93).equals("Yes"))    //RPU 3.6 changes to disable pop up of columns 
								if (model2.getValueAt(i, 11) == null
										|| model2.getValueAt(i, 11).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Deduction Under Section VI(ii) Should not be empty ",
											i, 11);
									isValid = true;
									break;
								}
								if(!model2.getValueAt(i, 93).equals("Yes"))   //RPU 3.6 changes to disable pop up of columns 
								if (model2.getValueAt(i, 12) == null
										|| model2.getValueAt(i, 12).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Deduction Under Section VI(iii) Should not be empty ",
											i, 12);
									isValid = true;
									break;
								}
								/*********************************************************/				
								//FRD 2.3 added 16(ia)
								
								if(new Integer(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4)) > 2017){
									if(!model2.getValueAt(i, 93).equals("Yes"))     //RPU 3.6 changes to disable pop up of columns 
								if (model2.getValueAt(i, 13) == null
										|| model2.getValueAt(i, 13).toString()
												.equals("")) {
									pointToCell_New_Annex2(
											"Total Deduction under VI(ii) and VI(iii) Should not be empty ",
											i, 13);
									isValid = true;
									break;
								}}
								/*********************************************************/
								if (model2.getValueAt(i, 14) == null
										|| model2.getValueAt(i, 14).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Income Chargeable under head salaries Should not be empty ",
											i, 14);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 15) == null
										|| model2.getValueAt(i, 15).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Income Chargeable under anyother head salaries Should not be empty ",
											i, 15);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 16) == null
										|| model2.getValueAt(i, 16).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Gross Total Should not be empty ",
											i, 16);
									isValid = true;
									break;
								}
								if(!model2.getValueAt(i, 93).equals("Yes"))		   //RPU 3.6 changes to disable pop up of columns 
								if (model2.getValueAt(i, 20) == null
										|| model2.getValueAt(i, 20).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Aggregate Amount of Deduuction under any other Should not be empty ",
											i, 20);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 21) == null
										|| model2.getValueAt(i, 21).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Total amount under Chapter VIA Should not be empty ",
											i, 21);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 22) == null
										|| model2.getValueAt(i, 22).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Total Taxable Income Should not be empty ",
											i, 22);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 23) == null
										|| model2.getValueAt(i, 23).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Income Tax on total Income Should not be empty ",
											i, 23);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 24) == null
										|| model2.getValueAt(i, 24).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Surcharge Should not be empty ",
											i, 24);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 25) == null
										|| model2.getValueAt(i, 25).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Education CESS Should not be empty ",
											i, 25);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 26) == null
										|| model2.getValueAt(i, 26).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Income Tax relief under Section 89 Should not be empty ",
											i, 26);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 27) == null
										|| model2.getValueAt(i, 27).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Net tax payable Should not be empty ",
											i, 27);
									isValid = true;
									break;
								}

								if (model2.getValueAt(i, 30) == null
										|| model2.getValueAt(i, 30).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Total Amount of tax deducted at source for whole year including TDS on superannuation Should not be empty ",
											i, 30);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 31) == null
										|| model2.getValueAt(i, 31).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Shortfall in tax deduction Should not be empty ",
											i, 31);
									isValid = true;
									break;
								}


							} else {

								if (model2.getValueAt(i, 2) == null
										| !(model2.getValueAt(i, 2)
												.toString()
												.equalsIgnoreCase("--Select--")
												|| model2
												.getValueAt(i, 2)
												.toString()
												.equalsIgnoreCase("ADD")
												|| model2
												.getValueAt(i, 2)
												.toString()
												.equalsIgnoreCase("DELETE") 
												|| model2
												.getValueAt(i, 2)
												.toString()
												.equalsIgnoreCase("PAN UPDATE"))) 
								{
									pointToCell_New_Annex2(
											"Invalid UPDATE MODE for Deductee",
											i, 2);
									isValid = true;
									break;
								}

								if (new Integer(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4)) >= 2013) {
									if (model2.getValueAt(i, 32) == null
											| !(model2.getValueAt(i, 32)
													.toString()
													.equalsIgnoreCase("")
													|| model2
													.getValueAt(i, 32)
													.toString()
													.equalsIgnoreCase(
															"--Select--")
															|| model2
															.getValueAt(i, 32)
															.toString()
															.equalsIgnoreCase(
																	"Y")
																	|| model2
																	.getValueAt(i, 32)
																	.toString()
																	.equalsIgnoreCase(
																			"N")
																			|| model2
																			.getValueAt(i, 32)
																			.toString()
																			.equalsIgnoreCase(
																					"YES") || model2
																					.getValueAt(i, 32)
																					.toString()
																					.equalsIgnoreCase("NO"))) {
										pointToCell_New_Annex2(
												"Invalid tax deducted at higher rate",
												i, 32);
										isValid = true;
										break;
									}
								}

								if (!GrpuUtil.isInt(model2.getValueAt(i, 1)
										.toString())
										|| model2.getValueAt(i, 1).toString()
										.length() > 9) {
									pointToCell_New_Annex2(
											"Sr number should be a Number", i,
											1);
									isValid = true;
									break;
								}

								if (GrpuUtil.checkPan(model2.getValueAt(i, 3)
										.toString())) {
									pointToCell_New_Annex2(
											"Not a Valid Pan number", i, 3);
									isValid = true;
									break;
								}

								if (!GrpuUtil.isValidCharString(model2
										.getValueAt(i, 4).toString())) {
									pointToCell_New_Annex2("Not a Valid Name",
											i, 4);
									isValid = true;
									break;
								}
								//newly modified for FRD1.6 by akansha
								if(new Integer(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4)) < 2013){
									if (!GrpuUtil.isDate(model2.getValueAt(i, 6)
											.toString().substring(0, 1),
											model2.getValueAt(i, 6).toString()
											.substring(3, 4), model2
											.getValueAt(i, 6).toString()
											.substring(6, 9))) {
										pointToCell_New_Annex2("Not a Valid Date",
												i, 6);
										isValid = true;
										break;
									}

									if (!GrpuUtil.isDate(model2.getValueAt(i, 7)
											.toString().substring(0, 1),
											model2.getValueAt(i, 7).toString()
											.substring(3, 4), 
											model2.getValueAt(i, 7).toString()
											.substring(6, 9))) {
										pointToCell_New_Annex2("Not a Valid Date",
												i, 7);
										isValid = true;
										break;
									}
								}

								if (model2.getValueAt(i, 3) == null
										|| model2.getValueAt(i, 3).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Pan No Should not be empty ", i, 3);
									isValid = true;
									break;
								}

								if (model2.getValueAt(i, 4) == null
										|| model2.getValueAt(i, 4).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Name Should not be empty ", i, 4);
									isValid = true;
									break;
								}
								if (model2.getValueAt(i, 5) == null
										|| model2.getValueAt(i, 5).toString()
										.equals("")) {
									pointToCell_New_Annex2(
											"Deductee Type Should not be empty ",
											i, 5);
									isValid = true;
									break;
								}

								//newly modified for FRD1.6 by akansha
								if(new Integer(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4)) < 2013){
									if (model2.getValueAt(i, 6) == null
											|| model2.getValueAt(i, 6).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"From Date Should not be empty ",
												i, 6);
										isValid = true;
										break;
									}
									if (model2.getValueAt(i, 7) == null
											|| model2.getValueAt(i, 7).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"To Date Should not be empty ", i,
												7);
										isValid = true;
										break;
									}
								}
								//***************************************************	

								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 10).toString(), 4)
										|| model2.getValueAt(i, 10).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Total Salary Amount is not valid ",
											i, 10);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 11).toString(), 2)
										|| model2.getValueAt(i, 11).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Deduction Under Section VI(ii) is not valid ",
											i, 11);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 12).toString(), 2)
										|| model2.getValueAt(i, 12).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Deduction Under Section VI(iii) is not valid ",
											i, 12);
									isValid = true;
									break;
								}
								/*********************************************************/				
								//FRD 2.3 added 16(ia)
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 13).toString(), 2)
										|| model2.getValueAt(i, 13).toString()
												.length() > 15) {
									pointToCell_New_Annex2(
											"Total Deduction under VI(ii) and VI(iii) is not valid ",
											i, 13);
									isValid = true;
									break;
								}
								/*********************************************************/	
								//								System.out.println("SD record throwing error: "
								//										+ i + " Value:"
								//										+ model2.getValueAt(i, 14).toString());
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 14).toString(), 4)
										|| model2.getValueAt(i, 14).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Income Chargeable under head salaries is not valid ",
											i, 14);
									isValid = true;
									break;
								}

								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 15).toString()
										.replaceAll("-", "0"), 4)
										|| model2.getValueAt(i, 15).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Income Chargeable under anyother head salaries is not valid ",
											i, 15);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 16).toString(), 4)
										|| model2.getValueAt(i, 16).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Gross Total is not valid ", i, 16);
									isValid = true;
									break;
								}
								/****************** Added for 2.7 Start ********************/
								
								if (new Integer(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4)) < 2018)
										
								{
									if (model2.getValueAt(i, 17) == null
											|| model2.getValueAt(i, 17).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"Aggregate Amount of Deduuction under 80CCF Should not be empty ",
												i, 17);
										isValid = true;
										break;
									}




									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 17).toString(), 2)
											|| model2.getValueAt(i, 17).toString()
											.length() > 15) {
										pointToCell_New_Annex2(
												"Aggregate Amount of Deduuction under 80CCF is not valid ",
												i, 17);
										isValid = true;
										break;
									}

								}
								
                           /****************** Added for 2.7 Start ********************/
								
								if (new Integer(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4)) < 2018)
										
								{
									if (model2.getValueAt(i, 17) == null
											|| model2.getValueAt(i, 17).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"Aggregate Amount of Deduuction under 80CCF Should not be empty ",
												i, 17);
										isValid = true;
										break;
									}




									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 17).toString(), 2)
											|| model2.getValueAt(i, 17).toString()
											.length() > 15) {
										pointToCell_New_Annex2(
												"Aggregate Amount of Deduuction under 80CCF is not valid ",
												i, 17);
										isValid = true;
										break;
									}

								}
								
								/****************** Added for 2.7 End ********************/								
													
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 20).toString(), 2)
										|| model2.getValueAt(i, 20).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Aggregate Amount of Deduuction under any other is not valid ",
											i, 20);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 21).toString(), 2)
										|| model2.getValueAt(i, 21).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Total amount under Chapter VIA is not valid ",
											i, 21);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 22).toString(), 4)
										|| model2.getValueAt(i, 22).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Total Taxable Income is not valid ",
											i, 22);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 23).toString(), 2)
										|| model2.getValueAt(i, 23).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Income Tax on total Income is not valid ",
											i, 23);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 24).toString(), 2)
										|| model2.getValueAt(i, 24).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Surcharge is not valid ", i, 24);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 25).toString(), 2)
										|| model2.getValueAt(i, 25).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Education CESS is not valid ", i,
											25);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 26).toString(), 2)
										|| model2.getValueAt(i, 26).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Income Tax relief under Section 89 is not valid ",
											i, 26);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 27).toString(), 2)
										|| model2.getValueAt(i, 27).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Net tax payable is not valid ", i,
											27);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(model2
										.getValueAt(i, 30).toString(), 2)
										|| model2.getValueAt(i, 30).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Total Amount of tax deducted at source for whole year including TDS on superannuation is not valid ",
											i, 30);
									isValid = true;
									break;
								}
								if (GrpuUtil.isDecimalCreateFile(
										model2.getValueAt(i, 31).toString()
										.replace("-", "0"), 2)
										|| model2.getValueAt(i, 31).toString()
										.length() > 15) {
									pointToCell_New_Annex2(
											"Shortfall in tax deduction is not valid ",
											i, 31);
									isValid = true;
									break;
								}



							}
							//newly added for FRD1.6 by akansha
							if(new Integer(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4)) >= 2016) {
								if (model2.getValueAt(i, 33) == null
										|| model2.getValueAt(i, 33).toString()
										.equals("--Select--") || model2.getValueAt(i, 33).toString()
										.equals("")
										|| model2.getValueAt(i, 42) == null
										|| model2.getValueAt(i, 42).toString()
										.equals("--Select--")|| model2.getValueAt(i, 42).toString()
										.equals("")) {
									isValid = true;
									//newly added for FRD1.6 by akansha
									if (model2.getValueAt(i, 33) == null
											|| model2.getValueAt(i, 33).toString()
											.equals("--Select--") || model2.getValueAt(i, 33).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 33 under (i.e. Whether house rent allowance claim exceeds rupees one lakh) cannot be blank under Annexure II",
												i, 33);
										break;
									}

									if (model2.getValueAt(i, 42) == null
											|| model2.getValueAt(i, 42).toString()
											.equals("--Select--") || model2.getValueAt(i, 42).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 42 under (i.e. Whether Interest paid to the lender under the head 'Income from house property') cannot be blank under Annexure II",
												i, 42);
										break;
									}
									//**************************************************
								}else{
									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 34) != null || !model2.getValueAt(i, 34).toString().equals(""))) {
										if((model2.getValueAt(i, 34).toString().equals("--Select--") || model2.getValueAt(i, 34).toString().equals("--SELECT--") || model2.getValueAt(i, 34).toString().equals(""))
												&& (model2.getValueAt(i, 36).toString().equals("--Select--") || model2.getValueAt(i, 36).toString()
														.equals("--SELECT--") || model2.getValueAt(i, 36).toString().equals(""))
														&& (model2.getValueAt(i, 38).toString().equals("--Select--") || model2.getValueAt(i, 38).toString()
																.equals("--SELECT--") || model2.getValueAt(i, 38).toString().equals(""))
																&& (model2.getValueAt(i, 40).toString().equals("--Select--") || model2.getValueAt(i, 40).toString()
																		.equals("--SELECT--") || model2.getValueAt(i, 40).toString().equals(""))){
											pointToCell_New_Annex2(
													"Column no. 34 under (i.e. PAN of landlord 1) cannot be blank under Annexure II",
													i, 34);
											isValid = true;
											break;

										}

									}
									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 35) == null
											|| model2.getValueAt(i, 35).toString()
											.equals(""))) {

										if(model2.getValueAt(i, 34).toString().equals("--Select--") || model2.getValueAt(i, 34).toString().equals("--SELECT--") || model2.getValueAt(i, 34).toString().equals("")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 35 under (i.e. Name of landlord 1) cannot be blank under Annexure II",
													i, 35);
											isValid = true;
											break;
										}
									}

									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 37) != null
											&& !model2.getValueAt(i, 37).toString()
											.equals("")) && (model2.getValueAt(i, 36) == null
											|| (model2.getValueAt(i, 36)!=null && model2.getValueAt(i, 36).toString()
											.equals("")))) {
										pointToCell_New_Annex2(
												"Column no. 36 under (i.e. PAN of landlord 2) cannot be blank under Annexure II",
												i, 36);
										isValid = true;
										break;

									}
									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 36) != null
											&& !model2.getValueAt(i, 36).toString()
											.equals("")) && (model2.getValueAt(i, 37) == null
											|| (model2.getValueAt(i, 37)!=null && model2.getValueAt(i, 37).toString()
											.equals("")))) {
										if(model2.getValueAt(i, 36).toString().equals("--Select--") || model2.getValueAt(i, 36).toString().equals("--SELECT--")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 37 under (i.e. Name of landlord 2) cannot be blank under Annexure II",
													i, 37);
											isValid = true;
											break;
										}
									}

									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 39) != null
											&& !model2.getValueAt(i, 39).toString()
											.equals("")) && (model2.getValueAt(i, 38) == null
											|| (model2.getValueAt(i, 38)!=null && model2.getValueAt(i, 38).toString()
											.equals("")))) {
										pointToCell_New_Annex2(
												"Column no. 38 under (i.e. PAN of landlord 3) cannot be blank under Annexure II",
												i, 38);
										isValid = true;
										break;

									}


									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 38) != null
											&& !model2.getValueAt(i, 38).toString()
											.equals("")) && (model2.getValueAt(i, 39) == null
											|| (model2.getValueAt(i, 39)!=null && model2.getValueAt(i, 39).toString()
											.equals("")))) {
										if(model2.getValueAt(i, 38).toString().equals("--Select--") || model2.getValueAt(i, 38).toString().equals("--SELECT--")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 39 under (i.e. Name of landlord 3) cannot be blank under Annexure II",
													i, 39);
											isValid = true;
											break;
										}
									}

									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 41) != null
											&& !model2.getValueAt(i, 41).toString()
											.equals("")) && (model2.getValueAt(i, 40) == null
											|| (model2.getValueAt(i, 40)!=null && model2.getValueAt(i, 40).toString()
											.equals("")))) {
										pointToCell_New_Annex2(
												"Column no. 40 under (i.e. PAN of landlord 4) cannot be blank under Annexure II",
												i, 40);
										isValid = true;
										break;

									}


									if (model2.getValueAt(i, 33)!=null && "Yes".equals(model2.getValueAt(i, 33).toString())
											&& (model2.getValueAt(i, 40) != null
											&& !model2.getValueAt(i, 40).toString()
											.equals("")) && (model2.getValueAt(i, 41) == null
											|| (model2.getValueAt(i, 41)!=null && model2.getValueAt(i, 41).toString()
											.equals("")))) {
										if(model2.getValueAt(i, 40).toString().equals("--Select--") || model2.getValueAt(i, 40).toString().equals("--SELECT--")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 41 under (i.e. Name of landlord 4) cannot be blank under Annexure II",
													i, 41);
											isValid = true;
											break;
										}
									}
									//*****************************************************
									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 43) != null || !model2.getValueAt(i, 43).toString().equals(""))) {
										if((model2.getValueAt(i, 43).toString().equals("--Select--") || model2.getValueAt(i, 43).toString().equals("--SELECT--") || model2.getValueAt(i, 43).toString().equals(""))
												&& (model2.getValueAt(i, 45).toString().equals("--Select--") || model2.getValueAt(i, 45).toString()
														.equals("--SELECT--") || model2.getValueAt(i, 45).toString().equals(""))
														&& (model2.getValueAt(i, 47).toString().equals("--Select--") || model2.getValueAt(i, 47).toString()
																.equals("--SELECT--") || model2.getValueAt(i, 47).toString().equals(""))
																&& (model2.getValueAt(i, 49).toString().equals("--Select--") || model2.getValueAt(i, 49).toString()
																		.equals("--SELECT--") || model2.getValueAt(i, 49).toString().equals(""))){
											pointToCell_New_Annex2(
													"Column no. 43 under (i.e. PAN of lender 1) cannot be blank under Annexure II",
													i, 43);
											isValid = true;
											break;

										}

									}
									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 44)==null || model2.getValueAt(i, 44).toString()
											.equals(""))) {
										if(model2.getValueAt(i, 43).toString().equals("--Select--") || model2.getValueAt(i, 43).toString().equals("--SELECT--") || model2.getValueAt(i, 43).toString().equals("")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 44 under (i.e. Name of lender1) cannot be blank under Annexure II",
													i, 44);
											isValid = true;
											break;
										}
									}

									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 46) != null
											&& !model2.getValueAt(i, 46).toString()
											.equals("")) && (model2.getValueAt(i, 45) == null
											|| (model2.getValueAt(i, 45)!=null && model2.getValueAt(i, 45).toString()
											.equals("")))) {
										pointToCell_New_Annex2(
												"Column no. 45 under (i.e. PAN of lender 2) cannot be blank under Annexure II",
												i, 45);
										isValid = true;
										break;

									}
									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 45) != null
											&& !model2.getValueAt(i, 45).toString()
											.equals("")) && (model2.getValueAt(i, 46) == null
											|| (model2.getValueAt(i, 46)!=null && model2.getValueAt(i, 46).toString()
											.equals("")))) {
										if(model2.getValueAt(i, 45).toString().equals("--Select--") || model2.getValueAt(i, 45).toString().equals("--SELECT--")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 46 under (i.e. Name of lender 2) cannot be blank under Annexure II",
													i, 46);
											isValid = true;
											break;
										}
									}

									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 48) != null
											&& !model2.getValueAt(i, 48).toString()
											.equals("")) && (model2.getValueAt(i, 47) == null
											||(model2.getValueAt(i, 47)!=null && model2.getValueAt(i, 47).toString()
											.equals("")))) {
										pointToCell_New_Annex2(
												"Column no. 47 under (i.e. PAN of lender 3) cannot be blank under Annexure II",
												i, 47);
										isValid = true;
										break;

									}


									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 47) != null
											&& !model2.getValueAt(i, 47).toString()
											.equals("")) && (model2.getValueAt(i, 48) == null
											|| (model2.getValueAt(i, 48)!=null && model2.getValueAt(i, 48).toString()
											.equals("")))) {
										if(model2.getValueAt(i, 47).toString().equals("--Select--") || model2.getValueAt(i, 47).toString().equals("--SELECT--")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 48 under (i.e. Name of lender 3) cannot be blank under Annexure II",
													i, 48);
											isValid = true;
											break;
										}
									}

									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 50) != null
											&& !model2.getValueAt(i, 50).toString()
											.equals("")) && (model2.getValueAt(i, 49) == null
											||(model2.getValueAt(i, 49)!=null && model2.getValueAt(i, 49).toString()
											.equals("")))) {
										pointToCell_New_Annex2(
												"Column no. 49 under (i.e. PAN of lender 4) cannot be blank under Annexure II",
												i, 49);
										isValid = true;
										break;

									}


									if (model2.getValueAt(i, 42)!=null && "Yes".equals(model2.getValueAt(i, 42).toString())
											&& (model2.getValueAt(i, 49) != null
											&& !model2.getValueAt(i, 49).toString()
											.equals("")) && (model2.getValueAt(i, 50) == null
											||(model2.getValueAt(i, 50) != null && model2.getValueAt(i, 50).toString()
											.equals("")))) {
										if(model2.getValueAt(i, 49).toString().equals("--Select--") || model2.getValueAt(i, 49).toString().equals("--SELECT--")){

										}else{
											pointToCell_New_Annex2(
													"Column no. 50 under (i.e. Name of lender 4) cannot be blank under Annexure II",
													i, 50);
											isValid = true;
											break;
										}
									}

									//newly added for FRD1.6 by akansha
									// SuperAnnuation conditions for applicability of Date fields
									//for fin year 2013 onwards as per applicability of superannuation records
									if(model2.getValueAt(i, 51)!=null && new Integer(JComboBox_Form_Sub1_finYear
											.getSelectedItem().toString()
											.substring(0, 4)) >= 2013){
										if("No".equals(model2.getValueAt(i, 51).toString())){

											// Case handled where superannuation flag is "No" and date is manadatory to
											// be mentioned for 'SD' record
											//These include normal behavior of validating as previous RPU
											if (model2.getValueAt(i, 6) == null
													|| model2.getValueAt(i, 6).toString()
													.equals("")) {
												pointToCell_New_Annex2(
														"From Date Should not be empty ",
														i, 6);
												isValid = true;
												break;

											}
											if (model2.getValueAt(i, 7) == null
													|| model2.getValueAt(i, 7).toString()
													.equals("")) {
												pointToCell_New_Annex2(
														"To Date Should not be empty ", i,
														7);
												isValid = true;
												break;
											}

											if(model2.getValueAt(i, 6)!=null && !"".equals(model2.getValueAt(i, 6).toString())){
												if (!GrpuUtil.isDate(model2.getValueAt(i, 6)
														.toString().substring(0, 1),
														model2.getValueAt(i, 6).toString()
														.substring(3, 4), model2
														.getValueAt(i, 6).toString()
														.substring(6, 9))) {
													pointToCell_New_Annex2("Not a Valid Date",
															i, 6);
													isValid = true;
													break;
												}
											}

											if(model2.getValueAt(i, 7)!=null && !"".equals(model2.getValueAt(i, 7).toString())){
												if (!GrpuUtil.isDate(model2.getValueAt(i, 7)
														.toString().substring(0, 1),
														model2.getValueAt(i, 7).toString()
														.substring(3, 4), model2
														.getValueAt(i, 7).toString()
														.substring(6, 9))) {
													pointToCell_New_Annex2("Not a Valid Date",
															i, 7);
													isValid = true;
													break;
												}
											}

											//***********************************************************
											//*****END of normal validations*****************************	
										}
									}



									//***********************************************************
								}
							}
                           							


							if(new Integer(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4)) >= 2013){
								if(model2.getValueAt(i, 51) == null
										|| model2.getValueAt(i, 51).toString()
										.equals("--Select--") || model2.getValueAt(i, 51).toString()
										.equals("")){
									isValid = true;
									if (model2.getValueAt(i, 51) == null
											|| model2.getValueAt(i, 51).toString()
											.equals("--Select--") || model2.getValueAt(i, 51).toString()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 51 under (i.e. whether contributions paid by the trustees of an approved superannuation fund) cannot be blank under Annexure II",
												i, 51);
										break;
									}
								}else if(model2.getValueAt(i, 51) == null
										|| model2.getValueAt(i, 51).toString()
										.equals("Yes")){
									if (model2.getValueAt(i, 52) == null
											|| model2.getValueAt(i, 52).toString().trim()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 52 under (i.e. Name of the superannuation fund) cannot be blank under Annexure II",
												i, 52);
										isValid = true;
										break;
									}
									if (model2.getValueAt(i, 53) == null
											|| model2.getValueAt(i, 53).toString().trim()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 53 under (i.e. Date from which the employee has contributed to the<br> superannuation fund) cannot be blank under Annexure II",
												i, 53);
										isValid = true;
										break;
									}
									if (model2.getValueAt(i, 54) == null
											|| model2.getValueAt(i, 54).toString().trim()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 54 under (i.e. Date to which the employee has contributed to the<br> superannuation fund) cannot be blank under Annexure II",
												i, 54);
										isValid = true;
										break;
									}
									if (model2.getValueAt(i, 55) == null
											|| model2.getValueAt(i, 55).toString().trim()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 55 under (i.e. The amount of contribution repaid on account of principal<br> and interest) cannot be blank under Annexure II",
												i, 55);
										isValid = true;
										break;
									}
									if (model2.getValueAt(i, 56) == null
											|| model2.getValueAt(i, 56).toString().trim()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 56 under (i.e The average rate of deduction of tax during the<br> preceding three years) cannot be blank under Annexure II",
												i, 56);
										isValid = true;
										break;
									}
									if (model2.getValueAt(i, 57) == null
											|| model2.getValueAt(i, 57).toString().trim()
											.equals("")) {
										pointToCell_New_Annex2(
												"Column no. 57 under (i.e. The amount of tax deducted on repayment) cannot be blank under Annexure II",
												i, 57);
										isValid = true;
										break;
									}
								}
							}


						}

					}

					if ("Regular".equals(valueOfTypeOfStmt)) {
						for (int i = 2; i < sdRowCount; i++) {
							
							

							if (new Integer(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4)) >= 2013) {
								if ((model2.getValueAt(i, 8) == null || model2
										.getValueAt(i, 9) == null)
										|| (model2.getValueAt(i, 8).toString()
												.equals("") || model2
												.getValueAt(i, 9).toString()
												.equals(""))) {
									isValid = true;

									if (model2.getValueAt(i, 8) == null
											|| model2.getValueAt(i, 8)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Taxable Amount Should not be empty ",
												i, 8);
										break;
									}
									if (model2.getValueAt(i, 9) == null
											|| model2.getValueAt(i, 9)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Reported Taxable Amount Should not be empty ",
												i, 9);
										break;
									}
								} else {

									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 8).toString(), 2)
											|| model2.getValueAt(i, 8)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Taxable Amount is invalid ",
												i, 8);
										isValid = true;
										break;
									}
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 9).toString(), 2)
											|| model2.getValueAt(i, 9)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Reported Taxable Amount is invalid ",
												i, 9);
										isValid = true;
										break;
									}

								}

								if ((model2.getValueAt(i, 28) == null || model2
										.getValueAt(i, 29) == null)
										|| (model2.getValueAt(i, 28).toString()
												.equals("") || model2
												.getValueAt(i, 29).toString()
												.equals(""))) {
									isValid = true;

									if (model2.getValueAt(i, 28) == null
											|| model2.getValueAt(i, 28)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"total amount of tax deducted at source Should not be empty ",
												i, 28);
										break;
									}
									if (model2.getValueAt(i, 29) == null
											|| model2.getValueAt(i, 29)
											.toString().equals("")) {
										pointToCell_New_Annex2(
												"Reported Amount of TDs by previous Employer  Should not be empty ",
												i, 29);
										break;
									}

								} else {

									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 28).toString(), 2)
											|| model2.getValueAt(i, 28)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"total amount of tax deducted at source is not valid ",
												i, 28);
										isValid = true;
										break;
									}
									if (GrpuUtil.isDecimalCreateFile(model2
											.getValueAt(i, 29).toString(), 2)
											|| model2.getValueAt(i, 29)
											.toString().length() > 15) {
										pointToCell_New_Annex2(
												"Reported Amount of TDs by previous Employer  is not valid ",
												i, 29);
										isValid = true;
										break;
									}

								}
							}

						}

					}
				}

			} else if ("Correction".equals(valueOfTypeOfStmt)) {
				isValid = corrval.validationsBH(this,mainObject);
			}

			if (!isValid) {

				CreateFile cr = new CreateFile(this, model, model1, model2,
						mainObject);
				if ("Regular".equals(valueOfTypeOfStmt)) {
					cr.createRegular();
				} else {
					cr.createCorrection(); // ---- by latish
				}
			}
			else
			{
			}
				} catch (Exception e2) {
			e2.printStackTrace();
		}

	}

	// ## Newly developed for correction Ver1.2 by Akansha
	public void pointToCell_New_Form(JComponent jcomp) {

		TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
		jcomp.requestFocus();
	}

	// ****************************************************

	//new develpment for FRD1.5 by akansha
	public void pointToCell_Annex1(int tabrow, int tabcol) {

		TabGRPU.setSelectedIndex(ANNE_TAB_INDEX);

		scrollToVisible(jTableTransacDetails1, tabrow - 1, tabcol-1);
	}
	public void pointToCell_Annex2(int tabrow, int tabcol) {

		TabGRPU.setSelectedIndex(ANNE2_TAB_INDEX);

		scrollToVisible(jTableTransacDetails2, tabrow - 1, tabcol-1);
	}
	//*******************************************************

	public void pointToCell_New_Annex2(String msg, int tabrow, int tabcol) {
		String message = msg + " at row : " + (tabrow - 1) + " and col : "
				+ (tabcol);
		TabGRPU.setSelectedIndex(ANNE2_TAB_INDEX);
		getMessage(message);
		scrollToVisible(jTableTransacDetails2, tabrow - 1, tabcol - 1);
	}

	public void pointToCell_New_Annex1(String msg, int tabrow, int tabcol) {
		String message = msg + " at row : " + (tabrow - 1) + " and col : "
				+ (tabcol);
		TabGRPU.setSelectedIndex(ANNE_TAB_INDEX);
		getMessage(message);
		scrollToVisible(jTableTransacDetails1, tabrow - 1, tabcol-1);
	}

	public void pointToCell_New_Challan(String msg, int tabrow, int tabcol) {
		String message = msg + " at row : " + (tabrow - 1) + " and col : "
				+ (tabcol + 1);
		TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
		getMessage(message);
		scrollToVisible(jTableTransacDetails, tabrow - 1, tabcol - 1);
	}

	public boolean isValidName(String s) {
		Pattern p = Pattern.compile("[^a-z0-9 ]", Pattern.CASE_INSENSITIVE);
		Matcher m = p.matcher(s);
		boolean b = m.find();
		return b;
	}

	public String getFileName(String file, File fileSelected) {

		fileNameInLowerCase = file.toLowerCase();
		int index_of_txt = fileNameInLowerCase.indexOf(".txt");
		int index_of_grpu = fileNameInLowerCase.length(); // change done for raw
		// file acceptance
		if (index_of_txt != -1) {
			fileName = file.substring(0, index_of_txt);
			path = fileSelected.getAbsolutePath();
			path = path.substring(0, path.lastIndexOf('\\'));

			return fileName;
		}
		if (index_of_grpu != -1) {
			fileName = file.substring(0, index_of_grpu);
			path = fileSelected.getAbsolutePath();
			path = path.substring(0, path.lastIndexOf('\\'));

			return fileName;
		} else {
			return file;
		}
	}

	// commente by amit
	public String getDdoMappingValue(int row, int col) {
		return "";
	}

	// Commented by //End
	public String getDeductorCategory() {
		return jComboBox_Deductor_Category.getSelectedItem().toString();

	}

	public void setErrorAt(int row, int col) {
		prevErrRow = errRow;
		prevErrCol = errCol;
		errRow = row;
		errCol = col;
		isError = true;
		if (prevErrRow != -1 && prevErrCol != -1)
			grpu.model.fireTableCellUpdated(prevErrRow, prevErrCol);
	}

	public void setNoErrorAt(int row, int col) {
		isError = false;
		if (errRow == row && errCol == col) {
			errRow = -1;
			errCol = -1;
		}
	}

	public static String getClipboard() {
		Transferable t = Toolkit.getDefaultToolkit().getSystemClipboard()
				.getContents(null);
		try {
			if (t != null && t.isDataFlavorSupported(DataFlavor.stringFlavor)) {
				String text = (String) t
						.getTransferData(DataFlavor.stringFlavor);
				return text;
			}
		} catch (UnsupportedFlavorException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

	public int actualRowsFilled(int filledrowNo[]) {
		int actualRowsAdded = 0;
		for (int i = 0; i < filledrowNo.length; i++)
			if (filledrowNo[i] != -1)
				actualRowsAdded++;

		return actualRowsAdded;
	}

	// Create File for the challan Here
	public boolean funValidate_challan(int filledrowNo[]) {
		int tabrow = 0;
		int tabcol = 0;
		int flg = 1;
		boolean gFlag = true;
		int actualRowsAdded = 0;
		try {
			actualRowsAdded = actualRowsFilled(filledrowNo);

			String typStmt = (String) jComboBox_TypOfStmt.getSelectedItem();
			if (typStmt.equals("Regular")) {
				if (!gFlag)
					return false;
			} else if (typStmt.equals("Correction")) {
				gFlag = validationForCorrection();
				if (!gFlag) {
					return false;
				}
				if (!gFlag)
					return false;
			}
			if (!gFlag)
				return false;
			if (!gFlag)
				return false;

			if (model.getRowCount() == 0) {
				int sel = TabGRPU.getSelectedIndex();
				if (sel == 0)
					TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("Number of rows in Challan Tab should be greater than or equal to 1. Press 'Add Rows' button for addition of rows");
				return false;
			}
			for (tabrow = 0; tabrow < model.getRowCount(); tabrow++) {

				if (tabrow == 0 || tabrow == 1)
					continue;

				if (filledrowNo[tabrow] < 0)
					continue;

				for (tabcol = 2; tabcol <= 22; tabcol++)

				{
					Object tabval = model.getValueAt(tabrow, tabcol);
					// Added Newly on 24032015 by Akansha
					int year1 = Integer.parseInt(JComboBox_Form_Sub1_finYear
							.getSelectedItem().toString().substring(0, 4));
					if (tabcol == 2) {
						if (tabval != null && !tabval.equals("")
								&& year1 <= 2012) {
							if ("--Select--".equals(tabval.toString())) {
								gFlag = true;
								if (gFlag) {
									pointToCell(
											"Valid Section Code should be provided",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;

								}
							}
						}
					}
					// *********************************
					if (tabcol == 3) {
						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								gFlag = GrpuUtil
										.isDecimal(tabval.toString(), 2);
								if (gFlag) {
									pointToCell(
											"Valid TDS amount must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}
							} else {
								pointToCell(
										"Length of the TDS can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break;
							}
						} else {

							pointToCell(
									"Valid TDS amount must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}
					}
					// validating the surcharge field
					if (tabcol == 4) {
						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								gFlag = GrpuUtil
										.isDecimal(tabval.toString(), 2);
								if (gFlag) {
									pointToCell(
											"Valid Surcharge amount must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}
							}

							else {
								pointToCell(
										"Length of the Surcharge can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						}

						else {
							pointToCell(
									"Valid Surcharge amount must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break;
						}

					}

					// validating the Education cess
					if (tabcol == 5) {

						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								gFlag = GrpuUtil
										.isDecimal(tabval.toString(), 2);
								if (gFlag) {
									pointToCell(
											"Valid Education Cess must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of the Education Cess can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						} else {
							pointToCell(
									"Valid Education Cess must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}

					}

					// End validating the Education cess

					// validating the interest
					if (tabcol == 6) {

						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								gFlag = GrpuUtil
										.isDecimal(tabval.toString(), 2);
								if (gFlag) {
									pointToCell(
											"Valid Interest must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of the Interest can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						} else {
							pointToCell(
									"Valid Interest must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}
					}

					// End interest

					// validating the Penalty/Others
					if (tabcol == 8) {

						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								gFlag = GrpuUtil
										.isDecimal(tabval.toString(), 2);
								if (gFlag) {
									pointToCell(
											"Valid Penalty/Others must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of Penalty/Others can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						} else {
							pointToCell(
									"Valid Penalty/Others must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}
					}
					// EndPenalty/Othres

					// validating Fee

					if (tabcol == 7) {
						if (Integer.parseInt(JComboBox_Form_Sub1_finYear
								.getSelectedItem().toString().substring(0, 4)) >= 2012) {

							if (tabval != null && !tabval.equals("")) {
								if (tabval.toString().length() <= 15) {
									gFlag = GrpuUtil.isDecimal(
											tabval.toString(), 2);
									if (gFlag) {
										pointToCell(
												"Valid Fee must be provided eg 1000.00",
												tabrow - 2, tabcol + 3);
										flg = 0;
										break;
									}

								}

								else {
									pointToCell(
											"Length of Fee can not exceed 15 digits",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break; // break if the field is empty
								}
							} else {
								pointToCell(
										"Valid Fee must be provided eg 1000.00",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						}
					}

					// End Fee

					// validating the Last total Tax Deposited

					if (typStmt.equals("Correction")) {

						if (tabcol == 9) {

							if (tabval != null && !tabval.equals("")) {
								if (tabval.toString().length() <= 15) {
									gFlag = GrpuUtil.isDecimal(
											tabval.toString(), 2);
									if (gFlag
											&& !"ADD".equalsIgnoreCase(model
													.getValueAt(tabrow, 1)
													.toString())) {
										pointToCell(
												"Valid Last Total Tax Deposited must be provided eg 1000.00",
												tabrow - 2, tabcol + 3);
										flg = 0;
										break;
									}

								}

								else {
									pointToCell(
											"Length of Last Total Tax Deposited can not exceed 15 digits",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break; // break if the field is empty
								}

							} else {
								pointToCell(
										"Valid Last Total Tax Deposited must be provided eg 1000.00",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						}

					}

					// End validating the Last total Tax Deposited

					// validating the Toatal Amount Deposited
					if (tabcol == 10) {
						double tds_c = 0;
						double sur_c = 0;
						double cess_c = 0;
						double int_c = 0;
						double fee_c = 0;
						double others_c = 0;
						double total_sum_depostd = 0;
						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								if (model.getValueAt(tabrow, 3) != null
										&& !model.getValueAt(tabrow, 3).equals(
												""))

									tds_c = Double.parseDouble(model
											.getValueAt(tabrow, 3).toString());

								if (model.getValueAt(tabrow, 4) != null
										&& !model.getValueAt(tabrow, 4).equals(
												""))

									sur_c = Double.parseDouble(model
											.getValueAt(tabrow, 4).toString());

								if (model.getValueAt(tabrow, 5) != null
										&& !model.getValueAt(tabrow, 5).equals(
												""))

									cess_c = Double.parseDouble(model
											.getValueAt(tabrow, 5).toString());

								if (model.getValueAt(tabrow, 6) != null
										&& !model.getValueAt(tabrow, 6).equals(
												""))

									int_c = Double.parseDouble(model
											.getValueAt(tabrow, 6).toString());

								if (model.getValueAt(tabrow, 7) != null
										&& !model.getValueAt(tabrow, 7).equals(
												""))

									fee_c = Double.parseDouble(model
											.getValueAt(tabrow, 7).toString());

								if (model.getValueAt(tabrow, 8) != null
										&& !model.getValueAt(tabrow, 8).equals(
												""))

									others_c = Double.parseDouble(model
											.getValueAt(tabrow, 8).toString());

								total_sum_depostd = tds_c + sur_c + cess_c
										+ int_c + fee_c + others_c;

								if ((total_sum_depostd != Double
										.parseDouble(tabval.toString()))) {
									pointToCell(
											" Valid Total Amount Deposited(4+5+6+7+8+9) must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of Total Amount Deposited(4+5+6+7+8+9) can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}

						} else {
							pointToCell(
									" Valid Last Total Tax Deposited(4+5+6+7+8+9) must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}

					}

					// End validating the Toatal Amount Deposited
					// validating Last BSR Code
					if (typStmt.equals("Correction")) {

						if (tabcol == 12) {

							if (tabval != null && !tabval.equals("")) {
								if (tabval.toString().length() == 7) {
									gFlag = GrpuUtil.isInt(tabval.toString());
									if (!gFlag) {
										pointToCell(
												"Valid Last BSR Code/24G recpt No  must be provided ",
												tabrow - 2, tabcol + 3);
										flg = 0;
										break;
									}

								}
								else {
									pointToCell(
											"Length of Last BSR Code/24G must be 7 digits",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break; // break if the field is empty
								}
							} 
						}

					}

					// End validating Last BSR Code

					// validating BSR Code/ReceiptN0 this validation to be done
					// at the time wheter tds deposited for book
					if (tabcol == 13) {

						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() == 7) {
								gFlag = GrpuUtil.isInt(tabval.toString());
								if (!gFlag) {
									pointToCell(
											"Valid  BSR Code/24G recpt No  must be provided ",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of  BSR Code/24G must be 7 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}

						} 
					}

					// End BSR Code/ReceiptN0

					// validating the Last date on which tax deposited

					if (typStmt.equals("Correction")) {

						if (tabcol == 14) {

							if (tabval != null && !tabval.equals("")) {
								if (tabval.toString().length() == 10) {
									char sep1 = tabval.toString().charAt(2);
									char sep2 = tabval.toString().charAt(5);
									String day = tabval.toString().substring(0,
											2);
									String month = tabval.toString().substring(
											3, 5);
									String year = tabval.toString().substring(
											6, 10);

									if (sep1 != '/' || sep2 != '/') {
										pointToCell(
												"Valid last date on which Tax deposited  must be provided ",
												tabrow - 2, tabcol + 3);
										flg = 0;
										break;

									}

									else if (!GrpuUtil.isInt(day)
											|| !GrpuUtil.isInt(month)
											|| !GrpuUtil.isInt(year)) {
										pointToCell(
												"Valid last date on which Tax deposited  must be provided ",
												tabrow - 2, tabcol + 3);
										flg = 0;
										break;
									}

									else if (GrpuUtil.isDate(day, month, year)) {

										pointToCell(
												"Valid last date on which Tax deposited  must be provided ",
												tabrow - 2, tabcol + 3);
										flg = 0;
										break;
									}

								}

								else {
									pointToCell(
											"Length of Last date on which Tax deposited is not valid must be of 10 digits",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break; // break if the field is empty
								}

							} else {
								pointToCell(
										"Valid Last date on which Tax deposited must be provided",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						}// idhar

					}

					// End Validating Last date on which tax deposited

					if (tabcol == 15) {

						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() == 10) {
								char sep1 = tabval.toString().charAt(2);
								char sep2 = tabval.toString().charAt(5);
								String day = tabval.toString().substring(0, 2);
								String month = tabval.toString()
										.substring(3, 5);
								String year = tabval.toString()
										.substring(6, 10);

								if (sep1 != '/' || sep2 != '/') {
									pointToCell(
											"Valid date on which Amnt deposited through challan  must be provided ",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;

								}

								else if (!GrpuUtil.isInt(day)
										|| !GrpuUtil.isInt(month)
										|| !GrpuUtil.isInt(year)) {
									pointToCell(
											"Valid date on which Amnt deposited through challan  must be provided ",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

								else if (GrpuUtil.isDate(day, month, year)) {

									pointToCell(
											"Valid date on which Amnt deposited through challan  must be provided ",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of date on which Amnt deposited through challan is not valid must be of 10 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}

						} else {
							pointToCell(
									"Valid date on which Amnt deposited through challan must be provided",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}

					}

					// Validating the Last DDO

					if (typStmt.equals("Correction")) {

						if (tabcol == 16) {

							if (tabval != null && !tabval.equals("")) {
								if (tabval.toString().length() == 5) {
									gFlag = GrpuUtil.isInt(tabval.toString());

									if (!gFlag) {
										pointToCell(
												"Valid Last Transfer Voucher No. must be provided ",
												tabrow - 2, tabcol + 3);
										flg = 0;
										break;
									}

								}

								else {
									pointToCell(
											"Length of Transfer Voucher No. must be 5 digits",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break; // break if the field is empty
								}

							} 
						}

					}

					// End Validating the Last DDO



					// Interest To be Allocated

					if (tabcol == 19) {

						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								gFlag = GrpuUtil
										.isDecimal(tabval.toString(), 2);
								if (gFlag) {
									pointToCell(
											"Valid Interest to be allocated must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of Interest to be allocated can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						} else {
							pointToCell(
									"Valid Interest to be allocated must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}
					}

					// End Interest To be Allocated

					// validating Others Field

					if (tabcol == 20) {

						if (tabval != null && !tabval.equals("")) {
							if (tabval.toString().length() <= 15) {
								gFlag = GrpuUtil
										.isDecimal(tabval.toString(), 2);
								if (gFlag) {
									pointToCell(
											"Valid Others Amount must be provided eg 1000.00",
											tabrow - 2, tabcol + 3);
									flg = 0;
									break;
								}

							}

							else {
								pointToCell(
										"Length of Others Amount can not exceed 15 digits",
										tabrow - 2, tabcol + 3);
								flg = 0;
								break; // break if the field is empty
							}
						} else {
							pointToCell(
									"Valid Others Amount must be provided eg 1000.00",
									tabrow - 2, tabcol + 3);
							flg = 0;
							break; // break if the field is empty
						}
					}

					// End validating Others Field



				}

				if (isError && isCreateFileFocusOut) {
					flg = 0;
					isError = false;
					isCreateFileFocusOut = false;
				}

				if (flg == 0)
					break;
			}

			if (flg == 0)
				return false;

			//newly commented for FRD1.6 by akansha
			if (actualRowsAdded == 0) {
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("Please enter Challan details");
				return false;
			}

			/*
			 * boolean result = checkMaxNoOfEntriesForEachTan();
			 * 
			 * if (!result) { return false; }
			 * 
			 * if (!tanFlagCheck()) { return false; }
			 */

			return true;
		} catch (NullPointerException e) {
			e.printStackTrace();
			return false;
		}

	}

	public void scrollToVisible(JTable table, int rowIndex, int vColIndex) {
		try {

			table.scrollRectToVisible(table.getCellRect(rowIndex, vColIndex,
					true));

			errRow = rowIndex + 1;
			errCol = vColIndex;
		} catch (Exception e) {

			e.printStackTrace();
		}
	}

	public int getLineNo() {
		lineNo++;
		return lineNo;
	}

	private void jButton_import_actionPerformed(ActionEvent e) {
		String fileExtsn = "";
		String getFileName = "";
		int gChk = 0;
		boolean gHashChk = false;
		try {

			delAllRowsDDO();

			File selFile = funOpenDialogBoxFVU();
			if (selFile != null) {
				getFileName = selFile.getName();
				if (getFileName.contains("."))
					fileExtsn = getFileName.substring(
							getFileName.lastIndexOf("."), getFileName.length());
				else
					fileExtsn = "";
				if (fileExtsn.equals(".tds")) {
					//gChk = fileValidate(selFile);
					import_or_open_file(selFile, method,"");
				}
				//if (fileExtsn.equals(""))
				//GrpuUtil.chkFileHash(selFile);
			}
		} catch (Exception e2) {
			e2.printStackTrace();
			getMessage("Exception occured : Import Button operation Failed");
		}
	}

	private File funOpenDialogBoxFVU() {
		String filename = File.separator + "tmp";
		JFileChooser fc = new JFileChooser(new File(filename));
		fc.setPreferredSize(new Dimension(500, 326));
		fc.addChoosableFileFilter(new MyFilterOpenFVU());
		fc.showOpenDialog(import_fileFrame);
		File selFile = fc.getSelectedFile();
		selFile = fc.getSelectedFile();
		return selFile;
	}

	public File funOpenDialogBoxGRPU() {
		String filename = File.separator + "tmp";
		JFileChooser fc = new JFileChooser();
		fc.setPreferredSize(new Dimension(500, 326));
		File selFile = null;
		fc.addChoosableFileFilter(new MyFilterGRPU());
		int result = fc.showOpenDialog(import_fileFrame);
		if(result == fc.CANCEL_OPTION)
			mainObject.openflag = false;
		else if(result == fc.ERROR_OPTION)
			mainObject.openflag = false;
		else
			mainObject.openflag = true;

		switch (result) {
		case 0: // '\0'
			selFile = fc.getSelectedFile();
			if (!checkFileName(selFile.getName())) {
				getMessage("Invalid File Name.\n  :  /  ?  >  <  *  \"  |  \\  ^  _ or Space, not allowed in File Name.");
				selFile = setSelectedFile(fc);
			} else {
				selFile = fc.getSelectedFile();
			}
			aPreSelectedFile = selFile;

			break;

		case 1: // '\001'
			selFile = null;

			break;

		case -1:
			selFile = null;
			break;
		}
		if (selFile == null)
			isOpened = false;
		else
			isOpened = true;
		selectedFile = selFile;
		return selFile;
	}

	public File setSelectedFile(JFileChooser theFileChooser) {
		int aResult = theFileChooser.showOpenDialog(import_fileFrame);
		File aFile = theFileChooser.getSelectedFile();
		boolean isFirst = true;
		switch (aResult) {
		default:
			break;

		case 0: // '\0'
			if (!checkFileName(aFile.getName())) {
				getMessage("Invalid File Name.\n  :  /  ?  >  <  *  \"  |  \\  ^  _ or Space, not allowed in File Name.");
				aFile = setSelectedFile(theFileChooser);
			} else {
				aFile = theFileChooser.getSelectedFile();
			}
			break;

		case 1: // '\001'
			aFile = null;
			break;

		case -1:
			aFile = null;
			break;
		}
		return aFile;
	}

	private File funSaveDialogBoxGRPU() {
		String filename = File.separator + "tmp";
		JFileChooser fc = new JFileChooser(new File(filename));
		fc.setPreferredSize(new Dimension(500, 326));
		File selFile = null;
		fc.addChoosableFileFilter(new MyFilterGRPU());
		int result = fc.showSaveDialog(import_fileFrame);
		switch (result) {
		case 0: // '\0'
			selFile = fc.getSelectedFile();
			break;

		case 1: // '\001'
			selFile = null;
			break;

		case -1:
			selFile = null;
			break;
		}
		return selFile;
	}

	private boolean import_or_open_file(File selFile, String method1,String typeOfFile) {
		//Newly commented by Akansha for progress bar 
		//final DemoProgressBar pgbar = new DemoProgressBar();
		String str = "";
		int caretCount = 0;
		int caretPos = 0;
		int nxtCaretPos = 0;
		int lastCaretPos = 0;
		int flagForRow =0;
		int flagForRowAnne2 = 0;
		boolean gTemp = false;
		boolean gTempFVUGRPU = false;
		boolean gSuccessFlag = true;
		boolean gHashFlag = true;
		String typOfHeader = "";
		String fileExtsn = "";
		String getFileName = "";
		String RegFH[] = new String[15];
		List<String> BatchHeader = null;
		Object TrsnDetails[] = null;
		Object ChllnDetails[] = null;
		Object AnnIIDetails[] = null;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
		DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		BufferedReader in = null;
		int rowNum = 0;
		Vector DtlforRow = new Vector();
		String stateCentrName = "";
		String LaststateCentrName = "";
		String stateName = "";
		String hashFromFile = "";
		String AbsoluteFilePath = "";
		String TypDed = "";
		String LastTypDed = "";
		method = method1;
		int indexForarray = 0;

		//temp code
		String key="key phrase used for XOR-ing";
		//*****************

		try {
			prevErrRow = -1;
			prevErrCol = -1;
			errRow = -1;
			errCol = -1;
			AbsoluteFilePath = selFile.getAbsolutePath();
			getFileName = selFile.getName();
			if (getFileName.contains("."))
				fileExtsn = getFileName.substring(getFileName.lastIndexOf("."),
						getFileName.length());
			else
				fileExtsn = ""; //
			boolean isFileValidated = validateImportedFile(selFile);

			if (!isFileValidated) {

				return false;
			}

			if (fileExtsn.equals(".tds")) // appending ! to bypass this check
				// for fvu
				// manish
			{
				mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));		
				int errCode = 0;

				if (errCode != 0) {
					mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));		
					getMessage(AbsoluteFilePath
							+ " : This is not the file you created. "
							+ "\nSome data has been tampered.Could not IMPORT File. ");
					gHashFlag = false;
					return false;
				} else {
					//newly added for FRD1.5 by Akansha
					mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	
					gHashFlag = true;
				}

			}

			if (fileExtsn.equals("")) // .grpu
			{
				// if(!GrpuUtil.ReadHashFromOpenFile(AbsoluteFilePath)) // by
				// Akansha
				// {
				// getMessage(AbsoluteFilePath +
				// " : File will not get opened as the data in the file has been "
				// + "changed from last saved file.");
				// gHashFlag = false;
				// }
				// else
				{
					// For Save menu
					if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
						mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));		
						//Newly commented by Akansha for progress bar 
						/*javax.swing.SwingUtilities.invokeLater(new Runnable() {
					            public void run() {
					                pgbar.createAndShowGUI();
					            }
					        });*/
						//****************************
						saveflg = true;
						saveaspath = String.valueOf(selFile);

					//System.out.print(saveaspath + "Save Path");
					}else if(valueOfTypeOfStmt.equalsIgnoreCase("Regular")){
						if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
							mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));	
					}
					fileOpenRecently = true;
										//System.out.println("Value Of File Open Recently = "	+ fileOpenRecently);
					gHashFlag = true;
				}
			}
			if (fileExtsn.equals("") && gHashFlag && model.getRowCount() > 0) // .grpu
				model.getDataVector().clear();
			if (selFile != null && (fileExtsn.equals("")) && "Open".equals(method)) // .grpu
			{//Open method:


				// Added by Latish
				ddlist.clear();
				// **********************
				// added by choia to get the row count for the drop down
				// modification

				row_count_annex1 = 0;
				row_count_annex2 = 0;
				row_count_challan = 0;
				challancount = 2;

				//new development for FRD1.5 by Akansha
				pancheckfagAnne2 ="";
				//new development for FRD1.3 by Akansha
				pancheckfag ="";
				if("Correction".equals(valueOfTypeOfStmt)){
					annexIcount.clear();
					annexIcount.add("");
					annexIIcount =""; // newly added for FRD1.5 by Akansha
				}
				//************************************				

				flagForRow=0;
				flagForRowAnne2 = 0;
				// end
				int ia = 0, ja = 0, ka = 0;
				checkPopup = 1; // For popup
				 System.out.println(fileExtsn);
				in = new BufferedReader(new FileReader(selFile));

				// Timer for uploading file
				//				System.out.println("Timer in: " + System.currentTimeMillis()
				//						/ 1000);
				// ******************
				/*	String akki ="";
				while((str = in.readLine())!=null){
					//temp code
					akki+=str;

					//*******************************
				}
				akki = Demo.base64decode( akki );
				akki = Demo.xorMessage(akki, key);
				//System.out.println("After decoding my str: "+ akki);
				String hee[] = akki.split("LineHash");
				//System.out.println("heeee...."+hee.length);*/
				while((str=in.readLine())!=null){
					//	str = hee[ak];
					//System.out.println("My str"+str);
					if (!gHashFlag) {
						gSuccessFlag = false;
						return false;
					}
					if (str.length() <= 20)
						continue;


					caretPos = 0;
					nxtCaretPos = 0;
					caretPos = str.indexOf("^", caretPos + 2);
					nxtCaretPos = str.indexOf("^", caretPos + 2);
					typOfHeader = str.substring(caretPos + 1, nxtCaretPos);
					if (typOfHeader.equals("FH")) {
						int NumOfCaret = GrpuUtil.checkCaretCount(str);

						RegFH = GrpuUtil.tokeniseFH(str);
						statementtype = RegFH[4].trim().toString().trim();
						tdsDate = changeDate(RegFH[5].trim().toString());
						// Added By manish garg

						if (statementtype.equalsIgnoreCase("C")
								&& fileExtsn.equals("")) {
							//newly developed for FRD1.3 by Akansha
							mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
							getError("Imported file is not a regular file.");
							gSuccessFlag = false;
							return false;
						} else if (valueOfTypeOfStmt
								.equalsIgnoreCase("Correction")
								&& fileExtsn.equals("")
								&& !statementtype.equalsIgnoreCase("C")) // .grpu
							// //
							// added
							// by
							// Akansha
						{
							//newly developed for FRD1.3 by Akansha
							mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
							getError("Imported file is not a correction file.");
							gSuccessFlag = false;
							return false;

						} else if (valueOfTypeOfStmt
								.equalsIgnoreCase("Regular")
								&& fileExtsn.equals("")
								&& !statementtype.equalsIgnoreCase("O")) // .grpu
							// //
							// added
							// by
							// Akansha
						{
							//newly developed for FRd1.3 by Akansha
							mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
							getError("Imported file is not a regular file.");
							gSuccessFlag = false;
							return false;

						}
						if (fileExtsn.equals(".fvu")) {
							FVUVersioninFile = RegFH[9].trim();

							try {
								// System.out.println(FVUVersioninFile);
								FVUVersioninFile = FVUVersioninFile.substring(
										4, 7).trim();
								FVUVerFile = Double
										.parseDouble(FVUVersioninFile);
								gTempFVUGRPU = FVUVerFile >= maxFVUVersion;

							} catch (Exception e2) {
								e2.printStackTrace();
								gSuccessFlag = false;
								return false;
							} finally {
								if (!gTempFVUGRPU) {
									getError("Incorrect File : FVU Version incorrect");
									gSuccessFlag = false;
									return false;
								}
							}
						}

					} else if (typOfHeader.equals("BH")) {
						// Code added for reading BH header added by Akansha
 						GRPUMain grpumain = this.mainObject;
						BatchHeader = GrpuUtil.tokeniseBH(str);
						// BatchHeader ne puri batch ki line read kr li
						// hai 4th token

						// Added by Akansha for adding static rows
						addStaticRows(model);

						//
						String formno = BatchHeader.get(4).toString();
						String dist = BatchHeader.get(62).toString();
						//System.out.println("Distinguish "+dist);
						if (fileExtsn.equals("")) {
							if (valueOfTypeOfStmt.equals("Correction")
									&& !"CONS".equals(dist)) { //new development for FRD1.3 by Akansha
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane
								.showMessageDialog(
										grpumain.contentPanel,
										"File you are trying to open is of 'Regular' type.");
								return false;
							} else if (valueOfTypeOfStmt.equals("Regular")
									&& "CONS".equals(dist)) {//new development for FRD1.3 by Akansha
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane
								.showMessageDialog(
										grpumain.contentPanel,
										"File you are trying to open is correction.");
								return false;
							}
						}
						if (formno.equals("24Q")) {
							if (this.formNumber.equals(formno)) {
								//	System.out.println("FILE HASH : " + filehash);
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								//new development for FRD1.3 by Akansha
								if("Correction".equals(valueOfTypeOfStmt))
									grpumain.retainSaveState();
								else
									grpumain.resetOldState();
								return false;
							}
						} else if (formno.equals("26Q")) {
							if (this.formNumber.equals(formno)) {
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								//new development for FRD1.3 by Akansha
								if("Correction".equals(valueOfTypeOfStmt))
									grpumain.retainSaveState();
								else
									grpumain.resetOldState();
								return false;

							}
						} else if (formno.equals("27Q")) {
							if (this.formNumber.equals(formno)) {
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								//new development for FRD1.3 by Akansha
								if("Correction".equals(valueOfTypeOfStmt))
									grpumain.retainSaveState();
								else
									grpumain.resetOldState();
								return false;
							}
						} else if (formno.equals("27EQ")) {
							if (this.formNumber.equals(formno)) {
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								//new development for FRD1.3 by Akansha
								if("Correction".equals(valueOfTypeOfStmt))
									grpumain.retainSaveState();
								else
									grpumain.resetOldState();
								return false;
							}
						}
						// **********************************************************************
					}
					if (typOfHeader.equals("CD")) { // Code added by Akansha
						ChllnDetails = GrpuUtil.tokenise(str);
						addBlankRows(1, true);
						model.setValueAt((ia + 1), (ia + 2), 0);
						ia++;
						int k = 2;
						for (int i = 4, j = 4; i <= TABLE_COLUMN_COUNT_challan; i++, j++) {
							model.setValueAt(ChllnDetails[j], challancount, k);
							k++;

						}
						if ("Correction".equals(valueOfTypeOfStmt)) {
							challantype += ChllnDetails[26];
							model.setValueAt(ChllnDetails[25], challancount, 1);
							//							System.out.println("Challan Mode:"
							//									+ ChllnDetails[25]);
							LastModeofDeposit.add(ChllnDetails[20].toString());

							//new development for FRD1.3 by Akansha
							//System.out.println("Challan 27 index: "+ChllnDetails[27].toString() );
							if(ChllnDetails[27]!=null && !"".equals(ChllnDetails[27].toString()) && !"LineHash".equals(ChllnDetails[27].toString()))
								annexIcount.add(ChllnDetails[27].toString());
						}

						challancount++;
						row_count_challan = challancount;
					}
					if (typOfHeader.equals("DD")) { // Code added by Akansha
						TrsnDetails = GrpuUtil.tokeniseAnnI(str);
						// System.out.println("String in anneI:"+str);
						if (TrsnDetails != null)
							ddlist.put(annIcount, TrsnDetails);
						 
						
						if ("24Q".equals(formNumber)) {
							// System.out.println("In 24Q: "
							// + TrsnDetails[31].toString());
							annIcolumn = TABLE_COLUMN_COUNT_annI_24Q; //RPU 3.2 fix added (+5) old value 31 //RPU 3.4 -2(35-2)
							if (TrsnDetails[33] != null
									&& !"".equals(TrsnDetails[33].toString())
									&& !"--Select--".equals(TrsnDetails[33]
											.toString()))
								pan_Updtn_Indicator.add(Integer
										.parseInt(TrsnDetails[33].toString()));
							if (TrsnDetails[34] != null	&& !"".equals(TrsnDetails[34].toString()))
							LastPanRefNo.add(TrsnDetails[34].toString());
							if (TrsnDetails[35] != null
									&& !"LineHash".equals(TrsnDetails[35]
											.toString()) && !"LineHash".equals(TrsnDetails[36]
													.toString()) && !"LineHash".equals(TrsnDetails[37]
															.toString())) {
								LastIncomeTax.add(TrsnDetails[35].toString());
								LastSurcharge.add(TrsnDetails[36].toString());
								LastEduCess.add(TrsnDetails[37].toString());
							}
							// new development for FRD1.3 by Akansha
							if (TrsnDetails[38] != null)
								pancheckfag += TrsnDetails[38].toString();

							// new development for newly appended value "F",
							// FRD1.9 on 18/01/17
							if (TrsnDetails[39] != null)
								strAnnexIColValue += TrsnDetails[39].toString();
							// ********************************************
							// } else if ("26Q".equals(formNumber)) {
							// annIcolumn = TABLE_COLUMN_COUNT_annI_26Q;
							// if (TrsnDetails[34] != null
							// && !"".equals(TrsnDetails[34].toString())
							// && !"--Select--".equals(TrsnDetails[34]
							// .toString()))
							// pan_Updtn_Indicator.add(Integer
							// .parseInt(TrsnDetails[34].toString()));
							// LastPanRefNo.add(TrsnDetails[35].toString());
							// if (TrsnDetails[36] != null
							// && !"LineHash".equals(TrsnDetails[36]
							// .toString())) {
							// LastIncomeTax.add(TrsnDetails[36].toString());
							// LastSurcharge.add(TrsnDetails[37].toString());
							// LastEduCess.add(TrsnDetails[38].toString());
							// }
							// //new development for FRD1.3 by Akansha
							// if(TrsnDetails[39]!=null)
							// pancheckfag += TrsnDetails[39].toString();
							//
							// //new development for newly appended value "F",
							// FRD1.9 on 18/01/17
							// if(TrsnDetails[40]!=null)
							// strAnnexIColValue += TrsnDetails[40].toString();
							//
							// System.out.println("In 26Q: 34" +
							// TrsnDetails[34].toString());
							// //"In 26Q: 39" + TrsnDetails[39].toString()
							// // +"In 26Q: 40" + TrsnDetails[40].toString()
							// //********************************************
							// } else if ("27Q".equals(formNumber)) {
							// annIcolumn = TABLE_COLUMN_COUNT_annI_27Q;
							// //newly added for fRD1.7 by akansha
							// //org value -- 39
							// System.out.println("annIcolumn  "+ annIcolumn);
							// if (TrsnDetails[45] != null
							// && !"".equals(TrsnDetails[45].toString())
							// && !"--Select--".equals(TrsnDetails[45]
							// .toString()))
							// pan_Updtn_Indicator.add(Integer
							// .parseInt(TrsnDetails[45].toString()));
							// //org value -- 40
							// //newly added for FRD1.6 by akansha
							// /*if (TrsnDetails[44] != null
							// && !"".equals(TrsnDetails[44].toString())
							// && !"LineHash"
							// .equalsIgnoreCase(TrsnDetails[44]
							// .toString()))*/
							// if (TrsnDetails[46] != null
							// && !"".equals(TrsnDetails[46].toString())
							// && !"--Select--".equals(TrsnDetails[46]
							// .toString()))
							// LastPanRefNo.add(TrsnDetails[46].toString());
							// //org value -- 41
							// if (TrsnDetails[47] != null
							// && !"LineHash"
							// .equalsIgnoreCase(TrsnDetails[47]
							// .toString())) {
							// LastIncomeTax.add(TrsnDetails[47].toString());
							// LastSurcharge.add(TrsnDetails[48].toString());
							// LastEduCess.add(TrsnDetails[49].toString());
							// }
							// //new development for FRD1.3 by Akansha
							// //org value -- 44
							// if(TrsnDetails[50]!=null)
							// pancheckfag += TrsnDetails[50].toString();
							//
							// //new development for newly appended value "F",
							// FRD1.9 on 18/01/17
							// if(TrsnDetails[51]!=null)
							// strAnnexIColValue += TrsnDetails[51].toString();
						} else if ("26Q".equals(formNumber)) {
							annIcolumn = TABLE_COLUMN_COUNT_annI_26Q;
							System.out.println("annIcolumn  " + annIcolumn);
							if (TrsnDetails[39] != null
									&& !"".equals(TrsnDetails[39].toString())
									&& !"--Select--".equals(TrsnDetails[39]
											.toString()) && !"LineHash".equals(TrsnDetails[39]
													.toString()))
								pan_Updtn_Indicator.add(Integer
										.parseInt(TrsnDetails[39].toString()));
							if (!"LineHash".equals(TrsnDetails[40]
									.toString()))
															LastPanRefNo.add(TrsnDetails[40].toString());
							if (TrsnDetails[41] != null
									&& !"LineHash".equals(TrsnDetails[41]
											.toString())) {
								LastIncomeTax.add(TrsnDetails[41].toString());
								LastSurcharge.add(TrsnDetails[42].toString());
								LastEduCess.add(TrsnDetails[43].toString());
							}
							// new development for FRD1.3 by Akansha
							if (TrsnDetails[44] != null)
								pancheckfag += TrsnDetails[44].toString();

							// new development for newly appended value "F",
							// FRD1.9 on 18/01/17
							if (TrsnDetails[45] != null)
								strAnnexIColValue += TrsnDetails[45].toString();

						//	System.out.println("In 26Q: 41"+ TrsnDetails[41].toString());

						} else if ("27Q".equals(formNumber)) {
																								
							annIcolumn = TABLE_COLUMN_COUNT_annI_27Q;
							//newly added for fRD1.7 by akansha
							
							if (TrsnDetails[48] != null
									&& !"".equals(TrsnDetails[48].toString())
									&& !"--Select--".equals(TrsnDetails[48]
											.toString()))
								pan_Updtn_Indicator.add(Integer
										.parseInt(TrsnDetails[48].toString()));
							if (!"LineHash".equals(TrsnDetails[49].toString()))
															LastPanRefNo.add(TrsnDetails[49].toString());
							//org value -- 41
							if (TrsnDetails[50] != null
									&& !"LineHash"
									.equalsIgnoreCase(TrsnDetails[50]
											.toString())) {
								LastIncomeTax.add(TrsnDetails[50].toString());
								LastSurcharge.add(TrsnDetails[51].toString());
								LastEduCess.add(TrsnDetails[52].toString());
							}
							//new development for FRD1.3 by Akansha
					
							if(TrsnDetails[53]!=null)
								pancheckfag += TrsnDetails[53].toString();

							//new development for newly appended value "F", FRD1.9 on 18/01/17
							if(TrsnDetails[54]!=null)
								strAnnexIColValue += TrsnDetails[54].toString();
						
						
						} else if ("27EQ".equals(formNumber)) {
						
							annIcolumn = TABLE_COLUMN_COUNT_annI_27EQ;
							if (TrsnDetails[42] != null   //old value 37  (42-5(new fillers))  //RPU 3.4 -2(41-2)
									&& !"".equals(TrsnDetails[42].toString())
									&& !"--Select--".equals(TrsnDetails[42]
											.toString()) && !"LineHash".equals(TrsnDetails[42].toString()) && 
									"Correction".equals(valueOfTypeOfStmt))
								pan_Updtn_Indicator.add(Integer
										.parseInt(TrsnDetails[42].toString()));	
							LastPanRefNo.add(TrsnDetails[43].toString());
							if (TrsnDetails[44] != null && !"LineHash".equals(TrsnDetails[44]
									.toString()) && !"LineHash".equals(TrsnDetails[45]
											.toString())
									&& !"LineHash".equals(TrsnDetails[46]
											.toString())) {
								LastIncomeTax.add(TrsnDetails[44].toString());
								LastSurcharge.add(TrsnDetails[45].toString());
								LastEduCess.add(TrsnDetails[46].toString());
							}
							// new development for FRD1.3 by Akansha
							if (TrsnDetails[47] != null)
								pancheckfag += TrsnDetails[47].toString();

							// new development for newly appended value "F",
							// FRD1.9 on 18/01/17
							if (TrsnDetails[48] != null)  //rpu 3.1 bug fix 18/May/2020
								strAnnexIColValue += TrsnDetails[48].toString();
							
							/** COmmentred fro RPU 3.5 Observation 19
							annIcolumn = TABLE_COLUMN_COUNT_annI_27EQ;
							if (TrsnDetails[39] != null   //old value 37  (42-5(new fillers))  //RPU 3.4 -2(41-2)
									&& !"".equals(TrsnDetails[39].toString())
									&& !"--Select--".equals(TrsnDetails[39]
											.toString()) && !"LineHash".equals(TrsnDetails[39].toString()) && 
									"Correction".equals(valueOfTypeOfStmt))
								pan_Updtn_Indicator.add(Integer
										.parseInt(TrsnDetails[39].toString()));
							if(TrsnDetails[40] != null  && !"".equals(TrsnDetails[40].toString()))
							LastPanRefNo.add(TrsnDetails[40].toString());
							if (TrsnDetails[41] != null && !"LineHash".equals(TrsnDetails[41]
									.toString()) && !"LineHash".equals(TrsnDetails[42]
											.toString())
									&& !"LineHash".equals(TrsnDetails[43]
											.toString())) {
								LastIncomeTax.add(TrsnDetails[41].toString());
								LastSurcharge.add(TrsnDetails[42].toString());
								LastEduCess.add(TrsnDetails[43].toString());
							}
							// new development for FRD1.3 by Akansha
							if (TrsnDetails[44] != null)
								pancheckfag += TrsnDetails[44].toString();

							// new development for newly appended value "F",
							// FRD1.9 on 18/01/17
							if (TrsnDetails[45] != null && TrsnDetails[45] !=null)  //rpu 3.1 bug fix 18/May/2020
								strAnnexIColValue += TrsnDetails[45].toString();
						
							/*************************************************************************/
						}
						int k = 1;
						if (model1.getRowCount() > 0 && flagForRow != 1) {
							int rowCount = model1.getRowCount();
							// Remove rows one by one from the end of the table
							for (int i = rowCount - 1; i >= 2; i--) {
								model1.removeRow(i);
							}
							flagForRow = 1;
						}

						if ("Regular".equals(valueOfTypeOfStmt))
							addBlankRows1(1, 0, false, true);
						// new development for FRD1.3 by akansha
						else if ("Correction".equals(valueOfTypeOfStmt)) {
							if (TrsnDetails[5] != null
									&& !"".equals(TrsnDetails[5].toString())) {
								if ("ADD".equals(TrsnDetails[5].toString()))
									addBlankRows1(1, 0, false, false);
								else if ("--Select--".equals(TrsnDetails[5]
										.toString())
										|| ("UPDATE".equals(TrsnDetails[5]
												.toString()))
										|| ("PAN UPDATE".equals(TrsnDetails[5]
												.toString())))
									addBlankRows1(1, 0, false, true);
							}
						}
						// *****************************************************
						model1.setValueAt((ja + 1), (ja + 2), 0);
						ja++;
						for (int i = 3, j = 4; i <= annIcolumn; i++, j++) {
							model1.setValueAt(TrsnDetails[j], annIcount, k);
							k++;
						}
						// added by cholia for the pan updation indicator

						// cholia end pan updation indicator
					
						annIcount++;
						row_count_annex1 = annIcount;
						

					}

					if (typOfHeader.equals("SD")) { // code Added by Akansha
						int localCaretCount = 0;
						StringTokenizer st_DD = new StringTokenizer(str, "^", true);
						while (st_DD.hasMoreTokens())
						{
							String val = st_DD.nextToken();
							if (val.equals("^"))
							{
								localCaretCount++;
							}
						}
						AnnIIDetails = GrpuUtil.tokenise(str);
						
						int k = 2;
						//newly changed for FRD1.6 by akansha
						//initial value 35 //initial value 60						
						/****************** Added for 2.7 Start ********************/
						/*if (AnnIIDetails[61] != null
						&& !"".equals(AnnIIDetails[61].toString())
						&& !"--Select--".equals(AnnIIDetails[61]
								.toString()))
					pan_Updtn_Indicator_Anne2.add(Integer
							.parseInt(AnnIIDetails[61].toString()));*/

						if (AnnIIDetails[TABLE_COLUMN_COUNT_annII+1] != null
								&& !"".equals(AnnIIDetails[TABLE_COLUMN_COUNT_annII+1].toString())
								&& !"--Select--".equals(AnnIIDetails[TABLE_COLUMN_COUNT_annII+1]
										.toString()))
							pan_Updtn_Indicator_Anne2.add(Integer
									.parseInt(AnnIIDetails[TABLE_COLUMN_COUNT_annII+1].toString()));

						/***************** Added for 2.7 End  ********************/


						//new development for FRD1.3 by Akansha
						if(model2.getRowCount()>0 && flagForRowAnne2!=1){
							int rowCount = model2.getRowCount();
							//Remove rows one by one from the end of the table
							for (int i = rowCount - 1; i >= 2; i--) {
								model2.removeRow(i);
							}
							flagForRowAnne2 = 1;
						}
						//**************************************
						if("Regular".equals(valueOfTypeOfStmt))
							addBlankRows2(1, true); // "true" keyword added by
						//new development for FRD1.3 by akansha
						else if("Correction".equals(valueOfTypeOfStmt)){
							

							/***************** Added for 2.7 Start  ********************/

							/*if(AnnIIDetails[63]!=null && !"".equals(AnnIIDetails[63].toString()) && !"LineHash".equals(AnnIIDetails[63].toString()))
							pancheckfagAnne2+=AnnIIDetails[63].toString();


							// new development for newly appended value "F", FRD1.9 on 18/01/17	
							if(AnnIIDetails[64]!=null)
								strAnnexIIColValue += AnnIIDetails[64].toString();*/

							if(AnnIIDetails[TABLE_COLUMN_COUNT_annII+3]!=null && !"".equals(AnnIIDetails[TABLE_COLUMN_COUNT_annII+3].toString()) && !"LineHash".equals(AnnIIDetails[TABLE_COLUMN_COUNT_annII+3].toString()))
								pancheckfagAnne2+=AnnIIDetails[TABLE_COLUMN_COUNT_annII+3].toString();


							// new development for newly appended value "F", FRD1.9 on 18/01/17	
							if(AnnIIDetails[TABLE_COLUMN_COUNT_annII+4]!=null)
								strAnnexIIColValue += AnnIIDetails[TABLE_COLUMN_COUNT_annII+4].toString();

							/***************** Added for 2.7 End  ********************/
							//***************************************
							if(AnnIIDetails[4]!=null && !"".equals(AnnIIDetails[4].toString())){
								if("Add".equals(AnnIIDetails[4].toString()))
									addBlankRows2(1, false); 
								else if("--Select--".equals(AnnIIDetails[4].toString()) || ("DELETE".equals(AnnIIDetails[4].toString()))
										|| ("PAN UPDATE".equals(AnnIIDetails[4].toString())))
									addBlankRows2(1, true);
							}
						}
						//*****************************************************
						model2.setValueAt((ka + 1), (ka + 2), 0);
						//model2.setValueAt((ka + 1), (ka + 2), 1); //newly commented for FRD1.3 by Akansha
						//new development for FRD1.3 by Akansha ---> serial number generation on import of file
						//newly changed for FRD1.6 by akansha
						//initial value 36
						//initial value 61

						/***************** Added for 2.7 Start  ********************/
						/*if(AnnIIDetails[62]!=null && !"LineHash".equals(annexIIcount))
						model2.setValueAt(AnnIIDetails[62],
								annIIcount,1);
						else
							model2.setValueAt((ka + 1), (ka + 2), 1);*/

						if(AnnIIDetails[TABLE_COLUMN_COUNT_annII+2]!=null && AnnIIDetails[TABLE_COLUMN_COUNT_annII+2]!="" && !"LineHash".equals(annexIIcount))
						{
							model2.setValueAt(AnnIIDetails[TABLE_COLUMN_COUNT_annII+2],
									annIIcount,1);
						//	model2.setValueAt((ka + 1), (ka + 2), 1);  //To set serial number
						}	
						else
							model2.setValueAt((ka + 1), (ka + 2), 1);

						/***************** Added for 2.7 End  ********************/
						ka++;
						// cholia to handle the default
						// value in the drop down
						for (int i = 4, j = 4; i <= TABLE_COLUMN_COUNT_annII; i++, j++) {

							if (k == 10){
								if (AnnIIDetails[j] != null && !"".equals(AnnIIDetails[j].toString()) )
									model2.setValueAt(df.format(Double
											.parseDouble(AnnIIDetails[j]
													.toString())), annIIcount,
													k);
								k++;
							}//FRD 2.3 added 16(ia), commented else if(k == 14)
							else if (k == 14){
								if (AnnIIDetails[j] != null && !"".equals(AnnIIDetails[j].toString()))
									model2.setValueAt(df.format(Double.parseDouble(AnnIIDetails[j].toString())), annIIcount,k);
								//System.out.println("income chargeable = "+model2.getValueAt(annIIcount, k));
								k++;
							}else if(k == 34 || k == 36 || k == 38 || k == 40 || k == 43 || k == 45 || k == 47 || k == 49){
								if("GOVERNMENT".equals(AnnIIDetails[j].toString())){
									model2.setValueAt("Payment made to Government organization (Central/State only)",annIIcount, k);
								}else if("NONRESDENT".equals(AnnIIDetails[j].toString())){
									model2.setValueAt("Payment made to Non-resident",annIIcount, k);
								}else if("OTHERVALUE".equals(AnnIIDetails[j].toString())){
									model2.setValueAt("Payment made to Other than Government organization and Non-resident",annIIcount, k);
								}else{
									model2.setValueAt(AnnIIDetails[j],annIIcount, k);
								}
								k++;
							}
							else if(k == 93)//RPU 3.6 changes by kiran  when importing saved file
							{
															
									if("Y".equals(AnnIIDetails[j]) || "Yes".equals(AnnIIDetails[j]))
										model2.setValueAt("Yes", annIIcount, k);
									else if("N".equals(AnnIIDetails[j]) || "No".equals(AnnIIDetails[j]))
										model2.setValueAt("No", annIIcount, k); 
									else if ("".equals(AnnIIDetails[j]))
										model2.setValueAt("--Select--", annIIcount, k);
							
							}
							else
							{//RPU 2.9 start
								if(localCaretCount==85)
								{
									if(k>69)
									   {																	
										model2.setValueAt(AnnIIDetails[72], annIIcount, 71);
										model2.setValueAt(AnnIIDetails[73], annIIcount, 73);
										model2.setValueAt(AnnIIDetails[74], annIIcount, 75);
										model2.setValueAt(AnnIIDetails[75], annIIcount, 77);
										model2.setValueAt(AnnIIDetails[76], annIIcount, 79);
										model2.setValueAt(AnnIIDetails[77], annIIcount, 81);
										model2.setValueAt(AnnIIDetails[78], annIIcount, 83);
										model2.setValueAt(AnnIIDetails[79], annIIcount, 86);
										model2.setValueAt(AnnIIDetails[80], annIIcount, 89);
										model2.setValueAt(AnnIIDetails[81], annIIcount, 90);
										model2.setValueAt(AnnIIDetails[82], annIIcount, 93);    //RPU 3.7 Addition of new column rahul to be fixed
										break;
									   }
									else
										{
										model2.setValueAt(AnnIIDetails[j],annIIcount, k);
										k++;
										}
									
								}//RPU 2.9 end
								else
								{
									model2.setValueAt(AnnIIDetails[j],annIIcount, k);
								    k++;
								}
							}
							

						}
						annIIcount++;
						row_count_annex2 = annIIcount;
					}
				}

				challancount = 2;
				annIcount = 2;
				annIIcount = 2;
				model.fireTableDataChanged();
				if (!fileExtsn.equals(".tds")) { // changed by Akansha .fvu
					if (valueOfTypeOfStmt.equalsIgnoreCase("Regular"))
						flagToDecideReloadFunctionCall = false;
					String correctionType ="";
					if (valueOfTypeOfStmt.equalsIgnoreCase("Correction"))
						correctionType = BatchHeader.get(6).toString()
						.trim();
					if (correctionType.equalsIgnoreCase("X")) {
						//	System.out.println("Inside X condition");
						jComboBox_TypeOfCorrection.setSelectedItem("Cancel");
						enableDisableFields();
					} else if (correctionType.equalsIgnoreCase("M")) {
						//	System.out.println("Inside M condition");
						jComboBox_TypeOfCorrection.setSelectedItem("Modify");
					} else {
					System.out.println("Inside Other condition");
						jComboBox_TypeOfCorrection.setSelectedIndex(0);
					}
				}

				// Timer for uploading file
				//				System.out.println("Timer out: " + System.currentTimeMillis()
				//						/ 1000);
				// ******************
				in.close();
				if (gSuccessFlag) { // Code added by Akansha
					if(!"tempfile".equals(typeOfFile)){
						mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	

						if (fileExtsn.equals("") && gHashFlag)
							getMessage("File opened successfully!");
						else if (gHashFlag) {
							JOptionPane
							.showMessageDialog(
									contentGRPU,
									"Consolidated TDS/TCS file is as on "
											+ tdsDate
											+ ". Ensure that the latest consolidated TDS/TCS file is used for preparation of correction statement");
							// getMessage("File imported successfully!");
						}
						TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
						currentAOData();
						//System.out.println("income chargeable 2 = "+model2.getValueAt(2, 14));
						// calculateStats(GrpuUtil.getFilledRows(model)); --- by
						// Akansha
					}
				}
				//newly added for FRD1.5 by Akansha
				if(mainObject.contentPanel!=null)				//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
					mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	
			} else if (selFile != null && fileExtsn.equals(".tds")
					&& "Import".equals(method)) {
				//System.out.println("I am here.... Load Object ");
				// Added by Latish
				ddlist.clear();
				// **********************

				// System.out.println(fileExtsn);
				// added by choia to get the row count for the drop down
				// modification
				row_count_annex1 = 0;
				row_count_annex2 = 0;
				// end
				row_count_challan = 0;
				checkPopup = 1; // For popup
				challancount = 2;
				challantype = "";
				pancheckfag = "";
				//new development for FRD1.5 by akansha
				pancheckfagAnne2 ="";
				//**************************************
				k_annex1 = 2;

				//new development for FRD1.3 by Akansha
				annexIIcount ="";
				annexIcount.clear();
				annexIcount.add("");

				int ia = 0, ja = 0, ka = 0;
				in = new BufferedReader(new FileReader(selFile));
				int anne2count = 0;

				// Timer for uploading file
				//				System.out.println("Timer in: " + System.currentTimeMillis()
				//						/ 1000);
				// ******************
				while ((str = in.readLine()) != null) {
					if (!gHashFlag) {
						gSuccessFlag = false;
						return false;
					}
					if (str.length() <= 20)
						continue;
					caretPos = 0;
					nxtCaretPos = 0;
					caretPos = str.indexOf("^", caretPos + 1);
					nxtCaretPos = str.indexOf("^", caretPos + 1);
					typOfHeader = str.substring(caretPos + 1, nxtCaretPos);
					if (typOfHeader.equals("FH")) {
						int NumOfCaret = GrpuUtil.checkCaretCount(str);

						RegFH = GrpuUtil.tokeniseFH(str);
						statementtype = RegFH[4].trim().toString().trim();
						tdsDate = changeDate(RegFH[5].trim().toString());
						// Added By manish garg
						filehash = RegFH[15].trim().toString().trim();
						if (statementtype.equalsIgnoreCase("C")
								&& fileExtsn.equals("")) {
							if(mainObject.contentPanel!=null)		//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
							getError("Imported file is not a regular file.");
							gSuccessFlag = false;
							return false;
						} else if (valueOfTypeOfStmt
								.equalsIgnoreCase("Correction")
								&& fileExtsn.equals("")
								&& !statementtype.equalsIgnoreCase("C")) // .grpu
							// //
							// added
							// by
							// Akansha
						{
							if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
							getError("Imported file is not a correction file.");
							gSuccessFlag = false;
							return false;

						} else if (valueOfTypeOfStmt
								.equalsIgnoreCase("Regular")
								&& fileExtsn.equals("")
								&& !statementtype.equalsIgnoreCase("O")) // .grpu
							// //
							// added
							// by
							// Akansha
						{
							if(mainObject.contentPanel!=null)				//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
								mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
							getError("Imported file is not a regular file.");
							gSuccessFlag = false;
							return false;

						}

					} else if (typOfHeader.equals("BH")) {
						// Code added for reading BH header added by Akansha
						GRPUMain grpumain = this.mainObject;
						BatchHeader = GrpuUtil.tokeniseBH(str);
						// BatchHeader ne puri batch ki line read kr li
						// hai 4th token

						String formno = BatchHeader.get(4).toString();
						if(BatchHeader!=null && BatchHeader.get(42)!=null && !"".equals(BatchHeader.get(42).toString())){
							annexIIcount = BatchHeader.get(42).toString();
							System.out.println("Anne2 ka count: "+ annexIIcount);}
						if (fileExtsn.equals("")) {
							if (valueOfTypeOfStmt.equals("Correction")
									&& !str.contains("CONS")) {
								if(mainObject.contentPanel!=null)				//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
									mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane
								.showMessageDialog(
										grpumain.contentPanel,
										"File you are trying to open is of 'Regular' type");
								return false;
							} else if (valueOfTypeOfStmt.equals("Regular")
									&& str.contains("CONS")) {
								if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
									mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane
								.showMessageDialog(
										grpumain.contentPanel,
										"File you are trying to open is correction.");
								return false;
							}
						}
						if (formno.equals("24Q")) {
							if (this.formNumber.equals(formno)) {
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								if(mainObject.contentPanel!=null)				//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
									mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								grpumain.retainSaveState();
								return false;
							}
						} else if (formno.equals("26Q")) {
							if (this.formNumber.equals(formno)) {
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
									mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								grpumain.retainSaveState();
								return false;
							}
						} else if (formno.equals("27Q")) {
							if (this.formNumber.equals(formno)) {
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
									mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								grpumain.retainSaveState();
								return false;
							}
						} else if (formno.equals("27EQ")) {
							if (this.formNumber.equals(formno)) {
								prepopulateData(BatchHeader, fileExtsn,
										valueOfTypeOfStmt);
							} else {
								if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
									mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
								JOptionPane.showMessageDialog(
										grpumain.contentPanel,
										"Select File related to Form "
												+ this.formNumber);
								grpumain.retainSaveState();
								return false;
							}
						}
						// **********************************************************************
					}
					if (typOfHeader.equals("CD")) { // Code added by Akansha
						ChllnDetails = GrpuUtil.tokenise(str);

						addBlankRows(1, true);
						model.setValueAt((ia + 1), (ia + 2), 0);
						ia++;
						challantype += ChllnDetails[8];
						System.out.println("Challan type:"+challantype);
						//	System.out.println("Challan Anne count: "+ ChllnDetails[7].toString());
						annexIcount.add(ChllnDetails[7].toString());
						//						System.out.println("CHLLN DETAILS on import on index "
						//								+ ia + " is " + ChllnDetails[36]);

						if ("".equals(ChllnDetails[36].toString()))
							LastModeofDeposit.add("--Select--");
						else
							LastModeofDeposit.add(ChllnDetails[36].toString());
						setChallanValues(ChllnDetails, challancount);
						challancount++;
						row_count_challan = challancount;

					}
					if (typOfHeader.equals("DD")) { // Code added by Akansha

						TrsnDetails = GrpuUtil.tokeniseAnnI(str);
						if (TrsnDetails != null)
							ddlist.put(annIcount, TrsnDetails);

						if ("24Q".equals(formNumber)) {
							annIcolumn = TABLE_COLUMN_COUNT_annI_24Q;
						} else if ("26Q".equals(formNumber)) {
							annIcolumn = TABLE_COLUMN_COUNT_annI_26Q;
						} else if ("27Q".equals(formNumber)) {
							annIcolumn = TABLE_COLUMN_COUNT_annI_27Q;
						} else if ("27EQ".equals(formNumber)) {
							annIcolumn = TABLE_COLUMN_COUNT_annI_27EQ;
						}

						addBlankRows1(1, 0, false, true);
						model1.setValueAt((ja + 1), (ja + 2), 0);
						ja++;
						System.out.println("TrsnDetails = " +str);
						System.out.println("values of DD = " +k_annex1 + "and" +TrsnDetails[3]);
						value_set_annexure1(k_annex1, TrsnDetails[3]);
						k_annex1++;

						pan_Updtn_Indicator.add(Integer.parseInt(TrsnDetails[31].toString()));
						LastIncomeTax.add(TrsnDetails[13].toString());
						LastSurcharge.add(TrsnDetails[14].toString());
						LastEduCess.add(TrsnDetails[15].toString());

						setAnnIValues(TrsnDetails, annIcount);
						annIcount++;
						row_count_annex1 = annIcount;
					}

					if (typOfHeader.equals("SD")) { // code Added by Akansha
						AnnIIDetails = GrpuUtil.tokenise(str);
						
						int k = 2;
						addBlankRows2(1, true);
						model2.setValueAt((ka + 1), (ka + 2), 0);
						model2.setValueAt((ka + 1), (ka + 2), 1);
						ka++;
						pan_Updtn_Indicator_Anne2.add(Integer
								.parseInt(AnnIIDetails[31].toString()));
						System.out.println("Akkkiii..... : "+AnnIIDetails[31].toString());
						anne2count = annIIcount;
						setAnnIIValues(AnnIIDetails, annIIcount);
						annIIcount++;
						row_count_annex2 = annIIcount;
					}
					if (typOfHeader.equals("S16")) {
						Object S16[] = GrpuUtil.tokenise(str);
						if ("16(iii)".equals(S16[5])) {
							model2.setValueAt(S16[6], anne2count, 12);
						} else if ("16(ii)".equals(S16[5])) {
							model2.setValueAt(S16[6], anne2count, 11);
						}/*********************************************************/				
						//FRD 2.3 added 16(ia)			
						else if ("16(ia)".equals(S16[5])) {
							model2.setValueAt(S16[6], anne2count, 13);
						}
						/*********************************************************/	
					}
					if (typOfHeader.equals("C6A")) {
						Object C6A[] = GrpuUtil.tokenise(str);
						System.out.println("c6A str.length(): "+str.length());
						if ("80CCE".equals(C6A[5])) {
							model2.setValueAt(C6A[6], anne2count, 17);
						} else if ("80CCF".equals(C6A[5])) {
							model2.setValueAt(C6A[6], anne2count, 18);
						} else if ("80CCG".equals(C6A[5])) {
							model2.setValueAt(C6A[6], anne2count, 19);
						} else if ("OTHERS".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 20);
							//RPU 2.9 start
							model2.setValueAt(C6A[7], anne2count, 91);
							model2.setValueAt(C6A[8], anne2count, 92);	
							
						}
						/****************** Added for 2.7 Start ********************/
						
						else if ("80C".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 71);
							model2.setValueAt(C6A[7], anne2count, 70);						
						}
						else if ("80CCC".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 73);
							model2.setValueAt(C6A[7], anne2count, 72);
						}
						else if ("80CCD(1)".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 75);
							model2.setValueAt(C6A[7], anne2count, 74);
						}
						else if ("80CCD(1B)".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 77);
							model2.setValueAt(C6A[7], anne2count, 76);
						}
						else if ("80CCD(2)".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 79);
							model2.setValueAt(C6A[7], anne2count, 78);
						}
						else if ("80D".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 81);
							model2.setValueAt(C6A[7], anne2count, 80);
						}
						else if ("80E".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 83);
							model2.setValueAt(C6A[7], anne2count, 82);
						}
						else if ("80G".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 86);
							model2.setValueAt(C6A[7], anne2count, 84);
							model2.setValueAt(C6A[8], anne2count, 85);
						}
						else if ("80TTA".equalsIgnoreCase(C6A[5].toString())) {
							model2.setValueAt(C6A[6], anne2count, 89);
							model2.setValueAt(C6A[7], anne2count, 87);
							model2.setValueAt(C6A[8], anne2count, 88);
						}
						//RPU 2.9 end
						/****************** Added for 2.7 End ********************/
					}

				}

				challancount = 2;
				annIcount = 2;
				annIIcount = 2;
				model.fireTableDataChanged();

				// Code for setting S16 and C6A empty values with 0.00
				if (model2 != null && "24Q".equals(formNumber)) {
					if ("Q4".equals(jComboBox_Quarter.getSelectedItem()
							.toString())) {

						for (int i = 2; i < model2.getRowCount(); i++) {
							if ("".equals(model2.getValueAt(i, 11))
									|| model2.getValueAt(i, 11) == null) {
								model2.setValueAt("0.00", i, 11);
							}
							if ("".equals(model2.getValueAt(i, 12))
									|| model2.getValueAt(i, 12) == null) {
								model2.setValueAt("0.00", i, 12);
							}
							if ("".equals(model2.getValueAt(i, 13))
									|| model2.getValueAt(i, 13) == null) {
								model2.setValueAt("0.00", i, 13);
							}
							if ("".equals(model2.getValueAt(i, 17))
									|| model2.getValueAt(i, 17) == null) {
								model2.setValueAt("0.00", i, 17);
							}
							if ("".equals(model2.getValueAt(i, 18))
									|| model2.getValueAt(i, 18) == null) {
								model2.setValueAt("0.00", i, 18);
							}
							if ("".equals(model2.getValueAt(i, 19))
									|| model2.getValueAt(i, 19) == null) {
								model2.setValueAt("0.00", i, 19);
							}
							if ("".equals(model2.getValueAt(i, 20))
									|| model2.getValueAt(i, 20) == null) {
								model2.setValueAt("0.00", i, 20);
							}
							
							/****************** Added for 2.7 Start ********************/
							
							if ("".equals(model2.getValueAt(i, 70))
									|| model2.getValueAt(i, 70) == null) {
								model2.setValueAt("0.00", i, 70);
							}
							if ("".equals(model2.getValueAt(i, 71))
									|| model2.getValueAt(i, 71) == null) {
								model2.setValueAt("0.00", i, 71);
							}
							if ("".equals(model2.getValueAt(i, 72))
									|| model2.getValueAt(i, 72) == null) {
								model2.setValueAt("0.00", i, 72);
							}
							if ("".equals(model2.getValueAt(i, 73))
									|| model2.getValueAt(i, 73) == null) {
								model2.setValueAt("0.00", i, 73);
							}
							if ("".equals(model2.getValueAt(i, 74))
									|| model2.getValueAt(i, 74) == null) {
								model2.setValueAt("0.00", i, 74);
							}
							if ("".equals(model2.getValueAt(i, 75))
									|| model2.getValueAt(i, 75) == null) {
								model2.setValueAt("0.00", i, 75);
							}
							if ("".equals(model2.getValueAt(i, 76))
									|| model2.getValueAt(i, 76) == null) {
								model2.setValueAt("0.00", i, 76);
							}
							if ("".equals(model2.getValueAt(i, 77))
									|| model2.getValueAt(i, 77) == null) {
								model2.setValueAt("0.00", i, 77);
							}
							if ("".equals(model2.getValueAt(i, 78))
									|| model2.getValueAt(i, 78) == null) {
								model2.setValueAt("0.00", i, 78);
							}
							//RPU 2.9 start
							if ("".equals(model2.getValueAt(i, 79))
									|| model2.getValueAt(i, 79) == null) {
								model2.setValueAt("0.00", i, 79);
							}
							if ("".equals(model2.getValueAt(i, 80))
									|| model2.getValueAt(i, 80) == null) {
								model2.setValueAt("0.00", i, 80);
							}
							if ("".equals(model2.getValueAt(i, 81))
									|| model2.getValueAt(i, 81) == null) {
								model2.setValueAt("0.00", i, 81);
							}
							if ("".equals(model2.getValueAt(i, 82))
									|| model2.getValueAt(i, 82) == null) {
								model2.setValueAt("0.00", i, 82);
							}
							if ("".equals(model2.getValueAt(i, 83))
									|| model2.getValueAt(i, 83) == null) {
								model2.setValueAt("0.00", i, 83);
							}
							if ("".equals(model2.getValueAt(i, 84))
									|| model2.getValueAt(i, 84) == null) {
								model2.setValueAt("0.00", i, 84);
							}
							if ("".equals(model2.getValueAt(i, 85))
									|| model2.getValueAt(i, 85) == null) {
								model2.setValueAt("0.00", i, 85);
							}
							if ("".equals(model2.getValueAt(i, 86))
									|| model2.getValueAt(i, 86) == null) {
								model2.setValueAt("0.00", i, 86);
							}
							if ("".equals(model2.getValueAt(i, 87))
									|| model2.getValueAt(i, 87) == null) {
								model2.setValueAt("0.00", i, 87);
							}
							if ("".equals(model2.getValueAt(i, 88))
									|| model2.getValueAt(i, 88) == null) {
								model2.setValueAt("0.00", i, 88);
							}
							if ("".equals(model2.getValueAt(i, 89))
									|| model2.getValueAt(i, 89) == null) {
								model2.setValueAt("0.00", i, 89);
							}
							if ("".equals(model2.getValueAt(i, 90))
									|| model2.getValueAt(i, 90) == null) {
								model2.setValueAt("0.00", i, 90);
							}
							
							if ("".equals(model2.getValueAt(i, 91))
									|| model2.getValueAt(i, 91) == null) {
								model2.setValueAt("0.00", i, 91);
							}
							
							if ("".equals(model2.getValueAt(i, 92))
									|| model2.getValueAt(i, 92) == null) {
								model2.setValueAt("0.00", i, 92);
							}
							if ("".equals(model2.getValueAt(i, 93))          //RPU 3.7 Addition of new column rahul
									|| model2.getValueAt(i, 93) == null) {
								model2.setValueAt("--Select--", i, 93);
							}
							//RPU 2.9 end
				        	/****************** Added for 2.7 End ********************/
							
							
							
							
						}
					}
				}
				// ******************
				in.close();
				if (gSuccessFlag) { // Code added by Akansha
					if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
						mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
					//Newly commented by Akansha for progress bar 
					if (fileExtsn.equals("") && gHashFlag)
						getMessage("File opened successfully!");
					else if (gHashFlag) {
						JOptionPane
						.showMessageDialog(
								contentGRPU,
								"Consolidated TDS/TCS file is as on "
										+ tdsDate
										+ ". Ensure that the latest consolidated TDS/TCS file is used for preparation of correction statement");
						// getMessage("File imported successfully!");
					}
					TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
					currentAOData();

				}
				// ********************************************
				String challan_str = "<html>File imported successfully.";

				if (challantype.length() > 0) {
					challan_str += ("");
					if (challantype.contains("U")) {
						challan_str += ("<br>Statement contains unmatched Challan/Challans.The same has been highlighted in red color.");
					}
					if (challantype.contains("O")) {
						challan_str += ("<br>Statement contains overbooked Challan/Challans.The same has been highlighted in blue color.");
					}

					if (pancheckfag.length() > 0) {
						if (pancheckfag.contains("N")) {
							challan_str += ("<br>Statement contains invalid PANs.The same has been highlighted in red color.");
						}
					}

					challan_str += (" </html>");
				}
				//newly added for FRD1.5 by Akansha
				if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
					mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	
				JOptionPane.showMessageDialog(null, challan_str);
			} else if (selFile == null){
				//newly added for FRD1.5 by Akansha
				if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
					mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	
				getMessage("The file is empty.");
			}else {
				//newly added for FRD1.5 by Akansha
				if(mainObject.contentPanel!=null)			//newly added for backup file, if GRPUMain obj is not null, to skip GrpuMain on 12/01/2017 FRD1.9
					mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	
				getMessage("File not proper");
				return false;
			}
		} catch (Exception e1) {
			e1.printStackTrace();
			//newly added for FRD1.5 by Akansha
			mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));	
			getError("Imported file is not a valid file.Please import valid file.");
			gSuccessFlag = false;
			return false;
		}
		// method = "";
		return true;
	}

	// Added by Akansha
	// Method for setting the annII values on the import of consolidated file
	// Specific indexing written --- anonymous behavior of values
	private void setAnnIIValues(Object[] annIIDetails, int rownumber) {

		//newly added for FRD1.9 for error messages to be populated if "F" found on 02/02/17
		if(annIIDetails[4].toString().equals("")){
			strAnnexIIColValue += "A";
		}else{
			strAnnexIIColValue += annIIDetails[4].toString();
		}
		System.out.println("strAnnexIIColValue="+strAnnexIIColValue);
		//**************************************************

		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		model2.setValueAt(annIIDetails[3], rownumber, 1);
		model2.setValueAt(annIIDetails[6], rownumber, 3);
		model2.setValueAt(annIIDetails[8], rownumber, 4);
		// ## Newly developed for correction Ver1.2
		if ("".equals(annIIDetails[9]))
			model2.setValueAt("--Select--", rownumber, 5);
		else
			model2.setValueAt(
					GrpuUtil.getDDTypeCode(annIIDetails[9].toString()),
					rownumber, 5);
		// **********************************************
		model2.setValueAt(formatdate(annIIDetails[10]), rownumber, 6);
		model2.setValueAt(formatdate(annIIDetails[11]), rownumber, 7);

		if ("".equals(annIIDetails[30].toString()))
			pancheckfagAnne2 += " ";
		else
			pancheckfagAnne2 += annIIDetails[30].toString();
		// ************************************************
		//**************************************

		//new development for FRD1.3 by Akansha

		model2.setValueAt(fractionhandle(annIIDetails[34], rownumber, 8),rownumber,8);


		model2.setValueAt(fractionhandle(annIIDetails[35], rownumber, 9),rownumber,9);



		model2.setValueAt(fractionhandle(annIIDetails[12], rownumber, 10),rownumber,10);

		//**************************************

		/*********************************************************/				
		//FRD 2.3 added 16(ia)
		//model2.setValueAt(annIIDetails[15], rownumber, 13);
		/*********************************************************/	


		/*model2.setValueAt(removeLeadingZeros(annIIDetails[16]), rownumber, 14);*/

		//new development for FRD1.3 by akansha

		model2.setValueAt(fractionhandle(annIIDetails[16], rownumber, 14),rownumber,14);

		//****************************************

		if (annIIDetails[17]!=null && !annIIDetails[17].toString().contains("-"))
			model2.setValueAt(
					df.format(Double.parseDouble(annIIDetails[17].toString())),
					rownumber, 15);
		else{
			String temp="0.00";
			if(annIIDetails[17]!=null && !"".equals(annIIDetails[17].toString()))
				temp = fractionhandle(annIIDetails[17].toString().substring(1,annIIDetails[17].toString().length()), rownumber, 15);
			model2.setValueAt("-"+temp, rownumber, 15);
		}

		//new development for FRD1.3 by akansha
		if (!annIIDetails[18].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[18], rownumber, 16),rownumber,16);
		else
			model2.setValueAt((annIIDetails[18]), rownumber, 16);

		if (!annIIDetails[21].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[21], rownumber, 21),rownumber,21);
		else
			model2.setValueAt((annIIDetails[21]), rownumber, 21);

		if (!annIIDetails[22].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[22], rownumber, 22),rownumber,22);
		else
			model2.setValueAt((annIIDetails[22]), rownumber, 22);

		if (!annIIDetails[23].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[23], rownumber, 23),rownumber,23);
		else
			model2.setValueAt((annIIDetails[23]), rownumber, 23);

		if (!annIIDetails[24].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[24], rownumber, 24),rownumber,24);
		else
			model2.setValueAt((annIIDetails[24]), rownumber, 24);

		if (!annIIDetails[25].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[25], rownumber, 25),rownumber,25);
		else
			model2.setValueAt((annIIDetails[25]), rownumber, 25);

		if (!annIIDetails[26].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[26], rownumber, 26),rownumber,26);
		else
			model2.setValueAt((annIIDetails[26]), rownumber, 26);

		if (!annIIDetails[27].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[27], rownumber, 27),rownumber,27);
		else
			model2.setValueAt((annIIDetails[27]), rownumber, 27);
		//****************************************
		model2.setValueAt(annIIDetails[36], rownumber, 28);
		model2.setValueAt(annIIDetails[37], rownumber, 29);


		//new development for FRD1.3 by akansha
		if (!annIIDetails[28].toString().contains("-"))
			model2.setValueAt(fractionhandle(annIIDetails[28], rownumber, 30),rownumber,30);
		else
			model2.setValueAt((annIIDetails[28]), rownumber, 30);
		//*************************************

		if (!annIIDetails[29].toString().contains("-"))
			model2.setValueAt(
					df.format(Double.parseDouble(annIIDetails[29].toString())),
					rownumber, 31);
		else
		{

			String temp="0.00";
			if(annIIDetails[29]!=null && !"".equals(annIIDetails[29].toString()))
				temp = fractionhandle(annIIDetails[29].toString().substring(1,annIIDetails[29].toString().length()), rownumber, 31);
			model2.setValueAt("-"+temp, rownumber, 31);

		}
		// ## Newly developed for correction Ver1.2
		if ("".equals(annIIDetails[38]))
			model2.setValueAt("--Select--", rownumber, 32);
		else{
			if("Y".equals(annIIDetails[38]))
				model2.setValueAt("Yes", rownumber, 32);
			else
				model2.setValueAt("No", rownumber, 32);
		}
		// ***************************************


		//newly added for FRD1.6 by akansha
		if ("".equals(annIIDetails[39]))
			model2.setValueAt("--Select--", rownumber, 33);
		else{
			if("Y".equals(annIIDetails[39]))
				model2.setValueAt("Yes", rownumber, 33);
			else
				model2.setValueAt("No", rownumber, 33);
		}
		//40 is skipped since it is count of pans of landlord
		if("GOVERNMENT".equals(annIIDetails[41].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,34);
		}else if("NONRESDENT".equals(annIIDetails[41].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,34);
		}else if("OTHERVALUE".equals(annIIDetails[41].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,34);
		}else{
			model2.setValueAt(annIIDetails[41],rownumber, 34);
		}
		//model2.setValueAt(annIIDetails[41], rownumber, 34);
		model2.setValueAt(annIIDetails[42], rownumber, 35);

		//model2.setValueAt(annIIDetails[43], rownumber, 36);
		if("GOVERNMENT".equals(annIIDetails[43].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,36);
		}else if("NONRESDENT".equals(annIIDetails[43].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,36);
		}else if("OTHERVALUE".equals(annIIDetails[43].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,36);
		}else{
			model2.setValueAt(annIIDetails[43],rownumber, 36);
		}

		model2.setValueAt(annIIDetails[44], rownumber, 37);

		//model2.setValueAt(annIIDetails[45], rownumber, 38);
		if("GOVERNMENT".equals(annIIDetails[45].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,38);
		}else if("NONRESDENT".equals(annIIDetails[45].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,38);
		}else if("OTHERVALUE".equals(annIIDetails[45].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,38);
		}else{
			model2.setValueAt(annIIDetails[45],rownumber, 38);
		}

		model2.setValueAt(annIIDetails[46], rownumber, 39);

		//model2.setValueAt(annIIDetails[47], rownumber, 40);
		if("GOVERNMENT".equals(annIIDetails[47].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,40);
		}else if("NONRESDENT".equals(annIIDetails[47].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,40);
		}else if("OTHERVALUE".equals(annIIDetails[47].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,40);
		}else{
			model2.setValueAt(annIIDetails[47],rownumber, 40);
		}

		model2.setValueAt(annIIDetails[48], rownumber, 41);

		//model2.setValueAt(annIIDetails[48], rownumber, 42);

		if ("".equals(annIIDetails[49]))
			model2.setValueAt("--Select--", rownumber, 42);
		else{
			if("Y".equals(annIIDetails[49]))
				model2.setValueAt("Yes", rownumber, 42);
			else
				model2.setValueAt("No", rownumber, 42);
		}
		//50 is skipped since it is count of pans of lender
		//model2.setValueAt(annIIDetails[51], rownumber, 43);
		if("GOVERNMENT".equals(annIIDetails[51].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,43);
		}else if("NONRESDENT".equals(annIIDetails[51].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,13);
		}else if("OTHERVALUE".equals(annIIDetails[51].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,43);
		}else{
			model2.setValueAt(annIIDetails[51],rownumber, 43);
		}
		model2.setValueAt(annIIDetails[52], rownumber, 44);

		//model2.setValueAt(annIIDetails[53], rownumber, 45);
		if("GOVERNMENT".equals(annIIDetails[53].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,45);
		}else if("NONRESDENT".equals(annIIDetails[53].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,45);
		}else if("OTHERVALUE".equals(annIIDetails[53].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,45);
		}else{
			model2.setValueAt(annIIDetails[53],rownumber, 45);
		}
		model2.setValueAt(annIIDetails[54], rownumber, 46);

		//model2.setValueAt(annIIDetails[55], rownumber, 47);
		if("GOVERNMENT".equals(annIIDetails[55].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,47);
		}else if("NONRESDENT".equals(annIIDetails[55].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,47);
		}else if("OTHERVALUE".equals(annIIDetails[55].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,47);
		}else{
			model2.setValueAt(annIIDetails[55],rownumber, 47);
		}
		model2.setValueAt(annIIDetails[56], rownumber, 48);

		//model2.setValueAt(annIIDetails[57], rownumber, 49);
		if("GOVERNMENT".equals(annIIDetails[57].toString())){
			model2.setValueAt("Payment made to Government organization (Central/State only)",rownumber,49);
		}else if("NONRESDENT".equals(annIIDetails[57].toString())){
			model2.setValueAt("Payment made to Non-resident",rownumber,49);
		}else if("OTHERVALUE".equals(annIIDetails[57].toString())){
			model2.setValueAt("Payment made to Other than Government organization and Non-resident",rownumber,49);
		}else{
			model2.setValueAt(annIIDetails[57],rownumber, 49);
		}
		model2.setValueAt(annIIDetails[58], rownumber, 50);

		//newly added for revised FRD1.6 by akansha
		if ("".equals(annIIDetails[59]))
			model2.setValueAt("--Select--", rownumber, 51);
		else{
			if("Y".equals(annIIDetails[59]))
				model2.setValueAt("Yes", rownumber, 51); //51
			else
				model2.setValueAt("No", rownumber, 51); 
		}
		model2.setValueAt(annIIDetails[60], rownumber, 52); //52

		model2.setValueAt(formatdate(annIIDetails[61]), rownumber, 53);//53
		model2.setValueAt(formatdate(annIIDetails[62]), rownumber, 54);//54

		if (!annIIDetails[63].toString().contains("-")) //55
			model2.setValueAt(fractionhandle(annIIDetails[63], rownumber, 55),rownumber,55);
		else
			model2.setValueAt((annIIDetails[63]), rownumber, 55);


		if (!annIIDetails[64].toString().contains("-")) //56
			model2.setValueAt(fractionhandle(annIIDetails[64], rownumber, 56),rownumber,56);
		else
			model2.setValueAt((annIIDetails[64]), rownumber, 56);

		if (!annIIDetails[65].toString().contains("-")) //57
			model2.setValueAt(fractionhandle(annIIDetails[65], rownumber, 57),rownumber,57);
		else
			model2.setValueAt((annIIDetails[65]), rownumber, 57);

		model2.setValueAt(annIIDetails[66], rownumber, 58);//58


		/****************** Added for 2.7 Start ********************/
         //values setting
		
		
		model2.setValueAt(fractionhandle(annIIDetails[67], rownumber, 59),rownumber,59);//59
		
		model2.setValueAt(fractionhandle(annIIDetails[68], rownumber, 60),rownumber,60);//60
		
		model2.setValueAt(fractionhandle(annIIDetails[69], rownumber, 61),rownumber,61);//61

		model2.setValueAt(fractionhandle(annIIDetails[70], rownumber, 62),rownumber,62);//62

		model2.setValueAt(fractionhandle(annIIDetails[71], rownumber, 63),rownumber,63);//63

		model2.setValueAt(fractionhandle(annIIDetails[72], rownumber, 64),rownumber,64);//64

		model2.setValueAt(fractionhandle(annIIDetails[73], rownumber, 65),rownumber,65);//65

		model2.setValueAt(fractionhandle(annIIDetails[74], rownumber, 66),rownumber,66);//66

		model2.setValueAt(fractionhandle(annIIDetails[75], rownumber, 67),rownumber,67);//67

		model2.setValueAt(fractionhandle(annIIDetails[76], rownumber, 68),rownumber,68);//68
		
		model2.setValueAt(fractionhandle(annIIDetails[77], rownumber, 69),rownumber,69);//69
		//RPU 2.9 start
		model2.setValueAt(fractionhandle(annIIDetails[78], rownumber, 90),rownumber,90);//90
		
		//RPU 3.6 changes by kiran	
		if(new Integer(grpu.JComboBox_Form_Sub1_finYear  
                    .getSelectedItem().toString()
                    .substring(0,4)) >= 2020 ) 
		{
			if("Y".equals(annIIDetails[79]))
				model2.setValueAt("Yes", rownumber, 93); //51
			else if("N".equals(annIIDetails[79]))
				model2.setValueAt("No", rownumber, 93); 
			else if ("".equals(annIIDetails[79]))
				model2.setValueAt("--Select--", rownumber, 93);
		}
		else
			model2.setValueAt("", rownumber, 93);
		
       /****************** Added for 2.7 End ********************/
		

		//*******************************************************************
	}

	// Added by Akansha
	// Method for setting the annI values on the import of consolidated file
	// Specific indexing written --- anonymous behavior of values
	private void setAnnIValues(Object[] trsnDetails, int rownumber) {

		//new development for newly appended value "F", FRD1.9 on 02/02/17	
		if(trsnDetails[5].toString().equals("") || ("27Q".equals(formNumber))){
			strAnnexIColValue += "O";
		}else{
			strAnnexIColValue += trsnDetails[5].toString();
			System.out.println("strAnnexIColValue="+strAnnexIColValue);
		}System.out.println(" Value in AnneI: "+trsnDetails[5].toString());
		//******************************************************

		// These particular indexes are common for all forms
		model1.setValueAt(trsnDetails[3], rownumber, 1);
		// newly added by cholia for section code issue
		String year = (JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				.substring(0, 4);
		int year1 = Integer.parseInt(year);
		if (year1 >= 2013)
			model1.setValueAt(trsnDetails[33], rownumber, 6);

		// end newly added by cholia
		model1.setValueAt(trsnDetails[4], rownumber, 11);
		if ("24Q".equals(formNumber)) {
			model1.setValueAt(trsnDetails[6], rownumber, 12);
			LastPanRefNo.add(trsnDetails[6].toString());
		} else {
			model1.setValueAt(trsnDetails[11], rownumber, 12);
			LastPanRefNo.add(trsnDetails[11].toString());
		}
		model1.setValueAt(trsnDetails[9], rownumber, 13);
		// Updated to check for any invalid PANs
		//System.out.println("PANs..... : " + (trsnDetails[30].toString()));
		if ("".equals(trsnDetails[30].toString()))
			pancheckfag += " ";
		else
			pancheckfag += trsnDetails[30].toString();
		// ************************************************
		model1.setValueAt(trsnDetails[9], rownumber, 14);
		model1.setValueAt(trsnDetails[12], rownumber, 15);
		model1.setValueAt(formatdate(trsnDetails[22]), rownumber, 16);

		//new development for FRD1.3 by Akansha
		model1.setValueAt(fractionhandle(trsnDetails[21], rownumber, 17),rownumber, 17);
		model1.setValueAt(fractionhandle(trsnDetails[13], rownumber, 18),rownumber, 18);
		model1.setValueAt(fractionhandle(trsnDetails[14], rownumber, 19),rownumber, 19);
		model1.setValueAt(fractionhandle(trsnDetails[15], rownumber, 20),rownumber, 20);

		model1.setValueAt(fractionhandle(trsnDetails[16], rownumber, 21),rownumber, 21);
		model1.setValueAt(fractionhandle(trsnDetails[16], rownumber, 22),rownumber, 22);
		model1.setValueAt(fractionhandle(trsnDetails[18], rownumber, 23),rownumber, 23);
		model1.setValueAt(fractionhandle(trsnDetails[18], rownumber, 24),rownumber, 24);
		//************************************
		model1.setValueAt(formatdate(trsnDetails[23]), rownumber, 25);
		model1.setValueAt(trsnDetails[29], rownumber, 26);

		// ****************************************************

		if ("24Q".equals(formNumber)) {
			model1.setValueAt(trsnDetails[34], rownumber, 27); // ## Added newly
			// for
			// correction
			// Ver1.2 by
			// Akansha
		} else if ("26Q".equals(formNumber)) {
			model1.setValueAt("0" + trsnDetails[7], rownumber, 27);
			// ## Newly developed for correction
			// Ver1.2
			if (trsnDetails[25] != null
					&& !"".equals(trsnDetails[25].toString())) {
				if (Double.parseDouble(trsnDetails[25].toString()) == 0)
					model1.setValueAt("0.0000", rownumber, 28);
				else{
					//	System.out.println("Value in decimal: "+(Double.parseDouble(trsnDetails[25].toString())));
					if(Math.floor(Double.parseDouble(trsnDetails[25].toString()))<=0)
						model1.setValueAt((trsnDetails[25].toString()).substring(1, trsnDetails[25].toString().length()),
								rownumber, 28);
					else
						model1.setValueAt(removeLeadingZeros(trsnDetails[25]),
								rownumber, 28);
				}
			} else
				model1.setValueAt((trsnDetails[25]), rownumber, 28);
			if ("".equals(trsnDetails[27])) {
				model1.setValueAt("--Select--", rownumber, 29);
			} else if ("Y".equals(trsnDetails[27]))
				model1.setValueAt("Yes", rownumber, 29);
			else if ("N".equals(trsnDetails[27]))
				model1.setValueAt("No", rownumber, 29);
			// ****************************************
			model1.setValueAt(trsnDetails[34], rownumber, 30);
			//rpu 3.1 start  to import last column
			model1.setValueAt(fractionhandle(trsnDetails[45], rownumber, 31), rownumber, 31);
			//rpu 3.4 start  to import last column
			model1.setValueAt(fractionhandle(trsnDetails[46], rownumber, 32), rownumber, 32);
			model1.setValueAt(fractionhandle(trsnDetails[47], rownumber, 33), rownumber, 33);
		} else if ("27Q".equals(formNumber)) {
			model1.setValueAt("0" + trsnDetails[7], rownumber, 27);
			if (trsnDetails[25] != null
					&& !"".equals(trsnDetails[25].toString())) {
				if (Double.parseDouble(trsnDetails[25].toString()) == 0)
					model1.setValueAt("0.0000", rownumber, 28);
				else //RPU 3.6 Bug fix to allow value starting with 0 eg. 0.2080
				{
					if(Math.floor(Double.parseDouble(trsnDetails[25].toString()))<=0)  
						model1.setValueAt((trsnDetails[25].toString()).substring(1, trsnDetails[25].toString().length()),
								rownumber, 28);
					else
						model1.setValueAt(removeLeadingZeros(trsnDetails[25]),
								rownumber, 28);
				}		
			} else
				model1.setValueAt(trsnDetails[25], rownumber, 28);
			// ## Newly developed for correction Ver1.2
			if ("".equals(trsnDetails[27])) {
				model1.setValueAt("--Select--", rownumber, 29);
			} else if ("Y".equals(trsnDetails[27]))
				model1.setValueAt("Yes", rownumber, 29);
			else if ("N".equals(trsnDetails[27]))
				model1.setValueAt("No", rownumber, 29);
			// ****************************************
			model1.setValueAt(trsnDetails[34], rownumber, 30);

			// ## Newly developed for correction Ver1.2
			if ("".equals(trsnDetails[35]))
				model1.setValueAt("--Select--", rownumber, 31);
			else
				model1.setValueAt(trsnDetails[35], rownumber, 31);
			// *****************************************

			// ## Newly developed for correction Ver1.2
			if ("".equals(trsnDetails[36]))
				model1.setValueAt("--Select--", rownumber, 32);
			else
				model1.setValueAt(
						GrpuUtil.getRemittanceCode(trsnDetails[36].toString()),
						rownumber, 32);
			// *******************************************
			model1.setValueAt(trsnDetails[37], rownumber, 33);

			// ## Newly developed for correction Ver1.2
			if ("".equals(trsnDetails[38]))
				model1.setValueAt("--Select--", rownumber, 34);
			else {
				System.out.println("Country Code: "
						+ GrpuUtil.getCountryCode(trsnDetails[38].toString()));
				model1.setValueAt(
						GrpuUtil.getCountryCode(trsnDetails[38].toString()),
						rownumber, 34);
			}
			// ******************************************
			if ("Y".equals(trsnDetails[26].toString()))
				model1.setValueAt("Yes", rownumber, 35);
			else if ("N".equals(trsnDetails[26].toString()))
				model1.setValueAt("No", rownumber, 35);
			else
				model1.setValueAt("--Select--", rownumber, 35); // ## Newly
			// Developed for
			// correction
			// Ver1.2
			//newly added for fRD1.7 by akansha
			//for newly added columns
			model1.setValueAt(trsnDetails[39], rownumber, 36);
			model1.setValueAt(trsnDetails[40], rownumber, 37);
			model1.setValueAt(trsnDetails[41], rownumber, 38);
			model1.setValueAt(trsnDetails[42], rownumber, 39);
			//rpu 3.1 start  to import last column
			model1.setValueAt(fractionhandle(trsnDetails[45], rownumber, 40), rownumber, 40);
			//rpu 3.4 start  to import last column
			model1.setValueAt(fractionhandle(trsnDetails[46], rownumber, 41), rownumber, 41);
			model1.setValueAt(fractionhandle(trsnDetails[47], rownumber, 42), rownumber, 42);

		} else if ("27EQ".equals(formNumber)) {
			model1.setValueAt("0" + trsnDetails[7], rownumber, 27);
			model1.setValueAt(fractionhandle(trsnDetails[20], rownumber,
					28), rownumber,
					28); // new development for FRD1.3 by Akansha
			// ## Newly developed for correction
			// Ver1.2
			if (trsnDetails[25] != null
					&& !"".equals(trsnDetails[25].toString())) {
				if (Double.parseDouble(trsnDetails[25].toString()) == 0)
					model1.setValueAt("0.0000", rownumber, 29);
				else  //RPU 3.6 Bug fix to allow value starting with 0 eg. 0.2080
				{
					if(Math.floor(Double.parseDouble(trsnDetails[25].toString()))<=0)  
						model1.setValueAt((trsnDetails[25].toString()).substring(1, trsnDetails[25].toString().length()),
								rownumber, 29);
					else
						model1.setValueAt(removeLeadingZeros(trsnDetails[25]),
								rownumber, 29);
				}
				} else
				model1.setValueAt((trsnDetails[25]), rownumber, 29);
			// ## Newly developed for correction Ver1.2
			if ("".equals(trsnDetails[27])) {
				model1.setValueAt("--Select--", rownumber, 30);
			} else if ("Y".equals(trsnDetails[27]))
				model1.setValueAt("Yes", rownumber, 30);
			else if ("N".equals(trsnDetails[27]))
				model1.setValueAt("No", rownumber, 30);
			// ****************************************
			model1.setValueAt(trsnDetails[34], rownumber, 31);

			/************************************************************/
			//added by Sadhana, FRD 2.2
			if ("".equals(trsnDetails[43])) {
				model1.setValueAt("--Select--", rownumber, 32);
			} else if ("Y".equals(trsnDetails[43]))
				model1.setValueAt("Yes", rownumber, 32);
			else if ("N".equals(trsnDetails[43]))
				model1.setValueAt("No", rownumber, 32);

			if ("".equals(trsnDetails[44])) {
				model1.setValueAt("--Select--", rownumber, 33);
			} else if ("Y".equals(trsnDetails[44]))
				model1.setValueAt("Yes", rownumber, 33);
			else if ("N".equals(trsnDetails[44]))
				model1.setValueAt("No", rownumber, 33);
			
			/************************************************************/
			//begin from here import
			//RPU 3.5 Import .tds 
			if ("".equals(trsnDetails[48])) {
				model1.setValueAt("--Select--", rownumber, 34);
			} else if ("Y".equals(trsnDetails[48]))
				model1.setValueAt("Yes", rownumber, 34);
			else if ("N".equals(trsnDetails[48]))
				model1.setValueAt("No", rownumber, 34);
			
			model1.setValueAt(trsnDetails[49], rownumber, 35);
			model1.setValueAt(formatdate(trsnDetails[50]), rownumber, 36);

		}
	}

	// Added for formatting values
	public String convertToDouble(Object obj) {
		String newvalue = "";
		if (obj != null) {
			if ("".equals(obj)) {
				newvalue = "0.00";
			} else {
				String value = obj.toString();

				Double d = Double.parseDouble(value);
				newvalue = String.valueOf(d) + "0";
			}
		}
		return newvalue;
	}

	public String removeLeadingZeros(Object obj) {
		String str = "";
		if(obj!=null)
			str = obj.toString();
		int flag = 1;
		if (str == null || "".equals(str)) {
			return "";
		}
		char[] chars = str.toCharArray();
		int index = 0;
		for (; index < str.length(); index++) {
			if (chars[index] != '0' && chars[index] != '.') {
				flag = 0;
				break;
			}
			flag = 1;
		}
		if (flag == 1) {
			return "0.00";
		}
		return (index == 0) ? str : str.substring(index);
	}

	//New development for FRD1.3 by akansha
	//Method developed for values less than 0
	public String fractionhandle(Object value,int rownumber,int column){
		if (value != null && !"".equals(value.toString())) {
			if (Double.parseDouble(value.toString()) == 0)
				return "0.00";
			else{
				if (Math.floor(Double.parseDouble(value.toString())) <= 0) {

					return 	(Double.parseDouble(value.toString()))+"";
				} else
					return removeLeadingZeros(value);
			}
		}else
			return ("0.00");
	}



	// **************************************************
	// Added by Akansha
	// Method for setting the challan values on import of consolidated file
	// Specific indexing written --- anonymous behavior of values
	private void setChallanValues(Object[] chllnDetails, int rownumber) {
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
		DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		model.setValueAt(chllnDetails[20], rownumber, 2);
		model.setValueAt(
				df.format(Double.parseDouble(chllnDetails[21].toString())),
				rownumber, 3);

		//new development for FRD1.3 by Akansha
		model.setValueAt(fractionhandle(chllnDetails[22], rownumber, 4),rownumber, 4);
		model.setValueAt(fractionhandle(chllnDetails[23], rownumber, 5),rownumber, 5);
		model.setValueAt(fractionhandle(chllnDetails[24], rownumber, 6),rownumber, 6);
		model.setValueAt(fractionhandle(chllnDetails[39], rownumber, 7),rownumber, 7);
		model.setValueAt(fractionhandle(chllnDetails[25], rownumber, 8),rownumber, 8);
		//****************************************
		model.setValueAt(chllnDetails[26], rownumber, 9);
		model.setValueAt(chllnDetails[26], rownumber, 10);
		model.setValueAt(chllnDetails[35], rownumber, 11);
		model.setValueAt(chllnDetails[15], rownumber, 12);
		model.setValueAt(chllnDetails[15], rownumber, 13);
		model.setValueAt(formatdate(chllnDetails[17]), rownumber, 14);
		model.setValueAt(formatdate(chllnDetails[17]), rownumber, 15);
		if ("Y".equals(chllnDetails[36].toString())) {
			model.setValueAt(chllnDetails[11], rownumber, 17); // depending upon
			// the condition
			model.setValueAt(chllnDetails[11], rownumber, 16); // depending upon
			// the condition
		} else { // ### Removed the condition of 'N' as on 07/04/2015 by Akansha
			model.setValueAt(chllnDetails[11], rownumber, 17); // depending upon
			// the condition
			model.setValueAt(chllnDetails[11], rownumber, 16); // depending upon
			// the condition

		}
		if ("Y".equals(chllnDetails[36].toString())) {
			model.setValueAt("Yes", rownumber, 18);
		} else if ("N".equals(chllnDetails[36].toString())) {
			model.setValueAt("No", rownumber, 18);
		} else {
			model.setValueAt("--Select--", rownumber, 18);
		}

		//new development for FRD1.3 by akansha
		model.setValueAt(fractionhandle(chllnDetails[33], rownumber, 19),rownumber, 19);
		model.setValueAt(fractionhandle(chllnDetails[34], rownumber, 20),rownumber, 20);
		//**************************************
		// ##Newly developed for crrection Ver 1.2
		if ("".equals(chllnDetails[40]) || "0".equals(chllnDetails[40]))
			model.setValueAt("--Select--", rownumber, 21);
		else
			model.setValueAt(chllnDetails[40], rownumber, 21);

		// *********************************************
		if ("".equals(chllnDetails[37].toString()))
			model.setValueAt("0.00", rownumber, 22);
		else
			model.setValueAt(chllnDetails[37], rownumber, 22);
	}

	// Formating the date taken as input from .tds file to dd/mm/yyyy
	// Added by Akansha
	private Object formatdate(Object object) {

		String date = "";
		if (object != null && !"".equals(object.toString())) {
			date = object.toString();
			date = date.substring(0, 2) + "/" + date.substring(2, 4) + "/"
					+ date.substring(4, 8);
			return date;
		} else
			return "";

	}

	// ********************************************************************************************************
	private String changeDate(String string) {
		int date = Integer.parseInt(string.substring(2, 4));
		switch (date) {
		case 1:
			return string.substring(0, 2) + "-January-"
			+ string.substring(4, 8);
		case 2:
			return string.substring(0, 2) + "-February-"
			+ string.substring(4, 8);
		case 3:
			return string.substring(0, 2) + "-March-" + string.substring(4, 8);
		case 4:
			return string.substring(0, 2) + "-April-" + string.substring(4, 8);
		case 5:
			return string.substring(0, 2) + "-May-" + string.substring(4, 8);
		case 6:
			return string.substring(0, 2) + "-June-" + string.substring(4, 8);
		case 7:
			return string.substring(0, 2) + "-July-" + string.substring(4, 8);
		case 8:
			return string.substring(0, 2) + "-August-" + string.substring(4, 8);
		case 9:
			return string.substring(0, 2) + "-September-"
			+ string.substring(4, 8);
		case 10:
			return string.substring(0, 2) + "-October-"
			+ string.substring(4, 8);
		case 11:
			return string.substring(0, 2) + "-November-"
			+ string.substring(4, 8);
		case 12:
			return string.substring(0, 2) + "-December-"
			+ string.substring(4, 8);
		}
		return "";
	}

	private Object[] saveTdDetailsArray(Object[] TrsnDetailsNew,
			String fileExtsn) {
		if (fileExtsn.equals("")) { // changed by Akansha // .grpu

			String lastTan = (String) TrsnDetailsNew[5];
			String remiitedAmountLast = (String) TrsnDetailsNew[24];
			String ddoReg = (String) TrsnDetailsNew[25];
			String ddoCodeLast = (String) TrsnDetailsNew[26];
			String totalTaxLast = (String) TrsnDetailsNew[27];
			String natOfDedLast = (String) TrsnDetailsNew[28];

			System.out.println(totalTaxLast.toString() + " Total Tax Last");

			if (lastTan != null && !lastTan.equalsIgnoreCase("")) {
				TrsnDetailsNew[6] = lastTan;

			}

			if (ddoReg != null && !ddoReg.equalsIgnoreCase("")) {
				TrsnDetailsNew[17] = ddoReg;

			}
			if (ddoCodeLast != null && !ddoCodeLast.equalsIgnoreCase("")) {
				TrsnDetailsNew[18] = ddoCodeLast;

			}
			if (totalTaxLast != null && !totalTaxLast.equalsIgnoreCase("")) {

				TrsnDetailsNew[15] = totalTaxLast;

			}
			if (remiitedAmountLast != null
					&& !remiitedAmountLast.equalsIgnoreCase("")) {
				TrsnDetailsNew[20] = remiitedAmountLast;

			}
			if (natOfDedLast != null && !natOfDedLast.equalsIgnoreCase("")) {
				TrsnDetailsNew[21] = natOfDedLast;

			}
			return TrsnDetailsNew;

		}

		else {
			return TrsnDetailsNew;
		}

	}

	private String getNatureOfDeduction(String natureOfDed) {
		String natureOFDedution = "";

		if (natureOfDed.equals("--Select--") || natureOfDed.equals("")) {

			natureOFDedution = jComboBox_NtrOfDedtn[0];
		} else if (natureOfDed.equals("24Q")) {

			natureOFDedution = jComboBox_NtrOfDedtn[1];
		} else if (natureOfDed.equals("26Q")) {

			natureOFDedution = jComboBox_NtrOfDedtn[2];
		}

		else if (natureOfDed.equals("27Q")) {

			natureOFDedution = jComboBox_NtrOfDedtn[3];
		} else if (natureOfDed.equals("27EQ")) {

			natureOFDedution = jComboBox_NtrOfDedtn[4];
		}

		return natureOFDedution;
	}

	public void disableControls() {
		try {
			jText_AIN.setEditable(false);
			jText_AOName.setEditable(false);
			jText_AOADD1.setEditable(false);
			jText_AOADD2.setEditable(false);
			jText_AOADD3.setEditable(false);
			jText_AOCity.setEditable(false);
			jComboBox_AOState.setEditable(false); // by Akansha
			jText_AOPIN.setEditable(false);
			jText_PhoneNo.setEditable(false);
			jText_EmailID.setEditable(false);
			jText_ResponsiblePersonName.setEditable(false);
			jText_ResponsiblePersonDesgn.setEditable(false);
			jComboBox_FinYear1.setEnabled(false);
			// jComboBox_State_Name.setEnabled(false); //by Akansha
			jComboBox_Deductor_Category.setEnabled(false);
			jComboBox_Month.setEnabled(false);
			// jComboBox_NatureOfDeduction.setEnabled(false);
			jText_CntofDDOTransnDtls.setEditable(false);
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

	public void getError(String errType) {
		errType = "File could not be imported or opened. \n" + errType;
		JOptionPane.showMessageDialog(JdialogFrame, errType);
	}

	private String getCaretLine(Vector getVector) {
		String newStr;
		for (newStr = ""; !getVector.isEmpty(); newStr = newStr
				+ getVector.remove(0) + "^")
			;
		return newStr;
	}

	public void getMessage(final String message) {

		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				JOptionPane.showMessageDialog(JdialogFrame, message);
			}
		});
	}

	public void colorGRPU() {
		contentGRPU.setBackground(Color.getHSBColor(255F, 8F, 255F));
		jPanelButton.setBackground(Color.getHSBColor(255F, 8F, 255F));
		jPanel14.setBorder(BorderFactory.createLineBorder(
				Color.getHSBColor(255F, 8F, 255F), 2));
	}

	public int returnRow() {
		int selectRow = 0;
		try {
			selectRow = jTableTransacDetails.getSelectedRow();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return selectRow;
	}

	public int returnColumn() {
		int selectCol = 0;
		try {
			selectCol = jTableTransacDetails.getSelectedColumn();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return selectCol;
	}

	/*public int fileValidate(File fileName) {
		String nameOfFile = fileName.getAbsolutePath();
		int gCheck = -1;
		try {
			Hash tbafObj = new Hash();
			gCheck = tbafObj.startProcessing(nameOfFile, nameOfFile, 0, 7, 0);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return gCheck;
	}*/

	public boolean validate_RevsnModeTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		boolean gStatus = true;
		if (Typ.trim().equals("O"))
			if (tabval != null) {
				pointToCell("Revision Mode must be NULL", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				gStatus = false;
			} else {
				this.setNoErrorAt(tabrow, tabcol);
				gStatus = true;
			}
		this.setNoErrorAt(tabrow, tabcol);
		return gStatus;
	}

	public boolean validate_OldSrlNoTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		String oldSrlNo = "";
		oldSrlNo = String.valueOf(tabval).trim();
		boolean gStatus = true;
		if (Typ.trim().equals("O"))
			if (!oldSrlNo.equals("null") && !oldSrlNo.equals("")) {
				pointToCell("Old Serial No.  must be NULL", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				gStatus = false;
			} else {
				this.setNoErrorAt(tabrow, tabcol);
				gStatus = true;
			}
		this.setNoErrorAt(tabrow, tabcol);
		return gStatus;
	}

	public boolean validate_TANTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		String tan = "";

		boolean gStatusTAN = false;
		if (Typ.trim().equals("O")) {
			if (tabval == null) {

				System.out.println("Inside Nuill Method");
				pointToCell("10 digit valid TAN should be provided", tabrow,
						tabcol);
				this.setErrorAt(tabrow, tabcol);
				return true;
			}
			tan = tabval.toString().trim();
			// gStatusTAN = checkTan(tan, tabrow);

			// System.out.println(tan+" "+gStatusTAN);
			if (gStatusTAN) {

				//	System.out.println("amit yahan pe hai tu");
				pointToCell("10 digit valid TAN should be provided", tabrow,
						tabcol);
				this.setErrorAt(tabrow, tabcol);
				return true;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return gStatusTAN;
	}

	// Added By for TDS validation

	public boolean validateField(String val) {

		if (val.length() > 0) {
			for (int i = 0; i < val.length(); i++) {
				int val1 = (int) val.charAt(i);
				if (!(val1 > 31 && val1 < 127)) {

					return false;
				}
			}
		}
		return true;
	}

	public boolean checkTan(String tan, int row) {

		tan = tan.toUpperCase();

		if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")
				&& row < numDdoRowsCorr) {

			Object[] tranObject = (Object[]) saveDDOVector.get(row);
			String preTan = tranObject[6].toString();
			preTan = preTan.toUpperCase();
			System.out.println("Insdie Check Tan  " + preTan + row + tan);
			if ((!(preTan.equals("TANINVALID") || preTan.equals("TANNOTAVBL")
					|| preTan.equals("TANAPPLIED") || preTan.equals("")))
					&& (tan.equals("TANINVALID") || tan.equals("TANNOTAVBL") || tan
							.equals("TANAPPLIED"))) {
				return true;
			}
		}
		if (tan.equals("TANINVALID") || tan.equals("TANNOTAVBL")
				|| tan.equals("TANAPPLIED"))
			return false;

		if (tan.trim().length() != 10)
			return true;
		String subtan = tan.substring(0, 3);
		String midSubtan = tan.substring(4, 9);
		String endSubtan = tan.substring(9, 10);
		int rccFlag = 0;
		for (int localR = 0; localR < GRPUConstants.TBAF_TAN_RCC.length; localR++) {
			if (!subtan.equals(GRPUConstants.TBAF_TAN_RCC[localR]))
				continue;
			rccFlag = 1;
			break;
		}

		if (rccFlag == 0)
			return true;

		for (int i = 0; i < 3; i++)
			if (subtan.charAt(i) <= '@' || subtan.charAt(i) >= '[')
				return true;

		if (!Character.isLetterOrDigit(tan.charAt(3)))
			return true;
		if (Character.isLetter(tan.charAt(3))
				&& (tan.charAt(3) <= '@' || tan.charAt(3) >= '['))
			return true;
		for (int i = 0; i < 5; i++)
			if (midSubtan.charAt(i) <= '/' || midSubtan.charAt(i) >= ':')
				return true;

		int checkBit = Integer.parseInt(midSubtan) % 7;
		
		//RPU 2.8 TanFormatChanges start
		if (checkBit == 0 && (endSubtan.charAt(0) == 'A' || endSubtan.charAt(0) == 'H'))
			return false;
		if (checkBit == 1 && (endSubtan.charAt(0) == 'B' || endSubtan.charAt(0) == 'I'))
			return false;
		if (checkBit == 2 && (endSubtan.charAt(0) == 'C' || endSubtan.charAt(0) == 'J'))
			return false;
		if (checkBit == 3 && (endSubtan.charAt(0) == 'D' || endSubtan.charAt(0) == 'K'))
			return false;
		if (checkBit == 4 && (endSubtan.charAt(0) == 'E' || endSubtan.charAt(0) == 'L'))
			return false;
		if (checkBit == 5 && (endSubtan.charAt(0) == 'F' || endSubtan.charAt(0) == 'M'))
			return false;
		if (checkBit == 6 && (endSubtan.charAt(0) == 'G' || endSubtan.charAt(0) == 'N'))
			return false;
		//RPU 2.8 TanFormatChanges end
		
		return true;
	}

	public boolean validate_NameTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		String Name = "";
		if (tabval != null)
			Name = tabval.toString().trim();
		if (Typ.trim().equals("O")) {
			if (tabval == null || Name.length() == 0) {
				pointToCell("Valid Name of the DDO must be provided", tabrow,
						tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (Name.length() >= 76) {
				pointToCell(
						"Name of the DDO cannot be greater than 75 characters",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_Addr1TD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		String Addr1 = "";
		if (tabval != null)
			Addr1 = tabval.toString().trim();
		if (Typ.trim().equals("O")) {
			if (tabval == null || Addr1.length() == 0) {
				pointToCell("Address 1 must Not be NULL", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (Addr1.length() >= 26) {
				pointToCell(
						"Length of Address Line 1 should be less than or equal to 25 characters",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_Addr2TD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		if (tabval != null) {
			String Addr2 = tabval.toString().trim();
			if (Typ.trim().equals("O") && Addr2.length() >= 26) {
				pointToCell(
						"Length of Address Line 2 should be less than or equal to 25 characters",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_Addr3TD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		if (tabval != null) {
			String Addr3 = tabval.toString().trim();
			if (Typ.trim().equals("O") && Addr3.length() >= 26) {
				pointToCell(
						"Length of Address Line 3 should be less than or equal to 25 characters",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_Addr4TD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		if (tabval != null) {
			String Addr4 = tabval.toString().trim();
			if (Typ.trim().equals("O") && Addr4.length() >= 26) {
				pointToCell(
						"Length of Address Line 4 should be less than or equal to 25 characters",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_CityTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		if (tabval == null || tabval.toString().trim().equals("")) {
			pointToCell("Valid DDO City must be provided", tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}
		if (tabval != null) {
			String City = tabval.toString().trim();
			if (City.length() >= 26) {
				pointToCell(
						"Length of DDO City should be less than or equal to 25 characters",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (Typ.trim().equals("O") && GrpuUtil.isValidCityName(City)) {
				pointToCell(
						"Invalid DDO City.Special Characters and Numbers are not allowed",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_StateTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		String StateStr = "";
		String chkState = "";
		if (tabval != null) {
			StateStr = tabval.toString().trim();
			String stCode = GrpuUtil.getStateCode(StateStr.trim());
			if (stCode.trim().equals("") || stCode.trim().equals("--Select--")) {
				pointToCell("DDO State name should be selected from Drop down",
						tabrow, tabcol);
				StateStr = "--Select--";
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		if (Typ.trim().equals("O")
				&& (tabval == null || StateStr.equals("--Select--") || StateStr
				.equals(""))) {
			pointToCell("DDO State name should be selected from Drop down ",
					tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		} else {
			this.setNoErrorAt(tabrow, tabcol);
			return true;
		}
	}

	public boolean validate_PinTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		boolean gPIN = true;
		String pinTD = "";
		int pinVal = 0;
		if (tabval != null) {
			pinTD = tabval.toString().trim();
			try {
				pinVal = Integer.parseInt(pinTD);
			} catch (NumberFormatException e) {
				pointToCell("PIN Code must be provided", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			} catch (Exception e) {
				pointToCell("PIN Code must be provided", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		if (Typ.trim().equals("O")) {
			if (tabval == null || tabval.toString().trim().equals("")) {
				pointToCell("PIN Code must be provided", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			gPIN = GrpuUtil.isInt(pinTD);
			if (!gPIN) {
				pointToCell("PIN Code must be provided", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (pinTD.length() != 6) {
				pointToCell("6 digit Valid PIN Code must be provided", tabrow,
						tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (pinVal < 0x1adb1) {
				pointToCell("6 digit Valid PIN Code must be provided", tabrow,
						tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (pinVal == 999999) {
				pointToCell("6 digit Valid PIN Code must be provided", tabrow,
						tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_TaxAmountTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		boolean gtaxAmt = true;
		String taxAmtTD = "";

		if (tabval != null)
			taxAmtTD = tabval.toString().trim();

		if (Typ.trim().equals("O")) {
			if (tabval == null || tabval.toString().trim().equals("")) {
				pointToCell("Tax Amount must be provided", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			gtaxAmt = GrpuUtil.isInt(taxAmtTD);
			if (!gtaxAmt) {
				pointToCell(
						"Valid Tax Amount must be provided (For e.g. 1000)",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (taxAmtTD.length() >= 13) {
				pointToCell(
						"Length of Tax Amount should be less than or equal to 12",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			if (taxAmtTD.indexOf(".") != -1) {
				pointToCell(
						"TAX Amount should be a valid Number.Decimals not allowed.",
						tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validate_MthYrTD(Object tabval, String Typ, int tabrow,
			int tabcol) {
		String MthYrArray[] = new String[2];
		int i = 0;
		String MthYrStr = "";
		if (Typ.trim().equals("O")
				&& (tabval == null || tabval.toString().trim()
				.equals("--Select--"))) {
			pointToCell("Please select a valid Month & Year of Payment",
					tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}
		if (tabval != null) {
			MthYrStr = tabval.toString().trim();
			if (!MthYrStr.equals("")) {
				for (StringTokenizer parser = new StringTokenizer(MthYrStr, " "); parser
						.hasMoreTokens();) {
					MthYrArray[i] = parser.nextToken().toString().trim();
					i++;
				}

				if (i != 2) {
					getMessage("Invalid Month & Year of Payment at Row : "
							+ (tabrow + 1) + " Column  : " + (tabcol - 2));
					this.setErrorAt(tabrow, tabcol);
					return false;
				}
				if (!chkMthYrClipboard(MthYrArray, -2)) {
					TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
					getMessage("Please select a valid Month & Year at Row : "
							+ (tabrow + 1) + " Column  : " + (tabcol - 2));
					this.setErrorAt(tabrow, tabcol);
					return false;
				}
			} else {
				getMessage("Please select a valid Month & Year at Row : "
						+ (tabrow + 1) + " Column  : " + (tabcol - 2));
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			String tanMonthYear = model.getValueAt(tabrow, 4).toString().trim()
					+ MthYrStr;
			if (hashTanMthYr.contains(tanMonthYear)) {
				getMessage("Month & Year of Payment should not appear more than once for the same TAN( "
						+ model.getValueAt(tabrow, 4).toString().trim()
						+ ") at Row : "
						+ (tabrow + 1)
						+ " Column  : "
						+ (tabcol - 2));
				this.setErrorAt(tabrow, tabcol);
				return false;
			}
			hashTanMthYr.add(tanMonthYear);
		} else {
			return false;
		}
		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public void pointToCell(String msg, int tabrow, int tabcol) {
		String message = msg + " at row : " + (tabrow + 1) + " and col : "
				+ (tabcol - 2);
		TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
		getMessage(message);
		scrollToVisible(jTableTransacDetails, tabrow - 1, tabcol);
	}

	public void pointToCellForDdoMapping(String msg, int tabrow, int tabcol) {
		String message = msg + " at row : " + (tabrow + 1) + " and col : "
				+ (tabcol - 4);
		TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
		getMessage(message);
		scrollToVisible(jTableTransacDetails, tabrow - 1, tabcol - 2);
	}

	public boolean BH_nullCheck() {
		boolean gBH = true;
		if (jText_AIN.getText().trim().equals("")) {
			String message = "Please enter "
					+ jLabel_AIN.getText().substring(0,
							jLabel_AIN.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jComboBox_FinYear1.getSelectedItem().equals("")
				|| jComboBox_FinYear1.getSelectedItem().equals("--Select--")) {
			String message = "Please select "
					+ jLabel_FinYear.getText().substring(0,
							jLabel_FinYear.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jComboBox_Month.getSelectedItem().equals("")
				|| jComboBox_Month.getSelectedItem().equals("--Select--")) {
			String message = "Please select "
					+ jLabel_Month.getText().substring(0,
							jLabel_Month.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jText_AOName.getText().trim().equals("")) {
			String message = "Please enter "
					+ jLabel_AOName.getText().substring(0,
							jLabel_AOName.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_AOName.setText("");
			return false;
		} // Added by manish
		else if (!checkOneAlpahNum(jText_AOName.getText())) {
			String message = "Special Characters / Numbers not Allowed in "
					+ jLabel_AOName.getText().substring(0,
							jLabel_AOName.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_AOName.setText("");
			return false;

		}
		if (jText_AOADD1.getText().trim().equals("")) {
			String message = "Please enter AO "
					+ jLabel_AOADD1.getText().substring(0,
							jLabel_AOADD1.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_AOADD1.setText("");
			return false;
		} // Added by manish
		else if (!checkOneAlpah(jText_AOADD1.getText())) {
			String message = "Special Characters not Allowed in "
					+ jLabel_AOADD1.getText().substring(0,
							jLabel_AOADD1.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_AOADD1.setText("");
			return false;

		}
		if (!(jText_AOADD2.getText().trim().equals(""))) {
			if (!checkOneAlpah(jText_AOADD2.getText())) {
				String message = "Special Characters not Allowed in "
						+ jLabel_AOADD2.getText().substring(0,
								jLabel_AOADD2.getText().length());
				TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
				JOptionPane.showMessageDialog(JdialogFrame, message);
				jText_AOADD2.setText("");
				return false;

			}
		}
		if (!(jText_AOADD3.getText().trim().equals(""))) {
			if (!checkOneAlpah(jText_AOADD3.getText())) {
				String message = "Special Characters not Allowed in "
						+ jLabel_AOADD3.getText().substring(0,
								jLabel_AOADD3.getText().length());
				TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
				JOptionPane.showMessageDialog(JdialogFrame, message);
				jText_AOADD3.setText("");
				return false;

			}
		}
		if (!(jText_AOADD4.getText().trim().equals(""))) {
			if (!checkOneAlpah(jText_AOADD4.getText())) {
				String message = "Special Characters not Allowed in"
						+ jLabel_AOADD4.getText().substring(0,
								jLabel_AOADD4.getText().length());
				TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
				JOptionPane.showMessageDialog(JdialogFrame, message);
				jText_AOADD4.setText("");
				return false;

			}
		}
		if (jText_AOCity.getText().trim().equals("")) {
			String message = "Please enter AO "
					+ jLabel_AOCity.getText().substring(0,
							jLabel_AOCity.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_AOCity.setText("");
			return false;
		}

		// End Manish
		if (jComboBox_AOState.getSelectedItem().equals("")
				|| jComboBox_AOState.getSelectedItem().equals("--Select--")) {
			String message = "Please select AO "
					+ jLabel_AOState.getText().substring(0,
							jLabel_AOState.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		if (jText_AOPIN.getText().trim().equals("")) {
			String message = "Please enter AO "
					+ jLabel_AOPIN.getText().substring(0,
							jLabel_AOPIN.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		if (jText_STD.getText().trim().equals("")) {
			String message = "Please enter AO STD Code";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		if (jText_PhoneNo.getText().trim().equals("")) {
			String message = "Please enter AO "
					+ jLabel_PhoneNo.getText().substring(0,
							jLabel_PhoneNo.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jText_EmailID.getText().trim().equals("")) {
			String message = "Please enter AO Email id.";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jComboBox_Deductor_Category.getSelectedItem().equals("")
				|| jComboBox_Deductor_Category.getSelectedItem().equals(
						"--Select--")) {
			String message = "Please select "
					+ jLabel_Deductor_Category.getText().substring(0,
							jLabel_Deductor_Category.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		if (jComboBox_Deductor_Category.getSelectedItem().equals("State Govt.")
				&& jComboBox_State_Name.getSelectedItem().equals("--Select--")) {

			String message = "Please select Name of State for AO";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jComboBox_Deductor_Category.getSelectedItem().equals("State Govt.")
				&& !jComboBox_MinistryName.getSelectedItem().equals(
						"--Select--")) {

			String message = "Invalid Ministry Name";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jComboBox_Deductor_Category.getSelectedItem().equals(
				"Central Govt.")
				&& jComboBox_MinistryName.getSelectedItem()
				.equals("--Select--")) {
			String message = "Please enter " + jLabel_MinistryName.getText();
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jComboBox_MinistryName.isEditable()
				&& jComboBox_MinistryName.getSelectedIndex() == 1
				&& jComboBox_SubMinistryName.getSelectedIndex() == 0) {
			String message = "Please select "
					+ jLabel_SubMinistryName.getText();
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jComboBox_SubMinistryName.getSelectedIndex() != 0
				&& jText_OtherMinistryName.isEditable()
				&& jText_OtherMinistryName.getText().equals("")) {
			String message = "Please enter "
					+ jLabel_OtherMinistryName.getText();
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		if (jText_ResponsiblePersonName.getText().equals("")) {
			String message = "Please enter "
					+ jLabel_ResponsiblePersonName.getText()
					.substring(
							0,
							jLabel_ResponsiblePersonName.getText()
							.length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_ResponsiblePersonName.setText("");
			return false;
		} // Added by manish
		else if (!checkOneAlpahNum(jText_ResponsiblePersonName.getText())) {
			String message = "Special Characters / Numbers  not Allowed in "
					+ jLabel_ResponsiblePersonName.getText()
					.substring(
							0,
							jLabel_ResponsiblePersonName.getText()
							.length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_ResponsiblePersonName.setText("");
			return false;

		}
		if (jText_ResponsiblePersonDesgn.getText().trim().equals("")) {
			String message = "Please enter "
					+ jLabel_ResponsiblePersonDesgn.getText()
					.substring(
							0,
							jLabel_ResponsiblePersonDesgn.getText()
							.length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_ResponsiblePersonDesgn.setText("");
			return false;
		} else if (!checkOneAlpahNum(jText_ResponsiblePersonDesgn.getText())) {
			String message = "Special Characters / Numbers not Allowed in "
					+ jLabel_ResponsiblePersonDesgn.getText()
					.substring(
							0,
							jLabel_ResponsiblePersonDesgn.getText()
							.length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_ResponsiblePersonDesgn.setText("");
			return false;

		}

		if (jText_ResponsiblePersonADD1.getText().trim().equals("")) {
			String message = "Please enter Responsible Person's Address Line 1";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_ResponsiblePersonADD1.setText("");
			return false;
		} else if (!checkOneAlpah(jText_ResponsiblePersonADD1.getText())) {
			String message = "Special Characters not Allowed in "
					+ jLabel_ResponsiblePersonADD1.getText()
					.substring(
							0,
							jLabel_ResponsiblePersonADD1.getText()
							.length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			jText_ResponsiblePersonADD1.setText("");
			return false;

		}
		if (!(jText_ResponsiblePersonADD2.getText().trim().equals(""))) {
			if (!checkOneAlpah(jText_ResponsiblePersonADD2.getText())) {
				String message = "Special Characters  not Allowed in "
						+ jLabel_ResponsiblePersonADD2.getText()
						.substring(
								0,
								jLabel_ResponsiblePersonADD2.getText()
								.length());
				TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
				JOptionPane.showMessageDialog(JdialogFrame, message);
				jText_ResponsiblePersonADD2.setText("");
				return false;

			}
		}
		if (!(jText_ResponsiblePersonADD3.getText().trim().equals(""))) {
			if (!checkOneAlpah(jText_ResponsiblePersonADD3.getText())) {
				String message = "Special Characters not Allowed in "
						+ jLabel_ResponsiblePersonADD3.getText()
						.substring(
								0,
								jLabel_ResponsiblePersonADD3.getText()
								.length());
				TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
				JOptionPane.showMessageDialog(JdialogFrame, message);
				jText_ResponsiblePersonADD3.setText("");
				return false;

			}
		}
		if (!(jText_ResponsiblePersonADD4.getText().trim().equals(""))) {
			if (!checkOneAlpah(jText_ResponsiblePersonADD4.getText())) {
				String message = "Special Characters not Allowed in"
						+ jLabel_ResponsiblePersonADD4.getText()
						.substring(
								0,
								jLabel_ResponsiblePersonADD4.getText()
								.length());
				TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
				JOptionPane.showMessageDialog(JdialogFrame, message);
				jText_ResponsiblePersonADD4.setText("");
				return false;

			}
		}

		// End by manish

		if (jText_ResponsiblePersonCity.getText().trim().equals("")) {
			String message = "Please enter Responsible Person's city";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		if (jComboBox_ResponsiblePersonState.getSelectedItem().equals("")
				|| jComboBox_ResponsiblePersonState.getSelectedItem().equals(
						"--Select--")) {
			String message = "Please enter Responsible Person's State/UT";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		if (jText_ResponsiblePersonPIN.getText().trim().equals("")) {
			String message = "Please enter Responsible Person's PIN ";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}

		String rpSTD = jText_ResponsiblePersonSTD.getText().trim();
		String rpPhone = jText_ResponsiblePersonPhoneNo.getText().trim();
		String rpMobile = jText_ResponsiblePersonMobilePhoneNo.getText().trim();

		if (rpSTD.equals("") && rpPhone.equals("") && rpMobile.equals("")) {
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane
			.showMessageDialog(JdialogFrame,
					"Please enter mobile phone no. or phone no. for responsible person");
			return false;
		}
		if (rpSTD.equals("") && !rpPhone.equals("")) {
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame,
					"Please provide STD code for responsible person");
			return false;
		}

		if (!rpSTD.equals("") && rpPhone.equals("")) {
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame,
					"Please provide phone number for responsible person");
			return false;
		}

		if (jText_ResponsiblePersonEmailID.getText().trim().equals("")) {
			String message = "Please enter Responsible Person's Email id";
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		return true;

	}

	// Added By Manish
	private boolean checkOneAlpahNum(String str) {
		if (str != null) {
			int lenghtOfString = str.length();
			if (str.trim().length() != lenghtOfString) {
				return false;
			}
			for (int i = 0; i < lenghtOfString; i++) {
				if ((str.charAt(i) > 64 && str.charAt(i) < 91)
						|| (str.charAt(i) > 96 && str.charAt(i) < 123)) {
					return true;
				}
			}
		}
		return false;
	}

	private boolean checkOneAlpah(String str) {
		if (str != null) {
			int lenghtOfString = str.length();
			if (str.trim().length() != lenghtOfString) {
				return false;
			}
			for (int i = 0; i < lenghtOfString; i++) {
				if ((str.charAt(i) > 47 && str.charAt(i) < 58)
						|| ((str.charAt(i) > 64 && str.charAt(i) < 91) || (str
								.charAt(i) > 96 && str.charAt(i) < 123))) {
					return true;
				}
			}
		}
		return false;
	}

	public void packColumn(JTable table, int vColIndex, int margin) {
		TableModel model = jTableTransacDetails.getModel();
		DefaultTableColumnModel colModel = (DefaultTableColumnModel) jTableTransacDetails
				.getColumnModel();
		TableColumn col = colModel.getColumn(vColIndex);
		int width = 0;
		TableCellRenderer renderer = col.getHeaderRenderer();
		if (renderer == null)
			renderer = table.getTableHeader().getDefaultRenderer();
		Component comp = renderer.getTableCellRendererComponent(table,
				col.getHeaderValue(), false, false, 0, 0);
		width = comp.getPreferredSize().width;
		for (int r = 0; r < table.getRowCount(); r++) {
			renderer = table.getCellRenderer(r, vColIndex);
			comp = renderer.getTableCellRendererComponent(table,
					table.getValueAt(r, vColIndex), false, false, r, vColIndex);
			width = Math.max(width, comp.getPreferredSize().width);
		}

		width += margin;
		col.setPreferredWidth(width);
	}

	// added by for insert rows

	public void packColumn_inertRow(JTable table, int vColIndex, int margin) {
		TableModel model = jTableTransacDetails_insert.getModel();
		DefaultTableColumnModel colModel = (DefaultTableColumnModel) jTableTransacDetails_insert
				.getColumnModel();
		TableColumn col = colModel.getColumn(vColIndex);
		int width = 0;
		TableCellRenderer renderer = col.getHeaderRenderer();
		if (renderer == null)
			renderer = table.getTableHeader().getDefaultRenderer();
		Component comp = renderer.getTableCellRendererComponent(table,
				col.getHeaderValue(), false, false, 0, 0);
		width = comp.getPreferredSize().width;
		for (int r = 0; r < table.getRowCount(); r++) {
			renderer = table.getCellRenderer(r, vColIndex);
			comp = renderer.getTableCellRendererComponent(table,
					table.getValueAt(r, vColIndex), false, false, r, vColIndex);
			width = Math.max(width, comp.getPreferredSize().width);
		}

		width += 2 * margin;
		col.setPreferredWidth(width);
	}

	//

	public void packColumn1(JTable table, int vColIndex, int margin) {

		TableModel model = jTableTransacDetails1.getModel();
		DefaultTableColumnModel colModel = (DefaultTableColumnModel) jTableTransacDetails1.getColumnModel();
		TableColumn col = colModel.getColumn(vColIndex);
		int width = 0;
		TableCellRenderer renderer = col.getHeaderRenderer();
		if (renderer == null)
			renderer = table.getTableHeader().getDefaultRenderer();
		Component comp = renderer.getTableCellRendererComponent(table,
				col.getHeaderValue(), false, false, 0, 0);
		width = comp.getPreferredSize().width;
		for (int r = 0; r < table.getRowCount(); r++) {
			renderer = table.getCellRenderer(r, vColIndex);
			comp = renderer.getTableCellRendererComponent(table,
					table.getValueAt(r, vColIndex), false, false, r, vColIndex);
			width = Math.max(width, comp.getPreferredSize().width);

		}

		width += 2 * margin;
		col.setPreferredWidth(width);
	}

	public void packColumn2(JTable table, int vColIndex, int margin) {
		TableModel model = jTableTransacDetails2.getModel();
		DefaultTableColumnModel colModel = (DefaultTableColumnModel) jTableTransacDetails2
				.getColumnModel();
		TableColumn col = colModel.getColumn(vColIndex);

		int width = 0;
		TableCellRenderer renderer = col.getHeaderRenderer();
		if (renderer == null)
			renderer = table.getTableHeader().getDefaultRenderer();
		Component comp = renderer.getTableCellRendererComponent(table,
				col.getHeaderValue(), false, false, 0, 0);
		width = comp.getPreferredSize().width;
		for (int r = 0; r < table.getRowCount(); r++) {
			renderer = table.getCellRenderer(r, vColIndex);
			comp = renderer.getTableCellRendererComponent(table,
					table.getValueAt(r, vColIndex), false, false, r, vColIndex);
			width = Math.max(width, comp.getPreferredSize().width);
		}

		width += 2 * margin;
		col.setPreferredWidth(width);
	}

	public static void setClipboard(String str) {
		StringSelection ss = new StringSelection(str);
		Toolkit.getDefaultToolkit().getSystemClipboard().setContents(ss, null);
	}

	public boolean chkMthYrClipboard(String MthYrArray[], int rowN) {
		String code = "";
		String monthVal = MthYrArray[0].trim();
		String YearVal = MthYrArray[1].trim();
		String getQ = GrpuUtil.getQtr(monthVal.trim());
		String QtrAOForm = jComboBox_Month.getSelectedItem().toString().trim();
		String FinYrAOForm = GrpuUtil.getFinYr(jComboBox_FinYear1
				.getSelectedItem().toString().trim());
		int nxtFinYr = 0;
		String NxtYrStr = "";
		boolean comboValYr = jComboBox_FinYear1.getSelectedItem().equals(
				"--Select--")
				|| jComboBox_FinYear1.getSelectedItem().equals("");
		boolean comboValQ = jComboBox_Month.getSelectedItem().equals(
				"--Select--")
				|| jComboBox_Month.getSelectedItem().equals("");
		String msgStr = "";
		try {
			if (!comboValYr) {
				nxtFinYr = Integer.parseInt(FinYrAOForm) + 1;
				NxtYrStr = String.valueOf(nxtFinYr);
			}
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (rowN != -2)
			msgStr = "'Month & Year of Payment'  in the Row  " + rowN
			+ " being copied by you from " + " MS EXCEL is IMPROPER.\n";
		else
			msgStr = "";
		// Changed by Abhishek on 18052010 added "YearVal.equals("2007")"
		boolean chkYear = YearVal.equals("2006") || YearVal.equals("2007")
				|| YearVal.equals("2008") || YearVal.equals("2009")
				|| YearVal.equals("2010") || YearVal.equals("2011");
		code = GrpuUtil.getMonthCode(monthVal);
		if (YearVal.length() != 4) {
			getMessage("Invalid Year");
			return false;
		}
		if (code.trim().equals("")) {
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			getMessage("Invalid Month");
			return false;
		}
		if (!chkYear) {
			getMessage("Invalid Year");
			return false;
		}
		if (comboValYr || comboValQ) {
			getMessage("Please make sure to select '"
					+ jLabel_FinYear.getText().substring(0,
							jLabel_FinYear.getText().length() - 1)
							+ " ' and '"
							+ jLabel_Month.getText().substring(0,
									jLabel_Month.getText().length() - 1)
									+ " ' from the AO form");
			return rowN != -2;
		}
		if (!getQ.equals(QtrAOForm)) {
			if (QtrAOForm.trim().equals("Q1")) {
				getMessage(msgStr
						+ "Month does'nt match the 'Quarter' selected by you in "
						+ " 'AO & Statement Details Form' .\n For Quarter : "
						+ jComboBox_Month.getSelectedItem()
						+ " : Expected value for Month : April/May/June. "
						+ "\nPlease select a " + "valid value "
						+ "from the Drop down box provided in "
						+ "'Column 12(Month & Year of Payment)'");
				return false;
			}
			if (QtrAOForm.trim().equals("Q2")) {
				getMessage(msgStr
						+ "Month does'nt match the 'Quarter' selected by you in "
						+ "'AO & Statement Details Form' .\n For Quarter : "
						+ jComboBox_Month.getSelectedItem()
						+ " : Expected value for Month : July/August/September."
						+ "\n Please select a valid value "
						+ "from the Drop down box provided in 'Column 12(Month & Year of Payment)'");
				return false;
			}
			if (QtrAOForm.trim().equals("Q3")) {
				getMessage(msgStr
						+ "Month does'nt match the 'Quarter' selected by you in "
						+ "'AO & Statement Details Form' .\n For Quarter : "
						+ jComboBox_Month.getSelectedItem()
						+ " : Expected value for Month : October/November/December."
						+ "\n Please select a valid value "
						+ "from the Drop down box provided "
						+ "in 'Column 12(Month & Year of Payment)'");
				return false;
			}
			if (QtrAOForm.trim().equals("Q4")) {
				getMessage(msgStr
						+ "Month does'nt match the 'Quarter' selected by you in "
						+ " 'AO & Statement Details Form '.\n For Quarter : "
						+ jComboBox_Month.getSelectedItem()
						+ " : Expected value for Month : January/February/March.\n Please select a valid value "
						+ "from the Drop down box provided in 'Column 12(Month & Year of Payment)'");
				return false;
			}
		} else if (!QtrAOForm.trim().equals("Q4")) {
			if (!YearVal.equals(FinYrAOForm)) {
				getMessage(msgStr
						+ "Year "
						+ YearVal
						+ " entered by you for 'Month & Year of Payment' does'nt match "
						+ "the 'Financial Year' selected by you in 'AO & Statement Details Form' ."
						+ "\n Expected value for Year :"
						+ FinYrAOForm
						+ ".\n Please select a valid value from the Drop down box provided in "
						+ "'Column 12(Month & Year of Payment)'");
				return false;
			}
		} else if (QtrAOForm.trim().equals("Q4")
				&& !YearVal.trim().equals(NxtYrStr.trim())) {
			getMessage(msgStr
					+ "You are copying "
					+ YearVal
					+ " as Year for 'Month & Year of Payment'.\n "
					+ "You selected Year "
					+ FinYrAOForm
					+ " as Financial Year from the Drop down in "
					+ "'AO & Statement Details Form'.\n For Quarter 'Q4' and Financial Year "
					+ FinYrAOForm
					+ " 'Month & Year of Payment' should be : January "
					+ NxtYrStr.trim()
					+ " / February "
					+ NxtYrStr.trim()
					+ " / March "
					+ NxtYrStr.trim()
					+ "\n Please select a valid value from the Drop down box provided in "
					+ "'Column 12(Month & Year of Payment)'");
			return false;
		}
		return true;
	}

	// commented by monu
	public String cellTooltip(int ColVal) {
		if (ColVal > GRPUConstants.CELL_TOOLTIP_TEXT.length)
			return null;
		else
			return GRPUConstants.CELL_TOOLTIP_TEXT[ColVal];
	}

	public String cellTooltip1(int ColVal) {
		if (ColVal > GRPUConstants.CELL_TOOLTIP_TEXT1.length)
			return null;
		else
			return GRPUConstants.CELL_TOOLTIP_TEXT1[ColVal];
	}

	// ## Newly added by Akansha for Ver 1.1
	public String cellTooltip27EQ(int ColVal) {
		if (ColVal > GRPUConstants.CELL_TOOLTIP_TEXT27EQ.length)
			return null;
		else
			return GRPUConstants.CELL_TOOLTIP_TEXT27EQ[ColVal];
	}

	public String cellTooltip24Q(int ColVal) {
		if (ColVal > GRPUConstants.CELL_TOOLTIP_TEXT24Q.length)
			return null;
		else
			return GRPUConstants.CELL_TOOLTIP_TEXT24Q[ColVal];
	}
	//RPU 3.1 start
	public String cellTooltip26Q(int ColVal) {
		if (ColVal > GRPUConstants.CELL_TOOLTIP_TEXT26Q.length)
			return null;
		else
			return GRPUConstants.CELL_TOOLTIP_TEXT26Q[ColVal];
	}
	

	// ************************************

	public String cellTooltip2(int ColVal) {
		if (ColVal > GRPUConstants.CELL_TOOLTIP_TEXT2.length)
			return null;
		else
			return GRPUConstants.CELL_TOOLTIP_TEXT2[ColVal];
	}

	private void cut() {
		copyOrCut(true); 
	}

	private void copy() {
		copyOrCut(false);
	}

	private void deleteCell() {
		System.out.println("In Delete Cell");
		deleteFlag = true;
		try {
			int D_Row = jTableTransacDetails.getSelectedRow();
			if (jTableTransacDetails.getSelectedRowCount() >= 1) {
				copyOrCut(false);
				int rowDeleted[] = jTableTransacDetails.getSelectedRows();
				int ColDeleted[] = jTableTransacDetails.getSelectedColumns();
				int selCol = jTableTransacDetails.getSelectedColumn();
				if (selCol == 0) {
					for (int i = 0; i < rowDeleted.length; i++) {
						// Added by manish
						if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
							if (rowDeleted[i] < numDdoRowsCorr) {
								getMessage("The Selected Rows/Columns cannot be deleted.");
								break;
							}
						}

						for (int j = 3; j < jTableTransacDetails
								.getColumnCount(); j++) {
							if (j == 3 || j >= 20) {
								continue;
							}

							model.setValueAt("", rowDeleted[i], j);
							if (j == 15 || j == 23 || j == 24)
								model.setValueAt("--Select--", rowDeleted[i], j);

						}

						model.fireTableRowsUpdated(rowDeleted[i], rowDeleted[i]);
					}

				} else {
					for (int i = 0; i < selectedData.size(); i++) {

						String tanValue = "";
						if (rowDeleted[i] < numDdoRowsCorr) {
							Object[] transObject = (Object[]) saveDDOVector
									.get(rowDeleted[i]);
							tanValue = transObject[6].toString();
							System.out.println(tanValue + " Tan Value");

						}

						if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {

							// Added by manish
							String revValue = model
									.getValueAt(rowDeleted[i], 2).toString();
							if (rowDeleted[i] < numDdoRowsCorr
									&& !revValue.equalsIgnoreCase("Update")) {
								getMessage("The Selected Rows/Columns cannot be deleted.");
								break;
							}

						}
						for (int j = selCol; j < ColDeleted.length + selCol; j++)
							if (j != 0) {
								if (j == 2 || j == 3 || columnNumberEditable(j)) {
									continue;
								}

								model.setValueAt("", rowDeleted[i], j);
								if (j == 15 || j == 23 || j == 24
										|| columnNumberEditable(j))
									model.setValueAt("--Select--",
											rowDeleted[i], j);
							}

						model.fireTableRowsUpdated(rowDeleted[i], rowDeleted[i]);
					}

				}
			}
			selectedData.clear();
		} catch (NullPointerException nullpointerexception) {
		} catch (Exception exception) {
		}
	}

	private void copyOrCut(boolean cutFlag) {
		System.out.println("Copy");
		isCutSelected = cutFlag;
		selectedRows = jTableTransacDetails.getSelectedRows();

		selectedRowCount = jTableTransacDetails.getSelectedRowCount();

		if (jTableTransacDetails.isColumnSelected(0)) {
			isRowSelected = true;
			selectedCols = NULL_INT_ARRAY;
			selectedColCount = 0;
		} else {
			isRowSelected = false;
			selectedCols = jTableTransacDetails.getSelectedColumns();
			selectedColCount = jTableTransacDetails.getSelectedColumnCount();
		}
		selectedData.clear();
		data = model.getDataVector();
		for (int i = 0; i < selectedRows.length; i++) {
			row = (Vector) data.elementAt(selectedRows[i]);
			if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
				int selRowIndex = selectedRows[i];

				String revValue = model.getValueAt(selRowIndex, 2).toString();

				if (selRowIndex < numDdoRowsCorr && cutFlag == true
						&& !revValue.equalsIgnoreCase("Update")) {
					selectedData.clear();
					if (isRowSelected)
						getMessage("The selected rows cannot be cut");
					if (selectedColCount > 0)
						getMessage("The selected columns cannot be cut");

					isRowSelected = false;
					//	isCutSelected = false; -- temp akki
					cutFlag = false;

					return;
				}

			}

			row = (Vector) row.clone();

			// Removed by manish To set Value of Drop Down Boxes for paste
			// row.set(18, "");
			// row.set(19, "");
			selectedData.addElement(row);
		}

	}

	public void paste() {
		System.out.println("Inside PAste");
		data = model.getDataVector();

		if ((jTableTransacDetails.getSelectedRowCount() != selectedRowCount || jTableTransacDetails
				.getSelectedColumnCount() != selectedColCount)
				&& (jTableTransacDetails.getSelectedRowCount() != 1 || jTableTransacDetails
				.getSelectedColumnCount() != 1)) {
			getMessage("Selection Area is not same as cut/copy area...");
			return;
		}
		if (selectedRowCount > model.getRowCount()
				- jTableTransacDetails.getSelectedRow()) {
			getMessage("Not enough no of rows to paste... ");
			return;
		}
		if (selectedColCount > model.getColumnCount()
				- jTableTransacDetails.getSelectedColumn()) {
			getMessage("Not enough no of Columns to paste... ");
			return;
		}
		if (isRowSelected) {

			int sRow = jTableTransacDetails.getSelectedRow();
			Vector fromRow = null;
			Vector toRow = null;
			for (int i = 0; i < selectedData.size(); i++) {
				fromRow = (Vector) selectedData.elementAt(i);

				toRow = (Vector) data.elementAt(sRow + i);
				if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
					String revModevalue = model.getValueAt(sRow + i, 2)
							.toString();
					if (!model.isCellEditable(sRow + i, 4)
							&& !revModevalue.equalsIgnoreCase("Update")) {
						getMessage("Data cannot be pasted in non-editable rows or columns");
						return;
					}
				} else {
					if (!model.isCellEditable(sRow + i, 4)) {
						getMessage("Data cannot be pasted in non-editable rows or columns");
						return;
					}

				}
				for (int j = 3; j < fromRow.size(); j++) {

					if (j == 3 || columnNumberEditable(j)) {

						continue;
					}
					toRow.set(j, fromRow.get(j));
				}
				model.fireTableRowsUpdated(sRow + i, sRow + i);
			}

			if (isCutSelected) {
				for (int i = 0; i < selectedRows.length; i++) {
					row = (Vector) data.elementAt(selectedRows[i]);
					int rowNumber = Integer.parseInt((String) row.get(0));
					for (int k = 3; k < fromRow.size(); k++) {
						if ((k == 4 && !model.isCellEditable(rowNumber, 4))
								|| k == 3) {
							continue;
						}
						if (k == 3 || columnNumberEditable(k))
							continue;
						else if (k == 15 || k == 23 || k == 24)
							row.set(k, "--Select--");
						else
							row.set(k, "");
					}

					model.fireTableRowsUpdated(selectedRows[i], selectedRows[i]);
				}

			}
		} else {

			int sRow = jTableTransacDetails.getSelectedRow();
			Vector fromRow = null;
			Vector toRow = null;
			int sCol = jTableTransacDetails.getSelectedColumn();
			if (sCol == 0 || sCol == 15 || sCol == 23 || sCol == 24
					|| columnNumberEditable(sCol)) {
				getMessage("You cannot paste here.. ");
				return;
			}
			if (isCutSelected) {
				for (int i = 0; i < selectedRows.length; i++) {
					row = (Vector) data.elementAt(selectedRows[i]);
					for (int j = 0; j < selectedCols.length; j++)
						if (selectedCols[j] > 2)
							if (selectedCols[j] == 15 || selectedCols[j] == 23
							|| selectedCols[j] == 24
							|| selectedCols[j] == 3
							|| columnNumberEditable(selectedCols[j]))
								continue;
							else
								row.set(selectedCols[j], "");

					model.fireTableRowsUpdated(selectedRows[i], selectedRows[i]);
				}

			}
			for (int i = 0; i < selectedData.size(); i++) {
				fromRow = (Vector) selectedData.elementAt(i);
				toRow = (Vector) data.elementAt(sRow + i);

				if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
					String revModevalue = model.getValueAt(sRow + i, 2)
							.toString();

					if (!model.isCellEditable(sRow + i, 4)
							&& !revModevalue.equalsIgnoreCase("Update")) {// Col
						// 4
						// is
						// being
						// checked
						// for
						// editable
						// as
						// if
						// a
						// row
						// is
						// editable
						// then
						// TAN
						// should
						// be
						// editable
						getMessage("Data cannot be pasted in non-editable rows or columns");
						return;
					}
				} else {
					if (!model.isCellEditable(sRow + i, 4)) {// Col 4 is being
						// checked for
						// editable as
						// if a row is
						// editable then
						// TAN should be
						// editable
						getMessage("Data cannot be pasted in non-editable rows or columns");
						return;
					}

				}
				for (int j = 0; j < selectedCols.length; j++) {
					if (selectedCols[j] > 2)
						if (sCol + j == 15 || sCol + j == 23 || sCol + j == 24
						|| columnNumberEditable(sCol + j)
						|| sCol + j == 3)
							continue;
						else if (TDCellPasteValidations.Validate_Field(
								fromRow.get(selectedCols[j]), sRow + i, sCol
								+ j))
							toRow.set(sCol + j, fromRow.get(selectedCols[j]));
						else
							toRow.set(sCol + j, "");
				}
				model.fireTableRowsUpdated(sRow + i, sRow + i);
			}

		}
		isCutSelected = false;
	}

	public void BH_CORRsetTabStops() {

	}

	public void BH_REGsetTabStops() {

		jText_AOName.setNextFocusableComponent(jText_AOADD1);

		jText_AOADD1.setNextFocusableComponent(jText_AOADD2);
		jText_AOADD2.setNextFocusableComponent(jText_AOADD3);
		jText_AOADD3.setNextFocusableComponent(jText_AOADD4);
		jText_AOADD4.setNextFocusableComponent(jText_AOCity);
		jText_AOCity.setNextFocusableComponent(jComboBox_AOState);
		// Added by Akansha
		// For 2nd Panel
		// jComboBox_AOState.setNextFocusableComponent(jText_Form_Sub2_PinCode);
		jText_Form_Sub2_PinCode.setNextFocusableComponent(jComboBox_AOState);
		jComboBox_AOState
		.setNextFocusableComponent(jText_Form_Sub2_TelNum_Std_Code);
		jText_Form_Sub2_TelNum_Std_Code
		.setNextFocusableComponent(jText_Form_Sub2_TelNum);
		jText_Form_Sub2_TelNum.setNextFocusableComponent(jText_Form_Sub2_Email);
		jText_Form_Sub2_Email
		.setNextFocusableComponent(jText_Form_Sub2_AlternateTelNum_Std_Code);
		jText_Form_Sub2_AlternateTelNum_Std_Code
		.setNextFocusableComponent(jText_Form_Sub2_AlternateTelNum);
		jText_Form_Sub2_AlternateTelNum
		.setNextFocusableComponent(jText_Form_Sub2_Email_Alternate);
		jText_Form_Sub2_Email_Alternate
		.setNextFocusableComponent(jText_Form_Sub2_AIN);
		jText_Form_Sub2_AIN
		.setNextFocusableComponent(jComboBox_Form_Sub2_isAddressChanged);
		jComboBox_Form_Sub2_isAddressChanged
		.setNextFocusableComponent(jText_Form_Sub2_GSTN);
		// ************************************************************************

		// Added by Akansha
		// For 3rd Panel
		jText_Form_Sub3_FlatNum.setNextFocusableComponent(jText_Form_Sub3_BuildingName);
		jText_Form_Sub3_Town.setNextFocusableComponent(jText_Form_Sub3_PinCode);
		jText_Form_Sub3_BuildingName.setNextFocusableComponent(jText_Form_Sub3_Road);
		jComboBox_State_Name.setNextFocusableComponent(jText_Form_Sub3_TelNum_Std_Code);
		jText_Form_Sub3_Road.setNextFocusableComponent(jText_Form_Sub3_Area);
		jText_Form_Sub3_Area.setNextFocusableComponent(jText_Form_Sub3_Town);

		jText_Form_Sub3_PinCode.setNextFocusableComponent(jComboBox_State_Name);
		jText_Form_Sub3_TelNum_Std_Code.setNextFocusableComponent(jText_Form_Sub3_TelNum);
		jText_Form_Sub3_TelNum.setNextFocusableComponent(jText_Form_Sub3_Email);
		jText_Form_Sub3_Email.setNextFocusableComponent(jText_Form_Sub3_TelNum_Alternate_Std_Code);
		jText_Form_Sub3_TelNum_Alternate_Std_Code.setNextFocusableComponent(jText_Form_Sub3_TelNum_Alternate);
		jText_Form_Sub3_TelNum_Alternate.setNextFocusableComponent(jText_Form_Sub3_Email_Alternate);
		jText_Form_Sub3_Email_Alternate.setNextFocusableComponent(jComboBox_Form_Sub3_isAddressChanged);
		jComboBox_Form_Sub3_isAddressChanged.setNextFocusableComponent(jText_Form_Sub3_MobileNumber);
		jText_Form_Sub3_MobileNumber.setNextFocusableComponent(jText_Form_Sub3_earlierReceiptNum);
		jText_Form_Sub3_earlierReceiptNum.setNextFocusableComponent(jComboBox_Form_Sub3_isRegularStatement);
		// *************************************************************************
		jText_AOPIN.setNextFocusableComponent(jText_STD);
		jText_STD.setNextFocusableComponent(jText_PhoneNo);
		jText_PhoneNo.setNextFocusableComponent(jText_EmailID);

		// Added by Akansha
		// For setting focus after financial year to quarter
		JComboBox_Form_Sub1_finYear
		.setNextFocusableComponent(jComboBox_Quarter);
		jComboBox_Quarter.setNextFocusableComponent(jText_Form_Sub1_Pan);
		// ******************************************************

		// jText_EmailID.setNextFocusableComponent(jText_regNoPaoDtoCddo);
		// jComboBox_Deductor_Category.setNextFocusableComponent(jComboBox_State_Name);
		// jComboBox_State_Name
		// .setNextFocusableComponent(jText_ResponsiblePersonName);
		// jComboBox_MinistryName.setNextFocusableComponent(jComboBox_SubMinistryName);
		jComboBox_SubMinistryName
		.setNextFocusableComponent(jText_ResponsiblePersonName);
		jText_OtherMinistryName
		.setNextFocusableComponent(jText_ResponsiblePersonName);
		/*
		 * jText_ResponsiblePersonName.setNextFocusableComponent(
		 * jText_ResponsiblePersonDesgn
		 * );jText_ResponsiblePersonDesgn.setNextFocusableComponent(
		 * jText_ResponsiblePersonADD1);
		 */
		jText_ResponsiblePersonADD1
		.setNextFocusableComponent(jText_ResponsiblePersonADD2);
		jText_ResponsiblePersonADD2
		.setNextFocusableComponent(jText_ResponsiblePersonADD3);
		jText_ResponsiblePersonADD3
		.setNextFocusableComponent(jText_ResponsiblePersonADD4);
		jText_ResponsiblePersonADD4
		.setNextFocusableComponent(jText_ResponsiblePersonCity);
		jText_ResponsiblePersonCity
		.setNextFocusableComponent(jComboBox_ResponsiblePersonState);
		jComboBox_ResponsiblePersonState
		.setNextFocusableComponent(jText_ResponsiblePersonPIN);
		jText_ResponsiblePersonPIN
		.setNextFocusableComponent(jText_ResponsiblePersonMobilePhoneNo);
		jText_ResponsiblePersonSTD
		.setNextFocusableComponent(jText_ResponsiblePersonPhoneNo);
		jText_ResponsiblePersonPhoneNo
		.setNextFocusableComponent(jText_ResponsiblePersonEmailID);
		jText_ResponsiblePersonMobilePhoneNo
		.setNextFocusableComponent(jText_ResponsiblePersonSTD);
		jText_ResponsiblePersonEmailID
		.setNextFocusableComponent(jButton_crtFile);
		jButton_crtFile.setNextFocusableComponent(jButton_sveFile);
		jButton_sveFile.setNextFocusableComponent(jButton_opnFile);
		jButton_opnFile.setNextFocusableComponent(jButton_addRow);
		// jButton_import.setNextFocusableComponent(jButton_addRow);
		jButton_addRow.setNextFocusableComponent(jButton_delRow);
		jButton_delRow.setNextFocusableComponent(jButton_back);
		if (jComboBox_TypOfStmt.isEditable()) {
			jButton_back.setNextFocusableComponent(jComboBox_TypOfStmt);
		} else if (jComboBox_TypeOfCorrection.isEnabled()) {
			jButton_back.setNextFocusableComponent(jComboBox_TypOfStmt);
		} else if (jText_OrigRRRNo.isEnabled()) {
			jButton_back.setNextFocusableComponent(jText_OrigRRRNo);
		} else if (jComboBox_TypOfStmt.getSelectedItem().toString()
				.equalsIgnoreCase("Regular")) {
			jButton_back.setNextFocusableComponent(jText_AIN);
		} else {
			jButton_back.setNextFocusableComponent(jText_AOName);

		}

	}

	public void colorBlackAOForm() {
		jLabel_Form_heading1.setForeground(Color.black.darker());
		jLabel_Form_quarterEnd.setForeground(Color.black.darker());
		jLabel_Form_formNumber.setForeground(Color.black.darker());
		jLabel_Form_Sub1_heading.setForeground(Color.black.darker());
		jLabel_Form_Sub1_finYear.setForeground(Color.black.darker());
		jLabel_Form_Sub1_Tan.setForeground(Color.black.darker());
		jLabel_Form_Sub1_LastTan.setForeground(Color.black.darker());
		jLabel_Form_Sub1_Pan.setForeground(Color.black.darker());
		jLabel_Form_Sub1_isRevised.setForeground(Color.black.darker());
		jLabel_Form_Sub1_Update_deductor.setForeground(Color.black.darker());
		jLabel_Form_Sub1_finYear.setForeground(Color.black.darker());
		jLabel_Form_Sub1_AssessmentYear.setForeground(Color.black.darker());
		jLabel_Form_Sub1_Type_of_Deductor.setForeground(Color.black.darker());
		jLabel_Form_Sub1_Last_Deductor_Type.setForeground(Color.black.darker());
		jLabel_Form_Sub1_Org_Receipt_Num.setForeground(Color.black.darker());
		jLabel_Form_Sub1_Previous_Receipt_num.setForeground(Color.black
				.darker());
		jLabel_Form_Sub1_Update_Instruction.setForeground(Color.black.darker());

		//newly developed for FRD1.5 Ver1.5 by akansha
		jButton_Form_Sub1_Know_Your_Tan.setForeground(Color.blue.brighter());

		jLabel_Form_Sub2_heading.setForeground(Color.black.darker());
		jCheckBox_Form_Sub2_Sameasabove.setForeground(Color.black.darker());
		jLabel_Form_Sub2_Name.setForeground(Color.black.darker());
		jLabel_Form_Sub2_Branch.setForeground(Color.black.darker());
		jLabel_Form_Sub2_State.setForeground(Color.black.darker());
		jLabel_Form_Sub2_PAO_Code.setForeground(Color.black.darker());
		jLabel_Form_Sub2_PAO_regNum.setForeground(Color.black.darker());
		jLabel_Form_Sub2_FlatNo.setForeground(Color.black.darker());
		jLabel_Form_Sub2_Area.setForeground(Color.black.darker());
		jLabel_Form_Sub2_Road.setForeground(Color.black.darker());
		jLabel_Form_Sub2_PinCode.setForeground(Color.black.darker());
		jLabel_Form_Sub2_TelNum.setForeground(Color.black.darker());
		jLabel_Form_Sub2_AlternateTelNum.setForeground(Color.black.darker());
		jLabel_Form_Sub2_AIN.setForeground(Color.black.darker());
		jLabel_Form_Sub2_GSTN.setForeground(Color.black.darker()); //For FRD2.1, added by Sadhana, set foreground color for newly label for GSTN
		jLabel_Form_Sub2_MinistryName.setForeground(Color.black.darker());
		jLabel_Form_Sub2_MinistryName_Other.setForeground(Color.black.darker());
		jLabel_Form_Sub2_DDO_Code.setForeground(Color.black.darker());
		jLabel_Form_Sub2_DDO_RegNum.setForeground(Color.black.darker());
		jLabel_Form_Sub2_TAN_RegNum.setForeground(Color.black.darker());
		jLabel_Form_Sub2_BuildingName.setForeground(Color.black.darker());
		jLabel_Form_Sub2_Town.setForeground(Color.black.darker());
		jLabel_Form_Sub2_StateTwo.setForeground(Color.black.darker());
		jLabel_Form_Sub2_Email.setForeground(Color.black.darker());
		jLabel_Form_Sub2_Email_Alternate.setForeground(Color.black.darker());
		jLabel_Form_Sub2_isAddressChanged.setForeground(Color.black.darker());

		jLabel_Form_Sub3_heading.setForeground(Color.black.darker());
		jLabel_Form_Sub3_Name.setForeground(Color.black.darker());
		jLabel_Form_Sub3_Designation.setForeground(Color.black.darker());
		jLabel_Form_Sub3_FlatNum.setForeground(Color.black.darker());
		jLabel_Form_Sub3_BuildingName.setForeground(Color.black.darker());
		jLabel_Form_Sub3_Road.setForeground(Color.black.darker());
		jLabel_Form_Sub3_TelNum.setForeground(Color.black.darker());
		jLabel_Form_Sub3_TelNum_Alternate.setForeground(Color.black.darker());
		jLabel_Form_Sub3_isAddressChange.setForeground(Color.black.darker());
		jLabel_Form_Sub3_earlierReceiptNum.setForeground(Color.black.darker());
		jLabel_Form_Sub3_Area.setForeground(Color.black.darker());
		jLabel_Form_Sub3_Town.setForeground(Color.black.darker());
		jLabel_Form_Sub3_State.setForeground(Color.black.darker());
		jLabel_Form_Sub3_PinCode.setForeground(Color.black.darker());
		jLabel_Form_Sub3_Email.setForeground(Color.black.darker());
		jLabel_Form_Sub3_Email_Alternate.setForeground(Color.black.darker());
		jLabel_Form_Sub3_MobileNumber.setForeground(Color.black.darker());
		jLabel_Form_Sub3_isRegularStatement.setForeground(Color.black.darker());

		jLabel_AODetails.setForeground(Color.black.darker());
		jLabel_RespDetails.setForeground(Color.black.darker());
		jLabel_Mandatory.setForeground(Color.black.darker());
		jLabel_AIN.setForeground(Color.black);
		jLabel_AOName.setForeground(Color.black);
		jLabel_AOADD1.setForeground(Color.black);
		jLabel_AOADD2.setForeground(Color.black);
		jLabel_AOADD3.setForeground(Color.black);
		jLabel_AOADD4.setForeground(Color.black);
		jLabel_AOCity.setForeground(Color.black);
		jLabel_AOState.setForeground(Color.black);
		jLabel_AOPIN.setForeground(Color.black);
		jLabel_PhoneNo.setForeground(Color.black);
		jLabel_STD.setForeground(Color.black);
		jLabel_EmailID.setForeground(Color.black);
		jLabel_ResponsiblePersonName.setForeground(Color.black);
		jLabel_ResponsiblePersonDesgn.setForeground(Color.black);
		jLabel_FinYear.setForeground(Color.black);
		jLabel_Deductor_Category.setForeground(Color.black);
		jLabel_State_Name.setForeground(Color.black);
		jLabel_Month.setForeground(Color.black);
		jLabel_CntofDDOTransnDtls.setForeground(Color.black);
		jLabel_OrigRRRNo.setForeground(Color.black);
		jLabel_PrevRRRNo.setForeground(Color.black);
		jLabel_TypOfStmt.setForeground(Color.black);
	}

	public void currentAOData() {
		aoData = new String[100];
		aoData[67] = jText_AIN.getText();
		aoData[18] = jText_AOName.getText();
		aoData[20] = jText_AOADD1.getText();
		aoData[21] = jText_AOADD2.getText();
		aoData[22] = jText_AOADD3.getText();
		aoData[23] = jText_AOADD4.getText();
		aoData[24] = jText_AOCity.getText(); // guessed
		aoData[25] = jComboBox_AOState.getSelectedItem().toString();
		aoData[26] = jText_AOPIN.getText();
		aoData[28] = jText_STD.getText();
		aoData[29] = jText_PhoneNo.getText();
		aoData[27] = jText_EmailID.getText();
		aoData[32] = jText_ResponsiblePersonName.getText();
		aoData[33] = jText_ResponsiblePersonDesgn.getText();
		aoData[16] = jComboBox_FinYear1.getSelectedItem().toString();
		aoData[31] = jComboBox_Deductor_Category.getSelectedItem().toString();
		aoData[67] = jText_regNoPaoDtoCddo.getText();
		aoData[53] = jComboBox_State_Name.getSelectedItem().toString();
		aoData[56] = jComboBox_MinistryName.getSelectedItem().toString();
		aoData[58] = jText_OtherMinistryName.getText();
		aoData[34] = jText_ResponsiblePersonADD1.getText();
		aoData[35] = jText_ResponsiblePersonADD2.getText();
		aoData[36] = jText_ResponsiblePersonADD3.getText();
		aoData[37] = jText_ResponsiblePersonADD4.getText();
		aoData[38] = jText_ResponsiblePersonCity.getText();
		aoData[39] = jComboBox_ResponsiblePersonState.getSelectedItem().toString();
		aoData[40] = jText_ResponsiblePersonPIN.getText();
		aoData[43] = jText_ResponsiblePersonSTD.getText();
		aoData[44] = jText_ResponsiblePersonPhoneNo.getText();
		aoData[42] = jText_ResponsiblePersonMobilePhoneNo.getText();
		aoData[41] = jText_ResponsiblePersonEmailID.getText();
	}

	public boolean checkAODetails() {
		aoModifiedData = new String[33];
		aoModifiedData[0] = jText_AIN.getText();
		aoModifiedData[1] = jText_AOName.getText();
		aoModifiedData[2] = jText_AOADD1.getText();
		aoModifiedData[3] = jText_AOADD2.getText();
		aoModifiedData[4] = jText_AOADD3.getText();
		aoModifiedData[5] = jText_AOADD4.getText();
		aoModifiedData[6] = jText_AOCity.getText();
		aoModifiedData[7] = jComboBox_AOState.getSelectedItem().toString();
		aoModifiedData[8] = jText_AOPIN.getText();
		aoModifiedData[9] = jText_STD.getText();
		aoModifiedData[10] = jText_PhoneNo.getText();
		aoModifiedData[11] = jText_EmailID.getText();
		aoModifiedData[12] = jText_ResponsiblePersonName.getText();
		aoModifiedData[13] = jText_ResponsiblePersonDesgn.getText();
		aoModifiedData[14] = jComboBox_FinYear1.getSelectedItem().toString();
		aoModifiedData[15] = jComboBox_Deductor_Category.getSelectedItem()
				.toString();
		aoModifiedData[16] = jComboBox_Month.getSelectedItem().toString();
		aoModifiedData[17] = jText_regNoPaoDtoCddo.getText();
		aoModifiedData[18] = jComboBox_State_Name.getSelectedItem().toString();
		aoModifiedData[19] = jComboBox_MinistryName.getSelectedItem()
				.toString();
		aoModifiedData[20] = jComboBox_SubMinistryName.getSelectedItem()
				.toString();
		aoModifiedData[21] = jText_OtherMinistryName.getText();
		aoModifiedData[22] = jText_ResponsiblePersonADD1.getText();
		aoModifiedData[23] = jText_ResponsiblePersonADD2.getText();
		aoModifiedData[24] = jText_ResponsiblePersonADD3.getText();
		aoModifiedData[25] = jText_ResponsiblePersonADD4.getText();
		aoModifiedData[26] = jText_ResponsiblePersonCity.getText();
		aoModifiedData[27] = jComboBox_ResponsiblePersonState.getSelectedItem()
				.toString();
		aoModifiedData[28] = jText_ResponsiblePersonPIN.getText();
		aoModifiedData[29] = jText_ResponsiblePersonSTD.getText();
		aoModifiedData[30] = jText_ResponsiblePersonPhoneNo.getText();
		aoModifiedData[31] = jText_ResponsiblePersonMobilePhoneNo.getText();
		aoModifiedData[32] = jText_ResponsiblePersonEmailID.getText();

		boolean notModified = false;
		for (int i = 0; i < aoModifiedData.length; i++) {

			if (aoModifiedData[i].equals(aoData[i])) {
				notModified = true;
				continue;
			}
			notModified = false;
			break;
		}

		return notModified;
	}

	public void setLabelcolor() {
		colorBlackAOForm();
	}

	public Dimension gettingPreferredSize() {
		Dimension size = super.getPreferredSize();
		size.width = size.width + 100;
		return size;
	}

	public boolean validateDDORegNo(Object tabval, int dedTyp, int tabrow,
			int tabcol) {

		if (tabval == null || tabval.toString().length() != 10) {
			pointToCell("DDO Registration number must of length 10", tabrow,
					tabcol);
			grpu.setErrorAt(tabrow, tabcol);
			return false;
		}

		tabval = tabval.toString().toUpperCase();

		String first3 = tabval.toString().substring(0, 3);

		if (dedTyp == 1) {
			if (!(first3.equalsIgnoreCase("cgv"))) {
				pointToCell("Invalid DDO Registration number", tabrow, tabcol);
				grpu.setErrorAt(tabrow, tabcol);
				return false;
			}
		} else if (dedTyp == 2) {
			if (!(first3.equalsIgnoreCase("sgv"))) {
				pointToCell("Invalid DDO Registration number", tabrow, tabcol);
				grpu.setErrorAt(tabrow, tabcol);
				return false;
			}
		}

		String fourthChar = tabval.toString().substring(3, 4);
		if (!((fourthChar.charAt(0) >= '0' && fourthChar.charAt(0) <= '9') || (fourthChar
				.charAt(0) >= 'A' && fourthChar.charAt(0) <= 'Z'))) {
			pointToCell("Invalid DDO Registration number", tabrow, tabcol);
			grpu.setErrorAt(tabrow, tabcol);
			return false;
		}

		String numeric = tabval.toString().substring(4, 9);
		int intNum = 0;
		try {
			intNum = Integer.parseInt(numeric);
		} catch (Exception e) {
			e.printStackTrace();
			// System.out.println(e);
			pointToCell("Invalid DDO Registration number", tabrow, tabcol);
			grpu.setErrorAt(tabrow, tabcol);
			return false;
		}

		// last alpha check

		int mod = intNum % 7;

		if (!(tabval.toString().charAt(9) == (char) (65 + mod))) {
			pointToCell("Invalid DDO Registration number", tabrow, tabcol);
			grpu.setErrorAt(tabrow, tabcol);
			return false;
		}

		grpu.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validateDDOCode(Object tabval, String typ, int tabrow,
			int tabcol) {

		if (tabval.toString().length() <= 0 || tabval.toString().length() > 20) {
			pointToCell("Valid DDO Code must be provided", tabrow, tabcol);
			grpu.setErrorAt(tabrow, tabcol);
			return false;
		}

		int nonZeroCount = 0;
		for (int i = 0; i < tabval.toString().length(); i++) {
			if (!(tabval.toString().charAt(i) >= '0' && tabval.toString()
					.charAt(i) <= '9')
					&& !(tabval.toString().charAt(i) >= 'a' && tabval
					.toString().charAt(i) <= 'z')
					&& !(tabval.toString().charAt(i) >= 'A' && tabval
					.toString().charAt(i) <= 'Z')) {
				pointToCell("Valid DDO Code must be provided", tabrow, tabcol);
				grpu.setErrorAt(tabrow, tabcol);
				return false;
			} else if (tabval.toString().charAt(i) != '0') {
				nonZeroCount++;
			}
		}

		if (nonZeroCount == 0) {
			pointToCell("Valid DDO Code must be provided", tabrow, tabcol);
			grpu.setErrorAt(tabrow, tabcol);
			return false;
		}

		grpu.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validateNatureOfDeduction(Object tabval, String typ,
			int tabrow, int tabcol) {

		if (tabval.toString().equalsIgnoreCase("--Select--")) {
			pointToCell(
					"Please select Nature of Deduction from the Drop down list at ",
					tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}

		boolean exists = false;
		;
		for (int i = 0; i < jComboBox_NtrOfDedtn.length; i++) {
			if (tabval.toString().equalsIgnoreCase(jComboBox_NtrOfDedtn[i]))
				exists = true;
		}

		if (!exists) {
			pointToCell("Invalid Nature of Deduction", tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			model.setValueAt("--Select--", tabrow, tabcol);
			return false;
		}

		this.setNoErrorAt(tabrow, tabcol);
		return true;
	}

	public boolean validateEmail(Object tabval, String typ, int tabrow,
			int tabcol) {

		if (tabval == null || tabval.toString().equals("")) {
			// optional field
			this.setNoErrorAt(tabrow, tabcol);
			return true;
		}

		String data = tabval.toString();
		String field = data.trim();

		if (!GrpuUtil.isValidCharString(data)) {
			pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}

		if (field.trim().equals("") || field.trim().length() == 0) {
			pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}
		for (int j = 0; j < field.length(); j++)
			if (field.charAt(j) == ' ') {
				pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
				this.setErrorAt(tabrow, tabcol);
				return false;
			}

		if (field.charAt(0) == '@' || field.charAt(0) == '.') {
			pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}

		if (field.charAt(field.length() - 1) == '@'
				|| field.charAt(field.length() - 1) == '.') {
			pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}
		int localCount = 0;
		int dotPos = 0;
		int ratePos = 0;
		for (int j = 0; j < field.length(); j++)
			if (field.charAt(j) == '@') {
				ratePos = j;
				if (field.charAt(j + 1) == '.') {
					pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
					this.setErrorAt(tabrow, tabcol);
					return false;
				}
				if (++localCount > 1) {
					pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
					this.setErrorAt(tabrow, tabcol);
					return false;
				}
			}

		if (localCount == 0) {
			pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
			this.setErrorAt(tabrow, tabcol);
			return false;
		}
		for (int x = 0; x < field.length(); x++)
			if (field.charAt(x) == '.') {
				dotPos = x;
				if (x + 1 != field.length() && field.charAt(x + 1) == '.') {
					pointToCell("Invalid E-mail ID  ", tabrow, tabcol);
					this.setErrorAt(tabrow, tabcol);
					return false;
				}
			}
		this.setNoErrorAt(tabrow, tabcol);
		return dotPos >= ratePos;

	}

	private String countDistinctDDO(int[] filledrowNo) {

		HashSet ddoTan = new HashSet();
		for (int i = 0; i < model.getRowCount(); i++) {
			if (!(filledrowNo[i] < 0)) {
				Object crTan = model.getValueAt(i, 4);
				if (crTan == null)
					continue;
				String currTan = crTan.toString();
				if (!(currTan.equals("TANINVALID")
						|| currTan.equals("TANNOTAVBL") || currTan
						.equals("TANAPPLIED")))
					ddoTan.add(currTan);
			}
		}

		return ddoTan.size() + "";
	}

	private String countDistinctDDONew(int[] filledrowNo) {

		HashSet ddoTan = new HashSet();
		for (int i = 0; i < model.getRowCount(); i++) {
			if (!(filledrowNo[i] < 0)) {
				Object crTan = model.getValueAt(i, 4);
				String revMode = (String) model.getValueAt(i, 2);
				// Added if condition to get the tax of only newly added rows
				if (revMode.equalsIgnoreCase("Add")
						|| revMode.equalsIgnoreCase("Delete")
						|| revMode.equalsIgnoreCase("Update")) {
					if (crTan == null)
						continue;
					String currTan = crTan.toString();
					if (!(currTan.equals("TANINVALID")
							|| currTan.equals("TANNOTAVBL") || currTan
							.equals("TANAPPLIED")))
						ddoTan.add(currTan);
				}
			}
		}

		return ddoTan.size() + "";
	}

	private void taxCalculationInUpdation(String formType, double previoustax,
			String taxType) {
		NumberFormat formatter = new DecimalFormat("#0.00");
		double previousAmountOfField = 0;
		System.out.println("**********" + formType + "FORM TYPE *********"
				+ "Tax Type" + taxType);

		if (formType != null) {

			if (formType.equalsIgnoreCase("24Q")) {
				if (taxType.equalsIgnoreCase("Control")) {

					previousAmountOfField = Double
							.parseDouble(jText_controlTax24q.getText());
					jText_controlTax24q.setText(formatter
							.format(previousAmountOfField - previoustax) + "");

				} else {
					previousAmountOfField = Double
							.parseDouble(jText_totalTDS24q.getText());
					jText_totalTDS24q.setText(formatter
							.format(previousAmountOfField - previoustax) + "");

				}

			}
			if (formType.equalsIgnoreCase("26Q")) {
				if (taxType.equalsIgnoreCase("Control")) {
					previousAmountOfField = Double
							.parseDouble(jText_controlTax26q.getText());
					jText_controlTax26q.setText(formatter
							.format(previousAmountOfField - previoustax) + "");
				} else {
					previousAmountOfField = Double
							.parseDouble(jText_totalTDS26q.getText());
					jText_totalTDS26q.setText(formatter
							.format(previousAmountOfField - previoustax) + "");

				}

			}
			if (formType.equalsIgnoreCase("27Q")) {
				if (taxType.equalsIgnoreCase("Control")) {
					previousAmountOfField = Double
							.parseDouble(jText_controlTax27q.getText());
					jText_controlTax27q.setText(formatter
							.format(previousAmountOfField - previoustax) + "");
				} else {
					previousAmountOfField = Double
							.parseDouble(jText_totalTDS27q.getText());
					jText_totalTDS27q.setText(formatter
							.format(previousAmountOfField - previoustax) + "");

				}

			}
			if (formType.equalsIgnoreCase("27EQ")) {
				if (taxType.equalsIgnoreCase("Control")) {
					previousAmountOfField = Double
							.parseDouble(jText_controlTax27Eq.getText());
					jText_controlTax27Eq.setText(formatter
							.format(previousAmountOfField - previoustax) + "");
				} else {
					previousAmountOfField = Double
							.parseDouble(jText_totalTDS27Eq.getText());
					jText_totalTDS27Eq.setText(formatter
							.format(previousAmountOfField - previoustax) + "");

				}

			}
		}

	}

	private void calculateStats(int[] filledrowNo) {

		NumberFormat formatter = new DecimalFormat("#0.00");
		numberOfTd = 0;
		try {

			for (int i = 0; i < model.getRowCount(); i++) {
				if (!(filledrowNo[i] < 0)) {

					// System.out.println("Row "+i);
					String revModeText = "";
					revModeText = (String) jTableTransacDetails
							.getValueAt(i, 2);

					if (revModeText == null) {
						revModeText = "";
					}

					// To skip the TD Which is not modified
					if (valueOfTypeOfStmt.equals("Correction")) {
						if (revModeText.equalsIgnoreCase("--Select--")
								|| revModeText.equalsIgnoreCase("")) {
							continue;
						}
					}
					numberOfTd++;
					String natureDed = jTableTransacDetails.getValueAt(i, 23)
							.toString();
					String DDOmapping = jTableTransacDetails.getValueAt(i, 24)
							.toString();

					// Deleted rows should not be taken into count
					if (!revModeText.equalsIgnoreCase("Delete")) {
						if (DDOmapping.equals(ddoMappingModes[1])) {
							int countddo = Integer.parseInt(jText_countOfDDOAdd
									.getText());
							jText_countOfDDOAdd.setText((countddo + 1) + "");
						} else if (DDOmapping.equals(ddoMappingModes[2])) {
							int countddo = Integer.parseInt(jText_countOfDDOUpd
									.getText());
							jText_countOfDDOUpd.setText((countddo + 1) + "");
						} else if (DDOmapping.equals(ddoMappingModes[3])) {
							int countddo = Integer.parseInt(jText_countOfDDODel
									.getText());
							jText_countOfDDODel.setText((countddo + 1) + "");
						}
					}

					if (natureDed.equals(jComboBox_NtrOfDedtn[1])) // 24q
					{
						jText_count24QTrans.setText((Integer
								.parseInt(jText_count24QTrans.getText()) + 1)
								+ "");
						double previousAmount = 0;
						double previousControlTax = 0;
						String previousFormType = null;
						if (i < numDdoRowsCorr) {

							Object[] tranObject = (Object[]) saveDDOVector
									.get(i);

							if (tranObject[15] != null
									&& !tranObject[15].toString().equals("")) {
								previousControlTax = Double
										.parseDouble(tranObject[15].toString());
							}
							if (tranObject[20] != null
									&& !tranObject[20].toString().equals("")) {
								previousAmount = Double
										.parseDouble(tranObject[20].toString());

							}
							if (tranObject[21] != null
									&& !tranObject[21].toString().equals("")) {
								previousFormType = tranObject[21].toString();

							}

						}
						Object strObject = jTableTransacDetails.getValueAt(i,
								19);
						String strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double amt = 0;
						if (strAmt != null && !strAmt.equals("")) {
							double controlAmt = 0;

							if (revModeText.equalsIgnoreCase("Update")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax24q
										.getText());
								jText_controlTax24q.setText(formatter
										.format(controlAmt + amt) + "");

								taxCalculationInUpdation(previousFormType,
										previousControlTax, "Control");

							} else if (!revModeText.equalsIgnoreCase("Delete")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax24q
										.getText());
								jText_controlTax24q.setText(formatter
										.format(controlAmt + amt) + "");
							}

						}

						// strAmt =jTableTransacDetails.getValueAt(i,
						// 21).toString();

						strObject = jTableTransacDetails.getValueAt(i, 21);
						strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double remAmt = 0;

						// Getting Previous value from saveDDO Vector

						if (strAmt != null && !strAmt.equals("")) {
							remAmt = Double.parseDouble(strAmt);

							amt = Double.parseDouble(jText_totalTDS24q
									.getText());
							if (revModeText.equalsIgnoreCase("Delete")) {
								jText_totalTDS24q.setText(formatter.format(amt
										- remAmt)
										+ "");
							} else if (revModeText.equalsIgnoreCase("Update")) {
								jText_totalTDS24q.setText(formatter
										.format(remAmt + amt) + "");

								taxCalculationInUpdation(previousFormType,
										previousAmount, "Total");
							} else {
								jText_totalTDS24q.setText(formatter
										.format(remAmt + amt) + "");
							}
						}
						amt = Double.parseDouble(jText_totalTDS.getText());
						System.out.println(remAmt + "Remitted Amount");
						if (revModeText.equalsIgnoreCase("Delete")) {

							jText_totalTDS.setText(formatter.format(amt
									- remAmt)
									+ "");
						} else if (revModeText.equalsIgnoreCase("Update")) {

							System.out.println(previousAmount + "*************"
									+ remAmt + amt);
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt - previousAmount)
									+ "");

						} else {
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt)
									+ "");
						}

					} else if (natureDed.equals(jComboBox_NtrOfDedtn[2]))// 26q
					{
						jText_count26QTrans.setText((Integer
								.parseInt(jText_count26QTrans.getText()) + 1)
								+ "");
						double previousAmount = 0;
						double previousControlTax = 0;
						String previousFormType = null;
						if (i < numDdoRowsCorr) {

							Object[] tranObject = (Object[]) saveDDOVector
									.get(i);
							if (tranObject[15] != null
									&& !tranObject[15].toString().equals("")) {
								previousControlTax = Double
										.parseDouble(tranObject[15].toString());
							}
							if (tranObject[20] != null
									&& !tranObject[20].toString().equals("")) {
								previousAmount = Double
										.parseDouble(tranObject[20].toString());

							}
							if (tranObject[21] != null
									&& !tranObject[21].toString().equals("")) {
								previousFormType = tranObject[21].toString();

							}
						}
						Object strObject = jTableTransacDetails.getValueAt(i,
								19);
						String strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double amt = 0;
						if (strAmt != null && !strAmt.equals("")) {
							double controlAmt = 0;
							if (revModeText.equalsIgnoreCase("Update")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax26q
										.getText());
								jText_controlTax26q.setText(formatter
										.format(controlAmt + amt) + "");
								taxCalculationInUpdation(previousFormType,
										previousControlTax, "Control");
							} else if (!revModeText.equalsIgnoreCase("Delete")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax26q
										.getText());
								jText_controlTax26q.setText(formatter
										.format(controlAmt + amt) + "");
							}

						}

						// strAmt =jTableTransacDetails.getValueAt(i,
						// 21).toString();

						strObject = jTableTransacDetails.getValueAt(i, 21);
						strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double remAmt = 0;

						// Getting Previous value from saveDDO Vector

						if (strAmt != null && !strAmt.equals("")) {
							remAmt = Double.parseDouble(strAmt);
							amt = Double.parseDouble(jText_totalTDS26q
									.getText());
							if (revModeText.equalsIgnoreCase("Delete")) {
								jText_totalTDS26q.setText(formatter.format(amt
										- remAmt)
										+ "");
							} else if (revModeText.equalsIgnoreCase("Update")) {
								jText_totalTDS26q.setText(formatter
										.format(remAmt + amt) + "");

								taxCalculationInUpdation(previousFormType,
										previousAmount, "Total");
							} else {
								jText_totalTDS26q.setText(formatter
										.format(remAmt + amt) + "");
							}

						}

						amt = Double.parseDouble(jText_totalTDS.getText());
						if (revModeText.equalsIgnoreCase("Delete")) {
							jText_totalTDS.setText(formatter.format(amt
									- remAmt)
									+ "");
						} else if (revModeText.equalsIgnoreCase("Update")) {
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt - previousAmount)
									+ "");

						} else {
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt)
									+ "");
						}

					} else if (natureDed.equals(jComboBox_NtrOfDedtn[3]))// 27q
					{

						jText_count27QTrans.setText((Integer
								.parseInt(jText_count27QTrans.getText()) + 1)
								+ "");

						double previousAmount = 0;
						double previousControlTax = 0;
						String previousFormType = null;
						if (i < numDdoRowsCorr) {

							Object[] tranObject = (Object[]) saveDDOVector
									.get(i);
							if (tranObject[15] != null
									&& !tranObject[15].toString().equals("")) {
								previousControlTax = Double
										.parseDouble(tranObject[15].toString());
							}
							if (tranObject[20] != null
									&& !tranObject[20].toString().equals("")) {
								previousAmount = Double
										.parseDouble(tranObject[20].toString());

							}
							if (tranObject[21] != null
									&& !tranObject[21].toString().equals("")) {
								previousFormType = tranObject[21].toString();

							}
						}
						Object strObject = jTableTransacDetails.getValueAt(i,
								19);
						String strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double amt = 0;
						if (strAmt != null && !strAmt.equals("")) {
							double controlAmt = 0;
							if (revModeText.equalsIgnoreCase("Update")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax27q
										.getText());
								jText_controlTax27q.setText(formatter
										.format(controlAmt + amt) + "");
								taxCalculationInUpdation(previousFormType,
										previousControlTax, "Control");
							} else if (!revModeText.equalsIgnoreCase("Delete")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax27q
										.getText());
								jText_controlTax27q.setText(formatter
										.format(controlAmt + amt) + "");
							}

						}

						// strAmt =jTableTransacDetails.getValueAt(i,
						// 21).toString();

						strObject = jTableTransacDetails.getValueAt(i, 21);
						strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double remAmt = 0;

						// Getting Previous value from saveDDO Vector

						if (strAmt != null && !strAmt.equals("")) {
							remAmt = Double.parseDouble(strAmt);
							amt = Double.parseDouble(jText_totalTDS27q
									.getText());
							if (revModeText.equalsIgnoreCase("Delete")) {
								jText_totalTDS27q.setText(formatter.format(amt
										- remAmt)
										+ "");
							} else if (revModeText.equalsIgnoreCase("Update")) {
								jText_totalTDS27q.setText(formatter
										.format(remAmt + amt) + "");
								taxCalculationInUpdation(previousFormType,
										previousAmount, "Total");
							} else {
								jText_totalTDS27q.setText(formatter
										.format(remAmt + amt) + "");
							}

						}

						amt = Double.parseDouble(jText_totalTDS.getText());
						if (revModeText.equalsIgnoreCase("Delete")) {
							jText_totalTDS.setText(formatter.format(amt
									- remAmt)
									+ "");
						} else if (revModeText.equalsIgnoreCase("Update")) {
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt - previousAmount)
									+ "");

						} else {
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt)
									+ "");
						}

					} else if (natureDed.equals(jComboBox_NtrOfDedtn[4]))// 27eq
					{
						jText_count27EQTrans.setText((Integer
								.parseInt(jText_count27EQTrans.getText()) + 1)
								+ "");
						double previousAmount = 0;
						double previousControlTax = 0;
						String previousFormType = null;
						if (i < numDdoRowsCorr) {

							Object[] tranObject = (Object[]) saveDDOVector
									.get(i);
							if (tranObject[15] != null
									&& !tranObject[15].toString().equals("")) {
								previousControlTax = Double
										.parseDouble(tranObject[15].toString());
							}
							if (tranObject[20] != null
									&& !tranObject[20].toString().equals("")) {
								previousAmount = Double
										.parseDouble(tranObject[20].toString());

							}
							if (tranObject[21] != null
									&& !tranObject[21].toString().equals("")) {
								previousFormType = tranObject[21].toString();

							}
						}
						Object strObject = jTableTransacDetails.getValueAt(i,
								19);
						String strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double amt = 0;
						if (strAmt != null && !strAmt.equals("")) {
							double controlAmt = 0;
							if (revModeText.equalsIgnoreCase("Update")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax27Eq
										.getText());
								jText_controlTax27Eq.setText(formatter
										.format(controlAmt + amt) + "");
								taxCalculationInUpdation(previousFormType,
										previousControlTax, "Control");
							} else if (!revModeText.equalsIgnoreCase("Delete")) {
								controlAmt = Double.parseDouble(strAmt);
								amt = Double.parseDouble(jText_controlTax27Eq
										.getText());
								jText_controlTax27Eq.setText(formatter
										.format(controlAmt + amt) + "");
							}

						}

						// strAmt =jTableTransacDetails.getValueAt(i,
						// 21).toString();

						strObject = jTableTransacDetails.getValueAt(i, 21);
						strAmt = "";
						if (strObject != null) {
							strAmt = strObject.toString();
						}
						double remAmt = 0;
						// Getting Previous value from saveDDO Vector

						if (strAmt != null && !strAmt.equals("")) {
							remAmt = Double.parseDouble(strAmt);
							amt = Double.parseDouble(jText_totalTDS27Eq
									.getText());
							if (revModeText.equalsIgnoreCase("Delete")) {
								jText_totalTDS27Eq.setText(formatter.format(amt
										- remAmt)
										+ "");
							} else if (revModeText.equalsIgnoreCase("Update")) {
								jText_totalTDS27Eq.setText(formatter
										.format(remAmt + amt) + "");
								taxCalculationInUpdation(previousFormType,
										previousAmount, "Total");

							} else {
								jText_totalTDS27Eq.setText(formatter
										.format(remAmt + amt) + "");
							}

						}

						amt = Double.parseDouble(jText_totalTDS.getText());
						if (revModeText.equalsIgnoreCase("Delete")) {
							jText_totalTDS.setText(formatter.format(amt
									- remAmt)
									+ "");
						} else if (revModeText.equalsIgnoreCase("Update")) {
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt - previousAmount)
									+ "");

						} else {
							jText_totalTDS.setText(formatter.format(remAmt
									+ amt)
									+ "");
						}
					}

				}

			}
			jText_CntofDDOTransnDtls.setText(Integer.toString(numberOfTd));
		} catch (Exception e) {

			getMessage("error stats");
			e.printStackTrace();
			jText_countOfDDOAdd.setText("0");
			jText_countOfDDOUpd.setText("0");
			jText_countOfDDODel.setText("0");

			jText_count24QTrans.setText("0");
			jText_totalTDS24q.setText("0.00");
			jText_controlTax24q.setText("0.00");

			jText_count26QTrans.setText("0");
			jText_totalTDS26q.setText("0.00");
			jText_controlTax26q.setText("0.00");

			jText_count27QTrans.setText("0");
			jText_totalTDS27q.setText("0.00");
			jText_controlTax27q.setText("0.00");

			jText_count27EQTrans.setText("0");
			jText_totalTDS27Eq.setText("0.00");
			jText_controlTax27Eq.setText("0.00");

			jText_totalTDS.setText("0.00");

		}

		jText_countOfDDOAdd.setEditable(false);
		jText_countOfDDOUpd.setEditable(false);
		jText_countOfDDODel.setEditable(false);

		jText_count24QTrans.setEditable(false);
		jText_totalTDS24q.setEditable(false);
		jText_controlTax24q.setEditable(false);

		jText_count26QTrans.setEditable(false);
		jText_totalTDS26q.setEditable(false);
		jText_controlTax26q.setEditable(false);

		jText_count27QTrans.setEditable(false);
		jText_totalTDS27q.setEditable(false);
		jText_controlTax27q.setEditable(false);

		jText_count27EQTrans.setEditable(false);
		jText_totalTDS27Eq.setEditable(false);
		jText_controlTax27Eq.setEditable(false);

		jText_totalTDS.setEditable(false);

	}

	public boolean checkMaxNoOfEntriesForEachTan() {

		class TanReturnCount {
			String tan = "";
			int count24q = 0;
			int count26q = 0;
			int count27q = 0;
			int count27eq = 0;

			boolean isValid() {
				if (count24q > 1)
					return false;
				if (count26q > 1)
					return false;
				if (count27q > 1)
					return false;
				if (count27eq > 1)
					return false;
				return true;
			}

		}

		class DDOCodeCount {
			String ddoCode = "";
			int count24q = 0;
			int count26q = 0;
			int count27q = 0;
			int count27eq = 0;

			boolean isValid() {
				if (count24q > 1)
					return false;
				if (count26q > 1)
					return false;
				if (count27q > 1)
					return false;
				if (count27eq > 1)
					return false;
				return true;
			}
		}

		class DDORegCount {
			String ddoReg = "";
			int count24q = 0;
			int count26q = 0;
			int count27q = 0;
			int count27eq = 0;

			boolean isValid() {
				if (count24q > 1)
					return false;
				if (count26q > 1)
					return false;
				if (count27q > 1)
					return false;
				if (count27eq > 1)
					return false;
				return true;
			}
		}

		HashMap tans = new HashMap();
		HashMap ddoCodes = new HashMap();
		HashMap ddoRegs = new HashMap();

		int rowsFilled[] = GrpuUtil.getFilledRows(model);

		for (int i = 0; i < rowsFilled.length; i++) {
			if (rowsFilled[i] < 0)
				continue;

			if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
				String revModeText = "";
				revModeText = (String) jTableTransacDetails.getValueAt(i, 2);

				// Added by manish
				if (revModeText.equalsIgnoreCase("Delete")
						|| revModeText.equalsIgnoreCase("--Select--")) {
					continue;

				}
			}

			String currTan = "";
			String currDDOCode = "";
			String currDDOReg = "";
			String natureOfDed = "";

			if (jTableTransacDetails.getValueAt(i, 4) != null)
				currTan = jTableTransacDetails.getValueAt(i, 4).toString()
				.trim();

			if (jTableTransacDetails.getValueAt(i, 9) != null)
				currDDOCode = jTableTransacDetails.getValueAt(i, 9).toString()
				.trim();

			if (jTableTransacDetails.getValueAt(i, 7) != null)
				currDDOReg = jTableTransacDetails.getValueAt(i, 7).toString()
				.trim();

			natureOfDed = jTableTransacDetails.getValueAt(i, 23).toString()
					.trim();

			// System.out.println(currTan + " -- "+currDDOCode+" -- "+currDDOReg
			// +" -- "+natureOfDed);

			TanReturnCount currTanObj = null;
			DDOCodeCount currDDOCodeObj = null;
			DDORegCount currDDORegObj = null;

			if (!(currTan.equals("TANINVALID") || currTan.equals("TANNOTAVBL") || currTan
					.equals("TANAPPLIED"))) {

				if (tans.containsKey(currTan)) {
					currTanObj = (TanReturnCount) tans.get(currTan);
				} else {
					currTanObj = new TanReturnCount();
					currTanObj.tan = currTan;
					tans.put(currTan, currTanObj);
				}

			}

			if (!(currDDOCode == null || currDDOCode.equals(""))) {
				if (ddoCodes.containsKey(currDDOCode)) {
					currDDOCodeObj = (DDOCodeCount) ddoCodes.get(currDDOCode);
				} else {
					currDDOCodeObj = new DDOCodeCount();
					currDDOCodeObj.ddoCode = currDDOCode;
					ddoCodes.put(currDDOCode, currDDOCodeObj);
				}
			} else {
				currDDOCodeObj = null;
			}

			if (!(currDDOReg == null || currDDOReg.equals(""))) {
				if (ddoRegs.containsKey(currDDOReg)) {
					currDDORegObj = (DDORegCount) ddoRegs.get(currDDOReg);
				} else {
					currDDORegObj = new DDORegCount();
					currDDORegObj.ddoReg = currDDOReg;
					ddoRegs.put(currDDOReg, currDDORegObj);
				}
			} else {
				currDDORegObj = null;
			}

			if (natureOfDed.equals(jComboBox_NtrOfDedtn[1])) {

				if (currTanObj != null)
					currTanObj.count24q++;
				if (currDDOCodeObj != null)
					currDDOCodeObj.count24q++;
				if (currDDORegObj != null)
					currDDORegObj.count24q++;
			} else if (natureOfDed.equals(jComboBox_NtrOfDedtn[2])) {
				if (currTanObj != null)
					currTanObj.count26q++;
				if (currDDOCodeObj != null)
					currDDOCodeObj.count26q++;
				if (currDDORegObj != null)
					currDDORegObj.count26q++;
			} else if (natureOfDed.equals(jComboBox_NtrOfDedtn[3])) {
				if (currTanObj != null)
					currTanObj.count27q++;
				if (currDDOCodeObj != null)
					currDDOCodeObj.count27q++;
				if (currDDORegObj != null)
					currDDORegObj.count27q++;
			} else if (natureOfDed.equals(jComboBox_NtrOfDedtn[4])) {
				if (currTanObj != null)
					currTanObj.count27eq++;
				if (currDDOCodeObj != null)
					currDDOCodeObj.count27eq++;
				if (currDDORegObj != null)
					currDDORegObj.count27eq++;
			}

			if (currTanObj != null && !currTanObj.isValid()) {
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("TAN "
						+ currTanObj.tan
						+ " cannot have more than 1 entry for same nature of deduction.");
				return false;
			}

			if (currDDOCodeObj != null && !currDDOCodeObj.isValid()) {
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("DDO Code "
						+ currDDOCodeObj.ddoCode
						+ " cannot have more than 1 entry for same nature of deduction.");
				return false;
			}

			if (currDDORegObj != null && !currDDORegObj.isValid()) {
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("DDO Registartion "
						+ currDDORegObj.ddoReg
						+ " cannot have more than 1 entry for same nature of deduction.");
				return false;
			}

		}

		// post check for tan ,ddo code and regno

		Collection col = tans.values();
		Iterator iter = col.iterator();
		while (iter.hasNext()) {
			TanReturnCount tanC = (TanReturnCount) iter.next();
			if (tanC != null && !tanC.isValid()) {
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("TAN " + tanC.tan
						+ " cannot have more than 1 entry of same return type");
				return false;
			}
		}

		col = ddoCodes.values();
		iter = col.iterator();

		while (iter.hasNext()) {
			DDOCodeCount ddoCnt = (DDOCodeCount) iter.next();
			if (ddoCnt != null && !ddoCnt.isValid()) {
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("DDO Code " + ddoCnt.ddoCode
						+ " cannot have more than 1 entry of same return type");
				return false;
			}
		}

		col = ddoRegs.values();
		iter = col.iterator();
		while (iter.hasNext()) {
			DDORegCount ddoReg = (DDORegCount) iter.next();
			if (ddoReg != null && !ddoReg.isValid()) {
				TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
				getMessage("DDO Registration " + ddoReg.ddoReg
						+ " cannot have more than 1 entry of same return type");
				return false;
			}
		}

		return true;
	}

	private boolean tanFlagCheck() {
		// No flag for D mode
		// either (A or NULL) or (U or Null) for others
		int rowsFilled[] = GrpuUtil.getFilledRows(model);

		HashMap tanFlags = new HashMap();

		for (int i = 0; i < rowsFilled.length; i++) {
			if (rowsFilled[i] < 0)
				continue;

			if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
				String revModeText = "";
				revModeText = (String) jTableTransacDetails.getValueAt(i, 2);

				// Added by manish
				if (revModeText.equalsIgnoreCase("Delete")
						|| revModeText.equalsIgnoreCase("--Select--")) {
					continue;

				}
			}

			String tan = model.getValueAt(i, 4).toString().trim();
			String ddoMap = model.getValueAt(i, 24).toString().trim();

			if (tan.equals("TANINVALID") || tan.equals("TANNOTAVBL")
					|| tan.equals("TANAPPLIED"))
				continue;

			// System.out.println(tan +"====="+ddoMap);
			Object entry = tanFlags.get(tan);

			if (entry == null) {
				// insert
				tanFlags.put(tan, ddoMap);
			} else {
				if (entry.toString().equals("Delete")) {
					// System.out.println("Invalid Flags");
					TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
					pointToCellForDdoMapping(tan
							+ " with delete mapping can occur only once ", i,
							24);
					return false;
				} else if (entry.toString().equals("--Select--")
						&& ddoMap.equals("Delete")) {
					TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
					pointToCellForDdoMapping(tan
							+ " with delete mapping can occur only once ", i,
							24);
					return false;
				} else if (entry.toString().equals("--Select--")
						&& !ddoMap.equals("--Select--")) {
					tanFlags.remove(tan);
					tanFlags.put(tan, ddoMap);
				} else if (!entry.toString().equals(ddoMap)
						&& !entry.toString().equals("--Select--")
						&& !ddoMap.equals("--Select--")) {
					// System.out.println("Invalid Flags");
					// getMessage(tan
					// +" cannot have different ddo mapping at row "+(i+1));
					TabGRPU.setSelectedIndex(DDO_TAB_INDEX);
					pointToCellForDdoMapping(tan
							+ " cannot have different ddo mapping ", i, 24);
					// setErrorAt(i, 21);
					return false;
				}
			}

		}

		return true;
	}

	private void delAllRowsDDO() {
		int numRows = model.getRowCount();
		for (int i = 0; i < numRows; i++)
			model.removeRow(0);

	}

	private String changeFormatOfFinYear(String finYear) {
		String startDigits = finYear.toString().trim();
		String endDigits = "" + (Integer.parseInt(startDigits) + 1);
		String sFinYr = startDigits + "-" + endDigits.substring(2, 4);
		return sFinYr;
	}

	// Manipulating on the text records to generate proper year format

	private String changeFormatAssmntYear(String assmntYear) {
		String year = assmntYear.trim();
		String temp = "";
		temp = "-" + year.substring(year.length() - 2, year.length());
		temp = year.substring(0, year.length() - 2) + temp;
		return temp;
	}

	// **************************************************************

	// Modified by Akansha
	private boolean validationForCorrection() {
		// String typeOfCorrection = (String) jComboBox_TypeOfCorrection
		// .getSelectedItem(); --- by Akansha

		String typeOfCorrection = "C1";

		if (typeOfCorrection.equalsIgnoreCase("--select--")
				|| typeOfCorrection.equals("")) {
			String message = "Please select "
					+ jLabel_TypeOfCorrection.getText().substring(0,
							jLabel_TypeOfCorrection.getText().length() - 1);
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;

		}
		if (jText_Form_Sub1_Org_Receipt_Num.getText().trim().equals("")) {
			String message = "Please enter "
					+ jLabel_OrigRRRNo.getText().substring(0,
							jLabel_OrigRRRNo.getText().length());
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		if (jText_Form_Sub1_Previous_Receipt_num.getText().trim().equals("")) {
			String message = "Please enter "
					+ jLabel_PrevRRRNo.getText().substring(0,
							jLabel_PrevRRRNo.getText().length());
			TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
			JOptionPane.showMessageDialog(JdialogFrame, message);
			return false;
		}
		return true;
	}

	// **********************************************************************
	private void enableDisableBusinessKeyFields() {
		if (valueOfTypeOfStmt.equals("Regular")) {
			jText_FinYear1.setVisible(false);
			jText_Month.setVisible(false);
			jComboBox_FinYear1.setVisible(true);
			jComboBox_Month.setVisible(true);
			jText_AIN.setEnabled(true);
			jComboBox_FinYear1.setEnabled(true);
			jComboBox_Month.setEnabled(true);
		} else {
			jText_FinYear1.setText(jComboBox_FinYear1.getSelectedItem()
					.toString());
			jText_Month.setText(jComboBox_Month.getSelectedItem().toString());
			jText_FinYear1.setVisible(true);
			jText_Month.setVisible(true);
			jComboBox_FinYear1.setVisible(false);
			jComboBox_Month.setVisible(false);

			jText_AIN.setEditable(false);
			jText_FinYear1.setEditable(false);
			jText_Month.setEditable(false);
		}

	}

	private void enableDisableBottomButton() {
		String typeOfCorrection = getTypeOfCorrection();
		selTAB = TabGRPU.getSelectedIndex();

		if (valueOfTypeOfStmt.equals("Correction")) {
			if (selTAB == ANNE2_TAB_INDEX) { // selTAB == DDO_TAB_INDEX || -->
				// newly commented for new FRD
				// Ver1.3
				jButton_addRow.setVisible(true); // changed by amit for the
				jButton_insertRow.setVisible(false);
			}
			// new development for FRD1.3 by Akansha
			if (selTAB == DDO_TAB_INDEX) {
				// new development for FRD1.5 by Akansha
				int finyear = 0;
				String dedtype = "";
				if (!"--Select--".equals(JComboBox_Form_Sub1_finYear
						.getSelectedItem()))
					finyear = Integer.parseInt(JComboBox_Form_Sub1_finYear
							.getSelectedItem().toString().substring(0, 4));
				dedtype = JComboBox_Form_Sub1_Type_of_Deductor
						.getSelectedItem().toString();
				if (finyear < 2013
						&& ("Central Government".equals(dedtype) || "State Government"
								.equals(dedtype)))
					jButton_addRow.setVisible(true);
				else
					jButton_addRow.setVisible(false);
				// ***********************************************************************
				jButton_insertRow.setVisible(false);
			}
			// correction
			jButton_delRow.setVisible(true); // enabling the delete row button
			//jLabel_Mandatory.setVisible(true);
			if (selTAB == ANNE_TAB_INDEX) {
				jButton_insertRow.setVisible(true); // added by cholia inert row
				jButton_addRow.setVisible(false);
			}
			// newly added by cholia for form tab
			else if (selTAB == BATCH_TAB_INDEX) {
				jButton_delRow.setVisible(false);
				jButton_opnFile.setVisible(false);
				jLabel_Mandatory.setVisible(true);
			}
			else if (grpu.selTAB == grpu.OTHER_SERVICES_TAB_INDEX) {
				grpu.jButton_delRow.setVisible(false);
				grpu.jButton_opnFile.setVisible(false);
				grpu.jButton_insertRow.setVisible(false);
				grpu.jButton_back.setVisible(false);
				grpu.jButton_addRow.setVisible(false);
				grpu.jButton_crtFile.setVisible(false);
				grpu.jButton_sveFile.setVisible(false);

			}
			// end newly added by cholia
		} else {
			if (selTAB == DDO_TAB_INDEX) {

				jButton_addRow.setVisible(true);
				jButton_delRow.setVisible(true);
				jButton_insertRow.setVisible(false);
				// jLabel_Mandatory.setVisible(false); // by Akansha for
				// mandatory
				// fields
			}
			// Added By for Enabling Ann_Tab_index for annexure 2
			else if (selTAB == ANNE_TAB_INDEX) {

				jButton_addRow.setVisible(false);
				jButton_delRow.setVisible(true);
				jButton_insertRow.setVisible(true);
			}

			else if (selTAB == ANNE2_TAB_INDEX) {
				jButton_addRow.setVisible(true);
				jButton_delRow.setVisible(true);
				jButton_insertRow.setVisible(false);
			}
			else if (grpu.selTAB == grpu.OTHER_SERVICES_TAB_INDEX) {
				grpu.jButton_delRow.setVisible(false);
				grpu.jButton_opnFile.setVisible(false);
				grpu.jButton_insertRow.setVisible(false);
				grpu.jButton_back.setVisible(false);
				grpu.jButton_addRow.setVisible(false);
				grpu.jButton_crtFile.setVisible(false);
				grpu.jButton_sveFile.setVisible(false);
			}
		}

	}

	private void enableDisableFields() {

		Object o = jComboBox_TypeOfCorrection.getSelectedItem();
		Object typeOfStmt = jComboBox_TypOfStmt.getSelectedItem();
		// UIManager.getDefaults().put("ComboBox.disabledForeground",
		// Color.BLACK);
		if ((typeOfStmt.toString().equalsIgnoreCase("Correction"))
				&& (!(o.toString().equalsIgnoreCase("Modify")))) {

			jText_AOName.setEnabled(false);
			jText_AOADD1.setEnabled(false);
			jText_AOADD2.setEnabled(false);
			jText_AOADD3.setEnabled(false);
			jText_AOADD4.setEnabled(false);
			jText_AOCity.setEnabled(false);
			jText_AOPIN.setEnabled(false);
			jText_PhoneNo.setEnabled(false);
			jText_EmailID.setEnabled(false);
			jText_Cur_CntofDDOTransnDtls.setEnabled(false);
			jText_STD.setEnabled(false);
			jText_regNoPaoDtoCddo.setEnabled(false);
			jText_ResponsiblePersonName.setEnabled(false);
			jText_ResponsiblePersonDesgn.setEnabled(false);
			jText_ResponsiblePersonADD1.setEnabled(false);
			jText_ResponsiblePersonADD2.setEnabled(false);
			jText_ResponsiblePersonADD3.setEnabled(false);
			jText_ResponsiblePersonADD4.setEnabled(false);
			jText_ResponsiblePersonCity.setEnabled(false);
			jText_ResponsiblePersonPIN.setEnabled(false);
			jText_ResponsiblePersonPhoneNo.setEnabled(false);
			jText_ResponsiblePersonEmailID.setEnabled(false);
			jText_ResponsiblePersonMobilePhoneNo.setEnabled(false);
			jText_ResponsiblePersonSTD.setEnabled(false);
			jComboBox_ResponsiblePersonState.setEnabled(false);
			jComboBox_Deductor_Category.setEnabled(false);
			jComboBox_AOState.setEnabled(false); // by Akansha
			jComboBox_MinistryName.setEnabled(false);
			jComboBox_SubMinistryName.setEnabled(false);
			jText_OtherMinistryName.setEnabled(false);

		} else {
			jText_AOName.setEnabled(true);
			jText_AOADD1.setEnabled(true);
			jText_AOADD2.setEnabled(true);
			jText_AOADD3.setEnabled(true);
			jText_AOADD4.setEnabled(true);
			jText_AOCity.setEnabled(true);
			jText_AOPIN.setEnabled(true);
			jText_PhoneNo.setEnabled(true);
			jText_EmailID.setEnabled(true);
			jText_regNoPaoDtoCddo.setEnabled(true);
			jText_Cur_CntofDDOTransnDtls.setEnabled(true);
			jText_STD.setEnabled(true);
			jText_ResponsiblePersonName.setEnabled(true);
			jText_ResponsiblePersonDesgn.setEnabled(true);
			jText_ResponsiblePersonADD1.setEnabled(true);
			jText_ResponsiblePersonADD2.setEnabled(true);
			jText_ResponsiblePersonADD3.setEnabled(true);
			jText_ResponsiblePersonADD4.setEnabled(true);
			jText_ResponsiblePersonCity.setEnabled(true);
			jText_ResponsiblePersonPIN.setEnabled(true);
			jText_ResponsiblePersonPhoneNo.setEnabled(true);
			jText_ResponsiblePersonEmailID.setEnabled(true);
			jText_ResponsiblePersonMobilePhoneNo.setEnabled(true);
			jText_ResponsiblePersonSTD.setEnabled(true);
			jComboBox_ResponsiblePersonState.setEnabled(true);
			jComboBox_Deductor_Category.setEnabled(true);

			if (jComboBox_Deductor_Category.getSelectedIndex() == 2) {
				jComboBox_State_Name.setEnabled(true);
			}

			if (jComboBox_Deductor_Category.getSelectedIndex() == 1) {
				jComboBox_MinistryName.setEnabled(true);
			}

			if (jComboBox_MinistryName.getSelectedIndex() == 1) {
				jComboBox_SubMinistryName.setEnabled(true);
			}

			if (jComboBox_SubMinistryName.getSelectedItem().toString()
					.equalsIgnoreCase("Others"))
				jText_OtherMinistryName.setEditable(true);

		}

	}

	private void disableFields() {

		jText_AOName.setEnabled(false);
		jText_AOADD1.setEnabled(false);
		jText_AOADD2.setEnabled(false);
		jText_AOADD3.setEnabled(false);
		jText_AOADD4.setEnabled(false);
		jText_AOCity.setEnabled(false);
		jText_AOPIN.setEnabled(false);
		jText_PhoneNo.setEnabled(false);
		jText_EmailID.setEnabled(false);
		jText_Cur_CntofDDOTransnDtls.setEnabled(false);
		jText_STD.setEnabled(false);
		jText_regNoPaoDtoCddo.setEnabled(false);
		jText_ResponsiblePersonName.setEnabled(false);
		jText_ResponsiblePersonDesgn.setEnabled(false);
		jText_ResponsiblePersonADD1.setEnabled(false);
		jText_ResponsiblePersonADD2.setEnabled(false);
		jText_ResponsiblePersonADD3.setEnabled(false);
		jText_ResponsiblePersonADD4.setEnabled(false);
		jText_ResponsiblePersonCity.setEnabled(false);
		jText_ResponsiblePersonPIN.setEnabled(false);
		jText_ResponsiblePersonPhoneNo.setEnabled(false);
		jText_ResponsiblePersonEmailID.setEnabled(false);
		jText_ResponsiblePersonMobilePhoneNo.setEnabled(false);
		jText_ResponsiblePersonSTD.setEnabled(false);
		jComboBox_ResponsiblePersonState.setEnabled(false);
		jComboBox_Deductor_Category.setEnabled(false);
		jComboBox_MinistryName.setEnabled(false);
		jComboBox_SubMinistryName.setEnabled(false);
		jText_OtherMinistryName.setEnabled(false);

	}

	// Added By for Showing colour of the columns
	public static boolean columnNumberEditableForcolour(int mColIndex,
			String tabname, int row_no, int selYear_anne2, int next_year_anne2,
			String formNumber) {

		if (tabname.trim().equals("Challan")) {

			if (row_no == 0 || row_no == 1) // Added By For brown colour
			{
				return true;
			}

			if (selYear_anne2 != 0 && next_year_anne2 != 0) {

				// new development for FRD1.5 by akansha
				if (mColIndex == 21)
					return true;
				// newly developed for fRD1.5 by akansha
				if ("Regular".equals(valueOfTypeOfStmt))
					if (mColIndex == 0)
						return true;
				// ****************************************
				if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
						&& mColIndex == 10) // for the cheque/DDo Number
					return true;

				// yaha pe
				else if ((selYear_anne2 > 2012 && next_year_anne2 > 2013)
						&& mColIndex == 1) // for the cheque/DDo Number
					return true;

				else if ((selYear_anne2 < 2012 && next_year_anne2 < 2013)
						&& mColIndex == 6)
					return true;
				else if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
						&& mColIndex == 20)
					return true;

				else if (mColIndex == 8) // Last total tax deposited
					return true;
				else
					return false;

			}

			else
				return false;

		}

		if (tabname.trim().equals("Anne1")) {

			if (row_no == 0 || row_no == 1) // Added By cholia For brown colour
			{
				return true;
			}

			if (selYear_anne2 != 0 && next_year_anne2 != 0) {

				if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)) {
					if (mColIndex == 5)
						return true;

					else if (mColIndex == 26 && formNumber.equals("24Q"))
						return true;

					else if (mColIndex == 29
							&& (formNumber.equals("26Q") || formNumber
									.equals("27Q")))
						return true;
					//trial //rpu 3.1 start //RPU 3.4
					else if ((mColIndex == 30 || mColIndex == 31 || mColIndex == 32)
							&& (formNumber.equals("26Q")))
						return true;

					else if (formNumber.equals("27Q")
							&& (mColIndex == 31 || mColIndex == 33
							|| mColIndex == 30 || mColIndex == 32
							// newly added for FRD1.6 by akansha
							|| mColIndex == 35 || mColIndex == 36
							|| mColIndex == 37 || mColIndex == 38 || mColIndex == 39 || mColIndex == 40 || mColIndex == 41 ))// mColIndex //color change //trial//RPU 3.4
						
						return true;

					// newly added by cholia2 24022015
					else if (formNumber.equals("27EQ")) { // ## Newly added on
						// 28/04/2015 for
						// Ver 1.1

						if (mColIndex == 30 || mColIndex == 33 || mColIndex == 34 || mColIndex == 35) //RPu 3.5 grey for year less than 2013
							return true;

						if (mColIndex == 29)
							return false;

					}

					// end newly added by cholia2
					else
						return false;

				}

				else if (selYear_anne2 > 2012 && next_year_anne2 > 2013) {
					if ((formNumber.equals("27Q") || formNumber.equals("26Q"))
							&& mColIndex == 28)
						return true;

					// new development for FRD1.5 by Akansha
					else if (formNumber.equals("27EQ") && (mColIndex == 29)) {// ##
						// Newly
						// added
						// on
						// 28/04/2015
						// for
						// Ver
						// 1.1

						return true;

					} else if (formNumber.equals("27EQ") && (mColIndex == 30))
						return false;
					else if(formNumber.equals("27EQ") &&
							(selYear_anne2 == 2020 && (jComboBox_Quarter.getSelectedItem().equals("Q1")  //RPU 3.5 
							|| jComboBox_Quarter.getSelectedItem().equals("Q2")))
							) {
						if(mColIndex == 33 || mColIndex == 34 || mColIndex == 35)
						return true;}
					else if (formNumber.equals("27EQ") && selYear_anne2 < 2020)
					{	if(mColIndex == 33 || mColIndex == 34 || mColIndex == 35)
								return true;
					}

					else if (formNumber.equals("27Q")
							&& (selYear_anne2 < 2016 && next_year_anne2 < 2017)
							&& (mColIndex == 35 || mColIndex == 37
							|| mColIndex == 38 || mColIndex == 36))
					
						{
						return true;
						}
					else if (formNumber.equals("27Q")
							&& (selYear_anne2 < 2019 && next_year_anne2 < 2020)
							&& (  mColIndex == 39)) //trial
						
						{
											return true;
						}
					//rpu 3.1 start to enable grey color for q1 and 2019
					else if(jComboBox_Quarter.getSelectedItem().equals("Q1")&& 
							selYear_anne2 == 2019 && formNumber.equals("27Q")&&
							(mColIndex == 39) )
					{
						//System.out.println("27Q to enable grey color for q1 and 2019");
						return true;
						}
					//RPU 3.4 to enable grey color for prveious year 
					else if(jComboBox_Quarter.getSelectedItem().equals("Q1")&&  
							selYear_anne2 == 2020 && formNumber.equals("27Q")&&
							(mColIndex == 40 || mColIndex == 41) )
					{
						return true;
					}
					else if (formNumber.equals("27Q")
							&& (selYear_anne2 < 2020 && next_year_anne2 < 2021)
							&& (mColIndex == 40 || mColIndex == 41)) 
						
						{		return true;
						}
					else if (formNumber.equals("26Q")
							&& (selYear_anne2 < 2019 && next_year_anne2 < 2020)
							&& (  mColIndex == 30))
						{
						return true;
						}
					else if(jComboBox_Quarter.getSelectedItem().equals("Q1")&& 
							selYear_anne2 == 2019 && formNumber.equals("26Q")&&
							(mColIndex == 30) )
					{
						System.out.println("26Q to enable grey color for q1 and 2019");
						return true;
						}
					//RPU 3.4 to enable grey color for prveious year
					else if (formNumber.equals("26Q")
							&& (selYear_anne2 < 2020 && next_year_anne2 < 2021)
							&& (  mColIndex == 31 || mColIndex == 32))
						{
						return true;
						}
					else if(jComboBox_Quarter.getSelectedItem().equals("Q1")&& 
							selYear_anne2 == 2020 && formNumber.equals("26Q")&&
							(  mColIndex == 31 || mColIndex == 32) )
					{
						
						return true;
						}
				} else
					return false;

			}

		}

		if (tabname.trim().equals("Anne2")) {

			if (row_no == 0 || row_no == 1) // Added By For brown colour
			{
				return true;
			}

			if (mColIndex == 1) {
				return true;
			}
			if (selYear_anne2 != 0 && next_year_anne2 != 0) {
				if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
						&& (mColIndex == 27 || mColIndex == 28
						|| mColIndex == 31 || mColIndex == 7
						|| mColIndex == 8 || mColIndex == 31))// disabling
					// column
					// 28
					// and
					// column
					// 29
					// for
					// annexure2
				{
					return true;
				}

				

				if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
						&& (mColIndex == 9 || mColIndex == 29))
					return true;

				if ((selYear_anne2 != 2010 && next_year_anne2 != 2011)
						&& (selYear_anne2 != 2011 && next_year_anne2 != 2012)
						&& (mColIndex == 17))
					return true;


				// newly added for revised FRD1.6 by akansha kra he
				if (mColIndex == 57 )
					return true;


				// newly added for FRD1.6 by akansha
				if ((mColIndex == 32 || mColIndex == 33 || mColIndex == 34
						|| mColIndex == 35 || mColIndex == 36
						|| mColIndex == 37 || mColIndex == 38
						|| mColIndex == 39 || mColIndex == 40
						|| mColIndex == 41 || mColIndex == 42
						|| mColIndex == 43 || mColIndex == 44
						|| mColIndex == 45 || mColIndex == 46
						|| mColIndex == 47 || mColIndex == 48 || mColIndex == 49
						)) {
					// System.out.println(" I am inside disabling --- years:"+selYear_anne2+" "+next_year_anne2);
					if (selYear_anne2 < 2016 && next_year_anne2 < 2017) {

						return true;
					} else {
						return false;
					}
				}
				//for gray color  //RPU 3.6 grey 
				if (mColIndex == 92 &&(selYear_anne2 < 2020 && next_year_anne2 < 2021))
                {
                    return true;// RPU 3.6 Changes to grey column when column Yes is present in column 93
                }
				
				if (mColIndex == 61 //add + for each column done
						//|| mColIndex == 62 RPU 3.6 Updated requirement to enable 63rd column
						|| mColIndex == 65
						|| mColIndex == 10
						|| mColIndex == 11
						|| mColIndex == 12
						|| mColIndex == 18
						|| mColIndex == 19
					    || mColIndex == 69
					    || mColIndex == 70
					    || mColIndex == 71
					    || mColIndex == 72
					    || mColIndex == 73
					    || mColIndex == 74
					    || mColIndex == 75
					    || mColIndex == 76
					    || mColIndex == 79
					    || mColIndex == 80
					    || mColIndex == 81
					    || mColIndex == 82
					    || mColIndex == 83
					    || mColIndex == 84
					    || mColIndex == 85
					    || mColIndex == 86
					    || mColIndex == 87
					    || mColIndex == 88
					    || mColIndex == 90
					    || mColIndex == 91)
					    
					    																
						{
						if(grpu.model2.getValueAt(row_no,93) != null && "Yes".equals(grpu.model2.getValueAt(row_no,93)))
						return true;
							else if ((selYear_anne2 < 2012 && next_year_anne2 < 2013)
									&& (mColIndex == 18))// ddiabling column 19 for
								// annexure2
							{
								return true;
							}
						
						}
			
				/***************** Added for 2.7 Start  ********************/
				if ((mColIndex == 58
						|| mColIndex == 59
						|| mColIndex == 60
						|| mColIndex == 61
						|| mColIndex == 62
						|| mColIndex == 63
						|| mColIndex == 64
						|| mColIndex == 65
						|| mColIndex == 66						
						|| mColIndex == 68
						|| mColIndex == 69
						|| mColIndex == 70
						|| mColIndex == 71
						|| mColIndex == 72
						|| mColIndex == 73
						|| mColIndex == 74
						|| mColIndex == 75
						|| mColIndex == 76
						|| mColIndex == 77
						|| mColIndex == 78
						|| mColIndex == 79
						|| mColIndex == 80
						|| mColIndex == 81
						|| mColIndex == 82
						|| mColIndex == 83
						|| mColIndex == 84
						|| mColIndex == 85
						|| mColIndex == 86
						|| mColIndex == 87
						|| mColIndex == 88
						|| mColIndex == 89
						|| mColIndex == 90
						|| mColIndex == 91
						|| mColIndex == 92)){
					if (selYear_anne2 < 2018 && next_year_anne2 < 2019) {

						return true;
					} else {
						return false;
					}
				}

				if (mColIndex == 67)
					return true;


				if (mColIndex == 7  || mColIndex == 16 ){

					if (selYear_anne2 > 2017 && next_year_anne2 > 2018){ 	
						return true;
					}else {
						return false;
					}
				}
				


				/***************** Added for 2.7 End  ********************/


				// newly added for FRD1.6 revised by akansha
				if (mColIndex == 50 || mColIndex == 51 || mColIndex == 52
						|| mColIndex == 53 || mColIndex == 54
						|| mColIndex == 55 || mColIndex == 56
						|| mColIndex == 57)
					if (selYear_anne2 < 2013 && next_year_anne2 < 2014)
						return true;
					else
						return false;
				// ***********************************************************



				// *************************************************************

				return false;

			} else
				return false;

		}

		else
			return false;

	}

	public static boolean columnNumberEditable(int mColIndex, String tabname,
			int row_no) {
		// commented by ye disable button ka colour change krne liye hai
		GRPU gr = new GRPU();

		if (tabname.trim().equals("Challan")) {

			if (row_no == 0 || row_no == 1) // Added By For brown colour
			{
				return true;
			}

			if (mColIndex == 0 || mColIndex == 9 || mColIndex == 10
					|| mColIndex == 11 || mColIndex == 13 || mColIndex == 15
					|| mColIndex == 21 || mColIndex == 8) {

				return true;
			}
			return false;
		}

		else if (tabname.trim().equals("Anne1")) {

			if (row_no == 0 || row_no == 1) // Added By For brown colour// for
				// the first two rows
			{
				return true;
			}

			if (gr.valueOfTypeOfStmt != null) {
				if (gr.valueOfTypeOfStmt.equals("Correction")) {
					if (mColIndex == 0)
						return false;

				}

			}

			if (mColIndex == 2 || mColIndex == 1 || mColIndex == 3
					|| mColIndex == 4 || mColIndex == 6 || mColIndex == 7
					|| mColIndex == 8 || mColIndex == 9 || mColIndex == 12
					|| mColIndex == 20 || mColIndex == 21 || mColIndex == 23
					|| mColIndex == 0 ) { //NOTSURE //TRY removed 31
				return true;
			}
			return false;

		} else if (tabname.trim().equals("Anne2")) {

			if (gr.valueOfTypeOfStmt != null) {
				if (gr.valueOfTypeOfStmt.equals("Regular")) {
					if (mColIndex == 1) {
						return true;
					}
				}
			}
			if (row_no == 0 || row_no == 1) // Added By For brown colour
			{
				return true;
			}
			//for gray color  //RPU 3.6 grey 
			if (mColIndex == 92){
				if(new Integer(grpu.JComboBox_Form_Sub1_finYear  
                    .getSelectedItem().toString()
                    .substring(0,4)) < 2020 && (new Integer(grpu.JComboBox_Form_Sub1_finYear  
                            .getSelectedItem().toString()
                            .substring(4)) < 2021))
            {
                return true;// RPU 3.6 Changes to disable column when column 93 is present
            }else
            {
            	return false;
            }
			}			
			
			if (mColIndex == 61 //add + for each column done
					//|| mColIndex == 62 RPU 3.6 Updated requirement to enable 63rd column
					|| mColIndex == 65
					|| mColIndex == 10
					|| mColIndex == 11
					|| mColIndex == 12
					|| mColIndex == 18
					|| mColIndex == 19
				    || mColIndex == 69
				    || mColIndex == 70
				    || mColIndex == 71
				    || mColIndex == 72
				    || mColIndex == 73
				    || mColIndex == 74
				    || mColIndex == 75
				    || mColIndex == 76
				    || mColIndex == 79
				    || mColIndex == 80
				    || mColIndex == 81
				    || mColIndex == 82
				    || mColIndex == 83
				    || mColIndex == 84
				    || mColIndex == 85
				    || mColIndex == 86
				    || mColIndex == 87
				    || mColIndex == 88
				    || mColIndex == 90
				    || mColIndex == 91)
				    
				    																
					{
					
					if(grpu.model2.getValueAt(row_no,93) != null && "Yes".equals(grpu.model2.getValueAt(row_no,93)))
					return true;
						else
					return false;
			
					}
		
			
			//FRD 2.3 added 16(ia), commented mColIndex == 12, to set background white 
			if (mColIndex == 1 || mColIndex == 20 || mColIndex == 21
					|| mColIndex == 26 || mColIndex == 30 /*|| mColIndex == 12*/
					|| mColIndex == 13 || mColIndex == 15 

					)
				return true;

			else
				return false;




		} else
			return false;

	}

	public static boolean columnNumberEditableChallan(int mColIndex) {

		// commented by abhi

		if (mColIndex == 9 || mColIndex == 10 || mColIndex == 12
				|| mColIndex == 14 || mColIndex == 16) {
			return true;
		}

		return false;

	}

	public static boolean columnNumberEditable(int mColIndex) {

		return true;
	}

	private void initializeAnneTab(String formNumber) {
		ddoTabFlag = true;
		final String tabname = "Anne1";
		
		model1 = new DefaultTableModel() {
			public boolean isCellEditable(int rowIndex, int mColIndex) {

				if (valueOfTypeOfStmt.equals("Regular")
						|| (valueOfTypeOfStmt.equals("Correction") && ((rowIndex >= row_count_annex1) || "ADD"
								.equals(model1.getValueAt(rowIndex, 2)
										.toString())))) {
					// newly added on 12march
					mcolInexSrNo = rowIndex;
					// System.out.println("I am inside ADD");
					if (mColIndex == 0 || mColIndex == 2 || mColIndex == 3
							|| mColIndex == 4 || mColIndex == 5
							|| mColIndex == 13 || mColIndex == 21
							|| mColIndex == 22 || mColIndex == 24
							|| mColIndex == 7 || mColIndex == 8
							|| mColIndex == 9 || mColIndex == 11
							|| mColIndex == 10) // -- disabling
						// the
						// columns
						// from the
						// tab
						return false;

					if (rowIndex == 0 || rowIndex == 1) // to disable first
						// two// rows
						return false;

					// faltu hai key pressed bad mein dekhte hain

					if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
						int selYear_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4));
						int next_year_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(5, 9));

						// added by cholia disabling the drop down for the
						// annexure1
						if (selYear_anne2 < 2013 && next_year_anne2 < 2014) {

							if (mColIndex == 6) // disabling the annexure 1
								// section code
								return false;

						}
						// Added by Akansha
						if (selYear_anne2 < 2013 && next_year_anne2 < 2014) {
							if ("26Q".equals(formNum)) {
								if (mColIndex == 30) {
									return false;
								}
							} else if ("27Q".equals(formNum)) {
								if (mColIndex == 30) {
									return false;
								}
							}
						}
						//RPU 3.1 start to add grey color in last colum if year <2019
						//not working
						if (selYear_anne2 < 2019 && next_year_anne2 < 2020) {
							if ("26Q".equals(formNum)) {
								if (mColIndex == 31) {
									return false;
								}
							} else if ("27Q".equals(formNum)) {
								if (mColIndex == 40) {
									return false;
								}
							}
						}//RPU 3.4
						if(((jComboBox_Quarter.getSelectedItem().equals("Q1"))
								&& selYear_anne2 == 2020) || selYear_anne2 < 2020)
						{
							if ("26Q".equals(formNum)) {
								if (mColIndex == 32) {
									return false;
								}
								if (mColIndex == 33) {
									return false;
								}
							} else if ("27Q".equals(formNum)) {
								if (mColIndex == 41) {
									return false;
								}
								if (mColIndex == 42) {
									return false;
								}
							}
							
						}
						//RPU 3.5 to make the column non editable
						if ("27EQ".equals(formNum)) {
						if(((jComboBox_Quarter.getSelectedItem().equals("Q1") || jComboBox_Quarter.getSelectedItem().equals("Q2"))
								&& selYear_anne2 == 2020) || selYear_anne2 < 2020)
						{
							
								if (mColIndex == 34 || mColIndex == 35 || mColIndex == 36 ) {
									model1.setValueAt("", rowIndex, 34);
									model1.setValueAt("", rowIndex, 35);
									model1.setValueAt("", rowIndex, 36);
									return false;
								}
							}
						
						else if (("F".equals(model1.getValueAt(rowIndex,26))) ||("G".equals(model1.getValueAt(rowIndex,26))))
						{
								
						if (mColIndex == 34 || mColIndex == 35 || mColIndex == 36 ) {
								return true;
							} 
						}
						else if("--Select--".equals(model1.getValueAt(rowIndex,26)) || !(("F".equals(model1.getValueAt(rowIndex,26))) ||("G".equals(model1.getValueAt(rowIndex,26)))))
							if (mColIndex == 34) 
							{
								model1.setValueAt("", rowIndex, 35);
								model1.setValueAt("", rowIndex, 36);
								return false;
						}
						}
						if (selYear_anne2 >= 2013) {
							if ("27Q".equals(formNum)) {
								if (mColIndex == 29)
									return false;
							}
						}

						// ******************************
						// added by cholia for annexure1 26
						if ((mColIndex == 26)) {

							if (selYear_anne2 < 2013 && next_year_anne2 < 2014) {

								String ChallanSrno = "";
								Object ChallanSrnoObj = model1.getValueAt(
										rowIndex, 1);
								if (ChallanSrnoObj != null)
									ChallanSrno = ChallanSrnoObj.toString();

								String modeSecChallan = "";
								Object modeSecChallanObj = model.getValueAt(
										Integer.parseInt(ChallanSrno) + 1, 2);
								if (modeSecChallanObj != null)
									modeSecChallan = modeSecChallanObj
									.toString();

								if (modeSecChallan.equals("--Select--")) {
									return false;
								}

							}

							if (selYear_anne2 >= 2013
									&& next_year_anne2 >= 2014) {
								String modeSecAnnex = "";
								Object modeSecAnnexObj = model1.getValueAt(
										rowIndex, 6);
								if (modeSecAnnexObj != null)
									modeSecAnnex = modeSecAnnexObj.toString();

								if (modeSecAnnex.equals("--Select--")) {
									return false;
								}

							}

						}
						// added by cholia column 26

						if (formNum.equals("24Q")) { // jTableTransacDetails1.putClientProperty("terminateEditOnFocusLost",
							// Boolean.TRUE);
							if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
									&& (mColIndex == 27))// mcol //mColIndex ==
															{

								// 27
								// i.e
								// certificate
								// Numberdisabling
								// Employee
								// Refernce
								// Number
								return false;

							}
						}

						if (formNum.equals("26Q") || formNum.equals("27Q")
								&& (valueOfTypeOfStmt.equals("Correction"))) // ##
							// New change by Akansha Ver 1.1 disabling for form 26Q
						{ // Modified by Akansha
							if ((selYear_anne2 > 2012 && next_year_anne2 > 2013)
									&& (mColIndex == 29))// mcol 29 disabling the paid by book  cash entry for form 26Q
							return false;
						}
						//RPU 3.1 start   disabling the 31st column 
						if (formNum.equals("26Q") ) 
						{
							//System.out.println("value row 6" + model1.getValueAt(rowIndex,6));
						if (selYear_anne2 < 2019 && next_year_anne2 < 2020)
							{
							if (mColIndex == 31 )
								return false;
							}
						else if (selYear_anne2 == 2019 && next_year_anne2 == 2020 && jComboBox_Quarter.getSelectedItem().equals("Q1"))
						{
							if (mColIndex == 31 )
							{	
								model1.setValueAt("", rowIndex, 31);
								return false;
						}
						}
							
						//RPU 3.1 start  to disable 31st column if section code is not equal to 94N
						else if (selYear_anne2 >= 2019 && next_year_anne2 >= 2020 && !"94N".equals(model1.getValueAt(rowIndex,6)) )
						{
							if (mColIndex == 31 )
							{
								model1.setValueAt("", rowIndex, 31);
								return false;
						}
						}
						}
						if (formNum.equals("26Q") ) //RPU 3.4 start  to disable 31st column if section code is not equal to 4NF
						{
							//System.out.println("value row 6" + model1.getValueAt(rowIndex,6));
						if (selYear_anne2 < 2020 && next_year_anne2 < 2021)
							{
							if (mColIndex == 32)
							{	System.out.println("value row 32 in import " + model1.getValueAt(rowIndex,32));
								model1.setValueAt("", rowIndex, 32);
								return false;
						}if ( mColIndex == 33)
						{
							model1.setValueAt("", rowIndex, 33);
							return false;
					}
							}
						else if (selYear_anne2 == 2020 && next_year_anne2 == 2021 && jComboBox_Quarter.getSelectedItem().equals("Q1"))
						{
							if (mColIndex == 32)
							{
								model1.setValueAt("", rowIndex, 32);
								return false;
						}if ( mColIndex == 33)
						{
							model1.setValueAt("", rowIndex, 33);
							return false;
					}
						}
						else if (selYear_anne2 >= 2020 && next_year_anne2 >= 2021 && !"4NF".equals(model1.getValueAt(rowIndex,6)) )
						{
							if (mColIndex == 32)
							{	System.out.println("Inside initialize annex to set value 0 when section not 4NF");
								model1.setValueAt("", rowIndex, 32);
								return false;
						}if ( mColIndex == 33)
						{
							model1.setValueAt("", rowIndex, 33);
							return false;
					}
						}
						}
						// Added for wheter rate of tds
						if (formNum.equals("27Q")) {
							if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
									&& (mColIndex == 31 || mColIndex == 32
									|| mColIndex == 34 || mColIndex == 33

											))// mcol
								// 31
								// disabling
								
								// Residence
								return false;
							// newly added for fRD1.6 by akansha
							if (selYear_anne2 < 2016 && next_year_anne2 < 2017)
								if (mColIndex == 36 || mColIndex == 37
								|| mColIndex == 38 || mColIndex == 39)
									return false;
							// ***********************************************
							//RPU 3.1 start disabling the 40th column 
								if (selYear_anne2 < 2019 && next_year_anne2 < 2020)
									{
									if (mColIndex == 40 )
									{
										model1.setValueAt("",rowIndex, 40);
										return false;
										}
									}
								else if (selYear_anne2 == 2019 && next_year_anne2 == 2020 && jComboBox_Quarter.getSelectedItem().equals("Q1"))
								{
									if (mColIndex == 40)
									{		model1.setValueAt("",rowIndex, 40);
										return false;
									}
								}
								//RPU 3.1 start  to disable 40th column if section code is not equal to 94N
								else if (selYear_anne2 >= 2019 && next_year_anne2 >= 2020 && !"94N".equals(model1.getValueAt(rowIndex,6)) )
								{
									if (mColIndex == 40 )
									{
										model1.setValueAt("",rowIndex, 40);
										return false;
									}
									}//RPU 3.4 start  to disable 41st column if section code is not equal to 4NF
								 if((selYear_anne2 < 2020 && next_year_anne2 < 2021)||
										(selYear_anne2 == 2020 && next_year_anne2 == 2021 && jComboBox_Quarter.getSelectedItem().equals("Q1"))||
										(selYear_anne2 >= 2020 && next_year_anne2 >= 2021 && !"4NF".equals(model1.getValueAt(rowIndex,6)) ))
								{
									if (mColIndex == 41 || mColIndex == 42)
									{
										model1.setValueAt("", rowIndex, 41);
										model1.setValueAt("", rowIndex, 42);
										return false;
								}
								}
								
								

						}

						if (formNum.equals("27EQ")) {
							if ((selYear_anne2 > 2012 && next_year_anne2 > 2013)
									&& (mColIndex == 30))// mcol 31 disabling
								// the whetre rate
								// of tds ,Nature of
								// Remittance,Country
								// Of Residence
								return false;

							// newly added by cholia2
							if (selYear_anne2 < 2013 && (mColIndex == 31)) {
								return false;
							}

							// end newly added by cholia2

							/*********************************************************************************/
							//Added by sadhana, FRD 2.2, for newly added 2 columns. col number 32 and 33
							if ((selYear_anne2 > 2016 && next_year_anne2 > 2017)){
								if (mColIndex == 32)
								{
									return true;
								}
								else if ((mColIndex == 33)){
									String ded_per_res = "";
									Object ded_hav_per_res_est = model1.getValueAt(
											rowIndex, 32);
									if (ded_hav_per_res_est != null)
										ded_per_res = ded_hav_per_res_est.toString();

									System.out.println("the mode is "
											+ ded_per_res);
									if (ded_per_res.equals("Yes"))
										return true;
									else {
										model1.setValueAt("--Select--", rowIndex, 33);
										return false;
									}

								}
							}else{
								if (mColIndex == 32 || mColIndex == 33){
									return false;
								}
							}
							//RPU 3.5 to grey out rows
							if (selYear_anne2 < 2020 && next_year_anne2 < 2021 || 
									(selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
									( jComboBox_Quarter.getSelectedItem().equals("Q1") ||  jComboBox_Quarter.getSelectedItem().equals("Q2")) ))
							{
								if (mColIndex == 34 || mColIndex == 35 || mColIndex == 36){
								return false;
							}
								
							}
							else
							{ 
								if (mColIndex == 35 || mColIndex == 36)
							{	String whether_pymnt_isLiable = "";
							Object Whethr_pyment_is_liable = model1.getValueAt(
									rowIndex, 34);
							if (Whethr_pyment_is_liable != null)
								whether_pymnt_isLiable = Whethr_pyment_is_liable.toString();

							System.out.println("the mode is "
									+ whether_pymnt_isLiable);
							if (whether_pymnt_isLiable.equals("Yes"))
								return true;
							else {
								model1.setValueAt("", rowIndex, 35);
								model1.setValueAt("", rowIndex, 36);
								return false;
							}
								
							}
								
							}

							/*********************************************************************************/

						}

					}

					return true;

				}
				// cholia code for the correction statement
				else if (valueOfTypeOfStmt.equals("Correction")
						&& (rowIndex < row_count_annex1)) // added by cholia
					// write code here
					// for the
					// correction
					// statements

				{

					if (rowIndex == 0 || rowIndex == 1) // to disable first
						// two// rows
						return false;

					// newly added by cholia to disable the first two rows for
					// the drop down

					if (mColIndex == 2 &&
							!"ADD".equals(model1.getValueAt(rowIndex, 2).toString())
							&& rowIndex > 1) // abling the// updation// mode 
						return true;

					// end
					String mode = "";
					Object modeObj = model1.getValueAt(rowIndex, 2);
					
					String sectioncode = "";
					Object sectioncodeObj = model1.getValueAt(rowIndex, 6);
					
					if (modeObj != null)
						mode = modeObj.toString();
					
					if (sectioncodeObj != null)
						sectioncode = sectioncodeObj.toString();

					if (rowIndex < row_count_annex1) {
						if (mColIndex == 0) // disabling the challan serial
							// number field for the already
							// exisitng rows
						{
							return false;

						}
					}

					if (rowIndex < row_count_annex1) // added by cholia for
						// enabling disabling of
						// the existing rows for
						// the correction

					{
						// commented by amit
						if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
							int selYear_anne2 = Integer
									.parseInt(JComboBox_Form_Sub1_finYear
											.getSelectedItem().toString()
											.substring(0, 4));
							int next_year_anne2 = Integer
									.parseInt(JComboBox_Form_Sub1_finYear
											.getSelectedItem().toString()
											.substring(5, 9));

							// till financial year 2009 2010

							if (selYear_anne2 <= 2009 && next_year_anne2 <= 2010) {

								// new development for newly appended value "F",
								// FRD1.9 on 18/01/17
								if (selYear_anne2 >= 2007 ) {

									if (strAnnexIColValue.charAt(rowIndex - 2) == 'O') {

										if (mode.equalsIgnoreCase("UPDATE")) {

											if (!"C".equals(model1.getValueAt(
													rowIndex, 26).toString()))

											{
												// System.out.println("Inside C");
												if (jTableTransacDetails1
														.getSelectedRow() != -1
														&& pan_Updtn_Indicator
														.get(jTableTransacDetails1
																.getSelectedRow() - 2) < 2) {

													if (mColIndex == 14)
														return true;
												} else {
													if (mColIndex == 14)
														return false;
												}

												// disabling the fields on the
												// basis of
												// the
												// UPDATE mode selected from the
												// drop
												// down

												if (formNum.equals("24Q")
														|| formNum
														.equals("26Q")
														|| formNum
														.equals("27Q")
														|| formNum
														.equals("27EQ")) {
													if (mColIndex == 0
															|| mColIndex == 1
															|| mColIndex == 3
															|| mColIndex == 4
															|| mColIndex == 5
															|| mColIndex == 13
															|| mColIndex == 21
															|| mColIndex == 22
															|| mColIndex == 24
															|| mColIndex == 7
															|| mColIndex == 8
															|| mColIndex == 9
															|| mColIndex == 10
															|| mColIndex == 11
															|| mColIndex == 6)
														return false;

													else {
														// idhar likhna hai bro
														if (mColIndex < 27) {
															if (formNum
																	.equals("24Q")
																	|| formNum
																	.equals("26Q")
																	|| formNum
																	.equals("27Q")
																	|| formNum
																	.equals("27EQ"))

																return true;

														} else

														{
															if (formNum
																	.equals("26Q")
																	|| formNum
																	.equals("27Q")
																	|| formNum
																	.equals("27EQ")) {
																if (mColIndex == 27
																		|| mColIndex == 28
																		|| mColIndex == 29)

																	return true;

															}
															if (formNum
																	.equals("27Q")
																	|| formNum
																	.equals("26Q")) {
																if (mColIndex == 30)
																	return false;

															}

															if (mColIndex > 30) {

																if (formNum
																		.equals("27Q")
																		|| formNum
																		.equals("27EQ")) {
																	if (mColIndex == 31
																			|| mColIndex == 32
																			|| mColIndex == 33
																			|| mColIndex == 34) {
																		return false; // disabling the NA fields for form27Q
																			}

																	else
																		return true;
																}

															}
															// new development
															// for FRD1.5 by
															// akansha
															if (mColIndex == 30) {
																if (formNum.equals("27EQ")) {
																	return true;
																}
															}
															// ****************************************

															/*********************************************************************************/
															//Added by sadhana, FRD 2.2 for newly added 2 columns. col number 32 and 33
															/*if(formNum.equals("27EQ")){
																if ((mColIndex == 33)){
																	String ded_per_res = "";
																	Object ded_hav_per_res_est = model1.getValueAt(
																			rowIndex, 32);
																	if (ded_hav_per_res_est != null)
																		ded_per_res = ded_hav_per_res_est.toString();

																	System.out.println("the mode is "
																			+ ded_per_res);
																	if (ded_per_res.equals("Yes"))
																		return true;
																	else {
																		model1.setValueAt("--Select--", rowIndex, 33);
																		return false;
																	}

																}
															}*/

															/*********************************************************************************/	
														}

													}

												}

											}// Newly added for 'C' remark
											else {// ## Newly added for
												// correction
												// Ver1.2 by Akansha

												if (jTableTransacDetails1
														.getSelectedRow() != -1
														&& pan_Updtn_Indicator
														.get(jTableTransacDetails1
																.getSelectedRow() - 2) < 2) {
													if (mColIndex == 14)
														return true;
												} else {
													if (mColIndex == 14)
														return false;
												}

												if (!formNum.equals("27Q")) {
													if (mColIndex == 12
															|| mColIndex == 16
															|| mColIndex == 23)
														return true;
												} else if (mColIndex == 12
														|| mColIndex == 31
														|| mColIndex == 16
														|| mColIndex == 23)
													return true;
											}
											// ***************************************************************
											
											
											
											
											
										}

										if (mode.equalsIgnoreCase("PAN UPDATE")
												&& jTableTransacDetails1
												.getSelectedRow() > 1
												&& ((jTableTransacDetails1
														.getSelectedRow() - 2) < pan_Updtn_Indicator
														.size())

														&& (pan_Updtn_Indicator
																.get(jTableTransacDetails1
																		.getSelectedRow() - 2) < 2)) // THE
											// PAN
											// UPDATE
											// COUNTER
											// <2
										{
											if (formNum.equals("24Q")) {
												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 27)
													return false;
												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;
											}

											if (formNum.equals("26Q")) {
												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 27
														|| mColIndex == 28
														|| mColIndex == 29
														|| mColIndex == 30
														|| mColIndex == 31 //rpu 3.1 start
														|| mColIndex == 32 //RPU 3.4 to disable column for pan update correction
														|| mColIndex == 33) 
													
													// 28
													// certificate
													return false;
												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;
											}

											if (formNum.equals("27Q")) // form
												// 27Q
											{

												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 27
														|| mColIndex == 28
														|| mColIndex == 29
														|| mColIndex == 30
														|| mColIndex == 31
														|| mColIndex == 32
														|| mColIndex == 33
														|| mColIndex == 34
														|| mColIndex == 40//rpu 3.1 start
														|| mColIndex == 41
														|| mColIndex == 42)//RPU 3.4 to disable column for pan update correction
													return false;

												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;
											}

											if (formNum.equals("27EQ")) {
												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 27
														|| mColIndex == 29
														|| mColIndex == 30
														|| mColIndex == 31
														|| mColIndex == 28
														) //RPU 3.5 Correction disable when pan update// 31 //Commented for Obs 19 || mColIndex == 34 || mColIndex == 35 || mColIndex == 36
														
													// ofr
													// certificate
													// code
													return false;
												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;
											}

										}

										else if (mode
												.equalsIgnoreCase("PAN UPDATE")
												&& jTableTransacDetails1
												.getSelectedRow() > 1
												&& ((jTableTransacDetails1
														.getSelectedRow() - 2) < pan_Updtn_Indicator
														.size())
														&& (pan_Updtn_Indicator
																.get(jTableTransacDetails1
																		.getSelectedRow() - 2) == 2)) // THE
											// PAN
											// UPDATE
											// COUNTER
											// ==2
										{

											if (formNum.equals("24Q")) {
												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 14
														|| mColIndex == 27) // 27
													// certificate
													// number
													return false;
												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;

											}

											if (formNum.equals("26Q")) {
												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 27
														|| mColIndex == 28
														|| mColIndex == 29
														|| mColIndex == 30
														|| mColIndex == 31//rpu 3.1 start
														|| mColIndex == 32
														|| mColIndex == 33)//RPU 3.4 to disable column for pan update correction
													// certificate
													return false;
												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;
											}

											if (formNum.equals("27Q")) // form
												// 27Q
											{

												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 27
														|| mColIndex == 28
														|| mColIndex == 29
														|| mColIndex == 30
														|| mColIndex == 31
														|| mColIndex == 32
														|| mColIndex == 33
														|| mColIndex == 34
														|| mColIndex == 40//rpu 3.1 start old value 41
													|| mColIndex == 41
													|| mColIndex == 42)//RPU 3.4 to disable column for pan update correction 
															return false;

												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;
											}

											if (formNum.equals("27EQ")) {
												if (mColIndex == 0
														|| mColIndex == 1
														|| mColIndex == 3
														|| mColIndex == 4
														|| mColIndex == 5
														|| mColIndex == 13
														|| mColIndex == 21
														|| mColIndex == 22
														|| mColIndex == 24
														|| mColIndex == 7
														|| mColIndex == 8
														|| mColIndex == 9
														|| mColIndex == 10
														|| mColIndex == 11
														|| mColIndex == 6
														|| mColIndex == 27
														|| mColIndex == 29
														|| mColIndex == 30
														|| mColIndex == 31
														|| mColIndex == 28
														|| mColIndex == 34
														|| mColIndex == 35
														|| mColIndex == 36) //RPU 3.5 Correction disable when pan update
													// ofr
													// certificate
													// code
													return false;
												// else
												// return true; ---- Newly
												// commented as
												// on 08/04/2015
												if (mColIndex == 14)
													return true;
											}
										}

									} else if (strAnnexIColValue.charAt(rowIndex - 2) == 'F' && (formNum.equals("24Q")|| formNum.equals("26Q")|| formNum.equals("27EQ"))) {
										/****************************************************************************************/
										//new development for newly appended value "F", frozen specific columns, FRD1.9 on 23/01/17
										if(mColIndex ==6 || mColIndex ==14 || mColIndex ==17 || mColIndex ==18 || mColIndex ==19 || mColIndex ==20 || mColIndex ==21  )
										{
											return false;
										}
										if (mode.equalsIgnoreCase("UPDATE")) {
											if (!"C".equals(model1.getValueAt(rowIndex, 26).toString()))
											{
												if (formNum.equals("24Q")|| formNum.equals("26Q")|| formNum.equals("27EQ")) {
													if (mColIndex == 0
															|| mColIndex == 1
															|| mColIndex == 3
															|| mColIndex == 4
															|| mColIndex == 5
															|| mColIndex == 13
															|| mColIndex == 21
															|| mColIndex == 22
															|| mColIndex == 24
															|| mColIndex == 7
															|| mColIndex == 8
															|| mColIndex == 9
															|| mColIndex == 10
															|| mColIndex == 11
															|| mColIndex == 6)
														return false;
													else {
														if (mColIndex < 27) {
															if (formNum.equals("24Q")|| formNum.equals("26Q")
																	|| formNum.equals("27EQ"))
																return true;
														} else
														{
															if (formNum.equals("26Q")|| formNum.equals("27EQ")) {
																if (mColIndex == 27|| mColIndex == 28|| mColIndex == 29)
																	return true;
															}
															if (formNum.equals("26Q")) {
																if (mColIndex == 30)
																	return false;
															}
															if (mColIndex > 30) {
																if (formNum.equals("27EQ")) {
																	if (mColIndex == 31
																			|| mColIndex == 32
																			|| mColIndex == 33
																			|| mColIndex == 34 //RPU 3.5 to disable 3 columns in case of < 2009
																			|| mColIndex == 35
																			|| mColIndex == 36) {
																		return false; 
																	}
																	else
																		return true;
																}
															}
															if (mColIndex == 30) {
																if (formNum
																		.equals("27EQ")) {
																	return true;
																}
															}
														}

														/*********************************************************************************/
														//Added by sadhana, FRD 2.2 for newly added 2 columns. col number 32 and 33
														/*if(formNum.equals("27EQ")){
															if ((mColIndex == 33)){
																String ded_per_res = "";
																Object ded_hav_per_res_est = model1.getValueAt(
																		rowIndex, 32);
																if (ded_hav_per_res_est != null)
																	ded_per_res = ded_hav_per_res_est.toString();

																System.out.println("the mode is "
																		+ ded_per_res);
																if (ded_per_res.equals("Yes"))
																	return true;
																else {
																	model1.setValueAt("--Select--", rowIndex, 33);
																	return false;
																}

															}
														}*/

														/*********************************************************************************/	
													}
												}
											}

										}
										/****************************************************************************************/
									}
								}
								// ******************************************************************
							} else // idhar likhna hai for financial year greaterthan 2009 and 2010
							{
								//System.out.println("value of strAnnexIColValue="+strAnnexIColValue.charAt(rowIndex - 2));
								if (strAnnexIColValue.charAt(rowIndex - 2) == 'O') {

									// System.out.println("PanUpdation Indicator: "
									// + pan_Updtn_Indicator.get(0));
									String remarks = "";
									Object remarks_obj = model1.getValueAt(
											rowIndex, 26);
									if (remarks_obj != null)
										remarks = remarks_obj.toString();

									// added by cholia Pan ka update krna hai
									// toh
									// yahan pe likh dena ki invalid pan aur
									// valid
									// pan aur Pan not avail

									// added by cholia to get the pan updation
									// indicator from the conso file

									// end
									// System.out
									// .println("the choliasameer the value of pan updation indicator is "
									// + pan_Updtn_Indicator
									// .get(jTableTransacDetails1
									// .getSelectedRow() - 2));
									// System.out.println("---"
									// + model1.getValueAt(rowIndex, 26)
									// .toString() + "---");
									if (mode.equalsIgnoreCase("UPDATE")
											&& ("C".equals(model1.getValueAt(
													rowIndex, 26).toString()))) {
										
										if ((jTableTransacDetails1
												.getSelectedRow() > 1 && (jTableTransacDetails1
														.getSelectedRow() - 2) < pan_Updtn_Indicator
														.size())
														&& pan_Updtn_Indicator
														.get(jTableTransacDetails1
																.getSelectedRow() - 2) < 2) {
											if (mColIndex == 14)
												return true;
										} else {
											if (mColIndex == 14)
												return false;
										}

										if (formNum.equals("24Q")) {
											if (selYear_anne2 >= 2013)
												if (mColIndex == 27)
													return true;
											// System.out.println("MCOLINDEX: "
											// + mColIndex);
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5

													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11
													// || mColIndex == 15 //$$
													// removed col15,6,25 New
													// development for RPU Java
													// Ver1.2
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													// || mColIndex == 23 //##
													// New
													// Development as on
													// 01/04/2015
													// by Akansha

													// ||mColIndex == 6

													// ||mColIndex == 17
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													// ||mColIndex == 25
													|| mColIndex == 26

													) {
												// grpu.getMessage("Update not allowed for Remarks in case of Tax deducted/collected at higher rate");
												return false;
											}

											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6) // disabling
														// //##
														// Newly
														// developed
														// for
														// correction
														// Ver1.2
														// by
														// Akansha
														// ||
														// mColIndex
														// == 27
														// the
														// section
														// code
														// when
														// fy
														// is
														// below
														// 2013
														// 2014
														return false;
													else if (mColIndex == 27) // new
														// development
														// for
														// FRD1.5
														// by
														// akansha
														return false;
													else
														return true; // abling
													// all
													// other
													// columns

												} else {

													return true; // abling all
													// other
													// columns
												}

											}

										}

										else if (formNum.equals("26Q")) {

											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11
													|| mColIndex == 27
													|| mColIndex == 28
													|| mColIndex == 29
															
													// || mColIndex == 6 //$$
													// Removed col 15,6,25 for
													// new
													// development RPU Java
													// Ver1.2
													// || mColIndex == 15
													|| mColIndex == 26
													// ||mColIndex == 17 // ##
													// Newly
													// developed bu Akansha for
													// correction Ver1.2
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													// ||mColIndex == 25
													|| mColIndex == 26
													|| mColIndex == 27
													|| mColIndex == 28

													)
												return false;
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6 ||  mColIndex == 31 ||  mColIndex == 32 ||  mColIndex == 33) // disabling //RPU 3.4
														// //##
														// Newly
														// developed
														// for
														// correction
														// Ver1.2
														// by
														// Akansha
														// ||
														// mColIndex
														// == 30
														// the
														// section
														// code
														// when
														// fy
														// is
														// below
														// 2013
														// 2014
														// and
														// the
														// certificate
														// number
														// for
														// form
														// 26
														return false;
													else if (mColIndex == 30)
														return false;
													else
														return true; // abling
													// all
													// other
													// columns

												}  
													else if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020) 
															|| (selYear_anne2 > 2020  ))
													{  if(sectioncode !=null && sectioncode.equals("4NF"))
													{
														if(mColIndex == 32)
														return true;
														if( mColIndex == 33)
															return true;
													}
													}
													else
													return true; // abling all
													// other
													// columns
												

											}

										}

										else if (formNum.equals("27Q")) {
											// System.out.println("---dOUBTFUL1---"
											// + mColIndex);
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11
													|| mColIndex == 26
													|| mColIndex == 18 // ##
													// Newly
													// added
													// for
													// form
													// 27Q
													// || mColIndex == 17
													// || mColIndex == 15
													|| mColIndex == 19
													|| mColIndex == 20
													|| mColIndex == 27
													|| mColIndex == 28
													|| mColIndex == 29

													// || mColIndex == 30
													// || mColIndex == 31 // newly
													// commented for FRD1.3 by Akansha
													// || mColIndex == 6 //$$ Removed
													// col
													// 15,6,25,32,33,34,35 for new
													// development RPU Java Ver1.2
													) {

												
												if (mColIndex == 18
														|| mColIndex == 19
														|| mColIndex == 20
														|| mColIndex == 27
														|| mColIndex == 28) {
													if (selYear_anne2 >= 2013
															&& next_year_anne2 >= 2014) {

														return true;
													} else
														return false;
												} else
													return false;
												// ********************************************
											} else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 30
															|| mColIndex == 31
															|| mColIndex == 37
															|| mColIndex == 38
															|| mColIndex == 39
															|| mColIndex == 40
															|| mColIndex == 41
															|| mColIndex == 42) //  //RPU 3.4
														//disabling the section code when fy is below 2013 2014
														
														return false;
													else
														return true; // abling all other columns
																									}

												else if (selYear_anne2 > 2013
														&& selYear_anne2 < 2016
														&& (mColIndex == 36
														|| mColIndex == 37
														|| mColIndex == 38 || mColIndex == 39)) {
													return false;

												}

												else {

													if (selYear_anne2 >= 2016
															&& (mColIndex == 36
															|| mColIndex == 37
															|| mColIndex == 38 || mColIndex == 39)) {
														return true;
													}
													//rpu 3.1 start
													 if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019) 
															|| (selYear_anne2 > 2019  ))
													{
														//rpu 3.1 to make last column non editable if section is not 94N
														if(mColIndex == 40)
														{
														if (sectioncode!=null &&!sectioncode.equalsIgnoreCase("94N"))
														{	model1.setValueAt("", rowIndex, 40);
															return false;
														}
														else
														return true;  //for amount of cash withdrawal in case of 94N
														}
													}
													//rpu 3.4 start
													 if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020) 
															|| (selYear_anne2 > 2020  ))
													{  if(sectioncode !=null && sectioncode.equals("4NF"))
													{
														if(mColIndex == 41)
														return true;
														if( mColIndex == 42)
															return true;
													}
													}
													return true; // abling all other columns
													
												}

											}

										}

										else if (formNum.equals("27EQ")) {

											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11
													// || mColIndex == 15
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													// || mColIndex == 23 //##
													// New
													// Development as on
													// 01/04/2015
													// by Akansha
													// || mColIndex == 25 //$$
													// Removed col 15,6,25 for
													// new
													// development RPU Java
													// Ver1.2
													|| mColIndex == 26
													|| mColIndex == 28
													// ||mColIndex == 6
													// ||mColIndex == 15
													// ||mColIndex == 17
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													|| mColIndex == 29
													|| mColIndex == 27

													|| mColIndex == 30)
												return false;
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6								//RPU 3.5 Dsiabling last 3 columns correction and remark C
															|| mColIndex == 31 ||  mColIndex == 34 ||  mColIndex == 35 ||  mColIndex == 36) // disabling
														// the
														// section
														// code
														// when
														// fy
														// is
														// below
														// 2013
														// 2014
														// and
														// certificate
														// number
														return false;
													else
														return true; // abling
													// all
													// other
													// columns

												} else {

													/*********************************************************************************/
													//Added by sadhana, FRD 2.2 for newly added 2 columns. col number 32 and 33
													if(selYear_anne2 > 2016 && next_year_anne2 > 2017){
														System.out.println("Inside Update yr > 201617");
														if ((mColIndex == 33)){
															String ded_per_res = "";
															Object ded_hav_per_res_est = model1.getValueAt(
																	rowIndex, 32);
															if (ded_hav_per_res_est != null)
																ded_per_res = ded_hav_per_res_est.toString();

															System.out.println("the mode is "
																	+ ded_per_res);
															if (ded_per_res.equals("Yes"))
																return true;
															else {
																model1.setValueAt("--Select--", rowIndex, 33);
																return false;
															}

														}
														if (mColIndex == 34 || mColIndex == 35 || mColIndex == 36)
														{
														if(selYear_anne2 < 2020 || 
																(selYear_anne2 == 2020  &&
																( jComboBox_Quarter.getSelectedItem().equals("Q1") ||  jComboBox_Quarter.getSelectedItem().equals("Q2")) ))  //RPU 3.5 Correction disable
															return false;
														else 
															return true; 
														}
													}else{
														if (mColIndex == 32 || mColIndex == 33)
															return false;
														else
															return true; 
													}

													/*********************************************************************************/

													if (mColIndex == 30)
														return false;
													return true; // abling all
													// other
													// columns

												}												
											}

										}

									} // end for remarks C

									// added by cholia for remarks !"C"

									else if (mode.equalsIgnoreCase("UPDATE")
											&& !("C".equals(model1.getValueAt(
													rowIndex, 26).toString()))) {
										System.out.println("section code "  +model1.getValueAt(rowIndex, 6).toString());
										System.out.println("Inside O");
										System.out.println("pan_Updtn_Indicator"+pan_Updtn_Indicator);
										if ((jTableTransacDetails1
												.getSelectedRow() > 1 && (jTableTransacDetails1
														.getSelectedRow() - 2) < pan_Updtn_Indicator
														.size())
														&& pan_Updtn_Indicator
														.get(jTableTransacDetails1
																.getSelectedRow() - 2) < 2) {
											if (mColIndex == 14)
												return true;
										} else {
											if (mColIndex == 14)
												return false;
										}

										if (formNum.equals("24Q")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11)
												return false;
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 27) // disabling
														// the
														// section
														// code
														// when
														// fy
														// is
														// below
														// 2013
														// 2014
														return false;
													else
														return true; // abling
													// all
													// other
													// columns

												} else {

													return true; // abling all
													// other
													// columns
												}

											}

										}

										else if (formNum.equals("26Q")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11)
												return false;
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 30 || mColIndex == 31 || mColIndex == 32 || mColIndex == 33)//rpu 3.1 start // disabling //RPU 3.4
														// the 
														// section
														// code
														// when
														// fy
														// is
														// below
														// 2013
														// 2014
														// and
														// the
														// certificate
														// number
														// for
														// form
														// 26
														return false;
													else
														return true; // abling
													// all
													// other
													// columns

												} 
												else	if(mColIndex == 31 )
												{
														if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019) 
																|| (selYear_anne2 > 2019 ))
															
															{
															//rpu 3.1 to make last column non editable if section is not 94N
															
															if (sectioncode!=null &&!sectioncode.equalsIgnoreCase("94N"))
															{
																
																model1.setValueAt("", rowIndex, 31);
											
																	return false;
															}								
															else
															return true;  //for amount of cash withdrawal in case of 94N
															}
													
												}
												else	if(mColIndex == 32 ) //RPU 3.4 Column 32
												{
														if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020) 
																|| (selYear_anne2 > 2020 ))
															{
															//rpu 3.4 to make 32nd column non editable if section is not 4NF
															if (sectioncode!=null &&!sectioncode.equalsIgnoreCase("4NF"))
															{
																model1.setValueAt("", rowIndex, 32);
																System.out.println("Column 32 " + model1.getValueAt(rowIndex, 32));
																return false;
															}								
															else
															return true;  
															}
												}else	if(mColIndex == 33) //RPU 3.4 Column 33
												{
													if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020) 
															|| (selYear_anne2 > 2020 ))
														{
														//rpu 3.4 to make 33rd column non editable if section is not 4NF
														if (sectioncode!=null &&!sectioncode.equalsIgnoreCase("4NF"))
														{
															model1.setValueAt("", rowIndex, 33);
															return false;
														}								
														else
														return true;  
														}
											}
												
												else {
													// new development for
													// FRD1.3 by Akansha
													if (mColIndex == 29)
														return false;
													else
														return true; // abling
													// all
													// other
													// columns
												}

											}
												
										
										} 

										else if (formNum.equals("27Q")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11) {
												System.out
												.println("---dOUBTFUL1---"
														+ mColIndex);
												return false;
											} else {
												System.out
												.println("---dOUBTFUL2---"
														+ mColIndex);
												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 30
															|| mColIndex == 31
															|| mColIndex == 32
															|| mColIndex == 33
															|| mColIndex == 34
															// newly added for
															// FRD1.6 by akansha
															|| mColIndex == 36
															|| mColIndex == 37
															|| mColIndex == 38
															|| mColIndex == 39
															|| mColIndex == 40 //rpu 3.1 start
															|| mColIndex == 41 || mColIndex == 42 //RPU 3.4
															) // disabling the section code when fy is below 2013-2014
															return false;
													else
														return true; // abling all other columns
												}

												else if (selYear_anne2 > 2013
														&& selYear_anne2 < 2016
														&& (mColIndex == 36
														|| mColIndex == 37
														|| mColIndex == 38 || mColIndex == 39)) {
													return false;

												}
												
												//rpu 3.1 start
												else	if(mColIndex == 40)
												{  if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2019) 
																|| (selYear_anne2 > 2019 ))
															{
															if (sectioncode!=null &&!sectioncode.equalsIgnoreCase("94N"))
															{
																model1.setValueAt("", rowIndex, 40);
																return false;
															}								
															else
															return true;
															}																																										
											    }
												//RPU 3.4 column 41 form 27
												else	if(mColIndex == 41)
												{  if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020) 
																|| (selYear_anne2 > 2020 ))
															{
															if (sectioncode!=null &&!sectioncode.equalsIgnoreCase("4NF"))
															{
																model1.setValueAt("", rowIndex, 41);
																return false;
															}								
															else
															return true;
															}																																										
											    }
												//RPU 3.4 column 42 form 27
												else	if(mColIndex == 42)
												{  if ((!jComboBox_Quarter.getSelectedItem().equals("Q1")&& selYear_anne2 == 2020) 
																|| (selYear_anne2 > 2020 ))
															{
															if (sectioncode!=null &&!sectioncode.equalsIgnoreCase("4NF"))
															{
																model1.setValueAt("", rowIndex, 42);
																return false;
															}								
															else
															return true;
															}																																										
											    }
												else {

													if (selYear_anne2 >= 2016
															&& (mColIndex == 36
															|| mColIndex == 37
															|| mColIndex == 38 || mColIndex == 39)) {
														return true;
													}
													System.out
													.println("---dOUBTFUL---"
															+ mColIndex);

													// new development for
													// FRD1.3 by Akansha
													if (mColIndex == 29)
														return false;
													else
														return true; // abling
													// all
													// other
													// columns
												}

											}

										}

										else if (formNum.equals("27EQ")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11)
												return false;
											else {

												if (selYear_anne2 < 2013 && next_year_anne2 < 2014) {
													System.out.println("inside the 27EQ....akki");

													
													if (mColIndex == 6 || mColIndex == 31 || mColIndex == 32 || mColIndex == 33||  mColIndex == 34 || mColIndex == 35 || mColIndex == 36) // disabling //RPU 3.5 correction 
														// the
														// section
														// code
														// when
														// fy
														// is
														// below
														// 2013
														// 2014
														// and
														// the
														// certificate
														// number
														// for
														// form
														// 26
														return false;
													else
														return true; // abling
													// all
													// other
													// columns




												} else {
													// new development for
													// FRD1.3 by Akansha

													/*********************************************************************************/
													//Added by sadhana, FRD 2.2 for newly added 2 columns. col number 32 and 33
													if(selYear_anne2 > 2016 && next_year_anne2 > 2017){
														if ((mColIndex == 33)){
															String ded_per_res = "";
															Object ded_hav_per_res_est = model1.getValueAt(
																	rowIndex, 32);
															if (ded_hav_per_res_est != null)
																ded_per_res = ded_hav_per_res_est.toString();

															System.out.println("the mode is "
																	+ ded_per_res);
															if (ded_per_res.equals("Yes"))
																return true;
															else {
																model1.setValueAt("--Select--", rowIndex, 33);
																return false;
															}

														}
														if (selYear_anne2 < 2020 && next_year_anne2 < 2021 || 
																(selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
																( jComboBox_Quarter.getSelectedItem().equals("Q1") ||  jComboBox_Quarter.getSelectedItem().equals("Q2")) ))  //RPU 3.5
														{
															if (mColIndex == 34 || mColIndex == 35 || mColIndex == 36){
															return false;
														}
															
														}
														else
														{
															if (mColIndex == 35 || mColIndex == 36)
														{	String whether_pymnt_isLiable = "";
														Object Whethr_pyment_is_liable = model1.getValueAt(
																rowIndex, 34);
														if (Whethr_pyment_is_liable != null)
															whether_pymnt_isLiable = Whethr_pyment_is_liable.toString();

														System.out.println("the mode is "
																+ whether_pymnt_isLiable);
														if (whether_pymnt_isLiable.equals("Yes"))
															return true;
														else {
															model1.setValueAt("", rowIndex, 35);
															model1.setValueAt("", rowIndex, 36);
															return false;
														}
															
														}
															if(mColIndex == 34 ) //Commented for Obs 19
															if(!("F".equals(model1.getValueAt(rowIndex,26)) || "G".equals(model1.getValueAt(rowIndex,26))))
																{
																return false;
																
																} 
														}
														
													}else{
														if (mColIndex == 32 || mColIndex == 33)
															return false;
														else
															return true; 
													}

													/*********************************************************************************/

													if (mColIndex == 30)
														return false;
													else
														return true; // abling
													// all
													// other
													// columns
												}

											}

										}

									} // end Remarks !=C

									else if (mode
											.equalsIgnoreCase("PAN UPDATE")
											&& (jTableTransacDetails1
													.getSelectedRow() > 1 && (jTableTransacDetails1
															.getSelectedRow() - 2) < pan_Updtn_Indicator
															.size())
															&& pan_Updtn_Indicator
															.get(jTableTransacDetails1
																	.getSelectedRow() - 2) < 2) // THE
										// PAN
										// UPDATE
										// COUNTER
										// <2
									{

										if (formNum.equals("24Q")) {

											if (mColIndex == 14) {
												System.out
												.println("Inside form 24Q");
												return true;
											} else
												return false;

										} else if (formNum.equals("26Q")) {
											if (mColIndex == 14) {
												System.out
												.println("Inside form 26Q Pan update");
												return true;
											} else
												return false;
										}

										else if (formNum.equals("27Q")) {
											if (mColIndex == 14) {
												System.out
												.println("Inside form 27Q Pan update");
												return true;
											} else
												return false;

										}

										if (formNum.equals("27EQ")) // 27eq
										{
											if (mColIndex == 14) {
												System.out
												.println("Inside form 27EQ PAN update");
												return true;
											} else
												return false;

										}

									}

								} else if (strAnnexIColValue.charAt(rowIndex - 2) == 'F' && (formNum.equals("24Q")|| formNum.equals("26Q")|| formNum.equals("27EQ"))) {
									/****************************************************************************************/
									//new development for newly appended value "F", frozen specific columns, FRD1.9 on 02/02/17
									if(mColIndex ==6 || mColIndex ==14 || mColIndex ==17 || mColIndex ==18 || mColIndex ==19 || mColIndex ==20 || mColIndex ==21  )
									{
										return false;
									}
									if (mode.equalsIgnoreCase("UPDATE")&& ("C".equals(model1.getValueAt(rowIndex, 26).toString()))) {
										if (formNum.equals("24Q")) {
											if (selYear_anne2 >= 2013)
												if (mColIndex == 27)
													return true;
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													|| mColIndex == 26

													) {
												return false;
											}
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6)
														return false;
													else if (mColIndex == 27) 
														return false;
													else
														return true;
												} else {
													return true; 
												}
											}
										}
										else if (formNum.equals("26Q")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11
													|| mColIndex == 27
													|| mColIndex == 28
													|| mColIndex == 29
													|| mColIndex == 26
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													|| mColIndex == 26
													|| mColIndex == 27
													|| mColIndex == 28
													)
												return false;
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6)
														return false;
													else if (mColIndex == 30)
														return false;
													else
														return true; 
												} 
												//rpu 3.1 start
												else	if(mColIndex == 31)
												{
														if ((!(jComboBox_Quarter.getSelectedItem().equals("Q1"))&& selYear_anne2 == 2019) 
																|| (selYear_anne2 > 2019 ))
															{
															return true;  //for amount of cash withdrawal in case of 94N
															}
												}
												//RPU 3.4 column 32nd
												else	if(mColIndex == 32)
												{
														if ((!(jComboBox_Quarter.getSelectedItem().equals("Q1"))&& selYear_anne2 == 2020) 
																|| (selYear_anne2 > 2020 ))
															{ if(sectioncode !=""  && sectioncode.equals("4NF"))
															{
															return true;  
															}
															}
												}else	if(mColIndex == 33)
												{
													if ((!(jComboBox_Quarter.getSelectedItem().equals("Q1"))&& selYear_anne2 == 2020) 
															|| (selYear_anne2 > 2020 ))
														{ if(sectioncode !=""  && sectioncode.equals("4NF"))
														{
															System.out.println("Inside remark  c");
														return true;  
														}
														}
												}
														else {
													return true; 
															}
											}
										}	else if (formNum.equals("27EQ")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													|| mColIndex == 26
													|| mColIndex == 28
													|| mColIndex == 18
													|| mColIndex == 19
													|| mColIndex == 20
													|| mColIndex == 29
													|| mColIndex == 27
													|| mColIndex == 30)
												return false;
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 31) 
														return false;
													else
														return true; 

												} 
												//RPU 3.5 to grey out rows
												else if (selYear_anne2 < 2020 && next_year_anne2 < 2021 || 
														(selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
														( jComboBox_Quarter.getSelectedItem().equals("Q1") ||  jComboBox_Quarter.getSelectedItem().equals("Q2")) ))
												{
													if (mColIndex == 34 || mColIndex == 35 || mColIndex == 36){
													return false;
												}
													
												}
												else
												{ if (mColIndex == 35 || mColIndex == 36)
												{	String whether_pymnt_isLiable = "";
												Object Whethr_pyment_is_liable = model1.getValueAt(
														rowIndex, 34);
												if (Whethr_pyment_is_liable != null)
													whether_pymnt_isLiable = Whethr_pyment_is_liable.toString();

												System.out.println("the mode is "
														+ whether_pymnt_isLiable);
												if (whether_pymnt_isLiable.equals("Yes"))
													return true;
												else {
													model1.setValueAt("", rowIndex, 35);
													model1.setValueAt("", rowIndex, 36);
													return false;
												}
													
												}
												if (mColIndex == 30)
													return false;
												return true;
												}
												
											}
										}

									}else if (mode.equalsIgnoreCase("UPDATE")&& !("C".equals(model1.getValueAt(rowIndex, 26).toString()))) {
										if (formNum.equals("24Q")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11)
												return false;
											else {
												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 27) 
														return false;
													else
														return true; 
												} else {
													return true;
												}
											}
										}else if (formNum.equals("26Q")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11)
												return false;
											else {
												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 30 ) 
														return false;
													else
														return true; 
												} 
												//rpu 3.1 start
												else	if(mColIndex == 31)
												{
														if ((!(jComboBox_Quarter.getSelectedItem().equals("Q1"))&& selYear_anne2 == 2019) 
																|| (selYear_anne2 > 2019 ))
															{ if(sectioncode!=null &&sectioncode.equalsIgnoreCase("94N"))
															return true;  //for amount of cash withdrawal in case of 94N
															}
													
												} //RPU 3.4 column 32
												else	if(mColIndex == 32)
												{
														if ((!(jComboBox_Quarter.getSelectedItem().equals("Q1"))&& selYear_anne2 == 2020) 
																|| (selYear_anne2 > 2020 ))
															{ if(sectioncode !=""  && sectioncode.equals("4NF"))  //NOTSURE
															{
																System.out.println("Inside remark not c");
																return true;  
															}}
												}else	if(mColIndex == 33)
												{
													if ((!(jComboBox_Quarter.getSelectedItem().equals("Q1"))&& selYear_anne2 == 2020) 
															|| (selYear_anne2 > 2020 ))
														{ if(sectioncode !=""  && sectioncode.equals("4NF"))  //NOTSURE
														return true;  
														}
												}
												else {
													if (mColIndex == 29)
														return false;
													else
														return true; 
												}
											}

										}else if (formNum.equals("27EQ")) {
											if (mColIndex == 0
													|| mColIndex == 1
													|| mColIndex == 3
													|| mColIndex == 4
													|| mColIndex == 5
													|| mColIndex == 13
													|| mColIndex == 21
													|| mColIndex == 22
													|| mColIndex == 24
													|| mColIndex == 7
													|| mColIndex == 8
													|| mColIndex == 9
													|| mColIndex == 10
													|| mColIndex == 11)
												return false;
											else {

												if (selYear_anne2 < 2013
														&& next_year_anne2 < 2014) {
													if (mColIndex == 6
															|| mColIndex == 31 || mColIndex == 34 || mColIndex == 35 || mColIndex == 36) 
														return false;
													else
														return true;
												} else {

													/*********************************************************************************/
													//Added by sadhana, FRD 2.2 for newly added 2 columns. col number 32 and 33
													if(selYear_anne2 > 2016 && next_year_anne2 > 2017){
														if ((mColIndex == 33)){
															String ded_per_res = "";
															Object ded_hav_per_res_est = model1.getValueAt(
																	rowIndex, 32);
															if (ded_hav_per_res_est != null)
																ded_per_res = ded_hav_per_res_est.toString();

															System.out.println("the mode is "
																	+ ded_per_res);
															if (ded_per_res.equals("Yes"))
																return true;
															else {
																model1.setValueAt("--Select--", rowIndex, 33);
																return false;
															}

														}
														
													}else{
														if (mColIndex == 32 || mColIndex == 33)
															return false;
														else
															return true; 
													}

													//RPU 3.5 to grey out rows
													if (selYear_anne2 < 2020 && next_year_anne2 < 2021 || 
															(selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
															( jComboBox_Quarter.getSelectedItem().equals("Q1") ||  jComboBox_Quarter.getSelectedItem().equals("Q2")) ))
													{
														if (mColIndex == 34 || mColIndex == 35 || mColIndex == 36){
														return false;
													}
														
													}
													else
													{ if (mColIndex == 35 || mColIndex == 36)
													{	String whether_pymnt_isLiable = "";
													Object Whethr_pyment_is_liable = model1.getValueAt(
															rowIndex, 34);
													if (Whethr_pyment_is_liable != null)
														whether_pymnt_isLiable = Whethr_pyment_is_liable.toString();

														if (whether_pymnt_isLiable.equals("Yes"))
														return true;
													else {
														model1.setValueAt("", rowIndex, 35);
														model1.setValueAt("", rowIndex, 36);
														return false;
													}
														
													}
														
													}

													/*********************************************************************************/	

													if (mColIndex == 30)
														return false;
													else
														return true; 
												}
											}
										}
									}
								}
								/*****************************************************************************/
							}
						}
					}
					// cholia add here for the newly added rows for the
					// corrdction
					// end here
					return false;
				}


				return false; // return false

			}

		};

		jTableTransacDetails1 = new JTable(model1) {

			public Component prepareRenderer(TableCellRenderer renderer,
					int rowIndex, int vColIndex) {

				Component c = super.prepareRenderer(renderer, rowIndex,
						vColIndex);
				Color prevColor = Color.white;
				if (c instanceof JComponent) {
					JComponent jc = (JComponent) c;
					if (vColIndex == 0 || vColIndex == 1) {
						// commented by
						// jc.setToolTipText((String)
						// getValueAt(rowIndex,vColIndex));
					} else {

						// new development for FRD1.5 by akansha
						if (vColIndex == 5) {

							if (Integer.parseInt(JComboBox_Form_Sub1_finYear
									.getSelectedItem().toString()
									.substring(0, 4)) > 2012) {
								// System.out.println("Sections: "+sections[i]
								// );
								if ("92A".equals((String) getValueAt(rowIndex,
										vColIndex))) {
									jc.setToolTipText("192 - 92A - Payment to Govt. Employees other than Union Government Employees");
								} else if ("92B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("192 - 92B - Payment of Employees other than Govt. Employee");
								} else if ("92C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>192 - 92C - Payments made to Union Govt. employees.<br>(Applicable from statement pertaining to FY 2013-14 onwards)</html>");
								} else if ("193".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("193 - Interest on Securities");
								} else if ("194".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194 - Dividend");
								}else if ("194IC".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194IC - Payment under specified agreement");
									//Section Code changes for RPU 2.9
								}else if ("94N".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194N - Payment of certain amounts in cash");
								}else if ("94A".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194A - Interest other than interest on securities");
								} else if ("94B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194B - Winnings from lotteries and crossword puzzles");
								} else if ("4BB".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194BB - Winnings from horse race");
								} else if ("94C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194C - Payment of contractors and sub-contractors");
								} else if ("94D".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194D - Insurance Commission");
								} else if ("4EE".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194EE - Payments in respect of Deposits under National Savings Schemes");
								} else if ("94F".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194F - Payments on account of Re-purchase of Units by Mutual Funds or UTI");
								} else if ("94G".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194G - Commission, prize etc., on sale of Lottery tickets");
								} else if ("94H".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194H - Commission or Brokerage");
								} else if ("94I".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194I - Rent (Applicable upto FY 2012-13)");
								} else if ("4IA".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194I (a) - Rent on Machinery, Plant or Equipment (Applicable from FY 2013-14 onwards)");
								} else if ("4IB".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194I (b) - Rent on Land or Building (Applicable from FY 2013-14 onwards)");
								} else if ("94J".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194J - Fees for Professional or Technical Services");
									//RPU 3.3 start
								} else if ("4JA".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194J (a) - Fees for Technical Services (not being professional services), royalty for sale, distribution or exhibition of cinematographic films and call centre (@2%)");
								} else if ("4JB".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194J (b) - Fee for professional service or royalty etc. (@10%)");
							} else if ("94L".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194LA - Payment of Compensation on acquisition of certain immovable property");
							} else if ("94K".equals((String) getValueAt(
									rowIndex, vColIndex))) {   //RPU 3.2 start addition of new section 94K for form 26Q
								jc.setToolTipText("194K - TDS on income from Mutual Fund units");
					
							} else if ("4BA".equals((String) getValueAt(
										rowIndex, vColIndex))) // new
								{
									jc.setToolTipText("<html>194LBA  - Certain income from units of business trust<br> (Applicable from FY 2014-15 Q3 onwards.)</html>");
								} else if ("4DA".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>194DA  - Payment in respect of life insurance policy<br> (Applicable from FY 2014-15 Q3 onwards)</html>");
								} else if ("2AA".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>192A  - Payment of accumulated balance due to an employee made by the trustees of the Employees<br> Provident Fund Scheme, 1952. (Applicable for statements pertaining to FY 2015-16 onwards)</html>");
								} else if ("LBB".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>194LBB -  - Income in respect of units of investment fund <br>(Applicable for statements pertaining to FY 2015-16 onwards)</html>");
								} else if ("94E".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194E - Payments to non-resident Sportsmen/Sport Associations");
								} else if ("94O".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194O - TDS on E-commerce transactions"); //RPU 3.5 start Addition of new section codes 
								} else if ("94Q".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194Q- Payment of certain sums for purchase of goods"); //RPU 3.7 CR 81169 tooltip for section code
								} else if ("195".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("195 - Other sums payable to a non-resident");
								} else if ("96A".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("196A - Income in respect of units of Non-Residents");
								} else if ("96B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("196B - Payments in respect of Units to an Offshore Fund");
								} else if ("96C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>196C - Income from foreign Currency Bonds or <br>shares of Indian Company payable to Non-Resident</html>");
								} else if ("96D".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("196D - Income of foreign institutional investors from securities");
								} else if ("6DA".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>196D(1A)- Income of specified fund from securities <br>referred to in clause (a) of sub-section (1) <br>of section 115AD (other than interest income referred to in section 194LD)</html>");
								} else if ("4LB".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>194LB  - Income by way of Interest from <br>Infrastructure Debt fund (Applicable from FY 2011-12 onwards)</html>");
								} else if ("4LC".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>194LC  - Income by way of interest from Indian company engaged <br>in certain business. (Applicable from FY 2012-13 onwards).</html>");
								} else if ("4LD".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>194LD - Income by way of interest on certain <br>bonds and Government securities</html>");
								} else if ("4BA".equals((String) getValueAt(
										rowIndex, vColIndex)))
								{
									jc.setToolTipText("<html>194LBA  - Certain income from units of business trust <br>(Applicable from FY 2014-15 Q3 onwards.)</html>");
								} //RPU 3.4 start Addition of new section codes 
								   else if ("BA1".equals((String) getValueAt(
										rowIndex, vColIndex)) && "26Q".equals(formNum))// new development
								{
									jc.setToolTipText("<html>194LBA(a)  - Certain income in the form of interest from units <br>of a business trust to a residential unit holder</html>");
								} else if ("BA2".equals((String) getValueAt(
										rowIndex, vColIndex)) && "26Q".equals(formNum))// new development
								{
									jc.setToolTipText("<html>194LBA(b)  - Certain income in the form of dividend from units <br>of a business trust to a residential unit holder.</html>");
								} else if ("BA1".equals((String) getValueAt(
												rowIndex, vColIndex)))// new development
										{
											jc.setToolTipText("<html>194LBA (a) - Income referred to in section 10(23FC)(a) from units of a business trust</html>");
										} else if ("BA2".equals((String) getValueAt(
												rowIndex, vColIndex)))// new development
										{
											jc.setToolTipText("<html>194LBA (b) - Income referred to in section 10(23FC)(b) from units of a business trust.</html>");
										} 
										else if ("BA3".equals((String) getValueAt(
												rowIndex, vColIndex)))// new development
										{
											jc.setToolTipText("<html>194LBA (c) - Income referred to in section 10(23FCA) from units of a business trust</html>");
										}
										else if ("4NF".equals((String) getValueAt(
										rowIndex, vColIndex)))// new development
								{
									jc.setToolTipText("<html>194NF - Payment of certain amounts in cash to non-filers.</html>");
							
								} else if ("LBB".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>194LBB -  - Income in respect of units of investment fund - <br>(Applicable for statements pertaining to FY 2015-16 onwards) </html>");
																} else if ("A".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("206C - A - Collection at source from Alcoholic Liquor for Human Consumption");
								} else if ("B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("206C - B - Collection at source from timber obtained under Forest Lease");
								} else if ("C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>206C - C - Collection at source from Timber <br>obtained by any Mode other than a Forest Lease</html>");
								} else if ("D".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>206C - D - Collection at source from any other <br>Forest Produce (not being Tendu Leaves)</html>");
								} else if ("E".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("206C - E - Collection at source from Scrap");
								} else if ("F".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("206C - F - Collection at source from contractors or licensee or lease relating to Parking lots");
								} else if ("G".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("206C - G - Collection at source from contractors or licensee or lease relating to toll plaza");
								} else if ("H".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("206C - H - Collection at source from contractors or licensee or lease relating to mine or quarry");
								} else if ("I".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("206C - I - Collection at source from tendu leaves");
								} else if ("J".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>206C - J - Collection at source from on sale of certain <br>Minerals (Applicable from 2nd Quarter of FY 2012-13 onwards)</html>");
								} else if ("K".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>206C - K - Collection at source on cash case of Bullion and <br>Jewellery (Applicable from 2nd Quarter of FY 2012-13 onwards)</html>");
								} 
							else if ("O".equals((String) getValueAt(
									rowIndex, vColIndex))) {			//RPU 3.5 start Addition of new section codes 
								jc.setToolTipText("<html>206C-O - Collection at source on remittance under LRS <br>for purchase of overseas tour program package</html>");
							} else if ("P".equals((String) getValueAt(
									rowIndex, vColIndex))) {
								jc.setToolTipText("<html>206C-P - Collection at source on remittance under LRS  <br>for educational loan taken from financial institution<br> mentioned in section 80E</html>");
							} else if ("Q".equals((String) getValueAt(
									rowIndex, vColIndex))) {
								jc.setToolTipText("<html>206C-Q - Collection at source on remittance under LRS  <br>for purpose other than for purchase of overseas tour package<br> or for educational loan taken from financial institution</html>");
							} else if ("R".equals((String) getValueAt(
									rowIndex, vColIndex))) {
								jc.setToolTipText("<html>206C-R - Collection at source on sale of goods</html>");
							}
								// newly added for FRD1.5 by akansha
								else if ("9IA".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("194IA  TDS on Sale of Property");
								} else if ("--Select--"
										.equals((String) getValueAt(rowIndex,
												vColIndex))) {
									jc.setToolTipText("--Select--");
								}
								// ****************************************************************
								// newly added for FRD1.6 by akansha
								else if ("LBC".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>194LBC - Income in respect of investment <br>in securitization trust</html>");
								} else if ("L".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>206C - L - TCS on sale of Motor vehicle</html>");
								} else if ("M".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>206C - M - TCS on sale in cash of any goods<br> (other than bullion/jewellery)</html>");
								} else if ("N".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>206C - N - TCS on providing of any services<br> (other than Chapter-XVII-B)</html>");
								}

							} else {

								String toolTipval = cellTooltip1(vColIndex);
								jc.setToolTipText(toolTipval);
							}

						} else if (vColIndex == 25) {
							// Form wise distribution of the remark's tooltips

							// newly developed for FRD1.5 by akansha
							if ("--Select--".equals((String) getValueAt(
									rowIndex, vColIndex))) {
								jc.setToolTipText("--Select--");
							}
							// ************************************
							if ("24Q".equals(formNum)) {
								if ("A".equals((String) getValueAt(rowIndex,
										vColIndex))) {
									jc.setToolTipText("A - Lower deduction on account of certificate under section 197");
								} else if ("B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("B - No deduction on account of certificate under section 197");
								} else if ("C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>C - Deduction of tax at higher rate due to non-availability <br>of PAN (Applicable from FY 2010-11 onwards)</html>");
								}
							} else if ("26Q".equals(formNum)) {
								if ("A".equals((String) getValueAt(rowIndex,
										vColIndex))) {
									jc.setToolTipText("A - Lower deduction / No deduction on account of certificate under section 197");
								} else if ("B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("B - No deduction on account of declaration under section 197A");
								}
								// new development for FRD1.5 by akansha
								else if ("B - In case of 15G/15H"
										.equals((String) getValueAt(rowIndex,
												vColIndex))) {
									jc.setToolTipText("B - No deduction on account of declaration under section 197A");
								}
								// *********************************************
								else if ("C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>C - Deduction of tax at higher rate due to non-availability<br> of PAN (Applicable from FY 2010-11 onwards)</html>");
								} else if ("T".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("T - Transporter transaction and if valid PAN is provided");
								} else if ("Y".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>Y - Transaction where tax not been deducted as amount paid/credited<br> to the vendor/party has not exceeded the threshold limit</html>");
								} else if ("S".equals((String) getValueAt(
										rowIndex, vColIndex))) {
										if ("94Q".equals((String) getValueAt(rowIndex,5)))
										jc.setToolTipText("S- if no deduction is in view of the provisions of sub-section (5) of section 194Q");
										else
											jc.setToolTipText("S - Software acquired under section 194J (Applicable from FY 2012-13 onwards)");
										 
								}//RPU 3.7 CR 81169 Multiple description
								else if ("Z".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>Z - No deduction on account of payment under section <br>197A (1F) (Applicable from FY 2013-14 onwards)</html>");
								}
								/*********************************************************/
								//FRD 2.3 change for adding new remark for 94A by, Sadhana
								else if ("R".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>R - In case of deduction on interest income for Senior Citizens</html>");
								}/*********************************************************/
								//rpu 3.1 start
								else if ("N".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>N - No deduction on account of payment made to a person<br> referred to in clause (iii) or clause (iv) of the provision to<br> section 194N or on account of notification issued under <br>clause (v) of the provision to section 194N</html>");
								}
								 //RPU 3.4 start Addition of new remark 
								else if ("O".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>O - No deduction is as per the provisions <br>of sub-section (2A) of section 194LBA</html>");
								}
								else if ("M".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>M - No deduction or lower deduction is on account of notification issued under second provision to section 194N</html>");
								}
								else if ("E".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>E - No deduction is on account of payment being made <br>to a person referred to in Board Circular no. 3<br> of 2002 dated 28th June, 2002 or Board Circular no. 11 <br>of 2002 dated 22nd November, 2002 or Board Circular no. 18 <br>of 2017 dated 28th May, 2017</html>");
								}
								else if ("D".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>D - No deduction or lower deduction is on account of payment<br> made to a person or class of person on account of notification<br> issued under sub-section (5) of section of 194A</html>");
								}
								 //CR 80278 new remark P,Q
								else if ("P".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>P - no deduction is on account of payment of dividend <br>made to a business trust referred to in clause (d)<br> of second proviso to section 194 or in view of any notification issued under clause (e) of the second proviso to section 194</html>");
								}
								else if ("Q".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>Q - no deduction in view of payment made to an entity <br>referred to in clause (x) of sub-section (3)<br> of section 194A</html>");
								}
								else if ("U".equals((String) getValueAt(
										rowIndex, vColIndex))) {//RPU 3.7 CR 81169
									jc.setToolTipText("<html>U- if the deduction is on higher rate in view of section 206AB for non-filing of return of income</html>");
								}
								
							} else if ("27Q".equals(formNum)) {
								if ("A".equals((String) getValueAt(rowIndex,
										vColIndex))) {
									jc.setToolTipText("A - Lower deduction or no deduction on account of certificate under section 197");
								} else if ("B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("B - No deduction on account of declaration under section 197A");
								} else if ("C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>C - Deduction of tax at higher rate due to non-availability<br> of PAN (Applicable from FY 2010-11 onwards)</html>");
								} else if ("S".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("S - Software acquired under section 195 (Applicable from FY 2012-13 onwards)");
									}
								//rpu 3.1 start
								else if ("N".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>N - No deduction on account of payment made to a person<br> referred to in clause (iii) or clause (iv) of the provision to<br> section 194N or on account of notification issued under <br>clause (v) of the provision to section 194N</html>");
									}
								else if ("M".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>M - No deduction or lower deduction is on account of notification issued under second provision to section 194N</html>");
								}
								//RPU 3.4 start Addition of new remark G
								else if ("G".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>G - No deduction is in view of clause (a) or clause (b)<br> of sub-section (1D) of section 197A</html>");
									}
								else if ("H".equals((String) getValueAt(
										rowIndex, vColIndex))) {//CR 80278 new remark H
									jc.setToolTipText("<html>H - In case of  no deduction is in view of proviso to <br>sub-section (1A) of section 196D in respect of<br> an income paid to a specified fund which is exempt under clause (4D) of section 10.</html>");
								}
								else if ("I".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>I - if no deduction is in view of sub-section (2) of section 196D<br> in respect of income of the nature of capital gains on transfer of securities<br> referred to in section 115AD paid or payable to a Foreign Institutional Investor</html>");
								} //CR 80278 new remark I
								else if ("J".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>J-  if deduction is at higher rate in view of section 206AB for non-filing of return of income<br> by the non-resident having a permanent establishment in India</html>");
								} //RPU 3.7 CR 81169 new remark J
								
							} else if ("27EQ".equals(formNum)) {
								if ("A".equals((String) getValueAt(rowIndex,
										vColIndex))) {
									jc.setToolTipText("A - In case of lower collection as per section 206C (9)");
								} else if ("B".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("B - Non collection as per section 206C (1A)");
								}else if ("C".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>C - Deduction of tax at higher rate due to non-availability<br> of PAN (Applicable from FY 2017-18 onwards)</html>"); //Added by Sadhana For RFD2.0
								}
								 //RPU 3.5 start Addition of new remark 
								else if ("D".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>D - if no collection is on account of the first provison to sub-section (1G) of section 206C</html>"); 
								}
								else if ("E".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>E - if no collection is on account of the fourth provison to sub-section (1G) of section 206C</html>"); 
								}
								else if ("F".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>F - if no collection is on account clause (i) or clause (ii) of the fifth provison to sub-section (1G) or in view of notification issued under the clause (ii).</html>"); //Added by Sadhana For RFD2.0
								}
								else if ("G".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>G - if no collection is on account of the second provison to sub-section (IH) of section 206C.</html>"); 
								}
								else if ("H".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>H - if no collection is on account of sub-clause (A) or sub-clause (B) or sub-clause (C), or in view of notification issued under sub-clause (c), of clause (a) of the Explanation.</html>"); 
								}
								else if ("I".equals((String) getValueAt(
										rowIndex, vColIndex))) {
									jc.setToolTipText("<html>I- if collection is at a higher rate in view of section 206CCA</html>");
								} //RPU 3.7 CR 81169 new remark I
								
							}
						}
						// ****************************************************************************
						else {

							// ## Newly added by Akansha for Ver1.1
							if ("27EQ".equals(jText_disabledFromNum.getText()
									.toString())) {

								String toolTipval = cellTooltip27EQ(vColIndex);
								jc.setToolTipText(toolTipval);

							} else if ("24Q".equals(jText_disabledFromNum
									.getText().toString())) {
								String toolTipval = cellTooltip24Q(vColIndex);
								jc.setToolTipText(toolTipval);
							}  else if ("26Q".equals(jText_disabledFromNum   //RPU 3.1 start
									.getText().toString())) {
								String toolTipval = cellTooltip26Q(vColIndex);
								jc.setToolTipText(toolTipval);
							} else {// ***************************************
								String toolTipval = cellTooltip1(vColIndex);
								jc.setToolTipText(toolTipval);
							}
						}
					}
				}
				return c;
			}

		};
		// Dimension of the table

		jTableTransacDetails1.setPreferredScrollableViewportSize(new Dimension(500, 70));
		//jTableTransacDetails1.setPreferredScrollableViewportSize(new Dimension(1355, 445));
		jTableTransacDetails1.setGridColor(Color.orange);
		jTableTransacDetails1.setRowHeight(20);
		JScrollPane jScrollPane7 = new JScrollPane(jTableTransacDetails1);
		jScrollPane7.getViewport().setScrollMode(
				JViewport.BACKINGSTORE_SCROLL_MODE);
		// jScrollPane7.getViewport ().setScrollMode (
		// JViewport.SIMPLE_SCROLL_MODE );
		jScrollPane7.setViewportView(jTableTransacDetails1);
		jTableTransacDetails1.getTableHeader().setReorderingAllowed(false);
		jTableTransacDetails1.getTableHeader().setFont(font);
		jTableTransacDetails1.setRowSelectionAllowed(false);
		jTableTransacDetails1.setColumnSelectionAllowed(false);
		jTableTransacDetails1.setCellSelectionEnabled(true);
		jTableTransacDetails1.setSurrendersFocusOnKeystroke(true); // Added for
		// issue on
		// 24042015
		viewport = (JViewport) jTableTransacDetails1.getParent();
		rect = jScrollPane7.getViewportBorderBounds();
		pt = viewport.getViewPosition();
		PanelAnnexureDet.setLayout(new GridLayout(1, 0, 0, 0));
		PanelAnnexureDet.add(jScrollPane7, 0);

		/*****************************************************************************/
		//Added by Sadhana
		/*jPanelTab2.setLayout(null);
		jPanelTab2.setPreferredSize(new Dimension(1355,700));
		jlabelAdv2.setBounds(10, 10, 500, 100);
		jPanelTab2.add(jlabelAdv2);
		jScrollPane7.setBounds(0, 100, 1355, 445);
		jPanelTab2.add(jScrollPane7);
		PanelAnnexureDet.add(jPanelTab2);*/
		/*****************************************************************************/

		JTableHeader jHeaderTransacDetails1 = jTableTransacDetails1
				.getTableHeader();
		jHeaderTransacDetails1.setPreferredSize(new Dimension(50000, 80));
		// -- To add Rupee symbol
		URL url = null;
		try {
			url = getClass().getResource("/images/rp.png");
			if (url == null)
				throw new Exception();

		} catch (Exception e) {
			System.err.println("Exception  while creating the Rupee image : ");
			e.printStackTrace();

		}

		// -- end
		// Added By For Annexure1
		// priya_ann1
		model1.addColumn("<html><center>Row Number</center></html>");// 0
		model1.addColumn("<html><center>Challan<br>Serial No.</center></html>");// 1
		model1.addColumn("<html><center>Update Mode<br>For Deductee<br>( Add / Update/<br>PAN Update)</center></html>");// 2
		model1.addColumn("<html><center>BSR Code of<br>Branch Where<br>Tax Deposited</center></html>");// 3
		model1.addColumn("<html><center>Date on which<br>Tax Deposited (DD/MM/YYYY)</center></html>");// 4
		model1.addColumn("<html><center>Transfer Voucher/<br>Challan Serial No.</center></html>");// 5
		if (formNumber.equals("27EQ"))
			// Collection Code under which payment made
			model1.addColumn("<html><center><tr>Collection Code Under <br>Which Payment Made</tr></center></html>");// 6
		else
			model1.addColumn("<html><center><tr>Section Under<br>Which Payment<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Made</tr></center></html>");// 6

		if (formNumber.equals("26Q") || formNumber.equals("24Q")
				|| formNumber.equals("27Q"))
			model1.addColumn("<html><center>Total TDS to be allocated<br>among deductees as in<br>the vertical total of col. 21<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 7
		else
			model1.addColumn("<html><center>Total TCS to be allocated<br>among parties as in<br>the vertical total of col. 21<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 7
		model1.addColumn("<html><center>Interest<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>");// 8
		model1.addColumn("<html><center>Others<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>");// 9
		model1.addColumn("<html><center>Total<br>(7+8+9)<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>");// 10
		model1.addColumn("<html><center>Sr. No.</center></html>");// 11

		if (formNumber.equals("24Q"))
			model1.addColumn("<html><center>Employee Reference No.<br>Provided by Employer/<br>PPO number, if available</center></html>");// 12
		else if (formNumber.equals("26Q") || formNumber.equals("27Q"))
			model1.addColumn("<html><center>Deductee Reference Number<br>Provided by the Deductor<br>(if available)</center></html>");// 12
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Party Reference Number<br>Provided by the Collector<br>(if available)</center></html>");// 12

		if (formNumber.equals("24Q"))
			model1.addColumn("<html><center>Last PAN of<br>Employee/Senior Citizen</center></html>");// 13
		else if (formNumber.equals("26Q") || formNumber.equals("27Q"))
			model1.addColumn("<html><center>Last PAN of<br>Deductee</center></html>");// 13
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Last PAN of<br>Party</center></html>");// 13

		if (formNumber.equals("24Q"))
			model1.addColumn("<html><center>PAN of the<br>Employee/Senior Citizen</center></html>");// 14
		else if (formNumber.equals("26Q") || formNumber.equals("27Q"))
			model1.addColumn("<html><center>PAN of the<br>Deductee</center></html>");// 14
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>PAN of the<br>Party</center></html>");// 14

		if (formNumber.equals("24Q"))
			model1.addColumn("<html><center>Name of the Employee/<br>Senior Citizen</center></html>");// 15
		else if (formNumber.equals("26Q") || formNumber.equals("27Q"))
			model1.addColumn("<html><center>Name of the Deductee</center></html>");// 15
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Name of the Party</center></html>");// 15

		if (formNumber.equals("27EQ"))
			// newly added by cholia
			model1.addColumn("<html><center>Date on which amount <br> Paid/Debited <br> (DD/MM/YYYY)</center></html>");// 16
		else
			model1.addColumn("<html><center>Date of Payment/Credit <br> (DD/MM/YYYY)</center></html>");// 16
		if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Amount Paid/Debited<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img>  </br></center></html>");// 17
		else
			model1.addColumn("<html><center>Amount Paid/Credited<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img>  </br></center></html>");// 17
		if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>TCS<br><img src='" + url
					+ "'  height='12' width='10'  > </img> </center></html>"); // 18
		else
			model1.addColumn("<html><center>TDS<br><img src='" + url
					+ "'  height='12' width='10'  > </img> </center></html>"); // 18
		model1.addColumn("<html><center>Surcharge<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 19
		model1.addColumn("<html><center>Education Cess<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 20
		if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Total Tax Collected<br>&nbsp;&nbsp;&nbsp;&nbsp;(18+19+20)<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 21
		else
			model1.addColumn("<html><center>Total Tax Deducted <br>&nbsp;&nbsp;&nbsp;&nbsp;(18+19+20)<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 21

		if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Last Total<br>Tax Collected<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 22
		else
			model1.addColumn("<html><center>Last Total<br>Tax Deducted<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 22


		//For RPU 2.6
		if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Total Tax<br>&nbsp;&nbsp;Collected<br><img src='"
					+ url + "'  height='12' width='10'> </img></center></html>");// 23
		else
			model1.addColumn("<html><center>Total Tax<br>&nbsp;&nbsp;Deposited<br><img src='"
					+ url + "'  height='12' width='10'> </img></center></html>");        // 23


		//For RPU 2.6
		if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Last Total Tax<br>Collected<br><img src='"
					+ url + "'  height='12' width='10'> </img></center></html>");// 24
		else
			model1.addColumn("<html><center>Last Total Tax<br>Deposited<br><img src='"
					+ url + "'  height='12' width='10'> </img></center></html>");// 24


		if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Date of Collection <br>(DD/MM/YYYY)</center></html>");// 25
		// //cholia
		// on
		// 11
		// macrh
		// 2015
		else
			model1.addColumn("<html><center>Date of Deduction <br>(DD/MM/YYYY)</center></html>");// 25

		if (formNumber.equals("24Q") || formNumber.equals("27Q"))
			model1.addColumn("<html><center>Remarks (Reason for<br>non-deduction / lower deduction/<br>higher deduction)</center></html>");// 26
		else if (formNumber.equals("26Q"))
			model1.addColumn("<html><center>Remarks (Reason for<br>non-deduction / lower deduction/<br>higher deduction / threshold)</center></html>");// 26
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Remarks<br>(Reason for<br>non-collection /<br>lower collection </center></html>");// 26
		if (formNumber.equals("24Q"))
			model1.addColumn("<html><center>Certificate number issued by<br> Assessing Officer u/s 197 for<br>non-deduction / lower deduction</center></html>");// 27
		else if (formNumber.equals("26Q") || formNumber.equals("27Q"))
			model1.addColumn("<html><center>Deductee Code<br>(1-Company,<br>2-Other than Company)</center></html>");// 27
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Party Code <br>(1-Company 2-Other than Company)</center></html>");// 27
		// else if (formNumber.equals("27EQ") || formNumber.equals("27Q"))
		// model1.addColumn("<html><center>Deductee Code <br>(1-Company<br>2-Other than Company)</center></html>");//
		// 27

		if (formNumber.equals("26Q") || formNumber.equals("27Q"))
			model1.addColumn("<html><center>Rate at which<br>Tax deducted</center></html>");// 28
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Total Value <br>of Purchase(s) <br><img src='"
					+ url + "'  height='12' width='10'> </img></center></html>");// 28

		if (formNumber.equals("26Q") || formNumber.equals("27Q"))// 29
			model1.addColumn("<html><center>Paid by book entry<br>or otherwise</center></html>");// 29
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Rate at which<br> Tax Collected</center></html>");// 29

		if (formNumber.equals("26Q") || formNumber.equals("27Q"))//
			model1.addColumn("<html><center>Certificate number issued by<br> the Assessing Officer u/s 197 for<br>non-deduction / lower deduction</center></html>"); // 30
		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Paid by Book entry<br>or otherwise</center></html>"); // 30

		if (formNumber.equals("27Q"))
			model1.addColumn("<html><center>Whether TDS rate of TDS <br> is IT act(a) and DTAA(b)</center></html>"); // 31

		else if (formNumber.equals("27EQ"))
			model1.addColumn("<html><center>Certificate number issued by<br> the Assessing Officer u/s 197 for<br>non-deduction / lower deduction</center></html>"); // 31
		if (formNumber.equals("27Q")) {
			model1.addColumn("<html><center>Nature of remittance</center></html>");// 32
			model1.addColumn("<html><center>Unique acknowledgement of the<br>corresponding Form no. 15CA <br>(if available)</center></html>");// 33
			model1.addColumn("<html><center>Country of the <br>Residence of the deductee</center></html>");// 34
			model1.addColumn("<html><center>Grossing up Indicator</center></html>");// 35

			// newly added for FRD1.7 by akansha
			model1.addColumn("<html><center>Email ID of deductee</center></html>");// 36
			model1.addColumn("<html><center>Contact number of deductee</center></html>");// 37
			model1.addColumn("<html><center>Address of deductee in country <br>of residence</center></html>");// 38
			model1.addColumn("<html><center>Tax Identification Number /Unique <br>identification number of <br>deductee</center></html>");// 39
			// **********************************************************************
		}

		/*****************************************************************/
		//added by sadhana FRD 2.2, added two new column.
		else if (formNumber.equals("27EQ")){
			//model1.addColumn("<html><center>Deductee is &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>&nbsp;Non-Resident</center></html>"); // 32
			model1.addColumn("<html><center>Deductee is Non-Resident</center></html>");
			model1.addColumn("<html><center>Deductee is having <br> Permanent Establishment <br> in India</center></html>"); // 33
			//RPU 3.5 Addition of 3  new columns
			model1.addColumn("<html><center>Whether the payment by collectee is liable to TDS <br>as per clause (a) of the fifth provison to sub-section (1G)<br> or second provison to sub-section (1H) and whether TDS has been<br> deducted from such payment (if either F or G is selected in 680)</center></html>");//34
			model1.addColumn("<html><center>Challan number</center></html>");//35
			model1.addColumn("<html><center>Date of payment of TDS<br> to Central Government</center></html>");//36
		}
		//RPU 3.1 start
		
		if (formNumber.equals("26Q") || formNumber.equals("27Q") )
		{	model1.addColumn("<html><center>Amount of cash withdrawal<br> in excess of Rs. 1 crore <br> as referred to in section 194N<br><img src='"
					+ url + "'  height='20' width='20'  > </img>  </br></center></html>");
		//RPU 3.4 Column name
		model1.addColumn("<html><center>Amount of cash withdrawal which is in excess of Rs. 20 lakhs<br> but does not exceed Rs. 1 crore for cases covered by sub-clause (a)<br> of clause (ii) of first provision to section 194N<br> <img src='"
				+ url + "'  height='12' width='20'  > </img>  </br></center></html>");
		model1.addColumn("<html><center>Amount of cash withdrawal which is in excess of Rs. 1 crore <br>for cases covered by sub-clause (b) of clause (ii) <br> of first provision to section 194N<br><img src='"
				+ url + "'  height='12' width='20'  > </img>  </br></center></html>");
		}
		/*****************************************************************/
		

		packColumn1(jTableTransacDetails1, 0, 15);
		packColumn1(jTableTransacDetails1, 1, 30);
		packColumn1(jTableTransacDetails1, 2, 20);
		packColumn1(jTableTransacDetails1, 3, 20);
		packColumn1(jTableTransacDetails1, 4, -10);
		packColumn1(jTableTransacDetails1, 5, 10);
		packColumn1(jTableTransacDetails1, 6, 10);
		packColumn1(jTableTransacDetails1, 7, 5);
		packColumn1(jTableTransacDetails1, 8, 30);
		packColumn1(jTableTransacDetails1, 9, 30);
		packColumn1(jTableTransacDetails1, 10, 30);
		packColumn1(jTableTransacDetails1, 11, 20);
		packColumn1(jTableTransacDetails1, 12, 0);
		packColumn1(jTableTransacDetails1, 13, 20);
		packColumn1(jTableTransacDetails1, 14, 30);
		packColumn1(jTableTransacDetails1, 15, 40);
		packColumn1(jTableTransacDetails1, 16, -10); // newly chnaged by cholia
		// for date width
		packColumn1(jTableTransacDetails1, 17, -10);
		packColumn1(jTableTransacDetails1, 18, 50);
		packColumn1(jTableTransacDetails1, 19, 20);
		packColumn1(jTableTransacDetails1, 20, 10);
		packColumn1(jTableTransacDetails1, 21, 0);
		packColumn1(jTableTransacDetails1, 22, 20);
		packColumn1(jTableTransacDetails1, 23, 20);
		packColumn1(jTableTransacDetails1, 24, 15);
		packColumn1(jTableTransacDetails1, 25, 10); // newly chnaged by cholia
		// for date of deduction
		packColumn1(jTableTransacDetails1, 26, 0);
		packColumn1(jTableTransacDetails1, 27, 10);
		if (formNumber.equals("27Q") || formNumber.equals("26Q") || formNumber.equals("27EQ")) {
			packColumn1(jTableTransacDetails1, 28, 20);
			packColumn1(jTableTransacDetails1, 29, 10);
			packColumn1(jTableTransacDetails1, 30, 10);
		}
		//RPU 3.1 start
		if (formNumber.equals("26Q")) {
			packColumn1(jTableTransacDetails1, 31, 10);
			packColumn1(jTableTransacDetails1, 32, 10); //RPU 3.4
			packColumn1(jTableTransacDetails1, 33, 20);

		}

		if (formNumber.equals("27EQ")) {
			packColumn1(jTableTransacDetails1, 26, 5);
			packColumn1(jTableTransacDetails1, 30, 5);

		}

		if (formNumber.equals("27Q") || formNumber.equals("27EQ")){
			packColumn1(jTableTransacDetails1, 31, 0);
			/*****************************************************************/
			packColumn1(jTableTransacDetails1, 32, -10);
			packColumn1(jTableTransacDetails1, 33, 0);
			/*****************************************************************/
		}
		if (formNumber.equals("27EQ")) { //RPU 3.5 Addition of 3  new columns
			packColumn1(jTableTransacDetails1, 34, 15);
			packColumn1(jTableTransacDetails1, 35, 10);
			packColumn1(jTableTransacDetails1, 36, 10);
		}
		if (formNumber.equals("27Q")) {
			packColumn1(jTableTransacDetails1, 32, -10);
			packColumn1(jTableTransacDetails1, 33, 0);
			packColumn1(jTableTransacDetails1, 34, -10);
			packColumn1(jTableTransacDetails1, 35, -10);

			// newly added for FRD1.7 by akansha
			packColumn1(jTableTransacDetails1, 36, 10);
			packColumn1(jTableTransacDetails1, 37, -10);
			packColumn1(jTableTransacDetails1, 38, -10);
			packColumn1(jTableTransacDetails1, 39, -10);
			// ******************************************
			//RPU 3.1 start
			packColumn1(jTableTransacDetails1, 40, 10);
			packColumn1(jTableTransacDetails1, 41, 10); //RPU 3.4
			packColumn1(jTableTransacDetails1, 42, 20);
			
		}

		// -- for two rows behind the model

		Vector<Object> row = new Vector<Object>();

		if (formNumber.equals("24Q")) {
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
			row.add("<html><tr><td align='center'></td></tr></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(325)</html>");
			row.add("<html></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(317)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(313)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(314)</html>");
			row.add("<html></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(315)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(316)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(318)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(320)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(321)</html>");
			row.add("<html></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(322)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(323)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(324)</html>");
			row.add("<html></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(319)</html>");

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(326)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(327)</html>");

			/*
			 * row.add(
			 * "<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(349)</html>"
			 * );row.add(
			 * "<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(350)</html>"
			 * );row.add(
			 * "<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(351)</html>"
			 * ); row.add("<html></html>");row.add(
			 * "<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</html>"
			 * );
			 */
		} else if (formNumber.equals("26Q")) {
			row.add("<html></html>");// 1
			row.add("<html></html>");// 2
			row.add("<html><tr><td align='center'></td></tr></html>");// 3
			row.add("<html></html>");// 4

			row.add("<html></html>");// 5
			row.add("<html></html>");// 6
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(417)</html>");// 7
			row.add("<html></html>");// 8
			row.add("<html></html>");
			row.add("<html></html>");
			row.add("<html></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(412)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(413)</html>");// 9
			row.add("<html></html>");// 10
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(415)</html>");// 11
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(416)</html>");// 12
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(418)</html>");// 13
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419)</html>");// 14
			row.add("<html></html>");// 15
			row.add("<html></html>");// 16
			row.add("<html></html>");// 17
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(420)</html>");// 18
			row.add("<html></html>");// 19
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(421)</html>");// 20
			row.add("<html></html>");// 21
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(422)</html>");// 22
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(424)</html>");// 23
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(414)</html>");// 24
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(423)</html>");// 25
			row.add("<html></html>");// 26
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(425)</html>");// 27
			//work here
			//RPU 3.1 start
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419A)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419B)</html>"); //RPU 3.4
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419C)</html>");
		}

		else if (formNumber.equals("27Q")) {
			row.add("<html></html>");// 1
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(701)</html>");// 2
			row.add("<html><tr><td align='center'></td></tr></html>");// 3
			row.add("<html></html>");// 4

			row.add("<html></html>");// 5
			row.add("<html></html>");// 6
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(719)</html>");// 7
			row.add("<html></html>");// 8
			row.add("<html></html>");
			row.add("<html></html>");
			row.add("<html></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(714)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(715)</html>");// 9
			row.add("<html></html>");// 10
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(717)</html>");// 11
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(718)</html>");// 12
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(720)</html>");// 13
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(721)</html>");// 14
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(722)</html>");// 15
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(723)</html>");// 16
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(724)</html>");// 17
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(725)</html>");// 18
			row.add("<html></html>");// 19
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(726)</html>");// 20
			row.add("<html></html>");// 21
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(727)</html>");// 22
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(729)</html>");// 23
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(716)</html>");// 24
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(728)</html>");// 25
			row.add("<html></html>");// 26
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(730)</html>");// 27
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(731)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(732)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(733)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(734)</html>");
			row.add("<html></html>");

			// newly added for FRD1.7 by akansha
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(735)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(736)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(737)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(738)</html>");
			// ******************************************************************
			//RPU 3.1 start
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(721A)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(720B)</html>"); //RPU 3.4
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(720C)</html>");
		}

		else if (formNumber.equals("27EQ")) {
			row.add("<html></html>");// 1
			row.add("<html></html>");// 2
			row.add("<html><tr><td align='center'></td></tr></html>");// 3
			row.add("<html></html>");// 4

			row.add("<html></html>");// 5
			row.add("<html></html>");// 6
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(672)</html>");// 7
			row.add("<html></html>");// 8
			row.add("<html></html>");
			row.add("<html></html>");
			row.add("<html></html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(664)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(665)</html>");// 9
			row.add("<html></html>");// 10
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(667)</html>");// 11
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(668)</html>");// 12
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(671)</html>");// 13
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(670)</html>");// 14
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(673)</html>");// 15
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(674)</html>");// 16
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(675)</html>");// 17
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(676)</html>");// 18
			row.add("<html></html>");// 19
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(677)</html>");// 20
			row.add("<html></html>");// 21
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(678)</html>");// 22
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(680)</html>");// 23
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(666)</html>");// 24
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(669)</html>");// 25
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(679)</html>");// 26
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(671)</html>");// 27
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(681)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(618A)</html>");//34 //RPU 3.5 Addition of 3  new columns
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(618B)</html>");//35
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(618C)</html>");//36
			/*****************************************************************/
			//Added by sadhana, FRD 2.2.
			/*row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(684)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(687)</html>");*/
			/*****************************************************************/
		}

		// Added by Amit
		addStaticAnnIRows(model1);
		// **********************

		// end
		FixedColumnTable fct = new FixedColumnTable(1, jScrollPane7);
		jTableTransacDetails1.setAutoResizeMode(0);

		// To change colour on the basis of the financial year

		int selYear_ann1_colour = 0;
		int next_year_ann1_colour = 0;
		if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
			selYear_ann1_colour = Integer.parseInt(JComboBox_Form_Sub1_finYear
					.getSelectedItem().toString().substring(0, 4));
			next_year_ann1_colour = Integer
					.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem()
							.toString().substring(5, 9));
			System.out.println(" selYear_colur is " + selYear_ann1_colour);
		}
		// End

		// challan serial number
		/*
		 * jTableTransacDetails1.getColumnModel().getColumn(0).setCellEditor(
		 * new GRPUTableCellEditorChlnSerNoannex1()); //daan
		 */

		// System.out.println("divya row count is " + row_count_annex1);

		jTableTransacDetails1.getColumnModel().getColumn(0)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		// start here

		jTableTransacDetails1.getColumnModel().getColumn(1)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// end

		jTableTransacDetails1.getColumnModel().getColumn(2)
		.setCellEditor(new GRPUTableCellEditorBSRCd());
		jTableTransacDetails1.getColumnModel().getColumn(2)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// Date on which tax deposited
		jTableTransacDetails1.getColumnModel().getColumn(3)
		.setCellEditor(new GRPUTableCellEditorDateofDep(mainObject));
		jTableTransacDetails1.getColumnModel().getColumn(3)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
		// End which tax deposited

		// Transfer voucher number
		jTableTransacDetails1.getColumnModel().getColumn(4)
		.setCellEditor(new GRPUTableCellEditorTV());
		jTableTransacDetails1.getColumnModel().getColumn(4)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// End Transfer voucher number
		jTableTransacDetails1.getColumnModel().getColumn(5)
		.setCellEditor(new GRPUTableCellEditorSection());
		jTableTransacDetails1.getColumnModel().getColumn(5)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		jTableTransacDetails1.getColumnModel().getColumn(6)
		.setCellEditor(new GRPUTableCellEditorTotalTDS());

		jTableTransacDetails1.getColumnModel().getColumn(6)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		jTableTransacDetails1.getColumnModel().getColumn(7)
		.setCellEditor(new GRPUTableCellEditorInterest());
		jTableTransacDetails1.getColumnModel().getColumn(7)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		jTableTransacDetails1.getColumnModel().getColumn(8)
		.setCellEditor(new GRPUTableCellEditorOthers());
		jTableTransacDetails1.getColumnModel().getColumn(8)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		/*
		 * jTableTransacDetails1.getColumnModel().getColumn(9)
		 * .setCellEditor(new GRPUTableCellEditorTotal());
		 */

		jTableTransacDetails1.getColumnModel().getColumn(9)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		/*
		 * jTableTransacDetails1.getColumnModel().getColumn(10)
		 * .setCellEditor(new GRPUTableCellEditorSrNo());
		 */

		jTableTransacDetails1.getColumnModel().getColumn(10)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// Employee Reference Number //vibha
		jTableTransacDetails1.getColumnModel().getColumn(11)
		.setCellEditor(new GRPUTableCellEditorEmpRefNum(formNumber));
		// added on 12 march 2015
		jTableTransacDetails1.getColumnModel().getColumn(11)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
		// End Employee Reference Number

		jTableTransacDetails1.getColumnModel().getColumn(12)
		.setCellEditor(new GRPUTableCellEditorLastPAN());
		jTableTransacDetails1.getColumnModel().getColumn(12)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// Pan of the Empolyee
		jTableTransacDetails1.getColumnModel().getColumn(13)
		.setCellEditor(new GRPUTableCellEditorPAN());
		jTableTransacDetails1.getColumnModel().getColumn(13)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
		// End Pan of the Empolyee

		// Name of the Eployee
		jTableTransacDetails1.getColumnModel().getColumn(14)
		.setCellEditor(new GRPUTableCellEditorEmployName(formNumber));
		jTableTransacDetails1.getColumnModel().getColumn(14)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// End Name of the Eployee

		// Date of payment/Credit
		jTableTransacDetails1.getColumnModel().getColumn(15)
		.setCellEditor(new GRPUTableCellEditorDateOfPay(mainObject));
		jTableTransacDetails1.getColumnModel().getColumn(15)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
		// End Date of payment/Credit

		// Amount paid /credited
		jTableTransacDetails1.getColumnModel().getColumn(16)
		.setCellEditor(new GRPUTableCellEditorAmtPaid());
		jTableTransacDetails1.getColumnModel().getColumn(16)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		// End Amount paid /credited

		// Annex1 tds
		jTableTransacDetails1.getColumnModel().getColumn(17)
		.setCellEditor(new GRPUTableCellEditorTDS(valueOfTypeOfStmt));
		jTableTransacDetails1.getColumnModel().getColumn(17)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		// End tds

		// surcharge
		jTableTransacDetails1
		.getColumnModel()
		.getColumn(18)
		.setCellEditor(
				new GRPUTableCellEditorSurcharge(valueOfTypeOfStmt));
		jTableTransacDetails1.getColumnModel().getColumn(18)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
		// End surcharge

		// education cess
		jTableTransacDetails1
		.getColumnModel()
		.getColumn(19)
		.setCellEditor(
				new GRPUTableCellEditorEduCessann1(valueOfTypeOfStmt));
		jTableTransacDetails1.getColumnModel().getColumn(19)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
		// Emd eductaionces

		// Total tax
		jTableTransacDetails1.getColumnModel().getColumn(20)
		.setCellEditor(new GRPUTableCellEditorTotTaxDed());
		jTableTransacDetails1.getColumnModel().getColumn(20)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		// End Total tax deducted

		jTableTransacDetails1.getColumnModel().getColumn(21)
		.setCellEditor(new GRPUTableCellEditorLstTotTaxDed());
		jTableTransacDetails1.getColumnModel().getColumn(21)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		// idhar Total Tax Deposited
		jTableTransacDetails1
		.getColumnModel()
		.getColumn(22)
		.setCellEditor(
				new GRPUTableCellEditorTotTaxDep(valueOfTypeOfStmt));
		jTableTransacDetails1.getColumnModel().getColumn(22)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
		// End Total Tax Deposited

		// LastTotal Tax Deposited
		jTableTransacDetails1.getColumnModel().getColumn(23)
		.setCellEditor(new GRPUTableCellEditorLstTotTaxDep());
		jTableTransacDetails1.getColumnModel().getColumn(23)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
		// End LastTotal Tax Deposited

		// Date of Dedcution
		jTableTransacDetails1.getColumnModel().getColumn(24)
		.setCellEditor(new GRPUTableCellEditorDateOfDed(mainObject));
		jTableTransacDetails1.getColumnModel().getColumn(24)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
		// End Date of Dedcution

		// remarks filed
		jTableTransacDetails1.getColumnModel().getColumn(25)
		.setCellEditor(new GRPUTableCellEditorRemarkannex1());
		jTableTransacDetails1.getColumnModel().getColumn(25)
		.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
		// end remarks filed
		if (formNumber.equals("24Q")) {
			jTableTransacDetails1.getColumnModel().getColumn(26)
			.setCellEditor(new GRPUTableCellEditorCertNum());
			// jTableTransacDetails1.getColumnModel().getColumn(26)
			// .setCellRenderer(new GRPUTableCellRenderer(tabname));
		}
		// amit end till For Form 24Q

		// Amit yahan pe start validations for 26Q
		if (formNumber.equals("26Q") || formNumber.equals("27Q")) {
			// Drop Deductee code
			jTableTransacDetails1.getColumnModel().getColumn(26)
			.setCellEditor(new GRPUTableCellEditorDedCode());
			jTableTransacDetails1.getColumnModel().getColumn(26)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			//

			jTableTransacDetails1.getColumnModel().getColumn(27)
			.setCellEditor(new GRPUTableCellEditorRateTaxDedtd());
			jTableTransacDetails1.getColumnModel().getColumn(27)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			jTableTransacDetails1.getColumnModel().getColumn(28)
			.setCellEditor(new GRPUTableCellEditorBookEntry());

			jTableTransacDetails1.getColumnModel().getColumn(29)
			.setCellEditor(new GRPUTableCellEditorCertNum());
			// jTableTransacDetails1.getColumnModel().getColumn(29)
			// .setCellRenderer(new GRPUTableCellRenderer(tabname));

		}//RPU 3.1 start
		
		
		if (formNumber.equals("26Q")) {
			System.out.println("26q inside Amount of cash withdrawal in excess of Rs. 1 crore as referred to in section 194N");
			// Amount of cash withdrawal in excess of Rs. 1 crore as referred to in section 194N
			jTableTransacDetails1.getColumnModel().getColumn(30)
					.setCellEditor(new GRPUTableCellEditorAmtCshWdrawS194N());
			jTableTransacDetails1.getColumnModel().getColumn(30)
					.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			//RPu 3.4 set value for column 32 and 33
			jTableTransacDetails1.getColumnModel().getColumn(31)
			.setCellEditor(new GRPUTableCellEditorAmtCshWdrawRs20lkhSbcle_a_194N());
			jTableTransacDetails1.getColumnModel().getColumn(31)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			jTableTransacDetails1.getColumnModel().getColumn(32)
	.setCellEditor(new GRPUTableCellEditorAmtCshWdrawRs20lkhSbcle_b_194N());
			System.out.println("26q column 32,33 ");
			jTableTransacDetails1.getColumnModel().getColumn(32)
	.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			
			// trial
		}

		// Amit yahan pe start validations for 26Q
		if (formNumber.equals("27Q")) {

			// whether tds rate of tds is IT act(a)
			jTableTransacDetails1.getColumnModel().getColumn(30)
			.setCellEditor(new GRPUTableCellEditorCertNum());
			jTableTransacDetails1.getColumnModel().getColumn(30)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			// end whether tds rate of tds is IT act(a)

			// Nature of remmitaance do here
			jTableTransacDetails1.getColumnModel().getColumn(31)
			.setCellEditor(new GRPUTableCellEditorCertNum());
			jTableTransacDetails1.getColumnModel().getColumn(31)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// end //Nature of remmitaance

			// Unique Acknowledegment number daan
			jTableTransacDetails1.getColumnModel().getColumn(32)
			.setCellEditor(new GRPUTableCellEditorUniqAckNo());
			jTableTransacDetails1.getColumnModel().getColumn(32)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// end Unique Acknowledegment number

			// country of residence
			jTableTransacDetails1.getColumnModel().getColumn(33)
			.setCellEditor(new GRPUTableCellEditorCountryResd());

			// end country of residence

			// Gross Indicator
			jTableTransacDetails1.getColumnModel().getColumn(34)
			.setCellEditor(new GRPUTableCellEditorGrossInd());
			jTableTransacDetails1.getColumnModel().getColumn(34)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			// End Gross Indicator

			// newly added for FRD1.7 by akansha
			jTableTransacDetails1.getColumnModel().getColumn(35)
			.setCellEditor(new GRPUTableCellEmailIDofdeductee());
			jTableTransacDetails1
			.getColumnModel()
			.getColumn(35)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne1",
							selYear_ann1_colour, next_year_ann1_colour,
							formNumber, false, "", false));

			jTableTransacDetails1
			.getColumnModel()
			.getColumn(36)
			.setCellEditor(new GRPUTableCellEditorContactNoofdeductee());
			jTableTransacDetails1
			.getColumnModel()
			.getColumn(36)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne1",
							selYear_ann1_colour, next_year_ann1_colour,
							formNumber, true, "", false));

			jTableTransacDetails1
			.getColumnModel()
			.getColumn(37)
			.setCellEditor(
					new GRPUTableCellEditorAddofDedCountryResidence());
			jTableTransacDetails1
			.getColumnModel()
			.getColumn(37)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne1",
							selYear_ann1_colour, next_year_ann1_colour,
							formNumber, false, "", false));

			jTableTransacDetails1
			.getColumnModel()
			.getColumn(38)
			.setCellEditor(
					new GRPUTableCellEditorTaxIdentificationNumber());
			jTableTransacDetails1
			.getColumnModel()
			.getColumn(38)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne1",
							selYear_ann1_colour, next_year_ann1_colour,
							formNumber, true, "", false));
			// *************************************************
			//RPU 3.1 start
			//Amount of cash withdrawal in excess of Rs. 1 crore as referred to in section 194N
			jTableTransacDetails1.getColumnModel().getColumn(39)
			.setCellEditor(new GRPUTableCellEditorAmtCshWdrawS194N());
			//jTableTransacDetails1.getColumnModel().getColumn(39).setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			jTableTransacDetails1.getColumnModel().getColumn(39)
			.setCellRenderer(new GRPUTableCellRendererForColour("Anne1",
					selYear_ann1_colour, next_year_ann1_colour,
					formNumber, true, "", false));
			//System.out.println("27q inside"+new GRPUTableCellRendererForColour("Anne1",selYear_ann1_colour, next_year_ann1_colour,				formNumber, true, "", false));
			//RPU 3.4
			jTableTransacDetails1.getColumnModel().getColumn(40)
			.setCellEditor(new GRPUTableCellEditorAmtCshWdrawRs20lkhSbcle_a_194N());
			jTableTransacDetails1.getColumnModel().getColumn(40)
			.setCellRenderer(new GRPUTableCellRendererForColour("Anne1",
					selYear_ann1_colour, next_year_ann1_colour,
					formNumber, true, "", false));
			jTableTransacDetails1.getColumnModel().getColumn(41)
			.setCellEditor(new GRPUTableCellEditorAmtCshWdrawRs20lkhSbcle_b_194N());
			jTableTransacDetails1.getColumnModel().getColumn(41)
			.setCellRenderer(new GRPUTableCellRendererForColour("Anne1",
					selYear_ann1_colour, next_year_ann1_colour,
					formNumber, true, "", false));
		
		}

		// End validations For 27Q
		if (formNumber.equals("27EQ")) {
			jTableTransacDetails1.getColumnModel().getColumn(26)
			.setCellEditor(new GRPUTableCellEditorPartyCode());
			jTableTransacDetails1.getColumnModel().getColumn(26)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			// total value of purchase
			jTableTransacDetails1.getColumnModel().getColumn(27)
			.setCellEditor(new GRPUTableCellEditorToatlValuePurchase());
			jTableTransacDetails1.getColumnModel().getColumn(27)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
			// End total value of purchase

			// rate at which tax collected

			jTableTransacDetails1.getColumnModel().getColumn(28)
			.setCellEditor(new GRPUTableCellEditorrateTaxCollected());
			jTableTransacDetails1.getColumnModel().getColumn(28)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
			// End rate at which tax collected

			// Paid by book entry
			jTableTransacDetails1.getColumnModel().getColumn(29)
			.setCellEditor(new GRPUTableCellEditorPartyCode());

			// End Paid by book entry

			// Certificate Number
			jTableTransacDetails1.getColumnModel().getColumn(30)
			.setCellEditor(new GRPUTableCellEditorCertNum());
			jTableTransacDetails1.getColumnModel().getColumn(30)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// End Certificate Number

			/*******************************************************************************************************/
			//Added by sadhana, FRD 2.2
			// Deductee is Non-Resident
			jTableTransacDetails1.getColumnModel().getColumn(31)
			.setCellEditor(new GRPUTableCellEditorDedPermanentRes(this));
			jTableTransacDetails1.getColumnModel().getColumn(31)
			.setCellRenderer(new GRPUTableCellRendererForColour("Anne1",
					selYear_ann1_colour, next_year_ann1_colour,
					formNumber, false, "", false));
			// End Deductee is Non-Resident 

			// Deductee is having Permanent Establishment in India  
			jTableTransacDetails1.getColumnModel().getColumn(32)
			.setCellEditor(new GRPUTableCellEditorDedPermanentResEst(this));
			jTableTransacDetails1.getColumnModel().getColumn(32)
			.setCellRenderer(new GRPUTableCellRendererForColour("Anne1",
					selYear_ann1_colour, next_year_ann1_colour,
					formNumber, false, "", false));
			// End Deductee is having Permanent Establishment in India  
			/*******************************************************************************************************/
			//RPU 3.5 Addition of new column
			jTableTransacDetails1.getColumnModel().getColumn(33)
			.setCellEditor(new GRPUTableCellEditorWhetherPymntisLiable(this));
			jTableTransacDetails1.getColumnModel().getColumn(33)
			.setCellRenderer(new GRPUTableCellRendererForColour("Anne1",
					selYear_ann1_colour, next_year_ann1_colour,
					formNumber, false, "", false));
			
			jTableTransacDetails1.getColumnModel().getColumn(34)
			.setCellEditor(new GRPUTableCellEditorChallanNumber());
			jTableTransacDetails1.getColumnModel().getColumn(34)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			
			//Date of payment of TDS to Central Government 
			jTableTransacDetails1.getColumnModel().getColumn(35)
			.setCellEditor(new GRPUTableCellEditorDateofPymntofTDStoCG(mainObject));
			jTableTransacDetails1.getColumnModel().getColumn(35)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			
		}

		jTableTransacDetails1.getTableHeader().setResizingAllowed(true);

		// added to enable tabout to TAN directly after serial no for Regular
		// File ans similar for correction File.
		Action myAct = new AbstractAction() {

			// faizi

			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub

				int row = jTableTransacDetails1.getSelectedRow();
				int col = jTableTransacDetails1.getSelectedColumn();

				if (col == 0) {
					if (valueOfTypeOfStmt.equalsIgnoreCase("Regular")) {
						jTableTransacDetails1.changeSelection(row, 4, false,
								false);
						jTableTransacDetails1.editCellAt(row, 4);
					} else if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
						jTableTransacDetails1.changeSelection(row, 2, false,
								false);
						jTableTransacDetails1.editCellAt(row, 2);
					}
				} else {

					// table to buttons tabout logic
					if (row == jTableTransacDetails1.getRowCount() - 1
							&& col == 24) {
						jTableTransacDetails1.changeSelection(0, 0, false,
								false);
						jTableTransacDetails1.editCellAt(0, 0);
						jButton_crtFile.requestFocus();
						return;
					} else if ((valueOfTypeOfStmt
							.equalsIgnoreCase("Correction")) && col == 2) {
						jTableTransacDetails1.changeSelection(row, 4, false,
								false);
						jTableTransacDetails1.editCellAt(row, 4);

					} else if (GRPU.columnNumberEditable(col + 1)) {
						jTableTransacDetails1.changeSelection(row, col + 1,
								false, false);
						jTableTransacDetails1.editCellAt(row, col + 1);

					} else if (col != 24) {
						jTableTransacDetails1.changeSelection(row, col + 1,
								false, false);
						jTableTransacDetails1.editCellAt(row, col + 1);
					} else {
						jTableTransacDetails1.changeSelection(row + 1, 0,
								false, false);
						jTableTransacDetails1.editCellAt(row, 0);
					}

				}

			}

		};

		jTableTransacDetails1.getInputMap().put(KeyStroke.getKeyStroke("TAB"),
				"none");
		jTableTransacDetails1.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0), "none");
		jTableTransacDetails1.getActionMap().put("text", myAct);
		// end

		/*
		 * TableColumn batchNoCol1 =
		 * jTableTransacDetails1.getColumnModel().getColumn(1);
		 * batchNoCol1.setMaxWidth(0); batchNoCol1.setMinWidth(0);
		 * batchNoCol1.setPreferredWidth(0);
		 */
		// valuesRevsnModeO = (new String[] {
		// ""
		// });
		// valuesRevsnModeR = (new String[] {
		// "A", "D"
		// });
		mthYrQ1 = (new String[] { "" });
		mthYrQ2 = (new String[] { "" });
		mthYrQ3 = (new String[] { "" });
		mthYrQ4 = (new String[] { "" });
		/*
		 * stateName = (new String[] { "--Select--",
		 * "Andaman & Nicobar Islands", "Andhra Pradesh", "Arunachal Pradesh",
		 * "Assam", "Bihar", "Chandigarh", "Chhatishgarh",
		 * "Dadra and Nagar Haveli", "Daman & Diu", "Delhi", "Goa", "Gujarat",
		 * "Haryana", "Himachal Pradesh", "Jammu & Kashmir", "Jharkhand",
		 * "Karnataka", "Kerala", "Lakshwadeep", "Madhya Pradesh",
		 * "Maharashtra", "Manipur", "Meghalaya", "Mizoram", "Nagaland",
		 * "Orissa", "Pondicherry", "Punjab", "Rajasthan", "Sikkim",
		 * "Tamil Nadu", "Tripura", "Uttar Pradesh", "Uttaranchal",
		 * "West Bengal" });
		 */

		/*
		 * updationModeForDed = (new String[] { "--Select--", "ADD", "UPDATE",
		 * "DELETE", "PAN UPDATE" });
		 */
		challanSerForDed = (new String[] { "--Select--", "ADD", "UPDATE",
				"DELETE", "PAN UPDATE" });
		// commented by
		// SecUnderPayMadeDed = (new String[] { "--Select--", "92A", "92B",
		// "92C" });

		// Added By for challan serial number

		/*
		 * System.out.println("total rows in challan is "+ chalnn_getRowCnt);
		 * Object[] chSerialArray = new Object[model.getRowCount()];
		 * 
		 * 
		 * //if(model.getRowCount()-2>0) //{ for (int i = 1; i <=
		 * chalnn_getRowCnt-2; i++) { chSerialArray[i]=i;
		 * challan_serial_number[i]=chSerialArray[i].toString();
		 * System.out.println("element is " + challan_serial_number[i]);
		 * 
		 * }
		 * 
		 * //}
		 * 
		 * 
		 * 
		 * 
		 * challan_serialannex1=jTableTransacDetails1.getColumnModel().getColumn(
		 * 0);
		 */

		// End challan serial number

		// for the Remarks Annexure1

		/*
		 * if (formNumber.equals("24Q") && (selYear_anne2 < 2013 &&
		 * next_year_anne2 < 2014)) remarksForDed = (new String[] {
		 * "--Select--", "A", "B", "C" }); else remarksForDed = (new String[] {
		 * "--Select--", "Amit" });
		 */

		// commented by
		/*
		 * if(formNumber.equals("24Q")) { remarksForDed = (new String[] {
		 * "--Select--", "A", "B", "C" }); }
		 * 
		 * else if (formNumber.equals("26Q")) remarksForDed = (new String[] {
		 * "--Select--", "A", "B", "C", "T", "Y", "S(From F.Y.2012-13 onwards)",
		 * "Z(From F.Y.2013-14 onwards)" }); else if (formNumber.equals("27Q"))
		 * remarksForDed = (new String[] { "--Select--", "A", "B", "C",
		 * "S(From F.Y.2012-13 onwards)" }); else if (formNumber.equals("27EQ"))
		 * remarksForDed = (new String[] { "--Select--", "A", "B" });
		 */

		if (formNumber.equals("26Q") || formNumber.equals("27Q")) {
			ded_code = (new String[] { "--Select--", "01", "02" });
			dedcodeannex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(26); // added for DeducteeCode

			paid_book_entry = (new String[] { "--Select--", "Yes", "No" });
			paidBookEntryAnnex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(28); // paid by book entry or not

		}

		if (formNumber.equals("27Q")) {
			rate_of_tds = (new String[] { "--Select--", "A", "B" });
			rateTdsannex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(30);
			// countrty residence
			country_resd = (new String[] { "--Select--", "AFGHANISTAN",
					"AKROTIRI", "ALBANIA", "ALGERIA", "AMERICAN SAMOA",
					"ANDORRA", "ANGOLA", "ANGUILLA", "ANTARCTICA",
					"ANTIGUA AND BARBUDA", "ARGENTINA", "ARMENIA", "ARUBA",
					"ASHMORE AND CARTIER ISLANDS", "AUSTRALIA", "AUSTRIA",
					"AZERBAIJAN", "BAHRAIN", "BAILIWICK OF GUERNSEY",
					"BAILIWICK OF JERSEY", "BAKER ISLAND", "BANGLADESH",
					"BARBADOS", "BELARUS", "BELGIUM", "BELIZE", "BENIN PORTO",
					"BERMUDA", "BHUTAN", "BOLIVIA", "BOSNIAAND HERZEGOVINA",
					"BOTSWANA", "BOUVET ISLAND", "BRAZIL",
					"BRITISH INDIAN OCEAN TERRITORY", "BRUNEI", "BULGARIA",
					"BURKINA FASO", "BURUNDI", "CAMBODIA", "CAMEROON",
					"CANADA", "CAPE VERDE", "CAYMAN ISLANDS",
					"CENTRAL AFRICAN REPUBLIC", "CHAD", "CHILE", "CHINA",
					"CHRISTMAS ISLAND", "CLIPPERTON ISLAND",
					"COCOS (KEELING) ISLANDS", "COLOMBIA",
					"COMMONWEALTH OF PUERTO RICO",
					"COMMONWEALTH OF THE NORTHERN MARIANA ISLANDS", "COMOROS",
					"CONGO,DEMOCRATIC REPUBLIC OF THE",
					"CONGO,REPUBLIC OF THE", "COOK ISLANDS",
					"CORAL SEA ISLANDS", "CORAL SEA ISLANDS TERRITORY",
					"COSTA RICA", "COTE D'IVOIRE", "CROATIA", "CUBA", "CYPRUS",
					"CZECH REPUBLIC", "DENMARK",
					"DEPARTMENTAL COLLECTIVITY OF MAYOTTE", "DHEKELIA",
					"DJIBOUTI", "DOMINICA", "DOMINICAN REPUBLIC",
					"EAST TIMOR (TIMORLASTE)", "ECUADOR", "EGYPT",
					"ELSALVADOR", "EQUATORIAL GUINEA", "ERITREA", "ESTONIA",
					"ETHIOPIA", "FALKLAND ISLANDS (ISLAS MALVINAS)",
					"FAROE ISLANDS", "FIJI", "FINLAND", "FRANCE",
					"FRENCH GUIANA", "FRENCH POLYNESIA",
					"FRENCH SOUTHERN ISLANDS", "GABON", "GEORGIA", "GERMANY",
					"GEURNSEY", "GHANA", "GIBRALTAR", "GREECE", "GREENLAND",
					"GRENADA", "GUADELOUPE", "GUAM", "GUATEMALA", "GUERNSEY",
					"GUINEA", "GUINEABISSAU", "GUYANA", "HAITI",
					"HEARD ISLAND AND MCDONALD ISLANDS", "HONDURAS",
					"HONG KONG", "HOWLAND ISLAND", "HUNGARY", "ICELAND",
					"INDIA", "INDONESIA", "IRAN", "IRAQ", "IRELAND",
					"ISLE OF MAN", "ISRAEL", "ITALY", "JAMAICA", "JAN MAYEN",
					"JAPAN", "JARVIS ISLAND", "JERSEY", "JOHNSTON ATOLL",
					"JORDAN", "KAZAKHSTAN", "KENYA", "KINGMAN REEF",
					"KIRIBATI", "KOREA, NORTH", "KOREA, SOUTH", "KOSOVO",
					"KUWAIT", "KYRGYZSTAN", "LAOS", "LATVIA", "LEBANON",
					"LESOTHO", "LIBERIA", "LIBYA", "LIECHTENSTEIN",
					"LITHUANIA", "LUXEMBOURG", "MACAU", "MACEDONIA",
					"MADAGASCAR", "MALAWI", "MALAYSIA", "MALAYSIA (LABUAN)",
					"MALDIVES", "MALI", "MALTA", "MARSHALLISLANDS",
					"MARTINIQUE", "MAURITANIA", "MAURITIUS", "MAYOTTE",
					"UNITED MEXICAN STATES", "MICRONESIA, FEDERATED STATES OF",
					"MIDWAY ISLANDS", "MOLDOVA", "MONACO", "MONGOLIA",
					"MONTENEGRO", "MONTSERRAT", "MOROCCO", "MOZAMBIQUE",
					"MYANMAR (BURMA)", "NAMIBIA", "NAURU", "NAVASSA ISLAND",
					"NEPAL", "NETHERLANDS", "NETHERLANDS ANTILLES",
					"NEW CALEDONIA", "NEWZEALAND", "NICARAGUA", "NIGER",
					"NIGERIA", "NIUE", "NORFOLK ISLAND",
					"NORTHERN MARIANA ISLANDS", "NORWAY", "OMAN", "PAKISTAN",
					"PALAU", "PALMYRA ATOLL", "PANAMA", "PAPUA NEW GUINEA",
					"PARACEL ISLANDS", "PARAGUAY", "PERU", "PHILIPPINES",
					"PITCAIRN ISLANDS",
					"PITCAIRN, HENDERSON, DUCIE, AND OENO ISLANDS", "POLAND",
					"PORTUGAL", "PUERTO RICO", "QATAR", "REUNION", "ROMANIA",
					"RUSSIA", "RWANDA", "SAINT BARTHELEMY", "SAINT HELENA",
					"SAINT KITTS AND NEVIS", "SAINT LUCIA", "SAINT MARTIN",
					"SAINT PIERRE AND MIQUELON",
					"SAINT VINCENT AND THE GRENADINES", "SAMOA", "SANMARINO",
					"SAO TOME AND PRINCIPE", "SAUDI ARABIA", "SENEGAL",
					"SERBIA", "SEYCHELLES", "SIERRA LEONE", "SINGAPORE",
					"SLOVAKIA", "SLOVENIA", "SOLOMON ISLANDS", "SOMALIA",
					"SOUTH AFRICA", "SOUTH GEORGIA AND SOUTH SANDWICH ISLANDS",
					"SPRATLY ISLANDS", "SPAIN", "SRI LANKA",
					"ST. VINCENT & GRENADINES", "SUDAN", "SURINAME",
					"SVALBARD", "SWAZILAND", "SWEDEN", "SWITZERLAND", "SYRIA",
					"TAIWAN", "TAJIKISTAN", "TANZANIA",
					"TERRITORIAL COLLECTIVITY OF ST. PIERRE & MIQUELON",
					"TERRITORY OF AMERICAN SAMOA",
					"TERRITORY OF ASHMORE AND CARTIER ISLANDS",
					"TERRITORY OF CHRISTMAS ISLAND",
					"TERRITORY OF COCOS (KEELING) ISLANDS",
					"TERRITORY OF GUAM",
					"TERRITORY OF HEARD ISLAND & MCDONALD ISLANDS",
					"TERRITORY OF NORFOLK ISLAND", "THAILAND", "THE BAHAMAS",
					"THE GAMBIA", "TOGO", "TOKELAU", "TONGA",
					"TRINIDAD AND TOBAGO", "TUNISIA", "TURKEY", "TURKMENISTAN",
					"TURKS AND CAICOS ISLANDS", "TUVALU", "UGANDA", "UKRAINE",
					"UNITED ARAB EMIRATES", "UNITED KINGDOM",
					"UNITED STATES VIRGIN ISLANDS", "UNITED STATES OF AMERICA",
					"URUGUAY", "UZBEKISTAN", "VANUATU",
					"VATICAN CITY (HOLYSEE)", "VENEZUELA", "VIETNAM",
					"VIRGIN ISLANDS, BRITISH", "VIRGIN ISLANDS, U.S.",
					"WAKE ISLAND", "WALLIS AND FUTUNA", "WESTERN SAHARA",
					"YEMEN", "ZAMBIA", "ZIMBABWE", "COMBODIA", "CONGO",
					"IVORY COAST", "WEST INDIES", "BRITISH VIRGIN ISLANDS" });

			country_resdannex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(33);
			// Nature Remtance

			// Newly added for Development as on 01/04/2015 11, 27, 37, 63, 64,
			// 21, 49, 16, 28, 31, 52 & 99
			nature_remit = (new String[] {
					"--Select--",
					// "COMMISSION", // new development for FRD1.3 by Akansha
					"INTEREST PAYMENT",
					// "PAYMENTS TO SPORTS PERSON & ARTISTS", //new development
					// for FRD1.3 by Akansha
					// "WINNING FROM HORSE RACES.", // new development for
					// FRD1.3 by Akansha
					// "WINNING FROM LOTTERIES, CROSSWORD PUZZLES, CARD GAMES AND OTHER GAMES OF ANY SORT.",
					// //new development for FRD1.3 by Akansha
					"FEES FOR TECHNICAL SERVICES/ FEES FOR INCLUDED SERVICES",
					"ROYALTY", "DIVIDEND", "INVESTMENT INCOME",
					"LONG TERM CAPITAL GAINS", "SHORT TERM CAPITAL GAINS",
			"OTHER INCOME / OTHER (NOT IN THE NATURE OF INCOME)" });
			// **************************************************************************
			// Commented as on 15/04/2015 by Akansha
			/*
			 * nature_remit = (new String[] { "--Select--", "ADVERTISEMENT FEE",
			 * "AMC CHARGES", "ARCHITECTURAL SERVICES", "BANDWIDTH CHARGES",
			 * "BROKEREAGE CHARGES",
			 * "BUSINESS INCOME OTHER THAN THAT COVERED BY CATEGORIES ABOVE",
			 * "CARGO HANDLING SERVICES INSPECTION & LOGISTICS SERVICES",
			 * "CELLULAR ROAMING CHARGES", "CHARTER HIRE CHARGES (SHIPPING)",
			 * "CLEARING & FORWARDING CHARGES", "COMMISSION",
			 * "COMMUNICATION CHARGES", "CONSULTING SERVICES", "DESIGNING FEE",
			 * "DIRECTORS FEES", "DIVIDEND", "DRILLING", "ENGINEERING SERVICES",
			 * "EQUIPMENT RENTAL CHARGES", "FABRICATION SERVICES",
			 * "FEES FOR TECHNICAL SERVICES/ FEES FOR INCLUDED SERVICES",
			 * "FREIGHT CHARGES", "INCOME FROM IMMOVEABLE PROPERTY",
			 * "INCOME FROM SHIPPING, INLAND WATERWAYS OR AIR TRANSPORT",
			 * "INSTALLATION & COMMISSIONING SERVICES", "INSURANCE COMMISSIONS",
			 * "INTEREST PAYMENT", "INVESTMENT INCOME", "LEASE PAYMENT",
			 * "LICENSING FEE", "LONG TERM CAPITAL GAINS", "MEMBERSHIP FEE",
			 * "MOBILESTATION CHARGES",
			 * "PAYMENTS FOR SOFTWARE BUNDLED WITH HARDWARE",
			 * "PAYMENTS FOR SOFTWARE BUNDLED WITH HARDWARE",
			 * "PAYMENTS TO PROFESSORS, TEACHERS OR RESEARCH SCHOLARS",
			 * "PAYMENTS TO SPORTS PERSON & ARTISTS",
			 * "PAYMENTS TO STUDENTS OR BUSINESS APPRENTICE",
			 * "PENSIONS(OTHER THAN THOSE RELATED TO PAST EMPLOYMENT)",
			 * "PROCESSING CHARGES", "PROFESSIONAL SERVICES",
			 * "PURCHASE OF SOFTWARE", "R&D CHARGES", "REGISTRATION CHARGES",
			 * "REIMBURSEMENT OF EXPENSES", "REPATRIATION OF SURPLUS FUNDS",
			 * "RETAINERSHIP FEES", "RETENTION FEES", "ROYALTY",
			 * "SALES AND MARKETING SERVICES", "SEISMIC DATA PROCESSING",
			 * "SHORT TERM CAPITAL GAINS", "SOFTWARE LICENCES",
			 * "SPONSORSHIP FEES", "SUBSCRIPTION FEES", "SUPERVISION CHARGES",
			 * "SURVEY FEES", "TELECASTING SERVICES", "TENDER FEES",
			 * "TESTING CHARGES", "TRAINING", "WARRANTY SERVICES",
			 * "WINNING FROM HORSE RACES.",
			 * "WINNING FROM LOTTERIES, CROSSWORD PUZZLES, CARD GAMES AND OTHER GAMES OF ANY SORT."
			 * , "CONSULAR RECEIPTS",
			 * "OTHER INCOME / OTHER (NOT IN THE NATURE OF INCOME)" });
			 */
			nature_remitsannex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(31);

			// EndNature Remtance
			// grossing up indicator
			gross_up_indicator = (new String[] { "--Select--", "Yes", "No" });
			grossupindicatorAnnex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(34);

			// End grodding up indicator

		}
		// End for the Remarks Annexure1

		if (formNumber.equals("27EQ")) { // For party code
			party_code = (new String[] { "--Select--", "1", "2" });
			partycoderesdannex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(26);

			// paid by book entry
			book_entry_27EQ = (new String[] { "--Select--", "Yes", "No" });
			bookentry27EQdannex1 = jTableTransacDetails1.getColumnModel()
					.getColumn(29);

			/*******************************************************************************************/
			//Added by Sadhana, FRD 2.2
			dedIsPermanentResidentList = (new String[] { "--Select--", "Yes", "No" });
			DedIsPermanentResident = jTableTransacDetails1.getColumnModel().getColumn(31);

			dedIsPermanentResidentEstList = (new String[] { "--Select--", "Yes", "No" });
			DedIsPermanentResidentEst = jTableTransacDetails1.getColumnModel().getColumn(32);
			/*******************************************************************************************/
				//begin from here
			//RPU 3.5 column 34
			
			WhetherpymntisliableList = (new String[] { "--Select--", "Yes", "No" });
			Whetherpymntisliable = jTableTransacDetails1.getColumnModel().getColumn(33);
			
		}

		revModeArray = (new String[] { "--Select--", "Delete", "Update" });
		int vColIndex1 = 1;
		// dedMode =
		// jTableTransacDetails1.getColumnModel().getColumn(vColIndex1);
		int vColIndex5 = 5;
		dedSecUnderPayMade = jTableTransacDetails1.getColumnModel().getColumn(
				vColIndex5);

		jTableTransacDetails1.setSelectionMode(1);

		ddoMappingModes = new String[] { "--Select--", "Add", "Update",
		"Delete" };

		Action testAction = new AbstractAction("testAction") {
			public void actionPerformed(ActionEvent evt) {
				System.out.println("Action disabled in annexure 1");
				System.out.println("calling paste method");
				pasteXL(tabname);
			}
		};
		KeyStroke ks = KeyStroke.getKeyStroke("control V");
		jTableTransacDetails1.getActionMap().put("testAction", testAction);
		jTableTransacDetails1.getInputMap(
				JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(ks,
						"testAction");
		jTableTransacDetails1.addMouseListener(new MouseAdapter() {


			public void mousePressed(MouseEvent evt) {
				int col_Sel = jTableTransacDetails1.columnAtPoint(evt
						.getPoint());
				int row_Sel = jTableTransacDetails1.rowAtPoint(evt.getPoint());
			}

			public void mouseReleased(MouseEvent evt) {
				selRow = returnRow();
				selCol = returnColumn();

				/*
				 * if(jComboBox_TypeOfCorrection.getSelectedItem().toString().
				 * equalsIgnoreCase ("Cancel")) {
				 * 
				 * if(selCol == 2 && selRow < numDdoRowsCorr) {
				 * getMessage("kerjflkrdjrlkdjlk"); } }
				 */

				boolean isPointInside = false;
				int sel_rowCnt = jTableTransacDetails1.getSelectedRowCount();
				int sel_colCnt = jTableTransacDetails1.getSelectedColumnCount();
				int col_Sel = jTableTransacDetails1.columnAtPoint(evt
						.getPoint());
				int row_Sel = jTableTransacDetails1.rowAtPoint(evt.getPoint());
				// System.out.println("selected Row count = " + sel_rowCnt
				// + "selected Column count = " + sel_colCnt
				// + "numberDdo = " + numDdoRowsCorr);
				for (int i = 0; i < sel_rowCnt; i++) {
					for (int j = 0; j < sel_colCnt; j++) {
						if (selRow + i != row_Sel || selCol + j != col_Sel)
							continue;
						isPointInside = true;
						break;
					}

				}

				if (evt.isPopupTrigger()) {
					if (col_Sel == 2 || col_Sel == 3
							|| columnNumberEditable(col_Sel) || col_Sel >= 25)
						return;

					Object tan = "";
					String tanValue = "";
					if (row_Sel < numDdoRowsCorr) {
						Object[] transObject = (Object[]) saveDDOVector
								.get(row_Sel);
						tanValue = transObject[6].toString();
						System.out.println(tanValue + " Tan Value");

					}
					if (valueOfTypeOfStmt.equalsIgnoreCase("Regular")) {
						item1.setEnabled(true);
						item3.setEnabled(true);
						item4.setEnabled(true);
						item6.setEnabled(true);

					} else if (row_Sel < numDdoRowsCorr
							&& !model1.getValueAt(row_Sel, 2).toString()
							.equalsIgnoreCase("Update")) {

						// System.out.println("HERE ONLy3");
						item1.setEnabled(false);
						item3.setEnabled(false);
						item4.setEnabled(false);
						item6.setEnabled(false);

					} else {
						item1.setEnabled(true);
						item3.setEnabled(true);
						item4.setEnabled(true);
						item6.setEnabled(true);
					}

					menu.show(jTableTransacDetails1.getComponentAt(evt
							.getPoint()), evt.getX(), evt.getY());
					if (col_Sel >= 0 && row_Sel >= 0 && !isPointInside) {
						// jTableTransacDetails1.changeSelection(row_Sel,
						// col_Sel, false, false);
						// jTableTransacDetails1.getComponentAt(evt.getPoint()).repaint();
					}
				}

			}

			public void mouseClicked(MouseEvent e) {
				System.out.println("Inside Mouse Clicked annexure 1");
				if (jTableTransacDetails1.getSelectedColumn() != 0) {
					jTableTransacDetails1.setRowSelectionAllowed(false);
					jTableTransacDetails1.setCellSelectionEnabled(true);
					jTableTransacDetails1.repaint();

					// ## Newly developed for correction Ver1.2 by Akansha
					int row = jTableTransacDetails1.getSelectedRow();
					int column = jTableTransacDetails1.getSelectedColumn() + 1;
					String mode = model1.getValueAt(row, 2).toString();
					if ("UPDATE".equals(mode)) {
						System.out.println("Inside Update");
						if ("C".equals(model1.getValueAt(row, 26).toString())) {

							if ("24Q".equals(grpu.formNumber)) {
								if (column == 18 || column == 19
										|| column == 20 || column == 26) { // $$
									// Removed
									// col
									// 15,6,25,17,27
									// for
									// new
									// development
									// RPU
									// Java
									// Ver1.2
									JOptionPane
									.showMessageDialog(
											null,
											"<html>For tax deducted/collected at higher rate, update is not allowed <br>for TDS, Surcharge, Education Cess and Remarks.</html>");
								}

							} else if ("26Q".equals(grpu.formNumber)) { // $$
								// Removed
								// col
								// 15,6,25,17,30
								// for
								// new
								// development
								// RPU
								// Java
								// Ver1.2
								if (column == 18 || column == 19
										|| column == 20 || column == 26
										|| column == 28 || column == 27
										|| column == 29) {
									JOptionPane
									.showMessageDialog(
											null,
											"<html>For tax deducted/collected at higher rate, update is not allowed <br>for TDS, Surcharge, Education Cess and Remarks.</html>");
								}

							} else if ("27Q".equals(grpu.formNumber)) { // $$
								// Removed
								// col
								// 15,6,32,33,34,35,25,17,30
								// for
								// new
								// development
								// RPU
								// Java
								// Ver1.2
								if (column == 18 || column == 19
										|| column == 20 || column == 26
										|| column == 28 || column == 27
										|| column == 29

										) {
									if (grpu.JComboBox_Form_Sub1_finYear
											.getSelectedItem() != null
											&& !"--Select--"
											.equals(grpu.JComboBox_Form_Sub1_finYear
													.getSelectedItem()
													.toString())
													&& Integer
													.parseInt(grpu.JComboBox_Form_Sub1_finYear
															.getSelectedItem()
															.toString()
															.substring(0, 4)) >= 2013
															&& column == 26) {
										JOptionPane
										.showMessageDialog(null,
												"Update is not allowed for this field");

									} else {
										if (grpu.JComboBox_Form_Sub1_finYear
												.getSelectedItem() != null
												&& !"--Select--"
												.equals(grpu.JComboBox_Form_Sub1_finYear
														.getSelectedItem()
														.toString())
														&& Integer
														.parseInt(grpu.JComboBox_Form_Sub1_finYear
																.getSelectedItem()
																.toString()
																.substring(0, 4)) < 2013)
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For tax deducted/collected at higher rate, update is not allowed <br>for TDS, Surcharge, Education Cess and Remarks.</html>");
									}
								}
							} else if ("27EQ".equals(grpu.formNumber)) { // $$
								// Removed
								// col
								// 15,6,25,17,31
								// for
								// new
								// development
								// RPU
								// Java
								// Ver1.2
								if (column == 18 || column == 19
										|| column == 20 || column == 26
										|| column == 28 || column == 27
										|| column == 29 || column == 30) {
									JOptionPane
									.showMessageDialog(
											null,
											"<html>For tax deducted/collected at higher rate, update is not allowed <br>for TDS, Surcharge, Education Cess and Remarks.</html>");
								}

							}
						}
System.out.println("strAnnexIColValue"+ strAnnexIColValue.charAt(row - 2));
						//new development for newly appended value "F", FRD1.9 on 02/02/17
						if(strAnnexIColValue.charAt(row - 2) == 'F'){
							if (column == 6){
								JOptionPane.showMessageDialog(null,
										"Correction in field is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 14){
								JOptionPane.showMessageDialog(null,
										"Update in PAN of deductee is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 17){
								JOptionPane.showMessageDialog(null,
										"Update in this field is not allowed and the same will be rejected at TRACEs as 26A has been submitted for this PAN");
							}
							if (column == 18){
								JOptionPane.showMessageDialog(null,
										"Correction in field TDS is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 19){
								JOptionPane.showMessageDialog(null,
										"Correction in field Surcharge is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 20){
								JOptionPane.showMessageDialog(null,
										"Correction in field Cess is not allowed as 26A has been submitted for this PAN");
							}
						}

						if (column == 14) {

							if (pan_Updtn_Indicator.get(row - 2) > 1) {

								JOptionPane
								.showMessageDialog(
										null,
										"<html>Further update of PAN for the deductee record is not allowed. <br>Update of deductee PAN (valid to valid) is allowed only once.</html>");
							}
						}

						/*********************************************************************************************/
						//added by sadhana, FRD 2.2
						if ("27EQ".equals(grpu.formNumber)) {
							if(column == 33){
								if("No".equals(model1.getValueAt(row, 32).toString()) || "--Select--".equals(model1.getValueAt(row, 32).toString())){
									JOptionPane.showMessageDialog(null,"<html>This field is applicable only when <br>Yes present under ''Deductee is Non-Resident''.</html>");

								}
							}	
							//RPU 3.5
							if(column == 34){
								if(Integer.parseInt(grpu.JComboBox_Form_Sub1_finYear
																.getSelectedItem().toString().substring(0, 4)) > 2020 ||
										((jComboBox_Quarter.getSelectedItem().equals("Q4") || jComboBox_Quarter.getSelectedItem().equals("Q3")) 
												&& Integer.parseInt(grpu.JComboBox_Form_Sub1_finYear
																.getSelectedItem().toString().substring(0, 4)) == 2020))
								 if(!("F".equals(model1.getValueAt(row, 26).toString()) || "G".equals(model1.getValueAt(row, 26).toString()))){
									 model1.setValueAt("--Select--",row,34);
									 JOptionPane.showMessageDialog(null,"<html>This field is applicable only when <br> F or G is selected in 680.</html>");

								}
							}
							if(column == 35 ||column == 36){
								if("No".equals(model1.getValueAt(row, 34).toString()) || "--Select--".equals(model1.getValueAt(row, 34).toString())){
									model1.setValueAt("",row,35);
									model1.setValueAt("",row,36);
									JOptionPane.showMessageDialog(null,"<html>This field is applicable only when <br>Yes present under ''Whether the payment by collectee is liable to TDS as per clause (a)  <br>of the fifth provison to sub-section (1G) or second provison to sub-section (1H) <br> and whether TDS has been deducted from such payment''.</html>");

								}
							}
						}

						/*********************************************************************************************/
					} else if ("PAN UPDATE".equals(mode)) {
						if (column == 14) {
							if (pan_Updtn_Indicator.get(row - 2) > 1) {
								JOptionPane
								.showMessageDialog(
										null,
										"<html>Further update of PAN for the deductee record is not allowed. <br>Update of deductee PAN (valid to valid) is allowed only once.</html>");
							}
						}

						//new development for newly appended value "F", FRD1.9 on 02/02/17
						if(strAnnexIColValue.charAt(row - 2) == 'F'){
							if (column == 6){
								JOptionPane.showMessageDialog(null,
										"Correction in field is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 14){
								JOptionPane.showMessageDialog(null,
										"Update in PAN of deductee is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 17){
								JOptionPane.showMessageDialog(null,
										"Update in this field is not allowed and the same will be rejected at TRACEs as 26A has been submitted for this PAN");
							}
							if (column == 18){
								JOptionPane.showMessageDialog(null,
										"Correction in field TDS is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 19){
								JOptionPane.showMessageDialog(null,
										"Correction in field Surcharge is not allowed as 26A has been submitted for this PAN");
							}
							if (column == 20){
								JOptionPane.showMessageDialog(null,
										"Correction in field Cess is not allowed as 26A has been submitted for this PAN");
							}
						}
					}

					/*********************************************************************************************/
					//added by sadhana, FRD 2.2
						if(valueOfTypeOfStmt.equals("Regular") || (valueOfTypeOfStmt.equals("Correction") &&
							((row >= row_count_annex1) || "ADD".equals(model1.getValueAt(row, 2).toString())))){
						if ("27EQ".equals(grpu.formNumber)) {
							if(column == 33){
								if("No".equals(model1.getValueAt(row, 32).toString()) || "--Select--".equals(model1.getValueAt(row, 32).toString())){
									JOptionPane.showMessageDialog(null,"<html>This field is applicable only when <br>Yes present under ''Deductee is Non-Resident''.</html>");

								}
							}	
							//RPU 3.5
							if(column == 34){
								if(!("F".equals(model1.getValueAt(row, 26).toString()) || "G".equals(model1.getValueAt(row, 26).toString()))){
									System.out.println("Error should be thrown for column 34");
									model1.setValueAt("--Select--",row,34);
									JOptionPane.showMessageDialog(null,"<html>This field is applicable only when <br> F or G is selected in 680.</html>");

								}
							}
							if(column == 35 ||column == 36){
								if("No".equals(model1.getValueAt(row, 34).toString()) || "--Select--".equals(model1.getValueAt(row, 34).toString())){
									System.out.println("Error should be thrown for column 35,36");
									model1.setValueAt("",row,35);
									model1.setValueAt("",row,36);
									JOptionPane.showMessageDialog(null,"<html>This field is applicable only when <br>Yes present under ''Whether the payment by collectee is liable to TDS as per clause (a) <br> of the fifth provison to sub-section (1G) or second provison to sub-section (1H)  <br>and whether TDS has been deducted from such payment''.</html>");

								}
							}

						}
					}
					/*********************************************************************************************/
					// ***************************************************************************
				} else {
					jTableTransacDetails1.setCellSelectionEnabled(false);
					jTableTransacDetails1.setRowSelectionAllowed(true);
					rowIsSelected = true;
					jTableTransacDetails1.repaint();
				}
			}

		});
		jTableTransacDetails1.addKeyListener(new KeyAdapter() {

			public void keyPressed(KeyEvent e) {

				int col = jTableTransacDetails1.getSelectedColumn();
				int row = jTableTransacDetails1.getSelectedRow();
				afterkeypressed = true;

				// System.out.println("Column Number: "+jTableTransacDetails1.getSelectedColumn()
				// );

				if (jTableTransacDetails1.getSelectedColumn() > 0
						&& (e.getKeyChar() >= ' ' && e.getKeyChar() < '\177' || e
						.getKeyChar() == '\b'))
					// model1.setValueAt("",
					// jTableTransacDetails1.getSelectedRow(),
					// jTableTransacDetails1.getSelectedColumn());
					if (e.isControlDown()) {
						if (e.getKeyCode() == 67)
							copy();
						else if (e.getKeyCode() == 86)
							paste();
						else if (e.getKeyCode() == 88)
							cut();
						else if (e.getKeyCode() == 32)
							pasteXL(tabname);
						else if (e.getKeyCode() == 70 || e.getKeyCode() == 82)
							if (e.getKeyCode() == 70) {
								FindReplace.mouse_whichTab = "F";
								FindReplace.isFindClk = true;
							} else if (e.getKeyCode() == 82)
								FindReplace.mouse_whichTab = "R";
							else if (GRPU.grpuFindReplace == null)
								GRPU.grpuFindReplace = new FindReplace(model1,
										jTableTransacDetails1, numDdoRowsCorr,
										grpu, "Anne1");

					} else if (e.getKeyCode() == 127)
						deleteCell();

			}

		});

		/*
		 * if(rows_able==false) //to disable {
		 * System.out.println("disable ho gya");
		 * model1.removeTableModelListener(jTableTransacDetails1); }
		 */

	}

	private void addStaticAnnIRows(DefaultTableModel model12) {

		Vector<Object> row = new Vector<Object>();
		// newRow for annI added by priyanka
		if (formNumber.equals("24Q")) {
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 1
			row.add("<html><tr><td align='center'></td></tr></html>");// 2
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 3

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(325)</html>");// 4

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 5

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(317)</html>");// 6

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 7

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 8

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 9

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 10

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(313)</html>");// 11

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(314)</html>");// 12

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 13

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(315)</html>");// 14

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(316)</html>");// 15

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(318)</html>");// 16
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(320)</html>");// 17
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(321)</html>");// 18
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 19
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(322)</html>");// 20

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(323)</html>");// 21

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 22
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(324)</html>");// 23
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 24
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(319)</html>");// 25
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(326)</html>");// 26
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(327)</html>");// 27
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 28
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 29
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 30
		}

		if (formNumber.equals("26Q")) {
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 1
			row.add("<html><tr><td align='center'></td></tr></html>");// 2
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 3

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 4

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 5

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(417)</html>");// 6

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 7

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 8

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 9

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 10

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(412)</html>");// 11

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(413)</html>");// 12

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 13

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(415)</html>");// 14

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(416)</html>");// 15

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(418)</html>");// 16
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419)</html>");// 17
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 18
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 19
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 20

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(420)</html>");// 21

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 22
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(421)</html>");// 23
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 24
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(422)</html>");// 25
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(424)</html>");// 26
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(414)</html>");// 27
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(423)</html>");// 28
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 29
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(425)</html>");// 30
			//RPU 3.1 start
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419A)</html>");// 31
			//RPu 3.4
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419B)</html>");// 32
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(419C)</html>");// 33
		}

		if (formNumber.equals("27Q")) {
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(701)</html>");// 1
			row.add("<html><tr><td align='center'></td></tr></html>");// 2
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 3

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 4

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 5

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(719)</html>");// 6

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 7

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 8

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 9

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 10

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(714)</html>");// 11

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(715)</html>");// 12

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 13

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(717)</html>");// 14

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(718)</html>");// 15

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(720)</html>");// 16
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(721)</html>");// 17
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(722)</html>");// 18
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(723)</html>");// 19
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(724)</html>");// 20

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(725)</html>");// 21

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 22
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(726)</html>");// 23
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 24
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(727)</html>");// 25
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(729)</html>");// 26
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(716)</html>");// 27
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(728)</html>");// 28
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 29
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(730)</html>");// 30

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(731)</html>");// 31
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(732)</html>");// 32
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(733)</html>");// 33
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(734)</html>");// 34
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 35

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(735)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(736)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(737)</html>");
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(738)</html>");
			//RPU 3.1 start
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(721A)</html>");// 40
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(720B)</html>");// 41
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(720C)</html>");// 42
			
		}

		if (formNumber.equals("27EQ")) {
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 1
			row.add("<html><tr><td align='center'></td></tr></html>");// 2
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 3

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 4

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 5

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(672)</html>");// 6

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 7

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 8

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 9

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 10

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(664)</html>");// 11

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(665)</html>");// 12

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 13

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(667)</html>");// 14

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(668)</html>");// 15

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(671)</html>");// 16
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(670)</html>");// 17
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(673)</html>");// 18
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(674)</html>");// 19
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(675)</html>");// 20

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(676)</html>");// 21

			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 22
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(677)</html>");// 23
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 24
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(678)</html>");// 25
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(680)</html>");// 26
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(666)</html>");// 27
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(669)</html>");// 28
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(679)</html>");// 29
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(671)</html>");// 30
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(681)</html>");// 31
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 32
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");// 33
			//RPU 3.5 Addition of new columns 3
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(618A)</html>");// 34
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(618B)</html>");// 35
			row.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(618C)</html>");// 36
			
			/****************************************************************************************/
		}

		// model2.addRow(row);
		// model1.addRow(row);
		model12.addRow(row);

		Vector<Object> row1 = new Vector<Object>();
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;1</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;6</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;7</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;8</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;11</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;12</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;13</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;14</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;15</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;16</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;17</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;18</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;19</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;21</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;22</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;23</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;24</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;25</html>");
		row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;26</html>");

		if (formNumber.equals("24Q"))
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27</html>");

		if (formNumber.equals("26Q")) {
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;28</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;29</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;30</html>");
			//RPU 3.1 start
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;31</html>");
			//RPu 3.4 static column
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;32</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;33</html>");
		}

		if (formNumber.equals("27Q")) {
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;28</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;29</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;30</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;31</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;32</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;33</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;34</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;35</html>");

			// newly added for FRD1.7 by akansha
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;36</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;37</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;38</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;39</html>");
			// ******************************************************
			//RPU 3.1 start
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;40</html>");
			//RPu 3.4 static column
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;41</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;42</html>");
		}
		if (formNumber.equals("27EQ")) {
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;28</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;29</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;30</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;31</html>");

			/****************************************************************************************/
			//Added by Sadhana, FRD 2.2
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;32</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;33</html>");
			//RPu 3.5 static column
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;34</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;35</html>");
			row1.add("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;36</html>");
			
			/****************************************************************************************/

		}
		model12.addRow(row1);

	}

	private void initializeAnne2Tab() {
		System.out.println("initialization");
		ddoTabFlag = true;
		final String tabname = "Anne2";
		if (model2 == null) {
			model2 = new DefaultTableModel() {
				public boolean isCellEditable(int rowIndex, int mColIndex) {
					// enabling disabling on the basis of Financial Years
					if (valueOfTypeOfStmt.equals("Regular")) {
						// Added For the updation mode for challan
						if (mColIndex == 2) // abling the updation mode by
							// cholia
							return false;
					}
					if (rowIndex == 0 || rowIndex == 1) {
						setBackground(Color.gray.brighter());
						setForeground(Color.black.darker());
						return false;
					}
					if (valueOfTypeOfStmt.equals("Regular")
							|| (valueOfTypeOfStmt.equals("Correction") && (rowIndex >= row_count_annex2))) {
						// model2.setValueAt("0.00",rowIndex,17); //to set the
						// default value as 0.00 for column 17

						if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
							int selYear_anne2 = Integer
									.parseInt(JComboBox_Form_Sub1_finYear
											.getSelectedItem().toString()
											.substring(0, 4));
							int next_year_anne2 = Integer
									.parseInt(JComboBox_Form_Sub1_finYear
											.getSelectedItem().toString()
											.substring(5, 9));

							if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
									&& mColIndex == 8)// disabling Reported
								// taxable
								// amount
								return false;

							if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
									&& mColIndex == 9)// disabling Reported tax
								return false;
							if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
									&& mColIndex == 10)// disabling Total amount
								// of
								// salary
								return false;
							// Added by Akansha
							if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
									&& mColIndex == 10)// disabling Total amount
								// of
								// salary
								return true;
							// **************************************************

							if (!((selYear_anne2 == 2010 && next_year_anne2 == 2011) || (selYear_anne2 == 2011 && next_year_anne2 == 2012))
									&& mColIndex == 18)// disabling amnt
								// deductible
								// 80CCF Fy othet than
								// 2010-2011 ||2011-2012
							{
								return false;
							}

							// newly changed by cholia
							if ((selYear_anne2 < 2012 && next_year_anne2 < 2013)
									&& mColIndex == 19)// disabling amnt
								// deductible
								// Under Section 80CCG
							{
								return false;
							}

							if (!(selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
									&& (mColIndex == 28 || mColIndex == 29 || mColIndex == 32))// disabling
								// column
								// 28
								// and
								// column
								// 29
								// for
								// annexure2
							{
								return false;
							}

							if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
									&& (mColIndex == 30))// disabling column 30
								// (sum
								// of 28 + 29)for
								// annexure2
							{
								return false;
							}

							// newly added for FRD1.6 by akansha

							if (mColIndex == 33)
								if (selYear_anne2 >= 2016
								&& next_year_anne2 >= 2017)
									return true;
								else
									return false;

							if (mColIndex == 34 || mColIndex == 35
									|| mColIndex == 36 || mColIndex == 37
									|| mColIndex == 38 || mColIndex == 39
									|| mColIndex == 40 || mColIndex == 41) {

								if (grpu.model2 != null
										&& grpu.model2.getValueAt(rowIndex, 33) != null
										&& "Yes".equals(grpu.model2.getValueAt(
												rowIndex, 33).toString())
												&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
									return true;
								else
									return false;
							}

							if (mColIndex == 42)
								if (selYear_anne2 >= 2016
								&& next_year_anne2 >= 2017)
									return true;
								else
									return false;

							if (mColIndex == 43 || mColIndex == 44
									|| mColIndex == 45 || mColIndex == 46
									|| mColIndex == 47 || mColIndex == 48
									|| mColIndex == 49 || mColIndex == 50) {

								if (grpu.model2 != null
										&& grpu.model2.getValueAt(rowIndex, 42) != null
										&& "Yes".equals(grpu.model2.getValueAt(
												rowIndex, 42).toString())
												&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
									return true;
								else
									return false;
							}

							// ******************************************

							// newly added for revised FRd1.6 by akansha
							if (mColIndex == 51)
								if (selYear_anne2 >= 2013
								&& next_year_anne2 >= 2014)
									return true;
								else
									return false;

							if (mColIndex == 52 || mColIndex == 53
									|| mColIndex == 54 || mColIndex == 55
									|| mColIndex == 56 || mColIndex == 57) {
								{

									if (grpu.model2 != null
											&& grpu.model2.getValueAt(rowIndex,
													51) != null
													&& "Yes".equals(grpu.model2
															.getValueAt(rowIndex, 51)
															.toString())
															&& (selYear_anne2 >= 2013 && next_year_anne2 >= 2014))
										return true;
									else
										return false;

								}
							}
							// *******************************************

							/*********************************************************/				
							//FRD 2.3 added 16(ia)		

							if ((selYear_anne2 < 2018 && next_year_anne2 < 2019)
									&& mColIndex == 13){
								return false;
							}
							//RPU flaw solve, as col 14, 16, 21, 22, 27, 31 was in editable mode, it should be Non-updatable, commented else part to disebled these fields
							/*else{
								return true;
							}*/

							/*********************************************************/

							/****************** Added for mColIndex Start ********************/
							if ((selYear_anne2 < 2018 && next_year_anne2 < 2019)
									&& (mColIndex == 59
									|| mColIndex == 60
									|| mColIndex == 61
									|| mColIndex == 62
									|| mColIndex == 63
									|| mColIndex == 64
									|| mColIndex == 65
									|| mColIndex == 66
									|| mColIndex == 67									
									|| mColIndex == 69
									|| mColIndex == 70
									|| mColIndex == 71
									|| mColIndex == 72
									|| mColIndex == 73
									|| mColIndex == 74
									|| mColIndex == 75
									|| mColIndex == 76
									|| mColIndex == 77
									|| mColIndex == 78
									|| mColIndex == 79
									|| mColIndex == 80
									|| mColIndex == 81
									|| mColIndex == 82
									|| mColIndex == 83
									|| mColIndex == 84
									|| mColIndex == 85
									|| mColIndex == 86
									|| mColIndex == 87
									|| mColIndex == 88
									|| mColIndex == 89
									|| mColIndex == 90
									|| mColIndex == 91
									|| mColIndex == 92)){
								return false;
							}

							if (mColIndex == 68) // for total amt exemption
							{
								return false;
							}

							if ((selYear_anne2 > 2017 && next_year_anne2 > 2018)
									&& (mColIndex == 17 || mColIndex == 8))
								return false;
							/***************** Added for 2.7 End  ********************/
							if (mColIndex == 93 &&(selYear_anne2 < 2020 && next_year_anne2 < 2021 ||
	                                (selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
	                                ( jComboBox_Quarter.getSelectedItem().equals("Q1") || jComboBox_Quarter.getSelectedItem().equals("Q3")||  jComboBox_Quarter.getSelectedItem().equals("Q2"))) ))
	                        {
	                            return false;// RPU 3.6 Changes to disable column when column 93 is present
	                        }
							
							if (mColIndex == 62
									//|| mColIndex == 63 RPU 3.6 Updated requirement to enable 63rd column
									|| mColIndex == 66
									|| mColIndex == 13
									|| mColIndex == 11
									|| mColIndex == 12
									|| mColIndex == 19
									|| mColIndex == 20
								    || mColIndex == 91
								    || mColIndex == 92
								    || mColIndex == 70
								    || mColIndex == 71
								    || mColIndex == 72
								    || mColIndex == 73
								    || mColIndex == 74
								    || mColIndex == 75
								    || mColIndex == 76
								    || mColIndex == 77
								    || mColIndex == 80
								    || mColIndex == 81
								    || mColIndex == 82
								    || mColIndex == 83
								    || mColIndex == 84
								    || mColIndex == 85
								    || mColIndex == 86
								    || mColIndex == 87
								    || mColIndex == 88
								    || mColIndex == 89)
								    																
									{
									

								if (grpu.model2 != null    //RPU 3.6 Changes to disable column when column 93 is present
										&& grpu.model2
										.getValueAt(
												rowIndex,
												93) != null
												&& "Yes".equals(grpu.model2
														.getValueAt(
																rowIndex,
																93)
																.toString())
																&& (selYear_anne2 > 2020 && next_year_anne2 > 2021 ||
									                                    (selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
									                                    (jComboBox_Quarter.getSelectedItem().equals("Q4")))))
									return false;
								else
									return true;
							}
						
						}
											

						
						//FRD 2.3 added 16(ia)	commented || mColIndex == 13
						if (mColIndex == 2 /*|| mColIndex == 13*/
								|| mColIndex == 14 || mColIndex == 16
								|| mColIndex == 21 || mColIndex == 1
								|| mColIndex == 31 || mColIndex == 27
								|| mColIndex == 22 || mColIndex == 58) { // newly
							// added
							// for
							// revised
							// FRD1.6
							// by
							// akansha
							return false;
						}
						
						

						return mColIndex != 0;

					}

					else {// added by cholia for the correction statement

						// newly Added by cholia For the updation mode for
						// challan


						String mode_annex2 = "";
						Object modeObj = model2.getValueAt(rowIndex, 2);
						if (modeObj != null)
							mode_annex2 = modeObj.toString();

						//new development for FRD1.3 by Akansha
						/*if(!"Add".equals(mode_annex2))
						if (mColIndex == 2 && rowIndex > 1) // abling the// updation mode by// cholia
							return true;*/

						if(!"Add".equals(mode_annex2)){
							System.out.println("strAnnexIIColValue.charAt(rowIndex - 2)  "+strAnnexIIColValue.charAt(rowIndex - 2));
							if (mColIndex == 2 && rowIndex > 1){ // abling the// updation mode by// cholia
								/*********************************************/
								//new development for newly appended value "F", FRD1.9 on 18/01/17	
								if (strAnnexIIColValue.charAt(rowIndex - 2) == 'A') {
									return true;
								} else if (strAnnexIIColValue
										.charAt(rowIndex - 2) == 'F' && (formNum.equals("24Q"))) {
									return false;
								}
								/*************************************/
							}
						}/*else{
							return true;
						}*/

						// added by cholia for the enabling disabling of the
						// felds on the basis of the imported rows
						if (rowIndex < row_count_annex2 && jTableTransacDetails2.getSelectedRow() > 1) {

							// new development for newly appended value "F", FRD1.9 on 18/01/17	
							int finYr_AnnxII = Integer.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0, 4));
							if (finYr_AnnxII >= 2007) {
								if (strAnnexIIColValue.charAt(rowIndex - 2) == 'A') {

									if (mode_annex2.equalsIgnoreCase("DELETE")) {
										return false;

									}

									else	if ((jTableTransacDetails2.getSelectedRow() > 1 && (jTableTransacDetails2
											.getSelectedRow() - 2) < pan_Updtn_Indicator_Anne2
											.size())
											&& (pan_Updtn_Indicator_Anne2
													.get(jTableTransacDetails2
															.getSelectedRow() - 2) < 2)
															&& mode_annex2.equals("PAN UPDATE"))// panupdationCounter<2
									{
										if (mColIndex == 3)
											return true;
										else
											return false;

									}

									else if ((jTableTransacDetails2.getSelectedRow() > 1 && (jTableTransacDetails2
											.getSelectedRow() - 2) < pan_Updtn_Indicator_Anne2
											.size())
											&& (pan_Updtn_Indicator_Anne2
													.get(jTableTransacDetails2
															.getSelectedRow() - 2) == 2)
															&& mode_annex2.equals("PAN UPDATE"))// panupdationCounter==2
									{
										return false;
									}
									//new development for FRD1.3 by Akansha
									else if(mode_annex2.equals("Add"))
									{

										if (JComboBox_Form_Sub1_finYear
												.getSelectedIndex() != 0) {
											int selYear_anne2 = Integer
													.parseInt(JComboBox_Form_Sub1_finYear
															.getSelectedItem()
															.toString()
															.substring(0, 4));
											int next_year_anne2 = Integer
													.parseInt(JComboBox_Form_Sub1_finYear
															.getSelectedItem()
															.toString()
															.substring(5, 9));

											if ((selYear_anne2 < 2025 && next_year_anne2 < 2026) //RPU 3.6 Observation 23 fix
													&& mColIndex == 8)// disabling
												// Reported
												// taxable
												// amount
												return false;

											if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
													&& mColIndex == 9)// disabling
												// Reported
												// tax
												return false;
											if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
													&& mColIndex == 10)// disabling
												// Total
												// amount
												// of
												// salary
												return false;
											// Added by Akansha
											if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
													&& mColIndex == 10)// disabling
												// Total
												// amount
												// of
												// salary
												return true;
											// **************************************************

											if (!((selYear_anne2 == 2010 && next_year_anne2 == 2011) || (selYear_anne2 == 2011 && next_year_anne2 == 2012))
													&& mColIndex == 18)// disabling
												// amnt
												// deductible
												// 80CCF Fy othet than
												// 2010-2011 ||2011-2012
											{
												return false;
											}

											// newly changed by cholia
											if ((selYear_anne2 < 2012 && next_year_anne2 < 2013)
													&& mColIndex == 19)// disabling
												// amnt
												// deductible
												// Under Section 80CCG
											{
												return false;
											}

											if (!(selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
													&& (mColIndex == 28
													|| mColIndex == 29 || mColIndex == 32))// disabling
												// column
												// 28
												// and
												// column
												// 29
												// for
												// annexure2
											{
												return false;
											}

											if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
													&& (mColIndex == 30))// disabling
												// column
												// 30
												// (sum
												// of 28 + 29)for
												// annexure2
											{
												return false;
											}

											// newly added for FRD1.6 by akansha
											if (mColIndex == 33
													&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
												return true;

											if (mColIndex == 34
													|| mColIndex == 35
													|| mColIndex == 36
													|| mColIndex == 37
													|| mColIndex == 38
													|| mColIndex == 39
													|| mColIndex == 40
													|| mColIndex == 41) {

												if (grpu.model2 != null
														&& grpu.model2
														.getValueAt(
																rowIndex,
																33) != null
																&& "Yes".equals(grpu.model2
																		.getValueAt(
																				rowIndex,
																				33)
																				.toString())
																				&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
													return true;
												else
													return false;
											}

											if (mColIndex == 42
													&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
												return true;

											if (mColIndex == 43
													|| mColIndex == 44
													|| mColIndex == 45
													|| mColIndex == 46
													|| mColIndex == 47
													|| mColIndex == 48
													|| mColIndex == 49
													|| mColIndex == 50) {

												if (grpu.model2 != null
														&& grpu.model2
														.getValueAt(
																rowIndex,
																42) != null
																&& "Yes".equals(grpu.model2
																		.getValueAt(
																				rowIndex,
																				42)
																				.toString())
																				&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
													return true;
												else
													return false;
											}

											// ******************************************

											// newly added for revised FRd1.6 by
											// akansha
											if (mColIndex == 51
													&& (selYear_anne2 >= 2013 && next_year_anne2 >= 2014))
												return true;

											if (mColIndex == 52
													|| mColIndex == 53
													|| mColIndex == 54
													|| mColIndex == 55
													|| mColIndex == 56
													|| mColIndex == 57) {

												if (grpu.model2 != null
														&& grpu.model2
														.getValueAt(
																rowIndex,
																51) != null
																&& "Yes".equals(grpu.model2
																		.getValueAt(
																				rowIndex,
																				51)
																				.toString())
																				&& (selYear_anne2 >= 2013 && next_year_anne2 >= 2014))
													return true;
												else
													return false;

											}
											
											if (mColIndex == 93 &&(selYear_anne2 < 2020 && next_year_anne2 < 2021 ||
					                                (selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
					                                ( jComboBox_Quarter.getSelectedItem().equals("Q1") || jComboBox_Quarter.getSelectedItem().equals("Q3")||  jComboBox_Quarter.getSelectedItem().equals("Q2"))) ))
					                        {
					                            return false;// RPU 3.6 Changes to disable column when column 93 is present 
					                        }
											
											
											if (mColIndex == 62
													//|| mColIndex == 63 RPU 3.6 Updated requirement to enable 63rd column
													|| mColIndex == 66
													|| mColIndex == 13
													|| mColIndex == 11
													|| mColIndex == 12
												    || mColIndex == 19
												    || mColIndex == 20
											        || mColIndex == 91
											        || mColIndex == 92
											        || mColIndex == 70
											        || mColIndex == 71
											        || mColIndex == 72
											        || mColIndex == 73
											        || mColIndex == 74
											        || mColIndex == 75
											        || mColIndex == 76
											        || mColIndex == 77
											        || mColIndex == 80
											        || mColIndex == 81
											        || mColIndex == 82
											        || mColIndex == 83
											        || mColIndex == 84
											        || mColIndex == 85
											        || mColIndex == 86
											        || mColIndex == 87
											        || mColIndex == 88
											        || mColIndex == 89)
													{
													

												if (grpu.model2 != null    //RPU 3.6 Changes to disable column when column 93 is present
														&& grpu.model2
														.getValueAt(
																rowIndex,
																93) != null
																&& "Yes".equals(grpu.model2
																		.getValueAt(
																				rowIndex,
																				93)
																				.toString())
																				&& (selYear_anne2 > 2020 && next_year_anne2 > 2021 ||
													                                    (selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
													                                    (jComboBox_Quarter.getSelectedItem().equals("Q4")))))
													return false;
												else
													return true;
											}
											// *******************************************

											/*********************************************************/				
											/*//FRD 2.3 added 16(ia)				
											if ((selYear_anne2 < 2018 && next_year_anne2 < 2019)
													&& mColIndex == 13)
												return false;*/
											
											/****************** Added for 2.7 Start ********************/
											
											if ((selYear_anne2 < 2018 && next_year_anne2 < 2019)
													&& (mColIndex == 13 
													|| mColIndex == 59
													|| mColIndex == 60
													|| mColIndex == 61
													|| mColIndex == 62
													|| mColIndex == 63
													|| mColIndex == 64
													|| mColIndex == 65
													|| mColIndex == 66
													|| mColIndex == 67
													|| mColIndex == 68
													|| mColIndex == 69
													|| mColIndex == 70
													|| mColIndex == 71
													|| mColIndex == 72
													|| mColIndex == 73
													|| mColIndex == 74
													|| mColIndex == 75
													|| mColIndex == 76
													|| mColIndex == 77
													|| mColIndex == 78
													|| mColIndex == 79
													|| mColIndex == 80
													|| mColIndex == 81
													|| mColIndex == 82
													|| mColIndex == 83
													|| mColIndex == 84
													|| mColIndex == 85
													|| mColIndex == 86
													|| mColIndex == 87
													|| mColIndex == 88
													|| mColIndex == 89
													|| mColIndex == 90
													|| mColIndex == 91
													|| mColIndex == 92))
												return false;
											
											
											/****************** Added for 2.7 End ********************/

										}
										//FRD 2.3 added 16(ia)	commented || mColIndex == 13
										if (mColIndex == 2 /*|| mColIndex == 13*/
												|| mColIndex == 14
												|| mColIndex == 16
												|| mColIndex == 21
												|| mColIndex == 1
												|| mColIndex == 31
												|| mColIndex == 27
												|| mColIndex == 22
												|| mColIndex == 58
												|| mColIndex == 68) { //RPU 3.6 Observation 23 fix
											return false;
										}
										

										return mColIndex != 0;

									}
									//**********************************************************


								} else if (strAnnexIIColValue
										.charAt(rowIndex - 2) == 'F' && (formNum.equals("24Q"))) {
									return false;
								}
							}
							//***********************************************************************

							else{
								if (mode_annex2.equalsIgnoreCase("DELETE")) {
									return false;

								}

								else	if ((jTableTransacDetails2.getSelectedRow() > 1 && (jTableTransacDetails2
										.getSelectedRow() - 2) < pan_Updtn_Indicator_Anne2
										.size())
										&& (pan_Updtn_Indicator_Anne2
												.get(jTableTransacDetails2
														.getSelectedRow() - 2) < 2)
														&& mode_annex2.equals("PAN UPDATE"))// panupdationCounter<2
								{
									if (mColIndex == 3)
										return true;
									else
										return false;

								}

								else if ((jTableTransacDetails2.getSelectedRow() > 1 && (jTableTransacDetails2
										.getSelectedRow() - 2) < pan_Updtn_Indicator_Anne2
										.size())
										&& (pan_Updtn_Indicator_Anne2
												.get(jTableTransacDetails2
														.getSelectedRow() - 2) == 2)
														&& mode_annex2.equals("PAN UPDATE"))// panupdationCounter==2
								{
									return false;
								}
								//new development for FRD1.3 by Akansha
								else if(mode_annex2.equals("Add"))
								{

									if (JComboBox_Form_Sub1_finYear
											.getSelectedIndex() != 0) {
										int selYear_anne2 = Integer
												.parseInt(JComboBox_Form_Sub1_finYear
														.getSelectedItem()
														.toString().substring(0, 4));
										int next_year_anne2 = Integer
												.parseInt(JComboBox_Form_Sub1_finYear
														.getSelectedItem()
														.toString().substring(5, 9));

										if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
												&& mColIndex == 8)// disabling
											// Reported
											// taxable
											// amount
											return false;

										if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
												&& mColIndex == 9)// disabling
											// Reported tax
											return false;
										if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
												&& mColIndex == 10)// disabling
											// Total amount
											// of
											// salary
											return false;
										// Added by Akansha
										if ((selYear_anne2 < 2013 && next_year_anne2 < 2014)
												&& mColIndex == 10)// disabling
											// Total amount
											// of
											// salary
											return true;
										// **************************************************

										if (!((selYear_anne2 == 2010 && next_year_anne2 == 2011) || (selYear_anne2 == 2011 && next_year_anne2 == 2012))
												&& mColIndex == 18)// disabling amnt
											// deductible
											// 80CCF Fy othet than
											// 2010-2011 ||2011-2012
										{
											return false;
										}

										// newly changed by cholia
										if ((selYear_anne2 < 2012 && next_year_anne2 < 2013)
												&& mColIndex == 19)// disabling amnt
											// deductible
											// Under Section 80CCG
										{
											return false;
										}

										if (!(selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
												&& (mColIndex == 28
												|| mColIndex == 29 || mColIndex == 32))// disabling
											// column
											// 28
											// and
											// column
											// 29
											// for
											// annexure2
										{
											return false;
										}

										if ((selYear_anne2 >= 2013 && next_year_anne2 >= 2014)
												&& (mColIndex == 30))// disabling
											// column 30
											// (sum
											// of 28 + 29)for
											// annexure2
										{
											return false;
										}

										//newly added for FRD1.6 by akansha
										if (mColIndex == 33 && (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
											return true;

										if( mColIndex == 34
												|| mColIndex == 35 || mColIndex == 36 || mColIndex == 37
												||  mColIndex == 38
												|| mColIndex == 39 || mColIndex == 40
												|| mColIndex == 41) {


											if (grpu.model2 != null
													&& grpu.model2.getValueAt(rowIndex, 33) != null
													&& "Yes".equals(grpu.model2.getValueAt(
															rowIndex, 33).toString())
															&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
												return true;
											else
												return false;
										}

										if (mColIndex == 42 && (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
											return true;

										if(mColIndex == 43
												|| mColIndex == 44 || mColIndex == 45 || mColIndex == 46
												||  mColIndex == 47
												|| mColIndex == 48 || mColIndex == 49 || mColIndex == 50)
										{



											if (grpu.model2 != null
													&& grpu.model2.getValueAt(rowIndex, 42) != null
													&& "Yes".equals(grpu.model2.getValueAt(
															rowIndex, 42).toString())
															&& (selYear_anne2 >= 2016 && next_year_anne2 >= 2017))
												return true;
											else
												return false;
										}
										
										if (mColIndex == 93 &&(selYear_anne2 < 2020 && next_year_anne2 < 2021 ||
				                                (selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
				                                ( jComboBox_Quarter.getSelectedItem().equals("Q1") || jComboBox_Quarter.getSelectedItem().equals("Q3")||  jComboBox_Quarter.getSelectedItem().equals("Q2"))) ))
				                        {
				                            return false;// RPU 3.6 Changes to disable column when column 93 is present
				                        }
										
										if (mColIndex == 62
												//|| mColIndex == 63 RPU 3.6 Updated requirement to enable 63rd column
												|| mColIndex == 66
												|| mColIndex == 13
												|| mColIndex == 11
												|| mColIndex == 12
											    || mColIndex == 19
											    || mColIndex == 20
										        || mColIndex == 91
										        || mColIndex == 92
										        || mColIndex == 70
										        || mColIndex == 71
										        || mColIndex == 72
										        || mColIndex == 73
										        || mColIndex == 74
										        || mColIndex == 75
										        || mColIndex == 76
										        || mColIndex == 77
										        || mColIndex == 80
										        || mColIndex == 81
										        || mColIndex == 82
										        || mColIndex == 83
										        || mColIndex == 84
										        || mColIndex == 85
										        || mColIndex == 86
										        || mColIndex == 87
										        || mColIndex == 88
										        || mColIndex == 89)
												{
												

											if (grpu.model2 != null    //RPU 3.6 Changes to disable column when column 93 is present
													&& grpu.model2
													.getValueAt(
															rowIndex,
															93) != null
															&& "Yes".equals(grpu.model2
																	.getValueAt(
																			rowIndex,
																			93)
																			.toString())
																			&& (selYear_anne2 > 2020 && next_year_anne2 > 2021 ||
												                                    (selYear_anne2 == 2020 && next_year_anne2 == 2021 &&
												                                    (jComboBox_Quarter.getSelectedItem().equals("Q4")))))
												return false;
											else
												return true;
										}
										

										//******************************************

										//newly added for revised FRd1.6 by akansha
										if(mColIndex == 51 && (selYear_anne2 >=2013 && next_year_anne2>=2014))
											return true;

										if(mColIndex == 52 || mColIndex == 53
												|| mColIndex == 54 || mColIndex == 55 || mColIndex == 56
												|| mColIndex == 57 ){




											if(grpu.model2!=null && grpu.model2.getValueAt(rowIndex,51)!=null &&
													"Yes".equals(grpu.model2.getValueAt(rowIndex,51).toString())
													&& (selYear_anne2 >=2013 && next_year_anne2>=2014))
												return true;
											else
												return false;



										}
										
										//*******************************************


									}
									//FRD 2.3 added 16(ia)	commented || mColIndex == 13
									if (mColIndex == 2 /*|| mColIndex == 13*/
											|| mColIndex == 14 || mColIndex == 16
											|| mColIndex == 21 || mColIndex == 1
											|| mColIndex == 31 || mColIndex == 27
											|| mColIndex == 22 || mColIndex == 58) { // newly added for revised FRD1.6 by akansha
										return false;
									}

									return mColIndex != 0;

								}
								//**********************************************************

							}
						}

						return false;

					}
				}

			};

			jTableTransacDetails2 = new JTable(model2) {

				public Component prepareRenderer(TableCellRenderer renderer,
						int rowIndex, int vColIndex) {

					Component c = super.prepareRenderer(renderer, rowIndex,
							vColIndex);
					Color prevColor = Color.white;
					if (c instanceof JComponent) {
						JComponent jc = (JComponent) c;
						if (vColIndex == 0 || vColIndex == 1) {
							jc.setToolTipText(String.valueOf(getValueAt(
									rowIndex, vColIndex)));
						} 
						//added newly for FRD1.9 -- tooltips for PAN of Employee
						else if(vColIndex == 33 ||vColIndex == 35 || vColIndex == 37 || vColIndex == 39 || vColIndex == 42 || vColIndex == 44 || vColIndex == 46 || vColIndex == 48){
							if("24Q".equals(formNumber)){
								if (Integer
										.parseInt(JComboBox_Form_Sub1_finYear
												.getSelectedItem().toString()
												.substring(0, 4)) >= 2016) {
									if ("Payment made to Government organization (Central/State only)"
											.equals((String) getValueAt(
													rowIndex, vColIndex))) {
										jc.setToolTipText("Payment made to Government organization (Central/State only)");
									} else if ("Payment made to Non-resident"
											.equals((String) getValueAt(
													rowIndex, vColIndex))) {
										jc.setToolTipText("Payment made to Non-resident");
									} else if ("Payment made to Other than Government organization and Non-resident"
											.equals((String) getValueAt(
													rowIndex, vColIndex))) {
										jc.setToolTipText("Payment made to Other than Government organization and Non-resident");
									}else if ("--Select--".equals((String) getValueAt(rowIndex, vColIndex)) || "--SELECT--".equals((String) getValueAt(rowIndex, vColIndex))) {
										jc.setToolTipText("Field is applicable only from F.Y. 2016-17 onwards");
									} else {
										jc.setToolTipText((String) getValueAt(
												rowIndex, vColIndex));
									}
								}else{
									jc.setToolTipText("Field is applicable only from F.Y. 2016-17 onwards");
								}
							}
						}
						else {
							String toolTipval = cellTooltip2(vColIndex);
							jc.setToolTipText(toolTipval);
						}
					}
					return c;
				}

			};
			jTableTransacDetails2
			.setPreferredScrollableViewportSize(new Dimension(500, 70));
			jTableTransacDetails2.setGridColor(Color.orange);
			jTableTransacDetails2.setRowHeight(20);
			JScrollPane jScrollPane7 = new JScrollPane(jTableTransacDetails2);

			jScrollPane7.setViewportView(jTableTransacDetails2);
			jScrollPane7.getViewport ().setScrollMode ( JViewport.BACKINGSTORE_SCROLL_MODE );
			//jScrollPane7.getViewport ().setScrollMode ( JViewport.SIMPLE_SCROLL_MODE );
			jTableTransacDetails2.getTableHeader().setReorderingAllowed(false);
			jTableTransacDetails2.getTableHeader().setFont(font);
			jTableTransacDetails2.setRowSelectionAllowed(false);
			jTableTransacDetails2.setColumnSelectionAllowed(false);
			jTableTransacDetails2.setCellSelectionEnabled(true);
			jTableTransacDetails2.setSurrendersFocusOnKeystroke(true); // Added
			// for
			// issue
			// on
			// 24042015
			viewport = (JViewport) jTableTransacDetails2.getParent();
			rect = jScrollPane7.getViewportBorderBounds();
			pt = viewport.getViewPosition();

			PanelAnnexure2Det.setLayout(new GridLayout(1, 0, 0, 0));// yahan
			PanelAnnexure2Det.add(jScrollPane7, 0);

			JTableHeader jHeaderTransacDetails2 = jTableTransacDetails2
					.getTableHeader();
			/*jHeaderTransacDetails2.setPreferredSize(new Dimension(50000, 105));*/
			/****************** Added for 2.7 Start ********************/

			jHeaderTransacDetails2.setPreferredSize(new Dimension(50000, 180));
			/***************** Added for 2.7 End  ********************/
			// -- To add Rupee symbol
			URL url = null;
			try {
				url = getClass().getResource("/images/rp.png");
				System.out.println(url + " url");
				if (url == null)
				{	System.out.println("Cannot find image at specified location");
					throw new Exception();
				}

			} catch (Exception e) {
				System.err
				.println("Exception  while creating the Rupee image : ");
				e.printStackTrace();

			}

			// -- end
			// priya2
			// Added By for annexure 2
			model2.addColumn("<html><center> Row Number</center></html>.");// 0

			model2.addColumn("<html><center> Serial Number </center></html>");// 1

			model2.addColumn("<html><center> Update Mode</center></html>");// 2

			model2.addColumn("<html><center>Permanent<br>Account Number<br>of the employee</center></html>");// 3

			model2.addColumn("<html><center>Name of the <br>employee</center></html>");// 4

			model2.addColumn("<html><center>Deductee type (Senior<br>Citizen, Super Senior<br>Citizen, Others)</center></html>");// 5
			// newly chnaged by cholia to show the calender
			model2.addColumn("<html><center> Date from which <br>employed with<br>current employer<br>in the current <br>financial year<br>(dd/mm/yyyy)</center></html>");// 6

			model2.addColumn("<html><center> Date to which<br> employed with<br> current employer<br>in the current <br>financial year<br>(dd/mm/yyyy)</center></html>");// 7
			
			// end newly chnaged by cholia to show the calender
			model2.addColumn("<html><center>Total amount of gross<br>salary received from<br>current employer<br>(Sum of columns 59+60<br>+61 for FY 2018-19<br>onwards)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 8

			model2.addColumn("<html><center>Reported total<br>amount of salary <br>received from other <br>employer(s)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 9

			model2.addColumn("<html><center> Total Amount<br>&nbsp;&nbsp;of Salary(8+9)<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 10

			model2.addColumn("<html><center>Total deduction<br>under section<br> 16(ii)<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 11
			// //yahan

			model2.addColumn("<html><center>Total deduction<br>under section <br>16(iii) <br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 12


			/********************************************************************************/
			//FRD 2.3 added 16(ia)	
			/*model2.addColumn("<html><center>Total Deduction Under Section <br>16(ii) and 16(iii)<br><img src='"
			+ url
			+ "'  height='12' width='10'  > </img></center></html>");// 13*/

			model2.addColumn("<html><center>Total deduction <br>under section<br>16(ia)<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 13
			/********************************************************************************/

			model2.addColumn("<html><center>Income<br> Chargeable Under<br> the Head<br> &ldquo;Salaries&rdquo; [8+9-<br>(68+11+12+13)]<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 14

			model2.addColumn("<html><center> Income (or<br>admissible loss)<br>from house<br>property reported<br>by employee<br>offered for TDS <br>[section 192 (2B)]<br><img src='"
					+ url
					+ "'  height='12' width='10'  > </img></center></html>");// 15

			model2.addColumn("<html><center>Gross total income <br>(14+15+ 69)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 16

			model2.addColumn("<html><center> Aggregate Amount<br>of Deductions Under<br>Sections 80C, 80CCC<br>and 80CCD(1) (Total to be<br>limited to amount specified <br>in section 80CCE)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 17

			model2.addColumn("<html><center> Amount Deductible<br>under Section 80CCF.<br>Applicable for FY 2010-11<br>and 2011-12 only<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 18

			model2.addColumn("<html><center> Amount Deductible<br>under Section 80CCG.<br>Applicable from FY<br>2012-13 onwards<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 19

			model2.addColumn("<html><center> Amount deductible <br>under any other <br>provision(s) of<br> Chapter VI_A<br>(Dedcutible Amount)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 20

			model2.addColumn("<html><center>Total amount<br>deductible under <br>Chapter VI_A<br>(17+18+19+ (71+<br>73+75) (limited to<br> Rs. 1,50,000) <br>+77+79+81+83<br>+86+89+20)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 21

			model2.addColumn("<html><center>Total<br>taxable <br>income  (16-<br>21)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 22

			model2.addColumn("<html><center>Income-tax<br> on total<br> income<br><img src='"+ url + "'  height='12' width='10' ></center></html>");// 23

			model2.addColumn("<html><center>(ii)<br>Surcharge<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 24

			model2.addColumn("<html><center>(iii) Health and<br>Education cess<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 25

			model2.addColumn("<html><center> Income Tax Relief<br>under Section 89,<br>when salary etc.<br>is paid in  arrear<br>or in advance<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 26

			model2.addColumn("<html><center> Net tax<br>Liability<br>[23+24+25 -<br>(90+26)]<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 27
			// Total Amount of TDS by current employer for whole year (aggregate
			// amount in col 21 - Anx I for all quarters in respect of each
			// employee)

			model2.addColumn("<html><center> Total Amount of <br>tax deducted at <br>source by the <br> current employer  <br>for the whole year<br>[aggregate of the <br>amount in columns<br>323 of Annexure I <br>for all the quarters <br>in respect of each<br>employee] <br>"
					+ "<img src='"
					+ url
					+ "'  height='12' width='10' ></center></html>");// 28

			model2.addColumn("<html><center> Reported amount of<br>tax deducted at <br> source by other <br>employer(s)/ <br>deductor(s) (income<br> in respect of which<br> included in computing<br> total taxable income<br> in column 13 )<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 29

			model2.addColumn("<html><center> Total amount of tax<br> deducted at source for the<br> whole year (28+29+57)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 30

			model2.addColumn("<html><center>Shortfall in tax deduction (+)/<br> Excess tax<br> deduction (_)<br> (27-30)<br><img src='"
					+ url + "'  height='12' width='10' ></center></html>");// 31

			model2.addColumn("<html><center>Whether tax deducted <br>at Higher rate due to <br>non furnishing of PAN <br>by deductee</center></html>");// 32

			//newly added for FRD1.6 by akansha
			//1st
			model2.addColumn("<html><center>(House rent allowance)<br> Whether aggregate rent <br>payment exceeds rupees <br>one lakh</center></html>");// 33
			model2.addColumn("<html><center>If exemption is<br> claimed under<br> section 10(13A),<br> PAN of landlord 1</center></html>");// 34
			model2.addColumn("<html><center>Name of landlord1</center></html>");// 35
			model2.addColumn("<html><center>If exemption is<br> claimed under<br> section 10(13A), PAN<br> of landlord 2</center></html>");// 34
			model2.addColumn("<html><center>Name of landlord2</center></html>");// 35
			model2.addColumn("<html><center>If exemption is<br> claimed under<br> section 10(13A), PAN<br> of landlord 3</center></html>");// 34
			model2.addColumn("<html><center>Name of landlord3</center></html>");// 35
			model2.addColumn("<html><center>If exemption is<br> claimed under<br> section 10(13A), PAN<br> of landlord 4</center></html>");// 34
			model2.addColumn("<html><center>Name of landlord4</center></html>");// 35
			model2.addColumn("<html><center>Whether Interest paid  <br>to the lender under <br>the head 'Income from<br> house property'.</center></html>");// 42
			model2.addColumn("<html><center>PAN of lender<br> 1, if interest on<br> housing loan is<br> claimed under<br> section 24(b) </center></html>");// 43
			model2.addColumn("<html><center>Name of lender 1, if<br> interest on housing<br> loan is claimed under<br> section 24(b) </center></html>");// 44
			//2nd		
			model2.addColumn("<html><center>PAN of lender<br> 2, if interest on<br> housing loan is<br> claimed under<br> section 24(b) </center></html>");// 45
			model2.addColumn("<html><center>Name of lender 2, if<br> interest on housing loan is<br> claimed under section<br> 24(b) </center></html>");// 46

			//3rd	
			model2.addColumn("<html><center>PAN of lender 3, if<br> interest on housing<br> loan is claimed under<br> section 24(b) </center></html>");// 47
			model2.addColumn("<html><center>Name of lender 3, if<br> interest on housing<br> loan is claimed under<br> section 24(b)</center></html>");// 48

			//4th	
			model2.addColumn("<html><center>PAN of lender 4, if interest<br> on housing loan is claimed<br> under section 24(b) </center></html>");// 49
			model2.addColumn("<html><center><center>Name of lender 4, if<br> interest on housing loan<br> is claimed under section<br> 24(b) </center></html>");// 50


			model2.addColumn("<html><center>Whether contributions<br> paid by the trustees of<br> an approved<br> superannuation fund</html>");
			model2.addColumn("<html><center>Name of the<br> superannuation fund</html>");
			model2.addColumn("<html><center>Date from which the<br> employee has contributed<br> to the superannuation fund</center></html>");
			model2.addColumn("<html><center>Date to which the<br> employee has contributed<br> to the superannuation fund</center></html>");
			model2.addColumn("<html><center>The amount of contribution<br> repaid on account of<br> principal and interest</center></html>");
			model2.addColumn("<html><center>The average rate of<br> deduction of tax during<br> the preceding three years</center></html>");
			model2.addColumn("<html><center>The amount of tax<br> deducted on repayment</center></html>");
			model2.addColumn("<html><center>Gross total income<br> including contribution repaid<br> on account of principal<br> and interest from<br> superannuation fund</html>");


			/****************** Added for 2.7 Start ********************/
			model2.addColumn("<html><center>(a) Gross Salary<br> as per provisions<br> contained in<br> sec.17(1)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>(b) Value of<br> perquisites<br> [section 17(2)]<br> (as per<br> FormNo.12BA,<br> wherever<br> applicable)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>(c) Profits in lieu<br> of salary [section<br> 17(3)]<br> (as per Form<br> No.12BA,<br> wherever<br> applicable) <br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Travel<br> concession or<br> assistance<br> [section 10(5)]<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Death-cum-<br>retirement gratuity<br> [section 10(10)]<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Commuted value of<br> pension [section<br> 10(10A)]<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Cash equivalent<br> of leave salary<br> encashment<br> [section<br> 10(10AA)] <br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>House rent<br> allowance<br> [section 10(13A)]<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Amount of any<br> other exemption<br> under section 10<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Total amount of<br> exemption<br> claimed under<br> section 10<br> (62+63+64+65+<br>66+67)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Income under the<br> head other<br> sources offered<br> for TDS [section<br> 192 (2B)])<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			
			//RPU 2.9 start
			model2.addColumn("<html><center>Deduction in<br> respect of life<br> insurance premia,<br> contributions to<br> provident fund<br> etc. (section 80C)<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in<br> respect of life<br> insurance premia,<br> contributions to<br> provident fund<br> etc. (section 80C)<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Deduction in respect<br> of contribution to<br> certain pension funds<br> (section 80CCC)<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in respect<br> of contribution to<br> certain pension funds<br> (section 80CCC)<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Deduction in<br> respect of<br> contribution by<br> taxpayer to<br> notified pension<br> scheme<br> [section<br> 80CCD(1)]<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in<br> respect of<br> contribution by<br> taxpayer to<br> notified pension<br> scheme<br> [section<br> 80CCD(1)]<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Deduction in<br> respect of<br> amount<br> paid/deposited<br> under notified<br> pension scheme<br> [section<br> 80CCD(1B)]<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in<br> respect of<br> amount<br> paid/deposited<br> under notified<br> pension scheme<br> [section<br> 80CCD(1B)]<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Deduction in<br> respect of<br> contribution by<br> employer to<br> notified pension<br> scheme [section<br> 80CCD(2)]<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in<br> respect of<br> contribution by<br> employer to<br> notified pension<br> scheme [section<br> 80CCD(2)]<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Deduction in<br> respect of<br> health<br> insurance<br> premia<br> (section 80D)<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in<br> respect of<br> health<br> insurance<br> premia<br> (section 80D)<br>((Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Deduction in<br> respect of<br> interest on loan<br> taken for higher<br> education<br> (section 80E)<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in<br> respect of<br> interest on loan<br> taken for higher<br> education<br> (section 80E)<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Total deduction<br> in respect<br> of donations to<br> certain funds,<br> charitable<br> institutions, etc.<br> (section 80G)<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Total deduction<br> in respect<br> of donations to<br> certain funds,<br> charitable<br> institutions, etc.<br> (section 80G)<br>(Qualifying Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			model2.addColumn("<html><center>Total deduction<br> in respect<br> of donations to<br> certain funds,<br> charitable<br> institutions, etc.<br> (section 80G)<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Deduction in respect <br>of interest on<br> deposits in<br> savings account<br> (section 80TTA)<br>(Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 
			model2.addColumn("<html><center>Deduction in respect <br>of interest on<br> deposits in<br> savings account<br> (section 80TTA)<br>(Qualifying Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			model2.addColumn("<html><center>Deduction in respect <br>of interest on<br> deposits in<br> savings account<br> (section 80TTA)<br>(Deductible Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			
			model2.addColumn("<html><center>Rebate under<br> section 87A, if<br> applicable<br><img src='"+ url + "'  height='12' width='10' ></center></html>"); 

			model2.addColumn("<html><center>Amount deductible under<br> any other provision(s)<br> of Chapter VI_A<br> (Gross Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			model2.addColumn("<html><center>Amount deductible under<br> any other provision(s)<br> of Chapter VI_A<br> (Qualifying Amount)<br><img src='"+ url + "'  height='12' width='10' ></center></html>");
			model2.addColumn("<html><center>Whether opting<br> for taxation  u/s <br> 115BAC?<br></center></html>");   //RPU 3.6 Changes
			//RPU 2.9 end
			
			/***************** Added for 2.7 End  ********************/

			//************************************


			// Addtion of the rows in the Annexures 2 idhar

			addStaticAnnIIRows(model2);
			// end

			// end
			packColumn2(jTableTransacDetails2, 0, 10);
			packColumn2(jTableTransacDetails2, 1, 15);
			packColumn2(jTableTransacDetails2, 2, 20);
			packColumn2(jTableTransacDetails2, 3, 20);
			packColumn2(jTableTransacDetails2, 4, 60);
			packColumn2(jTableTransacDetails2, 5, 30);
			packColumn2(jTableTransacDetails2, 6, 10); // newly chnaged by
			// cholia to show the
			// calender
			packColumn2(jTableTransacDetails2, 7, 10); // newly chnaged by
			// cholia to show the
			// calender
			packColumn2(jTableTransacDetails2, 8, 10);
			packColumn2(jTableTransacDetails2, 9, 0);
			packColumn2(jTableTransacDetails2, 10, 10);
			packColumn2(jTableTransacDetails2, 11, 5);
			packColumn2(jTableTransacDetails2, 12, 5);
			packColumn2(jTableTransacDetails2, 13, 5);
			packColumn2(jTableTransacDetails2, 14, 5);
			packColumn2(jTableTransacDetails2, 15, 5);
			packColumn2(jTableTransacDetails2, 16, 30);
			packColumn2(jTableTransacDetails2, 17, 15);
			packColumn2(jTableTransacDetails2, 18, -10);
			packColumn2(jTableTransacDetails2, 19, 10);
			packColumn2(jTableTransacDetails2, 20, 5);
			packColumn2(jTableTransacDetails2, 21, 10);
			packColumn2(jTableTransacDetails2, 22, 5);
			packColumn2(jTableTransacDetails2, 23, 10);
			packColumn2(jTableTransacDetails2, 24, 20);
			packColumn2(jTableTransacDetails2, 25, 10);
			packColumn2(jTableTransacDetails2, 26, 10); 
			packColumn2(jTableTransacDetails2, 27, 10);
			packColumn2(jTableTransacDetails2, 28, 10);
			packColumn2(jTableTransacDetails2, 29, 5);
			packColumn2(jTableTransacDetails2, 30, 0);
			packColumn2(jTableTransacDetails2, 31, -10);
			packColumn2(jTableTransacDetails2, 32, 0);

			//newly added for fRD1.6 by akansha
			packColumn2(jTableTransacDetails2, 33, 5);

			//1st
			packColumn2(jTableTransacDetails2, 34, 10);
			packColumn2(jTableTransacDetails2, 35, 10);
			packColumn2(jTableTransacDetails2, 36, 10);
			packColumn2(jTableTransacDetails2, 37, 10);

			//2nd
			packColumn2(jTableTransacDetails2, 38, 10);
			packColumn2(jTableTransacDetails2, 39, 10);
			packColumn2(jTableTransacDetails2, 40, 10);
			packColumn2(jTableTransacDetails2, 41,10);

			//3rd
			packColumn2(jTableTransacDetails2, 42, 5);
			packColumn2(jTableTransacDetails2, 43, 5);
			packColumn2(jTableTransacDetails2, 44, 5);
			packColumn2(jTableTransacDetails2, 45, 5);

			//4th
			packColumn2(jTableTransacDetails2, 46, 5);
			packColumn2(jTableTransacDetails2, 47, 5);
			packColumn2(jTableTransacDetails2, 48, 5);
			packColumn2(jTableTransacDetails2, 49, 5);
			packColumn2(jTableTransacDetails2, 50, 5);

			packColumn2(jTableTransacDetails2, 51, 5);
			packColumn2(jTableTransacDetails2, 52, 5);
			packColumn2(jTableTransacDetails2, 53, -10);
			packColumn2(jTableTransacDetails2, 54, -10);

			packColumn2(jTableTransacDetails2, 55, 5);
			packColumn2(jTableTransacDetails2, 56, 5);
			packColumn2(jTableTransacDetails2, 57, 5);
			packColumn2(jTableTransacDetails2, 58, 5);


			/****************** Added for 2.7 Start ********************/
			packColumn2(jTableTransacDetails2, 59, 5);
			packColumn2(jTableTransacDetails2, 60, 5);
			packColumn2(jTableTransacDetails2, 61, 5);
			packColumn2(jTableTransacDetails2, 62, 5);
			packColumn2(jTableTransacDetails2, 63, 5);
			packColumn2(jTableTransacDetails2, 64, 5);
			packColumn2(jTableTransacDetails2, 65, 5);
			packColumn2(jTableTransacDetails2, 66, 5);
			packColumn2(jTableTransacDetails2, 67, 5);
			packColumn2(jTableTransacDetails2, 68, 5);
			packColumn2(jTableTransacDetails2, 69, 5);
			packColumn2(jTableTransacDetails2, 70, 5);
			packColumn2(jTableTransacDetails2, 71, 5);
			packColumn2(jTableTransacDetails2, 72, 5);
			packColumn2(jTableTransacDetails2, 73, 5);
			packColumn2(jTableTransacDetails2, 74, 5);
			packColumn2(jTableTransacDetails2, 75, 5);
			packColumn2(jTableTransacDetails2, 76, 5);
			packColumn2(jTableTransacDetails2, 77, 5);
			packColumn2(jTableTransacDetails2, 78, 5);
			packColumn2(jTableTransacDetails2, 79, 5);		
			//RPU 2.9 start
			packColumn2(jTableTransacDetails2, 80, 5);
			packColumn2(jTableTransacDetails2, 81, 5);
			packColumn2(jTableTransacDetails2, 82, 5);
			packColumn2(jTableTransacDetails2, 83, 5);
			packColumn2(jTableTransacDetails2, 84, 5);
			packColumn2(jTableTransacDetails2, 85, 5);
			packColumn2(jTableTransacDetails2, 86, 5);
			packColumn2(jTableTransacDetails2, 87, 5);
			packColumn2(jTableTransacDetails2, 88, 5);
			packColumn2(jTableTransacDetails2, 89, 5);
			packColumn2(jTableTransacDetails2, 90, 5);
			packColumn2(jTableTransacDetails2, 91, 5);
			packColumn2(jTableTransacDetails2, 92, 5);
			packColumn2(jTableTransacDetails2, 93, 25);  //RPU 3.7 Addition of new column rahul
			//RPU 2.9 end
			
			/***************** Added for 2.7 End  ********************/

			FixedColumnTable fct = new FixedColumnTable(1, jScrollPane7);
			jTableTransacDetails2.setAutoResizeMode(0);
			// Methods Added By idhar niket

			int selYear_colur = 0;
			int next_year_colour = 0;
			if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
				selYear_colur = Integer.parseInt(JComboBox_Form_Sub1_finYear
						.getSelectedItem().toString().substring(0, 4));
				next_year_colour = Integer.parseInt(JComboBox_Form_Sub1_finYear
						.getSelectedItem().toString().substring(5, 9));
			}

			jTableTransacDetails2.getColumnModel().getColumn(0)
			.setCellEditor(new GRPUTableCellEditorChlnSerNo());
			jTableTransacDetails2.getColumnModel().getColumn(0)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			/*
			 * jTableTransacDetails2.getColumnModel().getColumn(1)
			 * .setCellEditor(new GRPUTableCellEditorUpdMode());
			 */
			jTableTransacDetails2.getColumnModel().getColumn(1)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			// Pan of the Empoyee
			jTableTransacDetails2.getColumnModel().getColumn(2)
			.setCellEditor(new GRPUTableCellEditorEmployPan());
			jTableTransacDetails2.getColumnModel().getColumn(2)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			// Employer name(3)
			jTableTransacDetails2.getColumnModel().getColumn(3)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2()); // newly
			// added
			// by
			// cholia
			// on
			// 11
			// march
			jTableTransacDetails2.getColumnModel().getColumn(3)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			jTableTransacDetails2.getColumnModel().getColumn(4)
			.setCellEditor(new GRPUTableCellEditorTV());
			jTableTransacDetails2.getColumnModel().getColumn(4)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// Date from which employed with current employer
			jTableTransacDetails2.getColumnModel().getColumn(5)
			.setCellEditor(new GRPUTableCellEditorDateEmployment(mainObject));
			jTableTransacDetails2.getColumnModel().getColumn(5)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// end

			// Date to which employed with current employer
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(6)
			.setCellEditor(new GRPUTableCellEditorDateToWhichEmployed(mainObject));
			jTableTransacDetails2.getColumnModel().getColumn(6)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// end
			
			GRPUTableCellEditorTaxableAmount gRPUTableCellEditorTaxableAmount = new GRPUTableCellEditorTaxableAmount();

			// Taxable Amount on which tax is deducted
		/*	jTableTransacDetails2.getColumnModel().getColumn(7)
			.setCellEditor(new GRPUTableCellEditorTaxableAmount());*/
			
			

			// end

			// Reported Taxable Amount on which tax is deducted by the precious
			// Employer
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(8)
			.setCellEditor(
					new GRPUTableCellEditorReportedTaxableAmount());

			// end

			// Reported Taxable Amount on which tax is deducted by the precious
			// Employer
			jTableTransacDetails2.getColumnModel().getColumn(9)
			.setCellEditor(new GRPUTableCellEditorTotalAmountSalary());
			jTableTransacDetails2.getColumnModel().getColumn(9)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
			// end

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(10)
			.setCellEditor(
					new GRPUTableCellEditorDeductionUndrSec16II());
			jTableTransacDetails2.getColumnModel().getColumn(10)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(11)
			.setCellEditor(
					new GRPUTableCellEditorDeductionUndrSec16III());
			jTableTransacDetails2.getColumnModel().getColumn(11)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			/*********************************************************/				
			//FRD 2.3 added 16(ia)			
			/*jTableTransacDetails2
			.getColumnModel()
			.getColumn(12)
			.setCellEditor(new GRPUTableCellEditorTotalDedtnUndrSec16());
	jTableTransacDetails2.getColumnModel().getColumn(12)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));*/


			jTableTransacDetails2
			.getColumnModel()
			.getColumn(12)
			.setCellEditor(
					new GRPUTableCellEditorDeductionUndrSec16IA());
			jTableTransacDetails2.getColumnModel().getColumn(12)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
			/*********************************************************/


			// Income Chargable Under the Head
			jTableTransacDetails2.getColumnModel().getColumn(13)
			.setCellEditor(new GRPUTableCellEditorPAN());
			jTableTransacDetails2.getColumnModel().getColumn(13)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

			// Income Section 192(2B)
			jTableTransacDetails2.getColumnModel().getColumn(14)
			.setCellEditor(new GRPUTableCellEditorIncmOthrThnSalry());
			jTableTransacDetails2.getColumnModel().getColumn(14)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// Total Gross Income
			jTableTransacDetails2.getColumnModel().getColumn(15)
			.setCellEditor(new GRPUTableCellEditorGrossTotalIncm());
			jTableTransacDetails2.getColumnModel().getColumn(15)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
			// Total Gross Income end

			// Aggregate Amount Of Deductions Under 80C,80CCC and 80CCD
			jTableTransacDetails2.getColumnModel().getColumn(16)
			.setCellEditor(new GRPUTableCellEditorAggrAmntDedctn());
			jTableTransacDetails2.getColumnModel().getColumn(16)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// end

			// Amount Dedcutable Under Section 80CCF
			jTableTransacDetails2.getColumnModel().getColumn(17)
			.setCellEditor(new GRPUTableCellEditorAmntDedSec80CCF());

			// end

			// Amount Dedcutable Under Section 80CCG

			jTableTransacDetails2.getColumnModel().getColumn(18)
			.setCellEditor(new GRPUTableCellEditorAmntDedSec80CCG());
			// end

			// Amount Dedcutible Under any other Provision Of Chapter VI-A

			jTableTransacDetails2.getColumnModel().getColumn(19)
			.setCellEditor(new GRPUTableCellEditorAmntDedChVIA());
			jTableTransacDetails2.getColumnModel().getColumn(19)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// end
			// Total Amount Deductible Under ChapterVI A
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(20)
			.setCellEditor(
					new GRPUTableCellEditorTotalSumAmntDedChVIA());
			jTableTransacDetails2.getColumnModel().getColumn(20)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// End
			jTableTransacDetails2.getColumnModel().getColumn(21)
			.setCellEditor(new GRPUTableCellEditorTotalTaxIncome());
			jTableTransacDetails2.getColumnModel().getColumn(21)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// Total tax-(i)
			jTableTransacDetails2.getColumnModel().getColumn(22)
			.setCellEditor(new GRPUTableCellEditorTotalTaxI());
			jTableTransacDetails2.getColumnModel().getColumn(22)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));
			// Surcharge
			jTableTransacDetails2.getColumnModel().getColumn(23)
			.setCellEditor(new GRPUTableCellEditorSurchargeannex2());
			jTableTransacDetails2.getColumnModel().getColumn(23)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// 23 EductaionCess
			jTableTransacDetails2.getColumnModel().getColumn(24)
			.setCellEditor(new GRPUTableCellEditorCessannex2());
			jTableTransacDetails2.getColumnModel().getColumn(24)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// end

			// Income Tax Relief
			jTableTransacDetails2.getColumnModel().getColumn(25)
			.setCellEditor(new GRPUTableCellEditorIncomeTaxRelief());
			jTableTransacDetails2.getColumnModel().getColumn(25)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// Income Tax Relief end

			// Net TaxPayble
			jTableTransacDetails2.getColumnModel().getColumn(26)
			.setCellEditor(new GRPUTableCellEditorNetTaxPayble());
			jTableTransacDetails2.getColumnModel().getColumn(26)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// End TaxPayble

			// Tds Dedcuted By the current Employer
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(27)
			.setCellEditor(
					new GRPUTableCellEditorTdsDedCurrnetEmpAnx2());

			// End Tds Dedcuted By the current Employer

			// Reported Amount Tds By previous Empyer

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(28)
			.setCellEditor(
					new GRPUTableCellEditorReportdTdsPrevEmplyrannx2());

			// End Reported Amount Tds By previous Empyer

			// Total Amount Dedcuted at source
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(29)
			.setCellEditor(
					new GRPUTableCellEditorTotalAmntDedWholeYrannx2());
			jTableTransacDetails2.getColumnModel().getColumn(29)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

			// End Total Amount Dedcuted at source

			jTableTransacDetails2.getColumnModel().getColumn(30)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// newly added by cholia on 03.03.2015
			jTableTransacDetails2.getColumnModel().getColumn(31)
			.setCellRenderer(new GRPUTableCellRenderer(tabname, false));
			// end //newly added by cholia on 03.03.2015


			//newly added by akansha for FRD1.6

			jTableTransacDetails2.getColumnModel()
			.getColumn(32).setCellEditor(new GRPUTableCellEditorWhthrHouseRentAllowanceClaim(this));

			//newly added for FRD1.6 by akansha
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(32)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							false, "",false)); // added

			//1st
			jTableTransacDetails2.getColumnModel()
			.getColumn(33).setCellEditor(new GRPUTableCellEditorPANLandlord(this));

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(33)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel().getColumn(34)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(34)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(35).setCellEditor(new GRPUTableCellEditorPANLandlord(this));

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(35)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel().getColumn(36)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(36)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added
			//2nd

			jTableTransacDetails2.getColumnModel()
			.getColumn(37).setCellEditor(new GRPUTableCellEditorPANLandlord(this));

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(37)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added
			jTableTransacDetails2.getColumnModel().getColumn(38)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(38)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(39).setCellEditor(new GRPUTableCellEditorPANLandlord(this));

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(39)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel().getColumn(40)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(40)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(41).setCellEditor(new GRPUTableCellEditorWhthrIntrstPaidToLender(this));

			//newly added for FRD1.6 by akansha
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(41)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							false, "",false)); // added


			//3rd
			jTableTransacDetails2.getColumnModel()
			.getColumn(42).setCellEditor(new GRPUTableCellEditorPANoflender());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(42)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel().getColumn(43)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(43)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(44).setCellEditor(new GRPUTableCellEditorPANoflender());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(44)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel().getColumn(45)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(45)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			//4th

			jTableTransacDetails2.getColumnModel()
			.getColumn(46).setCellEditor(new GRPUTableCellEditorPANoflender());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(46)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel().getColumn(47)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(47)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(48).setCellEditor(new GRPUTableCellEditorPANoflender());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(48)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel().getColumn(49)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(49)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			//newly added for revised FRD1.6 akansha

			jTableTransacDetails2.getColumnModel()
			.getColumn(50).setCellEditor(new GRPUTableCellEditorWhthrCntrPaidByTrustees());


			jTableTransacDetails2
			.getColumnModel()
			.getColumn(50)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							false, "",false)); // added


			jTableTransacDetails2.getColumnModel().getColumn(51)
			.setCellEditor(new GRPUTableCellEditorEmployName_anne2());
			jTableTransacDetails2
			.getColumnModel()
			.getColumn(51)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(52).setCellEditor(new GRPUTableCellEditorDateFromWhichEmpContrSA(mainObject));

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(52)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(53).setCellEditor(new GRPUTableCellEditorDateToWhichEmpContrSA(mainObject));

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(53)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(54).setCellEditor(new GRPUTableCellEditorAmtContrAccoOfPI());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(54)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added

			jTableTransacDetails2.getColumnModel()
			.getColumn(55).setCellEditor(new GRPUTableCellEditorAvgRateOfTaxDedThreeYrs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(55)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added


			jTableTransacDetails2.getColumnModel()
			.getColumn(56).setCellEditor(new GRPUTableCellEditorAmtTaxDeductedOnRepay());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(56)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added


			jTableTransacDetails2.getColumnModel()
			.getColumn(57).setCellEditor(new GRPUTableCellEditorGrossTotalIncmRepaidPIfromSA());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(57)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); // added



			/****************** Added for 2.7 Start ********************/

			jTableTransacDetails2.getColumnModel()
			.getColumn(58).setCellEditor(new GRPUTableCellEditorGrossSalaryAsPerSec17_1());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(58)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(59).setCellEditor(new GRPUTableCellEditorValueOfPerquisiteAsPerSec17_2());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(59)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(60).setCellEditor(new GRPUTableCellEditorProfitsInLieuOfSalaryAsPerSec17_3());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(60)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(61).setCellEditor(new GRPUTableCellEditorTravelConcession());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(61)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(62).setCellEditor(new GRPUTableCellEditorDeathCumRetirementGratuity());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(62)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(63).setCellEditor(new GRPUTableCellEditorCommutedValueOfPension());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(63)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(64).setCellEditor(new GRPUTableCellEditorCashEquivalentOfLeaveSalary());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(64)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(65).setCellEditor(new GRPUTableCellEditorHRA());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(65)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(66).setCellEditor(new GRPUTableCellEditorAmountOfAnyOtherExemption());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(66)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(67).setCellEditor(new GRPUTableCellEditorTotalAmountOfExemption());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(67)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 
			jTableTransacDetails2.getColumnModel()
			.getColumn(68).setCellEditor(new GRPUTableCellEditorIncomeUnderTheHead());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(68)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(69).setCellEditor(new GRPUTableCellEditorSection80C_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(69)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(70).setCellEditor(new GRPUTableCellEditorSection80C_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(70)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(71).setCellEditor(new GRPUTableCellEditorSection80CCC_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(71)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(72).setCellEditor(new GRPUTableCellEditorSection80CCC_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(72)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 
			jTableTransacDetails2.getColumnModel()
			.getColumn(73).setCellEditor(new GRPUTableCellEditorSection80CCD_1_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(73)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(74).setCellEditor(new GRPUTableCellEditorSection80CCD_1_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(74)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(75).setCellEditor(new GRPUTableCellEditorSection80CCD_1B_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(75)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(76).setCellEditor(new GRPUTableCellEditorSection80CCD_1B_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(76)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(77).setCellEditor(new GRPUTableCellEditorSection80CCD_2_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(77)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(78).setCellEditor(new GRPUTableCellEditorSection80CCD_2_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(78)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 
	
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(79).setCellEditor(new GRPUTableCellEditorSection80D_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(79)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(80).setCellEditor(new GRPUTableCellEditorSection80D_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(80)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(81).setCellEditor(new GRPUTableCellEditorSection80E_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(81)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(82).setCellEditor(new GRPUTableCellEditorSection80E_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(82)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			jTableTransacDetails2.getColumnModel()
			.getColumn(83).setCellEditor(new GRPUTableCellEditorSection80G_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(83)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(84).setCellEditor(new GRPUTableCellEditorSection80G_Qua());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(84)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(85).setCellEditor(new GRPUTableCellEditorSection80G_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(85)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(86).setCellEditor(new GRPUTableCellEditorSection80TTA_Grs());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(86)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			jTableTransacDetails2.getColumnModel()
			.getColumn(87).setCellEditor(new GRPUTableCellEditorSection80TTA_Qua());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(87)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(88).setCellEditor(new GRPUTableCellEditorSection80TTA_Ded());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(88)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(89).setCellEditor(new GRPUTableCellEditorRebateUnderSection87A());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(89)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false)); 

			jTableTransacDetails2.getColumnModel()
			.getColumn(90).setCellEditor(new GRPUTableCellEditorAmntGrsChVIA2());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(90)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			
			jTableTransacDetails2.getColumnModel()
			.getColumn(91).setCellEditor(new GRPUTableCellEditorAmntQuaChVIA2());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(91)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			
			jTableTransacDetails2.getColumnModel()   //RPU 3.7 Addition of new column rahul
			.getColumn(92).setCellEditor(new GRPUTableCellEditorWhetheroptingfornewtax());

			jTableTransacDetails2
			.getColumnModel()
			.getColumn(92)
			.setCellRenderer(
					new GRPUTableCellRendererForColour("Anne2",
							selYear_colur, next_year_colour, formNumber,
							true, "",false));
			
			//RPU 2.9 end
			/***************** Added for 2.7 End  ********************/

			//*************************************************

			/*
			 * jTableTransacDetails2.getColumnModel().getColumn(32).setCellEditor
			 * ( new GRPUTableCellEditorCertNum());
			 * jTableTransacDetails2.getColumnModel
			 * ().getColumn(32).setCellRenderer( new
			 * GRPUTableCellRenderer(tabname));
			 */

			// end
			jTableTransacDetails2.getTableHeader().setResizingAllowed(true);

			// added to enable tabout to TAN directly after serial no for
			// Regular
			// File ans similar for correction File.
			Action myAct = new AbstractAction() {

				public void actionPerformed(ActionEvent e) {
					// TODO Auto-generated method stub

					int row = jTableTransacDetails2.getSelectedRow();
					int col = jTableTransacDetails2.getSelectedColumn();

					if (col == 0) {
						if (valueOfTypeOfStmt.equalsIgnoreCase("Regular")) {
							jTableTransacDetails2.changeSelection(row, 4,
									false, false);
							jTableTransacDetails2.editCellAt(row, 4);
						} else if (valueOfTypeOfStmt
								.equalsIgnoreCase("Correction")) {
							jTableTransacDetails2.changeSelection(row, 2,
									false, false);
							jTableTransacDetails2.editCellAt(row, 2);
						}
					} else {

						// table to buttons tabout logic
						if (row == jTableTransacDetails2.getRowCount() - 1
								&& col == 24) {
							jTableTransacDetails2.changeSelection(0, 0, false,
									false);
							jTableTransacDetails2.editCellAt(0, 0);
							jButton_crtFile.requestFocus();
							return;
						} else if ((valueOfTypeOfStmt
								.equalsIgnoreCase("Correction")) && col == 2) {
							jTableTransacDetails2.changeSelection(row, 4,
									false, false);
							jTableTransacDetails2.editCellAt(row, 4);

						} else if (GRPU.columnNumberEditable(col + 1)) {
							jTableTransacDetails2.changeSelection(row, col + 1,
									false, false);
							jTableTransacDetails2.editCellAt(row, col + 1);

						} else if (col != 24) {
							jTableTransacDetails2.changeSelection(row, col + 1,
									false, false);
							jTableTransacDetails2.editCellAt(row, col + 1);
						} else {
							jTableTransacDetails2.changeSelection(row + 1, 0,
									false, false);
							jTableTransacDetails2.editCellAt(row, 0);
						}

					}

				}

			};

			jTableTransacDetails2.getInputMap().put(
					KeyStroke.getKeyStroke("TAB"), "none");
			jTableTransacDetails2.getInputMap().put(
					KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0), "none");
			jTableTransacDetails2.getActionMap().put("text", myAct);
			// end

			/*
			 * TableColumn batchNoCol1 =
			 * jTableTransacDetails2.getColumnModel().getColumn(1);
			 * batchNoCol1.setMaxWidth(0); batchNoCol1.setMinWidth(0);
			 * batchNoCol1.setPreferredWidth(0);
			 */
			// valuesRevsnModeO = (new String[] {
			// ""
			// });
			// valuesRevsnModeR = (new String[] {
			// "A", "D"
			// });
			mthYrQ1 = (new String[] { "" });
			mthYrQ2 = (new String[] { "" });
			mthYrQ3 = (new String[] { "" });
			mthYrQ4 = (new String[] { "" });
			/*
			 * stateName = (new String[] { "--Select--",
			 * "Andaman & Nicobar Islands", "Andhra Pradesh",
			 * "Arunachal Pradesh", "Assam", "Bihar", "Chandigarh",
			 * "Chhatishgarh", "Dadra and Nagar Haveli", "Daman & Diu", "Delhi",
			 * "Goa", "Gujarat", "Haryana", "Himachal Pradesh",
			 * "Jammu & Kashmir", "Jharkhand", "Karnataka", "Kerala",
			 * "Lakshwadeep", "Madhya Pradesh", "Maharashtra", "Manipur",
			 * "Meghalaya", "Mizoram", "Nagaland", "Orissa", "Pondicherry",
			 * "Punjab", "Rajasthan", "Sikkim", "Tamil Nadu", "Tripura",
			 * "Uttar Pradesh", "Uttaranchal", "West Bengal" });
			 */

			/*
			 * if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) { int
			 * selYear = Integer.parseInt(JComboBox_Form_Sub1_finYear
			 * .getSelectedItem().toString().substring(0, 4)); int next_year =
			 * Integer.parseInt(JComboBox_Form_Sub1_finYear
			 * .getSelectedItem().toString().substring(5, 9)); if (selYear <=
			 * 2010 && next_year <= 2011) jComboBox_deductee_Type = (new
			 * String[] { "--Select--", "Women", "Senior Citizen", "Others" });
			 * else if (selYear >= 2011 && next_year >= 2012) {
			 * jComboBox_deductee_Type = (new String[] { "--Select--", "Women",
			 * "Senior Citizen", "Super Senior Citizen", "Others" }); } }
			 */

			challanSerForDed1 = (new String[] { "--Select--", "ADD", "UPDATE",
					"DELETE", "PAN UPDATE" });
			SecUnderPayMadeDed1 = (new String[] { "--Select--", "92A", "92B",
			"92C" });
			remarksForDed1 = (new String[] { "--Select--", "ADD", "UPDATE",
					"DELETE", "PAN UPDATE" });

			//newly changed for FRD1.6 by akansha
			whetherTaxDedHigherRate = (new String[] { "--Select--", "Yes", "No" });

			/***********************************************************************************/
			//added Combobox for PAN of Lanlord1, PAN of Lanlord2, PAN of Lanlord3, and PAN of Lanlord4, On 16/01/2017, FRD1.9
			/*jComboBox_panOfLanlord = (new String[] { "--Select--", "Payment made to Government organization (Central/State only)", "Payment made to Non-resident", 
					"Payment made to Other than Government organization and Non-resident" });*/
			/**************************************************************************************/

			//newly added for FRD1.6 by akansha
			//whetherHouseRentAllowanceClaim = (new String[]{"--Select--","Yes","No"});
			//***********************************************************

			// revModeArray1 = (new String[] { "--Select--","Delete","Update"});

			// end

			int vColIndex2 = 1;
			dedMode1 = jTableTransacDetails2.getColumnModel().getColumn(
					vColIndex2);
			int vColIndex6 = 4;
			dedSecUnderPayMade1 = jTableTransacDetails2.getColumnModel()
					.getColumn(vColIndex6);
			int vColIndex1 = 31;
			dedChallanSer1 = jTableTransacDetails2.getColumnModel().getColumn(
					vColIndex1);

			jTableTransacDetails2.setSelectionMode(1);

			ddoMappingModes = new String[] { "--Select--", "Add", "Update",
			"Delete" };

			// added by cholia for copy paste

			Action testAction = new AbstractAction("testAction") {
				public void actionPerformed(ActionEvent evt) {
					System.out.println("Action disabled in annexure 2");
					System.out.println("calling paste method in annexure 2");
					pasteXL(tabname);
				}
			};
			KeyStroke ks = KeyStroke.getKeyStroke("control V");
			jTableTransacDetails2.getActionMap().put("testAction", testAction);
			jTableTransacDetails2.getInputMap(
					JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(ks,
							"testAction");

			// end
			jTableTransacDetails2.addMouseListener(new MouseAdapter() {

				public void mousePressed(MouseEvent evt) {
					int col_Sel = jTableTransacDetails2.columnAtPoint(evt
							.getPoint());
					int row_Sel = jTableTransacDetails2.rowAtPoint(evt
							.getPoint());

					int clickRow = jTableTransacDetails2.getSelectedRow();
					int clickCol = jTableTransacDetails2.getSelectedColumn() + 1;
					if(clickCol == 34 || clickCol == 36 || clickCol == 38 || clickCol == 40){

						if(clickCount == 0){
							currentCol = clickCol;
							clickCount++;
							//System.out.println("first click value ="+currentCol +"and" +previousCol);
						}else if(clickCount > 0){
							previousCol = currentCol;
							currentCol = clickCol;
							//System.out.println("after first click value ="+currentCol +"and" +previousCol);
						}

					}

				}

				public void mouseReleased(MouseEvent evt) {
					selRow = returnRow();
					selCol = returnColumn();

					/*
					 * if(jComboBox_TypeOfCorrection.getSelectedItem().toString()
					 * .equalsIgnoreCase ("Cancel")) {
					 * 
					 * if(selCol == 2 && selRow < numDdoRowsCorr) {
					 * getMessage("kerjflkrdjrlkdjlk"); } }
					 */

					boolean isPointInside = false;
					int sel_rowCnt = jTableTransacDetails2
							.getSelectedRowCount();
					int sel_colCnt = jTableTransacDetails2
							.getSelectedColumnCount();
					int col_Sel = jTableTransacDetails2.columnAtPoint(evt
							.getPoint());
					int row_Sel = jTableTransacDetails2.rowAtPoint(evt
							.getPoint());
					/*System.out.println("selected Row count = " + sel_rowCnt
							+ "selected Column count = " + sel_colCnt
							+ "numberDdo = " + numDdoRowsCorr);*/
					for (int i = 0; i < sel_rowCnt; i++) {
						for (int j = 0; j < sel_colCnt; j++) {
							if (selRow + i != row_Sel || selCol + j != col_Sel)
								continue;
							isPointInside = true;
							break;
						}

					}

					if (evt.isPopupTrigger()) {
						if (col_Sel == 2 || col_Sel == 3
								|| columnNumberEditable(col_Sel)
								|| col_Sel >= 25)
							return;

						Object tan = "";
						String tanValue = "";
						if (row_Sel < numDdoRowsCorr) {
							Object[] transObject = (Object[]) saveDDOVector
									.get(row_Sel);
							tanValue = transObject[6].toString();
							System.out.println(tanValue + " Tan Value");

						}
						if (valueOfTypeOfStmt.equalsIgnoreCase("Regular")) {
							item1.setEnabled(true);
							item3.setEnabled(true);
							item4.setEnabled(true);
							item6.setEnabled(true);

						} else if (row_Sel < numDdoRowsCorr
								&& !model2.getValueAt(row_Sel, 2).toString()
								.equalsIgnoreCase("Update")) {

							//System.out.println("HERE ONLy3");
							item1.setEnabled(false);
							item3.setEnabled(false);
							item4.setEnabled(false);
							item6.setEnabled(false);

						} else {
							item1.setEnabled(true);
							item3.setEnabled(true);
							item4.setEnabled(true);
							item6.setEnabled(true);
						}

						menu.show(jTableTransacDetails2.getComponentAt(evt
								.getPoint()), evt.getX(), evt.getY());
						if (col_Sel >= 0 && row_Sel >= 0 && !isPointInside) {
							// jTableTransacDetails2.changeSelection(row_Sel,
							// col_Sel, false, false);
							// jTableTransacDetails2.getComponentAt(evt.getPoint()).repaint();
						}
					}
				}

				public void mouseClicked(MouseEvent e) {
					System.out.println("Inside Mouse Clicked ann 2");
					if (jTableTransacDetails2.getSelectedColumn() != 0) {
						jTableTransacDetails2.setRowSelectionAllowed(false);
						jTableTransacDetails2.setCellSelectionEnabled(true);
						jTableTransacDetails2.repaint();
						// ## Newly developed for correction Ver1.2 by Akansha
						int row = jTableTransacDetails2.getSelectedRow();
						int column = jTableTransacDetails2.getSelectedColumn() + 1;
						String mode = model2.getValueAt(row, 2).toString();
						if (column == 3) {
							if ("PAN UPDATE".equals(mode)) {

								if ((jTableTransacDetails2.getSelectedRow() > 1 && (jTableTransacDetails2
										.getSelectedRow() - 2) < pan_Updtn_Indicator_Anne2
										.size())
										&& (pan_Updtn_Indicator_Anne2
												.get(row - 2) > 1)) {

									JOptionPane
									.showMessageDialog(
											null,
											"<html>Further update of PAN for the deductee record is not allowed. <br>Update of deductee PAN (valid to valid) is allowed only once.</html>");
								}
							}
						}
						//newly added for FRD1.9 for error messages to be populated if "F" found on 02/02/17
						if ("Correction".equals(valueOfTypeOfStmt)) {
							if(strAnnexIIColValue.charAt(row - 2) == 'F'){
								//FRD 2.3 added 16(ia)	commented column 13
								if (column == 2 || !(column == 10 /*|| column == 13*/ || column == 14 || column == 16 ||column == 18 || column == 21 || column == 22 || column == 27 || column == 30 ||column == 31 || column == 58  )){
									JOptionPane.showMessageDialog(null,
											"Update for this record is not allowed as 26A has been submitted for this PAN");
								}
							}
						}

						//newly added for FRD1.6 by akansha
						if(!"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString()) && new Integer(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0,4))>2012)
							if(column == 52 || column == 53 || column == 54 || column == 55 || column == 56 || column == 57 ){
								if("No".equals(model2.getValueAt(row, 51).toString()) || "--Select--".equals(model2.getValueAt(row, 51).toString())){
									JOptionPane
									.showMessageDialog(
											null,
											"<html>Further update of the record is not allowed. <br>Select valid value for 'Whether contributions paid by the trustees<br> of an approved superannuation fund'</html>");

								}
							}

						if(!"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem().toString()) && new Integer(JComboBox_Form_Sub1_finYear.getSelectedItem().toString().substring(0,4))>2015){

							if(column == 43 || column == 44 || column == 45 || column == 46 || column == 47 || column == 48 || column == 49 || column == 50 ){
								if("No".equals(model2.getValueAt(row, 42).toString()) || "--Select--".equals(model2.getValueAt(row, 42).toString())){
									JOptionPane
									.showMessageDialog(
											null,
											"<html>Further update of the record is not allowed. <br>Select valid value for 'Whether interest paid to the lender<br> under the head 'Income from house property''</html>");

								}
							}

							if(column == 34 || column == 35 || column == 36 || column == 37 || column == 38 || column == 39 || column == 40 || column == 41 ){
								if("No".equals(model2.getValueAt(row, 33).toString()) || "--Select--".equals(model2.getValueAt(row, 33).toString())){
									JOptionPane
									.showMessageDialog(
											null,
											"<html>Further update of the record is not allowed. <br>Select valid value for 'Whether house rent allowance claim<br> exceeds rupees one lakh'</html>");

								}
							}
						}

						/*********************************************************/				
						//FRD 2.3 added 16(ia)			
						int selYear_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4));
						int next_year_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(5, 9));
						
						
						/****************** Added for 2.7 Start ********************/
						if(selYear_anne2 > 2017 && next_year_anne2 > 2018){							
							if(column == 17 ){
								JOptionPane
								.showMessageDialog(
										null,
										"<html>Field is applicable till F.Y. 2017-18 only.</html>");
							}
						}
						/***************** Added for 2.7 End  ********************/
						
						if(selYear_anne2 < 2018 && next_year_anne2 < 2019){							
							if(column == 13 ){
								JOptionPane
								.showMessageDialog(
										null,
										"<html>Field is applicable only from F.Y. 2018-19 onwards.</html>");
							}

							/****************** Added for 2.7 Start ********************/
							
									if(column == 59
									|| column == 60
									|| column == 61
									|| column == 62
									|| column == 63
									|| column == 64
									|| column == 65
									|| column == 66
									|| column == 67
									|| column == 68
									|| column == 69
									|| column == 70
									|| column == 71
									|| column == 72
									|| column == 73
									|| column == 74
									|| column == 75
									|| column == 76
									|| column == 77
									|| column == 78
									|| column == 79
									|| column == 80
									|| column == 81
									|| column == 82
									|| column == 83
									|| column == 84
									|| column == 85
									|| column == 86
									|| column == 87
									|| column == 88
									|| column == 89
									|| column == 90
									|| column == 91
									|| column == 92){
								JOptionPane
								.showMessageDialog(
										null,
										"<html>Field is applicable only from F.Y. 2018-19 onwards.</html>");
							}
								
							/***************** Added for 2.7 End  ********************/

						}
						/*********************************************************/	

						/*if(column == 34 || column == 36 || column == 38 || column == 40){
							StrPrevious = model2.getValueAt(row, previousCol);
							StrCurrent = model2.getValueAt(row, currentCol);
						}*/

						//************************************************************
						/*************************************************************************/
						//FRD2.0
						if (selYear_anne2 >= 2020 && model2.getValueAt(row, 93).equals("Yes")){   //RPU 3.6 changes adding blank values
							
							model2.setValueAt("", row, 11);
							model2.setValueAt("", row, 12);
							model2.setValueAt("", row, 13);
							model2.setValueAt("", row, 19);
							model2.setValueAt("", row, 20);
							model2.setValueAt("", row, 62);
							//model2.setValueAt("", row, 63); RPU 3.6 Updated requirement to enable 63rd column
							model2.setValueAt("", row, 66);
							model2.setValueAt("", row, 70);
							model2.setValueAt("", row, 71);
							model2.setValueAt("", row, 72);
							model2.setValueAt("", row, 73);
							model2.setValueAt("", row, 74);
							model2.setValueAt("", row, 75);
							model2.setValueAt("", row, 76);
							model2.setValueAt("", row, 77);
							model2.setValueAt("", row, 80);
							model2.setValueAt("", row, 81);
							model2.setValueAt("", row, 82);
							model2.setValueAt("", row, 83);
							model2.setValueAt("", row, 84);
							model2.setValueAt("", row, 85);
							model2.setValueAt("", row, 86);
							model2.setValueAt("", row, 87);
							model2.setValueAt("", row, 88);
							model2.setValueAt("", row, 89);
							model2.setValueAt("", row, 91);
							model2.setValueAt("", row, 92);
						}

						/*if("No".equals(model2.getValueAt(row, 33).toString())){
							model2.setValueAt("--Select--", row, 34);
							model2.setValueAt("", row, 35);
							model2.setValueAt("--Select--", row, 36);
							model2.setValueAt("", row, 37);
							model2.setValueAt("--Select--", row, 38);
							model2.setValueAt("", row, 39);
							model2.setValueAt("--Select--", row, 40);
							model2.setValueAt("", row, 41);
						}
						else if("--Select--".equals(model2.getValueAt(row, 33).toString())){
							model2.setValueAt("--Select--", row, 34);
							model2.setValueAt("", row, 35);
							model2.setValueAt("--Select--", row, 36);
							model2.setValueAt("", row, 37);
							model2.setValueAt("--Select--", row, 38);
							model2.setValueAt("", row, 39);
							model2.setValueAt("--Select--", row, 40);
							model2.setValueAt("", row, 41);
						}

						if("No".equals(model2.getValueAt(row, 42).toString())){
							model2.setValueAt("--Select--", row, 43);
							model2.setValueAt("", row, 44);
							model2.setValueAt("--Select--", row, 45);
							model2.setValueAt("", row, 46);
							model2.setValueAt("--Select--", row, 47);
							model2.setValueAt("", row, 48);
							model2.setValueAt("--Select--", row, 49);
							model2.setValueAt("", row, 50);
						}
						else if("--Select--".equals(model2.getValueAt(row, 42).toString())){
							model2.setValueAt("--Select--", row, 43);
							model2.setValueAt("", row, 44);
							model2.setValueAt("--Select--", row, 45);
							model2.setValueAt("", row, 46);
							model2.setValueAt("--Select--", row, 47);
							model2.setValueAt("", row, 48);
							model2.setValueAt("--Select--", row, 49);
							model2.setValueAt("", row, 50);
						}*/
						/*************************************************************************/

					} else {
						jTableTransacDetails2.setCellSelectionEnabled(false);
						jTableTransacDetails2.setRowSelectionAllowed(true);
						rowIsSelected = true;
						jTableTransacDetails2.repaint();
					}
				}

			});
			jTableTransacDetails2.addKeyListener(new KeyAdapter() {

				public void keyPressed(KeyEvent e) {

					int col = jTableTransacDetails2.getSelectedColumn();
					int row = jTableTransacDetails2.getSelectedRow();
					if (jTableTransacDetails2.getModel().isCellEditable(row,
							col) == false)
						return;

					if (jTableTransacDetails2.getSelectedColumn() >= 0
							&& (e.getKeyChar() >= ' '
							&& e.getKeyChar() < '\177' || e
							.getKeyChar() == '\b'))
						// model2.setValueAt("", jTableTransacDetails2
						// .getSelectedRow(), jTableTransacDetails2
						// .getSelectedColumn());
						if (e.isControlDown()) {
							if (e.getKeyCode() == 67)
								copy();
							else if (e.getKeyCode() == 86)
								paste();
							else if (e.getKeyCode() == 88)
								cut();
							else if (e.getKeyCode() == 32)
								pasteXL(tabname);
							else if (e.getKeyCode() == 70
									|| e.getKeyCode() == 82)
								if (e.getKeyCode() == 70) {
									FindReplace.mouse_whichTab = "F";
									FindReplace.isFindClk = true;
								} else if (e.getKeyCode() == 82)
									FindReplace.mouse_whichTab = "R";
								else if (GRPU.grpuFindReplace == null)
									GRPU.grpuFindReplace = new FindReplace(
											model2, jTableTransacDetails2,
											numDdoRowsCorr,grpu,"Anne2");

						} else if (e.getKeyCode() == 127)
							deleteCell();

				}

			});

		}
	}

	private void addStaticAnnIIRows(DefaultTableModel model22) {
		// Addition of the two rows.
		Vector<Object> row = new Vector<Object>();
		row.add("<html><center>1</center></html>");
		row.add("<html><center>(330)</html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(331)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(332A)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(333)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(334)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(334)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(338)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(339)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(349)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(350)</center></html>");
		
		

		/*********************************************************/				
		//FRD 2.3 added 16(ia)		
		/*row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(336) and (337)</center></html>");*/
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(348)</center></html>");
		/*********************************************************/	


		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(351)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(352)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(355)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(365)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(366)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(367)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(368)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(370)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(371)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(372)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(373)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(374)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(375)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(376)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(377)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(345)</center></html>");

		//newly added for FRD1.6 by akansha
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(345)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(345)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(345)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(345)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(345)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(353)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");


		//newly added for revised FRD1.6 by akansha

		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");


		/****************** Added for 2.7 Start ********************/
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(335)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(336)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(337)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(340)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(341)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(342)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(343)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(344)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(346)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(347)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(354)</center></html>");
		//RPU 2.9 start
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(356)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(357)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(358)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(359)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(360)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(361)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(362)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(363)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(364)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(369)</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</center></html>");
		row.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(332B)</center></html>");   //RPU 3.7 Addition of new column rahul
		
     	//RPU 2.9 end

		/***************** Added for 2.7 End  ********************/
		

		//**************************************

		model2.addRow(row);
	
		Vector<Object> row1 = new Vector<Object>();
		row1.add("<html><body><p align='right'>2</p></body></html>");
		row1.add("<html><center>1</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;2</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;3</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;4</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;5</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;6</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;7</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;8</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;9</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;10</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;11</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;12</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;13</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;14</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;15</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;16</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;17</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;18</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;19</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;20</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;21</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;22</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;23</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;24</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;25</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;26</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;27</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;28</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;29</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;30</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;31</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;32</center></html>");

		//newly added for FRD1.6 by akansha
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;33</center></html>");
		//1st
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;34</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;35</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;36</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;37</center></html>");
		//2nd
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;38</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;39</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;40</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;41</center></html>");

		//3rd
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;42</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;43</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;44</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;45</center></html>");
		//4th
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;46</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;47</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;48</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;49</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;50</center></html>");

		//newly added for rrvised FRD1.6 by akansha
		//5th
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;51</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;52</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;53</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;54</center></html>");

		//6th
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;55</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;56</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;57</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;58</center></html>");


		//***********************************************	

		/****************** Added for 2.7 Start ********************/
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;59</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;60</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;61</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;62</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;63</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;64</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;65</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;66</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;67</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;68</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;69</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;70</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;71</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;72</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;73</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;74</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;75</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;76</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;77</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;78</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;79</center></html>");
		//RPU 2.9 start
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;80</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;81</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;82</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;83</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;84</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;85</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;86</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;87</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;88</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;89</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;90</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;91</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;92</center></html>");
		row1.add("<html><center>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;93</center></html>");  //RPU 3.6 Addition of new column rahul
		//RPU 2.9 end
		/***************** Added for 2.7 End  ********************/


		model22.addRow(row1);

	}

	private void initializeDDOTab() {

		ddoTabFlag = true;
		final String tabname = "Challan";

		model = new DefaultTableModel() {
			public boolean isCellEditable(int rowIndex, int mColIndex) {

				if (rowIndex == 0 || rowIndex == 1) {
					setBackground(Color.gray.brighter());
					setForeground(Color.black.darker());
					return false;
				}

				if (valueOfTypeOfStmt.equals("Regular")
						|| (valueOfTypeOfStmt.equals("Correction") && (rowIndex >= row_count_challan))) {
					// -- Getting financial year from the drop down and
					// disabling the fields
					if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
						int selYear = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4));
						int next_year = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(5, 9));
						if ((selYear > 2012 && next_year > 2013)
								&& (mColIndex == 2))
							return false;
						if ((selYear < 2012 && next_year < 2013)
								&& mColIndex == 7) // disabling the fee column
							// in challan
							return false;
						if ((selYear >= 2013 && next_year >= 2014)
								&& mColIndex == 11) // for the cheque/DDo Number
							return false;

						// disabling the minor head challan for the year
						// <2013-2014
						if ((mColIndex == 21))

						{
							if (selYear < 2013 && next_year < 2014) {
								return false;

							}

							else if (selYear >= 2013 && next_year >= 2014) {
								String mode_depoist = "";
								Object modeDepositObj = model.getValueAt(
										rowIndex, 18);
								if (modeDepositObj != null)
									mode_depoist = modeDepositObj.toString();

								System.out.println("the mode is "
										+ mode_depoist);
								if (mode_depoist.equals("No"))
									return true;
								else {
									model.setValueAt("--Select--", rowIndex, 21);
									return false;
								}
							}
						}

						// newly added by cholia for the challan section code on
						// 28.02.2015

						colSectionCode = jTableTransacDetails.getColumnModel()
								.getColumn(1);
						if (selYear <= 2009 && next_year <= 2010) {

							if (formNumber.equals("24Q"))
								jComboBox_Section_Code = (new String[] {
										"--Select--", "92A", "92B" });
						
							else if (formNumber.equals("26Q")) {
								jComboBox_Section_Code = (new String[] {
										"--Select--", "193", "194", "94A",
										"94B", "4BB", "94C", "94D", "4EE",
										"94F", "94G", "94H", "94I", "94J",
								"94L" });

							}

							else if (formNumber.equals("27Q")) {
								jComboBox_Section_Code = (new String[] {
										"--Select--", "94E", "195", "96A",
										"96B", "96C", "96D" });

							} else {
								jComboBox_Section_Code = (new String[] {
										"--Select--", "A", "B", "C", "D", "E",
										"F", "G", "H", "I" });

							}

						} else if (selYear >= 2010 && next_year >= 2011) {

							if (formNumber.equals("24Q"))
								jComboBox_Section_Code = (new String[] {
										"--Select--", "92A", "92B" });
							//Section Code changes for RPU 2.9

							else if (formNumber.equals("26Q")) {
									jComboBox_Section_Code = (new String[] {
										"--Select--", "193", "194", "94A",
										"94B", "4BB", "94C", "94D", "4EE",
										"94F", "94G", "94H", "94I", "94J",
								"94L" });

							}

							else if (formNumber.equals("27Q")) {
								if (selYear >= 2011 && selYear < 2012) { // Observation
									// Defect
									// fix
									// :
									// 361
									// ----
									// Akansha
									jComboBox_Section_Code = (new String[] {
											"--Select--", "94E", "195", "96A",
											"96B", "96C", "96D", "4LB" });
								} else if (selYear >= 2012 && selYear < 2014) {
									jComboBox_Section_Code = (new String[] {
											"--Select--", "94E", "195", "96A",
											"96B", "96C", "96D", "4LB", "4LC" });
								}
									else
									jComboBox_Section_Code = (new String[] {
											"--Select--", "94E", "195", "96A",
											"96B", "96C", "96D"});
								// End of Defect fix
								// Observation Defect fix : 356 --- Akansha
								if (selYear >= 2014)
									if (jComboBox_Quarter.getSelectedIndex() != 0)
										if ("Q3".equals(jComboBox_Quarter
												.getSelectedItem().toString())
												|| "Q4".equals(jComboBox_Quarter
														.getSelectedItem()
														.toString())) {
											jComboBox_Section_Code = (new String[] {
													"--Select--", "94E", "195",
													"96A", "96B", "96C", "96D",
													"4LB", "4LC", "4BA"});// new development for FRD1.3 by Akansha
										}
								// End of Observation
							}

							else {
								if (jComboBox_Quarter.getSelectedItem() != null) {
									if (jComboBox_Quarter.getSelectedItem()
											.equals("Q2")
											|| jComboBox_Quarter
											.getSelectedItem().equals(
													"Q3")
													|| jComboBox_Quarter
													.getSelectedItem().equals(
															"Q4")) {
										// Observation Defect fix: 355 ---- By
										// akansha
										if (selYear >= 2012) {
											jComboBox_Section_Code = (new String[] {
													"--Select--", "A", "B",
													"C", "D", "E", "F", "G",
													"H", "I", "J", "K" });
										} else {
											jComboBox_Section_Code = (new String[] {
													"--Select--", "A", "B",
													"C", "D", "E", "F", "G",
													"H", "I", });
										}
										// End of Obsv defect fix

									} else

										jComboBox_Section_Code = (new String[] {
												"--Select--", "A", "B", "C",
												"D", "E", "F", "G", "H", "I" });

								}
							}
						}

						final MyComboBoxEditor scetionCodeDropDown = new MyComboBoxEditor(
								jComboBox_Section_Code);

						scetionCodeDropDown.getComponent().setBackground(
								Color.white);
						//Temp code
						((JComboBox) scetionCodeDropDown.getComponent()).setRenderer(new MyComboBoxRenderer(jComboBox_Section_Code,(JComboBox) scetionCodeDropDown.getComponent(),formNumber));

						//************ End of temp code************************

						if (valueOfTypeOfStmt.toString().equals("Correction")
								|| valueOfTypeOfStmt.toString().equals(
										"Regular")) // newly added by cholia on
							// 27022015
						{
							final int row_naya = rowIndex;

							((JComboBox) scetionCodeDropDown.getComponent())
							.addActionListener(new ActionListener() {

								public void actionPerformed(
										ActionEvent e) {
									String challanSecCode = ((JComboBox) scetionCodeDropDown
											.getComponent())
											.getSelectedItem()
											.toString();

									for (int i = 2; i < model1
											.getRowCount(); i++) {

										if (Integer.parseInt(model1
												.getValueAt(i, 1)
												.toString()) == row_naya - 1) {
											//													System.out.println("the vini is "
											//															+ Integer
											//																	.parseInt(model1
											//																			.getValueAt(
											//																					i,
											//																					1)
											//																			.toString()));
											model1.setValueAt(
													challanSecCode, i,
													6);
										}

									}

									// end //newly added by cholia for
									// the population of section code
								}
							});

						}
						colSectionCode.setCellEditor(scetionCodeDropDown); // newly

					}
					// end newly added by cholia for the challan section code on
					// 28.02.2015
					// -- To disable the first two rows after the model

					if (mColIndex == 1 || mColIndex == 9 || mColIndex == 10
							|| mColIndex == 0 || mColIndex == 12
							|| mColIndex == 14 || mColIndex == 16
							|| mColIndex == 22) // mColIndex==14 for last date
						return false;

					else
						return true;
					// Added by Akansha for enabling and disabling of the
					// challan fields
				} else if (valueOfTypeOfStmt.equals("Correction")
						&& (rowIndex < row_count_challan)) {

					String mode = "";
					Object modeObj = model.getValueAt(rowIndex, 1);
					if (modeObj != null)
						mode = modeObj.toString();

					if (mColIndex == 9 || mColIndex == 10 || mColIndex == 0
							|| mColIndex == 12 || mColIndex == 14
							|| mColIndex == 16 || mColIndex == 22) // mColIndex==14
						// for last
						// date
						return false;

					if (mColIndex == 1 && !"ADD".equals(mode)) // For enabling
						// the updation
						// mode of the
						// challan
						return true;

					if (rowIndex < row_count_challan) { // added for enabling
						// and disabling of the
						// existing rows
						if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
							int selYear_challan = Integer
									.parseInt(JComboBox_Form_Sub1_finYear
											.getSelectedItem().toString()
											.substring(0, 4));
							int next_year_challan = Integer
									.parseInt(JComboBox_Form_Sub1_finYear
											.getSelectedItem().toString()
											.substring(5, 9));

							// newly added on 11032015
							colSectionCode = jTableTransacDetails
									.getColumnModel().getColumn(1);
							if (selYear_challan <= 2009
									&& next_year_challan <= 2010) {

								if (formNumber.equals("24Q"))
									jComboBox_Section_Code = (new String[] {
											"--Select--", "92A", "92B" });
								else if (formNumber.equals("26Q")) {
									jComboBox_Section_Code = (new String[] {
											"--Select--", "193", "194", "94A",
											"94B", "4BB", "94C", "94D", "4EE",
											"94F", "94G", "94H", "94I", "94J",
									"94L" });

								}

								else if (formNumber.equals("27Q")) {
									jComboBox_Section_Code = (new String[] {
											"--Select--", "94E", "195", "96A",
											"96B", "96C", "96D" });

								} else {
									jComboBox_Section_Code = (new String[] {
											"--Select--", "A", "B", "C", "D",
											"E", "F", "G", "H", "I" });

								}

							} else if (selYear_challan >= 2010
									&& next_year_challan >= 2011) {

								if (formNumber.equals("24Q"))
									jComboBox_Section_Code = (new String[] {
											"--Select--", "92A", "92B" });
								else if (formNumber.equals("26Q")) {
									jComboBox_Section_Code = (new String[] {
											"--Select--", "193", "194", "94A",
											"94B", "4BB", "94C", "94D", "4EE",
											"94F", "94G", "94H", "94I", "94J",
									"94L" });

								}

								else if (formNumber.equals("27Q")) {
									if (selYear_challan >= 2011
											&& selYear_challan < 2012) { // Observation
										// Defect
										// fix
										// :
										// 361
										// ----
										// Akansha
										jComboBox_Section_Code = (new String[] {
												"--Select--", "94E", "195",
												"96A", "96B", "96C", "96D",
										"4LB" });
									} else if (selYear_challan >= 2012
											&& selYear_challan < 2014) {
										jComboBox_Section_Code = (new String[] {
												"--Select--", "94E", "195",
												"96A", "96B", "96C", "96D",
												"4LB", "4LC" });
									} else
										jComboBox_Section_Code = (new String[] {
												"--Select--", "94E", "195",
												"96A", "96B", "96C", "96D" });
									// End of Defect fix
									// Observation Defect fix : 356 --- Akansha
									if (selYear_challan >= 2014)
										if (jComboBox_Quarter
												.getSelectedIndex() != 0)
											if ("Q3".equals(jComboBox_Quarter
													.getSelectedItem()
													.toString())
													|| "Q4".equals(jComboBox_Quarter
															.getSelectedItem()
															.toString())) {
												jComboBox_Section_Code = (new String[] {
														"--Select--", "94E",
														"195", "96A", "96B",
														"96C", "96D", "4LB",
														"4LC", "4BA" }); // new development for FRD1.3 by Akansha
											}
									// End of Observation
								}

								else {
									if (jComboBox_Quarter.getSelectedItem() != null) {
										if (jComboBox_Quarter.getSelectedItem()
												.equals("Q2")
												|| jComboBox_Quarter
												.getSelectedItem()
												.equals("Q3")
												|| jComboBox_Quarter
												.getSelectedItem()
												.equals("Q4")) {
											// Observation Defect fix: 355 ----
											// By akansha
											if (selYear_challan >= 2012) {
												jComboBox_Section_Code = (new String[] {
														"--Select--", "A", "B",
														"C", "D", "E", "F",
														"G", "H", "I", "J", "K" });
											} else {
												jComboBox_Section_Code = (new String[] {
														"--Select--", "A", "B",
														"C", "D", "E", "F",
														"G", "H", "I", });
											}
											// End of Obsv defect fix

										} else
											jComboBox_Section_Code = (new String[] {
													"--Select--", "A", "B",
													"C", "D", "E", "F", "G",
													"H", "I" });

									}
								}
							}


							final MyComboBoxEditor scetionCodeDropDown = new MyComboBoxEditor(
									jComboBox_Section_Code);

							scetionCodeDropDown.getComponent().setBackground(
									Color.white);




							if (valueOfTypeOfStmt.toString().equals(
									"Correction")
									|| valueOfTypeOfStmt.toString().equals(
											"Regular")) // newly added by cholia
								// on 27022015
							{

								//Temp code
								((JComboBox) scetionCodeDropDown.getComponent()).setRenderer(new MyComboBoxRenderer(jComboBox_Section_Code,(JComboBox) scetionCodeDropDown.getComponent(),formNumber));

								//************ End of temp code************************


								final int row_naya = rowIndex;

								((JComboBox) scetionCodeDropDown.getComponent())
								.addActionListener(new ActionListener() {

									public void actionPerformed(
											ActionEvent e) {
										String challanSecCode = ((JComboBox) scetionCodeDropDown
												.getComponent())
												.getSelectedItem()
												.toString();

										for (int i = 2; i < model1
												.getRowCount(); i++) {

											if (Integer.parseInt(model1
													.getValueAt(i, 1)
													.toString()) == row_naya - 1) {
												//														System.out.println("the vini is "
												//																+ Integer
												//																		.parseInt(model1
												//																				.getValueAt(
												//																						i,
												//																						1)
												//																				.toString()));
												model1.setValueAt(
														challanSecCode,
														i, 6);
											}

										}

										// end //newly added by cholia
										// for the population of section
										// code
									}
								});

							}
							colSectionCode.setCellEditor(scetionCodeDropDown); // newly
							// end

							// till financial year 2009 2010
							if (selYear_challan <= 2009
									&& next_year_challan <= 2010) {
								if (mode.equalsIgnoreCase("UPDATE")) {

									if (challantype.charAt(rowIndex - 2) == 'U') {
										if (mColIndex == 2 || mColIndex == 3
												|| mColIndex == 4
												|| mColIndex == 5
												|| mColIndex == 6
												|| mColIndex == 8
												|| mColIndex == 11
												|| mColIndex == 13
												|| mColIndex == 15
												|| mColIndex == 17
												|| mColIndex == 18
												|| mColIndex == 19
												|| mColIndex == 20
												|| mColIndex == 22) {
											return true;
										}

										if (selYear_challan >= 2013
												&& next_year_challan >= 2014) { // ##
											// Newly
											// developed
											// for
											// correction
											// Ver1.2
											// by
											// Akansha
											String mode_depoist = "";
											Object modeDepositObj = model
													.getValueAt(rowIndex, 18);
											if (modeDepositObj != null)
												mode_depoist = modeDepositObj
												.toString();

											if (mColIndex == 21
													&& "No".equals(mode_depoist))
												return true;
											else if (mColIndex == 21
													&& !"No".equals(mode_depoist)) {
												model.setValueAt("--Select--",
														rowIndex, 21);
												return false;
											}
										}

									} else if (challantype.charAt(rowIndex - 2) == 'O') {
										if (mColIndex == 2 || mColIndex == 19
												|| mColIndex == 20) {
											return true;
										}

									} else if (challantype.charAt(rowIndex - 2) == 'M') {
										if (mColIndex == 2 || mColIndex == 19
												|| mColIndex == 20) {
											return true;
										}
									} else if (challantype.charAt(rowIndex - 2) == 'P') {
										if (mColIndex == 2 || mColIndex == 13
												|| mColIndex == 15
												|| mColIndex == 17
												|| mColIndex == 19
												|| mColIndex == 20) {
											return true;
										}
									}
								}
								if (mode.equalsIgnoreCase("ADD")) {
									if (mColIndex == 1)
										return false;
									if (mColIndex == 2 || mColIndex == 3
											|| mColIndex == 4 || mColIndex == 5
											|| mColIndex == 6 || mColIndex == 8
											|| mColIndex == 11
											|| mColIndex == 13
											|| mColIndex == 15
											|| mColIndex == 17
											|| mColIndex == 18
											|| mColIndex == 19
											|| mColIndex == 20
											|| mColIndex == 22) {
										return true;
									}
								}
							} else {
								if (mode.equalsIgnoreCase("UPDATE")) {

									System.out
									.println("LATISHHHHHHHHHHHHHHHHHHHH:"
											+ challantype
											.charAt(rowIndex - 2));

									if (challantype.charAt(rowIndex - 2) == 'U') {
										if (mColIndex == 3 || mColIndex == 4
												|| mColIndex == 5
												|| mColIndex == 6
												|| mColIndex == 8
												|| mColIndex == 11
												|| mColIndex == 13
												|| mColIndex == 15
												|| mColIndex == 17
												|| mColIndex == 18
												|| mColIndex == 19
												|| mColIndex == 20
												|| mColIndex == 22) {
											System.out
											.println("INSIDEEEEEEEEEEEEEEEEEEEEEEEEEE");
											return true;
										}
										if (selYear_challan <= 2012
												&& next_year_challan <= 2013) {
											if (mColIndex == 2)
												return true;
										}
										if (selYear_challan <= 2012
												&& next_year_challan <= 2013) {
											if (mColIndex == 11)
												return true;
										}
										if (selYear_challan >= 2012
												&& next_year_challan >= 2013) {
											if (mColIndex == 7)
												return true;
										}
										if (selYear_challan >= 2013
												&& next_year_challan >= 2014) { // ##
											// Newly
											// developed
											// for
											// correction
											// Ver1.2
											// by
											// Akansha
											String mode_depoist = "";
											Object modeDepositObj = model
													.getValueAt(rowIndex, 18);
											if (modeDepositObj != null)
												mode_depoist = modeDepositObj
												.toString();

											if (mColIndex == 21
													&& "No".equals(mode_depoist))
												return true;
											else if (mColIndex == 21
													&& !"No".equals(mode_depoist)) {
												model.setValueAt("--Select--",
														rowIndex, 21);
												return false;
											}
										}
									} else if (challantype.charAt(rowIndex - 2) == 'O') {
										if (mColIndex == 19 || mColIndex == 20) {
											return true;
										}
										if (selYear_challan <= 2012
												&& next_year_challan <= 2013) {
											if (mColIndex == 2)
												return true;
										}
									} else if (challantype.charAt(rowIndex - 2) == 'M') {
										if (mColIndex == 19 || mColIndex == 20) {
											return true;
										}
										if (selYear_challan <= 2012
												&& next_year_challan <= 2013) {
											if (mColIndex == 2)
												return true;
										}
									} else if (challantype.charAt(rowIndex - 2) == 'P') {
										if (mColIndex == 13 || mColIndex == 15
												|| mColIndex == 17
												|| mColIndex == 19
												|| mColIndex == 20) {
											return true;
										}
										if (selYear_challan <= 2012
												&& next_year_challan <= 2013) {
											if (mColIndex == 2)
												return true;
										}
									}
								}
								if (mode.equalsIgnoreCase("ADD")) {
									if (mColIndex == 1)
										return false;
									if (mColIndex == 2 || mColIndex == 3
											|| mColIndex == 4 || mColIndex == 5
											|| mColIndex == 6 || mColIndex == 8
											|| mColIndex == 11
											|| mColIndex == 13
											|| mColIndex == 15
											|| mColIndex == 17
											|| mColIndex == 18
											|| mColIndex == 19
											|| mColIndex == 20
											|| mColIndex == 22) {
										return true;
									}
								}
							}
						}
					}

					return false;
				}
				// *********************************************************************
				return false;// added by amit
			}

		};

		// amit here

		jTableTransacDetails = new JTable(model) {

			public Component prepareRenderer(TableCellRenderer renderer,
					int rowIndex, int vColIndex) {

				Component c = super.prepareRenderer(renderer, rowIndex,
						vColIndex);
				Color prevColor = Color.white;
				if (c instanceof JComponent) {
					JComponent jc = (JComponent) c;
					if (vColIndex == 0) {
						jc.setToolTipText((String) getValueAt(rowIndex,
								vColIndex));
					}
					else if(vColIndex == 1){
						//new development for FRD1.5 by akansha
						// System.out.println("Sections: "+sections[i] );
						if("92A".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("192 - 92A - Payment to Govt. Employees other than Union Government Employees");
						}else if("92B".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("192 - 92B - Payment of Employees other than Govt. Employee");
						}else if("92C".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("<html>192 - 92C - Payments made to Union Govt. employees.<br>(Applicable from statement pertaining to FY 2013-14 onwards)</html>");
						}
						else if("193".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("193 - Interest on Securities");
						}
						else if("194".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194 - Dividend");
						}
						else if ("194IC".equals((String) getValueAt(
								rowIndex, vColIndex))) {
							jc.setToolTipText("194IC - Payment under specified agreement");
						}
						//Section Code changes for RPU 2.9
						else if ("94N".equals((String) getValueAt(
								rowIndex, vColIndex))) {
							jc.setToolTipText("194N - Payment of certain amounts in cash");
						}
						else if("94A".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194A - Interest other than interest on securities");
						}
						else if("94B".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194B - Winnings from lotteries and crossword puzzles");
						}
						else if("4BB".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194BB - Winnings from horse race");
						}
						else if("94C".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194C - Payment of contractors and sub-contractors");
						}
						else if("94D".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194D - Insurance Commission");
						}
						else if("4EE".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194EE - Payments in respect of Deposits under National Savings Schemes");
						}
						else if("94F".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194F - Payments on account of Re-purchase of Units by Mutual Funds or UTI");
						}
						else if("94G".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194G - Commission, prize etc., on sale of Lottery tickets");
						}
						else if("94H".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194H - Commission or Brokerage");
						}
						else if("94I".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194I - Rent (Applicable upto FY 2012-13)");
						}
						else if("4IA".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194I (a) - Rent on Machinery, Plant or Equipment (Applicable from FY 2013-14 onwards)");
						}
						else if("4IB".equals((String) getValueAt(rowIndex,
								vColIndex))){
							jc.setToolTipText("194I (b) - Rent on Land or Building (Applicable from FY 2013-14 onwards)");
						}
						else if("94J".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("194J - Fees for Professional or Technical Services");
						}
						//RPU 3.3 start
						else if ("4JA".equals((String) getValueAt(rowIndex, vColIndex))) 
						{
							jc.setToolTipText("194J (a) - Fees for Technical Services (not being professional services), royalty for sale, distribution or exhibition of cinematographic films and call centre (@2%)");
						} 
						else if ("4JB".equals((String) getValueAt(rowIndex, vColIndex)))
						{
							jc.setToolTipText("194J (b) - Fee for professional service or royalty etc. (@10%)");
					}
						else if("94K".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{ 
							jc.setToolTipText("194K - TDS on income from Mutual Fund units");//RPU 3.2 start addition of new section 94K for form 26Q
						}
						else if("94L".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("194LA - Payment of Compensation on acquisition of certain immovable property");
						}
					 else if ("94O".equals((String) getValueAt(
							rowIndex, vColIndex))) {
						jc.setToolTipText("194O - TDS on E-commerce transactions"); //RPU 3.5 start Addition of new section codes 
					 }
						
					 else if ("94Q".equals((String) getValueAt(
								rowIndex, vColIndex))) {
							jc.setToolTipText("194Q- Payment of certain sums for purchase of goods"); //RPU 3.5 start Addition of new section codes 
						 }
					
						else if("4BA".equals((String) getValueAt(rowIndex,
								vColIndex))) // new development for FRD1.3 by Akansha
						{
							jc.setToolTipText("<html>194LBA  - Certain income from units of business trust<br> (Applicable from FY 2014-15 Q3 onwards.)</html>");
						}
						else if("4DA".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>194DA  - Payment in respect of life insurance policy<br> (Applicable from FY 2014-15 Q3 onwards)</html>");
						}
						else if("2AA".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>192A  - Payment of accumulated balance due to an employee made by the trustees of the Employees<br> Provident Fund Scheme, 1952. (Applicable for statements pertaining to FY 2015-16 onwards)</html>");
						}
						else if("LBB".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>194LBB -  - Income in respect of units of investment fund <br>(Applicable for statements pertaining to FY 2015-16 onwards)</html>");
						}
						else if("94E".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("194E - Payments to non-resident Sportsmen/Sport Associations");
						}
						else if("195".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("195 - Other sums payable to a non-resident");
						}
						else if("96A".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("196A - Income in respect of units of Non-Residents");
						}
						else if("96B".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("196B - Payments in respect of Units to an Offshore Fund");
						}
						else if("96C".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>196C - Income from foreign Currency Bonds or <br>shares of Indian Company payable to Non-Resident</html>");
						}
						else if("96D".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("196D - Income of foreign institutional investors from securities");
						}
						else if("6DA".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>196D(1A)- Income of specified fund from securities <br>referred to in clause (a) of sub-section (1) <br>of section 115AD (other than interest income referred to in section 194LD)</html>");
						//CR 80278 new section code 196DP
						}
						else if("4LB".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>194LB  - Income by way of Interest from <br>Infrastructure Debt fund (Applicable from FY 2011-12 onwards)</html>");
						}
						else if("4LC".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>194LC  - Income by way of interest from Indian company engaged <br>in certain business. (Applicable from FY 2012-13 onwards).</html>");
						}
						else if("4LD".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("194LD  - (Applicable from FY 2013-14 onwards)");
						}
						else if("4BA".equals((String) getValueAt(rowIndex,
								vColIndex)))// new development for FRD1.3 by Akansha
						{
							jc.setToolTipText("<html>194LBA  - Certain income from units of business trust <br>(Applicable from FY 2014-15 Q3 onwards.)</html>");
						}
						else if("LBB".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>194LBB -  - Income in respect of units of investment fund - <br>(Applicable for statements pertaining to FY 2015-16 onwards) </html>");
						}
						
						else if("A".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("206C - A - Collection at source from Alcoholic Liquor for Human Consumption");
						}
						else if("B".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("206C - B - Collection at source from timber obtained under Forest Lease");
						}
						else if("C".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>206C - C - Collection at source from Timber <br>obtained by any Mode other than a Forest Lease</html>");
						}
						else if("D".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>206C - D - Collection at source from any other <br>Forest Produce (not being Tendu Leaves)</html>");
						}
						else if("E".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("206C - E - Collection at source from Scrap");
						}
						else if("F".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("206C - F - Collection at source from contractors or licensee or lease relating to Parking lots");
						}
						else if("G".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("206C - G - Collection at source from contractors or licensee or lease relating to toll plaza");
						}
						else if("H".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("206C - H - Collection at source from contractors or licensee or lease relating to mine or quarry");
						}
						else if("I".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("206C - I - Collection at source from tendu leaves");
						}
						else if("J".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>206C - J - Collection at source from on sale of certain <br>Minerals (Applicable from 2nd Quarter of FY 2012-13 onwards)</html>");
						}
						else if("K".equals((String) getValueAt(rowIndex,
								vColIndex)))
						{
							jc.setToolTipText("<html>206C - K - Collection at source on cash case of Bullion and <br>Jewellery (Applicable from 2nd Quarter of FY 2012-13 onwards)</html>");
						}
						//**************************************************************
					}//For RPU 2.6
					else if(vColIndex == 2 && formNumber.equals("27EQ")){
						jc.setToolTipText("TCS");
					}
					else {
						String toolTipval = cellTooltip(vColIndex);
						jc.setToolTipText(toolTipval);
					}
				}
				return c;
			}

		};

		jTableTransacDetails.setPreferredScrollableViewportSize(new Dimension(500, 70));
		//jTableTransacDetails.setPreferredScrollableViewportSize(new Dimension(1355, 445));
		jTableTransacDetails.setGridColor(Color.orange);
		jTableTransacDetails.setRowHeight(20);
		JScrollPane jScrollPane7 = new JScrollPane(jTableTransacDetails);

		jScrollPane7.setViewportView(jTableTransacDetails);
		jScrollPane7.getViewport ().setScrollMode ( JViewport.BACKINGSTORE_SCROLL_MODE );
		//jScrollPane7.getViewport ().setScrollMode ( JViewport.SIMPLE_SCROLL_MODE );
		jTableTransacDetails.getTableHeader().setReorderingAllowed(false);
		jTableTransacDetails.getTableHeader().setFont(font);
		jTableTransacDetails.setRowSelectionAllowed(false);
		jTableTransacDetails.setColumnSelectionAllowed(false);
		jTableTransacDetails.setCellSelectionEnabled(true);
		jTableTransacDetails.setSurrendersFocusOnKeystroke(true); // Added for
		// issue on
		// 24042015
		viewport = (JViewport) jTableTransacDetails.getParent();
		rect = jScrollPane7.getViewportBorderBounds();
		pt = viewport.getViewPosition();
		PanelTransacDet.setLayout(new GridLayout(1, 0, 0, 0));
		PanelTransacDet.add(jScrollPane7, 0);

		/*****************************************************************************/
		//Added by Sadhana, 
		/*jPanelTab1.setLayout(null);
		jPanelTab1.setPreferredSize(new Dimension(1355,700));
		jlabelAdv1.setBounds(10, 10, 500, 100);
		jPanelTab1.add(jlabelAdv1);
		jScrollPane7.setBounds(0, 100, 1355, 445);
		jPanelTab1.add(jScrollPane7);
		PanelTransacDet.add(jPanelTab1);*/
		/*****************************************************************************/

		// New Added
		JTableHeader jHeaderTransacDetails = jTableTransacDetails.getTableHeader();
		jHeaderTransacDetails.setPreferredSize(new Dimension(50000, 80));

		// -- To add Rupee symbol
		URL url = null;
		try {
			url = getClass().getResource("/images/rp.png");
			if (url == null)
			{System.out.println("Cannot find image at specified location");
				throw new Exception();
			}

		} catch (Exception e) {
			System.err.println("Exception  while creating the Rupee image : ");
			e.printStackTrace();

		}

		// -- end

		// New code Added By model for Challan
		model.addColumn("<html><center>Sr. No.</center></html>"); // 0
		model.addColumn("<html><center>Update<br>Mode For<br>Challan</center></html>"); // 1
		model.addColumn("<html><center>Section Code </center></html>"); // 2

		//For RPU 2.6
		if (formNumber.equals("27EQ"))
			model.addColumn("<html><center>TCS<br><img src='" + url
					+ "'  height='12' width='10'  > </img></center> </html>"); // 3
		else 
			model.addColumn("<html><center>TDS<br><img src='" + url
					+ "'  height='12' width='10'  > </img></center> </html>"); // 3

		model.addColumn("<html><center>Surcharge<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 4
		model.addColumn("<html><center>Education<br> Cess<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 5
		model.addColumn("<html><center>Interest<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 6
		model.addColumn("<html><center>Fee<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 7

		model.addColumn("<html><center>Penalty/<br>Others<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 8

		model.addColumn("<html><center>Last Total<br>Tax<br>Deposited<br><img src='"
				+ url + "'  height='12' width='10'  > </img></center></html>"); // 9

		model.addColumn("<html><center>Total Amount Deposited<br>as per challan /<br>Book Adjustment<br>(4+5+6+7+8+9)<br><img src='"
				+ url + "'  height='12' width='10'  > </img></center></html>"); // 10

		model.addColumn("<html><center>Cheque /<br>DD No.<br>(if any)</center></html>");// 11
		model.addColumn("<html><center>Last BSR Code / <br> 24G Receipt No.</center><html>"); // 12

		model.addColumn("<html><center>BSR Code / <br>  Receipt Number of <br>Form No. 24G</center></html>"); // 13

		model.addColumn("<html><center>Last Date<br>on which<br>Tax Deposited</center></html>");// 14
		model.addColumn("<html><center>Date on which Amount <br>Deposited through Challan /<br>Date of Transfer<br> Voucher (DD/MM/YYYY)</center></html>"); // 15
		model.addColumn("<html><center>Last DDO / <br>Transfer Voucher / <br>Challan Serial No. </center></html>"); // 16
		model.addColumn("<html><center>Challan Serial No. / <br>DDO Serial No. of <br>Form No. 24G</center></html>"); // 17
		// Whether TDS Deposited by Book Deposited by Book Entry? (Yes/No)
		model.addColumn("<html><center>Mode of Deposit<br> through Book <br> Adjustment (Yes/No)</center></html>"); // 18
		model.addColumn("<html><center>Interest to<br>be allocated / <br>apportioned<br><img src='"
				+ url + "'  height='12' width='10'  > </img></center></html>");// 19
		model.addColumn("<html><center>Others<br><img src='" + url
				+ "'  height='12' width='10'  > </img></center></html>"); // 20
		model.addColumn("<html><center>Minor Head of <br>Challan 200-TDS<br>payable by taxpayer<br>400-TDS regular assessment<br>(Raised by IT Dept)</center></html>"); // 21
		model.addColumn("<html><center>Challan Balance<br> as per <br>consolidated file</center></html>");// 22

		// Adding the first row after the model

		addStaticRows(model);

		// end second row
		packColumn(jTableTransacDetails, 0, 15);
		packColumn(jTableTransacDetails, 1, 30);
		packColumn(jTableTransacDetails, 2, 15);
		packColumn(jTableTransacDetails, 3, 80);
		packColumn(jTableTransacDetails, 4, 50);
		packColumn(jTableTransacDetails, 5, 50);
		packColumn(jTableTransacDetails, 6, 60);
		packColumn(jTableTransacDetails, 7, 80);
		packColumn(jTableTransacDetails, 8, 60);
		packColumn(jTableTransacDetails, 9, 60);
		packColumn(jTableTransacDetails, 10, -30);
		packColumn(jTableTransacDetails, 11, 50);
		packColumn(jTableTransacDetails, 12, 15);
		packColumn(jTableTransacDetails, 13, -5);
		packColumn(jTableTransacDetails, 14, 15);
		packColumn(jTableTransacDetails, 15, 0);
		packColumn(jTableTransacDetails, 16, 20);
		packColumn(jTableTransacDetails, 17, 15);
		packColumn(jTableTransacDetails, 18, -10);
		packColumn(jTableTransacDetails, 19, 30);
		packColumn(jTableTransacDetails, 20, 60);
		// packColumn(jTableTransacDetails, 21, 40);
		packColumn(jTableTransacDetails, 21, 10);
		packColumn(jTableTransacDetails, 22, 0);
		// end By amit

		// added by for fix column
		FixedColumnTable fct = new FixedColumnTable(1, jScrollPane7);
		jTableTransacDetails.setAutoResizeMode(0);

		int selYear_chaln_colour = 0;
		int next_year_chaln_colour = 0;

		if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
			selYear_chaln_colour = Integer.parseInt(JComboBox_Form_Sub1_finYear
					.getSelectedItem().toString().substring(0, 4));
			next_year_chaln_colour = Integer
					.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem()
							.toString().substring(5, 9));
			System.out.println("inside challan selYear_chaln_colour  "
					+ selYear_chaln_colour);
		}
		// end
		TableColumn updtModeChln = jTableTransacDetails.getColumnModel()
				.getColumn(0);
		// updtModeChln.setCellEditor(new GRPUTableCellEditorUpdMode()); // ---
		// by
		// Akansha

		updtModeChln.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		TableColumn sectionCode = jTableTransacDetails.getColumnModel()
				.getColumn(1);
		sectionCode.setCellEditor(new GRPUTableCellEditorTAN());
		//sectionCode.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// validation

		TableColumn tds = jTableTransacDetails.getColumnModel().getColumn(2);
		tds.setCellEditor(new GRPUTableCellEditorTdsAmount());
		tds.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		TableColumn surCharge = jTableTransacDetails.getColumnModel()
				.getColumn(3);
		surCharge.setCellEditor(new GRPUTableCellEditorSurChargAmount());
		surCharge.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		TableColumn educationCess = jTableTransacDetails.getColumnModel()
				.getColumn(4);
		educationCess.setCellEditor(new GRPUTableCellEditorEduCess());
		educationCess.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		TableColumn interset = jTableTransacDetails.getColumnModel().getColumn(
				5);
		interset.setCellEditor(new GRPUTableCellEditorIntrstChallan());
		interset.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		TableColumn fee = jTableTransacDetails.getColumnModel().getColumn(6);
		fee.setCellEditor(new GRPUTableCellEditorFeeChallan());
		fee.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		TableColumn others = jTableTransacDetails.getColumnModel().getColumn(7);
		others.setCellEditor(new GRPUTableCellEditorOthersChallan());
		others.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		TableColumn lastTaxDeposited = jTableTransacDetails.getColumnModel()
				.getColumn(8);
		lastTaxDeposited.setCellEditor(new GRPUTableCellEditorDDOCode());
		lastTaxDeposited.setCellRenderer(new GRPUTableCellRenderer(tabname,
				false));

		TableColumn totalTaxDeposited = jTableTransacDetails.getColumnModel()
				.getColumn(9);
		totalTaxDeposited
		.setCellEditor(new GRPUTableCellEditorTotalTaxDeposited());
		totalTaxDeposited.setCellRenderer(new GRPUTableCellRenderer(tabname,
				true));

		// cheque DDNo
		TableColumn ddNo = jTableTransacDetails.getColumnModel().getColumn(10);
		ddNo.setCellEditor(new GRPUTableCellEditorChequeNo());

		// DDNo End

		// lastBsrCode
		TableColumn lastBsrCode = jTableTransacDetails.getColumnModel()
				.getColumn(11);
		lastBsrCode.setCellEditor(new GRPUTableCellEditorLastBsrCode());
		lastBsrCode.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// End lastBsrCode

		TableColumn bsdrCode = jTableTransacDetails.getColumnModel().getColumn(
				12);
		bsdrCode.setCellEditor(new GRPUTableCellEditorBsrCode());
		bsdrCode.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		TableColumn lastDateTaxDeptd = jTableTransacDetails.getColumnModel()
				.getColumn(13);
		lastDateTaxDeptd
		.setCellEditor(new GRPUTableCellEditorLastDateTaxDepstd());
		lastDateTaxDeptd.setCellRenderer(new GRPUTableCellRenderer(tabname,
				false));

		TableColumn dateTaxDeptd = jTableTransacDetails.getColumnModel()
				.getColumn(14);
		dateTaxDeptd.setCellEditor(new GRPUTableCellEditorDateOfTaxDepstd(mainObject));
		dateTaxDeptd.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		TableColumn lastTransVoucher = jTableTransacDetails.getColumnModel()
				.getColumn(15);
		lastTransVoucher
		.setCellEditor(new GRPUTableCellEditorlastTransVoucher());
		lastTransVoucher.setCellRenderer(new GRPUTableCellRenderer(tabname,
				false));

		TableColumn transVoucher = jTableTransacDetails.getColumnModel()
				.getColumn(16);
		transVoucher.setCellEditor(new GRPUTableCellEditortransVoucher());
		transVoucher.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// bookentry
		TableColumn bookEntry = jTableTransacDetails.getColumnModel().getColumn(17);
		bookEntry.setCellEditor(new GRPUTableCellEditorBookEntry());
		bookEntry.setCellRenderer(new GRPUTableCellRenderer(tabname, false));

		// Interest
		TableColumn interestAllocated = jTableTransacDetails.getColumnModel()
				.getColumn(18);
		interestAllocated
		.setCellEditor(new GRPUTableCellEditorIntrstAllctdChallan());
		interestAllocated.setCellRenderer(new GRPUTableCellRenderer(tabname,
				true));

		TableColumn othersChallanB = jTableTransacDetails.getColumnModel()
				.getColumn(19);
		othersChallanB.setCellEditor(new GRPUTableCellEditorOthersChallanB());
		othersChallanB
		.setCellRenderer(new GRPUTableCellRenderer(tabname, true));

		// minorHeadChallan
		TableColumn minorHeadChallan = jTableTransacDetails.getColumnModel().getColumn(20);
		minorHeadChallan.setCellEditor(new GRPUTableCellEditorMinorHeadChallan());
		minorHeadChallan.setCellRenderer(new GRPUTableCellRenderer(tabname,false));
		// commented

		TableColumn ChallanConsolidated = jTableTransacDetails.getColumnModel()
				.getColumn(21);
		ChallanConsolidated
		.setCellEditor(new GRPUTableCellEditorChallanConsolidated());
		ChallanConsolidated.setCellRenderer(new GRPUTableCellRenderer(tabname,
				false));

		// amit end

		jTableTransacDetails.getTableHeader().setResizingAllowed(true);

		// added to enable tabout to TAN directly after serial no for Regular
		// File ans similar for correction File.
		Action myAct = new AbstractAction() {

			public void actionPerformed(ActionEvent e) {

				int row = jTableTransacDetails.getSelectedRow();
				int col = jTableTransacDetails.getSelectedColumn();

				System.out.println("Inside Action Performed column is " + col);

				if (col == 0) {
					if (valueOfTypeOfStmt.equalsIgnoreCase("Regular")) {
						jTableTransacDetails.changeSelection(row, 4, false,
								false);
						jTableTransacDetails.editCellAt(row, 4);
					} else if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
						jTableTransacDetails.changeSelection(row, 2, false,
								false);
						// jTableTransacDetails.editCellAt(row, 2);
					}
				} else {
					//System.out.println("I am in change selection");
					// table to buttons tabout logic
					if (row == jTableTransacDetails.getRowCount() - 1
							&& col == 24) {
						jTableTransacDetails
						.changeSelection(0, 0, false, false);
						jTableTransacDetails.editCellAt(0, 0);
						// jButton_crtFile.requestFocus();
						return;
					} else if ((valueOfTypeOfStmt
							.equalsIgnoreCase("Correction")) && col == 2) {
						jTableTransacDetails.changeSelection(row, 4, false,
								false);
						jTableTransacDetails.editCellAt(row, 4);

					} else if (GRPU.columnNumberEditable(col + 1)) {
						jTableTransacDetails.changeSelection(row, col + 1,
								false, false);
						jTableTransacDetails.editCellAt(row, col + 1);

					} else if (col != 24) {
						jTableTransacDetails.changeSelection(row, col + 1,
								false, false);
						jTableTransacDetails.editCellAt(row, col + 1);
					} else {
						jTableTransacDetails.changeSelection(row + 1, 0, false,
								false);
						// jTableTransacDetails.editCellAt(row, 0);
					}

				}

			}

		};

		jTableTransacDetails.getInputMap().put(KeyStroke.getKeyStroke("TAB"),
				"none");
		jTableTransacDetails.getInputMap().put(
				KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0), "none");
		jTableTransacDetails.getActionMap().put("text", myAct);
		// end

		// Amit added the second column
		/*
		 * TableColumn batchNoCol1 =
		 * jTableTransacDetails.getColumnModel().getColumn(1);
		 * batchNoCol1.setMaxWidth(0); batchNoCol1.setMinWidth(0);
		 * batchNoCol1.setPreferredWidth(0);
		 */
		// valuesRevsnModeO = (new String[] {
		// ""
		// });
		// valuesRevsnModeR = (new String[] {
		// "A", "D"
		// });
		mthYrQ1 = (new String[] { "" });
		mthYrQ2 = (new String[] { "" });
		mthYrQ3 = (new String[] { "" });
		mthYrQ4 = (new String[] { "" });
		//added for Ladakh
		stateName = (new String[] { "--Select--", "Andaman & Nicobar Islands",
				"Andhra Pradesh", "Arunachal Pradesh", "Assam", "Bihar",
				"Chandigarh", "Chhatishgarh", "Dadra Nagar Haveli & Daman Diu", "Delhi", "Goa", "Gujarat", "Haryana",
				"Himachal Pradesh", "Jammu & Kashmir", "Jharkhand",
				"Karnataka", "Kerala","Ladakh", "Lakshwadeep", "Madhya Pradesh",
				"Maharashtra", "Manipur", "Meghalaya", "Mizoram", "Nagaland",
				"Odisha", "Pondicherry", "Punjab", "Rajasthan", "Sikkim",
				"Tamil Nadu", "Tripura", "Uttar Pradesh", "Uttaranchal",
		"West Bengal" });

		revModeArray = (new String[] { "--Select--", "Delete", "Update" });

		int vColIndex = 2;
		col = jTableTransacDetails.getColumnModel().getColumn(vColIndex);
		int vColIndex1 = 14;
		colmn = jTableTransacDetails.getColumnModel().getColumn(vColIndex1);
		int vColIndex2 = 15;
		colState = jTableTransacDetails.getColumnModel().getColumn(vColIndex2);
		jTableTransacDetails.setSelectionMode(1);

		ddoMappingModes = new String[] { "--Select--", "Add", "Update",
		"Delete" };

		// cholia added here
		Action testAction = new AbstractAction("testAction") {
			public void actionPerformed(ActionEvent evt) {
				System.out.println("Action disabled");
				System.out.println("calling paste method");
				pasteXL(tabname);

			}
		};
		KeyStroke ks = KeyStroke.getKeyStroke("control V");
		jTableTransacDetails.getActionMap().put("testAction", testAction);
		jTableTransacDetails.getInputMap(
				JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(ks,
						"testAction");
		// jTableTransacDetails.getInputMap(JComponent).put(ks, "testAction");

		// amit end

		jTableTransacDetails.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				int col_Sel = jTableTransacDetails.columnAtPoint(evt.getPoint());
				int row_Sel = jTableTransacDetails.rowAtPoint(evt.getPoint());
			}

			public void mouseReleased(MouseEvent evt) {
				selRow = returnRow();
				selCol = returnColumn();

				boolean isPointInside = false;
				int sel_rowCnt = jTableTransacDetails.getSelectedRowCount();
				int sel_colCnt = jTableTransacDetails.getSelectedColumnCount();
				int col_Sel = jTableTransacDetails.columnAtPoint(evt.getPoint());
				int row_Sel = jTableTransacDetails.rowAtPoint(evt.getPoint());
				/*System.out.println("selected Row count = " + sel_rowCnt
						+ "selected Column count = " + sel_colCnt
						+ "numberDdo = " + numDdoRowsCorr);*/
				for (int i = 0; i < sel_rowCnt; i++) {
					for (int j = 0; j < sel_colCnt; j++) {
						if (selRow + i != row_Sel || selCol + j != col_Sel)
							continue;
						isPointInside = true;
						break;
					}

				}

				if (evt.isPopupTrigger()) {
					if (col_Sel == 2 || col_Sel == 3
							|| columnNumberEditableChallan(col_Sel)
							|| col_Sel >= 23)
						return;

					Object tan = "";
					String tanValue = "";
					if (row_Sel < numDdoRowsCorr) {
						Object[] transObject = (Object[]) saveDDOVector
								.get(row_Sel);
						tanValue = transObject[6].toString();
						System.out.println(tanValue + " Tan Value");

					}
					if (valueOfTypeOfStmt.equalsIgnoreCase("Regular")) {
						item1.setEnabled(true);
						item3.setEnabled(true);
						item4.setEnabled(true);
						item6.setEnabled(true);

					} else if (row_Sel < numDdoRowsCorr
							&& !model.getValueAt(row_Sel, 2).toString()
							.equalsIgnoreCase("Update")) {

						//System.out.println("HERE ONLy3");
						item1.setEnabled(false);
						item3.setEnabled(false);
						item4.setEnabled(false);
						item6.setEnabled(false);

					} else {
						item1.setEnabled(true);
						item3.setEnabled(true);
						item4.setEnabled(true);
						item6.setEnabled(true);
					}

					menu.show(
							jTableTransacDetails.getComponentAt(evt.getPoint()),
							evt.getX(), evt.getY());
					if (col_Sel >= 0 && row_Sel >= 0 && !isPointInside) {
						// jTableTransacDetails.changeSelection(row_Sel,
						// col_Sel,
						// false, false);
						// jTableTransacDetails.getComponentAt(evt.getPoint())
						// .repaint();
					}
				}
			}

			public void mouseClicked(MouseEvent e) {
				System.out.println("Inside Mouse Clicked");
				if (jTableTransacDetails.getSelectedColumn() != 0) {
					jTableTransacDetails.setRowSelectionAllowed(false);
					jTableTransacDetails.setCellSelectionEnabled(true);
					System.out.println("copy from excel ");
					//	System.out.println("I am in mouse clicked");
					int row = jTableTransacDetails.getSelectedRow();
					int column = jTableTransacDetails.getSelectedColumn();
					int finyear = Integer.parseInt((JComboBox_Form_Sub1_finYear
							.getSelectedItem().toString()).substring(0, 4));
					if ("Correction".equals(valueOfTypeOfStmt)) {
						if (challantype != null && row > 1) {
							System.out.println("Challan Type: " + challantype);
							System.out.println("Column :" + column);
							System.out.println("Row :" + row);
							System.out.println("Model first val: "
									+ model.getValueAt(row, 0));
							if ("".equals(model.getValueAt(row, 1))) {
								if (challantype.charAt(row - 2) == 'M') {

									if (finyear < 2013) {
										if (column == 2 || column == 3
												|| column == 4 || column == 5
												|| column == 7 || column == 8
												|| column == 10 || column == 12
												|| column == 14 || column == 16
												|| column == 17 || column == 21) {
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Section Code, Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");
											// System.out.println("I am in M");
										}

										if (finyear > 2012 && column == 6)
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Section Code, Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");

									} else {
										if (column == 2 || column == 3
												|| column == 4 || column == 5
												|| column == 6 || column == 7
												|| column == 8 || column == 12
												|| column == 14 || column == 16
												|| column == 17 || column == 21) {
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");
										}

										if (column == 20 & finyear > 2012)
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");

										if (column == 10 && finyear < 2013)
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");

									}

								} else if (challantype.charAt(row - 2) == 'O') {

									if (finyear < 2013) {
										if (column == 2 || column == 3
												|| column == 4 || column == 5
												|| column == 7 || column == 8
												|| column == 10 || column == 12
												|| column == 14 || column == 16
												|| column == 17 || column == 21) {
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Section Code, Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");
											// System.out.println("I am in O");
										}

										if (finyear > 2012 && column == 6)
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Section Code, Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");

									} else {
										if (column == 2 || column == 3
												|| column == 4 || column == 5
												|| column == 6 || column == 7
												|| column == 8 || column == 12
												|| column == 14 || column == 16
												|| column == 17 || column == 21) {
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");

											if (column == 20 & finyear > 2012)
												JOptionPane
												.showMessageDialog(
														null,
														"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br/> allowed only on fields Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");

										}

										if (column == 10 && finyear < 2013)
											JOptionPane
											.showMessageDialog(
													null,
													"<html>For Matched / Overbooked Challan / Transfer Voucher, update is <br> allowed only on fields Interest to be allocated / apportioned (Col No. 20) <br/> and Others (Col No. 21)</html>");

									}
								}

							}
						}
					}
					//new development for FRD1.3 by akansha
					//temp code for drop down working...
					if("Yes".equals(model.getValueAt(row, 18)))
						model.setValueAt("--Select--", row, 21);
					else if("--Select--".equals(model.getValueAt(row, 18)))
						model.setValueAt("--Select--", row, 21);
					else
						System.out.println("Its No in mode of deposit");
					//*****************************************
					jTableTransacDetails.repaint();

				} else {
					jTableTransacDetails.setCellSelectionEnabled(false);
					jTableTransacDetails.setRowSelectionAllowed(true);
					rowIsSelected = true;
					jTableTransacDetails.repaint();
				}
			}

		});
		// added by cholia to paste in the excel

		/*
		 * Action testAction = new AbstractAction("testAction") { public void
		 * actionPerformed(ActionEvent evt) {
		 * System.out.println("Action disabled");
		 * System.out.println("calling paste method"); pasteXL(); } }; KeyStroke
		 * ks = KeyStroke.getKeyStroke("control V");
		 * jTableTransacDetails.getActionMap().put("testAction", testAction);
		 * jTableTransacDetails
		 * .getInputMap(JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT).put(ks,
		 * "testAction"); //jTableTransacDetails.getInputMap(JComponent).put(ks,
		 * "testAction");
		 */

		// cholia end

		jTableTransacDetails.addKeyListener(new KeyAdapter() {

			public void keyPressed(KeyEvent e) {

				int col = jTableTransacDetails.getSelectedColumn();
				int row = jTableTransacDetails.getSelectedRow();

				//System.out.println("key pressed in challan"+jTableTransacDetails.getSelectedColumn());
				// newly changed by cholia
				/*
				 * if (jTableTransacDetails.getModel().isCellEditable(row, col)
				 * == false) return;
				 */
				//System.out.println("The key is: "+ e.getKeyCode());

				if (jTableTransacDetails.getSelectedColumn() >= 0
						&& (e.getKeyChar() >= ' ' && e.getKeyChar() < '\177' || e
						.getKeyChar() == '\b'))
					// model.setValueAt("",//
					// jTableTransacDetails.getSelectedRow(),jTableTransacDetails.getSelectedColumn());
					if (e.isControlDown()) {


						if (e.getKeyCode() == 67)
							copy();
						else if (e.getKeyCode() == 86) {
							System.out.println("pasteXL86");
							paste();

						} else if (e.getKeyCode() == e.VK_CUT)
							cut();
						else if (e.getKeyCode() == 32)
							pasteXL(tabname); // changed by cholia here
						else if (e.getKeyCode() == 70 || e.getKeyCode() == 82)
							if (e.getKeyCode() == 70) {
								FindReplace.mouse_whichTab = "F";
								FindReplace.isFindClk = true;
							} else if (e.getKeyCode() == 82)
								FindReplace.mouse_whichTab = "R";
							else if (GRPU.grpuFindReplace == null)
								GRPU.grpuFindReplace = new FindReplace(model,
										jTableTransacDetails, numDdoRowsCorr,grpu,"Challan");

					} else if (e.getKeyCode() == 127)
						deleteCell();

			}

		});

	}

	// Added by Akansha
	private void addStaticRows(DefaultTableModel model3) {

		Vector<Object> row = new Vector<Object>();
		// Adding the 2nd row after the model
		Vector<Object> row1 = new Vector<Object>();
		if ("24Q".equals(formNumber)) {

			row.add("<html><table><tr><td align='center'>(301)</td></tr></table></html>"); // 1
			row.add("");
			row.add("");
			row.add("(302)");
			row.add("");
			row.add("(303)");
			row.add("(304)");
			row.add("(305)");
			row.add("<html><center>(306)</center></html>");
			row.add("");
			row.add("(307)");
			row.add("");
			row.add("");
			row.add("(309)");
			row.add("");
			row.add("(311)");
			row.add("");
			row.add("(310)");
			row.add("(308)");
			row.add("");
			row.add("");
			row.add("(312)");
			row.add("");

			model.addRow(row);

			// end first row

			row1.add("1");
			row1.add("2");
			row1.add("3");
			row1.add("4");
			row1.add("5");
			row1.add("6");
			row1.add("7");
			row1.add("8");
			row1.add("9");
			row1.add("10");
			row1.add("11");
			row1.add("12");
			row1.add("13");
			row1.add("14");
			row1.add("15");
			row1.add("16");
			row1.add("17");
			row1.add("18");
			row1.add("19");
			row1.add("20");
			row1.add("21");
			row1.add("22");
			row1.add("23");

			model.addRow(row1);
		}
		if ("26Q".equals(formNumber)) {
			row.add("<html><table><tr><td align='center'>(401)</td></tr></table></html>"); // 1
			row.add("");
			row.add("");
			row.add("(402)");// 4
			row.add("");
			row.add("");// 6
			row.add("(403)");// 7
			row.add("(404)");// 8
			row.add("<html><center>(405)</center></html>");// 9
			row.add("");// 10
			row.add("(406)");// 11
			row.add("");// 12
			row.add("");// 13
			row.add("(408)");// 14
			row.add("");// 15
			row.add("(410)");// 16
			row.add("");// 17
			row.add("(409)");// 18
			row.add("(407)");// 19
			row.add("");// 20
			row.add("");// 21
			row.add("(411)");// 22
			row.add("");// 23

			model.addRow(row);

			// end first row
			row1.add("1");
			row1.add("2");
			row1.add("3");
			row1.add("4");
			row1.add("5");
			row1.add("6");
			row1.add("7");
			row1.add("8");
			row1.add("9");
			row1.add("10");
			row1.add("11");
			row1.add("12");
			row1.add("13");
			row1.add("14");
			row1.add("15");
			row1.add("16");
			row1.add("17");
			row1.add("18");
			row1.add("19");
			row1.add("20");
			row1.add("21");
			row1.add("22");
			row1.add("23");

			model.addRow(row1);
		}

		if ("27Q".equals(formNumber)) {
			row.add("<html><table><tr><td align='center'>(701)</td></tr></table></html>"); // 1
			row.add("");
			row.add("");
			row.add("(702)");// 4
			row.add("703");
			row.add("704");// 6
			row.add("(705)");// 7
			row.add("(706)");// 8
			row.add("<html><center>(707)</center></html>");// 9
			row.add("");// 10
			row.add("(708)");// 11
			row.add("");// 12
			row.add("");// 13
			row.add("(710)");// 14
			row.add("");// 15
			row.add("(712)");// 16
			row.add("");// 17
			row.add("(711)");// 18
			row.add("(709)");// 19
			row.add("");// 20
			row.add("");// 21
			row.add("(713)");// 22
			row.add("");// 23

			model.addRow(row);

			// end first row

			row1.add("1");
			row1.add("2");
			row1.add("3");
			row1.add("4");
			row1.add("5");
			row1.add("6");
			row1.add("7");
			row1.add("8");
			row1.add("9");
			row1.add("10");
			row1.add("11");
			row1.add("12");
			row1.add("13");
			row1.add("14");
			row1.add("15");
			row1.add("16");
			row1.add("17");
			row1.add("18");
			row1.add("19");
			row1.add("20");
			row1.add("21");
			row1.add("22");
			row1.add("23");

			model.addRow(row1);
		}

		if ("27EQ".equals(formNumber)) {
			row.add("<html><table><tr><td align='center'>(651)</td></tr></table></html>"); // 1
			row.add("");
			row.add("");
			row.add("(652)");// 4
			row.add("653");
			row.add("654");// 6
			row.add("(655)");// 7
			row.add("(656)");// 8
			row.add("<html><center>(657)</center></html>");// 9
			row.add("");// 10
			row.add("(658)");// 11
			row.add("");// 12
			row.add("");// 13
			row.add("(660)");// 14
			row.add("");// 15
			row.add("(662)");// 16
			row.add("");// 17
			row.add("(661)");// 18
			row.add("(659)");// 19
			row.add("");// 20
			row.add("");// 21
			row.add("(663)");// 22
			row.add("");// 23

			model.addRow(row);

			// end first row

			row1.add("1");
			row1.add("2");
			row1.add("3");
			row1.add("4");
			row1.add("5");
			row1.add("6");
			row1.add("7");
			row1.add("8");
			row1.add("9");
			row1.add("10");
			row1.add("11");
			row1.add("12");
			row1.add("13");
			row1.add("14");
			row1.add("15");
			row1.add("16");
			row1.add("17");
			row1.add("18");
			row1.add("19");
			row1.add("20");
			row1.add("21");
			row1.add("22");
			row1.add("23");

			model.addRow(row1);
		}

	}

	// *****************************************************************************************
	// For FOrm data
	private void initializeBHTab() throws URISyntaxException {
		jPanel16 = new JPanel();
		jPanel16.setLayout(new GridBagLayout());
		jPanel14 = new JPanel();
		jPanel14.setLayout(null);
		jPanel14.setPreferredSize(new Dimension(970, 1050)); //New dev for ver1.3 added by Akansha

		jScrollPaneTab1 = new JScrollPane(jPanel16);
		jScrollPaneTab1.setPreferredSize(null);
		jScrollPaneTab1.getVerticalScrollBar().setUnitIncrement(20);
		jScrollPaneTab1.setAutoscrolls(true);

		// PanelBatchDet.add(jScrollPaneTab444, 1);

		// added by dhaval 598588 for Swing_RPU start

		jLabel_Form_heading1 = new JLabel(); // Changed by Akansha
		// added by Akansha
		// code for changing the main label of the form
		if ("24Q".equals(formNumber)) {
			jLabel_Form_heading1
			.setText("Quarterly statement of deduction of tax under sub section (3) of section 200 of the Income Tax Act, 1961 in respect of Salary.");
		} else if ("26Q".equals(formNumber)) {
			jLabel_Form_heading1
			.setText("Quarterly statement of deduction of tax under sub section (3) of section 200 of the Income Tax Act, 1961 in respect of payments other than Salary.");
		} else if ("27Q".equals(formNumber)) {
			jLabel_Form_heading1
			.setText("Quarterly statement of deduction of tax under sub section (3) of section 200 of Income Tax Act, 1961 in respect of payments other than Salary made to non-residents.");
		} else if ("27EQ".equals(formNumber)) {
			jLabel_Form_heading1
			.setText("Quarterly statement of Tax collection at source under section 206C of Income Tax Act, 1961.");
		}
		//
		// added by Akansha
		/*
		 * String JComboBox_Form_Sub1_finYear_Data[] = { "--Select--",
		 * "2007-2008", "2008-2009", "2010-2011", "2011-2012", "2012-2013",
		 * "2013-2014", "2014-2015" }; JComboBox_Form_Sub1_finYear = new
		 * JComboBox( JComboBox_Form_Sub1_finYear_Data);
		 */
		jLabel_Form_quarterEnd = new JLabel("For Quarter Ended * ");
		String jComboBox_Quarter_Data[] = { "--Select--", "Q1", "Q2", "Q3",
		"Q4" };
		jComboBox_Quarter = new JComboBox(jComboBox_Quarter_Data);
		jComboBox_Quarter.setBackground(Color.white);
		jComboBox_Quarter.setSelectedIndex(0);
		jComboBox_Quarter.setEnabled(false);
		// **************************************************************************
		jText_Quarter = new JTextField();
		jText_Quarter.setEditable(false);
		jText_Quarter.setText(jComboBox_Quarter.getSelectedItem().toString());
		jText_Quarter.setVisible(true);

		jText_BalnkYear = new JTextField();
		jLabel_Form_year = new JLabel("( Year )");
		jText_disabledFromNum = new JTextField(formNumber);
		jText_disabledFromNum.setEditable(false);
		jText_disabledFromNum.setEnabled(false);

		jLabel_Form_formNumber = new JLabel("Form No. * ");

		jPanel_Form_particulars = new JPanel();
		jPanel_Form_particulars.setLayout(null);
		jPanel_Form_particulars.setPreferredSize(new Dimension(950, 220));
		jPanel_Form_particulars.setBorder(BorderFactory
				.createLineBorder(Color.BLACK));
		jLabel_Form_Sub1_heading = new JLabel("1. Particulars of Statement");
		jLabel_Form_Sub1_Tan = new JLabel(
				"Tax Deduction and Collection Account No. (TAN) *");
		jLabel_Form_Sub1_LastTan = new JLabel(
				"Last Tax Deduction and Collection Account No.");
		jLabel_Form_Sub1_Pan = new JLabel("Permanent Account Number. *");
		jLabel_Form_Sub1_isRevised = new JLabel(
				"Is this a Revised Return ( Yes / No )");

		jLabel_Form_Sub1_finYear = new JLabel("Financial Year. *");
		jLabel_Form_Sub1_AssessmentYear = new JLabel("Assessment Year *");

		//newly added for FRD1.5 Ver1.5 by akansha
		jButton_Form_Sub1_Know_Your_Tan = new JButton("<html><body><u>Check status of your TAN at Know your TAN</u></body></html>");

		//added buttons for link in utility tab
		/* for (int i = 0; i < strUriNames.length; ++i)
	        {
	            JButton Jbutton_utility_link = new JButton(strUriNames[i]);
	            linkButtonLookAndFeel(Jbutton_utility_link);
	            Jbutton_utility_link.addActionListener(this);
	            utility_link_box.add(Jbutton_utility_link);
	        }*/
		addComponent(PanelUtility, utility_link_box, 25, 200, 325, 20);                      //add box into PanelUtility

		// Added by Akansha
		if ("27EQ".equals(formNumber)) {
			jLabel_Form_Sub1_Type_of_Deductor = new JLabel(
					"Type of Collector *");
			jLabel_Form_Sub1_Update_Instruction = new JLabel(
					"( Indicate only if any change in Collector Details )");
			jLabel_Form_Sub1_Last_Deductor_Type = new JLabel(
					"Last Collector Type");
			jLabel_Form_Sub1_Update_deductor = new JLabel(
					"Update Collector Details");
			jLabel_Form_Sub2_heading = new JLabel("2. Particulars of Collector");
			jLabel_Form_Sub3_heading = new JLabel(
					"3. Particulars of the Person Responsible for Collection of Tax");
		} else {
			jLabel_Form_Sub1_Type_of_Deductor = new JLabel("Type of Deductor *");
			jLabel_Form_Sub1_Update_Instruction = new JLabel(
					"( Indicate only if any change in Deductor Details )");
			jLabel_Form_Sub1_Last_Deductor_Type = new JLabel(
					"Last Deductor Type");
			jLabel_Form_Sub1_Update_deductor = new JLabel(
					"Update Deductor Details");
			jLabel_Form_Sub2_heading = new JLabel(
					"2. Particulars of Deductor ( Employer )");
			jLabel_Form_Sub3_heading = new JLabel(
					"3. Particulars of the Person Responsible for Dedution of Tax");
		}
		// **************************

		jLabel_Form_Sub1_Org_Receipt_Num = new JLabel(
				"Receipt Number of Original Return");
		jLabel_Form_Sub1_Previous_Receipt_num = new JLabel(
				"Receipt Number of Previous Return");

		jText_Form_Sub1_Tan = new JTextField();
		jText_Form_Sub1_LastTan = new JTextField();
		jText_Form_Sub1_Pan = new JTextField();
		jText_Form_Sub1_isRevised = new JTextField();
		jText_Form_Sub1_Update_deductor = new JTextField();
		String JComboBox_Form_Sub1_Update_deductor_Data[] = { "--Select--",
		"Other Deductor Details" };
		JComboBox_Form_Sub1_Update_deductor = new JComboBox(
				JComboBox_Form_Sub1_Update_deductor_Data);
		JComboBox_Form_Sub1_Update_deductor.setBackground(Color.white);
		jText_Form_Sub1_finYear = new JTextField();
		// Akansha for rpu 1.1
		String finyear = "\"--Select--\",";
		List lt1 = new ArrayList();
		lt1 = GrpuUtil.financialYearCombo(1);
		List lt11 = (List) lt1.get(0);
		String JComboBox_Form_Sub1_finYear_Data[] = new String[lt11.size() + 1];
		JComboBox_Form_Sub1_finYear_Data[0] = "--Select--";
		int nik = 1;
		for (Object s : lt11) {
			JComboBox_Form_Sub1_finYear_Data[nik] = (String) s;
			nik++;
		}
		JComboBox_Form_Sub1_finYear = new JComboBox(
				JComboBox_Form_Sub1_finYear_Data);
		JComboBox_Form_Sub1_finYear.setBackground(Color.white);
		jText_Form_Sub1_AssessmentYear = new JTextField();
		jText_Form_Sub1_Type_of_Deductor = new JTextField();
		String JComboBox_Form_Sub1_Type_of_Deductor_Data[] = { "--Select--",
				"Central Government", "State Government",
				"Statutory body (Central Govt.)",
				"Statutory body (State Govt.)",
				"Autonomous body (Central Govt.)",
				"Autonomous body (State Govt.)",
				"Local Authority (Central Govt.)",
				"Local Authority (State Govt.)", "Company",
				"Branch / Division of Company", "Association of Person (AOP)",
				"Association of Person (Trust)", "Artificial Juridical Person",
				"Body of Individuals", "Individual/HUF", "Firm" };
		JComboBox_Form_Sub1_Type_of_Deductor = new JComboBox(
				JComboBox_Form_Sub1_Type_of_Deductor_Data);
		JComboBox_Form_Sub1_Type_of_Deductor.setBackground(Color.white);
		jText_Form_Sub1_Last_Deductor_Type = new JTextField();
		jText_Form_Sub1_Org_Receipt_Num = new JTextField();
		jText_Form_Sub1_Previous_Receipt_num = new JTextField();

		jPanel_Form_particulars_Deductor = new JPanel();
		jPanel_Form_particulars_Deductor.setLayout(null);
		jPanel_Form_particulars_Deductor.setPreferredSize(new Dimension(950,
				400));
		jPanel_Form_particulars_Deductor.setBorder(BorderFactory
				.createLineBorder(Color.BLACK));

		jCheckBox_Form_Sub2_Sameasabove = new JCheckBox("Same as above");
		jLabel_Form_Sub2_Name = new JLabel("Name *");
		jLabel_Form_Sub2_Branch = new JLabel("Branch / Division ( If any )");
		jLabel_Form_Sub2_State = new JLabel("State Name");
		jLabel_Form_Sub2_PAO_Code = new JLabel("PAO Code");
		jLabel_Form_Sub2_PAO_regNum = new JLabel("PAO Registration Number");
		jLabel_Form_Sub2_FlatNo = new JLabel("Flat No. *");
		jLabel_Form_Sub2_Area = new JLabel("Area / Location");
		jLabel_Form_Sub2_Road = new JLabel("Road / Street / Lane ");
		jLabel_Form_Sub2_PinCode = new JLabel("PIN Code *");
		jLabel_Form_Sub2_TelNum = new JLabel("Telephone No.");
		jLabel_Form_Sub2_AlternateTelNum = new JLabel(
				"Telephone No. ( Alternate )");
		jLabel_Form_Sub2_AIN = new JLabel(
				"<html>Account Office Identification Number <br>( AIN ) of PAO/TO/CDDO</html>");
		jLabel_Form_Sub2_GSTN = new JLabel("Goods and Services Tax Number (GSTN)");
		jLabel_Form_Sub2_MinistryName = new JLabel("Ministry / Dept. Name");
		jLabel_Form_Sub2_MinistryName_Other = new JLabel(
				"Ministry / Dept. Name ( Others )");
		jLabel_Form_Sub2_DDO_Code = new JLabel("DDO Code");
		jLabel_Form_Sub2_DDO_RegNum = new JLabel("DDO Registration Number");
		jLabel_Form_Sub2_TAN_RegNum = new JLabel("Permanent Account Number *");
		jLabel_Form_Sub2_BuildingName = new JLabel("Name of Premises / Building");
		jLabel_Form_Sub2_Town = new JLabel("Town / City / District");
		jLabel_Form_Sub2_StateTwo = new JLabel("State *");
		jLabel_Form_Sub2_Email = new JLabel("E-mail");
		jLabel_Form_Sub2_Email_Alternate = new JLabel("E-mail ( Alternate )");
		jLabel_Form_Sub2_isAddressChanged = new JLabel(
				"<html>Has Address Changed <br>Since Last Return *</html>");

		jText_Form_Sub2_Name = new JTextField();
		jText_Form_Sub2_Branch = new JTextField();
		jComboBox_Form_Sub2_State = new JComboBox();
		jText_Form_Sub2_PAO_Code = new JTextField();
		jText_Form_Sub2_PAO_regNum = new JTextField();
		jText_Form_Sub2_FlatNo = new JTextField();
		jText_Form_Sub2_Area = new JTextField();
		jText_Form_Sub2_Road = new JTextField();
		jText_Form_Sub2_PinCode = new JTextField();
		jText_Form_Sub2_TelNum_Std_Code = new JTextField();
		jText_Form_Sub2_TelNum = new JTextField();
		jText_Form_Sub2_AlternateTelNum_Std_Code = new JTextField();
		jText_Form_Sub2_AlternateTelNum = new JTextField();
		jText_Form_Sub2_AIN = new JTextField();
		jText_Form_Sub2_GSTN = new JTextField();
		jText_Form_Sub2_MinistryName = new JTextField();
		String JComboBox_Form_Sub2_MinistryName_Data[] = { "--Select--",
				"Agriculture", "Atomic Energy",
				"Andaman and Nicobar Islands Administration",
				"Chemicals and Petrochemicals", "Civil Aviation and Tourism",
				"Coal", "Consumer Affairs, Food and Public Distribution",
				"Commerce and Textiles", "Central Board of Direct Taxes",
				"Central Board of Excise and Customs",
				"Controller of Aid Accounts and Audit",
				"Central Pension Accounting Office",
				"Chandigarh Administration", "Dadra and Nagar Haveli",
				"Department of Posts", "Department of Telecommunications",
				"D/o of Commerce (Supply Division)",
				"Environment and Forests and Ministry of Earth Science",
				"External Affairs and Overseas Indian Affairs",
				"Election Commission", "Fertilizers", "Finance",
				"Food Processing Industries", "Government Of NCT of Delhi",
				"Goa, Daman and Diu", "Health and Family Welfare",
				"Home Affairs and Development of North Eastern Region",
				"Human Resource Development", "Industry",
				"Information and Broadcasting", "Labour",
				"Law and Justice and Company Affairs", "Lok Sabha Secretariat",
				"Lakshadweep",
				"Ministry of Defence (Controller General of Defence Accounts)",
				"Ministry of Railways",
				"Ministry of Non-conventional energy sources", "Mines",
				"New and Renewable Energy",
				"Personnel, Public Grievances and Pensions",
				"Petroleum and Natural Gas",
				"Plannning, Statistics and Programme Implementation", "Power",
				"Pondicherry Administration",
				"Pay and Accounts Officers (Audit)", "President's Secretariat",
				"Rural Development and Panchayati Raj",
				"Rajya Sabha secretariat", "Science And Technology", "Space",
				"Steel", "Social Justice and Empowerment",
				"Shipping and Road Transport and Highways",
				"Telecommunication and Information Technology",
				"Tribal Affairs",
				"Urban Development, Urban Employment and Poverty Alleviation",
				"Water Resources", "Others" };
		JComboBox_Form_Sub2_MinistryName = new JComboBox(
				JComboBox_Form_Sub2_MinistryName_Data);
		JComboBox_Form_Sub2_MinistryName.setBackground(Color.white);
		JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
		jText_Form_Sub2_MinistryName_Other = new JTextField();
		jText_Form_Sub2_DDO_Code = new JTextField();
		jText_Form_Sub2_DDO_RegNum = new JTextField();
		jText_Form_Sub2_TAN_RegNum = new JTextField();
		jText_Form_Sub2_BuildingName = new JTextField();
		jText_Form_Sub2_Town = new JTextField();
		jText_Form_Sub2_StateTwo = new JTextField();
		jText_Form_Sub2_Email = new JTextField();
		jText_Form_Sub2_Email_Alternate = new JTextField();
		jComboBox_Form_Sub2_isAddressChanged = new JComboBox();

		jPanel_Form_particulars_Person = new JPanel();
		jPanel_Form_particulars_Person.setLayout(null);
		jPanel_Form_particulars_Person
		.setPreferredSize(new Dimension(950, 300));
		jPanel_Form_particulars_Person.setBorder(BorderFactory
				.createLineBorder(Color.BLACK));

		jLabel_Form_Sub3_Name = new JLabel("Name *");
		jLabel_Form_Sub3_Designation = new JLabel("Designation *");
		jLabel_Form_Sub3_FlatNum = new JLabel("Flat No. *");
		jLabel_Form_Sub3_BuildingName = new JLabel(
				"Name of Premises / Building");
		jLabel_Form_Sub3_Road = new JLabel("Road / Street / Lane ");
		jLabel_Form_Sub3_TelNum = new JLabel("Telephone No.");
		jLabel_Form_Sub3_TelNum_Alternate = new JLabel(
				"Telephone No. ( Alternate )");
		jLabel_Form_Sub3_isAddressChange = new JLabel(
				"Has Address Changed Since Last Return *");
		jLabel_Form_Sub3_earlierReceiptNum = new JLabel();
		jLabel_Form_Sub3_Area = new JLabel("Area / Location");
		jLabel_Form_Sub3_Town = new JLabel("Town / City / District");
		jLabel_Form_Sub3_State = new JLabel("State *");
		jLabel_Form_Sub3_PinCode = new JLabel("PIN Code *");
		jLabel_Form_Sub3_Email = new JLabel("E-mail");
		jLabel_Form_Sub3_Email_Alternate = new JLabel("E-mail ( Alternate )");
		jLabel_Form_Sub3_MobileNumber = new JLabel("Mobile No.");
		jLabel_Form_Sub3_isRegularStatement = new JLabel();

		jText_Form_Sub3_Name = new JTextField();
		jText_Form_Sub3_Designation = new JTextField();
		jText_Form_Sub3_FlatNum = new JTextField();
		jText_Form_Sub3_BuildingName = new JTextField();
		jText_Form_Sub3_Road = new JTextField();
		jText_Form_Sub3_TelNum_Std_Code = new JTextField();
		jText_Form_Sub3_TelNum = new JTextField();
		jText_Form_Sub3_TelNum_Alternate_Std_Code = new JTextField();
		jText_Form_Sub3_TelNum_Alternate = new JTextField();
		jText_Form_Sub3_isAddressChange = new JTextField();
		jText_Form_Sub3_earlierReceiptNum = new JTextField();
		jText_Form_Sub3_Area = new JTextField();
		jText_Form_Sub3_Town = new JTextField();
		jText_Form_Sub3_State = new JTextField();
		jText_Form_Sub3_PinCode = new JTextField();
		jText_Form_Sub3_Email = new JTextField();
		jText_Form_Sub3_Email_Alternate = new JTextField();
		jText_Form_Sub3_MobileNumber = new JTextField();
		jComboBox_Form_Sub3_isRegularStatement = new JComboBox();
		jComboBox_Form_Sub3_isAddressChanged = new JComboBox();



		jComboBox_Quarter
		.setToolTipText("Financial Year must be selected first");
		jText_BalnkYear.setToolTipText("Enter Year");
		jText_Form_Sub1_Tan
		.setToolTipText("Tax Deduction Account No should be of length 10");

		// Added by Akansha
		// Use of setDocuments helps in converting the alphabets to uppercase
		// Use of genericListenerValidation() helps in validating the form
		// components
		JComboBox_Form_Sub1_Type_of_Deductor
		.setToolTipText("Specify Deductor/Collector type");
		JComboBox_Form_Sub1_Update_deductor
		.setToolTipText("To update deductor details in this field, select 'Update Deductor Details");
		jText_Form_Sub2_DDO_Code
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 20");
		jText_Form_Sub2_PAO_Code
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 20");
		jText_Form_Sub2_DDO_RegNum
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 10");
		jText_Form_Sub2_TAN_RegNum
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 12. Applicable only from F.Y. 2013-14 Onwards");

		jText_Form_Sub1_Tan.setDocument(new SecondaryValidations(10));
		jText_Form_Sub1_Pan.setDocument(new SecondaryValidations(10));
		jText_Form_Sub2_Name.setDocument(new Validations(75));
		jText_Form_Sub2_Branch.setDocument(new Validations(75));
		jText_Form_Sub2_DDO_Code.setDocument(new Validations(20));
		jText_Form_Sub2_PAO_Code.setDocument(new Validations(20));
		jText_Form_Sub2_DDO_RegNum.setDocument(new Validations(10));
		jText_Form_Sub2_PAO_regNum.setDocument(new Validations(7));
		jText_Form_Sub2_TAN_RegNum.setDocument(new Validations(10)); // #### New
		// Development
		// as on
		// 2/04/2015
		// by
		// Akansha
		jText_Form_Sub2_FlatNo.setDocument(new Validations(25));
		jText_Form_Sub2_BuildingName.setDocument(new Validations(25));
		jText_Form_Sub2_Area.setDocument(new Validations(25));
		jText_Form_Sub2_Town.setDocument(new Validations(25));
		jText_Form_Sub2_Road.setDocument(new Validations(25));
		jText_Form_Sub2_PinCode.setDocument(new Validations(6));
		jText_Form_Sub2_Email.setDocument(new Validations(75));
		jText_Form_Sub2_TelNum_Std_Code.setDocument(new Validations(5));
		jText_Form_Sub2_TelNum.setDocument(new Validations(10));
		jText_Form_Sub2_Email_Alternate.setDocument(new Validations(75));
		jText_Form_Sub2_AlternateTelNum_Std_Code
		.setDocument(new Validations(5));
		jText_Form_Sub2_AlternateTelNum.setDocument(new Validations(10));
		jText_Form_Sub2_AIN.setDocument(new Validations(7));
		jText_Form_Sub2_GSTN.setDocument(new Validations(15));
		jText_Form_Sub3_Name.setDocument(new Validations(75));
		jText_Form_Sub3_Area.setDocument(new Validations(25));
		jText_Form_Sub3_Designation.setDocument(new Validations(20));
		jText_Form_Sub3_Town.setDocument(new Validations(25));
		jText_Form_Sub3_FlatNum.setDocument(new Validations(25));
		jText_Form_Sub3_BuildingName.setDocument(new Validations(25));
		jText_Form_Sub3_PinCode.setDocument(new Validations(6));
		jText_Form_Sub3_Road.setDocument(new Validations(25));
		jText_Form_Sub3_Email.setDocument(new Validations(75));
		jText_Form_Sub3_Email_Alternate.setDocument(new Validations(75));
		jText_Form_Sub3_TelNum.setDocument(new Validations(10));
		jText_Form_Sub3_TelNum_Std_Code.setDocument(new Validations(5));
		jText_Form_Sub3_TelNum_Alternate.setDocument(new Validations(10));
		jText_Form_Sub3_TelNum_Alternate_Std_Code
		.setDocument(new Validations(5));
		jText_Form_Sub3_MobileNumber.setDocument(new Validations(10));
		jText_Form_Sub3_earlierReceiptNum.setDocument(new Validations(15));

		jCheckBox_Form_Sub2_Sameasabove.addItemListener(new ItemListener() {

			public void itemStateChanged(ItemEvent e) {
				if (e.getStateChange() == ItemEvent.SELECTED) {

					jText_Form_Sub3_FlatNum.setText(jText_Form_Sub2_FlatNo
							.getText().toString());
					jText_Form_Sub3_BuildingName
					.setText(jText_Form_Sub2_BuildingName.getText()
							.toString());
					jText_Form_Sub3_Road.setText(jText_Form_Sub2_Road.getText()
							.toString());
					jText_Form_Sub3_Area.setText(jText_Form_Sub2_Area.getText()
							.toString());
					jText_Form_Sub3_Town.setText(jText_Form_Sub2_Town.getText()
							.toString());
					jComboBox_State_Name.setSelectedItem(jComboBox_AOState
							.getSelectedItem());
					jText_Form_Sub3_PinCode.setText(jText_Form_Sub2_PinCode
							.getText().toString());

				} else {

					jText_Form_Sub3_FlatNum.setText("");
					jText_Form_Sub3_BuildingName.setText("");
					jText_Form_Sub3_Road.setText("");
					jText_Form_Sub3_Area.setText("");
					jText_Form_Sub3_Town.setText("");
					jComboBox_State_Name.setSelectedItem("--Select--");
					jText_Form_Sub3_PinCode.setText("");
				}

			}
		});

		jComboBox_Form_Sub3_isRegularStatement
		.addItemListener(new ItemListener() {

			public void itemStateChanged(ItemEvent arg0) {
				if ("Yes".equals(arg0.toString())) {
					jText_Form_Sub3_earlierReceiptNum.setEnabled(true);
				} else {
					if (checkPopup != 1) {
						JOptionPane
						.showMessageDialog(
								null,
								"Option you have selected is \"No\". Kindly confirm that there is no statement filed for form"
										+ formNumber
										+ "earlier, if found, the statement will be rejected at TIN central system");
					}
				}

			}
		});

		genericListenerValidation(jText_Form_Sub1_Tan, "AlphaNumeric");
		genericListenerValidation(jText_Form_Sub1_Pan, "AlphaNumeric");

		//Newly commented for ver1.3 by Akansha
		// Added by Akansha
		// Validation for email

		genericListenerFocusValidation(jText_Form_Sub2_Email,
				jText_Form_Sub2_AlternateTelNum_Std_Code);
		genericListenerFocusValidation(jText_Form_Sub2_Email_Alternate,
				jText_Form_Sub2_AIN);
		genericListenerFocusValidation(jText_Form_Sub3_Email_Alternate,
				jComboBox_Form_Sub3_isAddressChanged);
		genericListenerFocusValidation(jText_Form_Sub3_Email,
				jText_Form_Sub3_TelNum_Alternate_Std_Code);

		// *********************************************

		genericListenerValidation(jText_Form_Sub2_Name, "Alpha");
		genericListenerValidation(jText_Form_Sub2_Branch, "Alpha");
		genericListenerValidation(jText_Form_Sub2_MinistryName_Other, "Alpha");
		genericListenerValidation(jText_Form_Sub2_DDO_Code, "AlphaNumeric");
		genericListenerValidation(jText_Form_Sub2_PAO_Code, "AlphaNumeric");
		genericListenerValidation(jText_Form_Sub2_PAO_regNum, "Numeric");
		genericListenerValidation(jText_Form_Sub2_TAN_RegNum, "AlphaNumeric");
		genericListenerValidation(jText_Form_Sub2_FlatNo, "Alpha");
		genericListenerValidation(jText_Form_Sub2_BuildingName, "Alpha");
		genericListenerValidation(jText_Form_Sub2_Area, "Alpha");
		genericListenerValidation(jText_Form_Sub2_Town, "Alpha");
		genericListenerValidation(jText_Form_Sub2_Road, "Alpha");
		genericListenerValidation(jText_Form_Sub2_PinCode, "Numeric");
		genericListenerValidation(jText_Form_Sub2_Email, "Email");
		genericListenerValidation(jText_Form_Sub2_TelNum_Std_Code, "Numeric");
		genericListenerValidation(jText_Form_Sub2_TelNum, "Numeric");
		genericListenerValidation(jText_Form_Sub2_Email_Alternate, "Email");
		genericListenerValidation(jText_Form_Sub2_AlternateTelNum_Std_Code,
				"Numeric");
		genericListenerValidation(jText_Form_Sub2_AlternateTelNum, "Numeric");
		genericListenerValidation(jText_Form_Sub2_AIN, "Numeric");
		genericListenerValidation(jText_Form_Sub2_GSTN, "AlphaNumeric");
		genericListenerValidation(jText_Form_Sub3_Name, "Alpha");
		genericListenerValidation(jText_Form_Sub3_Area, "Alpha");
		genericListenerValidation(jText_Form_Sub3_Designation, "Alpha");
		genericListenerValidation(jText_Form_Sub3_Town, "Alpha");
		genericListenerValidation(jText_Form_Sub3_FlatNum, "Alpha");
		genericListenerValidation(jText_Form_Sub3_BuildingName, "Alpha");
		genericListenerValidation(jText_Form_Sub3_PinCode, "Numeric");
		genericListenerValidation(jText_Form_Sub3_Road, "Alpha");
		genericListenerValidation(jText_Form_Sub3_Email, "Email");
		genericListenerValidation(jText_Form_Sub3_Email_Alternate, "Email");
		genericListenerValidation(jText_Form_Sub3_TelNum, "Numeric");
		genericListenerValidation(jText_Form_Sub3_TelNum_Std_Code, "Numeric");
		genericListenerValidation(jText_Form_Sub3_TelNum_Alternate, "Numeric");
		genericListenerValidation(jText_Form_Sub3_TelNum_Alternate_Std_Code,
				"Numeric");
		genericListenerValidation(jText_Form_Sub3_MobileNumber, "Numeric");
		genericListenerValidation(jText_Form_Sub3_earlierReceiptNum, "Numeric");

		/**************************************************************************************************************************/
		//Added by Sadhana, on 04/07/2017 FRD2.0
		jText_Form_Sub2_Name.addFocusListener(new FocusListener() {
			@Override
			public void focusLost(FocusEvent e) {
				String strName = jText_Form_Sub2_Name.getText();
				System.out.println("Name Validation new = "+strName);
				if(!strName.equals("")){
					int counter = 0;
					char firstChar = strName.charAt(0);
					char lastChar = strName.charAt(strName.length() - 1);
					if(firstChar == lastChar){
						for (int i = 1; i < strName.length(); i++) {
							if(firstChar == strName.charAt(i)){
								counter++;
							}
						}
						if(counter == strName.length()-1){
							JOptionPane.showMessageDialog(null,"Invalid value, kindly provide valid value.");
							jText_Form_Sub2_Name.setText(""); 
							jText_Form_Sub2_Name.requestFocus();
						}
					}
				}
				/*int counter = 0;
				char firstChar = strName.charAt(0);
				char lastChar = strName.charAt(strName.length() - 1);
				if(firstChar == lastChar){
					for (int i = 1; i < strName.length(); i++) {
						if(firstChar == strName.charAt(i)){
							counter++;
						}
					}
					if(counter == strName.length()-1){
						JOptionPane.showMessageDialog(null,"Invalid value, kindly provide valid value.");
						jText_Form_Sub2_Name.setText(""); 
						jText_Form_Sub2_Name.requestFocus();
					}
				}*/
			}

			@Override
			public void focusGained(FocusEvent e) {
				// TODO Auto-generated method stub
			}
		});

		/******************************************************************************/
		/*jText_Form_Sub2_GSTN.addFocusListener(new FocusListener() {
			@Override
			public void focusLost(FocusEvent e) {
				if (!"".equals(grpu.jText_Form_Sub2_GSTN.getText().toString().trim())) {
					if(jText_Form_Sub2_GSTN.getText().length() < 15){
						JOptionPane.showMessageDialog(null,"Please provide valid 15 digits GSTN");
						jText_Form_Sub2_GSTN.requestFocus();
					}
				}
			}

			@Override
			public void focusGained(FocusEvent e) {
				// TODO Auto-generated method stub
			}
		});*/
		/******************************************************************************/

		jText_Form_Sub3_Name.addFocusListener(new FocusListener() {
			@Override
			public void focusLost(FocusEvent e) {
				String strName = jText_Form_Sub3_Name.getText();
				System.out.println("Name Validation new = "+strName);
				if(!strName.equals("")){
					int counter = 0;
					char firstChar = strName.charAt(0);
					char lastChar = strName.charAt(strName.length() - 1);
					if(firstChar == lastChar){
						for (int i = 1; i < strName.length(); i++) {
							if(firstChar == strName.charAt(i)){
								counter++;
							}
						}
						if(counter == strName.length()-1){
							JOptionPane.showMessageDialog(null,"Invalid value, kindly provide valid value.");
							jText_Form_Sub3_Name.setText(""); 
							jText_Form_Sub3_Name.requestFocus();
						}
					}
				}
				/*int counter = 0;
				char firstChar = strName.charAt(0);
				char lastChar = strName.charAt(strName.length() - 1);
				if(firstChar == lastChar){
					for (int i = 1; i < strName.length(); i++) {
						if(firstChar == strName.charAt(i)){
							counter++;
						}
					}
					if(counter == strName.length()-1){
						JOptionPane.showMessageDialog(null,"Invalid value, kindly provide valid value.");
						jText_Form_Sub3_Name.setText(""); 
						jText_Form_Sub3_Name.requestFocus();
					}
				}*/
			}

			@Override
			public void focusGained(FocusEvent e) {
				// TODO Auto-generated method stub
			}
		});

		/*jText_Form_Sub2_TAN_RegNum.addFocusListener(new FocusListener() {
			@Override
			public void focusLost(FocusEvent e) {
				// TODO Auto-generated method stub
				if (!"".equals(jText_Form_Sub2_TAN_RegNum.getText().toString())
						|| jText_Form_Sub2_TAN_RegNum.getText() != null) {
					if(GrpuUtil.checkPan(jText_Form_Sub2_TAN_RegNum.getText().toString())){
						JOptionPane.showMessageDialog(null,
								"Please mention valid PAN of responsible person");
						jText_Form_Sub2_TAN_RegNum.setText(""); 
						jText_Form_Sub2_TAN_RegNum.requestFocus();
					}
				}
			}

			@Override
			public void focusGained(FocusEvent e) {
				// TODO Auto-generated method stub

			}
		});*/


		/**************************************************************************************************************************/

		// ******************************************************
		jText_Form_Sub1_Pan.setToolTipText("Specify the PAN of the deductor");
		JComboBox_Form_Sub1_finYear
		.setToolTipText("Select Correct Financial Year");
		JComboBox_Form_Sub1_Type_of_Deductor
		.setToolTipText("Specify Deductor/Collector type");
		JComboBox_Form_Sub1_Update_deductor
		.setToolTipText("To update deductor details in this field, select 'Update Deductor Details");
		if (formNumber.equalsIgnoreCase("24Q")) {
			jText_Form_Sub2_Name
			.setToolTipText("Enter Name of the Deductor (Employer)");
		} else if (formNumber.equalsIgnoreCase("26Q")
				|| formNumber.equalsIgnoreCase("27Q")) {
			jText_Form_Sub2_Name.setToolTipText("Enter Name of the Deductor");
		} else if (formNumber.equalsIgnoreCase("27EQ")) {
			jText_Form_Sub2_Name.setToolTipText("Enter Name of the Collector");
		}

		if ("24Q".equals(formNumber)) {
			jLabel_Form_Sub3_earlierReceiptNum
			.setText("<html>Receipt No. of earlier Statement <br>filed for Form 24Q</html>");
			jLabel_Form_Sub3_isRegularStatement
			.setText("<html>Has regular statement for Form <br>24Q filed for earlier period</html>");
		} else if ("26Q".equals(formNumber)) {
			jLabel_Form_Sub3_earlierReceiptNum
			.setText("<html>Receipt No. of earlier Statement <br>filed for Form 26Q</html>");
			jLabel_Form_Sub3_isRegularStatement
			.setText("<html>Has regular statement for Form <br>26Q filed for earlier period</html>");
		} else if ("27Q".equals(formNumber)) {
			jLabel_Form_Sub3_earlierReceiptNum
			.setText("<html>Receipt No. of earlier Statement <br>filed for Form 27Q</html>");
			jLabel_Form_Sub3_isRegularStatement
			.setText("<html>Has regular statement for Form <br>27Q filed for earlier period</html>");
		} else if ("27EQ".equals(formNumber)) {
			jLabel_Form_Sub3_earlierReceiptNum
			.setText("<html>Receipt No. of earlier Statement <br>filed for Form 27EQ</html>");
			jLabel_Form_Sub3_isRegularStatement
			.setText("<html>Has regular statement for Form <br>27EQ filed for earlier period</html>");
		}
		jText_Form_Sub2_Branch.setToolTipText("");
		jComboBox_Form_Sub2_State.setToolTipText("");
		jText_Form_Sub2_PAO_Code
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 20");
		jText_Form_Sub2_PAO_regNum
		.setToolTipText("Enter only numeric values. Field length =7");
		jText_Form_Sub2_FlatNo
		.setToolTipText("Enter Flat No. Maximum length of the field = 25");
		jText_Form_Sub2_Area
		.setToolTipText("Enter Area / Location. Maximum length of the field = 25");
		jText_Form_Sub2_Town
		.setToolTipText("Enter Town / City / District. Maximum length of the field = 25");
		jText_Form_Sub2_Road
		.setToolTipText("Enter Road / Street / Lane. Maximum length of the field = 25");
		jText_Form_Sub2_AIN
		.setToolTipText("This field is applicable from 2013-14 onwards. Field length =75");
		jText_Form_Sub2_GSTN.setToolTipText("Enter Alphanumeric values. Field length =15"); //added by Sadhana, FRD 2.2
		jText_Form_Sub2_AlternateTelNum_Std_Code
		.setToolTipText("Enter only STD Code without using any special character like '+' or '-' This field is applicable from 2013-14 onwards.");
		jText_Form_Sub2_AlternateTelNum
		.setToolTipText("Enter only Telephone No. without using any special character like '+' or '-'. This field is applicable from 2013-14 onwards.");
		jText_Form_Sub2_PinCode
		.setToolTipText("Enter only numeric values. Field length =6");
		jText_Form_Sub2_TelNum_Std_Code
		.setToolTipText("Enter only STD Code without using any special character like '+' or '-'");
		jText_Form_Sub2_TelNum
		.setToolTipText("Enter only Telephone No. without using any special character like '+' or '-'. This field is applicable from 2013-14 onwards.");
		if (JComboBox_Form_Sub2_MinistryName.getSelectedIndex() == 0)
			JComboBox_Form_Sub2_MinistryName
			.setToolTipText("Please select Ministry/Department Name");
		else
			JComboBox_Form_Sub2_MinistryName
			.setToolTipText(JComboBox_Form_Sub2_MinistryName
					.getSelectedItem().toString());
		jText_Form_Sub2_DDO_Code
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 20");
		jText_Form_Sub2_DDO_RegNum
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 10");
		jText_Form_Sub2_BuildingName
		.setToolTipText("Enter Name of Premises / Building. Maximum length of the field = 25");
		jText_Form_Sub2_Town
		.setToolTipText("Enter Town / City / District. Maximum length of the field = 25");
		jText_Form_Sub2_StateTwo.setToolTipText("");
		jText_Form_Sub2_TAN_RegNum
		.setToolTipText("Alphanumeric Field. Special characters are not allowed. Max Length = 12. Applicable only from F.Y. 2013-14 Onwards");
		jText_Form_Sub2_Email_Alternate
		.setToolTipText("This field is applicable from 2013-14 onwards. Maximum Field length =75");
		jComboBox_Form_Sub2_isAddressChanged
		.setToolTipText("Select Yes or No from the list");
		jText_Form_Sub2_Email
		.setToolTipText("No special characters except '.','@' and \"_\" are allowed. Field length =75");
		jComboBox_Form_Sub2_isAddressChanged
		.setToolTipText("Select Y or N from the list");
		jComboBox_Form_Sub3_isAddressChanged
		.setToolTipText("Select Y or N from the list");
		jComboBox_Form_Sub3_isRegularStatement
		.setToolTipText("Select Y or N from the list");
		jComboBox_Form_Sub2_isAddressChanged.setToolTipText("");

		jText_Form_Sub2_MinistryName_Other.setEnabled(false);

		jText_Form_Sub3_Name
		.setToolTipText("Enter Name of the Person. Maximum length of the field = 75");
		jText_Form_Sub3_Area
		.setToolTipText("Enter Area / Location. Maximum length of the field = 25");
		jText_Form_Sub3_Designation
		.setToolTipText("Enter Designation. Maximum length of the field = 20");
		jText_Form_Sub3_Town
		.setToolTipText("Enter Town / City / District. Maximum length of the field = 25");
		jText_Form_Sub3_FlatNum
		.setToolTipText("Enter Flat No. Maximum length of the field = 25");
		jText_Form_Sub3_BuildingName
		.setToolTipText("Enter Name of Premises / Building. Maximum length of the field = 25");
		jText_Form_Sub3_PinCode
		.setToolTipText("Enter only numeric values. Field length =6");
		jText_Form_Sub3_Road
		.setToolTipText("Enter Road / Street / Lane. Maximum length of the field = 25");
		jText_Form_Sub3_Email
		.setToolTipText("No special characters except '.','@' and \"_\" are allowed. Field length =75");
		jText_Form_Sub3_TelNum_Std_Code
		.setToolTipText("Enter only STD Code without using any special character like '+' or '-'");
		jText_Form_Sub3_TelNum
		.setToolTipText("Enter only Telephone No. without using any special character like '+' or '-'. This field is applicable from 2013-14 onwards.");
		jText_Form_Sub3_Email_Alternate
		.setToolTipText("This field is applicable from 2013-14 onwards. Maximum Field length =75");
		jText_Form_Sub3_TelNum_Alternate_Std_Code
		.setToolTipText("Enter only STD Code without using any special character like '+' or '-' This field is applicable from 2013-14 onwards.");
		jText_Form_Sub3_TelNum_Alternate
		.setToolTipText("Enter only Telephone No. without using any special character like '+' or '-'. This field is applicable from 2013-14 onwards.");
		jText_Form_Sub3_MobileNumber
		.setToolTipText("Enter only Mobile Number without using any special character like '+' or '-' This field is applicable from 2010-11 onwards.");
		jText_Form_Sub3_earlierReceiptNum
		.setToolTipText("Enter only numeric values. Maximum length of the field = 15");
		// added by dhaval 598588 for Swing_RPU End

		PanelBatchDet.setLayout(new GridLayout(1, 0, 0, 0));
		// PanelBatchDet.add(jScrollPaneTab444, 0);
		PanelBatchDet.add(jScrollPaneTab1, 0);

		jLabel_AIN = new JLabel("Accounts Office Identification Number (AIN) *");
		jLabel_AOName = new JLabel("Accounts Office Name *");
		jLabel_AOADD1 = new JLabel("Address Line 1 *");
		jLabel_AOADD2 = new JLabel("Address Line 2");
		jLabel_AOADD3 = new JLabel("Address Line 3");
		jLabel_AOADD4 = new JLabel("Address Line 4");
		jLabel_AOCity = new JLabel("City *");
		jLabel_AOState = new JLabel("State/UT *");
		jLabel_AOPIN = new JLabel("PIN Code *");
		jLabel_PhoneNo = new JLabel("Phone No. *");
		jLabel_STD = new JLabel("STD Code *");
		jLabel_EmailID = new JLabel("Email ID *");
		jLabel_ResponsiblePersonName = new JLabel("Responsible Person Name *");
		jLabel_ResponsiblePersonDesgn = new JLabel(
				"Responsible Person Designation *");
		jLabel_FinYear = new JLabel("Financial Year *");
		jLabel_Deductor_Category = new JLabel("Account Officer Category *");
		jLabel_State_Name = new JLabel("Name of State *");
		jLabel_Month = new JLabel("Month *");
		// jLabel_NatureOfDeduction = new JLabel("Nature Of Deduction *");
		jLabel_CntofDDOTransnDtls = new JLabel("Count of DDO records *");
		jLabel_OrigRRRNo = new JLabel("Receipt No. of Original Statement");
		jLabel_PrevRRRNo = new JLabel("Receipt No. of Previous Statement");
		jLabel_TypOfStmt = new JLabel("Type of Statement");
		// jLabel_Last_AIN = new
		// JLabel("Last Accounts Office Identification Number (AIN)");
		// jLabel_Last_Financial_Year = new JLabel("Last Financial Year");
		// jLabel_Last_Deductor_Category = new
		// JLabel("Last Account Officer Category");
		// jLabel_Last_Month = new JLabel("Last Month");
		// jLabel_Last_Nature_Of_Deduction = new
		// JLabel("Last Nature Of Deduction");
		jLabel_RespDetails = new JLabel("Details of Responsible Person ");
		jLabel_AODetails = new JLabel("Details of Accounts Office");

		jLabel_Mandatory = new JLabel(
				"Note : fields marked in ( * ) are Mandatory");

		// Responsible Person Details
		jLabel_ResponsiblePersonADD1 = new JLabel("Address Line 1 *");
		jLabel_ResponsiblePersonADD2 = new JLabel("Address Line 2");
		jLabel_ResponsiblePersonADD3 = new JLabel("Address Line 3");
		jLabel_ResponsiblePersonADD4 = new JLabel("Address Line 4");
		jLabel_ResponsiblePersonCity = new JLabel("City *");
		jLabel_ResponsiblePersonPIN = new JLabel("PIN Code *");
		jLabel_ResponsiblePersonPhoneNo = new JLabel("Phone No.");
		jLabel_ResponsiblePersonEmailID = new JLabel("Email ID *");
		jLabel_ResponsiblePersonMobilePhoneNo = new JLabel("Mobile No. *");
		jLabel_ResponsiblePersonState = new JLabel("State/UT *");
		jLabel_ResponsiblePersonSTD = new JLabel("STD Code");

		// Added By manish on 28102011

		jLabel_TypeOfCorrection = new JLabel("Type Of Correction ");

		// End
		// ministry
		jLabel_MinistryName = new JLabel("Ministry/ Department name");
		jLabel_SubMinistryName = new JLabel("Sub-Ministry name");
		jLabel_OtherMinistryName = new JLabel("Sub-Ministry name (Others)");

		// dhaval set font start
		jLabel_Form_heading1.setFont(fontHeading);
		jLabel_Form_Sub1_heading.setFont(fontTab);
		jLabel_Form_Sub2_heading.setFont(fontTab);
		jLabel_Form_Sub3_heading.setFont(fontTab);
		// dhaval set font end

		// Added by Akansha

		jLabel_Form_Sub1_Update_Instruction.setFont(fontTab);

		//newly developed FRD1.5 Ver1.5 by akansha
		jButton_Form_Sub1_Know_Your_Tan.setFont( new Font(fontName, 1, 14));
		jButton_Form_Sub1_Know_Your_Tan.setHorizontalAlignment(SwingConstants.LEFT);
		jButton_Form_Sub1_Know_Your_Tan.setBorderPainted(false);
		jButton_Form_Sub1_Know_Your_Tan.setOpaque(false);
		jButton_Form_Sub1_Know_Your_Tan.setBackground(Color.WHITE);
		jButton_Form_Sub1_Know_Your_Tan.setMargin(new Insets(0, 0, 0, 0));


		final URI uri_btn;

		uri_btn = new URI("https://incometaxindiaefiling.gov.in/e-Filing/Services/KnowYourTan.html;jsessionid=hGDTWLfVC00DL5y3v00BCg6TrDYnhvGwZZfXtqGGG7JJ66TNcLFy!-131787011");
		class OpenUrlAction implements ActionListener {
			public void actionPerformed(ActionEvent e) {
				open(uri_btn);
			}
		}



		jButton_Form_Sub1_Know_Your_Tan.addActionListener(new OpenUrlAction());

		// ******************************************

		// dhaval set into center for form start
		jLabel_Form_heading1.setHorizontalAlignment(SwingConstants.CENTER);

		// dhaval set into center for form end

		jLabel_RespDetails.setFont(font);
		jLabel_AODetails.setFont(font);

		jLabel_Mandatory.setFont(font);
		jText_PhoneNo = new JTextField();
		jText_PhoneNo.addFocusListener(focusList);
		jText_AIN = new JTextField("Hello");
		jText_AIN.addFocusListener(focusList);
		jText_AOName = new JTextField();
		jText_AOName.addFocusListener(focusList);
		jText_AOADD1 = new JTextField();
		jText_AOADD1.addFocusListener(focusList);
		jText_AOADD2 = new JTextField();
		jText_AOADD2.addFocusListener(focusList);
		jText_AOADD3 = new JTextField();
		jText_AOADD3.addFocusListener(focusList);
		jText_AOADD4 = new JTextField();
		jText_AOADD4.addFocusListener(focusList);
		jText_AOCity = new JTextField();
		jText_AOCity.addFocusListener(focusList);
		jText_STD = new JTextField();
		jText_STD.addFocusListener(focusList);
		// jText_Last_AIN = new JTextField();
		jText_AOPIN = new JTextField();
		jText_AOPIN.addFocusListener(focusList);
		jText_EmailID = new JTextField();
		jText_EmailID.addFocusListener(focusList);
		jText_CntofDDOTransnDtls = new JTextField();
		jText_Cur_CntofDDOTransnDtls = new JTextField();
		jText_OrigRRRNo = new JTextField();
		jText_PrevRRRNo = new JTextField();
		jText_FinYear1 = new JTextField();
		jText_Month = new JTextField();
		//added for ladakh
		String jComboBox_AOStateName[] = { "--Select--",
				"Andaman & Nicobar Islands", "Andhra Pradesh",
				"Arunachal Pradesh", "Assam", "Bihar", "Chandigarh",
				"Chhatishgarh", "Dadra Nagar Haveli & Daman Diu",
				"Delhi", "Goa", "Gujarat", "Haryana", "Himachal Pradesh",
				"Jammu & Kashmir", "Jharkhand", "Karnataka", "Kerala","Ladakh",
				"Lakshwadeep", "Madhya Pradesh", "Maharashtra", "Manipur",
				"Meghalaya", "Mizoram", "Nagaland", "Odisha", "Pondicherry",
				"Punjab", "Rajasthan", "Sikkim", "Tamil Nadu", "Telangana",
				"Tripura", "Uttar Pradesh", "Uttarakhand", "West Bengal" };
		
		String jComboBox_DedCat[] = { "--Select--", "Central Govt.",
		"State Govt." };
		String jComboBox_State[] = { "--Select--", "Andaman & Nicobar Islands",
				"Andhra Pradesh", "Arunachal Pradesh", "Assam", "Bihar",
				"Chandigarh", "Chhatishgarh", "Dadra Nagar Haveli & Daman Diu", "Delhi", "Goa", "Gujarat", "Haryana",
				"Himachal Pradesh", "Jammu & Kashmir", "Jharkhand",
				"Karnataka", "Kerala","Ladakh", "Lakshwadeep", "Madhya Pradesh",
				"Maharashtra", "Manipur", "Meghalaya", "Mizoram", "Nagaland",
				"Odisha", "Pondicherry", "Punjab", "Rajasthan", "Sikkim",
				"Tamil Nadu", "Telangana", "Tripura", "Uttarakhand",
				"Uttar Pradesh", "West Bengal" };
		String jComboBox_Month_Data[] = { "--Select--", "January", "February",
				"March", "April", "May", "June", "July", "August", "September",
				"October", "November", "December" };
		// Added By amit for the drop down for the section code

		jComboBox_Book_Entry = new String[] { "--Select--", "Yes", "No" };
		jComboBox_Update_Mode = new String[] { "--Select--", "Update" };
		jComboBox_Minor_Head_Challan = new String[] { "--Select--", "200",
		"400" };
		String jComboBox_AddressChange[] = { "--Select--", "Yes", "No" };

		// amit end
		jComboBox_NtrOfDedtn = new String[] { "--Select--", "TDS-SAL (24Q)",
				"TDS-NON-SAL (26Q)", "TDS-NR (27Q)", "TCS (27EQ)" };
		String jComboBox_transctnType[] = { "--Select--", "C", "X" };
		String jComboBox_TypeOfStmt[] = { "Regular", "Correction" };

		String jComboBox_TypeOfCorrectionArray[] = { "--Select--", "Cancel",
		"Modify" };

		// Changed by Abhishek on 18052010 added "2010-11"
		String jComboBox_FinYear[] = { "--Select--", "2006-07", "2007-08",
				"2008-09", "2009-10", "2010-11", "2011-12" };
		String jComboBox_Last_FinYear[] = { "--Select--", "2006-07", "2007-08",
				"2008-09", "2009-10", "2010-11" };
		// End
		String jComboBox_Last_NtrOfDedtn[] = { "--Select--", "TDS-SAL (24Q)",
				"TDS-NON-SAL (26Q)", "TDS-NR (27Q)", "TCS (27EQ)" };
		String jComboBox_Last_Month_Data[] = { "--Select--", "January",
				"February", "March", "April", "May", "June", "July", "August",
				"September", "October", "November", "December" };
		String jComboBox_Last_DedCat[] = { "--Select--", "Central Govt.",
		"State Govt." };

		// ministry
		String jComboBox_MinistryData[] = { "--Select--", "Civil", "Railway",
				"Defence", "Telecommunication", "Post" };
		String jComboBox_SubMinistryData[] = { "--Select--", "Agriculture",
				"Atomic Energy", "Fertilizers", "Chemicals & Petrochemicals",
				"Civil Aviation & Tourism", "Coal",
				"Consumer Affairs, Food & Public Distribution",
				"Commerce & Textiles",
				"Environment & Forest and Ministry of Earth Science",
				"External affairs and Overseas Indian affairs", "Finance",
				"Central Board of Direct Taxes",
				"Central Board of Excise and Customs",
				"Controller of Aid Accounts and Audit",
				"Central Pension Accounting Office",
				"Food Processing Industries", "Health and Family Welfare",
				"Home Affairs and development of North Eastern Region",
				"Human Resource Development", "Industry",
				"Information and Broadcasting",
				"Telecommunication and Information Technology", "Labour",
				"Law and Justice and Company Affairs",
				"Personnel, Public Grievances and Pensions",
				"Petroleum and Natural Gas",
				"Planning, Statistics and Programme Implementation", "Power",
				"New and Renewable Energy",
				"Rural Development and Panchayati Raj",
				"Science and Technology", "Space", "Steel", "Mines",
				"Social Justice and Empowerment", "Tribal Affairs",
				"D/o of Commerce (Supply Division)",
				"Shipping and Road Transport and Highways",
				"Urban Development, Urban Employment and Povery Alleviation",
				"Water Resources", "President's Secretariat",
				"Lok Sabha Secretariat", "Rajya Sabha Secretariat",
				"Election Commision",
				"Andaman and Nicobar Islands Administration",
				"Chandigarh Administration", "Dadra and Nagar Haveli",
				"Goa, Daman and Diu", "Lakshwadeep",
				"Pondicherry Administration",
				"Pay and Account Officers (Audit)",
				"Non-conventional energy sources",
				"Government of NCT of Delhi", "Others" };

		jComboBox_MinistryName = new JComboBox(jComboBox_MinistryData);
		jComboBox_MinistryName.setBackground(Color.white);
		jComboBox_MinistryName.setEnabled(false);
		jComboBox_MinistryName.setSelectedIndex(0);
		jComboBox_MinistryName.addFocusListener(focusList);
		jComboBox_SubMinistryName = new JComboBox(jComboBox_SubMinistryData);
		jComboBox_SubMinistryName.setBackground(Color.white);
		jComboBox_SubMinistryName.setEnabled(false);
		jComboBox_SubMinistryName.addFocusListener(focusList);
		jText_OtherMinistryName = new JTextField();
		jText_OtherMinistryName.setEditable(false);
		jText_OtherMinistryName.addFocusListener(focusList);

		jComboBox_AOState = new JComboBox(jComboBox_AOStateName);
		// Added by Akansha
		jComboBox_AOState.setToolTipText("Please select State Name");
		// ******************
		jComboBox_Form_Sub2_isAddressChanged = new JComboBox(
				jComboBox_AddressChange);
		jComboBox_Form_Sub2_isAddressChanged.setBackground(Color.WHITE);

		jComboBox_Form_Sub3_isRegularStatement = new JComboBox(
				jComboBox_AddressChange);
		jComboBox_Form_Sub3_isRegularStatement.setBackground(Color.WHITE);

		jComboBox_Form_Sub3_isAddressChanged = new JComboBox(
				jComboBox_AddressChange);
		jComboBox_Form_Sub3_isAddressChanged.setBackground(Color.WHITE);

		jComboBox_Form_Sub2_State = new JComboBox(jComboBox_AOStateName);
		jComboBox_Form_Sub2_State.setBackground(Color.white);
		jComboBox_AOState.setBackground(Color.white);
		jComboBox_Deductor_Category = new JComboBox(jComboBox_DedCat);
		jComboBox_Deductor_Category.setBackground(Color.white);
		jComboBox_Deductor_Category.addFocusListener(focusList);
		jComboBox_State_Name = new JComboBox(jComboBox_AOStateName);
		// Added by Akansha
		jComboBox_State_Name.setToolTipText("Please select State Name");
		jComboBox_Form_Sub2_State.setToolTipText("Please select State Name");
		jText_Form_Sub1_Tan.setBackground(Color.white);
		jText_Form_Sub2_MinistryName_Other.setBackground(Color.white);
		// ******************
		jComboBox_State_Name.setBackground(Color.white);
		// jComboBox_State_Name.addFocusListener(focusList);
		jComboBox_State_Name.setSelectedIndex(0);
		jComboBox_Month = new JComboBox(jComboBox_Month_Data);
		jComboBox_Month.setBackground(Color.white);
		jComboBox_Month.addFocusListener(focusList);
		// jComboBox_NatureOfDeduction = new JComboBox(jComboBox_NtrOfDedtn);
		// jComboBox_NatureOfDeduction.setBackground(Color.white);
		jComboBox_TypOfStmt = new JComboBox(jComboBox_TypeOfStmt);
		jComboBox_TypOfStmt.setBackground(Color.white);
		jComboBox_FinYear1 = new JComboBox(FinancialYear.getFinancialYr()
				.toArray());
		jComboBox_FinYear1.setBackground(Color.white);
		jComboBox_FinYear1.addFocusListener(focusList);
		jComboBox_TypOfStmt.setFont(new Font(fontName, 1, 14));

		// manish

		jComboBox_TypeOfCorrection = new JComboBox(
				jComboBox_TypeOfCorrectionArray);
		jComboBox_TypeOfCorrection.setFont(new Font(fontName, 1, 14));
		jComboBox_TypeOfCorrection.setBackground(Color.white);
		jComboBox_TypeOfCorrection.addFocusListener(focusList);
		jComboBox_TypeOfCorrection.setEnabled(false);
		jComboBox_TypeOfCorrection.setEditable(false);
		// end

		// Responsible person fields
		jText_ResponsiblePersonName = new JTextField();
		jText_ResponsiblePersonName.addFocusListener(focusList);
		jText_ResponsiblePersonDesgn = new JTextField();
		jText_ResponsiblePersonDesgn.addFocusListener(focusList);
		jText_ResponsiblePersonADD1 = new JTextField();
		jText_ResponsiblePersonADD1.addFocusListener(focusList);
		jText_ResponsiblePersonADD2 = new JTextField();
		jText_ResponsiblePersonADD2.addFocusListener(focusList);
		jText_ResponsiblePersonADD3 = new JTextField();
		jText_ResponsiblePersonADD3.addFocusListener(focusList);
		jText_ResponsiblePersonADD4 = new JTextField();
		jText_ResponsiblePersonADD4.addFocusListener(focusList);
		jText_ResponsiblePersonCity = new JTextField();
		jText_ResponsiblePersonCity.addFocusListener(focusList);
		jText_ResponsiblePersonPIN = new JTextField();
		jText_ResponsiblePersonPIN.addFocusListener(focusList);
		jText_ResponsiblePersonPhoneNo = new JTextField();
		jText_ResponsiblePersonPhoneNo.addFocusListener(focusList);
		jText_ResponsiblePersonEmailID = new JTextField();
		jText_ResponsiblePersonEmailID.addFocusListener(focusList);
		jText_ResponsiblePersonMobilePhoneNo = new JTextField();
		jText_ResponsiblePersonMobilePhoneNo.addFocusListener(focusList);
		jText_ResponsiblePersonSTD = new JTextField();
		jText_ResponsiblePersonSTD.addFocusListener(focusList);
		jComboBox_ResponsiblePersonState = new JComboBox(jComboBox_State);
		jComboBox_ResponsiblePersonState.setBackground(Color.white);
		jComboBox_ResponsiblePersonState.addFocusListener(focusList);

		// statistical data

		jLabel_count24QTrans = new JLabel("Count of 24Q transaction");
		jText_count24QTrans = new JTextField("0");
		jText_count24QTrans.setEditable(false);

		jLabel_controlTax24q = new JLabel(
				"Control total of tax deducted/collected (24Q)");
		jText_controlTax24q = new JTextField("0");
		jText_controlTax24q.setEditable(false);

		jLabel_totalTDS24q = new JLabel(
				"Total TDS/TCS remitted to Government account (AG/Pr CCA) for 24Q");
		jText_totalTDS24q = new JTextField("0");
		jText_totalTDS24q.setEditable(false);

		jLabel_count26QTrans = new JLabel("Count of 26Q transaction");
		jText_count26QTrans = new JTextField("0");
		jText_count26QTrans.setEditable(false);

		jLabel_controlTax26q = new JLabel(
				"Control total of tax deducted/collected (26Q)");
		jText_controlTax26q = new JTextField("0");
		jText_controlTax26q.setEditable(false);

		jLabel_totalTDS26q = new JLabel(
				"Total TDS/TCS remitted to Government account (AG/Pr CCA) for 26Q");
		jText_totalTDS26q = new JTextField("0");
		jText_totalTDS26q.setEditable(false);

		jLabel_count27QTrans = new JLabel("Count of 27Q transaction");
		jText_count27QTrans = new JTextField("0");
		jText_count27QTrans.setEditable(false);

		jLabel_controlTax27q = new JLabel(
				"Control total of tax deducted/collected (27Q)");
		jText_controlTax27q = new JTextField("0");
		jText_controlTax27q.setEditable(false);

		jLabel_totalTDS27q = new JLabel(
				"Total TDS/TCS remitted to Government account (AG/Pr CCA) for 27Q");
		jText_totalTDS27q = new JTextField("0");
		jText_totalTDS27q.setEditable(false);

		jLabel_count27EQTrans = new JLabel("Count of 27EQ transaction");
		jText_count27EQTrans = new JTextField("0");
		jText_count27EQTrans.setEditable(false);

		jLabel_controlTax27Eq = new JLabel(
				"Control total of tax deducted/collected (27EQ)");
		jText_controlTax27Eq = new JTextField("0");
		jText_controlTax27Eq.setEditable(false);

		jLabel_totalTDS27Eq = new JLabel(
				"Total TDS/TCS remitted to Government account (AG/Pr CCA) for 27EQ");
		jText_totalTDS27Eq = new JTextField("0");
		jText_totalTDS27Eq.setEditable(false);

		jLabel_totalTDS = new JLabel("Total Amount");
		jText_totalTDS = new JTextField("0");
		jText_totalTDS.setEditable(false);

		jLabel_countOfDDOAdd = new JLabel("Count of DDO Added");
		jText_countOfDDOAdd = new JTextField("0");
		jText_countOfDDOAdd.setEditable(false);

		jLabel_countOfDDOUpd = new JLabel("Count of DDO Updated");
		jText_countOfDDOUpd = new JTextField("0");
		jText_countOfDDOUpd.setEditable(false);

		jLabel_countOfDDODel = new JLabel("Count of DDO Deleted");
		jText_countOfDDODel = new JTextField("0");
		jText_countOfDDODel.setEditable(false);

		jLabel_regNoPaoDtoCddo = new JLabel(
				"Account Office Registration Number");
		jText_regNoPaoDtoCddo = new JTextField("");
		jText_regNoPaoDtoCddo.addFocusListener(focusList);

		// jComboBox_State_Name.setEnabled(false); //by Akansha
		jText_OrigRRRNo.setEditable(false);
		jText_PrevRRRNo.setEditable(false);
		jText_OrigRRRNo.setEnabled(false);
		jText_PrevRRRNo.setEnabled(false);

		// edited By Manish 28102011 make it enabled
		jComboBox_TypOfStmt.setSelectedItem(valueOfTypeOfStmt);
		jComboBox_TypOfStmt.setEnabled(false);

		if (valueOfTypeOfStmt.equals("Correction")) {
			jComboBox_TypeOfCorrection.setEnabled(true);
			jText_OrigRRRNo.setEditable(true);
			jText_PrevRRRNo.setEditable(true);
			jText_OrigRRRNo.setEnabled(true);
			jText_PrevRRRNo.setEnabled(true);
		} else {
			jComboBox_TypeOfCorrection.setEnabled(false);
			jText_OrigRRRNo.setEditable(false);
			jText_PrevRRRNo.setEditable(false);
			jText_OrigRRRNo.setEnabled(false);
			jText_PrevRRRNo.setEnabled(false);
		}

		// jComboBox_TypOfStmt.setEnabled(true);
		// jComboBox_TypOfStmt.setEditable(true);

		jText_CntofDDOTransnDtls.setEditable(false);
		jText_Cur_CntofDDOTransnDtls.setEditable(false);
		jText_Cur_CntofDDOTransnDtls.setVisible(false);

		System.out.println("inside the initialisebhtab");
		// inside initialisebhtab
		TabGRPU.addChangeListener(new ChangeListener() {

			// -- changed for the annexure II form

			public void stateChanged(ChangeEvent e) {
				System.out.println("before state changed called");
				TabGRPU_stateChanged(e, "");
			}

		});


		addComponent(jPanel14, jLabel_Form_heading1, 5, 5, 950, 20);
		addComponent(jPanel14, jLabel_Form_quarterEnd, 350, 25, 170, 20);
		addComponent(jPanel14, jComboBox_Quarter, 490, 25, 100, 20);

		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_heading, 10, 5,
				200, 20);
		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_Tan, 25, 30,
				270, 20);
		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_LastTan, 25, 60,
				270, 20);
		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_Pan, 25, 90,
				270, 20);
		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_isRevised, 25,
				120, 270, 20);
		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_Update_deductor,
				25, 150, 270, 20);
		addComponent(jPanel_Form_particulars,
				jLabel_Form_Sub1_Update_Instruction, 25, 180, 400, 20);
		//newly developed for FRD1.5 Ver1.5 by akansha
		//addComponent(jPanel_Form_particulars, jButton_Form_Sub1_Know_Your_Tan, 25, 200, 325, 20);

		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_finYear, 530,
				30, 220, 20);
		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_AssessmentYear,
				530, 60, 220, 20);
		addComponent(jPanel_Form_particulars,
				jLabel_Form_Sub1_Type_of_Deductor, 530, 90, 220, 20);
		addComponent(jPanel_Form_particulars,
				jLabel_Form_Sub1_Last_Deductor_Type, 530, 120, 220, 20);
		addComponent(jPanel_Form_particulars, jLabel_Form_Sub1_Org_Receipt_Num,
				530, 150, 220, 20);
		addComponent(jPanel_Form_particulars,
				jLabel_Form_Sub1_Previous_Receipt_num, 530, 180, 220, 20);
		addComponent(jPanel_Form_particulars, jText_Form_Sub1_Tan, 315, 30,
				200, 23);
		addComponent(jPanel_Form_particulars, jText_Form_Sub1_LastTan, 315, 60,
				200, 23);
		addComponent(jPanel_Form_particulars, jText_Form_Sub1_Pan, 315, 90,
				200, 23);
		addComponent(jPanel_Form_particulars, jText_Form_Sub1_isRevised, 315,
				120, 200, 23);
		addComponent(jPanel_Form_particulars,
				JComboBox_Form_Sub1_Update_deductor, 315, 150, 200, 23);
		addComponent(jPanel_Form_particulars, JComboBox_Form_Sub1_finYear, 730,
				30, 200, 23);
		addComponent(jPanel_Form_particulars, jText_Form_Sub1_AssessmentYear,
				730, 60, 200, 23);
		addComponent(jPanel_Form_particulars,
				JComboBox_Form_Sub1_Type_of_Deductor, 730, 90, 200, 23);
		addComponent(jPanel_Form_particulars,
				jText_Form_Sub1_Last_Deductor_Type, 730, 120, 200, 23);
		addComponent(jPanel_Form_particulars, jText_Form_Sub1_Org_Receipt_Num,
				730, 150, 200, 23);
		addComponent(jPanel_Form_particulars,
				jText_Form_Sub1_Previous_Receipt_num, 730, 180, 200, 23);

		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_heading, 10, 5, 250, 20);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Name,
				25, 30, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Branch,
				25, 60, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_State,
				25, 90, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_PAO_Code, 25, 120, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_PAO_regNum, 25, 150, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_FlatNo,
				/*25, 180, 270, 20*/530, 150, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Area,
				/*530, 150, 220, 20*/25, 210, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_BuildingName, /*25, 210, 270, 20*/25, 180, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Road,
				/*25, 240, 270, 20*/530, 180, 220, 20);
		/*addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Road,
				25, 210, 270, 20);*/
		/*addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_PinCode, 25, 240, 270, 20);*/
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_TelNum,
				25, 270, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_AlternateTelNum, 25, 300, 270, 20);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_AIN,
				25, 330, 270, 27);
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_GSTN,
				25, 365, 270, 27); //For FRD2.1, added by Sadhana, added GSTN label into panel
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Name,
				300, 30, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Branch,
				300, 60, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jComboBox_Form_Sub2_State, 300, 90, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_PAO_Code, 300, 120, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_PAO_regNum, 300, 150, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_FlatNo,
				/*300, 180, 200, 23*/730, 150, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Area,
				/*730, 150, 200, 23*/300, 210, 200, 23);
		/*addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Road,
				300, 210, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_PinCode,
				300, 240, 200, 23);*/

		/*************************************************************/
		//Added by Sadhana FRD2.0
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Road,
				/*300, 240, 200, 23*/730, 180, 200, 23);
		/*************************************************************/

		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_TelNum_Std_Code, 300, 270, 75, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_TelNum,
				375, 270, 125, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_AlternateTelNum_Std_Code, 300, 300, 75, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_AlternateTelNum, 375, 300, 125, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_AIN,
				300, 330, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_GSTN,
				300, 365, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_MinistryName, 530, 30, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_MinistryName_Other, 530, 60, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_DDO_Code, 530, 90, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_DDO_RegNum, 530, 120, 220, 20);
		/*
		 * addComponent(jPanel_Form_particulars_Deductor,
		 * jLabel_Form_Sub2_TAN_RegNum, 530, 150, 220, 20);
		 */
		/*addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_BuildingName, 530, 180, 220, 20);*/
		/*addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Town,
				530, 210, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_StateTwo, 530, 240, 220, 20);*/

		/*************************************************************/
		//Added by Sadhana FRD2.0
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Town,
				/*530, 180, 220, 20*/530, 210, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_StateTwo, /*530, 210, 220, 20*/530, 240, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_PinCode, /*530, 240, 220, 20*/25, 240, 270, 20);
		/********************************************************************/
		addComponent(jPanel_Form_particulars_Deductor, jLabel_Form_Sub2_Email,
				530, 270, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_Email_Alternate, 530, 300, 220, 20);
		addComponent(jPanel_Form_particulars_Deductor,
				jLabel_Form_Sub2_isAddressChanged, 530, 330, 220, 40);
		addComponent(jPanel_Form_particulars_Deductor,
				JComboBox_Form_Sub2_MinistryName, 730, 30, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_MinistryName_Other, 730, 60, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_DDO_Code, 730, 90, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_DDO_RegNum, 730, 120, 200, 23);
		/*
		 * addComponent(jPanel_Form_particulars_Deductor,
		 * jText_Form_Sub2_TAN_RegNum, 730, 150, 200, 23);
		 */// #### New Development as on 2/04/2015 by Akansha
		/*addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_BuildingName, 730, 180, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Town,
				730, 210, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jComboBox_AOState, 730,
				240, 200, 23);*/
		/*************************************************************************/
		//Added by Sadhana FRD2.0
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_BuildingName, /*300, 210, 200, 23*/300, 180, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Town,
				/*730, 180, 200, 23*/730, 210, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jComboBox_AOState,
				/*730, 210, 200, 23*/730,240, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_PinCode,
				/*730,240, 200, 23*/300, 240, 200, 23);
		/*******************************************************************************/
		addComponent(jPanel_Form_particulars_Deductor, jText_Form_Sub2_Email,
				730, 270, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jText_Form_Sub2_Email_Alternate, 730, 300, 200, 23);
		addComponent(jPanel_Form_particulars_Deductor,
				jComboBox_Form_Sub2_isAddressChanged, 730, 330, 200, 23);

		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_heading,
				10, 5, 500, 20);
		addComponent(jPanel_Form_particulars_Person,
				jCheckBox_Form_Sub2_Sameasabove, 525, 5, 400, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_Name, 25,
				30, 270, 20);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_Designation, 25, 60, 270, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_FlatNum,
				/*25, 90, 270, 20*/530, 60, 220, 20);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_BuildingName, /*25, 120, 270, 20*/25, 90, 270, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_Road, /*25,
				150, 270, 20*/530, 90, 220, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_TelNum,
				25, 180, 270, 20);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_TelNum_Alternate, 25, 210, 270, 20);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_isAddressChange, 25, 240, 270, 20);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_isRegularStatement, 25, 270, 270, 40);

		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub2_TAN_RegNum, 530, 30, 220, 20);

		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_Area,
				/*530, 60, 220, 20*/25, 120, 270, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_Town,
				/*530, 90, 220, 20*/530, 120, 220, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_State,
				/*530, 120, 220, 20*/530, 150, 220, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_PinCode,
				/*530, 150, 220, 20*/25,150, 270, 20);
		addComponent(jPanel_Form_particulars_Person, jLabel_Form_Sub3_Email,
				530, 180, 220, 20);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_Email_Alternate, 530, 210, 220, 20);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_MobileNumber, 530, 240, 220, 40);
		addComponent(jPanel_Form_particulars_Person,
				jLabel_Form_Sub3_earlierReceiptNum, 530, 270, 220, 40);
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_Name, 300,
				30, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_Designation, 300, 60, 200, 23);
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_FlatNum,
				/*300, 90, 200, 23*/730,60, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_BuildingName, /*300, 120, 200, 23*/300, 90, 200, 23);
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_Road, /*300,
				150, 200, 23*/730,90, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_TelNum_Std_Code, 300, 180, 75, 23);
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_TelNum,
				375, 180, 125, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_TelNum_Alternate_Std_Code, 300, 210, 75, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_TelNum_Alternate, 375, 210, 125, 23);
		addComponent(jPanel_Form_particulars_Person,
				jComboBox_Form_Sub3_isAddressChanged, 300, 240, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jComboBox_Form_Sub3_isRegularStatement, 300, 270, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub2_TAN_RegNum, 730, 30, 200, 23); // #### New
		// Development
		// as on
		// 2/04/2015 by
		// Akansha
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_Area, /*730,
				60, 200, 23*/300, 120, 200, 23);
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_Town, /*730,
				90, 200, 23*/730,120, 200, 23);
		addComponent(jPanel_Form_particulars_Person, jComboBox_State_Name, /*730,
				120, 200, 23*/730, 150, 200, 23);
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_PinCode,
				/*730, 150, 200, 23*/300,150, 200, 23);
		addComponent(jPanel_Form_particulars_Person, jText_Form_Sub3_Email,
				730, 180, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_Email_Alternate, 730, 210, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_MobileNumber, 730, 240, 200, 23);
		addComponent(jPanel_Form_particulars_Person,
				jText_Form_Sub3_earlierReceiptNum, 730, 270, 200, 23);

		addComponent(jPanel14, jPanel_Form_particulars, 10, 50, 950, 225);
		addComponent(jPanel14, jPanel_Form_particulars_Deductor, 10, 300, 950,
				400); // New dev for ver1.3 added by Akansha
		addComponent(jPanel14, jPanel_Form_particulars_Person, 10, 720, 950,
				320);

		jPanel16.add(jPanel14);

		// dhaval add into form end

		// Added by Akansha
		// Code for adding the component mouse listener

		//	jText_Form_Sub1_Pan.addMouseListener(new PopClickListener());


		//newly developed for FRD1.5 Ver1.5 by akansha		
		//Panel1
		GrpuUtil.textFieldMenus(jText_Form_Sub1_Tan);
		GrpuUtil.textFieldMenus(jText_Form_Sub1_Pan);

		//Panel2
		GrpuUtil.textFieldMenus(jText_Form_Sub2_Name);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_Branch);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_MinistryName_Other);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_DDO_Code);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_PAO_Code);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_DDO_RegNum);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_PAO_regNum);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_Area);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_FlatNo);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_BuildingName);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_Road);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_Town);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_PinCode);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_TelNum_Std_Code);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_TelNum);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_Email);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_AlternateTelNum_Std_Code);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_AlternateTelNum);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_Email_Alternate);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_AIN);
		GrpuUtil.textFieldMenus(jText_Form_Sub2_GSTN);

		//Panel3
		GrpuUtil.textFieldMenus(jText_Form_Sub2_TAN_RegNum);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_Name);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_Designation);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_FlatNum);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_BuildingName);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_Road);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_Area);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_Town);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_PinCode);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_TelNum_Std_Code);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_TelNum);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_Email);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_TelNum_Alternate_Std_Code);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_TelNum_Alternate);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_Email_Alternate);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_MobileNumber);
		GrpuUtil.textFieldMenus(jText_Form_Sub3_earlierReceiptNum);
		// ******************************************

		JComboBox_Form_Sub2_MinistryName
		.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {

				if (JComboBox_Form_Sub2_MinistryName.getSelectedItem()
						.toString().equalsIgnoreCase("Others")) { // Newly
					// added
					// for
					// correction
					// Version1.2
					// by
					// Akansha
					if (!"Correction".equals(valueOfTypeOfStmt))
						jText_Form_Sub2_MinistryName_Other
						.setEnabled(true);
					else if ("Correction".equals(valueOfTypeOfStmt)
							&& !"Other Deductor Details"
							.equals(JComboBox_Form_Sub1_Update_deductor
									.getSelectedItem()
									.toString())) {
						jText_Form_Sub2_MinistryName_Other
						.setEnabled(false);
					} else if ("Correction".equals(valueOfTypeOfStmt)
							&& "Other Deductor Details"
							.equals(JComboBox_Form_Sub1_Update_deductor
									.getSelectedItem()
									.toString())) {
						jText_Form_Sub2_MinistryName_Other
						.setEnabled(true);
					}

				} else {
					jText_Form_Sub2_MinistryName_Other
					.setEnabled(false);
					jText_Form_Sub2_MinistryName_Other.setText("");
				}
			}
		});

		// Added by Akansha
		JComboBox_Form_Sub1_Update_deductor
		.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				if ("Other Deductor Details"
						.equals(JComboBox_Form_Sub1_Update_deductor
								.getSelectedItem())
								&& "Correction".equals(valueOfTypeOfStmt)) {

					// First panel
					jText_Form_Sub1_Tan.setEnabled(false);
					jText_Form_Sub1_LastTan.setEnabled(false);
					JComboBox_Form_Sub1_finYear.setEnabled(false);
					jText_Form_Sub1_Pan.setEnabled(true);
					JComboBox_Form_Sub1_finYear.setEnabled(false);
					JComboBox_Form_Sub1_Type_of_Deductor
					.setEnabled(true);
					// JComboBox_Form_Sub1_Update_deductor
					// .setEnabled(false);
					jText_Form_Sub1_isRevised.setText("Yes");
					jText_Form_Sub1_isRevised.setEnabled(false);
					jText_Form_Sub1_AssessmentYear.setEnabled(false);
					jText_Form_Sub1_Last_Deductor_Type
					.setEnabled(false);
					jText_Form_Sub1_Org_Receipt_Num.setEnabled(false);
					jText_Form_Sub1_Previous_Receipt_num
					.setEnabled(false);
					// *********
					// Second Panel
					jText_Form_Sub2_Name.setEnabled(true);
					jText_Form_Sub2_Branch.setEnabled(true);
					JComboBox_Form_Sub2_MinistryName.setEnabled(true);
					if ("Others"
							.equals(JComboBox_Form_Sub2_MinistryName
									.getSelectedItem().toString())) // Newly
						// added
						// for
						// correction
						// Ver1.2
						jText_Form_Sub2_MinistryName_Other
						.setEnabled(true);
					else
						jText_Form_Sub2_MinistryName_Other
						.setEnabled(false);
					jComboBox_Form_Sub2_State.setEnabled(false);
					jText_Form_Sub2_DDO_Code.setEnabled(true);
					jText_Form_Sub2_PAO_Code.setEnabled(true);
					jText_Form_Sub2_DDO_RegNum.setEnabled(true);
					jText_Form_Sub2_PAO_regNum.setEnabled(true);
					jText_Form_Sub2_TAN_RegNum.setEnabled(true); // ##
					// New
					// Development
					// as
					// on
					// 04/04/2015
					// by
					// Akansha
					jText_Form_Sub2_FlatNo.setEnabled(true);
					jText_Form_Sub2_Area.setEnabled(true);
					jText_Form_Sub2_BuildingName.setEnabled(true);
					jText_Form_Sub2_Town.setEnabled(true);
					jText_Form_Sub2_Road.setEnabled(true);
					jText_Form_Sub2_PinCode.setEnabled(true);
					jComboBox_AOState.setEnabled(true);
					jText_Form_Sub2_PinCode.setEnabled(true);
					jText_Form_Sub2_TelNum.setEnabled(true);
					jText_Form_Sub2_TelNum_Std_Code.setEnabled(true);
					jText_Form_Sub2_Email.setEnabled(true);
					jText_Form_Sub2_Email_Alternate.setEnabled(true);
					jText_Form_Sub2_AlternateTelNum_Std_Code
					.setEnabled(true);
					jText_Form_Sub2_AlternateTelNum.setEnabled(true);
					jText_Form_Sub2_AIN.setEnabled(false);
					jComboBox_Form_Sub2_isAddressChanged.setEnabled(true);
					//jText_Form_Sub2_GSTN.setEnabled(true);
					// *********

					// Third Panel
					jText_Form_Sub3_Name.setEnabled(true);
					jText_Form_Sub3_Designation.setEnabled(true);
					jText_Form_Sub3_FlatNum.setEnabled(true);
					jText_Form_Sub3_Road.setEnabled(true);
					jText_Form_Sub3_BuildingName.setEnabled(true);
					jComboBox_Form_Sub3_isAddressChanged
					.setEnabled(true);
					jComboBox_Form_Sub3_isRegularStatement
					.setEnabled(false);
					jText_Form_Sub3_Area.setEnabled(true);
					jText_Form_Sub3_Town.setEnabled(true);
					jComboBox_State_Name.setEnabled(true);
					jText_Form_Sub3_PinCode.setEnabled(true);
					jText_Form_Sub3_Email.setEnabled(true);
					jText_Form_Sub3_TelNum.setEnabled(true);
					jText_Form_Sub3_TelNum_Std_Code.setEnabled(true);
					jText_Form_Sub3_TelNum_Alternate_Std_Code
					.setEnabled(true);
					jText_Form_Sub3_TelNum_Alternate.setEnabled(true);
					jText_Form_Sub3_Email_Alternate.setEnabled(true);
					jText_Form_Sub3_earlierReceiptNum.setEnabled(false);
					jText_Form_Sub3_MobileNumber.setEnabled(true);
					// ***********
					enableDisableTypeOfDD();

					enableDisableOnFinYear();
				} else if ("--Select--"
						.equals(JComboBox_Form_Sub1_Update_deductor
								.getSelectedItem())
								&& "Correction".equals(valueOfTypeOfStmt)) {
					// First panel
					jText_Form_Sub1_Tan.setEnabled(false);
					jText_Form_Sub1_LastTan.setEnabled(false);
					JComboBox_Form_Sub1_finYear.setEnabled(false);
					jText_Form_Sub1_Pan.setEnabled(false);
					JComboBox_Form_Sub1_finYear.setEnabled(false);
					JComboBox_Form_Sub1_Type_of_Deductor
					.setEnabled(false);
					// JComboBox_Form_Sub1_Update_deductor
					// .setEnabled(false);
					jText_Form_Sub1_LastTan.setEnabled(false);
					jText_Form_Sub1_isRevised.setText("Yes");
					jText_Form_Sub1_isRevised.setEnabled(false);
					jText_Form_Sub1_AssessmentYear.setEnabled(false);
					jText_Form_Sub1_Last_Deductor_Type
					.setEnabled(false);
					jText_Form_Sub1_Org_Receipt_Num.setEnabled(false);
					jText_Form_Sub1_Previous_Receipt_num
					.setEnabled(false);
					// *********
					// Second Panel
					jText_Form_Sub2_Name.setEnabled(false);
					jText_Form_Sub2_Branch.setEnabled(false);
					JComboBox_Form_Sub2_MinistryName.setEnabled(false);
					jText_Form_Sub2_MinistryName_Other
					.setEnabled(false);
					jComboBox_Form_Sub2_State.setEnabled(false);
					jText_Form_Sub2_DDO_Code.setEnabled(false);
					jText_Form_Sub2_PAO_Code.setEnabled(false);
					jText_Form_Sub2_DDO_RegNum.setEnabled(false);
					jText_Form_Sub2_PAO_regNum.setEnabled(false);
					jText_Form_Sub2_TAN_RegNum.setEnabled(true); // ##
					// New
					// Development
					// as
					// on
					// 04/04/2015
					// by
					// Akansha
					jText_Form_Sub2_FlatNo.setEnabled(false);
					jText_Form_Sub2_Area.setEnabled(false);
					jText_Form_Sub2_BuildingName.setEnabled(false);
					jText_Form_Sub2_Town.setEnabled(false);
					jText_Form_Sub2_Road.setEnabled(false);
					jText_Form_Sub2_PinCode.setEnabled(false);
					jComboBox_AOState.setEnabled(false);
					jText_Form_Sub2_PinCode.setEnabled(false);
					jText_Form_Sub2_TelNum.setEnabled(false);
					jText_Form_Sub2_TelNum_Std_Code.setEnabled(false);
					jText_Form_Sub2_Email.setEnabled(false);
					jText_Form_Sub2_Email_Alternate.setEnabled(false);
					jText_Form_Sub2_AlternateTelNum_Std_Code
					.setEnabled(false);
					jText_Form_Sub2_AlternateTelNum.setEnabled(false);
					jText_Form_Sub2_AIN.setEnabled(false);
					jComboBox_Form_Sub2_isAddressChanged
					.setEnabled(false);
					//jText_Form_Sub2_GSTN.setEnabled(false);
					// *********

					// Third Panel
					jText_Form_Sub3_Name.setEnabled(false);
					jText_Form_Sub3_Designation.setEnabled(false);
					jText_Form_Sub3_FlatNum.setEnabled(false);
					jText_Form_Sub3_Road.setEnabled(false);
					jText_Form_Sub3_BuildingName.setEnabled(false);
					jComboBox_Form_Sub3_isAddressChanged
					.setEnabled(false);
					jComboBox_Form_Sub3_isRegularStatement
					.setEnabled(false);
					jText_Form_Sub3_Area.setEnabled(false);
					jText_Form_Sub3_Town.setEnabled(false);
					jComboBox_State_Name.setEnabled(false);
					jText_Form_Sub3_PinCode.setEnabled(false);
					jText_Form_Sub3_Email.setEnabled(false);
					jText_Form_Sub3_TelNum.setEnabled(false);
					jText_Form_Sub3_TelNum_Std_Code.setEnabled(false);
					jText_Form_Sub3_TelNum_Alternate_Std_Code
					.setEnabled(false);
					jText_Form_Sub3_TelNum_Alternate.setEnabled(false);
					jText_Form_Sub3_Email_Alternate.setEnabled(false);
					jText_Form_Sub3_earlierReceiptNum.setEnabled(false);
					jText_Form_Sub3_MobileNumber.setEnabled(false);
					// ***********
				}

			}
		});
		// *********************************

		// Added by Akansha
		// For auto load of the quarter fields and hide and show of AnnexureII
		// tab

		// kisi bhi button k action k liye action listener
		/*
		 * jComboBox_Quarter.addActionListener(new ActionListener() {
		 * 
		 * public void actionPerformed(ActionEvent arg0) { if
		 * (jComboBox_Quarter.getSelectedItem().equals("Q4") &&
		 * formNumber.endsWith("24Q")) { TabGRPU.addTab("Annexure II",
		 * PanelAnnexure2Det); initializeAnne2Tab(); //Added By for the enabling
		 * of Annexure II tab
		 * 
		 * } else { if (TabGRPU.getComponentCount() > 3) if
		 * (TabGRPU.getComponentAt(ANNE2_TAB_INDEX) != null) {
		 * TabGRPU.remove(ANNE2_TAB_INDEX); System.out.println("No of tabs: " +
		 * TabGRPU.getComponentCount()); } } } });
		 */
		// ******************************************************************

		jComboBox_MinistryName.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {

				if (((String) jComboBox_MinistryName.getSelectedItem())
						.equals("--Select--")
						|| jComboBox_MinistryName.getSelectedIndex() != 1) {
					jComboBox_SubMinistryName.setSelectedItem("--Select--");
					jComboBox_SubMinistryName.setEnabled(false);
					jText_OtherMinistryName.setText("");
					jText_OtherMinistryName.setEnabled(false);

				} else if (jComboBox_MinistryName.getSelectedIndex() == 1) {
					jComboBox_SubMinistryName.setEnabled(true);

				}
			}
		});

		jComboBox_SubMinistryName.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {

				if (((String) jComboBox_SubMinistryName.getSelectedItem())
						.equals("Others")) {
					jComboBox_SubMinistryName
					.setNextFocusableComponent(jText_OtherMinistryName);
					jText_OtherMinistryName.setEnabled(true);
				} else {
					jComboBox_SubMinistryName
					.setNextFocusableComponent(jText_ResponsiblePersonName);
					jText_OtherMinistryName.setText("");
					jText_OtherMinistryName.setEnabled(false);
				}

			}
		});


		// added by Akansha
		// Function to disable and enable the quarter drop down
		JComboBox_Form_Sub1_finYear.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				int i = 0;
				int year = 0;
				int index = 0;
				String yearselected = "";
				if ("Regular".equals(valueOfTypeOfStmt)) {
					System.out.println("changes to be added.......");
					if (JComboBox_Form_Sub1_finYear.getSelectedItem().equals(
							"--Select--")) {
						jComboBox_Quarter.setEnabled(false);
						jComboBox_Quarter.setSelectedIndex(0);
						jText_Form_Sub1_AssessmentYear.setText("");
						jText_Form_Sub2_AIN.setEnabled(false);
						jText_Form_Sub2_AIN.setText("");
					} else {
						if(!(("Open").equals(method))){
							String req_quarter = new Validations().isValidQuarter(
									jText_disabledFromNum.getText(),
									JComboBox_Form_Sub1_finYear.getSelectedItem()
									.toString(), method);
							if (checkPopup != 1) {
								// Code for adding the valid quarters
								// if ("24Q".equals(formNumber))
								// JOptionPane.showMessageDialog(contentGRPU,
								// "Please select quarter");
							}
							String req[] = req_quarter.split(",");
							jComboBox_Quarter.removeAllItems();
							for (; i < req.length; i++)
								jComboBox_Quarter.addItem(req[i]);
							jComboBox_Quarter.setEnabled(true);

							// *******************************************************

							enableDisableOnFinYear();

							// Code for Adding assessment year
							assessmentyear = new Validations()
							.AssessmentYearCombo(2);
							index = JComboBox_Form_Sub1_finYear.getSelectedIndex();
							jText_Form_Sub1_AssessmentYear.setText(assessmentyear
									.get(index - 1).toString());
							// *********************************************************

						}else{

							//temp code
							String req_quarter = new Validations().isValidQuarter(
									jText_disabledFromNum.getText(),
									JComboBox_Form_Sub1_finYear.getSelectedItem()
									.toString(), method);
							if (checkPopup != 1) {
								// Code for adding the valid quarters
								// if ("24Q".equals(formNumber))
								// JOptionPane.showMessageDialog(contentGRPU,
								// "Please select quarter");
							}
							String req[] = req_quarter.split(",");
							jComboBox_Quarter.removeAllItems();
							for (; i < req.length; i++)
								jComboBox_Quarter.addItem(req[i]);
							//end of temp code
							jComboBox_Quarter.setEnabled(true);
							// *******************************************************

							enableDisableOnFinYear();

							// Code for Adding assessment year
							assessmentyear = new Validations()
							.AssessmentYearCombo(2);

							index = JComboBox_Form_Sub1_finYear.getSelectedIndex();
							jText_Form_Sub1_AssessmentYear.setText(assessmentyear
									.get(index - 1).toString());
							// *********************************************************
						}// new development for FRD1.3 by Akansha
					}

					/***************************************************************************/
					//added by sadhana, FRD 2.2
					if (JComboBox_Form_Sub1_finYear.getSelectedItem().equals(
							"--Select--")) {
						if("27EQ".equals(formNumber)){
							int ddRowCount = model1.getRowCount();
							if(ddRowCount > 2){
								for (int j = 2; j < ddRowCount; j++) {
									model1.setValueAt("--Select--", j, 32);
									model1.setValueAt("--Select--", j, 33);
								}
							}
						}

					}

					if (JComboBox_Form_Sub1_finYear.getSelectedIndex() != 0) {
						int selYear_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4));
						int next_year_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(5, 9));

						if(selYear_anne2 < 2017 && next_year_anne2 < 2018){
							int ddRowCount = model1.getRowCount();
							if(ddRowCount > 2){
								for (int j = 2; j < ddRowCount; j++) {
									model1.setValueAt("--Select--", j, 32);
									model1.setValueAt("--Select--", j, 33);
								}
							}
						}											
					}
					/***************************************************************************/
				}
			}
		});

		// *********************************************************

		// Added by Akansha

		jComboBox_Form_Sub3_isRegularStatement
		.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if ("Yes".equals(jComboBox_Form_Sub3_isRegularStatement
						.getSelectedItem().toString())) {
					jText_Form_Sub3_earlierReceiptNum.setEnabled(true);
					checkPopup = 0;
				} else {
					if (checkPopup != 1)
						JOptionPane
						.showMessageDialog(
								null,
								"<html>Option you have selected is 'No'. Kindly confirm that there is no statement filed for Form "
										+ formNumber
										+ "<br> earlier, if found, the statement will be rejected at TIN central system.</html>");
					jText_Form_Sub3_earlierReceiptNum.setEnabled(false);
					jText_Form_Sub3_earlierReceiptNum.setText("");
				}

			}
		});

		// ***********************************************************

		// Added by Amit

		jComboBox_Quarter.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) { if (jText_disabledFromNum.getText().equals("24Q")&& jComboBox_Quarter.getSelectedItem() != null)
					if (jComboBox_Quarter.getSelectedItem().equals("Q4")) {
						TabGRPU.addTab("Annexure II (Salary Details)",PanelAnnexure2Det);
						TabGRPU.addTab("Other Services of TIN", PanelUtility);
						initializeAnne2Tab(); // Added By for the
						// enabling of Annexure II tab
						// in Quarter q4
						addBlankRows2(GRPUConstants.DEFAULT_ROWS_COUNT, false);
					} else {
						if (TabGRPU.getComponentCount() > 4)								//changes tab count 3 to 4
							if (TabGRPU.getComponentAt(ANNE2_TAB_INDEX) != null) {
								TabGRPU.remove(ANNE2_TAB_INDEX);
								System.out.println("No of tabs: "+ TabGRPU.getComponentCount());
							}
					}

				/*********************************************************/				
				//FRD 2.3 added 16(ia)												
				if(jText_disabledFromNum.getText().equals("24Q")&& jComboBox_Quarter.getSelectedItem() != null){
					if (jComboBox_Quarter.getSelectedItem().equals("Q4")) {
						int selYear_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(0, 4));
						int next_year_anne2 = Integer
								.parseInt(JComboBox_Form_Sub1_finYear
										.getSelectedItem().toString()
										.substring(5, 9));
						
						/****************** Added for 2.7 Start ********************/

						if(selYear_anne2 < 2018 && next_year_anne2 < 2019){
							int sdRowCount = model2.getRowCount();
							if(sdRowCount > 2){
								for (int j = 2; j < sdRowCount; j++) {
									model2.setValueAt("0.00", j, 13);
									model2.setValueAt("0.00", j, 59);
									model2.setValueAt("0.00", j, 60);
									model2.setValueAt("0.00", j, 61);
									model2.setValueAt("0.00", j, 62);
									model2.setValueAt("0.00", j, 63);
									model2.setValueAt("0.00", j, 64);
									model2.setValueAt("0.00", j, 65);
									model2.setValueAt("0.00", j, 66);
									model2.setValueAt("0.00", j, 67);
									model2.setValueAt("0.00", j, 68);
									model2.setValueAt("0.00", j, 69);
									model2.setValueAt("0.00", j, 70);
									model2.setValueAt("0.00", j, 71);
									model2.setValueAt("0.00", j, 72);
									model2.setValueAt("0.00", j, 73);
									model2.setValueAt("0.00", j, 74);
									model2.setValueAt("0.00", j, 75);
									model2.setValueAt("0.00", j, 76);
									model2.setValueAt("0.00", j, 77);
									model2.setValueAt("0.00", j, 78);
									model2.setValueAt("0.00", j, 79);
									model2.setValueAt("0.00", j, 80);
									model2.setValueAt("0.00", j, 81);
									model2.setValueAt("0.00", j, 82);
									model2.setValueAt("0.00", j, 83);
									model2.setValueAt("0.00", j, 84);
									model2.setValueAt("0.00", j, 85);
									model2.setValueAt("0.00", j, 86);
									model2.setValueAt("0.00", j, 87);
									model2.setValueAt("0.00", j, 88);
									model2.setValueAt("0.00", j, 89);
									model2.setValueAt("0.00", j, 90);
									model2.setValueAt("0.00", j, 91);
									model2.setValueAt("0.00", j, 92);
								}
							}
						}
						
						
						if(selYear_anne2 > 2017 && next_year_anne2 > 2018){
							int sdRowCount = model2.getRowCount();
							if(sdRowCount > 2){
								for (int j = 2; j < sdRowCount; j++) {
									model2.setValueAt("0.00", j, 8);
									model2.setValueAt("0.00", j, 17);
								}
							}
						}
						
						
						/****************** Added for 2.7 End ********************/
						
						
						
						
						

					}

				}
				/*********************************************************/	

			}

		});

		// *********************************************************

		// Added by Akansha
		// Code for deducter type selection
		JComboBox_Form_Sub1_Type_of_Deductor
		.addItemListener(new ItemListener() {


			public void itemStateChanged(ItemEvent e) {

				enableDisableTypeOfDD();
				//new development for FRD1.3 by Akansha
				//Prod issue fix
				if (".tds".equals(fileExtsn)) {
					if (!"--Select--"
							.equals(JComboBox_Form_Sub1_Type_of_Deductor
									.getSelectedItem().toString())
									&& "--Select--"
									.equals(jText_Form_Sub1_Last_Deductor_Type
											.getText().toString())) {
						jText_Form_Sub1_Last_Deductor_Type
						.setText(JComboBox_Form_Sub1_Type_of_Deductor
								.getSelectedItem().toString());
					}

					else if("O".equals(dedtype) ||"C".equals(dedtype) ){
						jText_Form_Sub1_Last_Deductor_Type
						.setText(JComboBox_Form_Sub1_Type_of_Deductor
								.getSelectedItem().toString());
					}
				}

				//newly developed for FRD1.5 Ver1.5 by akansha
				if (model != null) {
					int val = 0;
					for (int i = 2; i < model.getRowCount(); i++) {
						if (model.getValueAt(
								i, 0) != null) {
							if (("ADD".equals(model.getValueAt(
									i, 0)) && "Correction"
									.equals(valueOfTypeOfStmt))
									|| "Regular"
									.equals(valueOfTypeOfStmt)) {
								if(model.getValueAt(i,10)!=null && !"".equals(model.getValueAt(i,10).toString()))
								{
									val = Integer.parseInt(model
											.getValueAt(i, 10)
											.toString().substring(0,model
													.getValueAt(i, 10)
													.toString().length()-3));
								}else
									val=0;
								if (!("Central Government"
										.equals(JComboBox_Form_Sub1_Type_of_Deductor
												.getSelectedItem()
												.toString()) || "State Government"
												.equals(JComboBox_Form_Sub1_Type_of_Deductor
														.getSelectedItem()
														.toString()))) {

									//newly added for FRD1.5 by akansha
									if (val >= 1)
										model.setValueAt("No", i,
												18);

								} else{
									if(val>=1)
										model.setValueAt("Yes",
												i,
												18);
									else
										model.setValueAt("--Select--",
												i,
												18);

								}
							}
						}
					}

				}

				//********************************************
			}
		});
		// ***********************************************************

		// Redudant Code
		/*
		 * jComboBox_Month.addActionListener(new ActionListener() {
		 * 
		 * public void actionPerformed(ActionEvent e) {
		 * jComboBox_Month_actionPerformed(e); }
		 * 
		 * }); jComboBox_TypOfStmt.addActionListener(new ActionListener() {
		 * 
		 * public void actionPerformed(ActionEvent e) {
		 * jComboBox_TypOfStmt_actionPerformed(e); }
		 * 
		 * });
		 * 
		 * jComboBox_TypeOfCorrection.addActionListener(new ActionListener() {
		 * 
		 * public void actionPerformed(ActionEvent e) {
		 * jComboBox_TypeOfCorrection_actionPerformed(e); }
		 * 
		 * });
		 */
		jText_AOCity.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent focusevent1) {
			}

			public void focusLost(FocusEvent e) {
				if (GrpuUtil.isValidCityName(jText_AOCity.getText().toString()
						.trim())) {
					if (GRPU.TabGRPU.getSelectedIndex() == 1)
						GRPU.TabGRPU.setSelectedIndex(BATCH_TAB_INDEX);
					grpu.getMessage("Invalid AO City. \nSpecial characters Hyphen - ,Underscore _ , Open bracket ( ,Closed Bracket ) and . Dot are only allowed.\n Number (0-9) not allowed ");
					jText_AOCity.setText("");
				}
			}

		});

		jText_AIN.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AIN.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 0;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AIN.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 0;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_AOADD1.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AOADD1.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 2;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AOADD1.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 2;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_AOADD2.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AOADD2.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 3;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AOADD2.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 3;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_AOADD3.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AOADD3.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 4;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AOADD3.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 4;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_AOADD4.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AOADD4.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 12;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AOADD4.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 12;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_AOCity.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AOCity.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 5;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AOCity.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 5;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_AOName.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AOName.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 6;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AOName.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 6;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_AOPIN.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_AOPIN.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 7;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_AOPIN.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 7;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_EmailID.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_EmailID.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 8;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_EmailID.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 8;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_PhoneNo.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_PhoneNo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 9;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_PhoneNo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 9;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_STD.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_STD.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 13;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_STD.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 13;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_OtherMinistryName.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_OtherMinistryName.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 13;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_OtherMinistryName.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 13;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonDesgn.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonDesgn.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 10;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonDesgn.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 10;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});
		jText_ResponsiblePersonName.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonName.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 11;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonName.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 11;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonADD1.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD1.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 14;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD1.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 14;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonADD2.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD2.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 15;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD2.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 15;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonADD3.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD3.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 16;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD3.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 16;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonADD4.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD4.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 17;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonADD4.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 17;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonCity.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonCity.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 18;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonCity.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 18;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonPIN.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonPIN.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 19;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonPIN.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 19;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonSTD.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonSTD.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 20;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonSTD.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 20;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonPhoneNo.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonPhoneNo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 21;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonPhoneNo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 21;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_ResponsiblePersonMobilePhoneNo
		.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonMobilePhoneNo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(),
							evt.getY());
				else
					pasteintotextbox = 22;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonMobilePhoneNo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 22;
					textboxmenu.show(evt.getComponent(), evt.getX(),
							evt.getY());
				}
			}

		});

		jText_ResponsiblePersonEmailID.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_ResponsiblePersonEmailID.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 23;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_ResponsiblePersonEmailID.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 23;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_regNoPaoDtoCddo.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_regNoPaoDtoCddo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 24;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_regNoPaoDtoCddo.isEditable()) {
					return;
				}

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 24;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		jText_OtherMinistryName.addMouseListener(new MouseAdapter() {

			public void mousePressed(MouseEvent evt) {
				if (!jText_OtherMinistryName.isEditable())
					return;

				if (evt.isPopupTrigger())
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				else
					pasteintotextbox = 25;
			}

			public void mouseReleased(MouseEvent evt) {
				if (!jText_OtherMinistryName.isEditable())
					return;

				if (evt.isPopupTrigger()) {
					pasteintotextbox = 25;
					textboxmenu.show(evt.getComponent(), evt.getX(), evt.getY());
				}
			}

		});

		// BatchPane_ChkLenTxtBox(); --- Redundant Code

	}

	// Bottom buttom button
	private void initializeBottomMenu() {

		jButton_save = new JButton("    Save    ");
		jButton_save.setMnemonic('S');
		jButton_crtFile = new JButton("   Create File    ");

		//newly developed for FRD1.5 by akansha
		jButton_gotofileupd = new JButton("Go to excel file");
		jButton_imptoexcel = new JButton("Import excel file");
		//************************************
		// Added by Akansha
		jButton_sveFile = new JButton("   Save   ");
		jButton_opnFile = new JButton("   Open   ");

		jButton_feedback = new JButton("   Feedback   "); //Newly added for Feedback button on 12/01/17 for FRD1.9
		//jButton_checkTDS_TCS_rate = new JButton("   Check TDS/TCS rates   ");      //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9
		//jButton_checkTDS_TCS_rate.setVisible(false);                       //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9
		// ****************************************
		jButton_back = new JButton("   Back    ");
		// jButton_import = new JButton("   Import    ");
		jButton_addRow = new JButton("  Add Rows  ");
		jButton_delRow = new JButton("Delete a Row");
		jButton_insertRow = new JButton("Insert a Row"); // added by

		// Modified by Akansha
		jButton_addRow.setVisible(false);
		jButton_delRow.setVisible(false);
		jButton_insertRow.setVisible(false); // added
		//jLabel_Mandatory.setVisible(true);
		// ***********************************
		// ############
		// jButton_import.setEnabled(false);

		//newly developed for FRD1.5 by akansha
		if("Regular".equals(valueOfTypeOfStmt)){
			//addComponent(jPanelButton, jButton_gotofileupd, 0, 1, 150, 45);
			//addComponent(jPanelButton, jButton_imptoexcel, 0, 1, 150, 45);
		}
		//**********************************************************

		// Added by Akansha
		addComponent(jPanelButton, jLabel_Mandatory, 0, 1, 150, 45);
		addComponent(jPanelButton, jButton_crtFile, 90, 500, 150, 45);
		addComponent(jPanelButton, jButton_sveFile, 120, 500, 150, 45);
		addComponent(jPanelButton, jButton_opnFile, 150, 500, 150, 45);
		addComponent(jPanelButton, jButton_addRow, 120, 500, 150, 45);
		addComponent(jPanelButton, jButton_delRow, 150, 500, 150, 45);
		addComponent(jPanelButton, jButton_insertRow, 150, 500, 150, 45);
		addComponent(jPanelButton, jButton_back, 180, 500, 150, 45);

		// Added by Sadhana
		/*jPanelAdv.setLayout(null);
		jPanelAdv.setPreferredSize(new Dimension(700,100));
		addComponent(jPanelAdv, jLabel_Mandatory, 0, 50, 250, 45);
		addComponent(jPanelAdv, jButton_crtFile, 239, 60, 115, 28);
		addComponent(jPanelAdv, jButton_sveFile, 360, 60, 90, 28);
		addComponent(jPanelAdv, jButton_opnFile, 457, 60, 90, 28);
		addComponent(jPanelAdv, jButton_addRow, 456, 60, 105, 28);
		addComponent(jPanelAdv, jButton_insertRow, 456, 60, 110, 28);
		addComponent(jPanelAdv, jButton_delRow, 570, 60, 110, 28);
		addComponent(jPanelAdv, jButton_back, 554, 60, 90, 28);
		jPanelButton.add(jPanelAdv);*/

		//addComponent(jPanelButton, jButton_feedback, 210, 500, 150, 45);//newly added on 12/01/17
		//addComponent(jPanelButton, jButton_checkTDS_TCS_rate, 240, 500, 150, 45);     //newly added button to check TDS/TCS rates on 13/01/17 FRD1.9

		// Redudant Code
		/*
		 * jButton_save.addActionListener(new ActionListener() {
		 * 
		 * public void actionPerformed(ActionEvent e) {
		 * jButton_save_actionPerformed(e); }
		 * 
		 * });
		 */

		jButton_addRow.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				jButton_addRow_actionPerformed(e); // method called here
			}

		});
		// Addeed by for insert row
		jButton_insertRow.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				jButton_insertRow_actionPerformed(e); // method called here
			}

		});

		// To dar close the window foe the insert row functionality
		button_cancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				frame_insert.dispose();
				panel_insert.removeAll();
			}
		});

		button_ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//New dev for ver1.3 added by Akansha wherein the model_insert.getValueAt(i,2) changed to (i,1)
				// off focus

				//new development for FRd1.3 by Akansha
				frame_insert.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
				contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
				//**************************************
				int count = 0;
				int ia = model1.getRowCount() - 2;
				
				for (int i = 0; i < model_insert.getRowCount(); i++) {


					if (model_insert.getValueAt(i, 1) != null) {
						if (!(model_insert.getValueAt(i, 1)).equals("")) {
							count++;

							addBlankRows1(
									Integer.parseInt(model_insert.getValueAt(i,
											1).toString()), i + 1, true, false);

						}

					}

					if (model_insert.getValueAt(i, 1) != null
							&& !model_insert.getValueAt(i, 1).equals("")) {
						for (int j = 0; j < Integer.parseInt(model_insert
								.getValueAt(i, 1).toString()); j++) {
							model1.setValueAt(ia + 1, ia + 2, 0);
							ia++;
						}
					}

				}

				// added by cholia
				if (count == 0){
					//new development for FRd1.3 by Akansha
					frame_insert.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
					contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
					//************************************
					GRPU.grpu
					.getMessage("Please enter valid number of rows to be added");

				}else {
					//System.out.println("calling null yahan pe");
					sortMethod(null, true);
					//new development for FRd1.3 by Akansha
					frame_insert.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
					contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
					//*************************************
					frame_insert.dispose();
					panel_insert.removeAll();
				}
				frame_insert.dispose();
				panel_insert.removeAll();
			}

		});

		// End here
		jButton_delRow.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				jButton_delRow_actionPerformed(e);
			}

		});
		jButton_crtFile.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {

				//				System.out.println("In time: "+System.currentTimeMillis());
				jButton_crtFile_actionPerformed(e);
				//				System.out.println("Out time: "+System.currentTimeMillis());
			}

		});

		//newly added for FRD1.5 by akansha

		jButton_imptoexcel.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {

				//				System.out.println("In time: "+System.currentTimeMillis());
				jButton_importexcel_actionPerformed(e);
				//				System.out.println("Out time: "+System.currentTimeMillis());
			}

		});

		jButton_gotofileupd.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				jButton_gotoexcel_actionPerformed(e);

			}
		});
		//*************************************

		// Added by Akansha
		jButton_sveFile.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent ae) {
				// fileitemsave_actionPerformed(ae);
				contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
				savefile();
				contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
				System.out.println("default cursor");

			}
		});

		jButton_opnFile.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent ae) {
				if(!GRPUMain.openflag){
					fileitemopen_actionPerformed(ae);

				}else{
					GRPUMain.openflag = true;

					exitMessage = "Do you want to save the changes you made?";
					int answer = JOptionPane.showConfirmDialog(
							GRPU.JdialogFrame, exitMessage);
					if(answer==0){
						savefileReg();

					}
					else if(answer==1){
						fileitemopen_actionPerformed(null);

					}

				}

			}
		});

		// *****************************************
		jButton_back.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				jButton_back_actionPerformed(e);
				mainObject.checkflag = 1;
			}

		});

		/********************************************************************/
		//Added for Feedback button on 12/01/17 for FRD1.9

		jButton_feedback.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				URI uri_btn = null;

				try {
					uri_btn = new URI("https://www.tin-nsdl.com/customerfeedback.php");
				} catch (URISyntaxException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				if (Desktop.isDesktopSupported()) {
					try {

						Desktop.getDesktop().browse(uri_btn);
					} catch (IOException e) { 
						e.printStackTrace();
					}
				} else { 

				}

			}
		});

		/********************************************************************/

	}

	// Added by Akansha
	private void initializeMenus() {

		URL url = null;
		url = getClass().getResource("/icon/open.gif");
		openicon = new ImageIcon(url);
		url = getClass().getResource("/icon/Save.gif");
		saveicon = new ImageIcon(url);
		url = getClass().getResource("/icon/Saveas.gif");
		saveasicon = new ImageIcon(url);

		// url = getClass().getResource("/icon/print.png");
		// printicon = new ImageIcon(url);

		url = getClass().getResource("/icon/exit.gif");
		exiticon = new ImageIcon(url);
		url = getClass().getResource("/icon/cut.gif");
		cuticon = new ImageIcon(url);
		url = getClass().getResource("/icon/copy.gif");
		copyicon = new ImageIcon(url);
		url = getClass().getResource("/icon/paste.gif");
		pasteicon = new ImageIcon(url);
		url = getClass().getResource("/icon/find.gif");
		findicon = new ImageIcon(url);
		url = getClass().getResource("/icon/smallNSDL.gif");
		Abouticon = new ImageIcon(url);
		// *****************
		menu = new JPopupMenu();

		menuBar = new JMenuBar();

		filemenu = new JMenu("File");
		filemenu.setMnemonic('F');
		editmenu = new JMenu("Edit");
		editmenu.setMnemonic('E');
		helpMenu = new JMenu("Help");
		helpMenu.setMnemonic('H');
		menuBar.add(filemenu);
		menuBar.add(editmenu);
		menuBar.add(helpMenu);
		JMenuItem fileitemopen = new JMenuItem("Open", openicon);
		JMenuItem fileitemsave = new JMenuItem("Save", saveicon);
		JMenuItem fileitemsaveas = new JMenuItem("Save As", saveasicon);
		// Added by Akansha
		JMenuItem fileitemprint = new JMenuItem("Print", printicon);
		// ******************
		JMenuItem fileitemexit = new JMenuItem("Exit", exiticon);
		JMenuItem cutmenu = new JMenuItem("Cut", cuticon);
		JMenuItem copymenu = new JMenuItem("Copy", copyicon);
		JMenuItem pastemenu = new JMenuItem("Paste", pasteicon);
		JMenuItem deletemenu = new JMenuItem("Delete", null);
		JMenuItem findmenu = new JMenuItem("Find", findicon);
		JMenuItem replacemenu = new JMenuItem("Replace", null);
		JMenuItem pastefromexcel = new JMenuItem("Paste from Excel", pasteicon);
		JMenuItem pastecolfromexcel = new JMenuItem("Paste Column from Excel",
				pasteicon);
		JMenuItem helpItem = new JMenuItem("Help", Abouticon);

		//	JMenuItem feedbackItem = new JMenuItem("Feedback", Abouticon);//Added for Feedback button on 12/01/17 for FRD1.9

		filemenu.add(fileitemopen);
		filemenu.add(new JSeparator());
		filemenu.add(fileitemsave);
		//***************************************
		filemenu.add(new JSeparator());
		filemenu.add(fileitemexit);
		editmenu.add(cutmenu);
		editmenu.add(new JSeparator());
		editmenu.add(copymenu);
		editmenu.add(new JSeparator());
		editmenu.add(pastemenu);
		editmenu.add(new JSeparator());
		editmenu.add(deletemenu);
		editmenu.add(new JSeparator());
		editmenu.add(findmenu);
		editmenu.add(new JSeparator());
		editmenu.add(replacemenu);
		editmenu.add(new JSeparator());
		editmenu.add(pastefromexcel);
		helpMenu.add(helpItem);

		//	helpMenu.add(feedbackItem); //Added for Feedback button on 12/01/17 for FRD1.9

		editmenu.getMenuComponent(6).setEnabled(false);
		//editmenu.getMenuComponent(8).setEnabled(false);
		editmenu.getMenuComponent(10).setEnabled(false);
		editmenu.getMenuComponent(12).setEnabled(false);
		fileitemopen.setAccelerator(KeyStroke.getKeyStroke(79, 2));
		fileitemsave.setAccelerator(KeyStroke.getKeyStroke(83, 2));
		fileitemprint.setAccelerator(KeyStroke.getKeyStroke(80, 2));
		fileitemexit.setAccelerator(KeyStroke.getKeyStroke(115, 8));
		cutmenu.setAccelerator(KeyStroke.getKeyStroke(88, 2));
		copymenu.setAccelerator(KeyStroke.getKeyStroke(67, 2));
		pastemenu.setAccelerator(KeyStroke.getKeyStroke(86, 2));
		findmenu.setAccelerator(KeyStroke.getKeyStroke(70, 2));
		replacemenu.setAccelerator(KeyStroke.getKeyStroke(82, 2));

		//New dev for ver1.3 added by Akansha
		helpItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1,0));
		//feedbackItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2,0));		//added short key for feedback, FRD1.9

		item1 = new JMenuItem("Cut");
		item2 = new JMenuItem("Copy");
		item3 = new JMenuItem("Paste");
		item4 = new JMenuItem("Paste from Excel");
		item6 = new JMenuItem("Delete");
		menu.add(item1);
		menu.add(item2);
		menu.add(item3);
		menu.add(item6);
		menu.add(item4);

		// To disable open menu in case of correction
		if (valueOfTypeOfStmt.equalsIgnoreCase("Correction")) {
			fileitemopen.setEnabled(false);
		}

		JMenuItem textitem1 = new JMenuItem("Cut"); 
		JMenuItem textitem2 = new JMenuItem("Copy");
		JMenuItem textitem3 = new JMenuItem("Paste");
		textboxmenu.add(textitem1);
		textboxmenu.add(textitem2);
		textboxmenu.add(textitem3);
		selTAB = TabGRPU.getSelectedIndex();

		// addComponent(jPanelMenu, menuBar, 0, 0,0,0);

		shalinpanel.setBounds(0, 0, 700, 200);

		jLabel_FormNumber = new JLabel("Form Number : " + formNumber);
		if (formNumber.equalsIgnoreCase("24Q"))
			jLabel_FormSectionRules = new JLabel(form24QSection);
		else if (formNumber.equalsIgnoreCase("26Q"))
			jLabel_FormSectionRules = new JLabel(form26QSection);
		else if (formNumber.equalsIgnoreCase("27Q"))
			jLabel_FormSectionRules = new JLabel(form27QSection);
		else if (formNumber.equalsIgnoreCase("27EQ"))
			jLabel_FormSectionRules = new JLabel(form27EQSection);
		else
			jLabel_FormSectionRules = new JLabel(
					"Invalid Form Number. Try again... ");

		jLabel_FormNumber.setFont(new Font(fontName, Font.BOLD, 14)); // modified
		// by
		// Akansha
		jLabel_FormSectionRules.setFont(new Font(fontName, Font.BOLD, 14)); // modified
		// by
		// Akansha
		jLabel_FormNumber.setHorizontalAlignment(SwingConstants.CENTER);
		jLabel_FormSectionRules.setHorizontalAlignment(SwingConstants.CENTER);

		addComponent(shalinpanel, jLabel_FormNumber, 200, 0, 200, 20);
		// addComponent(shalinpanel,jLabel_FormSectionRules , 200, 100, 800,
		// 20);
		jLabel_FormNumber.setBounds(200, 0, 400, 50);

		jPanelMenu.add(menuBar, 0);
		jPanelMenu.add(shalinpanel, 1);
		jPanelMenu.add(jLabel_FormSectionRules, 2);

		// jPanelMenu.add(menuBar, "North");
		// jPanelMenu.add(shalinpanel,"Center");

		cutmenu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				if (selTAB == 1)
					cut();
				if (selTAB == 0)
					textitem1_actionPerformed(e);
			}

		});
		copymenu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				if (selTAB == 1)
					copy();
				if (selTAB == 0)
					textitem2_actionPerformed(e);
			}

		});
		pastemenu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				if (selTAB == 1)
					paste();
				if (selTAB == 0)
					textitem3_actionPerformed(e);
			}

		});
		pastefromexcel.addActionListener(new ActionListener() {
			// changed by cholia
			public void actionPerformed(ActionEvent e) {
				if (selTAB == DDO_TAB_INDEX)
					pasteXL("Challan");

				else if (selTAB == ANNE_TAB_INDEX)
					pasteXL("Anne1");

				else if (selTAB == ANNE2_TAB_INDEX)
					pasteXL("Anne2");

				// end by cholia
			}

		});
		deletemenu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				deleteCell();
			}

		});
		findmenu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				if (GRPU.grpuFindReplace == null) {
					FindReplace.mouse_whichTab = "F";
					System.out.println("Inside Find");
					JTable jtable = null;
					String tabname= "";
					if(TabGRPU.getSelectedIndex()==1){
						jtable = jTableTransacDetails;
						tabname = "Challan";
					}else if(TabGRPU.getSelectedIndex()==2){
						jtable = jTableTransacDetails1;
						tabname = "Anne1";
					}else if(TabGRPU.getSelectedIndex()==3){
						jtable = jTableTransacDetails2;
						tabname = "Anne2";
					}
					GRPU.grpuFindReplace = new FindReplace(model,
							jtable, numDdoRowsCorr,grpu,tabname);
				} else {
					JTable jtable = null;
					String tabname= "";
					if(TabGRPU.getSelectedIndex()==1){
						jtable = jTableTransacDetails;
						tabname = "Challan";
					}else if(TabGRPU.getSelectedIndex()==2){
						jtable = jTableTransacDetails1;
						tabname = "Anne1";
					}else if(TabGRPU.getSelectedIndex()==3){
						jtable = jTableTransacDetails2;
						tabname = "Anne2";
					}
					//					GRPU.grpuFindReplace.showFindTAB();
					//					GRPU.grpuFindReplace.show();
					GRPU.grpuFindReplace = new FindReplace(model,
							jtable, numDdoRowsCorr,grpu,tabname);
				}
			}

		});
		replacemenu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				if (GRPU.grpuFindReplace == null) {
					FindReplace.mouse_whichTab = "R";
					//					GRPU.grpuFindReplace = new FindReplace(model,
					//							jTableTransacDetails, numDdoRowsCorr);
					JTable jtable = null;
					String tabname= "";
					if(TabGRPU.getSelectedIndex()==1){
						jtable = jTableTransacDetails;
						tabname = "Challan";
					}else if(TabGRPU.getSelectedIndex()==2){
						jtable = jTableTransacDetails1;
						tabname = "Anne1";
					}else if(TabGRPU.getSelectedIndex()==3){
						jtable = jTableTransacDetails2;
						tabname = "Anne2";
					}
					GRPU.grpuFindReplace = new FindReplace(model,
							jtable, numDdoRowsCorr,grpu,tabname);
				} else {
					//					GRPU.grpuFindReplace.showReplaceTAB();
					//					GRPU.grpuFindReplace.show();
					JTable jtable = null;
					String tabname= "";
					if(TabGRPU.getSelectedIndex()==1){
						jtable = jTableTransacDetails;
						tabname = "Challan";
					}else if(TabGRPU.getSelectedIndex()==2){
						jtable = jTableTransacDetails1;
						tabname = "Anne1";
					}else if(TabGRPU.getSelectedIndex()==3){
						jtable = jTableTransacDetails2;
						tabname = "Anne2";
					}
					GRPU.grpuFindReplace = new FindReplace(model,
							jtable, numDdoRowsCorr,grpu,tabname);
				}
			}

		});
		pastecolfromexcel.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				item5_actionPerformed(e);
			}

		});

		fileitemexit.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				int rowFocused = jTableTransacDetails.getSelectedRow();
				int colFocused = jTableTransacDetails.getSelectedColumn();
				if (rowFocused != -1
						&& colFocused != -1
						&& (jTableTransacDetails.isEditing() || jTableTransacDetails
								.isCellSelected(rowFocused, colFocused)))
					ddoValuesChanged = true;
				if (checkAODetails()
						&& actualRowsFilled(GrpuUtil.getFilledRows(model)) == 0
						&& !ddoValuesChanged) {
					//System.out.println("---FOOF---1");
					System.exit(0);
				}

				else if (!isOpened && !fileCreated) {
					if (checkAODetails()
							&& actualRowsFilled(GrpuUtil.getFilledRows(model)) == 0
							&& !ddoValuesChanged) {
						//System.out.println("---FOOF---2");
						System.exit(0);
					} else if (fileSaveAs || fileSaved) {
						if (checkAODetails() && !ddoValuesChanged) {
							{
								//System.out.println("---FOOF---3");
								System.exit(0);
							}
						} else {
							if (getFileName(GRPU.selectedFile.getName(),
									GRPU.selectedFile) == GRPU.fileName)
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.fileName + " ?";
							else
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.selectedFile.getName() + " ?";
							int answer = JOptionPane.showConfirmDialog(
									GRPU.JdialogFrame, exitMessage);
							if (answer == 0) {
								int dataAdd[] = GrpuUtil.getFilledRows(model);
								if (getFileName(GRPU.selectedFile.getName(),
										GRPU.selectedFile) == GRPU.fileName) {
									// writeFile(GRPU.path + "\\" +
									// GRPU.fileName
									// + ".grpu", "S", dataAdd);
									savefile();
									{
										//	System.out.println("---FOOF---4");
										System.exit(0);
									}
								} else {
									// writeFile(GRPU.selectedFile
									// .getAbsolutePath(), "S", dataAdd);
									savefile();
									{
										//System.out.println("---FOOF---5");
										System.exit(0);
									}
								}
							} else if (answer == 1) {
								//	System.out.println("---FOOF---6");
								System.exit(0);
							}
						}
					} else if (!fileSaveAs || !fileSaved) {
						exitMessage = "Do you want to save the changes you made?";
						int userOption = JOptionPane.showConfirmDialog(
								GRPU.JdialogFrame, exitMessage);
						if (userOption == 0) {
							// if (fileitemsaveas_actionPerformed(e)) { --- by
							// Akansha
							//							System.out
							//									.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
							{
								//System.out.println("---FOOF---7");
								System.exit(0);
							}
							// }
						} else if (userOption == 1) {
							//							System.out
							//									.println("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@123");
							{
								//System.out.println("---FOOF---8");
								System.exit(0);
							}
						}
					}
				} else if (fileCreated && !isOpened) {
					if (checkAODetails() && !jTableTransacDetails.isEditing()
							&& !ddoValuesChanged) {
						//System.out.println("---FOOF---9");
						System.exit(0);
					} else if (!fileSaveAs && !fileSaved) {
						if (getFileName(GRPU.createdFile.getName(),
								GRPU.createdFile) == GRPU.fileName)
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.fileName + " ?";
						else
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.createdFile.getName() + " ?";
						int answer = JOptionPane.showConfirmDialog(
								GRPU.JdialogFrame, exitMessage);
						if (answer == 0) {
							int newdataAdded[] = GrpuUtil.getFilledRows(model);
							if (getFileName(GRPU.createdFile.getName(),
									GRPU.createdFile) == GRPU.fileName) {
								// writeFile(GRPU.path + "\\" + GRPU.fileName
								// + ".grpu", "S", newdataAdded);
								savefile();
							} else {
								// writeFile(GRPU.createdFile.getAbsolutePath()
								// + ".grpu", "S", newdataAdded);
								savefile();
							}
							{
								//System.out.println("---FOOF---10");
								System.exit(0);
							}
						} else if (answer == 1) {
							//System.out.println("---FOOF---11");
							System.exit(0);
						}
					} else if (fileSaveAs || fileSaved) {
						if (checkAODetails() && !ddoValuesChanged) {
							//	System.out.println("---FOOF---12");
							System.exit(0);
						} else if (getFileName(GRPU.selectedFile.getName(),
								GRPU.selectedFile) == GRPU.fileName)
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.fileName + " ?";
						else
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.selectedFile.getName() + " ?";
						int answer = JOptionPane.showConfirmDialog(
								GRPU.JdialogFrame, exitMessage);
						if (answer == 0) {
							int newdataAdded[] = GrpuUtil.getFilledRows(model);
							if (getFileName(GRPU.selectedFile.getName(),
									GRPU.selectedFile) == GRPU.fileName) {
								// writeFile(GRPU.path + "\\" + GRPU.fileName
								// + ".grpu", "S", newdataAdded);
								savefile();
							} else {
								// writeFile(GRPU.selectedFile.getAbsolutePath()
								// + ".grpu", "S", newdataAdded);
								savefile();
							}
							{
								//System.out.println("---FOOF---13");
								System.exit(0);
							}
						} else if (answer == 1) {
							//System.out.println("---FOOF---14");
							System.exit(0);
						}
					}
				} else if (isOpened && fileCreated) {
					if (getFileName(GRPU.selectedFile.getName(),
							GRPU.selectedFile) == GRPU.fileName)
						exitMessage = "Do you want to save the changes you made to "
								+ GRPU.fileName + " ?";
					else
						exitMessage = "Do you want to save the changes you made to "
								+ GRPU.selectedFile.getName() + " ?";
					int answer = JOptionPane.showConfirmDialog(
							GRPU.JdialogFrame, exitMessage);
					if (answer == 0) {
						int newdataAdded[] = GrpuUtil.getFilledRows(model);
						if (getFileName(GRPU.selectedFile.getName(),
								GRPU.selectedFile) == GRPU.fileName) {
							// writeFile(GRPU.path + "\\" + GRPU.fileName
							// + ".grpu", "S", newdataAdded);
							savefile();
						} else {
							// writeFile(GRPU.selectedFile.getAbsolutePath()
							// + ".grpu", "S", newdataAdded);
							savefile();
						}
						{
							//System.out.println("---FOOF---15");
							System.exit(0);
						}
					} else if (answer == 1) {
						//System.out.println("---FOOF---16");
						System.exit(0);
					}
				} else if (isOpened)
					try {
						if (checkAODetails() && !ddoValuesChanged) {
							//	System.out.println("---FOOF---17");
							System.exit(0);
						}
						if (fileSaveAs || fileSaved) {
							if (checkAODetails() && !ddoValuesChanged) {
								//	System.out.println("---FOOF---18");
								System.exit(0);
							} else if (!checkAODetails() || ddoValuesChanged) {
								if (getFileName(GRPU.selectedFile.getName(),
										GRPU.selectedFile) == GRPU.fileName)
									exitMessage = "Do you want to save the changes you made to "
											+ GRPU.fileName + " ?";
								else
									exitMessage = "Do you want to save the changes you made to "
											+ GRPU.selectedFile.getName()
											+ " ?";
								int answer = JOptionPane.showConfirmDialog(
										GRPU.JdialogFrame, exitMessage);
								if (answer == 0) {
									int newdataAdded[] = GrpuUtil
											.getFilledRows(model);
									if (getFileName(
											GRPU.selectedFile.getName(),
											GRPU.selectedFile) == GRPU.fileName) {
										// writeFile(GRPU.path + "\\"
										// + GRPU.fileName + ".grpu", "S",
										// newdataAdded);
										savefile();
										{
											//System.out.println("---FOOF---19");
											System.exit(0);
										}
									} else {
										// writeFile(GRPU.selectedFile
										// .getAbsolutePath()
										// + ".grpu", "S", newdataAdded);
										savefile();
										{
											//System.out.println("---FOOF---20");
											System.exit(0);
										}
									}
								} else if (answer == 1) {
									//System.out.println("---FOOF---21");
									System.exit(0);
								}
							}
						} else if (!fileSaveAs || !fileSaved)
							if (checkAODetails() && !ddoValuesChanged) {
								{
									//	System.out.println("---FOOF---22");
									System.exit(0);
								}
							} else {
								if (getFileName(GRPU.selectedFile.getName(),
										GRPU.selectedFile) == GRPU.fileName)
									exitMessage = "Do you want to save the changes you made to "
											+ GRPU.fileName + " ?";
								else
									exitMessage = "Do you want to save the changes you made to "
											+ GRPU.selectedFile.getName()
											+ " ?";
								int answer = JOptionPane.showConfirmDialog(
										GRPU.JdialogFrame, exitMessage);
								if (answer == 0) {
									int newdataAdded[] = GrpuUtil
											.getFilledRows(model);
									if (getFileName(
											GRPU.selectedFile.getName(),
											GRPU.selectedFile) == GRPU.fileName) {
										// writeFile(GRPU.path + "\\"
										// + GRPU.fileName + ".grpu", "S",
										// newdataAdded);
										savefile();
										{
											//	System.out.println("---FOOF---23");
											System.exit(0);
										}
									} else {
										// writeFile(GRPU.selectedFile
										// .getAbsolutePath()
										// + ".grpu", "S", newdataAdded);
										savefile();
										{
											//System.out.println("---FOOF---24");
											System.exit(0);
										}
									}
								} else if (answer == 1) {
									//System.out.println("---FOOF---25");
									System.exit(0);
								}
							}
					} catch (Exception exc) {
						exc.printStackTrace();
					}
			}

		});
		addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent w) {

				/*****************************/
				//new method called for Emergency Back up on 11/01/17

				//backupFile();

				/*****************************/

				try {
					int rowFocused = jTableTransacDetails.getSelectedRow();
					int colFocused = jTableTransacDetails.getSelectedColumn();
					if (rowFocused != -1
							&& colFocused != -1
							&& (jTableTransacDetails.isEditing() || jTableTransacDetails
									.isCellSelected(rowFocused, colFocused)))
						ddoValuesChanged = true;
					if (checkAODetails()
							&& actualRowsFilled(GrpuUtil.getFilledRows(model)) == 0
							&& !ddoValuesChanged) {
						//System.out.println("---FOOF---26");
						System.exit(0);
					} else if (!isOpened && !fileCreated) {
						if (checkAODetails()
								&& actualRowsFilled(GrpuUtil
										.getFilledRows(model)) == 0
										&& !ddoValuesChanged) {
							//	System.out.println("---FOOF---27");
							System.exit(0);
						} else if (fileSaveAs || fileSaved) {
							if (checkAODetails() && !ddoValuesChanged) {
								{
									//System.out.println("---FOOF---28");
									System.exit(0);
								}
							} else {

								if (getFileName(GRPU.selectedFile.getName(),
										GRPU.selectedFile) == GRPU.fileName)
									exitMessage = "Do you want to save the changes you made to "
											+ GRPU.fileName + " ?";
								else
									exitMessage = "Do you want to save the changes you made to "
											+ GRPU.selectedFile.getName()
											+ " ?";
								int answer = JOptionPane.showConfirmDialog(
										GRPU.JdialogFrame, exitMessage);
								if (answer == 0) {
									int dataAdd[] = GrpuUtil
											.getFilledRows(model);
									if (getFileName(
											GRPU.selectedFile.getName(),
											GRPU.selectedFile) == GRPU.fileName) {
										// writeFile(GRPU.path + "/"
										// + GRPU.fileName + ".grpu", "S",
										// dataAdd);
										savefile();
										{
											//System.out.println("---FOOF---29");
											System.exit(0);
										}
									} else {
										// writeFile(GRPU.selectedFile
										// .getAbsolutePath(), "S",
										// dataAdd);
										savefile();
										{
											//	System.out.println("---FOOF---30");
											System.exit(0);
										}
									}
								} else if (answer == 1) {
									//System.out.println("---FOOF---31");
									System.exit(0);
								}
							}
						} else if (!fileSaveAs || !fileSaved) {
							System.out.println("inside File Saved");
							exitMessage = "Do you want to save the changes you made?";
							int answer = JOptionPane.showConfirmDialog(
									GRPU.JdialogFrame, exitMessage);
							if (answer == 0) {
								File fileNameToSave = funSaveDialogBoxGRPU();
								if (fileNameToSave != null)
									if (fileNameToSave.getName().toLowerCase()
											.endsWith(".txt"))
										getMessage("Invalid File Name");
									else if (!fileNameToSave.getName()
											.toLowerCase().endsWith(".grpu")
											&& !fileNameToSave.getName()
											.toLowerCase().endsWith(""))
										getMessage("Invalid File Name");
									else if (!fileNameToSave.getName()
											.toLowerCase().endsWith(".grpu")
											&& fileNameToSave.getName()
											.toLowerCase().length() > GRPUConstants.FILE_LEN_GRPU)
										getMessage("Invalid length of filename. \nFilename cannot be more than "
												+ GRPUConstants.FILE_LEN_GRPU
												+ " characters");
									else if (fileNameToSave.getName()
											.toLowerCase().length()
											- GRPUConstants.FILE_EXTN_LEN_GRPU > GRPUConstants.FILE_LEN_GRPU)
										getMessage("Invalid length of filename. \nFilename cannot be more than "
												+ GRPUConstants.FILE_LEN_GRPU
												+ " characters");
									else if (!checkFileName(fileNameToSave
											.getName()))
										getMessage("Invalid File Name.\n  :  /  ?  >  <  *  \"  |  \\  ^  _ or Space, not allowed in File Name.");
									else if (fileNameToSave.getAbsoluteFile()
											.exists()) {
										String msg = fileNameToSave.getName()
												+ " already exists. Do you want to replace the existing file?";
										int userResponse = JOptionPane
												.showConfirmDialog(
														GRPU.JdialogFrame, msg);
										if (userResponse == 0) {
											int data[] = GrpuUtil
													.getFilledRows(model);
											if (getFileName(
													fileNameToSave.getName(),
													fileNameToSave) == GRPU.fileName) {
												// writeFile(GRPU.path + "\\"
												// + GRPU.fileName
												// + ".grpu", "S", data);
												savefile();
											} else {
												// writeFile(fileNameToSave
												// .getAbsolutePath()
												// + ".grpu", "S", data);
												savefile();
											}
											{
												System.out
												.println("---FOOF---32");
												System.exit(0);
											}
										}
									} else {
										int data[] = GrpuUtil
												.getFilledRows(model);
										if (getFileName(
												fileNameToSave.getName(),
												fileNameToSave) == GRPU.fileName) {
											// writeFile(GRPU.path + "\\"
											// + GRPU.fileName + ".grpu",
											// "S", data);
											savefile();
										} else {
											// writeFile(fileNameToSave
											// .getAbsolutePath()
											// + ".grpu", "S", data);
											savefile();
										}
										{
											//System.out.println("---FOOF---33");
											System.exit(0);
										}
									}
							} else if (answer == 1) {
								//System.out.println("---FOOF---34");
								System.exit(0);
							}
						}
					} else if (fileCreated && !isOpened) {
						if (checkAODetails()
								&& !jTableTransacDetails.isEditing()
								&& !ddoValuesChanged) {
							//System.out.println("---FOOF---35");
							System.exit(0);
						} else if (!fileSaveAs && !fileSaved) {

							if (getFileName(GRPU.createdFile.getName(),
									GRPU.createdFile) == GRPU.fileName)
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.fileName + " ?";
							else
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.createdFile.getName() + " ?";
							int answer = JOptionPane.showConfirmDialog(
									GRPU.JdialogFrame, exitMessage);
							if (answer == 0) {
								int newdataAdded[] = GrpuUtil
										.getFilledRows(model);
								if (getFileName(GRPU.createdFile.getName(),
										GRPU.createdFile) == GRPU.fileName) {
									// writeFile(GRPU.path + "\\" +
									// GRPU.fileName
									// + ".grpu", "S", newdataAdded);
									savefile();
								} else {
									// writeFile(GRPU.createdFile
									// .getAbsolutePath()
									// + ".grpu", "S", newdataAdded);
									savefile();
								}
								{
									//System.out.println("---FOOF---36");
									System.exit(0);
								}
							} else if (answer == 1) {
								//System.out.println("---FOOF---37");
								System.exit(0);
							}
						} else if (fileSaveAs || fileSaved) {
							if (checkAODetails() && !ddoValuesChanged) {
								//	System.out.println("---FOOF---38");
								System.exit(0);
							} else if (getFileName(GRPU.selectedFile.getName(),
									GRPU.selectedFile) == GRPU.fileName)
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.fileName + " ?";
							else
								exitMessage = "Do you want to save the changes you made to "
										+ GRPU.selectedFile.getName() + " ?";
							int answer = JOptionPane.showConfirmDialog(
									GRPU.JdialogFrame, exitMessage);
							if (answer == 0) {
								int newdataAdded[] = GrpuUtil
										.getFilledRows(model);
								if (getFileName(GRPU.selectedFile.getName(),
										GRPU.selectedFile) == GRPU.fileName) {
									// writeFile(GRPU.path + "\\" +
									// GRPU.fileName
									// + ".grpu", "S", newdataAdded);
									savefile();
								} else {
									// writeFile(GRPU.selectedFile
									// .getAbsolutePath()
									// + ".grpu", "S", newdataAdded);
									savefile();
								}
								{
									//System.out.println("---FOOF---39");
									System.exit(0);
								}
							} else if (answer == 1) {
								//System.out.println("---FOOF---40");
								System.exit(0);
							}
						}
					} else if (isOpened && fileCreated) {
						if (getFileName(GRPU.selectedFile.getName(),
								GRPU.selectedFile) == GRPU.fileName)
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.fileName + " ?";
						else
							exitMessage = "Do you want to save the changes you made to "
									+ GRPU.selectedFile.getName() + " ?";
						int answer = JOptionPane.showConfirmDialog(
								GRPU.JdialogFrame, exitMessage);
						if (answer == 0) {
							int newdataAdded[] = GrpuUtil.getFilledRows(model);
							if (getFileName(GRPU.selectedFile.getName(),
									GRPU.selectedFile) == GRPU.fileName) {
								// writeFile(GRPU.path + "\\" + GRPU.fileName
								// + ".grpu", "S", newdataAdded);
								savefile();
							} else {
								// writeFile(GRPU.selectedFile.getAbsolutePath()
								// + ".grpu", "S", newdataAdded);
								savefile();
							}
							{
								//System.out.println("---FOOF---41");
								System.exit(0);
							}
						} else if (answer == 1) {
							//System.out.println("---FOOF---42");
							System.exit(0);
						}
					} else if (isOpened)
						try {
							if (checkAODetails()
									&& !jTableTransacDetails.isEditing()
									&& !ddoValuesChanged) {
								//System.out.println("---FOOF---43");
								System.exit(0);
							} else if (fileSaveAs || fileSaved) {
								if (checkAODetails() && !ddoValuesChanged) {
									//	System.out.println("---FOOF---44");
									System.exit(0);
								} else if (!checkAODetails()
										|| ddoValuesChanged) {
									if (getFileName(
											GRPU.selectedFile.getName(),
											GRPU.selectedFile) == GRPU.fileName)
										exitMessage = "Do you want to save the changes you made to "
												+ GRPU.fileName + ".grpu?";
									else
										exitMessage = "Do you want to save the changes you made to "
												+ GRPU.selectedFile.getName()
												+ " ?";
									int answer = JOptionPane.showConfirmDialog(
											GRPU.JdialogFrame, exitMessage);
									if (answer == 0) {
										int newdataAdded[] = GrpuUtil
												.getFilledRows(model);
										if (getFileName(
												GRPU.selectedFile.getName(),
												GRPU.selectedFile) == GRPU.fileName) {
											// writeFile(GRPU.path + "\\"
											// + GRPU.fileName + ".grpu",
											// "S", newdataAdded);
											savefile();
											{
												System.out
												.println("---FOOF---44");
												System.exit(0);
											}
										} else {
											// writeFile(GRPU.selectedFile
											// .getAbsolutePath()
											// + ".grpu", "S",
											// newdataAdded);
											savefile();
											{
												System.out
												.println("---FOOF---45");
												System.exit(0);
											}
										}
									} else if (answer == 1) {
										//System.out.println("---FOOF---46");
										System.exit(0);
									}
								}
							} else if (!fileSaveAs || !fileSaved)
								if (checkAODetails() && !ddoValuesChanged) {
									//System.out.println("---FOOF---47");
									System.exit(0);
								} else if (!checkAODetails()
										|| ddoValuesChanged) {
									if (getFileName(
											GRPU.selectedFile.getName(),
											GRPU.selectedFile) == GRPU.fileName)
										exitMessage = "Do you want to save the changes you made to "
												+ GRPU.fileName + " ?";
									else
										exitMessage = "Do you want to save the changes you made to "
												+ GRPU.selectedFile.getName()
												+ " ?";
									int answer = JOptionPane.showConfirmDialog(
											GRPU.JdialogFrame, exitMessage);
									if (answer == 0) {
										int newdataAdded[] = GrpuUtil
												.getFilledRows(model);
										if (getFileName(
												GRPU.selectedFile.getName(),
												GRPU.selectedFile) == GRPU.fileName) {
											// writeFile(GRPU.path + "/"
											// + GRPU.fileName + ".grpu",
											// "S", newdataAdded);
											savefile();
											{
												System.out
												.println("---FOOF---48");
												System.exit(0);
											}
										} else {
											// writeFile(GRPU.selectedFile
											// .getAbsolutePath()
											// + ".grpu", "S",
											// newdataAdded);
											savefile();
											{
												System.out
												.println("---FOOF---49");
												System.exit(0);
											}
										}
									} else if (answer == 1) {
										//System.out.println("---FOOF---50");
										System.exit(0);
									}
								}
						} catch (Exception e) {
							{
								//System.out.println("---FOOF---51");
								System.exit(0);
							}
							e.printStackTrace();
						}
				} catch (Exception ee) {
					{
						//System.out.println("---FOOF---52");
						System.exit(0);
					}
					ee.printStackTrace();
				}
			}
		});
		helpItem.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				grpuHelp = new GRPUHelp(formNumber);
			}

		});


		/*******************************************/
		//Added for feedback menu on 12/01/17 for FRD1.9

		/*feedbackItem.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				URI uri_btn = null;

				try {
					uri_btn = new URI(
							"https://www.tin-nsdl.com/customerfeedback.php");
				} catch (URISyntaxException ex) {
					// TODO Auto-generated catch block
					ex.printStackTrace();
				}

				if (Desktop.isDesktopSupported()) {
					try {

						Desktop.getDesktop().browse(uri_btn);
					} catch (IOException ex) {
						ex.printStackTrace();
					}
				} else {

				}
			}

		});*/
		/***********************************/

		fileitemopen.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				fileitemopen_actionPerformed(e);
			}

		});
		fileitemsave.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				// fileitemsave_actionPerformed(e); --- by Akansha
				savefile();
			}

		});
		// Method for printing the filled form
		// Added by Akansha
		fileitemprint.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {

				//	print(contentGRPU);

				//	fileitemprint_actionPerformed(e);
				contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
				retrievedFormValues();
				//PdfCreation.getRecipt(fileLogs,grpu,model,model1,model2);
				contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));		
			}

		});

		// *********************************************

		/*
		 * fileitemsaveas.addActionListener(new ActionListener() { ---- by
		 * Akansha
		 * 
		 * public void actionPerformed(ActionEvent e) {
		 * fileitemsaveas_actionPerformed(e); }
		 * 
		 * });
		 */

		textitem1.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				textitem1_actionPerformed(e);
			}

		});
		textitem2.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				textitem2_actionPerformed(e);
			}

		});
		textitem3.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				textitem3_actionPerformed(e);
			}

		});

		item1.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				cut();
			}

		});
		item2.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				copy();
			}

		});
		item3.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				paste();
			}

		});
		/*
		 * item4.addActionListener(new ActionListener() {
		 * 
		 * public void actionPerformed(ActionEvent e) { pasteXL(); }
		 * 
		 * });
		 */
		item6.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent e) {
				deleteCell();
			}

		});

	}

	private void intializeOtherVars() {
		maxGRPUVersion = "GRPU 1.3";

		// End
		maxFVUVersion = 1.0D;
		FVUVersioninFile = "";
		FVUVerFile = 0.0D;
		addRowElmts = new String[50];
		saveflg = false;
		isCutRow = false;
		fileCreated = false;
		ddoValuesChanged = false;
		fileSaved = false;
		fileSaveAs = false;
		rowIsSelected = false;
		selTAB = 0;
		prevErrRow = -1;
		prevErrCol = -1;
		isRowSelected = false;
		isCutSelected = false;
		isOpened = false;
		deleteFlag = false;
		totalCnt = 0;
		totalLineCnt = 0;
		aoData = new String[33];
		aoModifiedData = new String[17];
		NULL_INT_ARRAY = new int[0];
		selectedData = new Vector();
		tabFlag = 0;
		cntPasteClk = 0;
		selColFocus = -1;
		selRowFocus = -1;
		h = new HashSet();

	}

	private boolean isValidRrrNumber(String RRR_No) {
		try {
			Long.parseLong(RRR_No.trim());
		} catch (Exception e) {
			return true;
		}
		if (Long.parseLong(RRR_No.trim()) == 0) {
			return true;
		}
		long longRRR_No;
		long longRRR_No1;
		int intRRR_No1, intRRR_No2;
		longRRR_No = Long.parseLong(RRR_No);
		longRRR_No1 = longRRR_No / 10;
		intRRR_No2 = (int) (longRRR_No % 10);
		intRRR_No1 = (int) (longRRR_No1 % 7);
		if (intRRR_No1 == intRRR_No2) {
			return false;
		} else {
			return true;
		}
	}

	public boolean validateImportedFile(File selFile) {
		StringBuffer s = new StringBuffer(".");
		String fileExtsn = "";
		String getFileName = selFile.getName();
		if (getFileName.contains(s))
			fileExtsn = getFileName.substring(getFileName.lastIndexOf("."),
					getFileName.length());
		else
			fileExtsn = "";
		if (!(fileExtsn.equals(".tds") || fileExtsn.equals(""))) // .grpu
		{
			getMessage("This is not an TDS or saved intermidiate file!");
			return false;
		}
		if (fileExtsn.equals(".tds")) {
			if (getFileName.toLowerCase().length()
					- GRPUConstants.FILE_EXTN_LEN_TXT > GRPUConstants.FILE_LEN_TXT) {

				getMessage("Invalid length of filename. \nFilename cannot be more than "
						+ GRPUConstants.FILE_LEN_TXT + " characters");
				return false;
			}
		}
		if (fileExtsn.equals("")) // .grpu
		{
			System.out.println(getFileName.toLowerCase().length());
			if (getFileName.toLowerCase().length()
					- GRPUConstants.FILE_EXTN_LEN_GRPU > GRPUConstants.FILE_LEN_TXT) {
				System.out.println("Inside GRPU");
				getMessage("Invalid length of filename. \nFilename cannot be more than "
						+ GRPUConstants.FILE_LEN_TXT + " characters");
				return false;
			}
		}

		return true;

	}

	// Prepopulated method for prepopulation of the form on auto load added by
	// Akansha
	public void prepopulateData(List<String> batchHeader, String fileExtsn,
			String statementtype) {

		String stateCentrName = "";
		batchValueArray = batchHeader; // To Save the values
		String year = "";
		int y = 0;
		System.out.println("Value Of rows " + batchHeader.get(1).toString());
		if ("Regular".equals(statementtype)) {
			if (batchHeader.get(1) != null)
				numDdoRowsCorr = Integer.parseInt(batchHeader.get(1).toString()
						.trim());

			// if (!fileExtsn.equals("")) // .grpu for opening a file
			// initializeDDOTab();

			// Restoring the previous values of the first panel
			if (batchHeader.get(14) != null)
				JComboBox_Form_Sub1_finYear.setSelectedItem((batchHeader
						.get(14).toString().trim()));
			else
				JComboBox_Form_Sub1_finYear.setSelectedItem("--Select--");
			if (batchHeader.get(5) != null)
				jComboBox_Quarter.setSelectedItem(GrpuUtil
						.getQuarter(batchHeader.get(5).toString().trim()));
			else
				jComboBox_Quarter.setSelectedItem("--Select--");

			if (batchHeader.get(8) != null)
				jText_Form_Sub1_Org_Receipt_Num.setText(batchHeader.get(8)
						.toString().trim());
			else
				jText_Form_Sub1_Org_Receipt_Num.setText("");
			if (batchHeader.get(7) != null)
				jText_Form_Sub1_Previous_Receipt_num.setText(batchHeader.get(7)
						.toString().trim());
			else
				jText_Form_Sub1_Previous_Receipt_num.setText("");
			if (batchHeader.get(9) != null)
				jText_Form_Sub1_Tan.setText(batchHeader.get(9).toString()
						.trim());
			else
				jText_Form_Sub1_Tan.setText("");
			if (batchHeader.get(10) != null)
				jText_Form_Sub1_LastTan.setText(batchHeader.get(10).toString()
						.trim());
			else
				jText_Form_Sub1_LastTan.setText("");

			jText_Form_Sub1_isRevised.setText(batchHeader.get(12).toString()
					.trim());
			if (batchHeader.get(11) != null)
				jText_Form_Sub1_Pan.setText(batchHeader.get(11).toString()
						.trim());
			else
				jText_Form_Sub1_Pan.setText("");
			if (batchHeader.get(15) != null)
				jText_Form_Sub1_AssessmentYear.setText((batchHeader.get(15)
						.toString().trim()));
			else
				jText_Form_Sub1_AssessmentYear.setText("");
			if (batchHeader.get(17) != null)
				jText_Form_Sub1_Last_Deductor_Type.setText(batchHeader.get(17)
						.toString().trim());
			else
				jText_Form_Sub1_Last_Deductor_Type.setText("");

			if (!"--Select--".equals(batchHeader.get(16).toString()))
				JComboBox_Form_Sub1_Type_of_Deductor.setSelectedIndex(Integer
						.parseInt(batchHeader.get(16).toString().trim()));
			else
				JComboBox_Form_Sub1_Type_of_Deductor.setSelectedIndex(0);
			if (!"--Select--".equals(batchHeader.get(13).toString()))
				JComboBox_Form_Sub1_Update_deductor.setSelectedIndex(Integer
						.parseInt(batchHeader.get(13).toString().trim()));
			else
				JComboBox_Form_Sub1_Update_deductor.setSelectedIndex(0);
			// ************************************************

			// Restoring the previous values of the second panel

			if (batchHeader.get(18) != null)
				jText_Form_Sub2_Name.setText(batchHeader.get(18).toString()
						.trim());
			else
				jText_Form_Sub2_Name.setText("");
			if (batchHeader.get(19) != null)
				jText_Form_Sub2_Branch.setText(batchHeader.get(19).toString()
						.trim());
			else
				jText_Form_Sub2_Branch.setText("");
			if (!"--Select--".equals(batchHeader.get(20).toString())) {
				jComboBox_Form_Sub2_State.setSelectedItem(GrpuUtil
						.getStateName(batchHeader.get(20).toString().trim()));

			} else
				jComboBox_Form_Sub2_State.setSelectedIndex(0);
			if (batchHeader.get(21) != null)
				jText_Form_Sub2_PAO_Code.setText(batchHeader.get(21).toString()
						.trim());
			else
				jText_Form_Sub2_PAO_Code.setText("");
			if (batchHeader.get(22) != null)
				jText_Form_Sub2_PAO_regNum.setText(batchHeader.get(22)
						.toString().trim());
			else
				jText_Form_Sub2_PAO_regNum.setText("");
			if (batchHeader.get(23) != null)
				jText_Form_Sub2_FlatNo.setText(batchHeader.get(23).toString()
						.trim());
			else
				jText_Form_Sub2_FlatNo.setText("");
			if (batchHeader.get(37) != null)
				jText_Form_Sub2_BuildingName.setText(batchHeader.get(37)
						.toString().trim());
			else
				jText_Form_Sub2_BuildingName.setText("");
			if (batchHeader.get(25) != null)
				jText_Form_Sub2_Road.setText(batchHeader.get(25).toString()
						.trim());
			else
				jText_Form_Sub2_Road.setText("");
			if (batchHeader.get(24) != null)
				jText_Form_Sub2_Area.setText(batchHeader.get(24).toString()
						.trim());
			else
				jText_Form_Sub2_Area.setText("");

			if (batchHeader.get(26) != null)
				jText_Form_Sub2_PinCode.setText(batchHeader.get(26).toString()
						.trim());
			else
				jText_Form_Sub2_PinCode.setText("");
			if (batchHeader.get(27) != null)
				jText_Form_Sub2_TelNum_Std_Code.setText(batchHeader.get(27)
						.toString().trim());
			else
				jText_Form_Sub2_TelNum_Std_Code.setText("");
			if (batchHeader.get(28) != null)
				jText_Form_Sub2_TelNum.setText(batchHeader.get(28).toString()
						.trim());
			else
				jText_Form_Sub2_TelNum.setText("");
			if (batchHeader.get(40) != null)
				jText_Form_Sub2_Email.setText(batchHeader.get(40).toString()
						.trim());
			else
				jText_Form_Sub2_Email.setText("");
			if (!"--Select--".equals(batchHeader.get(32).toString()))
				JComboBox_Form_Sub2_MinistryName.setSelectedIndex(Integer
						.parseInt(batchHeader.get(32).toString().trim()));
			else
				JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			if (batchHeader.get(33) != null)
				jText_Form_Sub2_MinistryName_Other.setText(batchHeader.get(33)
						.toString().trim());
			else
				jText_Form_Sub2_MinistryName_Other.setText("");
			if (batchHeader.get(31) != null)
				jText_Form_Sub2_AIN.setText(batchHeader.get(31).toString()
						.trim());
			else
				jText_Form_Sub2_AIN.setText("");
			if (!"--Select--".equals(batchHeader.get(39).toString())) {
				jComboBox_AOState.setSelectedItem(GrpuUtil
						.getStateName(batchHeader.get(39).toString().trim()));

			} else
				jComboBox_AOState.setSelectedIndex(0);
			if (batchHeader.get(34) != null)
				jText_Form_Sub2_DDO_Code.setText(batchHeader.get(34).toString()
						.trim());
			else
				jText_Form_Sub2_DDO_Code.setText("");
			if (batchHeader.get(35) != null)
				jText_Form_Sub2_DDO_RegNum.setText(batchHeader.get(35)
						.toString().trim());
			else
				jText_Form_Sub2_DDO_RegNum.setText("");
			if (batchHeader.get(36) != null)
				jText_Form_Sub2_TAN_RegNum.setText(batchHeader.get(36)
						.toString().trim());
			else
				jText_Form_Sub2_TAN_RegNum.setText("");
			if (batchHeader.get(38) != null)
				jText_Form_Sub2_Town.setText(batchHeader.get(38).toString()
						.trim());
			else
				jText_Form_Sub2_Town.setText("");
			if (batchHeader.get(29) != null)
				jText_Form_Sub2_AlternateTelNum_Std_Code.setText(batchHeader
						.get(29).toString().trim());
			else
				jText_Form_Sub2_AlternateTelNum_Std_Code.setText("");
			if (batchHeader.get(30) != null)
				jText_Form_Sub2_AlternateTelNum.setText(batchHeader.get(30)
						.toString().trim());
			else
				jText_Form_Sub2_AlternateTelNum.setText("");
			if (batchHeader.get(41) != null)
				jText_Form_Sub2_Email_Alternate.setText(batchHeader.get(41)
						.toString().trim());
			else
				jText_Form_Sub2_Email_Alternate.setText("");
			if (!"--Select--".equals(batchHeader.get(42).toString()))
				jComboBox_Form_Sub2_isAddressChanged.setSelectedIndex(Integer
						.parseInt(batchHeader.get(42).toString().trim()));
			else
				jComboBox_Form_Sub2_isAddressChanged.setSelectedIndex(0);
			if (!"--Select--".equals(batchHeader.get(52).toString()))
				jComboBox_Form_Sub3_isAddressChanged.setSelectedIndex(Integer
						.parseInt(batchHeader.get(52).toString().trim()));
			else
				jComboBox_Form_Sub3_isAddressChanged.setSelectedIndex(0);

			jComboBox_Deductor_Category.setSelectedItem(stateCentrName);
			/*
			 * if(jComboBox_Last_Deductor_Category.isEnabled()) // by Akansha {
			 * if(BatchHeader[22].toString().trim().equals("A"))
			 * LaststateCentrName = "Central Govt."; else
			 * if(BatchHeader[21].toString().trim().equals("--Select--"))
			 * LaststateCentrName = "--Select--"; else LaststateCentrName =
			 * "State Govt.";
			 * jComboBox_Last_Deductor_Category.setSelectedItem(LaststateCentrName
			 * ); }
			 */
			// added by manish
			// String batchInd = BatchHeader[6].toString().trim();
			// System.out.println("Batch Indicator:" + batchInd);
			//
			// if (batchInd.equals("")) {
			// batchIndicator = 0;
			// } else {
			// batchIndicator = Integer.parseInt(batchInd);
			// }

			// *********************************************************************************
			if (batchHeader.get(43) != null)
				jText_Form_Sub3_Name.setText(batchHeader.get(43).toString()
						.trim());
			else
				jText_Form_Sub3_Name.setText("");
			if (batchHeader.get(44) != null)
				jText_Form_Sub3_Designation.setText(batchHeader.get(44)
						.toString().trim());
			else
				jText_Form_Sub3_Designation.setText("");
			if (batchHeader.get(45) != null)
				jText_Form_Sub3_FlatNum.setText(batchHeader.get(45).toString()
						.trim());
			else
				jText_Form_Sub3_FlatNum.setText("");
			if (batchHeader.get(46) != null)
				jText_Form_Sub3_BuildingName.setText(batchHeader.get(46)
						.toString().trim());
			else
				jText_Form_Sub3_BuildingName.setText("");
			if (batchHeader.get(47) != null)
				jText_Form_Sub3_Road.setText(batchHeader.get(47).toString()
						.trim());
			else
				jText_Form_Sub3_Road.setText("");
			if (batchHeader.get(54) != null)
				jText_Form_Sub3_Area.setText(batchHeader.get(54).toString()
						.trim());
			else
				jText_Form_Sub3_Area.setText("");
			if (batchHeader.get(55) != null)
				jText_Form_Sub3_Town.setText(batchHeader.get(55).toString()
						.trim());
			else
				jText_Form_Sub3_Town.setText("");
			if (batchHeader.get(57) != null)
				jText_Form_Sub3_PinCode.setText(batchHeader.get(57).toString()
						.trim());
			else
				jText_Form_Sub3_PinCode.setText("");
			if (batchHeader.get(48) != null)
				jText_Form_Sub3_TelNum_Std_Code.setText(batchHeader.get(48)
						.toString().trim());
			else
				jText_Form_Sub3_TelNum_Std_Code.setText("");
			if (batchHeader.get(49) != null)
				jText_Form_Sub3_TelNum.setText(batchHeader.get(49).toString()
						.trim());
			else
				jText_Form_Sub3_TelNum.setText("");
			if (batchHeader.get(50) != null)
				jText_Form_Sub3_TelNum_Alternate_Std_Code.setText(batchHeader
						.get(50).toString().trim());
			else
				jText_Form_Sub3_TelNum_Alternate_Std_Code.setText("");
			if (batchHeader.get(51) != null)
				jText_Form_Sub3_TelNum_Alternate.setText(batchHeader.get(51)
						.toString().trim());
			else
				jText_Form_Sub3_TelNum_Alternate.setText("");
			if (batchHeader.get(58) != null)
				jText_Form_Sub3_Email.setText(batchHeader.get(58).toString()
						.trim());
			else
				jText_Form_Sub3_Email.setText("");
			if (batchHeader.get(60) != null)
				jText_Form_Sub3_MobileNumber.setText(batchHeader.get(60)
						.toString().trim());
			else
				jText_Form_Sub3_MobileNumber.setText("");
			if (batchHeader.get(53) != null)
				jText_Form_Sub3_earlierReceiptNum.setText(batchHeader.get(53)
						.toString().trim());
			else
				jText_Form_Sub3_earlierReceiptNum.setText("");
			if (!"--Select--".equals(batchHeader.get(56).toString()))
				jComboBox_State_Name.setSelectedItem(GrpuUtil
						.getStateName(batchHeader.get(56).toString().trim()));
			else
				jComboBox_State_Name.setSelectedIndex(0);
			if (batchHeader.get(59) != null)
				jText_Form_Sub3_Email_Alternate.setText(batchHeader.get(59)
						.toString().trim());
			else
				jText_Form_Sub3_Email_Alternate.setText("");
			if (!"--Select--".equals(batchHeader.get(61).toString()))
				jComboBox_Form_Sub3_isRegularStatement.setSelectedIndex(Integer
						.parseInt(batchHeader.get(61).toString().trim()));
			else
				jComboBox_Form_Sub3_isRegularStatement.setSelectedIndex(0);

			/******************************************************/
			if (batchHeader.get(62) != null)
				if(batchHeader.get(62).equals("LineHash")){
					jText_Form_Sub2_GSTN.setText("");
				}else{
					jText_Form_Sub2_GSTN.setText(batchHeader.get(62).toString()
							.trim());
				}
			else
				jText_Form_Sub2_GSTN.setText("");
			/******************************************************/

			// Enabling and disabling based on financial year
			enableDisableOnFinYear();
			// **********************************************

			// Enabling and disabling based on deductor type
			enableDisableTypeOfDD();
			// ***********************************************



		} else if ("Correction".equals(statementtype) && ("".equals(fileExtsn))) {
			if (batchHeader.get(1) != null)
				numDdoRowsCorr = Integer.parseInt(batchHeader.get(1).toString()
						.trim());
			filehash = batchHeader.get(63).toString().trim();
			// if (!fileExtsn.equals("")) // .grpu for opening a file
			// initializeDDOTab();

			// newly added for FRD1.5 by Akansha
			//	System.out.println("AnnexII count: "+batchHeader.get(64).toString() );
			if(batchHeader.get(64)!=null && !"".equals(batchHeader.get(64).toString()) && !"LineHash".equals(batchHeader.get(64).toString()))
				annexIIcount = batchHeader.get(64).toString();		


			// Restoring the previous values of the first panel
			if (batchHeader.get(14) != null)
				JComboBox_Form_Sub1_finYear.setSelectedItem((batchHeader
						.get(14).toString().trim()));
			else
				JComboBox_Form_Sub1_finYear.setSelectedItem("--Select--");
			if (batchHeader.get(5) != null)
				jComboBox_Quarter.setSelectedItem(GrpuUtil
						.getQuarter(batchHeader.get(5).toString().trim()));
			else
				jComboBox_Quarter.setSelectedItem("--Select--");

			if (batchHeader.get(8) != null)
				jText_Form_Sub1_Org_Receipt_Num.setText(batchHeader.get(8)
						.toString().trim());
			else
				jText_Form_Sub1_Org_Receipt_Num.setText("");
			if (batchHeader.get(7) != null)
				jText_Form_Sub1_Previous_Receipt_num.setText(batchHeader.get(7)
						.toString().trim());
			else
				jText_Form_Sub1_Previous_Receipt_num.setText("");
			if (batchHeader.get(9) != null)
				jText_Form_Sub1_Tan.setText(batchHeader.get(9).toString()
						.trim());
			else
				jText_Form_Sub1_Tan.setText("");
			if (batchHeader.get(10) != null)
				jText_Form_Sub1_LastTan.setText(batchHeader.get(10).toString()
						.trim());
			else
				jText_Form_Sub1_LastTan.setText("");

			jText_Form_Sub1_isRevised.setText(batchHeader.get(12).toString()
					.trim());
			if (batchHeader.get(11) != null)
				jText_Form_Sub1_Pan.setText(batchHeader.get(11).toString()
						.trim());
			else
				jText_Form_Sub1_Pan.setText("");
			if (batchHeader.get(15) != null)
				jText_Form_Sub1_AssessmentYear.setText((batchHeader.get(15)
						.toString().trim()));
			else
				jText_Form_Sub1_AssessmentYear.setText("");
			if (batchHeader.get(17) != null)
				jText_Form_Sub1_Last_Deductor_Type
				.setText(GrpuUtil.getDeductorType(batchHeader.get(17)
						.toString().trim()));
			else
				jText_Form_Sub1_Last_Deductor_Type.setText("");

			if (!"--Select--".equals(batchHeader.get(16).toString()))
				JComboBox_Form_Sub1_Type_of_Deductor.setSelectedIndex(Integer
						.parseInt(batchHeader.get(16).toString().trim()));
			else
				JComboBox_Form_Sub1_Type_of_Deductor.setSelectedIndex(0);


			// ### New Development for the added field as on 13/04/2015 by
			// Akansha
			if (!"--Select--".equals(batchHeader.get(13).toString())) {
				// Enabling and disabling based on financial year
				enableDisableOnFinYear();
				// **********************************************
				// Enabling and disabling based on deductor type
				enableDisableTypeOfDD();
				// ***********************************************
				JComboBox_Form_Sub1_Update_deductor.setSelectedIndex(Integer
						.parseInt(batchHeader.get(13).toString()));
			} else
				JComboBox_Form_Sub1_Update_deductor.setSelectedIndex(0);
			// ************************************************

			// Restoring the previous values of the second panel

			if (batchHeader.get(18) != null)
				jText_Form_Sub2_Name.setText(batchHeader.get(18).toString()
						.trim());
			else
				jText_Form_Sub2_Name.setText("");
			if (batchHeader.get(19) != null)
				jText_Form_Sub2_Branch.setText(batchHeader.get(19).toString()
						.trim());
			else
				jText_Form_Sub2_Branch.setText("");
			if (!"--Select--".equals(batchHeader.get(20).toString()))
				jComboBox_Form_Sub2_State.setSelectedItem(GrpuUtil
						.getStateName(batchHeader.get(20).toString().trim()));
			else
				jComboBox_Form_Sub2_State.setSelectedIndex(0);
			if (batchHeader.get(21) != null)
				jText_Form_Sub2_PAO_Code.setText(batchHeader.get(21).toString()
						.trim());
			else
				jText_Form_Sub2_PAO_Code.setText("");
			if (batchHeader.get(22) != null)
				jText_Form_Sub2_PAO_regNum.setText(batchHeader.get(22)
						.toString().trim());
			else
				jText_Form_Sub2_PAO_regNum.setText("");
			if (batchHeader.get(23) != null)
				jText_Form_Sub2_FlatNo.setText(batchHeader.get(23).toString()
						.trim());
			else
				jText_Form_Sub2_FlatNo.setText("");
			if (batchHeader.get(37) != null)
				jText_Form_Sub2_BuildingName.setText(batchHeader.get(37)
						.toString().trim());
			else
				jText_Form_Sub2_BuildingName.setText("");
			if (batchHeader.get(25) != null)
				jText_Form_Sub2_Road.setText(batchHeader.get(25).toString()
						.trim());
			else
				jText_Form_Sub2_Road.setText("");
			if (batchHeader.get(24) != null)
				jText_Form_Sub2_Area.setText(batchHeader.get(24).toString()
						.trim());
			else
				jText_Form_Sub2_Area.setText("");

			if (batchHeader.get(26) != null)
				jText_Form_Sub2_PinCode.setText(batchHeader.get(26).toString()
						.trim());
			else
				jText_Form_Sub2_PinCode.setText("");
			if (batchHeader.get(27) != null)
				jText_Form_Sub2_TelNum_Std_Code.setText(batchHeader.get(27)
						.toString().trim());
			else
				jText_Form_Sub2_TelNum_Std_Code.setText("");
			if (batchHeader.get(28) != null)
				jText_Form_Sub2_TelNum.setText(batchHeader.get(28).toString()
						.trim());
			else
				jText_Form_Sub2_TelNum.setText("");
			if (batchHeader.get(40) != null)
				jText_Form_Sub2_Email.setText(batchHeader.get(40).toString()
						.trim());
			else
				jText_Form_Sub2_Email.setText("");
			if (!"--Select--".equals(batchHeader.get(32).toString()))
				JComboBox_Form_Sub2_MinistryName.setSelectedIndex(Integer
						.parseInt(batchHeader.get(32).toString().trim()));
			else
				JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			if (batchHeader.get(33) != null)
				jText_Form_Sub2_MinistryName_Other.setText(batchHeader.get(33)
						.toString().trim());
			else
				jText_Form_Sub2_MinistryName_Other.setText("");
			if (batchHeader.get(31) != null)
				jText_Form_Sub2_AIN.setText(batchHeader.get(31).toString()
						.trim());
			else
				jText_Form_Sub2_AIN.setText("");
			if (!"--Select--".equals(batchHeader.get(39).toString()))
				jComboBox_AOState.setSelectedItem(GrpuUtil
						.getStateName(batchHeader.get(39).toString().trim()));
			else
				jComboBox_AOState.setSelectedIndex(0);
			if (batchHeader.get(34) != null)
				jText_Form_Sub2_DDO_Code.setText(batchHeader.get(34).toString()
						.trim());
			else
				jText_Form_Sub2_DDO_Code.setText("");
			if (batchHeader.get(35) != null)
				jText_Form_Sub2_DDO_RegNum.setText(batchHeader.get(35)
						.toString().trim());
			else
				jText_Form_Sub2_DDO_RegNum.setText("");
			if (batchHeader.get(36) != null)
				jText_Form_Sub2_TAN_RegNum.setText(batchHeader.get(36)
						.toString().trim());
			else
				jText_Form_Sub2_TAN_RegNum.setText("");
			if (batchHeader.get(38) != null)
				jText_Form_Sub2_Town.setText(batchHeader.get(38).toString()
						.trim());
			else
				jText_Form_Sub2_Town.setText("");
			if (batchHeader.get(29) != null)
				jText_Form_Sub2_AlternateTelNum_Std_Code.setText(batchHeader
						.get(29).toString().trim());
			else
				jText_Form_Sub2_AlternateTelNum_Std_Code.setText("");
			if (batchHeader.get(30) != null)
				jText_Form_Sub2_AlternateTelNum.setText(batchHeader.get(30)
						.toString().trim());
			else
				jText_Form_Sub2_AlternateTelNum.setText("");
			if (batchHeader.get(41) != null)
				jText_Form_Sub2_Email_Alternate.setText(batchHeader.get(41)
						.toString().trim());
			else
				jText_Form_Sub2_Email_Alternate.setText("");
			if (!"--Select--".equals(batchHeader.get(42).toString()))
				jComboBox_Form_Sub2_isAddressChanged.setSelectedIndex(Integer
						.parseInt(batchHeader.get(42).toString().trim()));
			else
				jComboBox_Form_Sub2_isAddressChanged.setSelectedIndex(0);

			if (!"-Select--".equals(batchHeader.get(52).toString()))
				jComboBox_Form_Sub3_isAddressChanged.setSelectedIndex(Integer
						.parseInt(batchHeader.get(52).toString()));
			else
				jComboBox_Form_Sub3_isAddressChanged.setSelectedIndex(0);
			jComboBox_Deductor_Category.setSelectedItem(stateCentrName);
			/*
			 * if(jComboBox_Last_Deductor_Category.isEnabled()) // by Akansha {
			 * if(BatchHeader[22].toString().trim().equals("A"))
			 * LaststateCentrName = "Central Govt."; else
			 * if(BatchHeader[21].toString().trim().equals("--Select--"))
			 * LaststateCentrName = "--Select--"; else LaststateCentrName =
			 * "State Govt.";
			 * jComboBox_Last_Deductor_Category.setSelectedItem(LaststateCentrName
			 * ); }
			 */
			// added by manish
			// String batchInd = BatchHeader[6].toString().trim();
			// System.out.println("Batch Indicator:" + batchInd);
			//
			// if (batchInd.equals("")) {
			// batchIndicator = 0;
			// } else {
			// batchIndicator = Integer.parseInt(batchInd);
			// }

			// *********************************************************************************
			if (batchHeader.get(43) != null)
				jText_Form_Sub3_Name.setText(batchHeader.get(43).toString()
						.trim());
			else
				jText_Form_Sub3_Name.setText("");
			if (batchHeader.get(44) != null)
				jText_Form_Sub3_Designation.setText(batchHeader.get(44)
						.toString().trim());
			else
				jText_Form_Sub3_Designation.setText("");
			if (batchHeader.get(45) != null)
				jText_Form_Sub3_FlatNum.setText(batchHeader.get(45).toString()
						.trim());
			else
				jText_Form_Sub3_FlatNum.setText("");
			if (batchHeader.get(46) != null)
				jText_Form_Sub3_BuildingName.setText(batchHeader.get(46)
						.toString().trim());
			else
				jText_Form_Sub3_BuildingName.setText("");
			if (batchHeader.get(47) != null)
				jText_Form_Sub3_Road.setText(batchHeader.get(47).toString()
						.trim());
			else
				jText_Form_Sub3_Road.setText("");
			if (batchHeader.get(54) != null)
				jText_Form_Sub3_Area.setText(batchHeader.get(54).toString()
						.trim());
			else
				jText_Form_Sub3_Area.setText("");
			if (batchHeader.get(55) != null)
				jText_Form_Sub3_Town.setText(batchHeader.get(55).toString()
						.trim());
			else
				jText_Form_Sub3_Town.setText("");
			if (batchHeader.get(57) != null)
				jText_Form_Sub3_PinCode.setText(batchHeader.get(57).toString()
						.trim());
			else
				jText_Form_Sub3_PinCode.setText("");
			if (batchHeader.get(48) != null)
				jText_Form_Sub3_TelNum_Std_Code.setText(batchHeader.get(48)
						.toString().trim());
			else
				jText_Form_Sub3_TelNum_Std_Code.setText("");
			if (batchHeader.get(49) != null)
				jText_Form_Sub3_TelNum.setText(batchHeader.get(49).toString()
						.trim());
			else
				jText_Form_Sub3_TelNum.setText("");
			if (batchHeader.get(50) != null)
				jText_Form_Sub3_TelNum_Alternate_Std_Code.setText(batchHeader
						.get(50).toString().trim());
			else
				jText_Form_Sub3_TelNum_Alternate_Std_Code.setText("");
			if (batchHeader.get(51) != null)
				jText_Form_Sub3_TelNum_Alternate.setText(batchHeader.get(51)
						.toString().trim());
			else
				jText_Form_Sub3_TelNum_Alternate.setText("");
			if (batchHeader.get(58) != null)
				jText_Form_Sub3_Email.setText(batchHeader.get(58).toString()
						.trim());
			else
				jText_Form_Sub3_Email.setText("");
			if (batchHeader.get(60) != null)
				jText_Form_Sub3_MobileNumber.setText(batchHeader.get(60)
						.toString().trim());
			else
				jText_Form_Sub3_MobileNumber.setText("");
			if (batchHeader.get(53) != null)
				jText_Form_Sub3_earlierReceiptNum.setText(batchHeader.get(53)
						.toString().trim());
			else
				jText_Form_Sub3_earlierReceiptNum.setText("");
			if (!"--Select--".equals(batchHeader.get(56).toString()))
				jComboBox_State_Name.setSelectedItem(GrpuUtil
						.getStateName(batchHeader.get(56).toString().trim()));
			else
				jComboBox_State_Name.setSelectedIndex(0);
			if (batchHeader.get(59) != null)
				jText_Form_Sub3_Email_Alternate.setText(batchHeader.get(59)
						.toString().trim());
			else
				jText_Form_Sub3_Email_Alternate.setText("");
			if (!"--Select--".equals(batchHeader.get(61).toString()))
				jComboBox_Form_Sub3_isRegularStatement.setSelectedIndex(Integer
						.parseInt(batchHeader.get(61).toString().trim()));
			else
				jComboBox_Form_Sub3_isRegularStatement.setSelectedIndex(0);
			// enableDisableFormFields(); --- Newly commented by Akansha
			// 07/04/2015

			/******************************************************/
			if (batchHeader.get(65) != null)
				/*jText_Form_Sub2_GSTN.setText(batchHeader.get(65).toString()
						.trim());*/
				if(batchHeader.get(65).equals("LineHash")){
					jText_Form_Sub2_GSTN.setText("");
				}else{
					jText_Form_Sub2_GSTN.setText(batchHeader.get(65).toString()
							.trim());
				}
			else
				jText_Form_Sub2_GSTN.setText("");
			/******************************************************/

		}

		else if (".tds".equals(fileExtsn) && "Correction".equals(statementtype)) {
			if (batchHeader.get(3) != null)
				numDdoRowsCorr = Integer.parseInt(batchHeader.get(3).toString()
						.trim());

			// if (!fileExtsn.equals("")) // .grpu for opening a file
			// initializeDDOTab();

			// Restoring the previous values of the first panel
			if (batchHeader.get(16) != null)
				JComboBox_Form_Sub1_finYear
				.setSelectedItem(GrpuUtil.getFinancialYear(batchHeader
						.get(16).toString().trim()));
			else
				JComboBox_Form_Sub1_finYear.setSelectedItem("--Select--");

			// For getting the year
			year = batchHeader.get(16).toString().trim();
			y = Integer.parseInt(year.substring(0, 4));

			// **********************************************

			if (batchHeader.get(17) != null)
				jComboBox_Quarter.setSelectedItem(GrpuUtil
						.getQuarter(batchHeader.get(17).toString().trim()));
			else
				jComboBox_Quarter.setSelectedItem("--Select--");

			if (batchHeader.get(7) != null)
				jText_Form_Sub1_Org_Receipt_Num.setText(batchHeader.get(7)
						.toString().trim());
			else
				jText_Form_Sub1_Org_Receipt_Num.setText("");
			if (batchHeader.get(8) != null)
				jText_Form_Sub1_Previous_Receipt_num.setText(batchHeader.get(8)
						.toString().trim());
			else
				jText_Form_Sub1_Previous_Receipt_num.setText("");
			if (batchHeader.get(12) != null)
				jText_Form_Sub1_Tan.setText(batchHeader.get(12).toString()
						.trim());
			else
				jText_Form_Sub1_Tan.setText("");
			if (batchHeader.get(12) != null)
				jText_Form_Sub1_LastTan.setText(batchHeader.get(12).toString()
						.trim());
			else
				jText_Form_Sub1_LastTan.setText("");

			if (batchHeader.get(14) != null)
				jText_Form_Sub1_Pan.setText(batchHeader.get(14).toString()
						.trim());
			else
				jText_Form_Sub1_Pan.setText("");

			if (batchHeader.get(15) != null) {
				jText_Form_Sub1_AssessmentYear
				.setText(GrpuUtil.getFinancialYear(batchHeader.get(15)
						.toString().trim()));
			} else
				jText_Form_Sub1_AssessmentYear.setText("");
			if (batchHeader.get(52) != null)
				jText_Form_Sub1_Last_Deductor_Type
				.setText(GrpuUtil.getDeductorType(batchHeader.get(31)
						.toString().trim())); // 52 index
			else
				jText_Form_Sub1_Last_Deductor_Type.setText("");

			JComboBox_Form_Sub1_Type_of_Deductor.setSelectedItem(GrpuUtil
					.getDeductorType(batchHeader.get(31).toString().trim())); 

			dedtype = batchHeader.get(31).toString().trim();

			if ("".equals(batchHeader.get(51).toString().trim()))
				JComboBox_Form_Sub1_Update_deductor.setSelectedIndex(0);
			else
				JComboBox_Form_Sub1_Update_deductor.setSelectedIndex(1);
			// ************************************************

			// Restoring the previous values of the second panel

			if (batchHeader.get(18) != null)
				jText_Form_Sub2_Name.setText(batchHeader.get(18).toString()
						.trim());
			else
				jText_Form_Sub2_Name.setText("");
			if (batchHeader.get(19) != null)
				jText_Form_Sub2_Branch.setText(batchHeader.get(19).toString()
						.trim());
			else
				jText_Form_Sub2_Branch.setText("");
			if ("".equals(batchHeader.get(53).toString().trim()))
				jComboBox_Form_Sub2_State.setSelectedItem("--Select--");
			else {
				String statecode = "";
				if (!(batchHeader.get(53).toString().contains("0"))) {
					int a = Integer.parseInt(batchHeader.get(53).toString()
							.trim());
					if (a / 10 == 0)
						statecode = "0" + batchHeader.get(53).toString().trim();
					else
						statecode = batchHeader.get(53).toString().trim();
				} else {
					statecode = batchHeader.get(53).toString().trim();
				}
				jComboBox_Form_Sub2_State.setSelectedItem(GrpuUtil
						.getStateName(statecode));
			}
			if (batchHeader.get(54) != null)
				jText_Form_Sub2_PAO_Code.setText(batchHeader.get(54).toString()
						.trim());
			else
				jText_Form_Sub2_PAO_Code.setText("");
			if (batchHeader.get(59) != null)
				jText_Form_Sub2_PAO_regNum.setText(batchHeader.get(59)
						.toString().trim());
			else
				jText_Form_Sub2_PAO_regNum.setText("");
			if (batchHeader.get(20) != null)
				jText_Form_Sub2_FlatNo.setText(batchHeader.get(20).toString()
						.trim());
			else
				jText_Form_Sub2_FlatNo.setText("");
			if (batchHeader.get(21) != null)
				jText_Form_Sub2_BuildingName.setText(batchHeader.get(21)
						.toString().trim());
			else
				jText_Form_Sub2_BuildingName.setText("");
			if (batchHeader.get(22) != null)
				jText_Form_Sub2_Road.setText(batchHeader.get(22).toString()
						.trim());
			else
				jText_Form_Sub2_Road.setText("");
			if (batchHeader.get(23) != null)
				jText_Form_Sub2_Area.setText(batchHeader.get(23).toString()
						.trim());
			else
				jText_Form_Sub2_Area.setText("");

			if (batchHeader.get(26) != null)
				jText_Form_Sub2_PinCode.setText(batchHeader.get(26).toString()
						.trim());
			else
				jText_Form_Sub2_PinCode.setText("");
			if (batchHeader.get(28) != null)
				jText_Form_Sub2_TelNum_Std_Code.setText(batchHeader.get(28)
						.toString().trim());
			else
				jText_Form_Sub2_TelNum_Std_Code.setText("");
			if (batchHeader.get(29) != null)
				jText_Form_Sub2_TelNum.setText(batchHeader.get(29).toString()
						.trim());
			else
				jText_Form_Sub2_TelNum.setText("");
			if (batchHeader.get(27) != null)
				jText_Form_Sub2_Email.setText(batchHeader.get(27).toString()
						.trim());
			else
				jText_Form_Sub2_Email.setText("");
			System.out.println("Ministry name:"
					+ batchHeader.get(56).toString());
			JComboBox_Form_Sub2_MinistryName.setSelectedItem(GrpuUtil
					.getMinistryName(batchHeader.get(56).toString().trim()));

			System.out.println("Ministry name: "
					+ batchHeader.get(57).toString());
			if (batchHeader.get(57) != null) {
				jText_Form_Sub2_MinistryName_Other.setText(batchHeader.get(57)
						.toString().trim());
				System.out.println("New : "
						+ jText_Form_Sub2_MinistryName_Other.getText());
			} else
				jText_Form_Sub2_MinistryName_Other.setText("");

			// Newly added for ministry codes
			if (batchHeader.get(56) == null
					|| "".equals(batchHeader.get(56).toString().trim()))
				JComboBox_Form_Sub2_MinistryName.setSelectedItem("--Select--");
			else {
				String ministry = "";
				if (!(batchHeader.get(56).toString()).contains("0")) {
					int a = Integer.parseInt(batchHeader.get(56).toString()
							.trim());
					if (a / 10 == 0)
						ministry = "0" + batchHeader.get(56).toString().trim();
					else
						ministry = batchHeader.get(56).toString().trim();
				} else
					batchHeader.get(56).toString().trim();

				JComboBox_Form_Sub2_MinistryName.setSelectedItem(GrpuUtil
						.getMinistryName(ministry));
			}
			// ********************************************************
			if ("".equals(batchHeader.get(25).toString().trim()))
				jComboBox_AOState.setSelectedItem("--Select--");
			else {
				String statecode = "";
				if (!(batchHeader.get(25).toString()).contains("0")) {
					int a = Integer.parseInt(batchHeader.get(25).toString()
							.trim());
					//	System.out.println("AAAAAAAA :" + a);
					if (a / 10 == 0)
						statecode = "0" + batchHeader.get(25).toString().trim();
					else
						statecode = batchHeader.get(25).toString().trim();
				} else {
					statecode = batchHeader.get(25).toString().trim();
				}
				jComboBox_AOState.setSelectedItem(GrpuUtil
						.getStateName(statecode));
			}
			if (batchHeader.get(55) != null)
				jText_Form_Sub2_DDO_Code.setText(batchHeader.get(55).toString()
						.trim());
			else
				jText_Form_Sub2_DDO_Code.setText("");
			if (batchHeader.get(60) != null)
				jText_Form_Sub2_DDO_RegNum.setText(batchHeader.get(60)
						.toString().trim());
			else
				jText_Form_Sub2_DDO_RegNum.setText("");

			if (batchHeader.get(24) != null)
				jText_Form_Sub2_Town.setText(batchHeader.get(24).toString()
						.trim());
			else
				jText_Form_Sub2_Town.setText("");
			if (y >= 2013) {
				if (batchHeader.get(62) != null)
					jText_Form_Sub2_AlternateTelNum_Std_Code
					.setText(batchHeader.get(62).toString().trim());
				else
					jText_Form_Sub2_AlternateTelNum_Std_Code.setText("");
				if (batchHeader.get(63) != null)
					jText_Form_Sub2_AlternateTelNum.setText(batchHeader.get(63)
							.toString().trim());
				else
					jText_Form_Sub2_AlternateTelNum.setText("");
				if (batchHeader.get(64) != null)
					jText_Form_Sub2_Email_Alternate.setText(batchHeader.get(64)
							.toString().trim());
				else
					jText_Form_Sub2_Email_Alternate.setText("");

			}

			if (batchHeader.get(58) != null) {
				if ((batchHeader.get(58).toString().trim()).length() == 10) // ###
					// New
					// Development
					// as
					// on
					// 02/04/2015
					jText_Form_Sub2_TAN_RegNum.setText(batchHeader.get(58)
							.toString().trim());
				else
					System.out.println("TAN :"
							+ batchHeader.get(58).toString().trim());
			} else {
				jText_Form_Sub2_TAN_RegNum.setText("");

			}

			if (y > 2012) { // ## Newly added for correction Ver1.2 by Akansha
				System.out.println("AIN number: "
						+ batchHeader.get(68).toString());
				if (batchHeader.get(68) != null) // Actual number 67
					jText_Form_Sub2_AIN.setText(batchHeader.get(68).toString()
							.trim());
				else
					jText_Form_Sub2_AIN.setText("");
			}

			/**********************************************************************/
			/*if (batchHeader.get(69) != null) // Actual number 67
				jText_Form_Sub2_GSTN.setText(batchHeader.get(69).toString()
						.trim());
			else
				jText_Form_Sub2_GSTN.setText("");*/
			/********************************************************************/

			jComboBox_Form_Sub2_isAddressChanged.setSelectedItem(GrpuUtil
					.getYesNoOption(batchHeader.get(30).toString().trim()));
			jComboBox_Form_Sub3_isAddressChanged.setSelectedItem(GrpuUtil
					.getYesNoOption(batchHeader.get(45).toString()));
			jComboBox_Deductor_Category.setSelectedItem(stateCentrName);
			/*
			 * if(jComboBox_Last_Deductor_Category.isEnabled()) // by Akansha {
			 * if(BatchHeader[22].toString().trim().equals("A"))
			 * LaststateCentrName = "Central Govt."; else
			 * if(BatchHeader[21].toString().trim().equals("--Select--"))
			 * LaststateCentrName = "--Select--"; else LaststateCentrName =
			 * "State Govt.";
			 * jComboBox_Last_Deductor_Category.setSelectedItem(LaststateCentrName
			 * ); }
			 */
			// added by manish
			// String batchInd = BatchHeader[6].toString().trim();
			// System.out.println("Batch Indicator:" + batchInd);
			//
			// if (batchInd.equals("")) {
			// batchIndicator = 0;
			// } else {
			// batchIndicator = Integer.parseInt(batchInd);
			// }

			// *********************************************************************************
			if (batchHeader.get(32) != null)
				jText_Form_Sub3_Name.setText(batchHeader.get(32).toString()
						.trim());
			else
				jText_Form_Sub3_Name.setText("");
			if (batchHeader.get(33) != null)
				jText_Form_Sub3_Designation.setText(batchHeader.get(33)
						.toString().trim());
			else
				jText_Form_Sub3_Designation.setText("");
			if (batchHeader.get(34) != null)
				jText_Form_Sub3_FlatNum.setText(batchHeader.get(34).toString()
						.trim());
			else
				jText_Form_Sub3_FlatNum.setText("");
			if (batchHeader.get(35) != null)
				jText_Form_Sub3_BuildingName.setText(batchHeader.get(35)
						.toString().trim());
			else
				jText_Form_Sub3_BuildingName.setText("");
			if (batchHeader.get(36) != null)
				jText_Form_Sub3_Road.setText(batchHeader.get(36).toString()
						.trim());
			else
				jText_Form_Sub3_Road.setText("");
			if (batchHeader.get(37) != null)
				jText_Form_Sub3_Area.setText(batchHeader.get(37).toString()
						.trim());
			else
				jText_Form_Sub3_Area.setText("");
			if (batchHeader.get(38) != null)
				jText_Form_Sub3_Town.setText(batchHeader.get(38).toString()
						.trim());
			else
				jText_Form_Sub3_Town.setText("");
			if (batchHeader.get(40) != null)
				jText_Form_Sub3_PinCode.setText(batchHeader.get(40).toString()
						.trim());
			else
				jText_Form_Sub3_PinCode.setText("");
			if (batchHeader.get(43) != null)
				jText_Form_Sub3_TelNum_Std_Code.setText(batchHeader.get(43)
						.toString().trim());
			else
				jText_Form_Sub3_TelNum_Std_Code.setText("");
			if (batchHeader.get(44) != null)
				jText_Form_Sub3_TelNum.setText(batchHeader.get(44).toString()
						.trim());
			else
				jText_Form_Sub3_TelNum.setText("");
			if (y >= 2013) {
				if (batchHeader.get(65) != null)
					jText_Form_Sub3_TelNum_Alternate_Std_Code
					.setText(batchHeader.get(65).toString().trim());
				else
					jText_Form_Sub3_TelNum_Alternate_Std_Code.setText("");
				if (batchHeader.get(66) != null)
					jText_Form_Sub3_TelNum_Alternate.setText(batchHeader
							.get(66).toString().trim());
				else
					jText_Form_Sub3_TelNum_Alternate.setText("");
				if (batchHeader.get(67) != null)
					jText_Form_Sub3_Email_Alternate.setText(batchHeader.get(67)
							.toString().trim());
				else
					jText_Form_Sub3_Email_Alternate.setText("");
			}
			if (batchHeader.get(41) != null)
				jText_Form_Sub3_Email.setText(batchHeader.get(41).toString()
						.trim());
			else
				jText_Form_Sub3_Email.setText("");

			if (y >= 2010) {
				if (batchHeader.get(47) != null)
					jText_Form_Sub3_MobileNumber.setText(batchHeader.get(47)
							.toString().trim());
				else
					jText_Form_Sub3_MobileNumber.setText("");
			}

			/*
			 * if (y > 2013) { if (batchHeader.get(13) != null)
			 * jText_Form_Sub3_earlierReceiptNum.setText(batchHeader
			 * .get(13).toString().trim()); else
			 * jText_Form_Sub3_earlierReceiptNum.setText(""); }
			 */
			if ("".equals(batchHeader.get(39).toString().trim()))
				jComboBox_State_Name.setSelectedItem("--Select--");
			else {
				String statecode = "";
				if (!(batchHeader.get(39).toString()).contains("0")) {
					int a = Integer.parseInt(batchHeader.get(39).toString()
							.trim());
					if (a / 10 == 0)
						statecode = "0" + batchHeader.get(39).toString().trim();
					else
						statecode = batchHeader.get(39).toString().trim();
				} else {
					statecode = batchHeader.get(39).toString().trim();
				}
				jComboBox_State_Name.setSelectedItem(GrpuUtil
						.getStateName(statecode));
			}
			// jComboBox_Form_Sub3_isRegularStatement.setSelectedIndex(Integer
			// .parseInt(BatchHeader[61].toString().trim()));

			// // Enabling and disabling based on financial year
			// enableDisableOnFinYear();
			// // **********************************************
			//
			// // Enabling and disabling based on deductor type
			// enableDisableTypeOfDD();
			// // ***********************************************
		}
		// ************************************
	}

	// ************************************************************************************
	// Added by Akansha
	// This method serves the purpose of disabling the form fields while type os
	// statement is "Correction"
	public void enableDisableFormFields() {

		if ("Correction".equals(valueOfTypeOfStmt)) {
			// First panel
			jText_Form_Sub1_Tan.setEnabled(false); // E
			jText_Form_Sub1_LastTan.setEnabled(false);
			JComboBox_Form_Sub1_finYear.setEnabled(false);
			jText_Form_Sub1_Pan.setEnabled(false); // E
			JComboBox_Form_Sub1_finYear.setEnabled(false);
			JComboBox_Form_Sub1_Type_of_Deductor.setEnabled(false);
			JComboBox_Form_Sub1_Update_deductor.setEnabled(true);
			jText_Form_Sub1_LastTan.setEnabled(false);
			jText_Form_Sub1_isRevised.setText("Yes");
			jText_Form_Sub1_isRevised.setEnabled(false);
			jText_Form_Sub1_AssessmentYear.setEnabled(false);
			jText_Form_Sub1_Last_Deductor_Type.setEnabled(false);
			jText_Form_Sub1_Org_Receipt_Num.setEnabled(false);
			jText_Form_Sub1_Previous_Receipt_num.setEnabled(false);
			// *********
			// Second Panel
			jText_Form_Sub2_Name.setEnabled(false);
			jText_Form_Sub2_Branch.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			jText_Form_Sub2_MinistryName_Other.setEnabled(false);
			jComboBox_Form_Sub2_State.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setEnabled(false); // E
			jText_Form_Sub2_PAO_Code.setEnabled(false); // E
			jText_Form_Sub2_DDO_RegNum.setEnabled(false); // E
			jText_Form_Sub2_PAO_regNum.setEnabled(false); // E
			// jText_Form_Sub2_TAN_RegNum.setEnabled(false); // E //#### New
			// Development as on 01/04/2015
			jText_Form_Sub2_FlatNo.setEnabled(false); // E
			jText_Form_Sub2_Area.setEnabled(false); // E
			jText_Form_Sub2_BuildingName.setEnabled(false); // E
			jText_Form_Sub2_Town.setEnabled(false); // E
			jText_Form_Sub2_Road.setEnabled(false); // E
			jText_Form_Sub2_PinCode.setEnabled(false); // E
			jComboBox_AOState.setEnabled(false);
			jText_Form_Sub2_PinCode.setEnabled(false); // E
			jText_Form_Sub2_TelNum.setEnabled(false); // E
			jText_Form_Sub2_TelNum_Std_Code.setEnabled(false); // E
			jText_Form_Sub2_Email.setEnabled(false); // E
			jText_Form_Sub2_Email_Alternate.setEnabled(false); // E
			jText_Form_Sub2_AlternateTelNum_Std_Code.setEnabled(false); // E
			jText_Form_Sub2_AlternateTelNum.setEnabled(false); // E
			jText_Form_Sub2_AIN.setEnabled(false); // E
			jComboBox_Form_Sub2_isAddressChanged.setEnabled(false);
			//	jText_Form_Sub2_GSTN.setEnabled(false); // E
			// *********

			// Third Panel
			jText_Form_Sub3_Name.setEnabled(false); // E
			jText_Form_Sub3_Designation.setEnabled(false); // E
			jText_Form_Sub3_FlatNum.setEnabled(false);// E
			jText_Form_Sub3_Road.setEnabled(false); // E
			jText_Form_Sub3_BuildingName.setEnabled(false);
			jComboBox_Form_Sub3_isAddressChanged.setEnabled(false);
			jComboBox_Form_Sub3_isRegularStatement.setEnabled(false);
			jText_Form_Sub3_Area.setEnabled(false); // E
			jText_Form_Sub3_Town.setEnabled(false); // E
			jComboBox_State_Name.setEnabled(false);
			jText_Form_Sub3_PinCode.setEnabled(false); // E
			jText_Form_Sub3_Email.setEnabled(false); // E
			jText_Form_Sub3_TelNum.setEnabled(false); // E
			jText_Form_Sub3_TelNum_Std_Code.setEnabled(false); // E
			jText_Form_Sub3_TelNum_Alternate_Std_Code.setEnabled(false); // E
			jText_Form_Sub3_TelNum_Alternate.setEnabled(false);// E
			jText_Form_Sub3_Email_Alternate.setEnabled(false); // E
			jText_Form_Sub3_earlierReceiptNum.setEnabled(false);
			jText_Form_Sub3_MobileNumber.setEnabled(false); // E
			jCheckBox_Form_Sub2_Sameasabove.setEnabled(false);
			// ***********

		} else if ("Regular".equals(valueOfTypeOfStmt)) {
			jText_Form_Sub1_Tan.setEnabled(true);
			JComboBox_Form_Sub1_finYear.setEnabled(true);
			jText_Form_Sub1_LastTan.setEnabled(false);
			jText_Form_Sub1_isRevised.setText("No");
			jText_Form_Sub1_isRevised.setEnabled(false);
			jText_Form_Sub1_AssessmentYear.setEnabled(false);
			jText_Form_Sub1_Last_Deductor_Type.setEnabled(false);
			jText_Form_Sub1_Org_Receipt_Num.setEnabled(false);
			jText_Form_Sub1_Previous_Receipt_num.setEnabled(false);
			jText_Form_Sub2_MinistryName_Other.setEnabled(false);
			// jText_Form_Sub2_TAN_RegNum.setEnabled(false); //#### New
			// Development as on 01/04/2015
			jText_Form_Sub2_Email_Alternate.setEnabled(false);
			jText_Form_Sub2_AlternateTelNum_Std_Code.setEnabled(false);
			jText_Form_Sub2_AlternateTelNum.setEnabled(false);
			jText_Form_Sub2_AIN.setEnabled(false);
			jText_Form_Sub3_TelNum_Alternate_Std_Code.setEnabled(false);
			jText_Form_Sub3_TelNum_Alternate.setEnabled(false);
			jText_Form_Sub3_Email_Alternate.setEnabled(false);
			jText_Form_Sub3_earlierReceiptNum.setEnabled(false);
			jText_Form_Sub3_MobileNumber.setEnabled(false);
			jLabel_Form_Sub3_MobileNumber.setEnabled(true);
			JComboBox_Form_Sub1_Update_deductor.setEnabled(false);
			jCheckBox_Form_Sub2_Sameasabove.setEnabled(true);
		}

	}

	// Added by akansha for enabling and disabling fields on the basis of type
	// of deductor

	public void enableDisableTypeOfDD() {

		String deductertype = JComboBox_Form_Sub1_Type_of_Deductor
				.getSelectedItem().toString();
		if ("--Select--".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(true);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
			jText_Form_Sub2_AIN.setText("");
		} else if ("Firm".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Individual/HUF".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Body of Individuals".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Artificial Juridical Person".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Association of Person (Trust)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Association of Person (AOP)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Branch / Division of Company".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Company".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(false);
			jText_Form_Sub2_DDO_Code.setText("");
			jText_Form_Sub2_DDO_RegNum.setEnabled(false);
			jText_Form_Sub2_DDO_RegNum.setText("");
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(false);
			jText_Form_Sub2_PAO_Code.setText("");
			jText_Form_Sub2_PAO_regNum.setEnabled(false);
			jText_Form_Sub2_PAO_regNum.setText("");
			jText_Form_Sub2_AIN.setText("");
		} else if ("Local Authority (State Govt.)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(true);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
			jText_Form_Sub2_AIN.setText("");
		} else if ("Local Authority (Central Govt.)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
			jText_Form_Sub2_AIN.setText("");
		} else if ("Autonomous body (State Govt.)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(true);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
			jText_Form_Sub2_AIN.setText("");
		} else if ("Autonomous body (Central Govt.)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
			jText_Form_Sub2_AIN.setText("");
		} else if ("Statutory body (State Govt.)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(true);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
			jText_Form_Sub2_AIN.setText("");
		} else if ("Statutory body (Central Govt.)".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
			jText_Form_Sub2_AIN.setText("");
		} else if ("State Government".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(false);
			JComboBox_Form_Sub2_MinistryName.setSelectedIndex(0);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(true);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
		} else if ("Central Government".equals(deductertype)) {
			JComboBox_Form_Sub2_MinistryName.setEnabled(true);
			jText_Form_Sub2_DDO_Code.setEnabled(true);
			jText_Form_Sub2_DDO_RegNum.setEnabled(true);
			jComboBox_Form_Sub2_State.setEnabled(false);
			jComboBox_Form_Sub2_State.setSelectedIndex(0);
			jText_Form_Sub2_PAO_Code.setEnabled(true);
			jText_Form_Sub2_PAO_regNum.setEnabled(true);
		}
		enableDisableOnFinYear();

	}

	// **********************************************************

	// Added by Akansha for email validation on out focus of text box

	public boolean validateEmailOffFocus(String type, Component cmp) {
		String field = type.trim();
		JTextField text = (JTextField) cmp;
		if (!GrpuUtil.isValidCharString(type)) {
			JOptionPane.showMessageDialog(null, "Please enter valid email.");
			text.setText("");
			return false;

		}
		if (field.trim().equals("") || field.trim().length() == 0) {
			JOptionPane.showMessageDialog(null, "Please enter valid email.");
			text.setText("");
			return false;
		}
		for (int j = 0; j < field.length(); j++)
			if (field.charAt(j) == ' ') {
				JOptionPane
				.showMessageDialog(null, "Please enter valid email.");
				text.setText("");
				return false;
			}

		if (field.charAt(0) == '@' || field.charAt(0) == '.') {
			JOptionPane.showMessageDialog(null, "Please enter valid email.");
			text.setText("");
			return false;
		}
		if (field.charAt(field.length() - 1) == '@'
				|| field.charAt(field.length() - 1) == '.') {
			JOptionPane.showMessageDialog(null, "Please enter valid email.");
			text.setText("");
			return false;
		}
		int localCount = 0;
		int dotPos = 0;
		int ratePos = 0;
		for (int j = 0; j < field.length(); j++)
			if (field.charAt(j) == '@') {
				ratePos = j;
				if (field.charAt(j + 1) == '.') {
					JOptionPane.showMessageDialog(null,
							"Please enter valid email.");
					text.setText("");
					return false;
				}
				if (++localCount > 1) {
					JOptionPane.showMessageDialog(null,
							"Please enter valid email.");
					text.setText("");
					return false;
				}
			}

		if (localCount == 0) {
			JOptionPane.showMessageDialog(null, "Please enter valid email.");
			text.setText("");
			return false;
		}
		for (int x = 0; x < field.length(); x++)
			if (field.charAt(x) == '.') {
				dotPos = x;
				if (x + 1 != field.length() && field.charAt(x + 1) == '.') {
					JOptionPane.showMessageDialog(null,
							"Please enter valid email.");
					text.setText("");
					return false;
				}
			}
		return true;
	}

	// **************************************************************
	// Added by Akansha for enabling and disabling on the basis of financial
	// year
	public void enableDisableOnFinYear() {
		// Code for checking the validity of the AIN number
		String yearselected = "";
		int year = 0;
		yearselected = JComboBox_Form_Sub1_finYear.getSelectedItem().toString();
		if (!"--Select--".equals(JComboBox_Form_Sub1_finYear.getSelectedItem()))
			year = Integer.parseInt(yearselected.substring(0, 4));
		if (year >= 2013) {
			if ("Central Government"
					.equals(JComboBox_Form_Sub1_Type_of_Deductor
							.getSelectedItem().toString())
							|| "State Government"
							.equals(JComboBox_Form_Sub1_Type_of_Deductor
									.getSelectedItem().toString()))
				jText_Form_Sub2_AIN.setEnabled(true);
			else
				jText_Form_Sub2_AIN.setEnabled(false);
			jText_Form_Sub2_Email_Alternate.setEnabled(true);
			jText_Form_Sub2_AlternateTelNum_Std_Code.setEnabled(true);
			jText_Form_Sub2_AlternateTelNum.setEnabled(true);
			jText_Form_Sub3_Email_Alternate.setEnabled(true);
			jText_Form_Sub3_TelNum_Alternate_Std_Code.setEnabled(true);
			jText_Form_Sub3_TelNum_Alternate.setEnabled(true);
			// jText_Form_Sub2_TAN_RegNum.setEnabled(true); //#### New
			// Development as on 01/04/2015
		} else {
			jText_Form_Sub2_AIN.setEnabled(false);
			jText_Form_Sub2_AIN.setText("");
			jText_Form_Sub2_Email_Alternate.setEnabled(false);
			jText_Form_Sub2_Email_Alternate.setText("");
			jText_Form_Sub2_AlternateTelNum_Std_Code.setEnabled(false);
			jText_Form_Sub2_AlternateTelNum_Std_Code.setText("");
			jText_Form_Sub2_AlternateTelNum.setEnabled(false);
			jText_Form_Sub2_AlternateTelNum.setText("");
			jText_Form_Sub3_Email_Alternate.setEnabled(false);
			jText_Form_Sub3_Email_Alternate.setText("");
			jText_Form_Sub3_TelNum_Alternate_Std_Code.setEnabled(false);
			jText_Form_Sub3_TelNum_Alternate_Std_Code.setText("");
			jText_Form_Sub3_TelNum_Alternate.setEnabled(false);
			jText_Form_Sub3_TelNum_Alternate.setText("");
			// jText_Form_Sub2_TAN_RegNum.setEnabled(false); //#### New
			// Development as on 01/04/2015
			// jText_Form_Sub2_TAN_RegNum.setText(""); //#### New Development as
			// on 01/04/2015

		}

		if (year >= 2010) {
			jText_Form_Sub3_MobileNumber.setEnabled(true);
			jLabel_Form_Sub3_MobileNumber.setEnabled(true);
		} else {
			jText_Form_Sub3_MobileNumber.setEnabled(false);
			jText_Form_Sub3_MobileNumber.setText("");
			jLabel_Form_Sub3_MobileNumber.setEnabled(true);
		}

		// *********************************************************
	}

	// *************************************************************



	public void genericListenerValidation(final JTextField cmp,
			final String type) {
		cmp.addKeyListener(new KeyListener() {

			public void keyTyped(KeyEvent arg0) {

			}

			public void keyReleased(KeyEvent arg0) {
				new Validations().txtFieldValidation(arg0, cmp, type);

			}

			public void keyPressed(KeyEvent arg0) {

			}
		});
	}

	// Added by Akansha for form validations
	public void genericListenerFocusValidation(final JTextField cmp,
			final Component cmp2) {
		cmp.addFocusListener(new FocusListener() {

			@Override
			public void focusLost(FocusEvent e) {
				//validateEmailOffFocus(cmp.getText().toString(), cmp); //Newly commented for ver1.3 by Akansha
				cmp.setNextFocusableComponent(cmp2);
			}

			@Override
			public void focusGained(FocusEvent e) {
				// TODO Auto-generated method stub

			}
		});
	}

	// *************************************************

	//new development for FRD1.3 by Akansha
	//String builder changed to arraylist<object>
	public void savefileReg() {
		linenumber = 1;
		
		//StringBuilder formdetails = new StringBuilder("");
		String challandetails = "";
		ArrayList<Object> annIdetails = null;
		String annIIdetails = "";
	
		if ("Regular".equals(valueOfTypeOfStmt)) {

			// Collection of data for the BH header
			// Method call for retrieving the values from the form
			retrievedFormValues();
			// ************************************************
			formdetails.add("0^" + linenumber + "^BH^1^" + formNumber + "^"
					+ quarter + "^" + correctiontype + "^" + prevtoken + "^"
					+ orgtoken + "^" + tan + "^" + lasttan + "^" + pan + "^"
					+ isrevised + "^" + updateDD + "^" + finyear + "^"
					+ assyear + "^" + typeofDD + "^" + lastDD + "^" + dedname
					+ "^" + dedbranch + "^" + dedstateone + "^" + paocode + "^"
					+ paoregnm + "^" + flatno + "^" + area + "^" + road + "^"
					+ dedpin + "^" + dedtelstd + "^" + dedtel + "^"
					+ dedalttelstd + "^" + dedalttel + "^" + dedain + "^"
					+ dedminstrydept + "^" + dedminstrydeptothers + "^"
					+ ddocode + "^" + ddoregnm + "^" + tanregnm + "^"
					+ dedbldgname + "^" + dedtown + "^" + dedstatetwo + "^"
					+ dedemail + "^" + dedemailalt + "^" + hasaddchanged + "^" 
					+ rpname + "^" + rpdesig + "^" + rpflatno + "^" + rpbuldg
					+ "^" + rproad + "^" + rptelnumstd + "^" + rptelnum + "^"
					+ rptelnumaltstd + "^" + rptelnumalt + "^"
					+ rpisaddresschng + "^" + rprecieptnm + "^" + rparea + "^"
					+ rptown + "^" + rpstate + "^" + rppin + "^" + rpemail
					+ "^" + rpemailalt + "^" + rpmobile + "^"
					+ rpisregstatement + "^" + gstn + "^" + "LineHash");

			// ************************************

			// Collection of data for challan tab
			// Method call for retrieving the values of challan
			challandetails = retrievedChallanValues();
			// **********************************************
			formdetails.add(System.getProperty("line.separator"));
			formdetails.add(challandetails);
			// ************************************

			// Collection of data for the annI tab
			annIdetails = retrievedAnnIValues();

			formdetails.add(annIdetails);
			// ************************************

			// ***************************************
			// Collection of data for annII tab
			if ("24Q".equals(formNumber)
					&& "Q4".equals(jComboBox_Quarter.getSelectedItem()
							.toString())) {
				annIIdetails = retrievedAnnIIValues();
				formdetails.add(annIIdetails);
			}
			// *************************************
		}
		/*else if ("Correction".equals(valueOfTypeOfStmt)) {
			// Collection of data for the BH header
			// Method call for retrieving the values from the form
			retrievedFormValues();
			// ************************************************
			formdetails.append("0^" + linenumber + "^BH^1^" + formNumber + "^"
					+ quarter + "^" + correctiontype + "^" + prevtoken + "^"
					+ orgtoken + "^" + tan + "^" + lasttan + "^" + pan + "^"
					+ isrevised + "^" + updateDD + "^" + finyear + "^"
					+ assyear + "^" + typeofDD + "^" + lastDD + "^" + dedname
					+ "^" + dedbranch + "^" + dedstateone + "^" + paocode + "^"
					+ paoregnm + "^" + flatno + "^" + area + "^" + road + "^"
					+ dedpin + "^" + dedtelstd + "^" + dedtel + "^"
					+ dedalttelstd + "^" + dedalttel + "^" + dedain + "^"
					+ dedminstrydept + "^" + dedminstrydeptothers + "^"
					+ ddocode + "^" + ddoregnm + "^" + tanregnm + "^"
					+ dedbldgname + "^" + dedtown + "^" + dedstatetwo + "^"
					+ dedemail + "^" + dedemailalt + "^" + hasaddchanged + "^"
					+ rpname + "^" + rpdesig + "^" + rpflatno + "^" + rpbuldg
					+ "^" + rproad + "^" + rptelnumstd + "^" + rptelnum + "^"
					+ rptelnumaltstd + "^" + rptelnumalt + "^"
					+ rpisaddresschng + "^" + rprecieptnm + "^" + rparea + "^"
					+ rptown + "^" + rpstate + "^" + rppin + "^" + rpemail
					+ "^" + rpemailalt + "^" + rpmobile + "^"
					+ rpisregstatement + "^" + "CONS^" + filehash + "^"
					+ "LineHash");
			// ************************************

			// Collection of data for challan tab
			// Method call for retrieving the values of challan
			challandetails = retrievedChallanValues();
			// **********************************************
			formdetails.append(System.getProperty("line.separator"));
			formdetails.append(challandetails);
			// ************************************

			// Collection of data for the annI tab
			annIdetails = retrievedAnnIValues();
			formdetails.append(annIdetails);
			// ************************************

			// ***************************************
			// Collection of data for annII tab
			if ("24Q".equals(formNumber)
					&& "Q4".equals(jComboBox_Quarter.getSelectedItem()
							.toString())) {
				annIIdetails = retrievedAnnIIValues();
				formdetails.append(annIIdetails);
			}
			// *************************************
		}*/

		//New dev for ver1.3 added by Akansha

		if (!"--Select--".equals(quarter) && !"".equals(tan.trim())
				&& !new Validations().checkTan(tan)) {
			String Filename = tan + "_" + formNumber + "_"
					+ finyear.substring(0, 4)
					+ finyear.substring(finyear.length() - 2, finyear.length())
					+ "_" + quarter;
			System.out.println("Save in open: "+ formdetails.size());
			//new development for FRD1.3 by Akansha
			new Validations().showSaveFileDialogReg(formdetails, Filename);
			mainObject.filename = "";
			if (mainObject.txtErrorFilePath != null)
				mainObject.txtErrorFilePath.setText("");
			if (mainObject.consFileName != null)
				mainObject.consFileName.setText("");
			if (mainObject.txtCINFileName != null)
				mainObject.txtCINFileName.setText("");
			//**************************************
			//formdetails.clear();
		}else if("--Select--".equals(quarter) && "".equals(tan.trim()) && "--Select--".equals(finyear))
			getMessage("<html>Please select financial year,quarter and TAN <br> before saving the file</html>");
		else if("--Select--".equals(quarter) && "".equals(tan.trim()) && !"--Select--".equals(finyear))
			getMessage("Please select quarter and TAN before saving the file");
		else if(!"--Select--".equals(quarter) && "".equals(tan.trim()) && !"--Select--".equals(finyear))
			getMessage("Please enter TAN before saving the file");
		else if(!"--Select--".equals(quarter) && !"".equals(tan.trim()) && !"--Select--".equals(finyear) && new Validations().checkTan(tan))
			getMessage("Please enter valid TAN before saving the file");
	}

	//****************************************************

	//created new method for emrgency backup on 11/01/17
	/*public void  backupFile() {
		linenumber = 1;
		String challandetails = "";
		ArrayList<Object> annIdetails = null;
		String annIIdetails = "";
		mainObject.contentPanel.setCursor(Cursor
				.getPredefinedCursor(Cursor.WAIT_CURSOR));
		if ("Regular".equals(valueOfTypeOfStmt)) {

			retrievedFormValues();

			formdetails.clear();
			formdetails.add("0^" + linenumber + "^BH^1^" + formNumber + "^"
					+ quarter + "^" + correctiontype + "^" + prevtoken + "^"
					+ orgtoken + "^" + tan + "^" + lasttan + "^" + pan + "^"
					+ isrevised + "^" + updateDD + "^" + finyear + "^"
					+ assyear + "^" + typeofDD + "^" + lastDD + "^" + dedname
					+ "^" + dedbranch + "^" + dedstateone + "^" + paocode + "^"
					+ paoregnm + "^" + flatno + "^" + area + "^" + road + "^"
					+ dedpin + "^" + dedtelstd + "^" + dedtel + "^"
					+ dedalttelstd + "^" + dedalttel + "^" + dedain + "^"
					+ dedminstrydept + "^" + dedminstrydeptothers + "^"
					+ ddocode + "^" + ddoregnm + "^" + tanregnm + "^"
					+ dedbldgname + "^" + dedtown + "^" + dedstatetwo + "^"
					+ dedemail + "^" + dedemailalt + "^" + hasaddchanged + "^"
					+ rpname + "^" + rpdesig + "^" + rpflatno + "^" + rpbuldg
					+ "^" + rproad + "^" + rptelnumstd + "^" + rptelnum + "^"
					+ rptelnumaltstd + "^" + rptelnumalt + "^"
					+ rpisaddresschng + "^" + rprecieptnm + "^" + rparea + "^"
					+ rptown + "^" + rpstate + "^" + rppin + "^" + rpemail
					+ "^" + rpemailalt + "^" + rpmobile + "^"
					+ rpisregstatement + "^" + "LineHash");

			challandetails = retrievedChallanValues();
			formdetails.add(System.getProperty("line.separator"));

			formdetails.add(challandetails);

			annIdetails = retrievedAnnIValues();

			if ("24Q".equals(formNumber)
					&& "Q4".equals(jComboBox_Quarter.getSelectedItem()
							.toString())) {
				annIIdetails = retrievedAnnIIValues();
				formdetails.add(annIIdetails);
			}
		} else if ("Correction".equals(valueOfTypeOfStmt)) {

			retrievedFormValues();

			formdetails.clear();

			formdetails.add("0^" + linenumber + "^BH^1^" + formNumber + "^"
					+ quarter + "^" + correctiontype + "^" + prevtoken + "^"
					+ orgtoken + "^" + tan + "^" + lasttan + "^" + pan + "^"
					+ isrevised + "^" + updateDD + "^" + finyear + "^"
					+ assyear + "^" + typeofDD + "^" + lastDD + "^" + dedname
					+ "^" + dedbranch + "^" + dedstateone + "^" + paocode + "^"
					+ paoregnm + "^" + flatno + "^" + area + "^" + road + "^"
					+ dedpin + "^" + dedtelstd + "^" + dedtel + "^"
					+ dedalttelstd + "^" + dedalttel + "^" + dedain + "^"
					+ dedminstrydept + "^" + dedminstrydeptothers + "^"
					+ ddocode + "^" + ddoregnm + "^" + tanregnm + "^"
					+ dedbldgname + "^" + dedtown + "^" + dedstatetwo + "^"
					+ dedemail + "^" + dedemailalt + "^" + hasaddchanged + "^"
					+ rpname + "^" + rpdesig + "^" + rpflatno + "^" + rpbuldg
					+ "^" + rproad + "^" + rptelnumstd + "^" + rptelnum + "^"
					+ rptelnumaltstd + "^" + rptelnumalt + "^"
					+ rpisaddresschng + "^" + rprecieptnm + "^" + rparea + "^"
					+ rptown + "^" + rpstate + "^" + rppin + "^" + rpemail
					+ "^" + rpemailalt + "^" + rpmobile + "^"
					+ rpisregstatement + "^" + "CONS^" + filehash + "^"
					+ annexIIcount + "^" + "LineHash");

			challandetails = retrievedChallanValues();
			formdetails.add(System.getProperty("line.separator"));
			formdetails.add(challandetails);
			annIdetails = retrievedAnnIValues();
			formdetails.add(annIdetails);

			if ("24Q".equals(formNumber)
					&& "Q4".equals(jComboBox_Quarter.getSelectedItem()
							.toString())) {
				annIIdetails = retrievedAnnIIValues();
				formdetails.add(annIIdetails);
			}
		}

		//create backup file:
		File f = new File("backupFile");
		FileOutputStream outFile = null;
		boolean isFileExist = false;
		System.out.println(f);
		isFileExist = f.exists();

		try {
			outFile = new FileOutputStream(f);
			if (isFileExist) {
				f.delete();
			}
			BufferedWriter out = new BufferedWriter(new FileWriter(f));
			for (Object x : formdetails) {
				if (x != null)
					out.write(x.toString());
			}
			out.close();

		} catch (Exception e) {
			System.out.println(e);
		} finally {
			try {
				outFile.flush();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			try {
				outFile.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			outFile = null;
			System.gc();
		}
	}*/

	/*********************************************************************/

	// Added by Akansha
	// Method for saving the contents of the file
	//String builder changed to arraylist<object>
	public void savefile() {
		linenumber = 1;
		
		//	ArrayList<Object> formdetails = new ArrayList<Object>();
		//StringBuilder formdetails1 = new StringBuilder("");
		String challandetails = "";
		ArrayList<Object> annIdetails = null;
		String annIIdetails = "";
		mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));		
		if ("Regular".equals(valueOfTypeOfStmt)) {

			// Collection of data for the BH header
			// Method call for retrieving the values from the form
			retrievedFormValues();
			// ************************************************
			//clearing the formdetails ArrayList
			formdetails.clear();
			//*********************************

			formdetails.add("0^" + linenumber + "^BH^1^" + formNumber + "^"
					+ quarter + "^" + correctiontype + "^" + prevtoken + "^"
					+ orgtoken + "^" + tan + "^" + lasttan + "^" + pan + "^"
					+ isrevised + "^" + updateDD + "^" + finyear + "^"
					+ assyear + "^" + typeofDD + "^" + lastDD + "^" + dedname
					+ "^" + dedbranch + "^" + dedstateone + "^" + paocode + "^"
					+ paoregnm + "^" + flatno + "^" + area + "^" + road + "^"
					+ dedpin + "^" + dedtelstd + "^" + dedtel + "^"
					+ dedalttelstd + "^" + dedalttel + "^" + dedain + "^"
					+ dedminstrydept + "^" + dedminstrydeptothers + "^"
					+ ddocode + "^" + ddoregnm + "^" + tanregnm + "^"
					+ dedbldgname + "^" + dedtown + "^" + dedstatetwo + "^"
					+ dedemail + "^" + dedemailalt + "^" + hasaddchanged + "^"
					+ rpname + "^" + rpdesig + "^" + rpflatno + "^" + rpbuldg
					+ "^" + rproad + "^" + rptelnumstd + "^" + rptelnum + "^"
					+ rptelnumaltstd + "^" + rptelnumalt + "^"
					+ rpisaddresschng + "^" + rprecieptnm + "^" + rparea + "^"
					+ rptown + "^" + rpstate + "^" + rppin + "^" + rpemail
					+ "^" + rpemailalt + "^" + rpmobile + "^"
					+ rpisregstatement + "^" + gstn + "^" + "LineHash");

			// ************************************

			// Collection of data for challan tab
			// Method call for retrieving the values of challan
			//			System.out.println("In time for challan:"+System.currentTimeMillis());
			challandetails = retrievedChallanValues();
			//			System.out.println("Out time for challan:"+System.currentTimeMillis());
			// **********************************************
			formdetails.add(System.getProperty("line.separator"));

			formdetails.add(challandetails);

			// ************************************

			// Collection of data for the annI tab
			//			System.out.println("In time for AnneI:"+System.currentTimeMillis());
			annIdetails = retrievedAnnIValues();
				System.out.println("Out time for AnneI:"+System.currentTimeMillis()+"details"+ annIdetails );
			//formdetails.add(annIdetails);
			// ************************************

			// ***************************************
			// Collection of data for annII tab
			if ("24Q".equals(formNumber)
					&& "Q4".equals(jComboBox_Quarter.getSelectedItem()
							.toString())) {
				annIIdetails = retrievedAnnIIValues();
				formdetails.add(annIIdetails);
			}
			// *************************************
		} else if ("Correction".equals(valueOfTypeOfStmt)) {
			// Collection of data for the BH header
			// Method call for retrieving the values from the form
			retrievedFormValues();
			// ************************************************
			//clearing the formdetails ArrayList
			formdetails.clear();
			//*********************************
			//new development for FRD1.5 by Akansha
			// added annexure II expected row count for the retrieval of number of rows
			//imported during .tds file opening
			System.out.println("State code change ="+dedstatetwo);
			formdetails.add("0^" + linenumber + "^BH^1^" + formNumber + "^"
					+ quarter + "^" + correctiontype + "^" + prevtoken + "^"
					+ orgtoken + "^" + tan + "^" + lasttan + "^" + pan + "^"
					+ isrevised + "^" + updateDD + "^" + finyear + "^"
					+ assyear + "^" + typeofDD + "^" + lastDD + "^" + dedname
					+ "^" + dedbranch + "^" + dedstateone + "^" + paocode + "^"
					+ paoregnm + "^" + flatno + "^" + area + "^" + road + "^"
					+ dedpin + "^" + dedtelstd + "^" + dedtel + "^"
					+ dedalttelstd + "^" + dedalttel + "^" + dedain + "^"
					+ dedminstrydept + "^" + dedminstrydeptothers + "^"
					+ ddocode + "^" + ddoregnm + "^" + tanregnm + "^"
					+ dedbldgname + "^" + dedtown + "^" + dedstatetwo + "^"
					+ dedemail + "^" + dedemailalt + "^" + hasaddchanged + "^"
					+ rpname + "^" + rpdesig + "^" + rpflatno + "^" + rpbuldg
					+ "^" + rproad + "^" + rptelnumstd + "^" + rptelnum + "^"
					+ rptelnumaltstd + "^" + rptelnumalt + "^"
					+ rpisaddresschng + "^" + rprecieptnm + "^" + rparea + "^"
					+ rptown + "^" + rpstate + "^" + rppin + "^" + rpemail
					+ "^" + rpemailalt + "^" + rpmobile + "^"
					+ rpisregstatement + "^" + "CONS^" + filehash + "^"
					+ annexIIcount + "^" + gstn + "^" + "LineHash");
			// ************************************

			// Collection of data for challan tab
			// Method call for retrieving the values of challan
			challandetails = retrievedChallanValues();
			// **********************************************
			formdetails.add(System.getProperty("line.separator"));
			formdetails.add(challandetails);
			// ************************************

			// Collection of data for the annI tab
			annIdetails = retrievedAnnIValues();
			formdetails.add(annIdetails);
			// ************************************

			// ***************************************
			// Collection of data for annII tab
			if ("24Q".equals(formNumber)
					&& "Q4".equals(jComboBox_Quarter.getSelectedItem()
							.toString())) {
				annIIdetails = retrievedAnnIIValues();
				formdetails.add(annIIdetails);
			}
			// *************************************
		}

		//New dev for ver1.3 added by Akansha

		if (!"--Select--".equals(quarter) && !"".equals(tan.trim()) && !new Validations().checkTan(tan)){
			String Filename = tan +"_"+ formNumber+"_"+finyear.substring(0,4)+finyear.substring(finyear.length()-2,finyear.length())+"_"+quarter;
			mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));		
			new Validations().showSaveFileDialog(formdetails, Filename,mainObject);
			mainObject.filename = "";
			if(mainObject.txtErrorFilePath!=null)
				mainObject.txtErrorFilePath.setText("");
			if(mainObject.consFileName!=null)
				mainObject.consFileName.setText("");
			if(mainObject.txtCINFileName!=null)
				mainObject.txtCINFileName.setText("");
			formdetails.clear();
			System.out.println("After first save file size: "+ formdetails.size());

		}else if("--Select--".equals(quarter) && "".equals(tan.trim()) && "--Select--".equals(finyear)){
			mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));		
			getMessage("<html>Please select financial year,quarter and TAN <br> before saving the file</html>");
		}
		else if("--Select--".equals(quarter) && "".equals(tan.trim()) && !"--Select--".equals(finyear)){
			mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));		
			getMessage("Please select quarter and TAN before saving the file");
		}else if(!"--Select--".equals(quarter) && "".equals(tan.trim()) && !"--Select--".equals(finyear)){
			mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));		
			getMessage("Please enter TAN before saving the file");
		}else if(!"--Select--".equals(quarter) && !"".equals(tan.trim()) && !"--Select--".equals(finyear) && new Validations().checkTan(tan)){
			mainObject.contentPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));		
			getMessage("Please enter valid TAN before saving the file");
		}

	}

	// *******************************************

	// Added by Akansha
	// This method helps in retreival of all the form values required for saving
	public void retrievedFormValues() {
		// First panel of the form
		correctiontype = "A";
		quarter = jComboBox_Quarter.getSelectedItem().toString();
		prevtoken = jText_Form_Sub1_Previous_Receipt_num.getText();
		orgtoken = jText_Form_Sub1_Org_Receipt_Num.getText();
		tan = jText_Form_Sub1_Tan.getText();
		lasttan = jText_Form_Sub1_LastTan.getText();
		pan = jText_Form_Sub1_Pan.getText();
		isrevised = jText_Form_Sub1_isRevised.getText();
		updateDD = JComboBox_Form_Sub1_Update_deductor.getSelectedIndex() + "";
		finyear = JComboBox_Form_Sub1_finYear.getSelectedItem().toString();
		assyear = jText_Form_Sub1_AssessmentYear.getText();
		typeofDD = JComboBox_Form_Sub1_Type_of_Deductor.getSelectedIndex() + "";
		lastDD = GrpuUtil.getDeductorCode(jText_Form_Sub1_Last_Deductor_Type
				.getText());
		// **********************************

		// Second panel of the form
		dedname = jText_Form_Sub2_Name.getText();
		dedbranch = jText_Form_Sub2_Branch.getText();
		dedstateone = GrpuUtil.getStateCode(jComboBox_Form_Sub2_State.getSelectedItem().toString());
		paocode = jText_Form_Sub2_PAO_Code.getText();
		paoregnm = jText_Form_Sub2_PAO_regNum.getText();
		flatno = jText_Form_Sub2_FlatNo.getText();
		area = jText_Form_Sub2_Area.getText();
		road = jText_Form_Sub2_Road.getText();
		dedpin = jText_Form_Sub2_PinCode.getText();
		dedtelstd = jText_Form_Sub2_TelNum_Std_Code.getText();
		dedtel = jText_Form_Sub2_TelNum.getText();
		dedalttelstd = jText_Form_Sub2_AlternateTelNum_Std_Code.getText();
		dedalttel = jText_Form_Sub2_AlternateTelNum.getText();
		dedain = jText_Form_Sub2_AIN.getText();
		dedminstrydept = JComboBox_Form_Sub2_MinistryName.getSelectedIndex()
				+ "";
		dedminstrydeptothers = jText_Form_Sub2_MinistryName_Other.getText();
		ddocode = jText_Form_Sub2_DDO_Code.getText();
		ddoregnm = jText_Form_Sub2_DDO_RegNum.getText();
		tanregnm = jText_Form_Sub2_TAN_RegNum.getText();
		dedbldgname = jText_Form_Sub2_BuildingName.getText();
		dedtown = jText_Form_Sub2_Town.getText();
		dedstatetwo = GrpuUtil.getStateCode(jComboBox_AOState.getSelectedItem()
				.toString());
		dedemail = jText_Form_Sub2_Email.getText();
		dedemailalt = jText_Form_Sub2_Email_Alternate.getText();
		hasaddchanged = jComboBox_Form_Sub2_isAddressChanged.getSelectedIndex()
				+ "";
		gstn = jText_Form_Sub2_GSTN.getText();

		// ***********************************

		// Third panel of the form
		rpname = jText_Form_Sub3_Name.getText();
		rpdesig = jText_Form_Sub3_Designation.getText();
		rpflatno = jText_Form_Sub3_FlatNum.getText();
		rpbuldg = jText_Form_Sub3_BuildingName.getText();
		rproad = jText_Form_Sub3_Road.getText();
		rptelnumstd = jText_Form_Sub3_TelNum_Std_Code.getText();
		rptelnum = jText_Form_Sub3_TelNum.getText();
		rptelnumaltstd = jText_Form_Sub3_TelNum_Alternate_Std_Code.getText();
		rptelnumalt = jText_Form_Sub3_TelNum_Alternate.getText();
		rpisaddresschng = jComboBox_Form_Sub3_isAddressChanged
				.getSelectedIndex() + "";
		rprecieptnm = jText_Form_Sub3_earlierReceiptNum.getText();
		rparea = jText_Form_Sub3_Area.getText();
		rptown = jText_Form_Sub3_Town.getText();
		rpstate = GrpuUtil.getStateCode(jComboBox_State_Name.getSelectedItem()
				.toString());
		rppin = jText_Form_Sub3_PinCode.getText();
		rpemail = jText_Form_Sub3_Email.getText();
		rpemailalt = jText_Form_Sub3_Email_Alternate.getText();

		//		System.out.println("ALTERNATE EMAIL R1 "
		//				+ jText_Form_Sub3_Email_Alternate.getText());
		//		System.out.println("ALTERNATE EMAIL D1 "
		//				+ jText_Form_Sub2_Email_Alternate.getText());

		rpmobile = jText_Form_Sub3_MobileNumber.getText();
		rpisregstatement = jComboBox_Form_Sub3_isRegularStatement
				.getSelectedIndex() + "";

		// ***********************************

	}

	// Added by Akansha
	// This method helps in retreival of all the challan values required for
	// saving
	public String retrievedChallanValues() {
		int filledrowNo[] = GrpuUtil.getFilledRows(model);
		int tabrow = 0;
		int tabcol = 0;
		int count = 0;
		StringBuilder challan = new StringBuilder("");
		ChallanCount = new Integer((model.getRowCount()) - 2).toString();
		linenumber++;
		for (tabrow = 0; tabrow < model.getRowCount(); tabrow++) {

			if (tabrow == 0 || tabrow == 1)
				continue;

			if (filledrowNo[tabrow] < 0)
				continue;
			count = tabrow - 1;
			challan.append("0^" + linenumber + "^CD^" + "1");
			for (tabcol = 2; tabcol <= 22; tabcol++) {
				Object tabval = model.getValueAt(tabrow, tabcol);
				if (tabval != null)
					challan.append("^" + tabval);
				else {
					tabval = "";
					challan.append("^" + tabval);
				}

			}

			if ("Correction".equals(valueOfTypeOfStmt)) {
				challan.append("^" + model.getValueAt(tabrow, 1));
				if (challantype.length() > (tabrow - 2))
					challan.append("^" + challantype.charAt(tabrow - 2));
				//new development for FRD1.3 by Akansha
				//new development for FRD1.5 by Akansha
				if(!"ADD".equals(model.getValueAt(tabrow, 1))){
					if(annexIcount.size()>(tabrow-1))
						challan.append("^"+ annexIcount.get((tabrow-1)).toString());
				}
				//***********************************
				challan.append("^LineHash");
			} else {
				challan.append("^LineHash");
			}
			challan.append(System.getProperty("line.separator"));

			linenumber++;
		}
		return challan.toString();
	}

	// *********************************************************

	// Added by Akansha
	// This method helps in retreival of all the annI values required for saving
	public ArrayList<Object> retrievedAnnIValues() { 
		int filledrowNo[] = null;
		int colcount = 0;
		if ("24Q".equals(formNumber)) {
			filledrowNo = GrpuUtil.getFilledRowsAnnI(model1,
					TABLE_COLUMN_COUNT_annI_24Q - 1);
			colcount = TABLE_COLUMN_COUNT_annI_24Q;
		} else if ("26Q".equals(formNumber)) {
			filledrowNo = GrpuUtil.getFilledRowsAnnI(model1,
					TABLE_COLUMN_COUNT_annI_26Q - 1);
			colcount = TABLE_COLUMN_COUNT_annI_26Q;
		} else if ("27Q".equals(formNumber)) {
			filledrowNo = GrpuUtil.getFilledRowsAnnI(model1,
					TABLE_COLUMN_COUNT_annI_27Q - 1);
			colcount = TABLE_COLUMN_COUNT_annI_27Q;
			System.out.println("row colum"+filledrowNo+colcount);
			
		} else if ("27EQ".equals(formNumber)) {
			filledrowNo = GrpuUtil.getFilledRowsAnnI(model1,
					TABLE_COLUMN_COUNT_annI_27EQ - 1);
			colcount = TABLE_COLUMN_COUNT_annI_27EQ;
		}
		int tabrow = 0;
		int tabcol = 0;
		int count = 0;
		Object tabval = new Object();

		//ArrayList<Object> annI = new ArrayList<Object>();
		for (tabrow = 0; tabrow < model1.getRowCount(); tabrow++) {
			StringBuilder annI = new StringBuilder("");
			if (tabrow == 0 || tabrow == 1)
				continue;

			if (filledrowNo[tabrow] < 0)
				continue;
			count = tabrow + 1;
			annI.append("0^" + linenumber + "^DD^" + "1");
			System.out.println("Column Count in AnneI: "+colcount);
			for (tabcol = 1; tabcol < colcount - 1; tabcol++) {

				tabval = model1.getValueAt(tabrow, tabcol);
				
				if (tabval != null){
					//annI.append("^" + tabval);
					if(tabval.equals("194IC")){
						annI.append("^" + "4IC");
					}
					//Section Code changes for RPU 2.9
					
					else{
						annI.append("^" + tabval);
				
						
					}
				}
				else {
					//tabval = "";
					//annI.add("^" + tabval); // new development for FRD1.3 by Akansha
					annI.append("^");
				}

			}
			//RPU 3.1 to append last blank 4 fillers in saved file
			annI.append("^^");//annI.append("^^^^");
			//RPU 3.4 removed two appenders as two new columns added
			//System.out.println("pan_Updtn_Indicator" + "".equals(pan_Updtn_Indicator));
			//rpu 3.1 start to checl if its not empty  && pan_Updtn_Indicator.size()>0
			if (pan_Updtn_Indicator != null && pan_Updtn_Indicator.size()>0
					&& "Correction".equals(valueOfTypeOfStmt)
					&& !"ADD".equals(model1.getValueAt(tabrow, 2))) {
				annI.append("^" + pan_Updtn_Indicator.get(tabrow - 2) + "^");
				if(LastPanRefNo.size()>(tabrow -2))
					annI.append(LastPanRefNo.get(tabrow - 2) + "^");
				else
					annI.append("^");
				annI.append(LastIncomeTax.get(tabrow - 2) + "^");
				annI.append(LastSurcharge.get(tabrow - 2) + "^");
				annI.append(LastEduCess.get(tabrow - 2));
				//new development for FRD1.3 by Akansha
				if (pancheckfag.length() > (tabrow - 2))
					annI.append("^" + pancheckfag.charAt(tabrow - 2));

				// new development for newly appended value "F", FRD1.9 on 18/01/17
				if (strAnnexIColValue.length() > (tabrow - 2))
					annI.append("^" + strAnnexIColValue.charAt(tabrow - 2));


			} else
				annI.append("^");
			
			annI.append("^LineHash");
			annI.append(System.getProperty("line.separator"));
			linenumber++;
			System.out.println("AnnI value:"+annI.toString());
			formdetails.add(annI.toString());
			System.out.println("Size of appender: "+ annI.length());
			annI.setLength(0);

		}

		return null;
	}

	// *********************************************************

	// Added by Akansha
	// This method helps in retreival of all the challan values required for
	// saving
	public String retrievedAnnIIValues() {
		StringBuilder annII = new StringBuilder("");
		if (model2 != null) {
			int filledrowNo[] = GrpuUtil.getFilledRowsAnnII(model2,
					TABLE_COLUMN_COUNT_annII - 2);
			int tabrow = 0;
			int tabcol = 0;
			int count = 0;

			for (tabrow = 0; tabrow < model2.getRowCount(); tabrow++) {

				if (tabrow == 0 || tabrow == 1)
					continue;

				if (filledrowNo[tabrow] < 0)
					continue;
				count = tabrow - 1;
				annII.append("0^" + linenumber + "^SD^" + "1");
				for (tabcol = 2; tabcol < TABLE_COLUMN_COUNT_annII - 1; tabcol++) {

					Object tabval = model2.getValueAt(tabrow, tabcol);
					/*	if (tabval != null)
						annII.append("^" + tabval);
					else {
						tabval = "";
						annII.append("^" + tabval);
					}*/
					// new development for newly appended value "F", FRD1.9 on 02/02/17
					if(tabcol == 34 || tabcol == 36 || tabcol == 38 || tabcol == 40 || tabcol == 43 || tabcol == 45 || tabcol == 47 || tabcol == 49){
						if(tabval.equals("Payment made to Government organization (Central/State only)")){
							tabval = "GOVERNMENT";
						}else if(tabval.equals("Payment made to Non-resident")){
							tabval = "NONRESDENT";
						}else if(tabval.equals("Payment made to Other than Government organization and Non-resident")){
							tabval = "OTHERVALUE";
						}
						else
						{
							tabval = tabval;
						}
						annII.append("^" + tabval);
					}else if (tabval != null)
						annII.append("^" + tabval);
					else {
						tabval = "";
						annII.append("^" + tabval);
					}

				}
				if (pan_Updtn_Indicator_Anne2 != null
						&& "Correction".equals(valueOfTypeOfStmt)
						&& !"Add".equals(model2.getValueAt(tabrow, 2))) { 
					annII.append("^"
							+ pan_Updtn_Indicator_Anne2.get(tabrow - 2));
				} else
					annII.append("^");
				annII.append("^"+ model2.getValueAt(tabrow, 1));
				if (pan_Updtn_Indicator_Anne2 != null
						&& "Correction".equals(valueOfTypeOfStmt)
						&& !"Add".equals(model2.getValueAt(tabrow, 2))) {
					//new development for FRD1.5 by Akansha
					if (pancheckfagAnne2.length() > (tabrow - 2))
						annII.append("^" + pancheckfagAnne2.charAt(tabrow - 2));


					// new development for newly appended value "F", FRD1.9 on 18/01/17
					if (strAnnexIIColValue.length() > (tabrow - 2))
						annII.append("^" + strAnnexIIColValue.charAt(tabrow - 2));
				}else
					annII.append("^");
				if("Add".equals(model2.getValueAt(tabrow, 2))){
					if (strAnnexIIColValue.length() > (tabrow - 2))
						//System.out.println("value of strAnnexIIColValue when saving file = "+strAnnexIIColValue);
						annII.append("^" + strAnnexIIColValue.charAt(tabrow - 2));
				}
				annII.append("^LineHash");
				annII.append(System.getProperty("line.separator"));
				linenumber++;
			}
		}
		return annII.toString();
	}

	// *********************************************************

	// start her

	public void setTotalTaxDepvalue(String val, int row, int col) {

		// added by akansha
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		// end akansha

		if (model.getValueAt(row, 10) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//System.out.println("pheli bar");
					double cur_val = Double.parseDouble(val);
					model.setValueAt(df.format(cur_val), row, 10);
				}
			}

		}
		if (model.getValueAt(row, 10) != null) {
			if (val != null) {
				if (!val.equals("")) {
					if (col == 2) // Tds Column is selected
					{

						td = Double.parseDouble(val);

						//System.out.println("shaa is " + td);
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = td + col4 + col5 + col6 + col7 + col8;

						//System.out.println("shatotal; is " + s3);
						model.setValueAt(df.format(s3), row, 10);
						if ((df.format(s3)).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 3)// Surcharge is selected
					{
						sur = Double.parseDouble(val);

						//	System.out.println("shaa sur is " + sur);
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = sur + col3 + col5 + col6 + col7 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 4)// Education Cess is Selected is selected
					{
						eduCess = Double.parseDouble(val);
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = eduCess + col3 + col4 + col6 + col7 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 5)// Interest is selected
					{
						interest = Double.parseDouble(val);
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = interest + col3 + col4 + col5 + col7 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 6)// Fee is selected
					{
						fee = Double.parseDouble(val);
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = fee + col3 + col4 + col5 + col6 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 7)// Others is selected
					{
						others = Double.parseDouble(val);
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						s3 = others + col3 + col4 + col5 + col7 + col6;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

				}

				else {

					if (col == 2) // Tds Column is selected
					{
						td = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = td + col4 + col5 + col6 + col7 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}
					}

					if (col == 3)// Surcharge is selected
					{
						sur = 0;
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = sur + col3 + col5 + col6 + col7 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 4)// Education Cess is Selected is selected
					{
						eduCess = 0;
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = eduCess + col3 + col4 + col6 + col7 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 5)// Interest is selected
					{
						interest = 0;
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = interest + col3 + col4 + col5 + col7 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 6)// Fee is selected
					{
						fee = 0;
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						if (model.getValueAt(row, 8) != null
								&& (!"".equals(model.getValueAt(row, 8)))) {
							col8 = Double.parseDouble(model.getValueAt(row, 8)
									.toString());

						} else
							col8 = 0;

						s3 = fee + col3 + col4 + col5 + col6 + col8;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

					if (col == 7)// Others is selected
					{
						others = 0;
						if (model.getValueAt(row, 3) != null
								&& (!"".equals(model.getValueAt(row, 3)))) {
							col3 = Double.parseDouble(model.getValueAt(row, 3)
									.toString());

						} else
							col3 = 0;
						if (model.getValueAt(row, 4) != null
								&& (!"".equals(model.getValueAt(row, 4)))) {
							col4 = Double.parseDouble(model.getValueAt(row, 4)
									.toString());

						} else
							col4 = 0;

						if (model.getValueAt(row, 5) != null
								&& (!"".equals(model.getValueAt(row, 5)))) {
							col5 = Double.parseDouble(model.getValueAt(row, 5)
									.toString());

						} else
							col5 = 0;

						if (model.getValueAt(row, 7) != null
								&& (!"".equals(model.getValueAt(row, 7)))) {
							col7 = Double.parseDouble(model.getValueAt(row, 7)
									.toString());

						} else
							col7 = 0;

						if (model.getValueAt(row, 6) != null
								&& (!"".equals(model.getValueAt(row, 6)))) {
							col6 = Double.parseDouble(model.getValueAt(row, 6)
									.toString());

						} else
							col6 = 0;

						s3 = others + col3 + col4 + col5 + col7 + col6;
						model.setValueAt(df.format(s3), row, 10);
						if (df.format(s3).length() > 15) {
							GRPU.grpu
							.getMessage("Total length of Total Amount Deposited as per challan fiel can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model.setValueAt("", row, 10);

						}

					}

				}

			}

		}

		totalTaxDepBookEntryFlag(String.valueOf(s3), row, col);
	}

	public void lastTotalTaxDepstd(String val, int row, int col) {
		if (val != null) {
			if (!val.equals("")) {
				//System.out.println("pheli bar yahan pe aayya");
				double cur_val = Double.parseDouble(val);
				model1.setValueAt(cur_val, row, 24);

			}

			else
				model1.setValueAt("", row, 24);

		}

	}

	// $$ New development for RPU Java Ver1.2
	public void setInterestAllctd(String val, int row, int col) {
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if (val != null) {
			if (!val.equals("")) {

				double cur_val = Double.parseDouble(val);
				model.setValueAt(df.format(cur_val), row, 19);

			}

			else
				model.setValueAt("0.00", row, 19);

		}

	}

	// ***

	// new development for FRD1.3 by Akansha
	public void setTaxDeposited(String val, int row, int col) {
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if (val != null) {
			if (!val.equals("")) {

				double cur_val = Double.parseDouble(val);
				model1.setValueAt(df.format(cur_val), row, 23);

			}

			else
				model1.setValueAt("0.00", row, 23);

		}

	}

	//RPU 3.1 start
	public void setAmtCshWdrawS194N(String val, int row, int col) {
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
		DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if("26Q".equals(formNumber))
		{
		if (val != null  && "94N".equals(model1.getValueAt(row, 6))) {
			if (!val.equals("")) {
				double cur_val = Double.parseDouble(val);
				model1.setValueAt(df.format(cur_val), row, 31);
			}
			else
				model1.setValueAt("0.00", row, 31);
						}
		}
		else if("27Q".equals(formNumber))
		{
		if (val != null  && "94N".equals(model1.getValueAt(row, 6))) {
			if (!val.equals("")) {
				double cur_val = Double.parseDouble(val);
				model1.setValueAt(df.format(cur_val), row, 40);
			}
			else
				model1.setValueAt("0.00", row, 40);
						}
		}

	}//RPU 3.4 start
	public void setAmtOfCshWdrawInExcessOfRs20lkhSbclause_a_194N(String val, int row, int col)
	{
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
		DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if("26Q".equals(formNumber))
		{
		if (val != null  && "4NF".equals(model1.getValueAt(row, 6))) {
			if (!val.equals("")) {
				double cur_val = Double.parseDouble(val);
				model1.setValueAt(df.format(cur_val), row, 32);
			}
			else
				//model1.setValueAt("0.00", row, 32);
				model1.setValueAt("", row, 32);
						}
		}
		else if("27Q".equals(formNumber))
		{
		if (val != null  && "4NF".equals(model1.getValueAt(row, 6))) {
			if (!val.equals("")) {
				double cur_val = Double.parseDouble(val);
				model1.setValueAt(df.format(cur_val), row, 41);
			}
			else
				model1.setValueAt("0.00", row, 41);
						}
		}
	}
	public void setAmtOfCshWdrawInExcessOfRs20lkhSbclause_b_194N(String val, int row, int col)
	{
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
		DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if("26Q".equals(formNumber))
		{
		if (val != null  && "4NF".equals(model1.getValueAt(row, 6))) {
			if (!val.equals("")) {
				double cur_val = Double.parseDouble(val);
				model1.setValueAt(df.format(cur_val), row, 33);
			}
			else
				model1.setValueAt("0.00", row, 33);
						}
		}
		else if("27Q".equals(formNumber))
		{
		if (val != null  && "4NF".equals(model1.getValueAt(row, 6))) {
			if (!val.equals("")) {
				double cur_val = Double.parseDouble(val);
				model1.setValueAt(df.format(cur_val), row, 42);
			}
			else
				model1.setValueAt("0.00", row, 42);
						}
		}
	}


	// Added By amit For annexure 2 Total Tax Dedcuted

	public void setTotalTaxDedcuted(String val, int row, int col) {
		double tds = 0;
		double sur = 0;
		double cess = 0;
		double totalTaxDepsted = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
		DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		if (model1.getValueAt(row, 21) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//System.out.println("pheli bar yahan pe aayya");
					double cur_val = Double.parseDouble(val);
					model1.setValueAt(cur_val, row, 21);
					model1.setValueAt(cur_val, row, 23); // new development for FRD1.3 by Akansha

				}
			}

		}
		if (model1.getValueAt(row, 21) != null) {
			if (val != null) {
				if (!val.equals("")) {
					if (col == 17) // Tds Column is selected
					{
						//						System.out
						//								.println("abhi yahan pe aaya in col8 value is"
						//										+ val);
						tds = Double.parseDouble(val);
						if (model1.getValueAt(row, 19) != null
								&& (!"".equals(model1.getValueAt(row, 19)))) {
							sur = Double.parseDouble(model1.getValueAt(row, 19)
									.toString());

						} else
							sur = 0;

						if (model1.getValueAt(row, 20) != null
								&& (!"".equals(model1.getValueAt(row, 20)))) {
							cess = Double.parseDouble(model1
									.getValueAt(row, 20).toString());

						} else
							cess = 0;

						totalTaxDepsted = tds + sur + cess;

						model1.setValueAt(df.format(totalTaxDepsted), row, 21);
						model1.setValueAt(df.format(totalTaxDepsted), row, 23); // new development for FRD1.3 by Akansha

						if ((df.format(totalTaxDepsted)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total tax deducted   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model1.setValueAt("", row, 21);

						}

					}
					if (col == 18) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						sur = Double.parseDouble(val);
						if (model1.getValueAt(row, 18) != null
								&& (!"".equals(model1.getValueAt(row, 18)))) {
							tds = Double.parseDouble(model1.getValueAt(row, 18)
									.toString());

						} else
							tds = 0;

						if (model1.getValueAt(row, 20) != null
								&& (!"".equals(model1.getValueAt(row, 20)))) {
							cess = Double.parseDouble(model1
									.getValueAt(row, 20).toString());

						} else
							cess = 0;

						totalTaxDepsted = tds + sur + cess;

						model1.setValueAt(df.format(totalTaxDepsted), row, 21);
						model1.setValueAt(df.format(totalTaxDepsted), row, 23); // new development for FRD1.3 by Akansha
						if ((df.format(totalTaxDepsted)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total tax deducted  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model1.setValueAt("", row, 21);

						}

					}

					if (col == 19) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						cess = Double.parseDouble(val);
						if (model1.getValueAt(row, 18) != null
								&& (!"".equals(model1.getValueAt(row, 18)))) {
							tds = Double.parseDouble(model1.getValueAt(row, 18)
									.toString());

						} else
							tds = 0;

						if (model1.getValueAt(row, 19) != null
								&& (!"".equals(model1.getValueAt(row, 19)))) {
							sur = Double.parseDouble(model1.getValueAt(row, 19)
									.toString());

						} else
							sur = 0;

						totalTaxDepsted = tds + sur + cess;
						model1.setValueAt(df.format(totalTaxDepsted), row, 21);
						model1.setValueAt(df.format(totalTaxDepsted), row, 23); // new development for FRD1.3 by Akansha
						if ((df.format(totalTaxDepsted)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total tax deducted  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model1.setValueAt("", row, 21);

						}

					}

				} // deleet yahan

				else {

					if (col == 17) // Tds Column is selected
					{
						//						System.out
						//								.println("abhi yahan pe aaya in col8 value is"
						//										+ val);
						tds = 0;
						if (model1.getValueAt(row, 19) != null
								&& (!"".equals(model1.getValueAt(row, 19)))) {
							sur = Double.parseDouble(model1.getValueAt(row, 19)
									.toString());

						} else
							sur = 0;

						if (model1.getValueAt(row, 20) != null
								&& (!"".equals(model1.getValueAt(row, 20)))) {
							cess = Double.parseDouble(model1
									.getValueAt(row, 20).toString());

						} else
							cess = 0;

						totalTaxDepsted = tds + sur + cess;

						model1.setValueAt(df.format(totalTaxDepsted), row, 21);
						model1.setValueAt(df.format(totalTaxDepsted), row, 23); // new development for FRD1.3 by Akansha
						if ((df.format(totalTaxDepsted)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total tax deducted   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model1.setValueAt("", row, 21);

						}

					}
					if (col == 18) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						sur = 0;
						if (model1.getValueAt(row, 18) != null
								&& (!"".equals(model1.getValueAt(row, 18)))) {
							tds = Double.parseDouble(model1.getValueAt(row, 18)
									.toString());

						} else
							tds = 0;

						if (model1.getValueAt(row, 20) != null
								&& (!"".equals(model1.getValueAt(row, 20)))) {
							cess = Double.parseDouble(model1
									.getValueAt(row, 20).toString());

						} else
							cess = 0;

						totalTaxDepsted = tds + sur + cess;

						model1.setValueAt(df.format(totalTaxDepsted), row, 21);

						if ((df.format(totalTaxDepsted)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total tax deducted  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model1.setValueAt("", row, 21);

						}

					}

					if (col == 19) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						cess = 0;
						if (model1.getValueAt(row, 18) != null
								&& (!"".equals(model1.getValueAt(row, 18)))) {
							tds = Double.parseDouble(model1.getValueAt(row, 18)
									.toString());

						} else
							tds = 0;

						if (model1.getValueAt(row, 19) != null
								&& (!"".equals(model1.getValueAt(row, 19)))) {
							sur = Double.parseDouble(model1.getValueAt(row, 19)
									.toString());

						} else
							sur = 0;

						totalTaxDepsted = tds + sur + cess;
						model1.setValueAt(df.format(totalTaxDepsted), row, 21);
						model1.setValueAt(df.format(totalTaxDepsted), row, 23); // new development for FRD1.3 by Akansha
						if ((df.format(totalTaxDepsted)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total tax deducted  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model1.setValueAt("", row, 21);

						}

					}

				} // idhartak

			}

		}

	}

	// End For Annexure 2 For Total Tax Dedcuted

	// Added BY Total Amount Dedcutible Under ChapterVIA

	/****************** Added for 2.7 Start ********************/

	public void setTotalAmountGrossSal(String val, int row, int col) {

		String finyear = JComboBox_Form_Sub1_finYear.getSelectedItem().toString();
		int fyear=0;
		fyear = Integer.parseInt(finyear.substring(0,4));

		if(fyear>=2018)
		{
			double grossSalaryAsPerSec17_1=0;
			double valueOfPerquisiteAsPerSec17_2=0;
			double profitsInLieuOfSalaryAsPerSec17_3=0;
			double totalGrossSal=0;


			DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
			df.setMaximumFractionDigits(2);
			if (model2.getValueAt(row, 8) == null) {
				if (val != null) {
					if (!val.equals("")) {
						//System.out.println("pheli bar yahan pe aayya val hai "
						//	+ val);
						double cur_val = Double.parseDouble(val);
						model2.setValueAt(cur_val, row, 8);
					}
				}

			}
			if (model2.getValueAt(row, 8) != null) {
				if (val != null) {
					// pranay 

					if (col == 58) // Tds Column is selected
					{
						if (!val.equals("")) 
							grossSalaryAsPerSec17_1 = Double.parseDouble(val);
						else
							grossSalaryAsPerSec17_1 = 0;
					}else
					{
						if (model2.getValueAt(row, 59) != null
								&& (!"".equals(model2.getValueAt(row, 59)))) // colunm59
						{
							grossSalaryAsPerSec17_1 = Double.parseDouble(model2.getValueAt(
									row, 59).toString());

						} else
							grossSalaryAsPerSec17_1 = 0;
					}

					if (col == 59) // Tds Column is selected
					{
						if (!val.equals("")) 
							valueOfPerquisiteAsPerSec17_2 = Double.parseDouble(val);
						else
							valueOfPerquisiteAsPerSec17_2 = 0;
					}else
					{
						if (model2.getValueAt(row, 60) != null
								&& (!"".equals(model2.getValueAt(row, 60)))) // colunm60
						{
							valueOfPerquisiteAsPerSec17_2 = Double.parseDouble(model2.getValueAt(
									row, 60).toString());

						} else
							valueOfPerquisiteAsPerSec17_2 = 0;
					}

					if (col == 60) // Tds Column is selected
					{
						if (!val.equals("")) 
							profitsInLieuOfSalaryAsPerSec17_3 = Double.parseDouble(val);
						else
							profitsInLieuOfSalaryAsPerSec17_3 = 0;
					}else
					{
						if (model2.getValueAt(row, 61) != null
								&& (!"".equals(model2.getValueAt(row, 61)))) // colunm63
						{
							profitsInLieuOfSalaryAsPerSec17_3 = Double.parseDouble(model2.getValueAt(
									row, 61).toString());

						} else
							profitsInLieuOfSalaryAsPerSec17_3 = 0;
					}



					totalGrossSal =grossSalaryAsPerSec17_1+ valueOfPerquisiteAsPerSec17_2+profitsInLieuOfSalaryAsPerSec17_3;
					model2.setValueAt(df.format(totalGrossSal), row, 8);
					if ((df.format(totalGrossSal)).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Total Amount of gross salary received from current employer can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						model2.setValueAt("", row, 8);

					}


				}

			}
		}

	}





	public void setTotalAmountOfExemption(String val, int row, int col) {

		double amountOfAnyOtherExemptionSec10=0;
		double travelConcession =0;
		double deathCumRetirementGratuity =0;
		double commutedValueOfPension=0;
		double cashEquivalentOfLeaveSalary=0;
		double hra=0;
		double totalAmntExe=0;


		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if (model2.getValueAt(row, 68) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//System.out.println("pheli bar yahan pe aayya val hai "
					//	+ val);
					double cur_val = Double.parseDouble(val);
					model2.setValueAt(cur_val, row, 68);
				}
			}

		}
		if (model2.getValueAt(row, 68) != null) {
			if (val != null) {
				// pranay 


				if (col == 61) // Tds Column is selected
				{
					if (!val.equals("")) 
						travelConcession = Double.parseDouble(val);
					else
						travelConcession = 0;
				}else
				{
					if (model2.getValueAt(row, 62) != null
							&& (!"".equals(model2.getValueAt(row, 62)))) // colunm62
					{
						travelConcession = Double.parseDouble(model2.getValueAt(
								row, 62).toString());

					} else
						travelConcession = 0;
				}

				if (col == 62) // Tds Column is selected
				{
					if (!val.equals("")) 
						deathCumRetirementGratuity = Double.parseDouble(val);
					else
						deathCumRetirementGratuity = 0;
				}else
				{
					if (model2.getValueAt(row, 63) != null
							&& (!"".equals(model2.getValueAt(row, 63)))) // colunm63
					{
						deathCumRetirementGratuity = Double.parseDouble(model2.getValueAt(
								row, 63).toString());

					} else
						deathCumRetirementGratuity = 0;
				}

				if (col == 63) // Tds Column is selected
				{
					if (!val.equals("")) 
						commutedValueOfPension = Double.parseDouble(val);
					else
						commutedValueOfPension = 0;
				}else
				{
					if (model2.getValueAt(row, 64) != null
							&& (!"".equals(model2.getValueAt(row, 64)))) // colunm64
					{
						commutedValueOfPension = Double.parseDouble(model2.getValueAt(
								row, 64).toString());

					} else
						commutedValueOfPension = 0;
				}

				if (col == 64) // Tds Column is selected
				{
					if (!val.equals("")) 
						cashEquivalentOfLeaveSalary = Double.parseDouble(val);
					else
						cashEquivalentOfLeaveSalary = 0;
				}else
				{
					if (model2.getValueAt(row, 65) != null
							&& (!"".equals(model2.getValueAt(row, 65)))) // colunm65
					{
						cashEquivalentOfLeaveSalary = Double.parseDouble(model2.getValueAt(
								row, 65).toString());

					} else
						cashEquivalentOfLeaveSalary = 0;
				}

				if (col == 65) // Tds Column is selected
				{
					if (!val.equals("")) 
						hra = Double.parseDouble(val);
					else
						hra = 0;
				}else
				{
					if (model2.getValueAt(row, 66) != null
							&& (!"".equals(model2.getValueAt(row, 66)))) // colunm66
					{
						hra = Double.parseDouble(model2.getValueAt(
								row, 66).toString());

					} else
						hra = 0;
				}
				
				if (col == 66) // Tds Column is selected
				{
					if (!val.equals("")) 
						amountOfAnyOtherExemptionSec10 = Double.parseDouble(val);
					else
						amountOfAnyOtherExemptionSec10 = 0;
				}else
				{
					if (model2.getValueAt(row, 67) != null
							&& (!"".equals(model2.getValueAt(row, 67)))) // colunm61
					{
						amountOfAnyOtherExemptionSec10 = Double.parseDouble(model2.getValueAt(
								row, 67).toString());

					} else
						amountOfAnyOtherExemptionSec10 = 0;
				}

				totalAmntExe = travelConcession 
						+ deathCumRetirementGratuity 
						+ commutedValueOfPension 
						+ cashEquivalentOfLeaveSalary
						+ hra
						+ amountOfAnyOtherExemptionSec10;
				
				model2.setValueAt(df.format(totalAmntExe), row, 68);
				if ((df.format(totalAmntExe)).length() > 15) {
					GRPU.grpu
					.getMessage("Length of Total Amount Of Exemption under Section 10 can't exceed 15 digits");
					GRPU.grpu.setErrorAt(row, col);
					model2.setValueAt("", row, 68);

				}


			}

		}

	}
	/****************** Added for 2.7 End ********************/


	public void setTotalAmntDedChapVIA(String val, int row, int col) {
		double aggrAmnt = 0;
		double amnt80ccf = 0; // 18
		double amnt80ccg = 0; // 19
		double amntChpVIA = 0; // 20
		double totalAmntDed = 0; // 21

		/****************** Added for 2.7 Start ********************/

		double  section80C=0;     // 70
		double  section80CCC=0;   // 71
		double  section80CCD_1=0;  // 72
		double  section80CCD_1B=0; // 73
		double  section80CCD_2=0;  // 74
		double  section80D=0;      // 75
		double  section80E=0;      // 76
		double  section80G=0;      // 77
		double  section80TTA=0;    // 78



		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if (model2.getValueAt(row, 21) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//System.out.println("pheli bar yahan pe aayya val hai "
					//	+ val);
					double cur_val = Double.parseDouble(val);
					model2.setValueAt(cur_val, row, 21);
				}
			}

		}
		if (model2.getValueAt(row, 21) != null) {
			if (val != null) {
				// pranay 
				if (col == 16) // Tds Column is selected
				{
					if (!val.equals("")) 
						aggrAmnt = Double.parseDouble(val);
					else
						aggrAmnt = 0;
				}else
				{
					if (model2.getValueAt(row, 17) != null
							&& (!"".equals(model2.getValueAt(row, 17)))) // colunm18
					{
						aggrAmnt = Double.parseDouble(model2.getValueAt(
								row, 17).toString());

					} else
						aggrAmnt = 0;
				}

				if (col == 17) // Tds Column is selected
				{
					if (!val.equals("")) 
						amnt80ccf = Double.parseDouble(val);
					else
						amnt80ccf = 0;
				}else
				{
					if (model2.getValueAt(row, 18) != null
							&& (!"".equals(model2.getValueAt(row, 18)))) // colunm18
					{
						amnt80ccf = Double.parseDouble(model2.getValueAt(
								row, 18).toString());

					} else
						amnt80ccf = 0;
				}

				if (col == 18) // Tds Column is selected
				{
					if (!val.equals("")) 
						amnt80ccg = Double.parseDouble(val);
					else
						amnt80ccg = 0;
				}else
				{
					if (model2.getValueAt(row, 19) != null
							&& (!"".equals(model2.getValueAt(row, 19)))) // colunm19
					{
						amnt80ccg = Double.parseDouble(model2.getValueAt(
								row, 19).toString());

					} else
						amnt80ccg = 0;
				}

				if (col == 19) // Tds Column is selected
				{
					if (!val.equals("")) 
						amntChpVIA = Double.parseDouble(val);
					else
						amntChpVIA = 0;
				}else
				{
					if (model2.getValueAt(row, 20) != null
							&& (!"".equals(model2.getValueAt(row, 20)))) // colunm120
					{
						amntChpVIA = Double.parseDouble(model2.getValueAt(
								row, 20).toString());

					} else
						amntChpVIA = 0;
				}

				if (col == 70) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80C = Double.parseDouble(val);
					else
						section80C = 0;
				}else
				{
					if (model2.getValueAt(row, 71) != null
							&& (!"".equals(model2.getValueAt(row, 71)))) // colunm71
					{
						section80C = Double.parseDouble(model2.getValueAt(
								row, 71).toString());

					} else
						section80C = 0;
				}

				if (col == 72) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80CCC = Double.parseDouble(val);
					else
						section80CCC = 0;
				}else
				{
					if (model2.getValueAt(row, 73) != null
							&& (!"".equals(model2.getValueAt(row, 73)))) // colunm73
					{
						section80CCC = Double.parseDouble(model2.getValueAt(
								row, 73).toString());

					} else
						section80CCC = 0;
				}

				if (col == 74) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80CCD_1 = Double.parseDouble(val);
					else
						section80CCD_1 = 0;
				}else
				{
					if (model2.getValueAt(row, 75) != null
							&& (!"".equals(model2.getValueAt(row, 75)))) // colunm75
					{
						section80CCD_1 = Double.parseDouble(model2.getValueAt(
								row, 75).toString());

					} else
						section80CCD_1 = 0;
				}

				if (col == 76) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80CCD_1B = Double.parseDouble(val);
					else
						section80CCD_1B = 0;
				}else
				{
					if (model2.getValueAt(row, 77) != null
							&& (!"".equals(model2.getValueAt(row, 77)))) // colunm77
					{
						section80CCD_1B = Double.parseDouble(model2.getValueAt(
								row, 77).toString());

					} else
						section80CCD_1B = 0;
				}

				if (col == 78) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80CCD_2 = Double.parseDouble(val);
					else
						section80CCD_2 = 0;
				}else
				{
					if (model2.getValueAt(row, 79) != null
							&& (!"".equals(model2.getValueAt(row, 79)))) // colunm79
					{
						section80CCD_2 = Double.parseDouble(model2.getValueAt(
								row, 79).toString());

					} else
						section80CCD_2 = 0;
				}

				if (col == 80) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80D = Double.parseDouble(val);
					else
						section80D = 0;
				}else
				{
					if (model2.getValueAt(row, 81) != null
							&& (!"".equals(model2.getValueAt(row, 81)))) // colunm81
					{
						section80D = Double.parseDouble(model2.getValueAt(
								row, 81).toString());

					} else
						section80D = 0;
				}

				if (col == 82) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80E = Double.parseDouble(val);
					else
						section80E = 0;
				}else
				{
					if (model2.getValueAt(row, 83) != null
							&& (!"".equals(model2.getValueAt(row, 83)))) // colunm83
					{
						section80E = Double.parseDouble(model2.getValueAt(
								row, 83).toString());

					} else
						section80E = 0;
				}

				if (col == 85) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80G = Double.parseDouble(val);
					else
						section80G = 0;
				}else
				{
					if (model2.getValueAt(row, 86) != null
							&& (!"".equals(model2.getValueAt(row, 86)))) // colunm86
					{
						section80G = Double.parseDouble(model2.getValueAt(
								row, 86).toString());

					} else
						section80G = 0;
				}

				if (col == 88) // Tds Column is selected
				{
					if (!val.equals("")) 
						section80TTA = Double.parseDouble(val);
					else
						section80TTA = 0;
				}else
				{
					if (model2.getValueAt(row, 89) != null
							&& (!"".equals(model2.getValueAt(row, 89)))) // colunm89
					{
						section80TTA = Double.parseDouble(model2.getValueAt(
								row, 89).toString());

					} else
						section80TTA = 0;
				}

				totalAmntDed = aggrAmnt + amnt80ccf + amnt80ccg + amntChpVIA + section80C     + section80CCC   + section80CCD_1 + section80CCD_1B + section80CCD_2 + section80D     + section80E     + section80G     + section80TTA;
				model2.setValueAt(df.format(totalAmntDed), row, 21);
				if ((df.format(totalAmntDed)).length() > 15) {
					GRPU.grpu
					.getMessage("Length of Total Amount deductible chapter VIA can't exceed 15 digits");
					GRPU.grpu.setErrorAt(row, col);
					model2.setValueAt("", row, 21);

				}


			}

		}

	}
	/****************** Added for 2.7 End ********************/
	// End

	// Added By for IncomechargableUnder Head Salaries
	public void setIncmChargblHeadSal(String val, int row, int col) {
		double totalSal = 0;
		double totalDed = 0;
		double diff = 0;
		double col11 = 0;
		double col12 = 0;
		double col13 = 0;
		double col68 = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
	
		
		

		if (col == 7
				|| col == 8 
				|| col == 9 
				|| col == 10 
				|| col == 11 
				|| col == 12 
				|| col == 58 
				|| col == 59 
				|| col == 60
				|| col == 61 
				|| col == 62 
				|| col == 63
				|| col == 64 
				|| col == 65 
				|| col == 66
				|| col == 67
				) {
			 
			  
		if (col == 9)
		{
			if (val != null && !"".equals(val)) {
				totalSal = Double.parseDouble(val);
				model2.setValueAt(df.format(totalSal), row, 10);
			}
		}
		
		if (col == 10)
		{
			if (val != null && !"".equals(val)) {
				col11 = Double.parseDouble(val);
				model2.setValueAt(df.format(col11), row, 11);

			}
		}
		if (col == 11)
		{
			if (val != null && !"".equals(val)) {
				col12 = Double.parseDouble(val);
				model2.setValueAt(df.format(col12), row, 12);

			}
		}
		if (col == 12)
		{
			if (val != null && !"".equals(val)) {
				col13 = Double.parseDouble(val);
				model2.setValueAt(df.format(col13), row, 13);

			}
		}
	/*	if (col == 67)
		{
			if (val != null && !"".equals(val)) {
				col68 = Double.parseDouble(val);
				model2.setValueAt(df.format(col68), row, 68);

			}
		}*/

			/*********************************************************/				
			//FRD 2.3 added 16(ia)	

			/*if (model2.getValueAt(row, 13) != null) {
				if (!model2.getValueAt(row, 13).toString().equals(""))
					totalDed = Double.parseDouble(model2.getValueAt(row, 13)
							.toString());
				else
					totalDed = 0;

			}*/
		
		System.out.println("col11=" +model2.getValueAt(row, 11));
		System.out.println("col12=" +model2.getValueAt(row, 12));
		System.out.println("col13=" +model2.getValueAt(row, 13));
		

			if (model2.getValueAt(row, 11) != null) {
				if (!model2.getValueAt(row, 11).toString().equals("")){
					col11 = Double.parseDouble(model2.getValueAt(row, 11)
							.toString());
				System.out.println("col11= "+col11);}
				else
					col11 = 0;

			}

			if (model2.getValueAt(row, 12) != null) {
				if (!model2.getValueAt(row, 12).toString().equals(""))
					col12 = Double.parseDouble(model2.getValueAt(row, 12)
							.toString());
				else
					col12 = 0;

			}

			if (model2.getValueAt(row, 13) != null) {
				if (!model2.getValueAt(row, 13).toString().equals(""))
					col13 = Double.parseDouble(model2.getValueAt(row, 13)
							.toString());
				else
					col13 = 0;

			}
			
			if (model2.getValueAt(row, 68) != null) {
				if (!model2.getValueAt(row, 68).toString().equals(""))
					col68 = Double.parseDouble(model2.getValueAt(row, 68)
							.toString());
				else
					col68 = 0;

			}

			totalDed16 = col11 + col12 + col13 + col68;
			/*********************************************************/
			System.out.println("total ded of 16 I II and IA = "+totalDed16);
			
			if (model2.getValueAt(row, 10) != null) {
				if (!model2.getValueAt(row, 10).toString().equals(""))
					totalSal = Double.parseDouble(model2.getValueAt(row, 10)
							.toString());
				else
					totalSal = 0;

			}

			diff = totalSal - totalDed16;
			 System.out.println("sysout14");
			model2.setValueAt(df.format(diff), row, 14);
			
			
			if ((df.format(diff)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of Income Chargable Under Head Salaries can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 14);

			}

		}
		
		/*********************************************************/	
		
		
		
		

	} // yahan

	// End by

	// Added for column For Total Taxable Income

	public void settotalTaxIncm(String val, int row, int col) {
		double grossTotal = 0;
		double totalAmntChpVIA = 0;
		double totalTaxIncm = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);


		/****************** Added for 2.7 Start ********************/

		
		
		
		
		if ( col == 7
				|| col == 8
				|| col == 9
				|| col == 10
				|| col == 11
				|| col == 12 //FRD 2.3 added 16(ia)	
				|| col == 14
				|| col == 16
				|| col == 17
				|| col == 18
				|| col == 19
				|| col == 58
				|| col == 59
				|| col == 60
				|| col == 61 
				|| col == 62 
				|| col == 63
				|| col == 64 
				|| col == 65
				|| col == 66
				|| col == 68
				|| col == 69
				|| col == 70
				|| col == 71
				|| col == 72
				|| col == 73
				|| col == 74
				|| col == 75
				|| col == 76
				|| col == 77) {
			if (model2.getValueAt(row, 16) != null) {
				if (!model2.getValueAt(row, 16).toString().equals(""))
					grossTotal = Double.parseDouble(model2.getValueAt(row, 16)
							.toString());
				else
					grossTotal = 0;

			}

			if (model2.getValueAt(row, 21) != null) {
				if (!model2.getValueAt(row, 21).toString().equals(""))
					totalAmntChpVIA = Double.parseDouble(model2.getValueAt(row,
							21).toString());
				else
					totalAmntChpVIA = 0;

			}

			totalTaxIncm = grossTotal - totalAmntChpVIA;

			model2.setValueAt(df.format(totalTaxIncm), row, 22);

			if ((df.format(totalTaxIncm)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of Total Taxable Income can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 22);

			}

		}

		/****************** Added for 2.7 End  ********************/

	}

	// End for column For Total Taxable Income

	//newly added for fRD1.6 by akansha
	public void setGrossTotalSA(String val,int row,int col){
		double amtcontrepaid =0;
		double headsal = 0;
		double grosstotalSA = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		String finyear = JComboBox_Form_Sub1_finYear.getSelectedItem().toString();
		int fyear=0;
		fyear = Integer.parseInt(finyear.substring(0,4));
		if (fyear >= 2013 && (model2.getValueAt(row, 51)!=null && !model2.getValueAt(row, 51).toString().equals("No")
				&& !model2.getValueAt(row, 51).toString().equals("--Select--"))) {

			if (col == 54) {
				if (val != null) {
					if (!val.equals(""))
						amtcontrepaid = Double.parseDouble(val);
					else
						amtcontrepaid = 0;
				}

				if (model2.getValueAt(row, 16) != null) {
					if (!model2.getValueAt(row, 16).toString().equals(""))
						headsal = Double.parseDouble(model2.getValueAt(row, 16)
								.toString());
					else
						headsal = 0;
				}

				grosstotalSA = amtcontrepaid + headsal;
				model2.setValueAt(df.format(grosstotalSA), row, 58);
			}
			//FRD 2.3 added 16(ia) || col == 12
			if (col == 14 || col == 7 || col == 8 || col == 9 || col == 10
					|| col == 11 || col == 12

					/****************** Added for 2.7 Start ********************/
					|| col == 58
					|| col == 59
					|| col == 60
					|| col == 61 
					|| col == 62 
					|| col == 63
					|| col == 64 
					|| col == 65 
					|| col == 66
					|| col == 68
					/****************** Added for 2.7 End  ********************/
					) {
				if (model2.getValueAt(row, 55) != null) {
					if (!model2.getValueAt(row, 55).toString().equals(""))
						amtcontrepaid = Double.parseDouble(model2.getValueAt(
								row, 55).toString());
					else
						amtcontrepaid = 0;
				}

				if (model2.getValueAt(row, 16) != null) {
					if (!model2.getValueAt(row, 16).toString().equals(""))
						headsal = Double.parseDouble(model2.getValueAt(row, 16)
								.toString());
					else
						headsal = 0;
				}

				grosstotalSA = amtcontrepaid + headsal;
				model2.setValueAt(df.format(grosstotalSA), row, 58);
			}
		}

	}
	//******************************************************

	// Added By amit for shortfall
	public void setShortFallTaxDedctn(String val, int row, int col) {
		
		double netTaxPaybl = 0;
		double totalamntWholeyear = 0;
		double shortFall = 0;
		double wholeYrAmnt = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		if (col == 27
				|| col == 29
				|| col == 28
				|| col == 22
				|| col == 23
				|| col == 24
				|| col == 25
				|| col == 89
				|| col == 56
				) {
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}
		
		
		
		
		/*
		double netTaxPaybl = 0;
		double totalamntWholeyear = 0;
		double shortFall = 0;
		double wholeYrAmnt = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		if (col == 27) {
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			//model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}

		// newly added by cholia2 on feb 24

		if (col == 29) {

			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (val != null && !"".equals(val))
				wholeYrAmnt = Double.parseDouble(val.toString());

			shortFall = netTaxPaybl - wholeYrAmnt;

			//model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}

		// newly added by cholia2 on feb 24
		if (col == 28) {
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			//model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}

		if (col == 22) {
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			//model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}
		// Edited by vaishnavi

		if (col == 29) {
			if (val != null) {
				if (!val.toString().equals(""))

				{
					totalamntWholeyear = Double.parseDouble(val.toString());

				}

			}

			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}

		// end

		if (col == 23) {
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			//model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}

		if (col == 24) {
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}

		if (col == 25) {
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}

		}
		//neewly added for FRD1.6 by akansha
		if(col==56){
			if (model2.getValueAt(row, 27) != null) {
				if (!model2.getValueAt(row, 27).toString().equals(""))
					netTaxPaybl = Double.parseDouble(model2.getValueAt(row, 27)
							.toString());
				else
					netTaxPaybl = 0;

			}

			if (model2.getValueAt(row, 30) != null) {
				if (!model2.getValueAt(row, 30).toString().equals(""))
					totalamntWholeyear = Double.parseDouble(model2.getValueAt(
							row, 30).toString());
				else
					totalamntWholeyear = 0;

			}

			shortFall = netTaxPaybl - totalamntWholeyear;

			model2.setValueAt(shortFall, row, 31);
			model2.setValueAt(df.format(shortFall), row, 31);

			if ((df.format(shortFall)).length() > 15) {
				GRPU.grpu
				.getMessage("Length of ShortFall in tax can't exceed 15 digits");
				GRPU.grpu.setErrorAt(row, col);
				model2.setValueAt("", row, 31);

			}



		}
		//*************************************
	*/}

	// End by amit for shortfall in tax
	// Added By For Gross Total Income 
	public void setGrossTotalIncome(String val, int row, int col) {
		//double incmOtherSal = 0;
		double col14annex2 = 0;
		double grossTotalSal = 0;
		double col15annex2 = 0;
		double col69annex2 = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		//System.out.println("Value: "+ val +" Col: "+col);
		
	
		
		
		if (val != null) {
			if (!val.equals("")) {
				if (col == 14 ) // Tds Column is selected
				{
					//	System.out.println("abhi yahan pe aaya in col8 value is"
					//	+ val);
					col15annex2 = Double.parseDouble(val);
					model2.setValueAt(df.format(col15annex2), row, 15);

				}


				if (col == 68 ) // Tds Column is selected
				{
					//	System.out.println("abhi yahan pe aaya in col8 value is"
					//	+ val);
					col69annex2 = Double.parseDouble(val);
					model2.setValueAt(df.format(col69annex2), row, 69);
				}


				/****************** Added for 2.7 Start ********************/


				if ( col == 7
						|| col == 8
						|| col == 9
						|| col == 10
						|| col == 11
						|| col == 12 //FRD 2.3 added 16(ia)	
						|| col == 14
						|| col == 58
						|| col == 59
						|| col == 60
						|| col == 61 
						|| col == 62 
						|| col == 63
						|| col == 64 
						|| col == 65 
						|| col == 66
						|| col == 68
						) {
					if (model2.getValueAt(row, 14) != null
							&& (!"".equals(model2.getValueAt(row, 14)))) {
						col14annex2 = Double.parseDouble(model2.getValueAt(row,
								14).toString());

					} else
						col14annex2 = 0;

					if (model2.getValueAt(row, 15) != null
							&& (!"".equals(model2.getValueAt(row, 15)))) {
						col15annex2 = Double.parseDouble(model2.getValueAt(row,
								15).toString());

					} else
						col15annex2 = 0;


					if (model2.getValueAt(row, 69) != null
							&& (!"".equals(model2.getValueAt(row, 69)))) {
						col69annex2 = Double.parseDouble(model2.getValueAt(row,
								69).toString());

					} else
						col69annex2 = 0;

					grossTotalSal = col14annex2 + col15annex2 + col69annex2;
					model2.setValueAt(df.format(grossTotalSal), row, 16);

					if ((df.format(grossTotalSal)).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Gross Total Income can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						model2.setValueAt("", row, 16);

					}

				}

				/****************** Added for 2.7 End  ********************/

			}

			/*else {
				if (col == 14) // Tds Column is selected
				{
				//	System.out.println("abhi yahan pe aaya in col8 value is"
				//			+ val);
					col15annex2 = 0;
					if (model2.getValueAt(row, 14) != null
							&& (!"".equals(model2.getValueAt(row, 14)))) {
						col14annex2 = Double.parseDouble(model2.getValueAt(row,
								14).toString());

					} else
						col14annex2 = 0;

					grossTotalSal = incmOtherSal + col14annex2;
					model2.setValueAt(df.format(grossTotalSal), row, 16);
				}

			}*/

		}

	}

	// end For Gross TotalIncome

	// Added BY amit
	public String getValue(int row, int col) {
		Object tabval = model.getValueAt(row, col);

		if (tabval != null) {
			return tabval.toString();
		}
		return "";
	}

	// -- To Generate the Result For Total Tax Deposited

	// end

	// Added By For Total amount of salary(Fieldno:10) For annexure2

	public void setTotalAmountSalaryvalue(String val, int row, int col) {

		double TaxblAmnt = 0;
		double col9ReortedTax = 0;
		double col8ReortedTax = 0;
		double TotalSal = 0;
		int fyear=0;
		
		

		String finyear = JComboBox_Form_Sub1_finYear.getSelectedItem().toString();
		fyear = Integer.parseInt(finyear.substring(0,4));
		
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		if (model2.getValueAt(row, 10) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//	System.out.println("pheli bar yahan pe aayya");
					double cur_val = Double.parseDouble(val);
					model2.setValueAt(cur_val, row, 10);
				}
			}

		}
		
		/****************** Added for 2.7 Start ********************/

		if (model2.getValueAt(row, 10) != null) {
			if (val != null) {
				
				if (fyear < 2018 && col == 7) // Tds Column is selected
				{

					if (!val.equals("")) {
						col8ReortedTax = Double.parseDouble(val);
						model2.setValueAt(col8ReortedTax, row, 8);

					}else
					{	
						col8ReortedTax = 0;
					}
				}
				if (col == 8) // Tds Column is selected
				{

					if (!val.equals("")) {

						col9ReortedTax = Double.parseDouble(val);
						model2.setValueAt(col9ReortedTax, row, 9);

					}else
					{

						col9ReortedTax = 0;
					}

				}
				
				
				if (model2.getValueAt(row, 8) != null
						&& (!"".equals(model2.getValueAt(row, 8)))) {
					col8ReortedTax = Double.parseDouble(model2
							.getValueAt(row, 8).toString());

				}
				
				if (model2.getValueAt(row, 9) != null
						&& (!"".equals(model2.getValueAt(row, 9)))) {
					col9ReortedTax = Double.parseDouble(model2
							.getValueAt(row, 9).toString());

				} 
				
				
				
				TotalSal = col8ReortedTax + col9ReortedTax;

				model2.setValueAt(df.format(TotalSal), row, 10);
				if ((df.format(TotalSal)).length() > 15) {
					GRPU.grpu
					.getMessage("Length of Total Amount of Salary  can't exceed 15 digits");
					GRPU.grpu.setErrorAt(row, col);
					model2.setValueAt("", row, 10);

				}


			}

		}



/*		if (model2.getValueAt(row, 10) != null) {
			if (val != null) {
				if (!val.equals("")) {
					if (col == 7) // Tds Column is selected
					{
						//						System.out
						//								.println("abhi yahan pe aaya in col8 value is"
						//										+ val);
						TaxblAmnt = Double.parseDouble(val);
						if (model2.getValueAt(row, 9) != null
								&& (!"".equals(model2.getValueAt(row, 9)))) {
							col9ReortedTax = Double.parseDouble(model2
									.getValueAt(row, 9).toString());

						} else
							col9ReortedTax = 0;

						TotalSal = TaxblAmnt + col9ReortedTax;

						model2.setValueAt(df.format(TotalSal), row, 10);
						if ((df.format(TotalSal)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount of Salary  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 10);

						}

					}
					if (col == 8) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						ReportdTaxblAmnt = Double.parseDouble(val);
						if (model2.getValueAt(row, 8) != null
								&& (!"".equals(model2.getValueAt(row, 8)))) {
							col8ReortedTax = Double.parseDouble(model2
									.getValueAt(row, 8).toString());

						} else
							col8ReortedTax = 0;
						//
						//						System.out.println("ReportdTaxblAmnt"
						//								+ ReportdTaxblAmnt);
						//						System.out.println("col8ReortedTax" + col8ReortedTax);

						TotalSal = ReportdTaxblAmnt + col8ReortedTax;

						model2.setValueAt(df.format(TotalSal), row, 10);
						if ((df.format(TotalSal)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount of Salary  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 10);

						}

					}

				} // deleet yahan

				else {
					if (col == 7) // Tds Column is selected
					{
						TaxblAmnt = 0;
						if (model2.getValueAt(row, 9) != null
								&& (!"".equals(model2.getValueAt(row, 9)))) {
							col9ReortedTax = Double.parseDouble(model2
									.getValueAt(row, 9).toString());

						} else
							col9ReortedTax = 0;

						TotalSal = TaxblAmnt + col9ReortedTax;
						model2.setValueAt(df.format(TotalSal), row, 10);
						if ((df.format(TotalSal)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount of Salary  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 10);

						}

					}
					if (col == 8) // Tds Column is selected
					{
						ReportdTaxblAmnt = 0;
						if (model2.getValueAt(row, 8) != null
								&& (!"".equals(model2.getValueAt(row, 8)))) {
							col8ReortedTax = Double.parseDouble(model2
									.getValueAt(row, 8).toString());

						} else
							col8ReortedTax = 0;

						TotalSal = ReportdTaxblAmnt + col8ReortedTax;
						model2.setValueAt(df.format(TotalSal), row, 10);
						if ((df.format(TotalSal)).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount of Salary  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 10);

						}

					}

				} // idhartak

			}
			
			

		}*/
		
		/****************** Added for 2.7 End  ********************/

	}

	// end

	// Added For Net Tax Payble

	public void setNetTaxPaybl(String val, int row, int col) {

		double totalTax = 0;
		double sur = 0;
		double cess = 0;
		double taxRelief = 0;
		double rebateUnderSection87A=0;
		double netTaxPaybl = 0;




		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if (model2.getValueAt(row, 27) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//System.out.println("pheli bar yahan pe aayya val hai "
					//	+ val);
					double cur_val = Double.parseDouble(val);
					model2.setValueAt(cur_val, row, 27);
				}
			}

		}
		if (model2.getValueAt(row, 27) != null) {
			if (val != null) {
				// pranay 

				if (col == 22) // Tds Column is selected
				{
					if (!val.equals("")) 
						totalTax = Double.parseDouble(val);
					else
						totalTax = 0;
				}else
				{
					if (model2.getValueAt(row, 23) != null
							&& (!"".equals(model2.getValueAt(row, 23)))) // colunm23
					{
						totalTax = Double.parseDouble(model2.getValueAt(
								row, 23).toString());

					} else
						totalTax = 0;
				}

				if (col == 23) // Tds Column is selected
				{
					if (!val.equals("")) 
						sur = Double.parseDouble(val);
					else
						sur = 0;
				}else
				{
					if (model2.getValueAt(row, 24) != null
							&& (!"".equals(model2.getValueAt(row, 24)))) // colunm24
					{
						sur = Double.parseDouble(model2.getValueAt(
								row, 24).toString());

					} else
						sur = 0;
				}

				if (col == 24) // Tds Column is selected
				{
					if (!val.equals("")) 
						cess = Double.parseDouble(val);
					else
						cess = 0;
				}else
				{
					if (model2.getValueAt(row, 25) != null
							&& (!"".equals(model2.getValueAt(row, 25)))) // colunm25
					{
						cess = Double.parseDouble(model2.getValueAt(
								row, 25).toString());

					} else
						cess = 0;
				}
				if (col == 25) // Tds Column is selected
				{
					if (!val.equals("")) 
						taxRelief = Double.parseDouble(val);
					else
						taxRelief = 0;
				}else
				{
					if (model2.getValueAt(row, 26) != null
							&& (!"".equals(model2.getValueAt(row, 26)))) // colunm26
					{
						taxRelief = Double.parseDouble(model2.getValueAt(
								row, 26).toString());

					} else
						taxRelief = 0;
				}

				if (col == 89) // Tds Column is selected
				{
					if (!val.equals("")) 
						rebateUnderSection87A = Double.parseDouble(val);
					else
						rebateUnderSection87A = 0;
				}else
				{
					if (model2.getValueAt(row, 90) != null
							&& (!"".equals(model2.getValueAt(row, 90)))) // colunm90
					{
						rebateUnderSection87A = Double.parseDouble(model2.getValueAt(
								row, 90).toString());

					} else
						rebateUnderSection87A = 0;
				}

				netTaxPaybl =(totalTax + sur + cess)-(rebateUnderSection87A + taxRelief);
				model2.setValueAt(df.format(netTaxPaybl), row, 27);
				if ((df.format(netTaxPaybl)).length() > 15) {
					GRPU.grpu
					.getMessage("Length of Net Tax Liability can't exceed 15 digits");
					GRPU.grpu.setErrorAt(row, col);
					model2.setValueAt("", row, 27);

				}


			}

		}

	}
	/*
	public void setNetTaxPaybl(String val, int row, int col) {
		double totalTax = 0;
		double netTaxPaybl = 0;
		double sur = 0;
		double cess = 0;
		double taxRelief = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		if (model2.getValueAt(row, 27) == null) {
			if (val != null) {
				if (!val.equals("")) {
				//	System.out.println("pheli bar yahan pe aayya");
					double cur_val = Double.parseDouble(val);
					model2.setValueAt(cur_val, row, 27);
				}
			}

		}
		if (model2.getValueAt(row, 27) != null) {
			if (val != null) {
				if (!val.equals("")) {
					if (col == 22) // Tds Column is selected
					{
//						System.out
//								.println("abhi yahan pe aaya in col8 value is"
//										+ val);
						totalTax = Double.parseDouble(val);

						if (model2.getValueAt(row, 24) != null
								&& (!"".equals(model2.getValueAt(row, 24)))) {
							sur = Double.parseDouble(model2.getValueAt(row, 24)
									.toString());

						} else
							sur = 0;

						if (model2.getValueAt(row, 26) != null
								&& (!"".equals(model2.getValueAt(row, 26)))) {
							taxRelief = Double.parseDouble(model2.getValueAt(
									row, 26).toString());

						} else
							taxRelief = 0;

						if (model2.getValueAt(row, 25) != null
								&& (!"".equals(model2.getValueAt(row, 25)))) {
							cess = Double.parseDouble(model2
									.getValueAt(row, 25).toString());

						} else
							cess = 0;

//						System.out.println("TaxblAmnt  is" + TaxblAmnt);
//						System.out.println("col9ReortedTax  is"
//								+ col9ReortedTax);
//						System.out.println("value is col8"
//								+ model2.getValueAt(row, 7));
//						System.out.println("next ocol9"
//								+ model2.getValueAt(row, 8));

						netTaxPaybl = totalTax + sur + cess - taxRelief;
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}

					if (col == 23) // Tds Column is selected
					{
						sur = Double.parseDouble(val);

						//System.out.println("annex 2surcharge is " + sur);
						if (model2.getValueAt(row, 23) != null
								&& (!"".equals(model2.getValueAt(row, 23)))) {
//							System.out.println("inside "
//									+ model2.getValueAt(row, 22));

							totalTax = Double.parseDouble(model2.getValueAt(
									row, 23).toString());

						} else
							totalTax = 0;

						if (model2.getValueAt(row, 25) != null
								&& (!"".equals(model2.getValueAt(row, 25)))) {
							cess = Double.parseDouble(model2
									.getValueAt(row, 25).toString());

						} else
							cess = 0;

						if (model2.getValueAt(row, 26) != null
								&& (!"".equals(model2.getValueAt(row, 26)))) {
							taxRelief = Double.parseDouble(model2.getValueAt(
									row, 26).toString());

						} else
							taxRelief = 0;

						//System.out.println("totalTax" + totalTax);

						//System.out.println("cess" + cess);

						//System.out.println("taxRelief" + taxRelief);
						netTaxPaybl = totalTax + sur + cess - taxRelief;
					//	System.out.println("next taxpayble is " + netTaxPaybl);
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}
					if (col == 24) // Tds Column is selected
					{
//						System.out
//								.println("abhi yahan pe aaya in col8 value is"
//										+ val);
						cess = Double.parseDouble(val);

						if (model2.getValueAt(row, 23) != null
								&& (!"".equals(model2.getValueAt(row, 23)))) {
							totalTax = Double.parseDouble(model2.getValueAt(
									row, 23).toString());

						} else
							totalTax = 0;

						if (model2.getValueAt(row, 24) != null
								&& (!"".equals(model2.getValueAt(row, 24)))) {
							sur = Double.parseDouble(model2.getValueAt(row, 24)
									.toString());

						} else
							sur = 0;

						if (model2.getValueAt(row, 26) != null
								&& (!"".equals(model2.getValueAt(row, 26)))) {
							taxRelief = Double.parseDouble(model2.getValueAt(
									row, 26).toString());

						} else
							taxRelief = 0;

						netTaxPaybl = totalTax + sur + cess - taxRelief;
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}
					if (col == 25) // Tds Column is selected
					{
						taxRelief = Double.parseDouble(val);

						if (model2.getValueAt(row, 23) != null
								&& (!"".equals(model2.getValueAt(row, 23)))) {
							totalTax = Double.parseDouble(model2.getValueAt(
									row, 23).toString());

						} else
							totalTax = 0;

						if (model2.getValueAt(row, 24) != null
								&& (!"".equals(model2.getValueAt(row, 24)))) {
							sur = Double.parseDouble(model2.getValueAt(row, 24)
									.toString());

						} else
							sur = 0;

						if (model2.getValueAt(row, 25) != null
								&& (!"".equals(model2.getValueAt(row, 25)))) {
							cess = Double.parseDouble(model2
									.getValueAt(row, 25).toString());

						} else
							cess = 0;

//						System.out.println("TaxblAmnt  is" + TaxblAmnt);
//						System.out.println("col9ReortedTax  is"
//								+ col9ReortedTax);
//						System.out.println("value is col8"
//								+ model2.getValueAt(row, 7));
//						System.out.println("next ocol9"
//								+ model2.getValueAt(row, 8));

						netTaxPaybl = totalTax + sur + cess - taxRelief;
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}

				} // deleet yahan

				else {
					// start else

					if (col == 22) // Tds Column is selected
					{
//						System.out
//								.println("abhi yahan pe aaya in col8 value is"
//										+ val);
						totalTax = 0;

						if (model2.getValueAt(row, 24) != null
								&& (!"".equals(model2.getValueAt(row, 24)))) {
							sur = Double.parseDouble(model2.getValueAt(row, 24)
									.toString());

						} else
							sur = 0;

						if (model2.getValueAt(row, 26) != null
								&& (!"".equals(model2.getValueAt(row, 26)))) {
							taxRelief = Double.parseDouble(model2.getValueAt(
									row, 26).toString());

						} else
							taxRelief = 0;

						if (model2.getValueAt(row, 25) != null
								&& (!"".equals(model2.getValueAt(row, 25)))) {
							cess = Double.parseDouble(model2
									.getValueAt(row, 25).toString());

						} else
							cess = 0;

//						System.out.println("TaxblAmnt  is" + TaxblAmnt);
//						System.out.println("col9ReortedTax  is"
//								+ col9ReortedTax);
//						System.out.println("value is col8"
//								+ model2.getValueAt(row, 7));
//						System.out.println("next ocol9"
//								+ model2.getValueAt(row, 8));

						netTaxPaybl = totalTax + sur + cess - taxRelief;
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}

					if (col == 23) // Tds Column is selected
					{
						sur = 0;

					//	System.out.println("annex 2surcharge is " + sur);
						if (model2.getValueAt(row, 23) != null
								&& (!"".equals(model2.getValueAt(row, 23)))) {
//							System.out.println("inside "
//									+ model2.getValueAt(row, 22));

							totalTax = Double.parseDouble(model2.getValueAt(
									row, 23).toString());

						} else
							totalTax = 0;

						if (model2.getValueAt(row, 25) != null
								&& (!"".equals(model2.getValueAt(row, 25)))) {
							cess = Double.parseDouble(model2
									.getValueAt(row, 25).toString());

						} else
							cess = 0;

						if (model2.getValueAt(row, 26) != null
								&& (!"".equals(model2.getValueAt(row, 26)))) {
							taxRelief = Double.parseDouble(model2.getValueAt(
									row, 26).toString());

						} else
							taxRelief = 0;

//						System.out.println("totalTax" + totalTax);
//
//						System.out.println("cess" + cess);
//
//						System.out.println("taxRelief" + taxRelief);
						netTaxPaybl = totalTax + sur + cess - taxRelief;
					//	System.out.println("next taxpayble is " + netTaxPaybl);
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}
					if (col == 24) // Tds Column is selected
					{
//						System.out
//								.println("abhi yahan pe aaya in col8 value is"
//										+ val);
						cess = 0;

						if (model2.getValueAt(row, 23) != null
								&& (!"".equals(model2.getValueAt(row, 23)))) {
							totalTax = Double.parseDouble(model2.getValueAt(
									row, 23).toString());

						} else
							totalTax = 0;

						if (model2.getValueAt(row, 24) != null
								&& (!"".equals(model2.getValueAt(row, 24)))) {
							sur = Double.parseDouble(model2.getValueAt(row, 24)
									.toString());

						} else
							sur = 0;

						if (model2.getValueAt(row, 26) != null
								&& (!"".equals(model2.getValueAt(row, 26)))) {
							taxRelief = Double.parseDouble(model2.getValueAt(
									row, 26).toString());

						} else
							taxRelief = 0;

						netTaxPaybl = totalTax + sur + cess - taxRelief;
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}
					if (col == 25) // Tds Column is selected
					{
						taxRelief = 0;

						if (model2.getValueAt(row, 23) != null
								&& (!"".equals(model2.getValueAt(row, 23)))) {
							totalTax = Double.parseDouble(model2.getValueAt(
									row, 23).toString());

						} else
							totalTax = 0;

						if (model2.getValueAt(row, 24) != null
								&& (!"".equals(model2.getValueAt(row, 24)))) {
							sur = Double.parseDouble(model2.getValueAt(row, 24)
									.toString());

						} else
							sur = 0;

						if (model2.getValueAt(row, 25) != null
								&& (!"".equals(model2.getValueAt(row, 25)))) {
							cess = Double.parseDouble(model2
									.getValueAt(row, 25).toString());

						} else
							cess = 0;

//						System.out.println("TaxblAmnt  is" + TaxblAmnt);
//						System.out.println("col9ReortedTax  is"
//								+ col9ReortedTax);
//						System.out.println("value is col8"
//								+ model2.getValueAt(row, 7));
//						System.out.println("next ocol9"
//								+ model2.getValueAt(row, 8));

						netTaxPaybl = totalTax + sur + cess - taxRelief;
						model2.setValueAt(df.format(netTaxPaybl), row, 27);
						if ((df.format(netTaxPaybl)).length() > 15) {
							GRPU.grpu
									.getMessage("Length of Net Tax Payble   can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 27);

						}

					}

					// end else

				} // idhartak

			}

		}

	}*/

	// End

	// Added By for the total sum of deductionUnder16II and
	// deductionUnder16III

	public void setTotalDeductionSec16value(String val, int row, int col) {

		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		/*if (model2.getValueAt(row, 13) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//System.out.println("pheli bar yahan pe aayya");
					double cur_val = Double.parseDouble(val);
					//model2.setValueAt(cur_val, row, 13);
				}
			}

		}*/
		//if (model2.getValueAt(row, 13) != null) {
		if (val != null) {
			if (!val.equals("")) {
				if (col == 10) // Tds Column is selected
				{
					//						System.out
					//								.println("abhi yahan pe aaya in col8 value is"
					//										+ val);
					col12Ded16II = Double.parseDouble(val);
					if (model2.getValueAt(row, 12) != null
							&& (!model2.getValueAt(row, 12).equals(""))) {
						col12Ded16III = Double.parseDouble(model2
								.getValueAt(row, 12).toString());

					} else
						col12Ded16III = 0;

					/*********************************************************/				
					//FRD 2.3 added 16(ia)				
					if (model2.getValueAt(row, 13) != null
							&& (!model2.getValueAt(row, 13).equals(""))) {
						col12Ded16IA = Double.parseDouble(model2
								.getValueAt(row, 13).toString());

					} else
						col12Ded16IA = 0;

					/*********************************************************/	

					TotalDed = col12Ded16II + col12Ded16III + col12Ded16IA; //FRD 2.3 added 16(ia)	

					//model2.setValueAt(df.format(TotalDed), row, 13);

					totalDed16 = TotalDed; //FRD 2.3 added 16(ia)
					if (df.format(TotalDed).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Total Deductions Under Section 16 can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						//model2.setValueAt("", row, 13);

					}

				}
				if (col == 11) // Tds Column is selected
				{
					//System.out.println("abhi yahan pe aaya in col9");
					col12Ded16III = Double.parseDouble(val);
					if (model2.getValueAt(row, 11) != null
							&& (!model2.getValueAt(row, 11).equals(""))) {
						col12Ded16II = Double.parseDouble(model2
								.getValueAt(row, 11).toString());

					} else
						col12Ded16II = 0;

					//						System.out.println("ReportdTaxblAmnt"
					//								+ ReportdTaxblAmnt);
					//						System.out.println("col8ReortedTax" + col8ReortedTax);

					/*********************************************************/				
					//FRD 2.3 added 16(ia)				
					if (model2.getValueAt(row, 13) != null
							&& (!model2.getValueAt(row, 13).equals(""))) {
						col12Ded16IA = Double.parseDouble(model2
								.getValueAt(row, 13).toString());

					} else
						col12Ded16IA = 0;

					/*********************************************************/		

					TotalDed = col12Ded16III + col12Ded16II + col12Ded16IA; //FRD 2.3 added 16(ia)

					totalDed16 = TotalDed; //FRD 2.3 added 16(ia)

					//model2.setValueAt(df.format(TotalDed), row, 13);
					if (df.format(TotalDed).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Total Deductions Under Section 16 can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						//model2.setValueAt("", row, 13);

					}

				}

				/*********************************************************/				
				//FRD 2.3 added 16(ia)	
				if (col == 12) 
				{
					col12Ded16IA = Double.parseDouble(val);

					if (model2.getValueAt(row, 11) != null
							&& (!model2.getValueAt(row, 11).equals(""))) {
						col12Ded16II = Double.parseDouble(model2
								.getValueAt(row, 11).toString());

					} else
						col12Ded16II = 0;

					if (model2.getValueAt(row, 12) != null
							&& (!model2.getValueAt(row, 12).equals(""))) {
						col12Ded16III = Double.parseDouble(model2
								.getValueAt(row, 12).toString());

					} else
						col12Ded16III = 0;

					TotalDed = col12Ded16III + col12Ded16II + col12Ded16IA;

					//model2.setValueAt(df.format(TotalDed), row, 13);
					totalDed16 = TotalDed;
					if (df.format(TotalDed).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Total Deductions Under Section 16 can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						model2.setValueAt("", row, 13);

					}
				}
				/*********************************************************/	

			} // deleet yahan

			else {
				if (col == 10) // Tds Column is selected
				{
					//						System.out
					//								.println("abhi yahan pe aaya in col8 value is"
					//										+ val);
					col12Ded16II = 0;
					if (model2.getValueAt(row, 12) != null
							&& (!model2.getValueAt(row, 12).equals(""))) {
						col12Ded16III = Double.parseDouble(model2
								.getValueAt(row, 12).toString());

					} else
						col12Ded16III = 0;

					/*********************************************************/				
					//FRD 2.3 added 16(ia)				
					if (model2.getValueAt(row, 13) != null
							&& (!model2.getValueAt(row, 13).equals(""))) {
						col12Ded16IA = Double.parseDouble(model2
								.getValueAt(row, 13).toString());

					} else
						col12Ded16IA = 0;

					/*********************************************************/

					TotalDed = col12Ded16II + col12Ded16III + col12Ded16IA; //FRD 2.3 added 16(ia)
					totalDed16 = TotalDed; //FRD 2.3 added 16(ia)

					//model2.setValueAt(df.format(TotalDed), row, 13);
					if (df.format(TotalDed).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Total Deductions Under Section 16 can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						model2.setValueAt("", row, 13);

					}

				}
				if (col == 11) // Tds Column is selected
				{
					//System.out.println("abhi yahan pe aaya in col9");
					col12Ded16III = 0;
					if (model2.getValueAt(row, 11) != null
							&& (!model2.getValueAt(row, 11).equals(""))) {
						col12Ded16II = Double.parseDouble(model2
								.getValueAt(row, 11).toString());

					} else
						col12Ded16II = 0;

					//						System.out.println("ReportdTaxblAmnt"
					//								+ ReportdTaxblAmnt);
					//						System.out.println("col8ReortedTax" + col8ReortedTax);

					/*********************************************************/				
					//FRD 2.3 added 16(ia)				
					if (model2.getValueAt(row, 13) != null
							&& (!model2.getValueAt(row, 13).equals(""))) {
						col12Ded16IA = Double.parseDouble(model2
								.getValueAt(row, 13).toString());

					} else
						col12Ded16IA = 0;

					/*********************************************************/

					TotalDed = col12Ded16II + col12Ded16III + col12Ded16IA; //FRD 2.3 added 16(ia)
					totalDed16 = TotalDed; //FRD 2.3 added 16(ia)
					//model2.setValueAt(df.format(TotalDed), row, 13);
					if (df.format(TotalDed).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Total Deductions Under Section 16 can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						model2.setValueAt("", row, 13);

					}

				}

				/*********************************************************/				
				//FRD 2.3 added 16(ia)	
				if (col == 12) 
				{
					col12Ded16IA = 0;						
					if (model2.getValueAt(row, 11) != null
							&& (!model2.getValueAt(row, 11).equals(""))) {
						col12Ded16II = Double.parseDouble(model2
								.getValueAt(row, 11).toString());

					} else
						col12Ded16II = 0;

					if (model2.getValueAt(row, 12) != null
							&& (!model2.getValueAt(row, 12).equals(""))) {
						col12Ded16III = Double.parseDouble(model2
								.getValueAt(row, 12).toString());

					} else
						col12Ded16III = 0;

					TotalDed = col12Ded16III + col12Ded16II + col12Ded16IA;
					totalDed16 = TotalDed; //FRD 2.3 added 16(ia)
					//model2.setValueAt(df.format(TotalDed), row, 13);
					if (df.format(TotalDed).length() > 15) {
						GRPU.grpu
						.getMessage("Length of Total Deductions Under Section 16 can't exceed 15 digits");
						GRPU.grpu.setErrorAt(row, col);
						model2.setValueAt("", row, 13);

					}
				}
				/*********************************************************/	

			} // idhartak

		}

		//}

	}

	// End Total amount of salary(Fieldno:10) For annexure2

	// Added For total amount Deducted At source for whole year

	public void setTotalAmntDedSrcWholeYear(String val, int row, int col) {
		double col28 = 0;
		double col29 = 0;
		//newly added for FRD1.6 by akansha
		double col57 = 0;
		double TotalDed = 0;

		//		//newly added for FRD1.6 by akansha
		//		String year = JComboBox_Form_Sub1_finYear.getSelectedItem().toString();
		//		int finyear = 0;
		//		if(!"--Select--".equalsIgnoreCase(year))
		//			finyear = Integer.parseInt(year.substring(0,4));
		//		//*************************************************

		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		if (model2.getValueAt(row, 30) == null) {
			if (val != null) {
				if (!val.equals("")) {
					//System.out.println("pheli bar yahan pe aayya");
					double cur_val = Double.parseDouble(val);
					model2.setValueAt(cur_val, row, 30);
				}
			}

		}
		if (model2.getValueAt(row, 30) != null) {
			if (val != null) {
				if (!val.equals("")) {
					if (col == 27) // Tds Column is selected
					{
						//						System.out
						//								.println("abhi yahan pe aaya in col8 value is"
						//										+ val);

						col28 = Double.parseDouble(val);
						if (model2.getValueAt(row, 29) != null
								&& (!model2.getValueAt(row, 29).equals(""))) {
							col29 = Double.parseDouble(model2.getValueAt(row,
									29).toString());

						} else
							col29 = 0;
						//newly added FRD1.6 by akansha
						if (model2.getValueAt(row, 57) != null
								&& (!model2.getValueAt(row, 57).equals(""))) {
							col57 = Double.parseDouble(model2.getValueAt(row,
									57).toString());

						} else
							col57 = 0;

						TotalDed = col28 + col29 + col57;

						model2.setValueAt(df.format(TotalDed), row, 30);
						if (df.format(TotalDed).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount deducted for whole year column30  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 30);

						}

					}
					if (col == 28) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						col29 = Double.parseDouble(val);
						if (model2.getValueAt(row, 28) != null
								&& (!model2.getValueAt(row, 28).equals(""))) {
							col28 = Double.parseDouble(model2.getValueAt(row,
									28).toString());

						} else
							col28 = 0;
						//newly added FRD1.6 by akansha
						if (model2.getValueAt(row, 57) != null
								&& (!model2.getValueAt(row, 57).equals(""))) {
							col57 = Double.parseDouble(model2.getValueAt(row,
									57).toString());

						} else
							col57 = 0;

						//						System.out.println("ReportdTaxblAmnt"
						//								+ ReportdTaxblAmnt);
						//						System.out.println("col8ReortedTax" + col8ReortedTax);

						TotalDed = col29 + col28 +col57;

						model2.setValueAt(df.format(TotalDed), row, 30);
						if (df.format(TotalDed).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount deducted for whole year column30  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 30);

						}

					}

					if (col == 56) // Tds Column is selected
					{
						//						System.out
						//								.println("abhi yahan pe aaya in col8 value is"
						//										+ val);

						col57 = Double.parseDouble(val);
						if (model2.getValueAt(row, 29) != null
								&& (!model2.getValueAt(row, 29).equals(""))) {
							col29 = Double.parseDouble(model2.getValueAt(row,
									29).toString());

						} else
							col29 = 0;

						if (model2.getValueAt(row, 28) != null
								&& (!model2.getValueAt(row, 28).equals(""))) {
							col28 = Double.parseDouble(model2.getValueAt(row,
									28).toString());

						} else
							col28 = 0;

						TotalDed = col28 + col29 + col57;

						model2.setValueAt(df.format(TotalDed), row, 30);
						if (df.format(TotalDed).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount deducted for whole year column30  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 30);

						}

					}
				} // deleet yahan

				else {
					if (col == 27) // Tds Column is selected
					{
						//						System.out
						//								.println("abhi yahan pe aaya in col8 value is"
						//										+ val);

						col28 = 0;
						if (model2.getValueAt(row, 29) != null
								&& (!model2.getValueAt(row, 29).equals(""))) {
							col29 = Double.parseDouble(model2.getValueAt(row,
									29).toString());

						} else
							col29 = 0;
						//newly added FRD1.6 by akansha
						if (model2.getValueAt(row, 57) != null
								&& (!model2.getValueAt(row, 57).equals(""))) {
							col57 = Double.parseDouble(model2.getValueAt(row,
									57).toString());

						} else
							col57 = 0;

						TotalDed = col28 + col29+ col57;

						model2.setValueAt(df.format(TotalDed), row, 30);
						if (df.format(TotalDed).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount deducted for whole year column30  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 30);

						}

					}
					if (col == 28) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						col29 = 0;
						if (model2.getValueAt(row, 28) != null
								&& (!model2.getValueAt(row, 28).equals(""))) {
							col28 = Double.parseDouble(model2.getValueAt(row,
									28).toString());

						} else
							col28 = 0;
						//newly added FRD1.6 by akansha
						if (model2.getValueAt(row, 57) != null
								&& (!model2.getValueAt(row, 57).equals(""))) {
							col57 = Double.parseDouble(model2.getValueAt(row,
									57).toString());

						} else
							col57 = 0;
						//						System.out.println("ReportdTaxblAmnt"
						//								+ ReportdTaxblAmnt);
						//						System.out.println("col8ReortedTax" + col8ReortedTax);

						TotalDed = col29 + col28 +col57;

						model2.setValueAt(df.format(TotalDed), row, 30);
						if (df.format(TotalDed).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount deducted for whole year column30  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 30);

						}

					}

					//newly added FRD1.6 by akansha
					if (col == 56) // Tds Column is selected
					{
						//System.out.println("abhi yahan pe aaya in col9");
						col57 = 0;
						if (model2.getValueAt(row, 28) != null
								&& (!model2.getValueAt(row, 28).equals(""))) {
							col28 = Double.parseDouble(model2.getValueAt(row,
									28).toString());

						} else
							col28 = 0;

						if (model2.getValueAt(row, 29) != null
								&& (!model2.getValueAt(row, 29).equals(""))) {
							col29 = Double.parseDouble(model2.getValueAt(row,
									29).toString());

						} else
							col29 = 0;
						//						System.out.println("ReportdTaxblAmnt"
						//								+ ReportdTaxblAmnt);
						//						System.out.println("col8ReortedTax" + col8ReortedTax);

						TotalDed = col29 + col28 +col57;

						model2.setValueAt(df.format(TotalDed), row, 30);
						if (df.format(TotalDed).length() > 15) {
							GRPU.grpu
							.getMessage("Length of Total Amount deducted for whole year column30  can't exceed 15 digits");
							GRPU.grpu.setErrorAt(row, col);
							model2.setValueAt("", row, 30);

						}

					}

				} // idhartak

			}

		}

	}

	// End Added For total amount Deducted At source for whole year

	// Added By amit for the population of the annexure 1 tab from challan tab

	public void jCombo_challanSerialNum_actionPerformed(ActionEvent e,
			MyComboBoxEditor challanSerialNumberCombo, boolean annex1_insert,
			int insert, int row_no) {
		// declared getting variables from challan
		Object index = null;
		ArrayList challan_srl_num_annex1 = new ArrayList();
		double challanTds = 0;
		double challanSur = 0;
		double challanCess = 0;
		double sum_total = 0;
		double annex1_interest = 0;
		double annex1_others = 0;
		double annex1_total_tds_allocated = 0;
		int i;
		int j;
		int count;
		int k;
		double total = 0;

		int selected_row = 0;

		//	System.out.println("I am stuck");

		if (!annex1_insert) {
			//System.out.println("Drop down wale mein");

			// newly added on 12 march
			// selected_row = jTableTransacDetails1.getSelectedRow();
			selected_row = mcolInexSrNo;
			// end newly added on 12 march
			index = ((JComboBox) challanSerialNumberCombo.getComponent())
					.getSelectedItem();
		} else if (annex1_insert) {
			//System.out.println("inert row mein");
			selected_row = row_no;
			index = insert;
		}

		//System.out.println("  index is " + index);
		//System.out.println("  slected row is " + selected_row);
		// yahan pe
		if (index != null) // newly added by cholia
		{
			if (!annex1_insert) {
				//	System.out.println(" before callthe selected row is "
				//			+ mcolInexSrNo);
				sortMethod(index, false);

				/*
				 * for (k = 0; k < chalnn_getRowCnt1; k++) {
				 * 
				 * if (k + 2 == jTableTransacDetails1.getSelectedRow()) { if
				 * (index != null) //akash
				 * challan_srl_num_annex1.add(Integer.parseInt(index
				 * .toString())); } else { if (!model1.getValueAt(k + 2,
				 * 1).toString() .equals("--Select--")) {
				 * 
				 * challan_srl_num_annex1.add(Integer.parseInt(model1
				 * .getValueAt(k + 2, 1).toString()));
				 * 
				 * } else { System.out.println("chol aaya");
				 * challan_srl_num_annex1.add(Integer.parseInt("00")); }
				 * 
				 * } } System.out.println("---DARLING 6---"+
				 * System.currentTimeMillis()/10); System.out.println("SIZE IS"
				 * + challan_srl_num_annex1.size());
				 * 
				 * 
				 * //if (!annex1_insert)
				 * 
				 * //{
				 * 
				 * for (i = 0; i < challan_srl_num_annex1.size(); i++) { count =
				 * 0; System.out.println("---DARLING 7---"+
				 * System.currentTimeMillis()/10);
				 * 
				 * 
				 * 
				 * 
				 * 
				 * for (j = 0; j < challan_srl_num_annex1.size(); j++) { if
				 * (Integer.parseInt(challan_srl_num_annex1.get(i).toString())
				 * != 0) { if (Integer.parseInt(challan_srl_num_annex1.get(i)
				 * .toString()) == Integer
				 * .parseInt(challan_srl_num_annex1.get(j).toString())) {
				 * System.out.println("print " +
				 * challan_srl_num_annex1.get(i).toString()); count++;
				 * System.out.println("cholia row number is " + j
				 * 
				 * + "value is" + Integer.parseInt(challan_srl_num_annex1
				 * .get(j).toString())); model1.setValueAt(count, j + 2, 11);
				 * 
				 * } }
				 * 
				 * } System.out.println("---DARLING 8---"+
				 * System.currentTimeMillis()/10);
				 * 
				 * }
				 */

			} // yahan

			// }

			//	System.out.println("---DARLING  9---" + System.currentTimeMillis()
			//		/ 10);
			// End

			// For Bsr code For annex1
			Object challanBsrCode = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 13);
			if (challanBsrCode != null) {
				if (!challanBsrCode.equals("")) {
					model1.setValueAt(challanBsrCode, selected_row, 3);
				}

			} else {
				model1.setValueAt("", selected_row, 3);
			}

			// End

			// For Date on ehich tax deposited For annex1 disabled
			Object challandateTaxDeposited = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 15);
			if (challandateTaxDeposited != null) {
				if (!challandateTaxDeposited.equals("")) {
					model1.setValueAt(challandateTaxDeposited, selected_row, 4);
				}

			}

			else {
				model1.setValueAt("", selected_row, 4);

			}

			// End

			// commented by

			// newly chnaged by cholia for the section code prior 2013-2014

			int selYear_chalnSerNo = Integer
					.parseInt(JComboBox_Form_Sub1_finYear.getSelectedItem()
							.toString().substring(0, 4));

			if (selYear_chalnSerNo < 2013) {
				Object challandateSecionCode = model.getValueAt(
						Integer.parseInt(index.toString()) + 1, 2);
				if (challandateSecionCode != null) {
					if (!challandateSecionCode.equals("")) {
						model1.setValueAt(challandateSecionCode, selected_row,
								6);
					}

				} else {
					model1.setValueAt("", selected_row, 6);

				}

			}

			// end newly chnaged by cholia for the section code prior 2013-2014
			// For Transfer voucher number For annex1 disabled

			Object challanDdoSerial = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 17);
			if (challanDdoSerial != null) {
				if (!challanDdoSerial.equals("")) {
					model1.setValueAt(challanDdoSerial, selected_row, 5);
				}

			} else {

				model1.setValueAt("", selected_row, 5);

			}

			// End

			// For total Tds to be allotted For annex1 disabled
			Object challanTds_obj = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 3);
			Object challanSur_obj = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 4);
			Object challanCess_obj = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 5);
			DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
			df.setMaximumFractionDigits(2);
			if (challanTds_obj != null) {
				if (!challanTds_obj.equals("")) {
					challanTds = Double.parseDouble(model.getValueAt(
							Integer.parseInt(index.toString()) + 1, 3)
							.toString());
					sum_total = challanTds + challanSur + challanCess;
					// System.out.println("---FAIZI---1 " + challanTds);
					model1.setValueAt(df.format(sum_total), selected_row, 7);
				}

			}
			if (challanTds_obj == null && challanSur_obj == null
					&& challanCess_obj == null)
				model1.setValueAt("", selected_row, 7);
			// End

			// For total Tds to be allotted For annex1 disabled from challan
			// surcharge

			if (challanSur_obj != null) {
				if (!challanSur_obj.equals("")) {
					challanSur = Double.parseDouble(challanSur_obj.toString());
					sum_total = challanTds + challanSur + challanCess;
					// System.out.println("---FAIZI---2 " + challanTds);
					model1.setValueAt(df.format(sum_total), selected_row, 7);
				}

			}
			// End

			// For total Tds to be allotted For annex1 disabled from cess
			if (challanCess_obj != null) {
				if (!challanCess_obj.equals("")) {
					challanCess = Double
							.parseDouble(challanCess_obj.toString());
					sum_total = challanTds + challanSur + challanCess;
					// System.out.println("---FAIZI---3 " + challanTds);
					model1.setValueAt(df.format(sum_total), selected_row, 7);
				}

			}
			// End

			// For Interest annexure1
			Object challanInterest = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 6); // selectin
			// value
			// from cahllan
			if (challanInterest != null) {
				if (!challanInterest.equals("")) {
					model1.setValueAt(challanInterest, selected_row, 8);

				}

			}

			else {
				model1.setValueAt("", selected_row, 8);
			}

			// End For Interest annexure1

			// For Others field annexure 1
			Object challanOthers = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 8); // selectin
			// value
			// from cahllan
			if (challanOthers != null) {
				if (!challanOthers.equals("")) {
					model1.setValueAt(challanOthers, selected_row, 9);
				}

			}

			else {
				model1.setValueAt("", selected_row, 9);

			}

			// End Others field annexure 1

			// For Total(7+8+9) for annexure 1
			Object total_allocated = model1.getValueAt(selected_row, 7); // getting
			// total

			if (total_allocated != null) {
				if (!total_allocated.equals("")) {
					annex1_total_tds_allocated = Double.parseDouble(model1
							.getValueAt(selected_row, 7).toString());

				}

			}

			// End Total(7+8+9)

			// Annexure1 interest
			Object annex1_intrst = model1.getValueAt(selected_row, 8); // getting
			// total

			if (annex1_intrst != null) {
				if (!annex1_intrst.equals("")) {
					annex1_interest = Double.parseDouble(model1.getValueAt(
							selected_row, 8).toString());

				}
			}

			//
			// others
			Object annex1_oth = model1.getValueAt(selected_row, 9); // getting
			// total

			if (annex1_oth != null) {
				if (!annex1_oth.equals("")) {
					annex1_others = Double.parseDouble(model1.getValueAt(
							selected_row, 9).toString());

				}
			}
			// others end
			total = annex1_total_tds_allocated + annex1_interest
					+ annex1_others;
			model1.setValueAt(df.format(total), selected_row, 10);

		}

		else {
			model1.setValueAt("", selected_row, 3);
			model1.setValueAt("", selected_row, 4);
			// model1.setValueAt("", selected_row, 6);
			model1.setValueAt("", selected_row, 5);
			model1.setValueAt("", selected_row, 7);
			model1.setValueAt("", selected_row, 8);
			model1.setValueAt("", selected_row, 9);
			model1.setValueAt("", selected_row, 10);
		}

		// yahan se suru krna hai bhai:

	}

	// End the population of the annexure 1 tab from challan tab

	public void value_set_annexure1(int row_selected, Object index) {

		int selected_row = row_selected;
		double challanTds = 0;
		double challanSur = 0;
		double challanCess = 0;
		double sum_total = 0;
		double annex1_interest = 0;
		double annex1_others = 0;
		double annex1_total_tds_allocated = 0;
		int i;
		int j;
		int count;
		int k;
		double total = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);

		// Financial year calculation
		String year = (JComboBox_Form_Sub1_finYear.getSelectedItem().toString())
				.substring(0, 4);
		String endyear = (JComboBox_Form_Sub1_finYear.getSelectedItem()
				.toString()).substring(5, 8);
		int year1 = Integer.parseInt(year);
		int endyear1 = Integer.parseInt(endyear);
		// ***************************************
		System.out.println("alanskha index is" + index.toString() + "and" + selected_row);
		System.out.println("row number = "+selected_row);

		// For Bsr code For annex1
		//System.out.println("print value =" +model.getValueAt(Integer.parseInt(index.toString())+1, 13));
		Object challanBsrCode = model.getValueAt(
				Integer.parseInt(index.toString())+1, 13);
		if (challanBsrCode != null) {
			if (!challanBsrCode.equals("")) {
				model1.setValueAt(challanBsrCode, selected_row, 3);
			}

		} else {
			model1.setValueAt("", selected_row, 3);
		}

		// End
		// For addition of Section codes in AnnI if year before 2012-2013
		if (year1 <= 2012 && endyear1 <= 2013) {
			Object challanSecCode = model.getValueAt(
					Integer.parseInt(index.toString()) + 1, 2);
			if (challanSecCode != null) {
				if (!challanSecCode.equals("")) {
					model1.setValueAt(challanSecCode, selected_row, 6);

				}

			} else {
				model1.setValueAt("", selected_row, 6);

			}

		}
		// ************************************************************
		// For Date on ehich tax deposited For annex1 disabled
		Object challandateTaxDeposited = model.getValueAt(
				Integer.parseInt(index.toString()) + 1, 15);
		if (challandateTaxDeposited != null) {
			if (!challandateTaxDeposited.equals("")) {
				model1.setValueAt(challandateTaxDeposited, selected_row, 4);
			}

		}

		else {
			model1.setValueAt("", selected_row, 4);

		}

		// End

		// commented by

		// For Transfer voucher number For annex1 disabled

		Object challanDdoSerial = model.getValueAt(
				Integer.parseInt(index.toString()) + 1, 17);
		if (challanDdoSerial != null) {
			if (!challanDdoSerial.equals("")) {
				model1.setValueAt(challanDdoSerial, selected_row, 5);
			}

		} else {

			model1.setValueAt("", selected_row, 5);

		}

		// End

		// For total Tds to be allotted For annex1 disabled
		Object challanTds_obj = model.getValueAt(
				Integer.parseInt(index.toString()) + 1, 3);
		Object challanSur_obj = model.getValueAt(
				Integer.parseInt(index.toString()) + 1, 4);
		Object challanCess_obj = model.getValueAt(
				Integer.parseInt(index.toString()) + 1, 5);

		if (challanTds_obj != null) {
			if (!challanTds_obj.equals("")) {
				challanTds = Double.parseDouble(model.getValueAt(
						Integer.parseInt(index.toString()) + 1, 3).toString());
				sum_total = challanTds + challanSur + challanCess;

				model1.setValueAt(df.format(sum_total), selected_row, 7);
			}

		}
		if (challanTds_obj == null && challanSur_obj == null
				&& challanCess_obj == null)
			model1.setValueAt("", selected_row, 7);
		// End

		// For total Tds to be allotted For annex1 disabled from challan
		// surcharge

		if (challanSur_obj != null) {
			if (!challanSur_obj.equals("")) {
				challanSur = Double.parseDouble(challanSur_obj.toString());
				sum_total = challanTds + challanSur + challanCess;

				model1.setValueAt(df.format(sum_total), selected_row, 7);
			}

		}
		// End

		// For total Tds to be allotted For annex1 disabled from cess
		if (challanCess_obj != null) {
			if (!challanCess_obj.equals("")) {
				challanCess = Double.parseDouble(challanCess_obj.toString());
				sum_total = challanTds + challanSur + challanCess;

				model1.setValueAt(df.format(sum_total), selected_row, 7);
			}

		}
		// End

		// For Interest annexure1
		Object challanInterest = model.getValueAt(
				Integer.parseInt(index.toString()) + 1, 6); // selectin value
		// from cahllan
		if (challanInterest != null) {
			if (!challanInterest.equals("")) {
				model1.setValueAt(challanInterest, selected_row, 8);

			}

		}

		else {
			model1.setValueAt("", selected_row, 8);
		}

		// End For Interest annexure1

		// For Others field annexure 1
		Object challanOthers = model.getValueAt(
				Integer.parseInt(index.toString()) + 1, 8); // selectin value
		// from cahllan
		if (challanOthers != null) {
			if (!challanOthers.equals("")) {
				model1.setValueAt(challanOthers, selected_row, 9);
			}

		}

		else {
			model1.setValueAt("", selected_row, 9);

		}

		// End Others field annexure 1

		// For Total(7+8+9) for annexure 1
		Object total_allocated = model1.getValueAt(selected_row, 7); // getting
		// total

		if (total_allocated != null) {
			if (!total_allocated.equals("")) {
				annex1_total_tds_allocated = Double.parseDouble(model1
						.getValueAt(selected_row, 7).toString());

			}

		}

		// End Total(7+8+9)

		// Annexure1 interest
		Object annex1_intrst = model1.getValueAt(selected_row, 8); // getting
		// total

		if (annex1_intrst != null) {
			if (!annex1_intrst.equals("")) {
				annex1_interest = Double.parseDouble(model1.getValueAt(
						selected_row, 8).toString());

			}
		}

		//
		// others
		Object annex1_oth = model1.getValueAt(selected_row, 9); // getting total

		if (annex1_oth != null) {
			if (!annex1_oth.equals("")) {
				annex1_others = Double.parseDouble(model1.getValueAt(
						selected_row, 9).toString());

			}
		}
		// others end
		total = annex1_total_tds_allocated + annex1_interest + annex1_others;
		// System.out.println("---FAIZI 1---" + total);
		model1.setValueAt(df.format(total), selected_row, 10);

	}

	// added by cholia for entering the data in annexure1

	public void populateAnnex1(String val, int row, int col) {
		double eduCes = 0;
		double Sur = 0;
		double totalTdsAllocated = 0;
		double tdsChallan = 0;
		double othersAnnex1 = 0;
		double totalAnnex1 = 0;
		double interestAnnex1 = 0;
		double totalTcsAnnex1 = 0;
		DecimalFormatSymbols sf = new DecimalFormatSymbols(Locale.ENGLISH);
		DecimalFormat df = new DecimalFormat("0.00",sf);
		df.setMaximumFractionDigits(2);
		int i = 0;

		// google
		if (col == 12) // Tds Column is selected
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {
						if (val != null && (!"".equals(val.toString()))) {
							model1.setValueAt(val, i, 3);

						}
					}
				}
			}

		}

		if (col == 14) // Date on ehich tax deposited For annex1 disabled
			// selected
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {
						if (val != null && (!"".equals(val.toString()))) {

							model1.setValueAt(val, i, 4);

						}
					}
				}
			}

		}

		if (col == 16) // For Transfer voucher number For annex1 disabled
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {
						if (val != null && (!"".equals(val.toString()))) {
							model1.setValueAt(val, i, 5);

						}
					}
				}
			}

		}

		// yahan se suru krna hai kal

		if (col == 2) // For tds annex1 disabled
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {
						// setValuesAnnex1FrmChalln( val, i, row , sur,
						// eduCess);
						if (val != null && (!"".equals(val.toString()))) {
							if (model.getValueAt(row, 4) != null
									&& !"".equals(model.getValueAt(row, 4)
											.toString())) {
								sur = Double.parseDouble(model.getValueAt(row,
										4).toString());

							}

							if (model.getValueAt(row, 5) != null
									&& !"".equals(model.getValueAt(row, 5)
											.toString())) {
								eduCess = Double.parseDouble(model.getValueAt(
										row, 5).toString());

							}
							totalTdsAllocated = Double.parseDouble(val) + sur
									+ eduCess;
							model1.setValueAt(df.format(totalTdsAllocated), i,
									7);

							if (model1.getValueAt(i, 8) != null
									&& !"".equals(model1.getValueAt(i, 8)
											.toString())) {
								interestAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 8).toString());

							}
							if (model1.getValueAt(i, 7) != null
									&& !"".equals(model1.getValueAt(i, 7)
											.toString())) {
								totalTcsAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 7).toString());

							}

							if (model1.getValueAt(i, 9) != null
									&& !"".equals(model1.getValueAt(i, 9)
											.toString())) {
								othersAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 9).toString());

							}

							totalAnnex1 = othersAnnex1 + interestAnnex1
									+ totalTcsAnnex1;
							model1.setValueAt(df.format(totalAnnex1), i, 10); // setting
							// total
							// values
							// in
							// annexure1

						}

						else {
							if (val.equals("")) {
								val = "0.00";
								System.out
								.println("yahan pe aaya hu after null values"
										+ val);

								if (model.getValueAt(row, 4) != null
										&& !"".equals(model.getValueAt(row, 4)
												.toString())) {
									sur = Double.parseDouble(model.getValueAt(
											row, 4).toString());

								}

								if (model.getValueAt(row, 5) != null
										&& !"".equals(model.getValueAt(row, 5)
												.toString())) {
									eduCess = Double.parseDouble(model
											.getValueAt(row, 5).toString());

								}
								totalTdsAllocated = Double.parseDouble(val)
										+ sur + eduCess;
								model1.setValueAt(df.format(totalTdsAllocated),
										i, 7);

								if (model1.getValueAt(i, 8) != null
										&& !"".equals(model1.getValueAt(i, 8)
												.toString())) {
									interestAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 8).toString());

								}
								if (model1.getValueAt(i, 7) != null
										&& !"".equals(model1.getValueAt(i, 7)
												.toString())) {
									totalTcsAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 7).toString());

								}

								if (model1.getValueAt(i, 9) != null
										&& !"".equals(model1.getValueAt(i, 9)
												.toString())) {
									othersAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 9).toString());

								}

								totalAnnex1 = othersAnnex1 + interestAnnex1
										+ totalTcsAnnex1;
								model1.setValueAt(df.format(totalAnnex1), i, 10); // setting
								// total
								// values
								// in
								// annexure1

							}

						} // yahan

					} // khtm
				}
			}

		}

		if (col == 3) // For Surcharge annex1 disabled
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {

						// setValuesAnnex1FrmChalln( val, i, row , sur,
						// eduCess);

						if (val != null && (!"".equals(val.toString()))) {
							if (model.getValueAt(row, 3) != null
									&& !"".equals(model.getValueAt(row, 3)
											.toString())) {
								tdsChallan = Double.parseDouble(model
										.getValueAt(row, 3).toString());

							}

							if (model.getValueAt(row, 5) != null
									&& !"".equals(model.getValueAt(row, 5)
											.toString())) {
								eduCess = Double.parseDouble(model.getValueAt(
										row, 5).toString());

							}
							totalTdsAllocated = Double.parseDouble(val)
									+ tdsChallan + eduCess;
							model1.setValueAt(df.format(totalTdsAllocated), i,
									7);

							if (model1.getValueAt(i, 8) != null
									&& !"".equals(model1.getValueAt(i, 8)
											.toString())) {
								interestAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 8).toString());

							}
							if (model1.getValueAt(i, 7) != null
									&& !"".equals(model1.getValueAt(i, 7)
											.toString())) {
								totalTcsAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 7).toString());

							}

							if (model1.getValueAt(i, 9) != null
									&& !"".equals(model1.getValueAt(i, 9)
											.toString())) {
								othersAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 9).toString());

							}

							totalAnnex1 = othersAnnex1 + interestAnnex1
									+ totalTcsAnnex1;
							model1.setValueAt(df.format(totalAnnex1), i, 10); // setting
							// total
							// values
							// in
							// annexure1

						}

						else {
							if (val.equals("")) {
								val = "0.00";

								if (model.getValueAt(row, 3) != null
										&& !"".equals(model.getValueAt(row, 3)
												.toString())) {
									tdsChallan = Double.parseDouble(model
											.getValueAt(row, 3).toString());

								}

								if (model.getValueAt(row, 5) != null
										&& !"".equals(model.getValueAt(row, 5)
												.toString())) {
									eduCess = Double.parseDouble(model
											.getValueAt(row, 5).toString());

								}
								totalTdsAllocated = Double.parseDouble(val)
										+ tdsChallan + eduCess;
								model1.setValueAt(df.format(totalTdsAllocated),
										i, 7);

								if (model1.getValueAt(i, 8) != null
										&& !"".equals(model1.getValueAt(i, 8)
												.toString())) {
									interestAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 8).toString());

								}
								if (model1.getValueAt(i, 7) != null
										&& !"".equals(model1.getValueAt(i, 7)
												.toString())) {
									totalTcsAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 7).toString());

								}

								if (model1.getValueAt(i, 9) != null
										&& !"".equals(model1.getValueAt(i, 9)
												.toString())) {
									othersAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 9).toString());

								}

								totalAnnex1 = othersAnnex1 + interestAnnex1
										+ totalTcsAnnex1;
								model1.setValueAt(df.format(totalAnnex1), i, 10); // setting
								// total
								// values
								// in
								// annexure1

							}

						}

					}
				}
			}

		}

		if (col == 4) // For EducationCess annex1 disabled
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {
						// setValuesAnnex1FrmChalln( val, i, row , sur,
						// eduCess);

						if (val != null && (!"".equals(val.toString()))) {
							if (model.getValueAt(row, 3) != null
									&& !"".equals(model.getValueAt(row, 3)
											.toString())) {
								tdsChallan = Double.parseDouble(model
										.getValueAt(row, 3).toString());

							}

							if (model.getValueAt(row, 4) != null
									&& !"".equals(model.getValueAt(row, 4)
											.toString())) {
								sur = Double.parseDouble(model.getValueAt(row,
										4).toString());

							}
							totalTdsAllocated = Double.parseDouble(val)
									+ tdsChallan + sur;
							model1.setValueAt(df.format(totalTdsAllocated), i,
									7);

							if (model1.getValueAt(i, 8) != null
									&& !"".equals(model1.getValueAt(i, 8)
											.toString())) {
								interestAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 8).toString());

							}
							if (model1.getValueAt(i, 7) != null
									&& !"".equals(model1.getValueAt(i, 7)
											.toString())) {
								totalTcsAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 7).toString());

							}

							if (model1.getValueAt(i, 9) != null
									&& !"".equals(model1.getValueAt(i, 9)
											.toString())) {
								othersAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 9).toString());

							}

							totalAnnex1 = othersAnnex1 + interestAnnex1
									+ totalTcsAnnex1;
							model1.setValueAt(df.format(totalAnnex1), i, 10); // setting
							// total
							// values
							// in
							// annexure1

						}

						else {
							if (val.equals("")) {
								val = "0.00";

								if (model.getValueAt(row, 3) != null
										&& !"".equals(model.getValueAt(row, 3)
												.toString())) {
									tdsChallan = Double.parseDouble(model
											.getValueAt(row, 3).toString());

								}

								if (model.getValueAt(row, 4) != null
										&& !"".equals(model.getValueAt(row, 4)
												.toString())) {
									sur = Double.parseDouble(model.getValueAt(
											row, 4).toString());

								}
								totalTdsAllocated = Double.parseDouble(val)
										+ tdsChallan + sur;
								model1.setValueAt(df.format(totalTdsAllocated),
										i, 7);

								if (model1.getValueAt(i, 8) != null
										&& !"".equals(model1.getValueAt(i, 8)
												.toString())) {
									interestAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 8).toString());

								}
								if (model1.getValueAt(i, 7) != null
										&& !"".equals(model1.getValueAt(i, 7)
												.toString())) {
									totalTcsAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 7).toString());

								}

								if (model1.getValueAt(i, 9) != null
										&& !"".equals(model1.getValueAt(i, 9)
												.toString())) {
									othersAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 9).toString());

								}

								totalAnnex1 = othersAnnex1 + interestAnnex1
										+ totalTcsAnnex1;
								model1.setValueAt(df.format(totalAnnex1), i, 10); // setting
								// total
								// values
								// in
								// annexure1

							}

						} // yahan

					}
				}
			}

		}

		if (col == 5) // Intersecolumn
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {
						// setValuesAnnex1FrmChalln( val, i, row , sur,
						// eduCess);

						if (val != null && (!"".equals(val.toString()))) {
							model1.setValueAt(val, i, 8);
							if (model1.getValueAt(i, 9) != null
									&& !"".equals(model1.getValueAt(i, 9)
											.toString())) {
								othersAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 9).toString());

							}

							if (model1.getValueAt(i, 7) != null
									&& !"".equals(model1.getValueAt(i, 7)
											.toString())) {
								totalTcsAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 7).toString());

							}

							totalAnnex1 = Double.parseDouble(val)
									+ othersAnnex1 + totalTcsAnnex1;
							model1.setValueAt(df.format(totalAnnex1), i, 10);

						}

						else {
							if (val.equals("")) {
								val = "0.00";

								model1.setValueAt(val, i, 8);

								if (model1.getValueAt(i, 9) != null
										&& !"".equals(model1.getValueAt(i, 9)
												.toString())) {
									othersAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 9).toString());

								}

								if (model1.getValueAt(i, 7) != null
										&& !"".equals(model1.getValueAt(i, 7)
												.toString())) {
									totalTcsAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 7).toString());

								}

								totalAnnex1 = Double.parseDouble(val)
										+ othersAnnex1 + totalTcsAnnex1;
								model1.setValueAt(df.format(totalAnnex1), i, 10);
							}

						} // yahan

					}
				}
			}

		}

		// Interest end

		// others annexure1
		if (col == 7) // challan others filed
		{
			for (i = 2; i < jTableTransacDetails1.getRowCount(); i++) {

				if (model1.getValueAt(i, 1) != null
						&& !"".equals(model1.getValueAt(i, 1).toString())) {
					if (Integer.parseInt(model1.getValueAt(i, 1).toString()) == row - 1) {
						// setValuesAnnex1FrmChalln( val, i, row , sur,
						// eduCess);

						if (val != null && (!"".equals(val.toString()))) {
							model1.setValueAt(val, i, 9);
							if (model1.getValueAt(i, 8) != null
									&& !"".equals(model1.getValueAt(i, 8)
											.toString())) {
								interestAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 8).toString());

							}

							if (model1.getValueAt(i, 7) != null
									&& !"".equals(model1.getValueAt(i, 7)
											.toString())) {
								totalTcsAnnex1 = Double.parseDouble(model1
										.getValueAt(i, 7).toString());

							}
							totalAnnex1 = Double.parseDouble(val)
									+ interestAnnex1 + totalTcsAnnex1;
							model1.setValueAt(df.format(totalAnnex1), i, 10);

						}

						else {
							if (val.equals("")) {
								val = "0.00";

								model1.setValueAt(val, i, 9);

								if (model1.getValueAt(i, 8) != null
										&& !"".equals(model1.getValueAt(i, 8)
												.toString())) {
									interestAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 8).toString());

								}
								if (model1.getValueAt(i, 7) != null
										&& !"".equals(model1.getValueAt(i, 7)
												.toString())) {
									totalTcsAnnex1 = Double.parseDouble(model1
											.getValueAt(i, 7).toString());

								}

								totalAnnex1 = Double.parseDouble(val)
										+ interestAnnex1 + totalTcsAnnex1;
								model1.setValueAt(df.format(totalAnnex1), i, 10);
							}

						} // yahan

					}
				}
			}

		}

	}



	// ajay

	public void sortMethod(Object index, boolean srSet) {
		int k = 0, i = 0, j = 0;
		;
		int count = 0;
		ArrayList challan_srl_num_annex1 = new ArrayList();
		int naya = 0;
		Set challan_srl_unique = new TreeSet();
		boolean check=true,check1=true;
		if (srSet) {
			index = model1.getValueAt(mcolInexSrNo, 1);
			//System.out.println("Inside sort Method: "+ mcolInexSrNo);
		}

		//	System.out.println("akansha is" + chalnn_getRowCnt1);

		for (k = 0; k < chalnn_getRowCnt1; k++) {
			if (k + 2 == mcolInexSrNo
					&& jTableTransacDetails1.getSelectedColumn() == 0)

			{
				// end
				if (index != null) // akash
				{
					//System.out.println("the index is " + index);
					challan_srl_unique.add(Integer.parseInt(index.toString()));

					challan_srl_num_annex1.add(Integer.parseInt(index.toString()));

				}
			}

			else if (!model1.getValueAt(k + 2, 1).toString()
					.equals("--Select--")) {
				//				System.out.println("value hai row mein"
				//						+ Integer.parseInt(model1.getValueAt(k + 2, 1)
				//								.toString()));

				challan_srl_unique.add(Integer.parseInt(model1.getValueAt(
						k + 2, 1).toString()));
				challan_srl_num_annex1.add(Integer.parseInt(model1.getValueAt(
						k + 2, 1).toString()));

			} else {
				//System.out.println("chol aaya");
				challan_srl_num_annex1.add(Integer.parseInt("00"));
			}

		}

		Iterator iter = challan_srl_unique.iterator();

		List<String> indexVal = new ArrayList<String>();


		while (iter.hasNext()) {
			String shalin = iter.next().toString();
			count = 0;
			//System.out.println("shah value is " + akansha);
			int temp=1,temp1=1;
			for (j = 0; j < challan_srl_num_annex1.size(); j++) {

				if (Integer.parseInt(challan_srl_num_annex1.get(j).toString()) != 0) {
					if (Integer.parseInt(shalin) == Integer
							.parseInt(challan_srl_num_annex1.get(j).toString())) {

						if ("Regular".equals(valueOfTypeOfStmt)) {
							count++;
							int ya = j + 2;
							model1.setValueAt(count, j + 2, 11);
						} else if ("Correction".equals(valueOfTypeOfStmt)) {
							//new temp code
							count++;
							int ya = j + 2;
							//System.out.println("the row value is " + ya);

							//## Newly added for correction Ver1.2 by Akansha

							if (model1.getValueAt(ya, 11) != null && !model1.getValueAt(ya, 11).toString().equalsIgnoreCase("") && !"ADD".equals(model1.getValueAt(ya,2).toString())) {

								if (annexIcount != null && annexIcount.size() > 1) {

									if (temp < Integer.parseInt(annexIcount.get(Integer.parseInt(shalin)))) {
										//System.out.println("i am inside this");
										temp = Integer.parseInt(annexIcount.get(Integer.parseInt(shalin)));

									}
								} else {
									if (temp < Integer.parseInt(model1.getValueAt(ya, 11).toString())) {

										temp = Integer.parseInt(model1.getValueAt(ya, 11).toString());
									}
								}
							}

							//*************************************************
							if("ADD".equals(model1.getValueAt(ya,2).toString()))
							{
								/***************************************************************/
								//For FRD2.1, added by Sadhana, Changes in the sequence of population of sr.no. under column no.11 of AnnexureI for correction statements. 
								/*if (annexIcount != null && annexIcount.size() > 1) {

									if (temp < Integer.parseInt(annexIcount.get(Integer.parseInt(shalin)))) {
										//System.out.println("i am inside this");
										temp = Integer.parseInt(annexIcount.get(Integer.parseInt(shalin)));

									}*//***************************************************************//*
								} else {
									if (temp < Integer.parseInt(model1.getValueAt(ya, 11).toString())) {

										temp = Integer.parseInt(model1.getValueAt(ya, 11).toString());
									}
								}
								model1.setValueAt(temp, ya, 11);
								temp++;	*/

								//For FRD2.1, added by Sadhana, Changes in the sequence of population of sr.no. under column no.11 of AnnexureI for correction statements.
								if (annexIcount != null && annexIcount.size() > 1) {
									//added condition to add new deductee record for newly added challan.
									if(annexIcount.size() <= Integer.parseInt(shalin)){
										temp = temp;
									}else{
										if (temp < Integer.parseInt(annexIcount.get(Integer.parseInt(shalin)))) {
											temp = Integer.parseInt(annexIcount.get(Integer.parseInt(shalin)));
										}
									}
								} else {
									if (temp < Integer.parseInt(model1.getValueAt(ya, 11).toString())) {
										temp = Integer.parseInt(model1.getValueAt(ya, 11).toString());
									}
								}
								model1.setValueAt(temp, ya, 11);
								temp++;							

							}													
							//end of new temp code
						}

					}
				}

			}
			check=true;
			//check1=true;
		}
		//new development for FRD1.5 by akansha
		if(frame_insert!=null)
			frame_insert.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
		contentGRPU.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

	public void jComboBox_deductee_Type_annex2(MyComboBoxEditor dedcuteeTypeComboAnnx2) {

		String item = ((JComboBox) dedcuteeTypeComboAnnx2.getComponent())
				.getSelectedItem().toString();

		if (((JComboBox) dedcuteeTypeComboAnnx2.getComponent())
				.getSelectedIndex() == 0) {
			GRPU.grpu.getMessage("select abhi mat krvalue");

		}
	}
	//newly developed for FRD1.5 Ver1.5 by akansha
	private static void open(URI uri)
	{
		if (Desktop.isDesktopSupported()) {
			try {

				Desktop.getDesktop().browse(uri);
			} catch (IOException e) { /* TODO: error handling */ }
		} else { 

		}
	}
	//****************************************************

	//newly developed for FRD1.5 Ver1.5 by akansha
	public void panCheckValidDedCode(String string, int rowTable, int colTable) {
		String value = string;
		int row = rowTable;
		int col = colTable;

		if(!"24Q".equals(formNumber)){
			if (("ADD".equals(model1.getValueAt(rowTable, 2)) && "Correction".equals(valueOfTypeOfStmt))
					|| "Regular".equals(valueOfTypeOfStmt)) {
				//System.out.println("Value of character: "+ value.charAt(3));
				if (value.charAt(3) == 'C' || value.charAt(3) == 'c') {
					model1.setValueAt("01", rowTable, 27);
				} 
				else if("PANINVALID".equalsIgnoreCase(value) || "PANAPPLIED".equalsIgnoreCase(value) || "PANNOTAVBL".equalsIgnoreCase(value))
					model1.setValueAt("--Select--", rowTable, 27);
				else {
					model1.setValueAt("02", rowTable, 27);
				}
			}
		}
	}

	public void totalTaxDepBookEntryFlag(String val, int rowTable,int colTable) {

		double value = 0.00;
		if(val!=null && !"".equals(val)){
			value = Double.parseDouble(val);
		}
		int row = rowTable;
		int col = colTable;
		//System.out.println("Value: "+(value>=1.0) );		
		if(("ADD".equals(model.getValueAt(rowTable, 1)) && "Correction".equals(valueOfTypeOfStmt))
				|| "Regular".equals(valueOfTypeOfStmt)){
			if(!("Central Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString())
					|| "State Government".equalsIgnoreCase(JComboBox_Form_Sub1_Type_of_Deductor.getSelectedItem().toString()))){
				//	System.out.println("Insdie first");
				if(value>=1.0)
					model.setValueAt("No",row,18);
				else
					model.setValueAt("--Select--", row,18);
			}else{
				//System.out.println("Inside second");
				if(value>=1.0)
					model.setValueAt("Yes",row,18);
				else{
					//	System.out.println("Inside seconddfdf");
					model.setValueAt("--Select--", row,18);
				}
			}
		}

	}
	//**********************************************************************************

	//newly added for FRD1.6 by akansha 
	public void setDisablingValues(String tds, int roTble, int colTable) {
		int rowTable;
		rowTable = roTble;
		System.out.println("ColTable Value: "+tds);
		System.out.print("Row Table Value:"+rowTable);
		//	JOptionPane.showMessageDialog(null,"Row Value: "+roTble+" Col Value: "+colTable);
		if (colTable == 50) {

			if ("No".equals(model2.getValueAt(rowTable,51).toString()) || "--Select--".equals(model2.getValueAt(rowTable,51).toString())) {
				if (model2.getValueAt(rowTable, 52) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 52)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 52);

				}
				if (model2.getValueAt(rowTable, 53) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 53)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 53);
				}
				if (model2.getValueAt(rowTable, 54) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 54)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 54);
				}
				if (model2.getValueAt(rowTable, 55) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 55)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 55);
				}
				if (model2.getValueAt(rowTable, 56) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 56)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 56);
				}
				if (model2.getValueAt(rowTable, 57) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 57)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 57);
				}
				if (model2.getValueAt(rowTable, 58) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 58)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 58);
				}
			}
		}
		if(colTable == 41){

			if ("No".equals(model2.getValueAt(rowTable,42).toString()) || "--Select--".equals(model2.getValueAt(rowTable,42).toString())) {
				if (model2.getValueAt(rowTable, 43) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 43)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 43);
				}
				if (model2.getValueAt(rowTable, 44) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 44)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 44);
				}
				if (model2.getValueAt(rowTable, 45) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 45)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 45);
				}
				if (model2.getValueAt(rowTable, 46) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 46)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 46);
				}
				if (model2.getValueAt(rowTable, 47) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 47)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 47);
				}
				if (model2.getValueAt(rowTable, 48) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 48)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 48);
				}
				if (model2.getValueAt(rowTable, 49) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 49)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 49);
				}
				if (model2.getValueAt(rowTable, 50) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 50)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 50);
				}
			}

		}

		if(colTable == 32){
			System.out.println("I am inside 32");
			if ("No".equals(model2.getValueAt(rowTable,33).toString()) || "--Select--".equals(model2.getValueAt(rowTable,33).toString())) {
				if (model2.getValueAt(rowTable, 34) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 34)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 34);
				}
				if (model2.getValueAt(rowTable, 35) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 35)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 35);
				}
				if (model2.getValueAt(rowTable, 36) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 36)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 36);
				}
				if (model2.getValueAt(rowTable, 37) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 37)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 37);
				}
				if (model2.getValueAt(rowTable, 38) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 38)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 38);
				}
				if (model2.getValueAt(rowTable, 39) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 39)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 39);
				}
				if (model2.getValueAt(rowTable, 40) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 40)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 40);
				}
				if (model2.getValueAt(rowTable, 41) != null
						&& !"".equalsIgnoreCase(model2.getValueAt(rowTable, 41)
								.toString().trim())) {
					model2.setValueAt("", rowTable, 41);
				}
			}



		}
	}

	//added action performed for utility link buttons.
	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub
		if (Desktop.isDesktopSupported()) {
			Desktop desktop = Desktop.getDesktop();
			try {
				String command = ((JButton) e.getSource()).getActionCommand();				
				desktop.browse(new URI (command));
			} catch (Exception ex) {
			}
		} 	
	}

	/******************************************/
	//added new requirement.
	//added windows listener


	/******************************************/
	
}

